/*! For license information please see module.js.LICENSE.txt */
define(["@emotion/css","@grafana/data","@grafana/runtime","@grafana/ui","app/core/config","app/core/core","app/core/table_model","app/core/utils/datemath","app/core/utils/kbn","lodash","moment","prismjs","react","react-dom","react-redux","redux","rxjs"],((e,t,r,n,o,i,a,l,u,s,c,d,f,p,g,v,h)=>(()=>{var m={75174:(e,t,r)=>{"use strict";r.r(t),r.d(t,{Components:()=>n,Pages:()=>o,selectors:()=>i});const n={RadioButton:{container:"data-testid radio-button"},Breadcrumbs:{breadcrumb:e=>`data-testid ${e} breadcrumb`},TimePicker:{openButton:"data-testid TimePicker Open Button",overlayContent:"data-testid TimePicker Overlay Content",fromField:"data-testid Time Range from field",toField:"data-testid Time Range to field",applyTimeRange:"data-testid TimePicker submit button",copyTimeRange:"data-testid TimePicker copy button",pasteTimeRange:"data-testid TimePicker paste button",calendar:{label:"data-testid Time Range calendar",openButton:"data-testid Open time range calendar",closeButton:"data-testid Close time range Calendar"},absoluteTimeRangeTitle:"data-testid-absolute-time-range-narrow"},DataSourcePermissions:{form:()=>'form[name="addPermission"]',roleType:"Role to add new permission to",rolePicker:"Built-in role picker",permissionLevel:"Permission Level"},DateTimePicker:{input:"data-testid date-time-input"},DataSource:{TestData:{QueryTab:{scenarioSelectContainer:"Test Data Query scenario select container",scenarioSelect:"Test Data Query scenario select",max:"TestData max",min:"TestData min",noise:"TestData noise",seriesCount:"TestData series count",spread:"TestData spread",startValue:"TestData start value",drop:"TestData drop values"}},DataSourceHttpSettings:{urlInput:"data-testid Datasource HTTP settings url"},Jaeger:{traceIDInput:"Trace ID"},Prometheus:{configPage:{connectionSettings:"Data source connection URL",manageAlerts:"prometheus-alerts-manager",scrapeInterval:"data-testid scrape interval",queryTimeout:"data-testid query timeout",defaultEditor:"data-testid default editor",disableMetricLookup:"disable-metric-lookup",prometheusType:"data-testid prometheus type",prometheusVersion:"data-testid prometheus version",cacheLevel:"data-testid cache level",incrementalQuerying:"prometheus-incremental-querying",queryOverlapWindow:"data-testid query overlap window",disableRecordingRules:"disable-recording-rules",customQueryParameters:"data-testid custom query parameters",httpMethod:"data-testid http method",exemplarsAddButton:"data-testid Add exemplar config button",internalLinkSwitch:"data-testid Internal link switch"},queryEditor:{explain:"data-testid prometheus explain switch wrapper",editorToggle:"data-testid QueryEditorModeToggle",options:"data-testid prometheus options",legend:"data-testid prometheus legend wrapper",format:"data-testid prometheus format",step:"prometheus-step",type:"data-testid prometheus type",exemplars:"prometheus-exemplars",builder:{metricSelect:"data-testid metric select",hints:"data-testid prometheus hints",metricsExplorer:"data-testid metrics explorer",queryAdvisor:"data-testid query advisor"},code:{queryField:"data-testid prometheus query field",metricsBrowser:{openButton:"data-testid open metrics browser",selectMetric:"data-testid select a metric",metricList:"data-testid metric list",labelNamesFilter:"data-testid label names filter",labelValuesFilter:"data-testid label values filter",useQuery:"data-testid use query",useAsRateQuery:"data-testid use as rate query",validateSelector:"data-testid validate selector",clear:"data-testid clear"}}},exemplarMarker:"data-testid Exemplar marker",variableQueryEditor:{queryType:"data-testid query type",labelnames:{metricRegex:"data-testid label names metric regex"},labelValues:{labelSelect:"data-testid label values label select"},metricNames:{metricRegex:"data-testid metric names metric regex"},varQueryResult:"data-testid variable query result",seriesQuery:"data-testid prometheus series query",classicQuery:"data-testid prometheus classic query"},annotations:{minStep:"prometheus-annotation-min-step",title:"data-testid prometheus annotation title",tags:"data-testid prometheus annotation tags",text:"data-testid prometheus annotation text",seriesValueAsTimestamp:"data-testid prometheus annotation series value as timestamp"}}},Menu:{MenuComponent:e=>`${e} menu`,MenuGroup:e=>`${e} menu group`,MenuItem:e=>`${e} menu item`,SubMenu:{container:"data-testid SubMenu container",icon:"data-testid SubMenu icon"}},Panels:{Panel:{title:e=>`data-testid Panel header ${e}`,headerItems:e=>`data-testid Panel header item ${e}`,menuItems:e=>`data-testid Panel menu item ${e}`,menu:e=>`data-testid Panel menu ${e}`,containerByTitle:e=>`${e} panel`,headerCornerInfo:e=>`Panel header ${e}`,status:e=>`data-testid Panel status ${e}`,loadingBar:()=>"Panel loading bar",HoverWidget:{container:"data-testid hover-header-container",dragIcon:"data-testid drag-icon"},PanelDataErrorMessage:"data-testid Panel data error message"},Visualization:{Graph:{container:"Graph container",VisualizationTab:{legendSection:"Legend section"},Legend:{legendItemAlias:e=>`gpl alias ${e}`,showLegendSwitch:"gpl show legend"},xAxis:{labels:()=>"div.flot-x-axis > div.flot-tick-label"}},BarGauge:{value:"Bar gauge value",valueV2:"data-testid Bar gauge value"},PieChart:{svgSlice:"data testid Pie Chart Slice"},Text:{container:()=>".markdown-html"},Table:{header:"table header",footer:"table-footer",body:"data-testid table body"}}},VizLegend:{seriesName:e=>`data-testid VizLegend series ${e}`},Drawer:{General:{title:e=>`Drawer title ${e}`,expand:"Drawer expand",contract:"Drawer contract",close:"data-testid Drawer close",rcContentWrapper:()=>".rc-drawer-content-wrapper",subtitle:"data-testid drawer subtitle"}},PanelEditor:{General:{content:"Panel editor content"},OptionsPane:{content:"Panel editor option pane content",select:"Panel editor option pane select",fieldLabel:e=>`${e} field property editor`},DataPane:{content:"Panel editor data pane content"},applyButton:"data-testid Apply changes and go back to dashboard",toggleVizPicker:"data-testid toggle-viz-picker",toggleVizOptions:"data-testid toggle-viz-options",toggleTableView:"toggle-table-view",showZoomField:"Map controls Show zoom control field property editor",showAttributionField:"Map controls Show attribution field property editor",showScaleField:"Map controls Show scale field property editor",showMeasureField:"Map controls Show measure tools field property editor",showDebugField:"Map controls Show debug field property editor",measureButton:"show measure tools"},PanelInspector:{Data:{content:"Panel inspector Data content"},Stats:{content:"Panel inspector Stats content"},Json:{content:"Panel inspector Json content"},Query:{content:"Panel inspector Query content",refreshButton:"Panel inspector Query refresh button",jsonObjectKeys:()=>".json-formatter-key"}},Tab:{title:e=>`Tab ${e}`,active:()=>'[class*="-activeTabStyle"]'},RefreshPicker:{runButton:"RefreshPicker run button",intervalButton:"RefreshPicker interval button",runButtonV2:"data-testid RefreshPicker run button",intervalButtonV2:"data-testid RefreshPicker interval button"},QueryTab:{content:"Query editor tab content",queryInspectorButton:"Query inspector button",queryHistoryButton:"data-testid query-history-button",addQuery:"data-testid query-tab-add-query"},QueryHistory:{queryText:"Query text"},QueryEditorRows:{rows:"Query editor row"},QueryEditorRow:{actionButton:e=>`data-testid ${e}`,title:e=>`Query editor row title ${e}`,container:e=>`Query editor row ${e}`},AlertTab:{content:"data-testid Alert editor tab content"},Alert:{alert:e=>`Alert ${e}`,alertV2:e=>`data-testid Alert ${e}`},TransformTab:{content:"data-testid Transform editor tab content",newTransform:e=>`data-testid New transform ${e}`,transformationEditor:e=>`data-testid Transformation editor ${e}`,transformationEditorDebugger:e=>`data-testid Transformation editor debugger ${e}`},Transforms:{card:e=>`data-testid New transform ${e}`,disableTransformationButton:"data-testid Disable transformation button",Reduce:{modeLabel:"data-testid Transform mode label",calculationsLabel:"data-testid Transform calculations label"},SpatialOperations:{actionLabel:"root Action field property editor",locationLabel:"root Location Mode field property editor",location:{autoOption:"Auto location option",coords:{option:"Coords location option",latitudeFieldLabel:"root Latitude field field property editor",longitudeFieldLabel:"root Longitude field field property editor"},geohash:{option:"Geohash location option",geohashFieldLabel:"root Geohash field field property editor"},lookup:{option:"Lookup location option",lookupFieldLabel:"root Lookup field field property editor",gazetteerFieldLabel:"root Gazetteer field property editor"}}},searchInput:"data-testid search transformations",noTransformationsMessage:"data-testid no transformations message",addTransformationButton:"data-testid add transformation button",removeAllTransformationsButton:"data-testid remove all transformations button"},NavBar:{Configuration:{button:"Configuration"},Toggle:{button:"data-testid Toggle menu"},Reporting:{button:"Reporting"}},NavMenu:{Menu:"data-testid navigation mega-menu",item:"data-testid Nav menu item"},NavToolbar:{container:"data-testid Nav toolbar"},PageToolbar:{container:()=>".page-toolbar",item:e=>`${e}`,itemButton:e=>`data-testid ${e}`},QueryEditorToolbarItem:{button:e=>`QueryEditor toolbar item button ${e}`},BackButton:{backArrow:"data-testid Go Back"},OptionsGroup:{group:e=>e?`Options group ${e}`:"Options group",toggle:e=>e?`Options group ${e} toggle`:"Options group toggle"},PluginVisualization:{item:e=>`Plugin visualization item ${e}`,current:()=>'[class*="-currentVisualizationItem"]'},Select:{option:"Select option",input:()=>'input[id*="time-options-input"]',singleValue:()=>'div[class*="-singleValue"]'},FieldConfigEditor:{content:"Field config editor content"},OverridesConfigEditor:{content:"Field overrides editor content"},FolderPicker:{container:"Folder picker select container",containerV2:"data-testid Folder picker select container",input:"data-testid folder-picker-input"},ReadonlyFolderPicker:{container:"data-testid Readonly folder picker select container"},DataSourcePicker:{container:"data-testid Data source picker select container",input:()=>'input[id="data-source-picker"]',inputV2:"data-testid Select a data source",dataSourceList:"data-testid Data source list dropdown",advancedModal:{dataSourceList:"data-testid Data source list",builtInDataSourceList:"data-testid Built in data source list"}},TimeZonePicker:{container:"Time zone picker select container",containerV2:"data-testid Time zone picker select container"},WeekStartPicker:{container:"Choose starting day of the week",containerV2:"data-testid Choose starting day of the week",placeholder:"Choose starting day of the week"},TraceViewer:{spanBar:"data-testid SpanBar--wrapper"},QueryField:{container:"data-testid Query field"},QueryBuilder:{queryPatterns:"data-testid Query patterns",labelSelect:"data-testid Select label",valueSelect:"data-testid Select value",matchOperatorSelect:"data-testid Select match operator"},ValuePicker:{button:e=>`data-testid Value picker button ${e}`,select:e=>`data-testid Value picker select ${e}`},Search:{section:"Search section",sectionV2:"data-testid Search section",items:"Search items",itemsV2:"data-testid Search items",cards:"data-testid Search cards",collapseFolder:e=>`data-testid Collapse folder ${e}`,expandFolder:e=>`data-testid Expand folder ${e}`,dashboardItem:e=>`${n.Search.dashboardItems} ${e}`,dashboardCard:e=>`data-testid Search card ${e}`,folderHeader:e=>`data-testid Folder header ${e}`,folderContent:e=>`data-testid Folder content ${e}`,dashboardItems:"data-testid Dashboard search item"},DashboardLinks:{container:"data-testid Dashboard link container",dropDown:"data-testid Dashboard link dropdown",link:"data-testid Dashboard link"},LoadingIndicator:{icon:"data-testid Loading indicator"},CallToActionCard:{button:e=>`Call to action button ${e}`,buttonV2:e=>`data-testid Call to action button ${e}`},DataLinksContextMenu:{singleLink:"data-testid Data link"},CodeEditor:{container:"data-testid Code editor container"},DashboardImportPage:{textarea:"data-testid-import-dashboard-textarea",submit:"data-testid-load-dashboard"},ImportDashboardForm:{name:"data-testid-import-dashboard-title",submit:"data-testid-import-dashboard-submit"},PanelAlertTabContent:{content:"data-testid Unified alert editor tab content"},VisualizationPreview:{card:e=>`data-testid suggestion-${e}`},ColorSwatch:{name:"data-testid-colorswatch"},DashboardRow:{title:e=>`data-testid dashboard-row-title-${e}`},UserProfile:{profileSaveButton:"data-testid-user-profile-save",preferencesSaveButton:"data-testid-shared-prefs-save",orgsTable:"data-testid-user-orgs-table",sessionsTable:"data-testid-user-sessions-table",extensionPointTabs:"data-testid-extension-point-tabs",extensionPointTab:e=>`data-testid-extension-point-tab-${e}`},FileUpload:{inputField:"data-testid-file-upload-input-field",fileNameSpan:"data-testid-file-upload-file-name"},DebugOverlay:{wrapper:"debug-overlay"},OrgRolePicker:{input:"Role"},AnalyticsToolbarButton:{button:"Dashboard insights"},Variables:{variableOption:"data-testid variable-option"},Annotations:{annotationsTypeInput:"annotations-type-input",annotationsChoosePanelInput:"choose-panels-input"},Tooltip:{container:"data-testid tooltip"}},o={Login:{url:"/login",username:"data-testid Username input field",password:"data-testid Password input field",submit:"data-testid Login button",skip:"data-testid Skip change password button"},Home:{url:"/"},DataSource:{name:"data-testid Data source settings page name input field",delete:"Data source settings page Delete button",readOnly:"data-testid Data source settings page read only message",saveAndTest:"data-testid Data source settings page Save and Test button",alert:"data-testid Data source settings page Alert"},DataSources:{url:"/datasources",dataSources:e=>`Data source list item ${e}`},EditDataSource:{url:e=>`/datasources/edit/${e}`,settings:"Datasource settings page basic settings"},AddDataSource:{url:"/datasources/new",dataSourcePlugins:e=>`Data source plugin item ${e}`,dataSourcePluginsV2:e=>`Add new data source ${e}`},ConfirmModal:{delete:"data-testid Confirm Modal Danger Button"},AddDashboard:{url:"/dashboard/new",itemButton:e=>`data-testid ${e}`,addNewPanel:"Add new panel",addNewRow:"Add new row",addNewPanelLibrary:"Add new panel from panel library"},Dashboard:{url:e=>`/d/${e}`,DashNav:{nav:"Dashboard navigation",navV2:"data-testid Dashboard navigation",publicDashboardTag:"data-testid public dashboard tag",shareButton:"data-testid share-button"},SubMenu:{submenu:"Dashboard submenu",submenuItem:"data-testid template variable",submenuItemLabels:e=>`data-testid Dashboard template variables submenu Label ${e}`,submenuItemValueDropDownValueLinkTexts:e=>`data-testid Dashboard template variables Variable Value DropDown value link text ${e}`,submenuItemValueDropDownDropDown:"Variable options",submenuItemValueDropDownOptionTexts:e=>`data-testid Dashboard template variables Variable Value DropDown option text ${e}`,Annotations:{annotationsWrapper:"data-testid annotation-wrapper",annotationLabel:e=>`data-testid Dashboard annotations submenu Label ${e}`,annotationToggle:e=>`data-testid Dashboard annotations submenu Toggle ${e}`}},Settings:{Actions:{close:"data-testid dashboard-settings-close"},General:{deleteDashBoard:"Dashboard settings page delete dashboard button",sectionItems:e=>`Dashboard settings section item ${e}`,saveDashBoard:"Dashboard settings aside actions Save button",saveAsDashBoard:"Dashboard settings aside actions Save As button",timezone:"Time zone picker select container",title:"Tab General"},Annotations:{List:{addAnnotationCTA:n.CallToActionCard.button("Add annotation query"),addAnnotationCTAV2:n.CallToActionCard.buttonV2("Add annotation query"),annotations:"data-testid list-annotations"},Settings:{name:"Annotations settings name input"},NewAnnotation:{panelFilterSelect:"data-testid annotations-panel-filter",showInLabel:"show-in-label",previewInDashboard:"data-testid annotations-preview",delete:"data-testid annotations-delete",apply:"data-testid annotations-apply",enable:"data-testid annotation-enable",hide:"data-testid annotation-hide"}},Variables:{List:{addVariableCTA:n.CallToActionCard.button("Add variable"),addVariableCTAV2:n.CallToActionCard.buttonV2("Add variable"),newButton:"Variable editor New variable button",table:"Variable editor Table",tableRowNameFields:e=>`Variable editor Table Name field ${e}`,tableRowDefinitionFields:e=>`Variable editor Table Definition field ${e}`,tableRowArrowUpButtons:e=>`Variable editor Table ArrowUp button ${e}`,tableRowArrowDownButtons:e=>`Variable editor Table ArrowDown button ${e}`,tableRowDuplicateButtons:e=>`Variable editor Table Duplicate button ${e}`,tableRowRemoveButtons:e=>`Variable editor Table Remove button ${e}`},Edit:{General:{headerLink:"Variable editor Header link",modeLabelNew:"Variable editor Header mode New",modeLabelEdit:"Variable editor Header mode Edit",generalNameInput:"Variable editor Form Name field",generalNameInputV2:"data-testid Variable editor Form Name field",generalTypeSelect:"Variable editor Form Type select",generalTypeSelectV2:"data-testid Variable editor Form Type select",generalLabelInput:"Variable editor Form Label field",generalLabelInputV2:"data-testid Variable editor Form Label field",generalHideSelect:"Variable editor Form Hide select",generalHideSelectV2:"data-testid Variable editor Form Hide select",selectionOptionsMultiSwitch:"data-testid Variable editor Form Multi switch",selectionOptionsIncludeAllSwitch:"data-testid Variable editor Form IncludeAll switch",selectionOptionsCustomAllInput:"data-testid Variable editor Form IncludeAll field",previewOfValuesOption:"data-testid Variable editor Preview of Values option",submitButton:"data-testid Variable editor Run Query button",applyButton:"data-testid Variable editor Apply button"},QueryVariable:{queryOptionsDataSourceSelect:n.DataSourcePicker.inputV2,queryOptionsRefreshSelect:"Variable editor Form Query Refresh select",queryOptionsRefreshSelectV2:"data-testid Variable editor Form Query Refresh select",queryOptionsRegExInput:"Variable editor Form Query RegEx field",queryOptionsRegExInputV2:"data-testid Variable editor Form Query RegEx field",queryOptionsSortSelect:"Variable editor Form Query Sort select",queryOptionsSortSelectV2:"data-testid Variable editor Form Query Sort select",queryOptionsQueryInput:"data-testid Variable editor Form Default Variable Query Editor textarea",valueGroupsTagsEnabledSwitch:"Variable editor Form Query UseTags switch",valueGroupsTagsTagsQueryInput:"Variable editor Form Query TagsQuery field",valueGroupsTagsTagsValuesQueryInput:"Variable editor Form Query TagsValuesQuery field"},ConstantVariable:{constantOptionsQueryInput:"Variable editor Form Constant Query field",constantOptionsQueryInputV2:"data-testid Variable editor Form Constant Query field"},DatasourceVariable:{datasourceSelect:"data-testid datasource variable datasource type"},TextBoxVariable:{textBoxOptionsQueryInput:"Variable editor Form TextBox Query field",textBoxOptionsQueryInputV2:"data-testid Variable editor Form TextBox Query field"},CustomVariable:{customValueInput:"data-testid custom-variable-input"},IntervalVariable:{intervalsValueInput:"data-testid interval variable intervals input",autoEnabledCheckbox:"data-testid interval variable auto value checkbox",stepCountIntervalSelect:"data-testid interval variable step count input",minIntervalInput:"data-testid interval variable mininum interval input"},GroupByVariable:{dataSourceSelect:n.DataSourcePicker.inputV2,infoText:"data-testid group by variable info text",modeToggle:"data-testid group by variable mode toggle"},AdHocFiltersVariable:{datasourceSelect:n.DataSourcePicker.inputV2,infoText:"data-testid ad-hoc filters variable info text"}}}},Annotations:{marker:"data-testid annotation-marker"},Rows:{Repeated:{ConfigSection:{warningMessage:"data-testid Repeated rows warning message"}}}},Dashboards:{url:"/dashboards",dashboards:e=>`Dashboard search item ${e}`},SaveDashboardAsModal:{newName:"Save dashboard title field",save:"Save dashboard button"},SaveDashboardModal:{save:"Dashboard settings Save Dashboard Modal Save button",saveVariables:"Dashboard settings Save Dashboard Modal Save variables checkbox",saveTimerange:"Dashboard settings Save Dashboard Modal Save timerange checkbox"},SharePanelModal:{linkToRenderedImage:"Link to rendered image"},ShareDashboardModal:{PublicDashboard:{Tab:"Tab Public dashboard",WillBePublicCheckbox:"data-testid public dashboard will be public checkbox",LimitedDSCheckbox:"data-testid public dashboard limited datasources checkbox",CostIncreaseCheckbox:"data-testid public dashboard cost may increase checkbox",PauseSwitch:"data-testid public dashboard pause switch",EnableAnnotationsSwitch:"data-testid public dashboard on off switch for annotations",CreateButton:"data-testid public dashboard create button",DeleteButton:"data-testid public dashboard delete button",CopyUrlInput:"data-testid public dashboard copy url input",CopyUrlButton:"data-testid public dashboard copy url button",SettingsDropdown:"data-testid public dashboard settings dropdown",TemplateVariablesWarningAlert:"data-testid public dashboard disabled template variables alert",UnsupportedDataSourcesWarningAlert:"data-testid public dashboard unsupported data sources alert",NoUpsertPermissionsWarningAlert:"data-testid public dashboard no upsert permissions alert",EnableTimeRangeSwitch:"data-testid public dashboard on off switch for time range",EmailSharingConfiguration:{Container:"data-testid email sharing config container",ShareType:"data-testid public dashboard share type",EmailSharingInput:"data-testid public dashboard email sharing input",EmailSharingInviteButton:"data-testid public dashboard email sharing invite button",EmailSharingList:"data-testid public dashboard email sharing list",DeleteEmail:"data-testid public dashboard delete email button",ReshareLink:"data-testid public dashboard reshare link button"}}},PublicDashboard:{page:"public-dashboard-page",NotAvailable:{container:"public-dashboard-not-available",title:"public-dashboard-title",pausedDescription:"public-dashboard-paused-description"}},RequestViewAccess:{form:"request-view-access-form",recipientInput:"request-view-access-recipient-input",submitButton:"request-view-access-submit-button"},PublicDashboardConfirmAccess:{submitButton:"data-testid confirm-access-submit-button"},Explore:{url:"/explore",General:{container:"data-testid Explore",graph:"Explore Graph",table:"Explore Table",scrollView:"data-testid explorer scroll view"}},SoloPanel:{url:e=>`/d-solo/${e}`},PluginsList:{page:"Plugins list page",list:"Plugins list",listItem:"Plugins list item",signatureErrorNotice:"data-testid Unsigned plugins notice"},PluginPage:{page:"Plugin page",signatureInfo:"data-testid Plugin signature info",disabledInfo:"data-testid Plugin disabled info"},PlaylistForm:{name:"Playlist name",interval:"Playlist interval",itemDelete:"data-testid playlist-form-delete-item"},BrowseDashboards:{table:{body:"data-testid browse-dashboards-table",row:e=>`data-testid browse dashboards row ${e}`,checkbox:e=>`data-testid ${e} checkbox`},NewFolderForm:{form:"data-testid new folder form",nameInput:"data-testid new-folder-name-input",createButton:"data-testid new-folder-create-button"}},Search:{url:"/?search=openn",FolderView:{url:"/?search=open&layout=folders"}},PublicDashboards:{ListItem:{linkButton:"public-dashboard-link-button",configButton:"public-dashboard-configuration-button",trashcanButton:"public-dashboard-remove-button",pauseSwitch:"data-testid public dashboard pause switch"}},UserListPage:{tabs:{allUsers:"data-testid all-users-tab",orgUsers:"data-testid org-users-tab",anonUserDevices:"data-testid anon-user-devices-tab",publicDashboardsUsers:"data-testid public-dashboards-users-tab",users:"data-testid users-tab"},org:{url:"/org/users"},admin:{url:"/admin/users"},publicDashboards:{container:"data-testid public-dashboards-users-list"},UserListAdminPage:{container:"data-testid user-list-admin-page"},UsersListPage:{container:"data-testid users-list-page"},UserAnonListPage:{container:"data-testid user-anon-list-page"},UsersListPublicDashboardsPage:{container:"data-testid users-list-public-dashboards-page",DashboardsListModal:{listItem:e=>`data-testid dashboards-list-item-${e}`}}},ProfilePage:{url:"/profile"}},i={pages:o,components:n}},57751:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncButtonCascader=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(82007),a=r(46089),l=n.__importDefault(r(59841));t.AsyncButtonCascader=e=>{const{onChange:t,className:r,loadData:u}=e,s=n.__rest(e,["onChange","className","loadData"]),c=(d=(0,i.useTheme2)(),{popup:a.css`
      label: popup;
      z-index: ${d.zIndex.dropdown};
    `,icon:a.css`
      margin: 1px 0 0 4px;
    `});var d;return o.default.createElement(l.default,Object.assign({onChange:t,loadData:u,changeOnSelect:!0,popupClassName:c.popup},s,{expandIcon:null}),o.default.createElement("button",{className:(0,a.cx)("gf-form-label",r),disabled:e.disabled},e.children," ",o.default.createElement(i.Icon,{name:"angle-down",className:c.icon})))},t.AsyncButtonCascader.displayName="AsyncButtonCascader"},97353:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Cascader=void 0;var n=r(82007);Object.defineProperty(t,"Cascader",{enumerable:!0,get:function(){return n.Cascader}})},92581:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AdvancedHttpSettings=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(78916);t.AdvancedHttpSettings=({config:e,onChange:t,className:r})=>{const l={container:(0,o.css)({maxWidth:578})};return n.default.createElement(a.ConfigSubSection,{title:"Advanced HTTP settings",className:(0,o.cx)(l.container,r)},n.default.createElement(i.InlineField,{htmlFor:"advanced-http-cookies",label:"Allowed cookies",labelWidth:24,tooltip:"Grafana proxy deletes forwarded cookies by default. Specify cookies by name that should be forwarded to the data source.",disabled:e.readOnly,grow:!0},n.default.createElement(i.TagsInput,{id:"advanced-http-cookies",placeholder:"New cookie (hit enter to add)",tags:e.jsonData.keepCookies,onChange:r=>{t(Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{keepCookies:r})}))}})),n.default.createElement(i.InlineField,{htmlFor:"advanced-http-timeout",label:"Timeout",labelWidth:24,tooltip:"HTTP request timeout in seconds",disabled:e.readOnly,grow:!0},n.default.createElement(i.Input,{id:"advanced-http-timeout",type:"number",min:0,placeholder:"Timeout in seconds","aria-label":"Timeout in seconds",value:e.jsonData.timeout,onChange:r=>{t(Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{timeout:parseInt(r.currentTarget.value,10)})}))}})))}},4948:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AdvancedHttpSettings=void 0;var n=r(92581);Object.defineProperty(t,"AdvancedHttpSettings",{enumerable:!0,get:function(){return n.AdvancedHttpSettings}})},25647:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Auth=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(34302),a=r(31583),l=r(68381),u=r(78916);t.Auth=({selectedMethod:e,mostCommonMethod:t,visibleMethods:r,defaultOptionsOverrides:s,customMethods:c,onAuthMethodSelect:d,basicAuth:f,TLS:p,customHeaders:g,readOnly:v=!1})=>{const h={container:(0,o.css)({maxWidth:578})};return n.default.createElement("div",{className:h.container},n.default.createElement(u.ConfigSection,{title:"Authentication"},n.default.createElement(i.AuthMethodSettings,{selectedMethod:e,mostCommonMethod:t,customMethods:c,visibleMethods:r,defaultOptionsOverrides:s,onAuthMethodSelect:d,basicAuth:f,readOnly:v}),p&&n.default.createElement(a.TLSSettings,Object.assign({},p,{readOnly:v})),g&&n.default.createElement(l.CustomHeaders,Object.assign({},g,{readOnly:v}))))}},34302:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AuthMethodSettings=void 0;const n=r(91666).__importStar(r(85959)),o=r(46089),i=r(82007),a=r(85822),l=r(78916),u=r(75160),s={[u.AuthMethod.BasicAuth]:{label:"Basic authentication",value:u.AuthMethod.BasicAuth,description:"Authenticate with your data source username and password"},[u.AuthMethod.CrossSiteCredentials]:{label:"Enable cross-site access control requests",value:u.AuthMethod.CrossSiteCredentials,description:"Allow cross-site Access-Control requests with your existing credentials and cookies. This enables the server to authenticate the user and perform authorized requests on their behalf on other domains."},[u.AuthMethod.OAuthForward]:{label:"Forward OAuth Identity",value:u.AuthMethod.OAuthForward,description:"Forward the OAuth access token (and if available: the OIDC ID token) of the user querying to the data source"},[u.AuthMethod.NoAuth]:{label:"No Authentication",value:u.AuthMethod.NoAuth,description:"Data source is available without authentication"}};t.AuthMethodSettings=({selectedMethod:e,mostCommonMethod:t,visibleMethods:r,defaultOptionsOverrides:c,customMethods:d,onAuthMethodSelect:f,basicAuth:p,readOnly:g})=>{var v,h,m,y;const[b,E]=(0,n.useState)(!1),{colors:O,spacing:S}=(0,i.useTheme2)(),_=(0,n.useMemo)((()=>{var e;return null!=r?r:[u.AuthMethod.BasicAuth,u.AuthMethod.OAuthForward,u.AuthMethod.NoAuth,...null!==(e=null==d?void 0:d.map((e=>e.id)))&&void 0!==e?e:[]]}),[d,r]),w=_.length>1,T=(0,n.useMemo)((()=>{var e;const r=null!==(e=null==d?void 0:d.reduce(((e,t)=>(e[t.id]={label:t.label,value:t.id,description:t.description},e)),{}))&&void 0!==e?e:{},n={};let o;for(o in s)n[o]=Object.assign(Object.assign({},s[o]),null==c?void 0:c[o]);const i=Object.assign(Object.assign({},r),n);return _.filter((e=>Boolean(i[e]))).map((e=>{const r=i[e];return e===t&&w?Object.assign(Object.assign({},r),{label:`${r.label} (most common)`}):r}))}),[_,d,c,t,w]);let P=e;w?e===u.AuthMethod.NoAuth&&t&&!b&&(P=t):P=_[0];let C=null;P===u.AuthMethod.BasicAuth&&p?C=n.default.createElement(a.BasicAuth,Object.assign({},p,{readOnly:g})):P.startsWith("custom-")&&(C=null!==(h=null===(v=null==d?void 0:d.find((e=>e.id===P)))||void 0===v?void 0:v.component)&&void 0!==h?h:null);const I=w?"Authentication methods":null!==(m=T[0].label)&&void 0!==m?m:"",A=w?"Choose an authentication method to access the data source":null!==(y=T[0].description)&&void 0!==y?y:"",R={authMethods:(0,o.css)(Object.assign({marginTop:S(2.5)},w&&{padding:S(2),border:`1px solid ${O.border.weak}`})),selectedMethodFields:(0,o.css)({marginTop:S(1.5)})};return n.default.createElement(l.ConfigSubSection,{title:I,description:A},n.default.createElement("div",{className:R.authMethods},w&&n.default.createElement(i.Select,{options:T,value:P,onChange:e=>{E(!0),f(e.value)},disabled:g}),C&&n.default.createElement("div",{className:R.selectedMethodFields},C)))}},85822:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicAuth=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(41971);t.BasicAuth=({user:e,passwordConfigured:t,userLabel:r="User",userTooltip:l="The username of the data source account",userPlaceholder:u="User",passwordLabel:s="Password",passwordTooltip:c="The password of the data source account",passwordPlaceholder:d="Password",onUserChange:f,onPasswordChange:p,onPasswordReset:g,readOnly:v})=>{const h=(0,a.useCommonStyles)(),m={lastInlineField:(0,o.css)({marginBottom:0})};return n.default.createElement(n.default.Fragment,null,n.default.createElement(i.InlineField,{className:h.inlineFieldNoMarginRight,label:r,labelWidth:24,tooltip:l,required:!0,htmlFor:"basic-auth-user-input",interactive:!0,grow:!0,disabled:v},n.default.createElement(i.Input,{id:"basic-auth-user-input",placeholder:u,value:e,onChange:e=>f(e.currentTarget.value),required:!0})),n.default.createElement(i.InlineField,{className:(0,o.cx)(h.inlineFieldNoMarginRight,h.inlineFieldWithSecret,m.lastInlineField),label:s,labelWidth:24,tooltip:c,required:!0,htmlFor:"basic-auth-password-input",interactive:!0,grow:!0,disabled:v},n.default.createElement(i.SecretInput,{id:"basic-auth-password-input",isConfigured:t,onReset:v?()=>{}:g,placeholder:d,onChange:e=>p(e.currentTarget.value),required:!0})))}},34518:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomHeader=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(41971);t.CustomHeader=({header:e,onChange:t,onBlur:r,onDelete:l,readOnly:u})=>{const{spacing:s}=(0,i.useTheme2)(),c=(0,a.useCommonStyles)(),d={container:(0,o.css)({alignItems:"center"}),input:(0,o.css)({minWidth:"100%"}),headerNameField:(0,o.css)({width:"40%",marginRight:0,paddingRight:s(1)}),headerValueField:(0,o.css)({width:"45%",marginRight:0}),removeHeaderBtn:(0,o.css)({margin:"0 0 3px 10px"})};return n.default.createElement(n.default.Fragment,null,n.default.createElement(i.InlineFieldRow,{className:d.container},n.default.createElement(i.InlineField,{label:"Header",labelWidth:9,grow:!0,className:d.headerNameField,htmlFor:`custom-header-${e.id}-name-input`,disabled:u},n.default.createElement(i.Input,{id:`custom-header-${e.id}-name-input`,placeholder:"X-Custom-Header",value:e.name,width:12,onChange:r=>t(Object.assign(Object.assign({},e),{name:r.currentTarget.value})),onBlur:r,className:d.input})),n.default.createElement(i.InlineField,{label:"Value",labelWidth:9,grow:!0,className:(0,o.cx)(c.inlineFieldWithSecret,d.headerValueField),htmlFor:`custom-header-${e.id}-value-input`,disabled:u},n.default.createElement(i.SecretInput,{id:`custom-header-${e.id}-value-input`,isConfigured:e.configured,placeholder:"Header value",value:e.value,width:12,onChange:r=>t(Object.assign(Object.assign({},e),{value:r.currentTarget.value})),onReset:u?()=>{}:()=>t(Object.assign(Object.assign({},e),{configured:!1,value:""})),onBlur:r,className:d.input})),n.default.createElement(i.IconButton,{name:"trash-alt",tooltip:"Remove header",tooltipPlacement:"top",className:d.removeHeaderBtn,onClick:l,type:"button",disabled:u})))}},68381:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomHeaders=void 0;const n=r(91666).__importStar(r(85959)),o=r(46089),i=r(82007),a=r(34518),l=r(78916);function u(){return Math.random().toString(16).slice(2)}t.CustomHeaders=({headers:e,onChange:t,readOnly:r})=>{const{spacing:s}=(0,i.useTheme2)(),[c,d]=(0,n.useState)(e.map((e=>Object.assign(Object.assign({},e),{id:u(),value:""}))));(0,n.useEffect)((()=>{d((t=>{let r=!1;const n=t.map((t=>{var n;const o=null===(n=e.find((e=>e.name===t.name)))||void 0===n?void 0:n.configured;return void 0!==o&&t.configured!==o?(r=!0,Object.assign(Object.assign({},t),{configured:o})):t}));return r?n:t}))}),[e]);const f=()=>{t(c.map((({name:e,value:t,configured:r})=>({name:e,value:t,configured:r}))))},p={container:(0,o.css)({marginTop:s(3)}),addHeaderButton:(0,o.css)({marginTop:s(1.5)})};return n.default.createElement("div",{className:p.container},n.default.createElement(l.ConfigSubSection,{title:"HTTP headers",description:"Pass along additional context and metadata about the request/response",isCollapsible:!0,isInitiallyOpen:c.length>0},n.default.createElement("div",null,c.map((e=>n.default.createElement(a.CustomHeader,{key:e.id,header:e,onChange:e=>((e,t)=>{d(c.map((r=>r.id===e?Object.assign({},t):r)))})(e.id,e),onDelete:()=>(e=>{const r=c.findIndex((t=>t.id===e));if(-1===r)return;const n=[...c];n.splice(r,1),d(n),t(n.map((({name:e,value:t,configured:r})=>({name:e,value:t,configured:r}))))})(e.id),onBlur:f,readOnly:r})))),n.default.createElement("div",{className:p.addHeaderButton},n.default.createElement(i.Button,{icon:"plus",variant:"secondary",fill:"outline",onClick:()=>{d([...c,{id:u(),name:"",value:"",configured:!1}])},disabled:r},0===c.length?"Add header":"Add another header"))))}},66678:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.convertLegacyAuthProps=t.AuthMethod=t.Auth=void 0;var n=r(25647);Object.defineProperty(t,"Auth",{enumerable:!0,get:function(){return n.Auth}});var o=r(75160);Object.defineProperty(t,"AuthMethod",{enumerable:!0,get:function(){return o.AuthMethod}});var i=r(85316);Object.defineProperty(t,"convertLegacyAuthProps",{enumerable:!0,get:function(){return i.convertLegacyAuthProps}})},41971:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.useCommonStyles=void 0;const n=r(46089);t.useCommonStyles=()=>({inlineFieldNoMarginRight:(0,n.css)({marginRight:0}),inlineFieldWithSecret:(0,n.css)({'[class$="layoutChildrenWrapper"]:first-child':{flexGrow:1}})})},70014:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelfSignedCertificate=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(66636),l=r(41971);t.SelfSignedCertificate=({enabled:e,certificateConfigured:t,onToggle:r,onCertificateChange:u,onCertificateReset:s,tooltips:c,readOnly:d})=>{var f;const p=(0,l.useCommonStyles)();return n.default.createElement(a.TLSSettingsSection,{enabled:e,label:"Add self-signed certificate",tooltipText:"Add your own Certificate Authority (CA) certificate on top of one generated by the certificate authorities for additional security measures",onToggle:e=>r(e),readOnly:d},n.default.createElement(i.InlineField,{label:"CA Certificate",labelWidth:24,tooltip:null!==(f=null==c?void 0:c.certificateLabel)&&void 0!==f?f:"Your self-signed certificate",required:!0,htmlFor:"self-signed-certificate-input",interactive:!0,grow:!0,className:(0,o.cx)(p.inlineFieldNoMarginRight,p.inlineFieldWithSecret),disabled:d},n.default.createElement(i.SecretTextArea,{id:"self-signed-certificate-input",isConfigured:t,onChange:e=>u(e.currentTarget.value),onReset:d?()=>{}:s,placeholder:"Begins with --- BEGIN CERTIFICATE ---",rows:6,required:!0})))}},95840:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SkipTLSVerification=void 0;const n=r(91666).__importDefault(r(85959)),o=r(66636);t.SkipTLSVerification=({enabled:e,onToggle:t,readOnly:r})=>n.default.createElement(o.TLSSettingsSection,{enabled:e,label:"Skip TLS certificate validation",tooltipText:"Skipping TLS certificate validation is not recommended unless absolutely necessary or for testing",onToggle:e=>t(e),readOnly:r})},70619:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TLSClientAuth=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(66636),l=r(41971);t.TLSClientAuth=({enabled:e,serverName:t,clientCertificateConfigured:r,clientKeyConfigured:u,onToggle:s,onServerNameChange:c,onClientCertificateChange:d,onClientKeyChange:f,onClientCertificateReset:p,onClientKeyReset:g,tooltips:v,readOnly:h})=>{var m,y,b;const E=(0,l.useCommonStyles)();return n.default.createElement(a.TLSSettingsSection,{enabled:e,label:"TLS Client Authentication",tooltipText:"Validate using TLS client authentication, in which the server authenticates the client",onToggle:e=>s(e),readOnly:h},n.default.createElement(i.InlineField,{label:"ServerName",labelWidth:24,tooltip:null!==(m=null==v?void 0:v.serverNameLabel)&&void 0!==m?m:"A Servername is used to verify the hostname on the returned certificate",required:!0,htmlFor:"client-auth-servername-input",interactive:!0,grow:!0,className:E.inlineFieldNoMarginRight,disabled:h},n.default.createElement(i.Input,{id:"client-auth-servername-input",placeholder:"domain.example.com",value:t,onChange:e=>c(e.currentTarget.value),required:!0})),n.default.createElement(i.InlineField,{label:"Client Certificate",labelWidth:24,tooltip:null!==(y=null==v?void 0:v.certificateLabel)&&void 0!==y?y:"The client certificate can be generated from a Certificate Authority or be self-signed",required:!0,htmlFor:"client-auth-client-certificate-input",interactive:!0,grow:!0,className:(0,o.cx)(E.inlineFieldNoMarginRight,E.inlineFieldWithSecret),disabled:h},n.default.createElement(i.SecretTextArea,{id:"client-auth-client-certificate-input",isConfigured:r,onChange:e=>d(e.currentTarget.value),onReset:h?()=>{}:p,placeholder:"Begins with --- BEGIN CERTIFICATE ---",rows:6,required:!0})),n.default.createElement(i.InlineField,{label:"Client Key",labelWidth:24,tooltip:null!==(b=null==v?void 0:v.keyLabel)&&void 0!==b?b:"The client key can be generated from a Certificate Authority or be self-signed",required:!0,htmlFor:"client-auth-client-key-input",interactive:!0,grow:!0,className:(0,o.cx)(E.inlineFieldNoMarginRight,E.inlineFieldWithSecret),disabled:h},n.default.createElement(i.SecretTextArea,{id:"client-auth-client-key-input",isConfigured:u,onChange:e=>f(e.currentTarget.value),onReset:h?()=>{}:g,placeholder:"Begins with --- RSA PRIVATE KEY CERTIFICATE ---",rows:6,required:!0})))}},31583:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TLSSettings=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(70014),l=r(70619),u=r(95840),s=r(78916);t.TLSSettings=({selfSignedCertificate:e,TLSClientAuth:t,skipTLSVerification:r,readOnly:c})=>{const{spacing:d}=(0,i.useTheme2)(),f={container:(0,o.css)({marginTop:d(3)})};return n.default.createElement(s.ConfigSubSection,{className:f.container,title:"TLS settings",description:"Additional security measures that can be applied on top of authentication"},n.default.createElement(a.SelfSignedCertificate,Object.assign({},e,{readOnly:c})),n.default.createElement(l.TLSClientAuth,Object.assign({},t,{readOnly:c})),n.default.createElement(u.SkipTLSVerification,Object.assign({},r,{readOnly:c})))}},66636:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TLSSettingsSection=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007);t.TLSSettingsSection=({children:e,enabled:t,label:r,tooltipText:a,onToggle:l,readOnly:u})=>{const{colors:s,spacing:c}=(0,i.useTheme2)(),d={container:(0,o.css)({marginTop:3}),checkboxContainer:(0,o.css)({display:"flex",alignItems:"center"}),infoIcon:(0,o.css)({marginTop:-2,marginLeft:5,color:s.text.secondary}),content:(0,o.css)({margin:c(1,0,2,3)})};return n.default.createElement("div",{className:d.container},n.default.createElement("div",{className:d.checkboxContainer},n.default.createElement(i.Checkbox,{value:t,label:r,onChange:()=>l(!t),disabled:u}),n.default.createElement(i.Tooltip,{placement:"top",content:a,interactive:!0},n.default.createElement(i.Icon,{name:"info-circle",className:d.infoIcon,size:"sm"}))),t&&e&&n.default.createElement("div",{className:d.content},e))}},75160:(e,t)=>{"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.AuthMethod=void 0,(r=t.AuthMethod||(t.AuthMethod={})).NoAuth="NoAuth",r.BasicAuth="BasicAuth",r.OAuthForward="OAuthForward",r.CrossSiteCredentials="CrossSiteCredentials"},85316:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCustomHeaders=t.getTLSProps=t.getBasicAuthProps=t.getOnAuthMethodSelectHandler=t.getSelectedMethod=t.convertLegacyAuthProps=void 0;const n=r(75160),o="httpHeaderName",i="httpHeaderValue";function a(e){return e.basicAuth?n.AuthMethod.BasicAuth:e.withCredentials?n.AuthMethod.CrossSiteCredentials:e.jsonData.oauthPassThru?n.AuthMethod.OAuthForward:n.AuthMethod.NoAuth}function l(e,t){return r=>{t(Object.assign(Object.assign({},e),{basicAuth:r===n.AuthMethod.BasicAuth,withCredentials:r===n.AuthMethod.CrossSiteCredentials,jsonData:Object.assign(Object.assign({},e.jsonData),{oauthPassThru:r===n.AuthMethod.OAuthForward})}))}}function u(e,t){return{user:e.basicAuthUser,passwordConfigured:e.secureJsonFields.basicAuthPassword,onUserChange:r=>t(Object.assign(Object.assign({},e),{basicAuthUser:r})),onPasswordChange:r=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{basicAuthPassword:r})})),onPasswordReset:()=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{basicAuthPassword:""}),secureJsonFields:Object.assign(Object.assign({},e.secureJsonFields),{basicAuthPassword:!1})}))}}function s(e,t){return{selfSignedCertificate:{enabled:Boolean(e.jsonData.tlsAuthWithCACert),certificateConfigured:e.secureJsonFields.tlsCACert,onToggle:r=>t(r?Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{tlsAuthWithCACert:r})}):Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{tlsAuthWithCACert:r}),secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsCACert:""}),secureJsonFields:Object.assign(Object.assign({},e.secureJsonFields),{tlsCACert:!1})})),onCertificateChange:r=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsCACert:r})})),onCertificateReset:()=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsCACert:""}),secureJsonFields:Object.assign(Object.assign({},e.secureJsonFields),{tlsCACert:!1})}))},TLSClientAuth:{enabled:e.jsonData.tlsAuth,serverName:e.jsonData.serverName,clientCertificateConfigured:e.secureJsonFields.tlsClientCert,clientKeyConfigured:e.secureJsonFields.tlsClientKey,onToggle:r=>t(r?Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{tlsAuth:r})}):Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{tlsAuth:r,serverName:""}),secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsClientCert:"",tlsClientKey:""}),secureJsonFields:Object.assign(Object.assign({},e.secureJsonFields),{tlsClientCert:!1,tlsClientKey:!1})})),onServerNameChange:r=>t(Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{serverName:r})})),onClientCertificateChange:r=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsClientCert:r})})),onClientCertificateReset:()=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsClientCert:""}),secureJsonFields:Object.assign(Object.assign({},e.secureJsonFields),{tlsClientCert:!1})})),onClientKeyChange:r=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsClientKey:r})})),onClientKeyReset:()=>t(Object.assign(Object.assign({},e),{secureJsonData:Object.assign(Object.assign({},e.secureJsonData),{tlsClientKey:""}),secureJsonFields:Object.assign(Object.assign({},e.secureJsonFields),{tlsClientKey:!1})}))},skipTLSVerification:{enabled:e.jsonData.tlsSkipVerify,onToggle:r=>t(Object.assign(Object.assign({},e),{jsonData:Object.assign(Object.assign({},e.jsonData),{tlsSkipVerify:r})}))}}}function c(e,t){return{headers:Object.keys(e.jsonData).filter((e=>e.startsWith(o))).sort().map((t=>{var r;const n=t.slice(14);return{name:e.jsonData[t],configured:null!==(r=e.secureJsonFields[`${i}${n}`])&&void 0!==r&&r}})),onChange:r=>{const n=Object.fromEntries(Object.entries(e.jsonData).filter((([e])=>!e.startsWith(o)))),a=Object.fromEntries(Object.entries(e.secureJsonData||{}).filter((([e])=>!e.startsWith(i)))),l=Object.fromEntries(Object.entries(e.secureJsonFields).filter((([e])=>!e.startsWith(i))));r.forEach(((e,t)=>{n[`${o}${t+1}`]=e.name,e.configured?l[`${i}${t+1}`]=!0:a[`${i}${t+1}`]=e.value})),t(Object.assign(Object.assign({},e),{jsonData:n,secureJsonData:a,secureJsonFields:l}))}}}t.convertLegacyAuthProps=function({config:e,onChange:t}){return{selectedMethod:a(e),onAuthMethodSelect:l(e,t),basicAuth:u(e,t),TLS:s(e,t),customHeaders:c(e,t),readOnly:e.readOnly}},t.getSelectedMethod=a,t.getOnAuthMethodSelectHandler=l,t.getBasicAuthProps=u,t.getTLSProps=s,t.getCustomHeaders=c},22896:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigDescriptionLink=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007);t.ConfigDescriptionLink=function(e){const{description:t,suffix:r,feature:n}=e,o=`Learn more about ${n}`,u=(0,a.useStyles2)(l);return i.default.createElement("span",{className:u.container},t,i.default.createElement("a",{"aria-label":o,href:`https://grafana.com/docs/grafana/next/datasources/${r}`,rel:"noreferrer",target:"_blank"},o))};const l=e=>({container:(0,o.css)({color:e.colors.text.secondary,a:(0,o.css)({color:e.colors.text.link,textDecoration:"underline",marginLeft:"5px","&:hover":{textDecoration:"none"}})})})},68633:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigSection=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(81900);t.ConfigSection=e=>{var{children:t}=e,r=n.__rest(e,["children"]);return o.default.createElement(i.GenericConfigSection,Object.assign({},r,{kind:"section"}),t)}},90125:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigSubSection=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(81900);t.ConfigSubSection=e=>{var{children:t}=e,r=n.__rest(e,["children"]);return o.default.createElement(i.GenericConfigSection,Object.assign({},r,{kind:"sub-section"}),t)}},81900:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GenericConfigSection=void 0;const n=r(91666).__importStar(r(85959)),o=r(46089),i=r(82007);t.GenericConfigSection=({children:e,title:t,description:r,isCollapsible:a=!1,isInitiallyOpen:l=!0,kind:u="section",className:s})=>{const{colors:c,typography:d,spacing:f}=(0,i.useTheme2)(),[p,g]=(0,n.useState)(!a||l),v=p?"angle-up":"angle-down",h="sub-section"===u,m=`${p?"Collapse":"Expand"} section ${t}`,y={header:(0,o.css)({display:"flex",justifyContent:"space-between",alignItems:"center"}),title:(0,o.css)({margin:0}),subtitle:(0,o.css)({margin:0,fontWeight:d.fontWeightRegular}),descriptionText:(0,o.css)(Object.assign(Object.assign({marginTop:f(h?.25:.5),marginBottom:0},d.bodySmall),{color:c.text.secondary})),content:(0,o.css)({marginTop:f(2)})};return n.default.createElement("div",{className:s},n.default.createElement("div",{className:y.header},"section"===u?n.default.createElement("h3",{className:y.title},t):n.default.createElement("h6",{className:y.subtitle},t),a&&n.default.createElement(i.IconButton,{name:v,onClick:()=>g(!p),type:"button",size:"xl","aria-label":m})),r&&n.default.createElement("p",{className:y.descriptionText},r),p&&n.default.createElement("div",{className:y.content},e))}},78916:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigDescriptionLink=t.ConfigSubSection=t.ConfigSection=void 0;var n=r(68633);Object.defineProperty(t,"ConfigSection",{enumerable:!0,get:function(){return n.ConfigSection}});var o=r(90125);Object.defineProperty(t,"ConfigSubSection",{enumerable:!0,get:function(){return o.ConfigSubSection}});var i=r(22896);Object.defineProperty(t,"ConfigDescriptionLink",{enumerable:!0,get:function(){return i.ConfigDescriptionLink}})},63182:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConnectionSettings=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(78916);t.ConnectionSettings=({config:e,onChange:t,description:r,urlPlaceholder:l,urlTooltip:u,urlLabel:s,className:c})=>{const d=/^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/.test(e.url),f={container:(0,o.css)({maxWidth:578})};return n.default.createElement(n.default.Fragment,null,n.default.createElement(a.ConfigSection,{title:"Connection",description:r,className:(0,o.cx)(f.container,c)},n.default.createElement(i.InlineField,{htmlFor:"connection-url",label:s||"URL",labelWidth:24,tooltip:u||n.default.createElement(n.default.Fragment,null,"Specify a complete HTTP URL",n.default.createElement("br",null),"(for example https://example.com:8080)"),grow:!0,disabled:e.readOnly,required:!0,invalid:!d&&!e.readOnly,error:d?"":"Please enter a valid URL",interactive:!0},n.default.createElement(i.Input,{id:"connection-url","aria-label":"Data source connection URL",onChange:r=>t(Object.assign(Object.assign({},e),{url:r.currentTarget.value})),value:e.url||"",placeholder:l||"URL"}))))}},78475:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConnectionSettings=void 0;var n=r(63182);Object.defineProperty(t,"ConnectionSettings",{enumerable:!0,get:function(){return n.ConnectionSettings}})},80363:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataSourceDescription=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007);t.DataSourceDescription=({dataSourceName:e,docsLink:t,hasRequiredFields:r=!0,className:a})=>{const l=(0,i.useTheme2)(),u={container:(0,o.css)({p:{margin:0},"p + p":{marginTop:l.spacing(2)}}),text:(0,o.css)(Object.assign(Object.assign({},l.typography.body),{color:l.colors.text.secondary,a:(0,o.css)({color:l.colors.text.link,textDecoration:"underline","&:hover":{textDecoration:"none"}})}))};return n.default.createElement("div",{className:(0,o.cx)(u.container,a)},n.default.createElement("p",{className:u.text},"Before you can use the ",e," data source, you must configure it below or in the config file. For detailed instructions,"," ",n.default.createElement("a",{href:t,target:"_blank",rel:"noreferrer"},"view the documentation"),"."),r&&n.default.createElement("p",{className:u.text},n.default.createElement("i",null,"Fields marked with * are required")))}},72626:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SecureSocksProxyToggle=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(82007),a=r(18531);t.SecureSocksProxyToggle=e=>{var{labelWidth:t=10}=e,r=n.__rest(e,["labelWidth"]);const{dataSourceConfig:l,onChange:u}=r;return a.config.secureSocksDSProxyEnabled&&o.default.createElement("div",null,o.default.createElement("div",{className:"gf-form"},o.default.createElement("div",{className:"gf-form gf-form-inline"},o.default.createElement(i.InlineField,{htmlFor:"secureSocksProxyEnabled",label:"Secure Socks Proxy Enabled",labelWidth:t,tooltip:o.default.createElement(o.default.Fragment,null,"Proxy the datasource connection through the secure socks proxy to a different network. To learn more about configuring the datasource connection proxy,"," ",o.default.createElement("a",{href:"https://grafana.com/docs/grafana/latest/setup-grafana/configure-grafana/proxy/",target:"_blank",rel:"noopener noreferrer"},"click here."))},o.default.createElement(i.InlineSwitch,{id:"secureSocksProxyEnabled",value:l.jsonData.enableSecureSocksProxy,onChange:e=>{u(Object.assign(Object.assign({},l),{jsonData:Object.assign(Object.assign({},l.jsonData),{enableSecureSocksProxy:e.target.checked})}))}})))))}},15134:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AdvancedHttpSettings=t.ConnectionSettings=t.convertLegacyAuthProps=t.AuthMethod=t.Auth=t.ConfigDescriptionLink=t.ConfigSubSection=t.ConfigSection=t.DataSourceDescription=t.SecureSocksProxyToggle=void 0;var n=r(72626);Object.defineProperty(t,"SecureSocksProxyToggle",{enumerable:!0,get:function(){return n.SecureSocksProxyToggle}});var o=r(80363);Object.defineProperty(t,"DataSourceDescription",{enumerable:!0,get:function(){return o.DataSourceDescription}});var i=r(78916);Object.defineProperty(t,"ConfigSection",{enumerable:!0,get:function(){return i.ConfigSection}}),Object.defineProperty(t,"ConfigSubSection",{enumerable:!0,get:function(){return i.ConfigSubSection}}),Object.defineProperty(t,"ConfigDescriptionLink",{enumerable:!0,get:function(){return i.ConfigDescriptionLink}});var a=r(66678);Object.defineProperty(t,"Auth",{enumerable:!0,get:function(){return a.Auth}}),Object.defineProperty(t,"AuthMethod",{enumerable:!0,get:function(){return a.AuthMethod}}),Object.defineProperty(t,"convertLegacyAuthProps",{enumerable:!0,get:function(){return a.convertLegacyAuthProps}});var l=r(78475);Object.defineProperty(t,"ConnectionSettings",{enumerable:!0,get:function(){return l.ConnectionSettings}});var u=r(4948);Object.defineProperty(t,"AdvancedHttpSettings",{enumerable:!0,get:function(){return u.AdvancedHttpSettings}})},81751:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomHeadersSettings=void 0;const n=r(91666).__importStar(r(85959)),o=r(46089),i=r(93241),a=r(82007),l=(0,a.stylesFactory)((()=>({layout:o.css`
      display: flex;
      align-items: center;
      margin-bottom: 4px;
      > * {
        margin-left: 4px;
        margin-bottom: 0;
        height: 100%;
        &:first-child,
        &:last-child {
          margin-left: 0;
        }
      }
    `}))),u=({header:e,onBlur:t,onChange:r,onRemove:o,onReset:i})=>{const u=l();return n.default.createElement("div",{className:u.layout},n.default.createElement(a.LegacyForms.FormField,{label:"Header",name:"name",placeholder:"X-Custom-Header",labelWidth:5,value:e.name||"",onChange:t=>r(Object.assign(Object.assign({},e),{name:t.target.value})),onBlur:t}),n.default.createElement(a.LegacyForms.SecretFormField,{label:"Value","aria-label":"Value",name:"value",isConfigured:e.configured,value:e.value,labelWidth:5,inputWidth:e.configured?11:12,placeholder:"Header Value",onReset:()=>i(e.id),onChange:t=>r(Object.assign(Object.assign({},e),{value:t.target.value})),onBlur:t}),n.default.createElement(a.Button,{type:"button","aria-label":"Remove header",variant:"secondary",size:"xs",onClick:t=>o(e.id)},n.default.createElement(a.Icon,{name:"trash-alt"})))};u.displayName="CustomHeaderRow";class s extends n.PureComponent{constructor(e){super(e),this.state={headers:[]},this.updateSettings=()=>{const{headers:e}=this.state,t=Object.fromEntries(Object.entries(this.props.dataSourceConfig.jsonData).filter((([e,t])=>!e.startsWith("httpHeaderName")))),r=Object.fromEntries(Object.entries(this.props.dataSourceConfig.secureJsonData||{}).filter((([e,t])=>!e.startsWith("httpHeaderValue"))));for(const[n,o]of e.entries())t[`httpHeaderName${n+1}`]=o.name,o.configured||(r[`httpHeaderValue${n+1}`]=o.value);this.props.onChange(Object.assign(Object.assign({},this.props.dataSourceConfig),{jsonData:t,secureJsonData:r}))},this.onHeaderAdd=()=>{this.setState((e=>({headers:[...e.headers,{id:(0,i.uniqueId)(),name:"",value:"",configured:!1}]})))},this.onHeaderChange=(e,t)=>{this.setState((({headers:r})=>({headers:r.map(((r,n)=>e!==n?r:Object.assign({},t)))})))},this.onHeaderReset=e=>{this.setState((({headers:t})=>({headers:t.map(((t,r)=>t.id!==e?t:Object.assign(Object.assign({},t),{value:"",configured:!1})))})))},this.onHeaderRemove=e=>{this.setState((({headers:t})=>({headers:t.filter((t=>t.id!==e))})),this.updateSettings)};const{jsonData:t,secureJsonData:r,secureJsonFields:n}=this.props.dataSourceConfig;this.state={headers:Object.keys(t).sort().filter((e=>e.startsWith("httpHeaderName"))).map(((e,o)=>({id:(0,i.uniqueId)(),name:t[e],value:void 0!==r?r[e]:"",configured:n&&n[`httpHeaderValue${o+1}`]||!1})))}}render(){const{headers:e}=this.state;return n.default.createElement("div",{className:"gf-form-group"},n.default.createElement("div",{className:"gf-form"},n.default.createElement("h6",null,"Custom HTTP Headers")),n.default.createElement("div",null,e.map(((e,t)=>n.default.createElement(u,{key:e.id,header:e,onChange:e=>{this.onHeaderChange(t,e)},onBlur:this.updateSettings,onRemove:this.onHeaderRemove,onReset:this.onHeaderReset})))),n.default.createElement("div",{className:"gf-form"},n.default.createElement(a.Button,{variant:"secondary",icon:"plus",type:"button",onClick:e=>{this.onHeaderAdd()}},"Add header")))}}t.CustomHeadersSettings=s,t.default=s},22220:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataLink=void 0;const n=r(91666).__importStar(r(85959)),o=r(46089),i=r(82007),{FormField:a,Switch:l}=i.LegacyForms,u=r(78131),s=r(83783),c=(0,i.stylesFactory)((()=>({firstRow:o.css`
    display: flex;
  `,nameField:o.css`
    flex: 2;
  `,regexField:o.css`
    flex: 3;
  `,row:o.css`
    display: flex;
    align-items: baseline;
  `})));t.DataLink=e=>{const{value:t,onChange:r,onDelete:d,suggestions:f,className:p}=e,g=c(),[v,h]=function(e){const[t,r]=(0,n.useState)(!!e),o=(0,u.usePrevious)(e);return(0,n.useEffect)((()=>{o||!e||t||r(!0),o&&!e&&t&&r(!1)}),[o,e,t]),[t,r]}(t.datasourceUid),m=e=>n=>{r(Object.assign(Object.assign({},t),{[e]:n.currentTarget.value}))};return n.default.createElement("div",{className:p},n.default.createElement("div",{className:g.firstRow+" gf-form"},n.default.createElement(a,{className:g.nameField,labelWidth:6,inputWidth:null,label:"Field",type:"text",value:t.field,tooltip:"Can be exact field name or a regex pattern that will match on the field name.",onChange:m("field")}),n.default.createElement(i.Button,{variant:"destructive",title:"Remove field",icon:"times",onClick:e=>{e.preventDefault(),d()}})),n.default.createElement("div",{className:"gf-form"},n.default.createElement(a,{className:g.nameField,inputWidth:null,label:"Label",type:"text",value:t.label,onChange:m("label"),tooltip:"Use to provide a meaningful label to the data matched in the regex"}),n.default.createElement(a,{className:g.regexField,inputWidth:null,label:"Regex",type:"text",value:t.matcherRegex,onChange:m("matcherRegex"),tooltip:"Use to parse and capture some part of the log message. You can use the captured groups in the template."})),n.default.createElement("div",{className:"gf-form"},n.default.createElement(a,{label:v?"Query":"URL",labelWidth:6,inputEl:n.default.createElement(i.DataLinkInput,{placeholder:v?"${__value.raw}":"http://example.com/${__value.raw}",value:t.url||"",onChange:e=>r(Object.assign(Object.assign({},t),{url:e})),suggestions:f}),className:o.css`
            width: 100%;
          `})),n.default.createElement("div",{className:g.row},n.default.createElement(l,{labelClass:"width-6",label:"Internal link",checked:v,onChange:()=>{v&&r(Object.assign(Object.assign({},t),{datasourceUid:void 0})),h(!v)}}),v&&n.default.createElement(s.DataSourcePicker,{onChange:e=>{r(Object.assign(Object.assign({},t),{datasourceUid:e.uid}))},current:t.datasourceUid})))}},43395:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataLinks=void 0;const n=r(91666).__importDefault(r(85959)),o=r(46089),i=r(82007),a=r(87781),l=r(22220);t.DataLinks=e=>{const{value:t,onChange:r}=e,u=(s=(0,i.useTheme2)(),{infoText:o.css`
    padding-bottom: ${s.v1.spacing.md};
    color: ${s.v1.colors.textWeak};
  `,dataLink:o.css`
    margin-bottom: ${s.v1.spacing.sm};
  `});var s;return n.default.createElement(n.default.Fragment,null,n.default.createElement("h3",{className:"page-heading"},"Data links"),n.default.createElement("div",{className:u.infoText},"Add links to existing fields. Links will be shown in log row details next to the field value."),n.default.createElement("div",{className:"gf-form-group"},t&&t.map(((e,o)=>n.default.createElement(l.DataLink,{className:u.dataLink,key:o,value:e,onChange:e=>{const n=[...t];n.splice(o,1,e),r(n)},onDelete:()=>{const e=[...t];e.splice(o,1),r(e)},suggestions:[{value:a.DataLinkBuiltInVars.valueRaw,label:"Raw value",documentation:"Raw value of the field",origin:a.VariableOrigin.Value}]}))),n.default.createElement("div",null,n.default.createElement(i.Button,{variant:"secondary",className:o.css`
              margin-right: 10px;
            `,icon:"plus",onClick:e=>{e.preventDefault();const n=[...t||[],{field:"",label:"",matcherRegex:"",url:""}];r(n)}},"Add"))))}},96674:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});const n=r(91666);n.__exportStar(r(12671),t),n.__exportStar(r(43395),t),n.__exportStar(r(22220),t)},12671:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},83783:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataSourcePicker=void 0;const n=r(91666).__importStar(r(85959)),o=r(82007),i=r(75174),a=r(24997),l=r(18531);class u extends n.PureComponent{constructor(e){super(e),this.dataSourceSrv=(0,l.getDataSourceSrv)(),this.state={},this.onChange=e=>{const t=this.dataSourceSrv.getInstanceSettings(e.value);t&&(this.props.onChange(t),this.setState({error:void 0}))}}componentDidMount(){const{current:e}=this.props;this.dataSourceSrv.getInstanceSettings(e)||this.setState({error:"Could not find data source "+e})}getCurrentValue(){const{current:e,hideTextValue:t,noDefault:r}=this.props;if(!e&&r)return{label:"No datasources found"};const n=this.dataSourceSrv.getInstanceSettings(e);return n?{label:n.name.substr(0,37),value:n.name,imgUrl:n.meta.info.logos.small,hideText:t,meta:n.meta}:{label:(null!=e?e:"no name")+" - not found",value:(null!=e?e:"no name")+" - not found",imgUrl:"",hideText:t}}getDataSourceOptions(){return this.dataSourceSrv.getList().map((e=>({value:e.uid,label:e.name,imgUrl:e.meta.info.logos.small,meta:e.meta})))}render(){const{autoFocus:e,onBlur:t,openMenuOnFocus:r,placeholder:l}=this.props,{error:u}=this.state,s=this.getDataSourceOptions(),c=this.getCurrentValue();return n.default.createElement("div",{"aria-label":i.selectors.components.DataSourcePicker.container},n.default.createElement(o.Select,{className:"ds-picker select-container",isMulti:!1,isClearable:!1,backspaceRemovesValue:!1,onChange:this.onChange,options:s,autoFocus:e,onBlur:t,openMenuOnFocus:r,maxMenuHeight:500,placeholder:l,noOptionsMessage:"No datasources found",value:c,invalid:!!u,getOptionLabel:e=>e.meta&&(0,a.isUnsignedPluginSignature)(e.meta.signature)&&e!==c?n.default.createElement(o.HorizontalGroup,{align:"center",justify:"space-between"},n.default.createElement("span",null,e.label)," ",n.default.createElement(a.PluginSignatureBadge,{status:e.meta.signature})):e.label||""}))}}t.DataSourcePicker=u,u.defaultProps={autoFocus:!1,openMenuOnFocus:!1,placeholder:"Select datasource"}},80341:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DatePicker=void 0;const n=r(91666),o=n.__importStar(r(85959)),i=n.__importDefault(r(9636)),a=r(82007),l=r(53169);t.DatePicker=(0,o.memo)((e=>{const t=(0,a.useTheme2)(),r=(0,l.getStyles)(t),{isOpen:n,onClose:i}=e;return n?o.default.createElement(a.ClickOutsideWrapper,{useCapture:!0,includeButtonPress:!1,onClick:i},o.default.createElement("div",{className:r.modal,"data-testid":"date-picker"},o.default.createElement(u,Object.assign({},e)))):null})),t.DatePicker.displayName="DatePicker";const u=(0,o.memo)((({value:e,onChange:t})=>{const r=(0,a.useTheme2)(),n=(0,l.getBodyStyles)(r);return o.default.createElement(i.default,{className:n.body,tileClassName:n.title,value:e||new Date,nextLabel:o.default.createElement(a.Icon,{name:"angle-right"}),prevLabel:o.default.createElement(a.Icon,{name:"angle-left"}),onChange:e=>{Array.isArray(e)||t(e)},locale:"en"})}));u.displayName="Body"},53169:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getBodyStyles=t.getStyles=void 0;const n=r(46089);t.getStyles=e=>{const t=e.isDark?e.v1.palette.dark9:e.v1.palette.gray5;return{container:n.css`
      top: -1px;
      position: absolute;
      right: 544px;
      box-shadow: 0px 0px 20px ${e.v1.colors.dropdownShadow};
      background-color: ${e.v1.colors.bodyBg};
      z-index: -1;
      border: 1px solid ${t};
      border-radius: 2px 0 0 2px;

      &:after {
        display: block;
        background-color: ${e.v1.colors.bodyBg};
        width: 19px;
        height: 100%;
        content: '';
        position: absolute;
        top: 0;
        right: -19px;
        border-left: 1px solid ${e.v1.colors.border1};
      }
    `,modal:n.css`
      z-index: ${e.v1.zIndex.modal};
    `,content:n.css`
      margin: 0 auto;
      width: 268px;
    `,backdrop:n.css`
      position: fixed;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: #202226;
      opacity: 0.7;
      z-index: ${e.v1.zIndex.modalBackdrop};
      text-align: center;
    `}},t.getBodyStyles=e=>{const t=e.isDark?e.v1.palette.dark9:e.v1.palette.gray5;return{title:n.css`
      color: ${e.colors.text};
      background-color: ${e.v1.colors.bodyBg};
      font-size: ${e.v1.typography.size.md};
      border: 1px solid transparent;

      &:hover {
        position: relative;
      }
    `,body:n.css`
      z-index: ${e.zIndex.modal};
      position: fixed;
      background-color: ${e.v1.colors.bodyBg};
      width: 268px;

      box-shadow: 0px 0px 20px ${e.v1.colors.dropdownShadow};
      border: 1px solid ${t};
      border-radius: 2px 0 0 2px;

      .react-calendar__navigation__label,
      .react-calendar__navigation__arrow,
      .react-calendar__navigation {
        padding-top: 4px;
        background-color: inherit;
        color: ${e.colors.text};
        border: 0;
        font-weight: ${e.v1.typography.weight.semibold};
      }

      .react-calendar__month-view__weekdays {
        background-color: inherit;
        text-align: center;
        color: ${e.v1.palette.blue77};

        abbr {
          border: 0;
          text-decoration: none;
          cursor: default;
          display: block;
          padding: 4px 0 4px 0;
        }
      }

      .react-calendar__month-view__days {
        background-color: inherit;
      }

      .react-calendar__tile,
      .react-calendar__tile--now {
        margin-bottom: 4px;
        background-color: inherit;
        height: 26px;
      }

      .react-calendar__navigation__label,
      .react-calendar__navigation > button:focus,
      .time-picker-calendar-tile:focus {
        outline: 0;
      }

      .react-calendar__tile--active,
      .react-calendar__tile--active:hover {
        color: ${e.v1.palette.white};
        font-weight: ${e.v1.typography.weight.semibold};
        background: ${e.v1.palette.blue95};
        box-shadow: none;
        border: 0px;
      }

      .react-calendar__tile--rangeEnd,
      .react-calendar__tile--rangeStart {
        padding: 0;
        border: 0px;
        color: ${e.v1.palette.white};
        font-weight: ${e.v1.typography.weight.semibold};
        background: ${e.v1.palette.blue95};

        abbr {
          background-color: ${e.v1.palette.blue77};
          border-radius: 100px;
          display: block;
          padding-top: 2px;
          height: 26px;
        }
      }

      .react-calendar__tile--rangeStart {
        border-top-left-radius: 20px;
        border-bottom-left-radius: 20px;
      }

      .react-calendar__tile--rangeEnd {
        border-top-right-radius: 20px;
        border-bottom-right-radius: 20px;
      }
    `}}},16631:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DatePickerWithInput=t.formatDate=void 0;const n=r(91666),o=r(82007),i=n.__importDefault(r(85959)),a=r(80341);r(52298),t.formatDate=e=>e.toISOString().split("T")[0],t.DatePickerWithInput=e=>{const{value:r,onChange:l,className:u}=e,s=n.__rest(e,["value","onChange","className"]),[c,d]=i.default.useState(!1);let f="grafana-plugin-ui-date-input";return u&&(f+=` ${u}`),i.default.createElement(i.default.Fragment,null,i.default.createElement(o.Input,Object.assign({type:"date",placeholder:"Date",value:(0,t.formatDate)(r||new Date),onClick:()=>d(!0),onChange:()=>{},className:f},s)),i.default.createElement(a.DatePicker,{isOpen:c,value:r,onChange:e=>l(e),onClose:()=>d(!1)}))}},61315:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebounceInput=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(82007),a=r(38692);t.DebounceInput=e=>{const{delay:t,onDebounce:r,value:l}=e,u=n.__rest(e,["delay","onDebounce","value"]),[s,c]=o.default.useState(l),d=(0,a.useDebounce)(s,t);return o.default.useEffect((()=>r(d)),[d]),o.default.useEffect((()=>c(l)),[l]),o.default.createElement(i.Input,Object.assign({onChange:e=>c(e.currentTarget.value),value:s},u))}},24997:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapPluginErrorCodeToSignatureStatus=t.isUnsignedPluginSignature=t.PluginSignatureBadge=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(82007),a=r(87781);t.PluginSignatureBadge=e=>{var{status:t}=e,r=n.__rest(e,["status"]);const l=function(e){switch(e||(e=a.PluginSignatureStatus.invalid),e){case a.PluginSignatureStatus.internal:return{text:"Core",icon:"cube",color:"blue",tooltip:"Core plugin that is bundled with Grafana"};case a.PluginSignatureStatus.valid:return{text:"Signed",icon:"lock",color:"green",tooltip:"Signed and verified plugin"};case a.PluginSignatureStatus.invalid:return{text:"Invalid signature",icon:"exclamation-triangle",color:"red",tooltip:"Invalid plugin signature"};case a.PluginSignatureStatus.modified:return{text:"Modified signature",icon:"exclamation-triangle",color:"red",tooltip:"Valid signature but content has been modified"};case a.PluginSignatureStatus.missing:return{text:"Missing signature",icon:"exclamation-triangle",color:"red",tooltip:"Missing plugin signature"}}return{text:"Unsigned",icon:"exclamation-triangle",color:"red",tooltip:"Unsigned external plugin"}}(t);return o.default.createElement(i.Badge,Object.assign({text:l.text,color:l.color,icon:l.icon,tooltip:l.tooltip},r))},t.isUnsignedPluginSignature=function(e){return e&&e!==a.PluginSignatureStatus.valid&&e!==a.PluginSignatureStatus.internal},t.mapPluginErrorCodeToSignatureStatus=function(e){switch(e){case a.PluginErrorCode.invalidSignature:return a.PluginSignatureStatus.invalid;case a.PluginErrorCode.missingSignature:return a.PluginSignatureStatus.missing;case a.PluginErrorCode.modifiedSignature:return a.PluginSignatureStatus.modified;default:return a.PluginSignatureStatus.missing}},t.PluginSignatureBadge.displayName="PluginSignatureBadge"},37392:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AccessoryButton=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007);t.AccessoryButton=e=>{var{className:t}=e,r=n.__rest(e,["className"]);const u=(0,a.useStyles2)(l);return i.default.createElement(a.Button,Object.assign({},r,{className:(0,o.cx)(t,u.button)}))};const l=e=>({button:(0,o.css)({paddingLeft:e.spacing(1.5),paddingRight:e.spacing(1.5)})})},60897:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfirmModal=void 0;const n=r(91666).__importStar(r(85959)),o=r(82007);t.ConfirmModal=function({isOpen:e,onCancel:t,onDiscard:r,onCopy:i}){const a=(0,n.useRef)(null);return(0,n.useEffect)((()=>{var t;e&&(null===(t=a.current)||void 0===t||t.focus())}),[e]),n.default.createElement(o.Modal,{title:n.default.createElement("div",{className:"modal-header-title"},n.default.createElement(o.Icon,{name:"exclamation-triangle",size:"lg"}),n.default.createElement("span",{className:"p-l-1"},"Warning")),onDismiss:t,isOpen:e},n.default.createElement("p",null,"Builder mode does not display changes made in code. The query builder will display the last changes you made in builder mode."),n.default.createElement("p",null,"Do you want to copy your code to the clipboard?"),n.default.createElement(o.Modal.ButtonRow,null,n.default.createElement(o.Button,{type:"button",variant:"secondary",onClick:t,fill:"outline"},"Cancel"),n.default.createElement(o.Button,{variant:"destructive",type:"button",onClick:r,ref:a},"Discard code and switch"),n.default.createElement(o.Button,{variant:"primary",onClick:i},"Copy code and switch")))}},4639:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DatasetSelector=void 0;const n=r(91666),o=n.__importStar(r(85959)),i=r(78131),a=r(82007),l=r(37079);t.DatasetSelector=({db:e,dataset:t,value:r,onChange:u,disabled:s,className:c,applyDefault:d})=>{const f=(0,i.useAsync)((()=>n.__awaiter(void 0,void 0,void 0,(function*(){return t?(u((0,l.toOption)(t)),[(0,l.toOption)(t)]):(yield e.datasets()).map(l.toOption)}))),[]);return(0,o.useEffect)((()=>{d&&(r?f.value&&void 0===f.value.find((e=>e.value===r))&&f.value.length>0&&u(f.value[0]):f.value&&f.value[0]&&u(f.value[0]))}),[f.value,r,d,u]),o.default.createElement(a.Select,{className:c,"aria-label":"Dataset selector",value:r,options:f.value,onChange:u,disabled:s,isLoading:f.loading,menuShouldPortal:!0})}},84997:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorField=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007);t.EditorField=e=>{const{label:t,optional:r,tooltip:o,tooltipInteractive:u,children:s,width:c}=e,d=n.__rest(e,["label","optional","tooltip","tooltipInteractive","children","width"]),f=(0,a.useStyles2)(l,c),p=(null==d?void 0:d.htmlFor)||(null===a.ReactUtils||void 0===a.ReactUtils?void 0:a.ReactUtils.getChildId(s)),g=i.default.createElement(i.default.Fragment,null,i.default.createElement("label",{className:f.label,htmlFor:p},t,r&&i.default.createElement("span",{className:f.optional}," - optional"),o&&i.default.createElement(a.Tooltip,{placement:"top",content:o,theme:"info",interactive:u},i.default.createElement(a.Icon,{tabIndex:0,name:"info-circle",size:"sm",className:f.icon}))),i.default.createElement(a.Space,{v:.5}));return i.default.createElement("div",{className:f.root},i.default.createElement(a.Field,Object.assign({className:f.field,label:g},d),s))};const l=(e,t)=>({root:(0,o.css)({minWidth:e.spacing(null!=t?t:0)}),label:(0,o.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),optional:(0,o.css)({fontStyle:"italic",color:e.colors.text.secondary}),field:(0,o.css)({marginBottom:0}),icon:(0,o.css)({color:e.colors.text.secondary,marginLeft:e.spacing(1),":hover":{color:e.colors.text.primary}})})},99398:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorFieldGroup=void 0;const n=r(91666).__importDefault(r(85959)),o=r(79641);t.EditorFieldGroup=({children:e})=>n.default.createElement(o.EditorStack,{gap:1},e)},24772:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorHeader=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007);t.EditorHeader=({children:e})=>{const t=(0,a.useStyles2)(l);return i.default.createElement("div",{className:t.root},e)};const l=e=>({root:(0,o.css)({display:"flex",flexWrap:"wrap",alignItems:"center",gap:e.spacing(3),minHeight:e.spacing(4)})})},3373:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorList=void 0;const n=r(91666),o=r(82007),i=n.__importDefault(r(85959)),a=r(79641);t.EditorList=i.default.forwardRef((function({items:e,renderItem:t,onChange:r},n){return i.default.createElement(a.EditorStack,null,e.map(((n,o)=>i.default.createElement("div",{key:o},t(n,(t=>((t,n)=>{const o=[...e];o[t]=n,r(o)})(o,t)),(()=>(t=>{const n=[...e];n.splice(t,1),r(n)})(o)))))),i.default.createElement(o.Button,{ref:n,onClick:()=>{const t=[...e,{}];r(t)},variant:"secondary",size:"md",icon:"plus","aria-label":"Add",type:"button"}))}))},24637:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorRow=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007),l=r(79641);t.EditorRow=({children:e})=>{const t=(0,a.useStyles2)(u);return i.default.createElement("div",{className:t.root},i.default.createElement(l.EditorStack,{gap:2},e))};const u=e=>({root:(0,o.css)({padding:e.spacing(1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.radius.default})})},1912:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorRows=void 0;const n=r(91666).__importDefault(r(85959)),o=r(79641);t.EditorRows=({children:e})=>n.default.createElement(o.EditorStack,{gap:.5,direction:"column"},e)},79641:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorStack=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(82007);t.EditorStack=e=>{var t,r,{children:a,wrap:l=!0}=e,u=n.__rest(e,["children","wrap"]);return o.default.createElement(i.Stack,Object.assign({wrap:l?"wrap":void 0,direction:null!==(t=u.direction)&&void 0!==t?t:"row",gap:null!==(r=u.gap)&&void 0!==r?r:2},u),a)}},27153:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSwitch=void 0;const n=r(91666),o=r(46089),i=r(82007),a=n.__importDefault(r(85959));t.EditorSwitch=e=>{const t=l();return a.default.createElement("div",{className:t.switch},a.default.createElement(i.Switch,Object.assign({},e)))};const l=()=>({switch:(0,o.css)({display:"flex",alignItems:"center",minHeight:30})})},89464:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FlexItem=void 0;const n=r(91666).__importDefault(r(85959));t.FlexItem=({grow:e,shrink:t})=>n.default.createElement("div",{style:{display:"block",flexGrow:e,flexShrink:t}})},90413:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineSelect=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(82007);t.InlineSelect=function(e){var{label:t}=e,r=n.__rest(e,["label"]);const[o]=(0,i.useState)((()=>Math.random().toString(16).slice(2))),c=(0,a.useStyles2)(s),d={SelectContainer:l,ValueContainer:u,SingleValue:u};return i.default.createElement("div",{className:c.root},t&&i.default.createElement("label",{className:c.label,htmlFor:o},t,":"," "),i.default.createElement(a.Select,Object.assign({openMenuOnFocus:!0,inputId:o},r,{components:d})))};const l=e=>{const{children:t}=e,r=(0,a.useStyles2)(s);return i.default.createElement(a.SelectContainer,Object.assign({},e,{className:(0,o.cx)(e.className,r.container)}),t)},u=e=>{const{className:t,children:r}=e,n=(0,a.useStyles2)(s);return i.default.createElement("div",{className:(0,o.cx)(t,n.valueContainer)},r)},s=e=>({root:(0,o.css)({display:"flex",fontSize:12,alignItems:"center"}),label:(0,o.css)({color:e.colors.text.secondary,whiteSpace:"nowrap"}),container:(0,o.css)({background:"none",borderColor:"transparent"}),valueContainer:(0,o.css)({display:"flex",alignItems:"center",flex:"initial",color:e.colors.text.secondary,fontSize:12})})},18367:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InputGroup=void 0;const n=r(91666),o=r(46089),i=r(82007),a=n.__importStar(r(85959));t.InputGroup=({children:e})=>{const t=(0,i.useStyles2)(u),r=a.Children.map(e,(e=>(0,a.isValidElement)(e)&&e.props.invalid?(0,a.cloneElement)(e,{className:(0,o.cx)(e.props.className,t.invalidChild)}):e));return a.default.createElement("div",{className:t.root},r)};const l=["","base","hovered","invalid","focused"],u=()=>({root:(0,o.css)({display:"flex","> *":{"&:not(:first-child)":{marginLeft:-1},"&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0},"&:not(:first-child):not(:last-child)":{borderRadius:0},position:"relative",zIndex:l.indexOf("base"),"&:hover":{zIndex:l.indexOf("hovered")},"&:focus-within":{zIndex:l.indexOf("focused")}}}),invalidChild:(0,o.css)({zIndex:l.indexOf("invalid")})})},91483:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SqlQueryEditor=void 0;const n=r(91666),o=n.__importStar(r(85959)),i=r(78131),a=r(33918),l=r(37079),u=r(75399),s=r(94003),c=r(11913),d=r(86659),f=r(47716);t.SqlQueryEditor=function({datasource:e,query:t,onChange:r,onRunQuery:g,range:v}){var h,m,y,b,E,O,S;const[_,w]=(0,o.useState)(!0),T=e.getDB(),P=e.dataset,{loading:C,error:I}=(0,i.useAsync)((()=>n.__awaiter(this,void 0,void 0,(function*(){return()=>{void 0!==e.getDB(e.id).init&&e.getDB(e.id).init()}}))),[e]),A=(0,a.applyQueryDefaults)(t),[R,x]=(0,o.useState)({filter:!!(null===(h=A.sql)||void 0===h?void 0:h.whereString),group:!!(null===(b=null===(y=null===(m=A.sql)||void 0===m?void 0:m.groupBy)||void 0===y?void 0:y[0])||void 0===b?void 0:b.property.name),order:!!(null===(O=null===(E=A.sql)||void 0===E?void 0:E.orderBy)||void 0===O?void 0:O.property.name),preview:!0}),[N,D]=(0,o.useState)(A);(0,o.useEffect)((()=>()=>{void 0!==e.getDB(e.id).dispose&&e.getDB(e.id).dispose()}),[e]);const L=(0,o.useCallback)((e=>{p(e)&&g&&g()}),[g]),j=(e,t=!0)=>{var n,o;D(e),r(e),(0,u.haveColumns)(null===(n=e.sql)||void 0===n?void 0:n.columns)&&(null===(o=e.sql)||void 0===o?void 0:o.columns.some((e=>e.name)))&&!R.group&&x(Object.assign(Object.assign({},R),{group:!0})),t&&L(e)};return C||I?null:o.default.createElement(o.default.Fragment,null,o.default.createElement(s.QueryHeader,{db:T,defaultDataset:P||"",enableDatasets:!T.disableDatasets,onChange:e=>{D(e),r(e)},onRunQuery:g,onQueryRowChange:x,queryRowFilter:R,query:A,isQueryRunnable:_,labels:null===(S=e.getDB(e.id))||void 0===S?void 0:S.labels}),o.default.createElement(f.Space,{v:.5}),A.editorMode!==l.EditorMode.Code&&o.default.createElement(d.VisualEditor,{db:T,query:A,onChange:e=>j(e,!1),queryRowFilter:R,onValidate:w,range:v}),A.editorMode===l.EditorMode.Code&&o.default.createElement(c.RawEditor,{db:T,query:A,queryToValidate:N,onChange:j,onRunQuery:g,onValidate:w,range:v}))};const p=e=>Boolean(e.rawSql)},94003:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryHeader=void 0;const n=r(91666).__importStar(r(85959)),o=r(78131),i=r(60897),a=r(4639),l=r(51075),u=r(82007),s=r(84997),c=r(24772),d=r(24637),f=r(89464),p=r(90413),g=r(47716),v=r(86171),h=r(37079),m=r(75399),y=[{label:"Builder",value:h.EditorMode.Builder},{label:"Code",value:h.EditorMode.Code}];t.QueryHeader=function({db:e,defaultDataset:t,enableDatasets:r,query:b,queryRowFilter:E,onChange:O,onRunQuery:S,onQueryRowChange:_,isQueryRunnable:w,labels:T=new Map([["dataset","Dataset"]])}){const{editorMode:P}=b,[C,I]=(0,o.useCopyToClipboard)(),[A,R]=(0,n.useState)(!1),x=(0,m.getRawSqlFn)(e),N=(0,n.useCallback)((e=>{P!==h.EditorMode.Code?O(Object.assign(Object.assign({},b),{editorMode:e})):R(!0)}),[P,O,b]);return n.default.createElement(n.default.Fragment,null,n.default.createElement(c.EditorHeader,null,n.default.createElement(p.InlineSelect,{label:"Format",value:b.format,placeholder:"Select format",menuShouldPortal:!0,onChange:e=>{const t=Object.assign(Object.assign({},b),{format:void 0!==e.value?e.value:h.QueryFormat.Table});O(t)},options:h.QUERY_FORMAT_OPTIONS}),P===h.EditorMode.Builder&&n.default.createElement(n.default.Fragment,null,n.default.createElement(u.InlineSwitch,{id:"sql-filter",label:"Filter",transparent:!0,showLabel:!0,value:E.filter,onChange:e=>e.target instanceof HTMLInputElement&&_(Object.assign(Object.assign({},E),{filter:e.target.checked}))}),n.default.createElement(u.InlineSwitch,{id:"sql-group",label:"Group",transparent:!0,showLabel:!0,value:E.group,onChange:e=>e.target instanceof HTMLInputElement&&_(Object.assign(Object.assign({},E),{group:e.target.checked}))}),n.default.createElement(u.InlineSwitch,{id:"sql-order",label:"Order",transparent:!0,showLabel:!0,value:E.order,onChange:e=>e.target instanceof HTMLInputElement&&_(Object.assign(Object.assign({},E),{order:e.target.checked}))}),n.default.createElement(u.InlineSwitch,{id:"sql-preview",label:"Preview",transparent:!0,showLabel:!0,value:E.preview,onChange:e=>e.target instanceof HTMLInputElement&&_(Object.assign(Object.assign({},E),{preview:e.target.checked}))})),n.default.createElement(f.FlexItem,{grow:1}),n.default.createElement(v.RunQueryButton,{queryInvalid:!w,onClick:()=>S()}),n.default.createElement(u.RadioButtonGroup,{options:y,size:"sm",value:P,onChange:N}),n.default.createElement(i.ConfirmModal,{isOpen:A,onCopy:()=>{R(!1),I(b.rawSql),O(Object.assign(Object.assign({},b),{rawSql:x(b),editorMode:h.EditorMode.Builder}))},onDiscard:()=>{R(!1),O(Object.assign(Object.assign({},b),{rawSql:x(b),editorMode:h.EditorMode.Builder}))},onCancel:()=>R(!1)})),P===h.EditorMode.Builder&&n.default.createElement(n.default.Fragment,null,n.default.createElement(g.Space,{v:.5}),n.default.createElement(d.EditorRow,null,!0===r&&n.default.createElement(s.EditorField,{label:T.get("dataset")||"Dataset",width:25},n.default.createElement(a.DatasetSelector,{db:e,dataset:t,value:void 0===b.dataset?null:b.dataset,onChange:e=>{if(e.value===b.dataset)return;const t=Object.assign(Object.assign({},b),{dataset:e.value,table:void 0,sql:void 0,rawSql:""});O(t)}})),n.default.createElement(s.EditorField,{label:"Table",width:25},n.default.createElement(l.TableSelector,{db:e,dataset:b.dataset||t,query:b,value:void 0===b.table?null:b.table,onChange:e=>{if(e.value===b.table)return;const t=Object.assign(Object.assign({},b),{table:e.value,sql:void 0,rawSql:""});O(t)},applyDefault:!0})))))}},86171:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RunQueryButton=void 0;const n=r(91666).__importDefault(r(85959)),o=r(82007);t.RunQueryButton=({ariaLabel:e="Query editor Run button",queryRunning:t=!1,queryInvalid:r=!1,invalidQueryTooltip:i,disabled:a=!1,onClick:l,dataTestId:u})=>{let s=r?"exclamation-triangle":void 0;t&&(s="fa fa-spinner");const c=n.default.createElement(o.Button,{"aria-label":e,size:"sm",variant:"secondary",icon:s,disabled:a||t,onClick:l,"data-testid":u},"Run query");return r?n.default.createElement(o.Tooltip,{theme:"error",placement:"top",content:null!=i?i:n.default.createElement(n.default.Fragment,null,"Your query is invalid. Check below for details. ",n.default.createElement("br",null),"However, you can still run this query.")},c):c}},47716:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Space=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007);t.Space=e=>{const t=(0,a.useTheme2)(),r=l(t,e);return i.default.createElement("span",{className:(0,o.cx)(r.wrapper)})},t.Space.defaultProps={v:0,h:0,layout:"block"};const l=(0,a.stylesFactory)(((e,t)=>{var r,n;return{wrapper:(0,o.css)([{paddingRight:e.spacing(null!==(r=t.h)&&void 0!==r?r:0),paddingBottom:e.spacing(null!==(n=t.v)&&void 0!==n?n:0)},"inline"===t.layout&&{display:"inline-block"},"block"===t.layout&&{display:"block"}])}}))},51075:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TableSelector=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(78131),a=r(87781),l=r(82007);t.TableSelector=({db:e,dataset:t,value:r,className:u,onChange:s})=>{const c=(0,i.useAsync)((()=>n.__awaiter(void 0,void 0,void 0,(function*(){return t?(yield e.tables(t)).map(a.toOption):[]}))),[t]);return o.default.createElement(l.Select,{className:u,disabled:c.loading,"aria-label":"Table selector",value:r,options:c.value,onChange:s,isLoading:c.loading,menuShouldPortal:!0,placeholder:c.loading?"Loading tables":"Select table"})}},33918:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyQueryDefaults=void 0;const n=r(37079),o=r(75399);t.applyQueryDefaults=function(e){let t=(null==e?void 0:e.editorMode)||n.EditorMode.Builder;return void 0===(null==e?void 0:e.editorMode)&&void 0!==(null==e?void 0:e.rawSql)&&(t=n.EditorMode.Code),Object.assign(Object.assign({},e),{refId:(null==e?void 0:e.refId)||"A",format:void 0!==(null==e?void 0:e.format)?e.format:n.QueryFormat.Table,rawSql:(null==e?void 0:e.rawSql)||"",editorMode:t,sql:(null==e?void 0:e.sql)||{columns:[(0,o.createFunctionField)()],groupBy:[(0,o.setGroupByField)()],limit:50}})}},97669:(e,t)=>{"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.QueryEditorExpressionType=t.QueryEditorPropertyType=void 0,(t.QueryEditorPropertyType||(t.QueryEditorPropertyType={})).String="string",(r=t.QueryEditorExpressionType||(t.QueryEditorExpressionType={})).Property="property",r.Operator="operator",r.Or="or",r.And="and",r.GroupBy="groupBy",r.Function="function",r.FunctionParameter="functionParameter"},2202:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RunQueryButton=t.SqlQueryEditor=t.Space=t.InputGroup=t.InlineSelect=t.EditorStack=t.FlexItem=t.EditorSwitch=t.EditorRows=t.EditorList=t.EditorRow=t.EditorField=t.EditorHeader=t.EditorFieldGroup=t.AccessoryButton=void 0;const n=r(91666);n.__exportStar(r(97496),t);var o=r(37392);Object.defineProperty(t,"AccessoryButton",{enumerable:!0,get:function(){return o.AccessoryButton}});var i=r(99398);Object.defineProperty(t,"EditorFieldGroup",{enumerable:!0,get:function(){return i.EditorFieldGroup}});var a=r(24772);Object.defineProperty(t,"EditorHeader",{enumerable:!0,get:function(){return a.EditorHeader}});var l=r(84997);Object.defineProperty(t,"EditorField",{enumerable:!0,get:function(){return l.EditorField}});var u=r(24637);Object.defineProperty(t,"EditorRow",{enumerable:!0,get:function(){return u.EditorRow}});var s=r(3373);Object.defineProperty(t,"EditorList",{enumerable:!0,get:function(){return s.EditorList}});var c=r(1912);Object.defineProperty(t,"EditorRows",{enumerable:!0,get:function(){return c.EditorRows}});var d=r(27153);Object.defineProperty(t,"EditorSwitch",{enumerable:!0,get:function(){return d.EditorSwitch}});var f=r(89464);Object.defineProperty(t,"FlexItem",{enumerable:!0,get:function(){return f.FlexItem}});var p=r(79641);Object.defineProperty(t,"EditorStack",{enumerable:!0,get:function(){return p.EditorStack}});var g=r(90413);Object.defineProperty(t,"InlineSelect",{enumerable:!0,get:function(){return g.InlineSelect}});var v=r(18367);Object.defineProperty(t,"InputGroup",{enumerable:!0,get:function(){return v.InputGroup}});var h=r(47716);Object.defineProperty(t,"Space",{enumerable:!0,get:function(){return h.Space}});var m=r(91483);Object.defineProperty(t,"SqlQueryEditor",{enumerable:!0,get:function(){return m.SqlQueryEditor}});var y=r(86171);Object.defineProperty(t,"RunQueryButton",{enumerable:!0,get:function(){return y.RunQueryButton}}),n.__exportStar(r(37079),t)},84061:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryEditorRaw=void 0;const n=r(91666).__importStar(r(85959)),o=r(34077),i=r(49846);t.QueryEditorRaw=function({children:e,onChange:t,query:r,width:a,height:l,completionProvider:u}){const s=(0,n.useRef)(r);(0,n.useEffect)((()=>{s.current=r}),[r]);const c=(0,n.useCallback)(((e,r)=>{const n=Object.assign(Object.assign({},s.current),{rawQuery:!0,rawSql:e});t(n,r)}),[t]);return n.default.createElement(i.SQLEditor,{width:a,height:l,query:r.rawSql,onChange:c,language:{id:"sql",completionProvider:u,formatter:o.formatSQL}},e)}},3291:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryToolbox=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(82007),l=r(75358);t.QueryToolbox=function(e){var{showTools:t,onFormatCode:r,onExpand:u,isExpanded:s}=e,c=n.__rest(e,["showTools","onFormatCode","onExpand","isExpanded"]);const d=(0,a.useTheme2)(),[f,p]=(0,i.useState)(),g=(0,i.useMemo)((()=>({container:o.css`
        border: 1px solid ${d.colors.border.medium};
        border-top: none;
        padding: ${d.spacing(.5,.5,.5,.5)};
        display: flex;
        flex-grow: 1;
        justify-content: space-between;
        font-size: ${d.typography.bodySmall.fontSize};
      `,error:o.css`
        color: ${d.colors.error.text};
        font-size: ${d.typography.bodySmall.fontSize};
        font-family: ${d.typography.fontFamilyMonospace};
      `,valid:o.css`
        color: ${d.colors.success.text};
      `,info:o.css`
        color: ${d.colors.text.secondary};
      `,hint:o.css`
        color: ${d.colors.text.disabled};
        white-space: nowrap;
        cursor: help;
      `})),[d]);let v={};return t||void 0!==f||(v={height:0,padding:0,visibility:"hidden"}),i.default.createElement("div",{className:g.container,style:v},i.default.createElement("div",null,c.onValidate&&i.default.createElement(l.QueryValidator,Object.assign({},c,{onValidate:e=>{p(e),c.onValidate(e)}}))),t&&i.default.createElement("div",null,i.default.createElement(a.HorizontalGroup,{spacing:"sm"},r&&i.default.createElement(a.IconButton,{onClick:r,name:"brackets-curly",size:"xs",tooltip:"Format query"}),u&&i.default.createElement(a.IconButton,{onClick:()=>u(!s),name:s?"angle-up":"angle-down",size:"xs",tooltip:s?"Collapse editor":"Expand editor"}),i.default.createElement(a.Tooltip,{content:"Hit CTRL/CMD+Return to run query"},i.default.createElement(a.Icon,{className:g.hint,name:"keyboard"})))))}},75358:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryValidator=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(78131),l=n.__importDefault(r(52087)),u=r(87781),s=r(82007);t.QueryValidator=function({db:e,query:t,onValidate:r,range:c}){var d;const[f,p]=(0,i.useState)(),g=(0,s.useTheme2)(),v=(0,i.useMemo)((()=>(0,u.getValueFormat)("bytes")),[]),h=(0,i.useMemo)((()=>({error:o.css`
        color: ${g.colors.error.text};
        font-size: ${g.typography.bodySmall.fontSize};
        font-family: ${g.typography.fontFamilyMonospace};
      `,valid:o.css`
        color: ${g.colors.success.text};
      `,info:o.css`
        color: ${g.colors.text.secondary};
      `})),[g]),[m,y]=(0,a.useAsyncFn)((t=>n.__awaiter(this,void 0,void 0,(function*(){var r;return""===(null===(r=t.rawSql)||void 0===r?void 0:r.trim())?null:yield e.validateQuery(t,c)}))),[e]),[,]=(0,l.default)((()=>n.__awaiter(this,void 0,void 0,(function*(){const e=yield y(t);return e&&p(e),null}))),1e3,[t,y]);if((0,i.useEffect)((()=>{(null==f?void 0:f.isError)&&r(!1),(null==f?void 0:f.isValid)&&r(!0)}),[f,r]),!m.value&&!m.loading)return null;const b=(null===(d=m.value)||void 0===d?void 0:d.error)?function(e){const t=e.split(":");return t.length>2?t.slice(2).join(":"):e}(m.value.error):"";return i.default.createElement(i.default.Fragment,null,m.loading&&i.default.createElement("div",{className:h.info},i.default.createElement(s.Spinner,{inline:!0,size:12})," Validating query..."),!m.loading&&m.value&&i.default.createElement(i.default.Fragment,null,i.default.createElement(i.default.Fragment,null,m.value.isValid&&m.value.statistics&&i.default.createElement("div",{className:h.valid},i.default.createElement(s.Icon,{name:"check"})," This query will process"," ",i.default.createElement("strong",null,(0,u.formattedValueToString)(v(m.value.statistics.TotalBytesProcessed)))," ","when run.")),i.default.createElement(i.default.Fragment,null,m.value.isError&&i.default.createElement("div",{className:h.error},b))))}},11913:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RawEditor=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(78131),l=n.__importDefault(r(52445)),u=r(82007),s=r(84061),c=r(3291);function d(e){return{modal:o.css`
      width: 95vw;
      height: 95vh;
    `,modalContent:o.css`
      height: 100%;
      padding-top: 0;
    `}}t.RawEditor=function({db:e,query:t,onChange:r,onRunQuery:n,onValidate:o,queryToValidate:f,range:p}){const g=(0,u.useTheme2)(),v=(0,u.useStyles2)(d),[h,m]=(0,i.useState)(!1),[y,b]=(0,a.useMeasure)(),[E,O]=(0,a.useMeasure)(),S=(0,i.useMemo)((()=>e.getSqlCompletionProvider()),[e]),_=(n,a)=>i.default.createElement(s.QueryEditorRaw,{completionProvider:S,query:t,width:n,height:a?a-b.height:void 0,onChange:r},(({formatQuery:t})=>i.default.createElement("div",{ref:y},i.default.createElement(c.QueryToolbox,{db:e,query:f,onValidate:o,onFormatCode:t,showTools:!0,range:p,onExpand:m,isExpanded:h})))),w=(e=!1)=>e?i.default.createElement(l.default,null,(({width:e,height:t})=>_(e,t))):i.default.createElement("div",{ref:E},_());return i.default.createElement(i.default.Fragment,null,h?i.default.createElement("div",{style:{width:O.width,height:O.height,background:g.colors.background.primary,display:"flex",alignItems:"center",justifyContent:"center"}},"Editing in expanded code editor"):w(),h&&i.default.createElement(u.Modal,{title:`Query ${t.refId}`,closeOnBackdropClick:!1,closeOnEscape:!1,className:v.modal,contentClassName:v.modalContent,isOpen:h,onDismiss:()=>{m(!1)}},w(!0)))}},37079:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toOption=t.QUERY_FORMAT_OPTIONS=t.EditorMode=t.QueryFormat=void 0;const n=r(87781);var o,i;!function(e){e[e.Timeseries=0]="Timeseries",e[e.Table=1]="Table",e[e.Logs=2]="Logs",e[e.Trace=3]="Trace",e[e.OptionMulti=4]="OptionMulti"}(o=t.QueryFormat||(t.QueryFormat={})),(i=t.EditorMode||(t.EditorMode={})).Builder="builder",i.Code="code",t.QUERY_FORMAT_OPTIONS=[{label:"Time series",value:o.Timeseries},{label:"Table",value:o.Table}],t.toOption=null!==n.toOption&&void 0!==n.toOption?n.toOption:e=>({label:e,value:e})},34077:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatSQL=void 0;const n=r(91666).__importDefault(r(83405));t.formatSQL=function(e){return n.default.format(e).replace(/(\$ \{ .* \})|(\$ __)|(\$ \w+)/g,(e=>e.replace(/\s/g,"")))}},75399:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFunctionField=t.setPropertyField=t.setGroupByField=t.haveColumns=t.toRawSql=t.getRawSqlFn=void 0;const n=r(93241),o=r(97669);function i({sql:e,dataset:t,table:r},o){var i,l,u,s;let c="";return e&&a(e.columns)?(c+=function(e){const t=e.map((e=>{var t,r;let n="";return e.name?n+=`${e.name}(${null===(t=e.parameters)||void 0===t?void 0:t.map((e=>`${e.name}`))})`:n+=`${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>`${e.name}`))}`,n}));return`SELECT ${t.join(", ")} `}(e.columns),o?r&&(c+=`FROM ${r} `):t&&r&&(c+=`FROM ${t}.${r} `),e.whereString&&(c+=`WHERE ${e.whereString} `),(null===(l=null===(i=e.groupBy)||void 0===i?void 0:i[0])||void 0===l?void 0:l.property.name)&&(c+=`GROUP BY ${e.groupBy.map((e=>e.property.name)).filter((e=>!(0,n.isEmpty)(e))).join(", ")} `),(null===(u=e.orderBy)||void 0===u?void 0:u.property.name)&&(c+=`ORDER BY ${e.orderBy.property.name} `),(null===(s=e.orderBy)||void 0===s?void 0:s.property.name)&&e.orderByDirection&&(c+=`${e.orderByDirection} `),void 0!==e.limit&&e.limit>=0&&(c+=`LIMIT ${e.limit} `),c):c}function a(e){if(!e)return!1;const t=e.some((e=>{var t,r;return(null===(t=e.parameters)||void 0===t?void 0:t.length)||(null===(r=e.parameters)||void 0===r?void 0:r.some((e=>e.name)))})),r=e.some((e=>e.name));return t||r}t.getRawSqlFn=function(e){return e.toRawSql?e.toRawSql:t=>i(t,Boolean(e.disableDatasets))},t.toRawSql=i,t.haveColumns=a,t.setGroupByField=function(e){return{type:o.QueryEditorExpressionType.GroupBy,property:{type:o.QueryEditorPropertyType.String,name:e}}},t.setPropertyField=function(e){return{type:o.QueryEditorExpressionType.Property,property:{type:o.QueryEditorPropertyType.String,name:e}}},t.createFunctionField=function(e){return{type:o.QueryEditorExpressionType.Function,name:e,parameters:[]}}},92923:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.useSqlChange=void 0;const n=r(85959),o=r(75399);t.useSqlChange=function({query:e,onQueryChange:t,db:r}){return{onSqlChange:(0,n.useCallback)((n=>{const i=(0,o.getRawSqlFn)(r)({sql:n,dataset:e.dataset,table:e.table,refId:e.refId}),a=Object.assign(Object.assign({},e),{sql:n,rawSql:i});t(a)}),[r,t,e])}}},11431:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.raqbConfig=t.settings=t.widgets=t.emptyInitTree=t.emptyInitValue=void 0;const n=r(91666),o=r(93241),i=n.__importDefault(r(85959)),a=r(82961),l=r(87781),u=r(82007);t.emptyInitValue={id:a.Utils.uuid(),type:"group",children1:{[a.Utils.uuid()]:{type:"rule",properties:{field:null,operator:null,value:[],valueSrc:[]}}}},t.emptyInitTree={id:a.Utils.uuid(),type:"group",children1:{[a.Utils.uuid()]:{type:"rule",properties:{field:null,operator:null,value:[],valueSrc:[]}}}},t.widgets=Object.assign(Object.assign({},a.BasicConfig.widgets),{text:Object.assign(Object.assign({},a.BasicConfig.widgets.text),{factory:function(e){return i.default.createElement(u.Input,{value:(null==e?void 0:e.value)||"",placeholder:null==e?void 0:e.placeholder,onChange:t=>null==e?void 0:e.setValue(t.currentTarget.value)})}}),number:Object.assign(Object.assign({},a.BasicConfig.widgets.number),{factory:function(e){return i.default.createElement(u.Input,{value:null==e?void 0:e.value,placeholder:null==e?void 0:e.placeholder,type:"number",onChange:t=>null==e?void 0:e.setValue(Number.parseInt(t.currentTarget.value,10))})}}),datetime:Object.assign(Object.assign({},a.BasicConfig.widgets.datetime),{factory:function(e){return i.default.createElement(u.DateTimePicker,{onChange:t=>{null==e||e.setValue(null==t?void 0:t.format(a.BasicConfig.widgets.datetime.valueFormat))},date:(0,l.dateTime)(null==e?void 0:e.value).utc()})}})}),t.settings=Object.assign(Object.assign({},a.BasicConfig.settings),{canRegroup:!1,maxNesting:1,canReorder:!1,showNot:!1,addRuleLabel:"Add",deleteLabel:"Remove",renderConjs:function(e){return i.default.createElement(u.Select,{id:null==e?void 0:e.id,"aria-label":"Conjunction",menuShouldPortal:!0,options:(null==e?void 0:e.conjunctionOptions)?Object.keys(null==e?void 0:e.conjunctionOptions).map(l.toOption):void 0,value:null==e?void 0:e.selectedConjunction,onChange:t=>null==e?void 0:e.setConjunction(t.value)})},renderField:function(e){var t;const r=(null===(t=null==e?void 0:e.config)||void 0===t?void 0:t.fields)||{};return i.default.createElement(u.Select,{id:null==e?void 0:e.id,width:25,"aria-label":"Field",menuShouldPortal:!0,options:null==e?void 0:e.items.map((e=>{var t,n;const o=null===(n=null===(t=r[e.key].mainWidgetProps)||void 0===t?void 0:t.customProps)||void 0===n?void 0:n.icon;return{label:e.label,value:e.key,icon:o}})),value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.label)}})},renderButton:function(e){return i.default.createElement(u.Button,{type:"button",title:`${null==e?void 0:e.label} filter`,onClick:null==e?void 0:e.onClick,variant:"secondary",size:"md",icon:"Add"===(null==e?void 0:e.label)?"plus":"times"})},renderOperator:function(e){return i.default.createElement(u.Select,{options:null==e?void 0:e.items.map((e=>({label:e.label,value:e.key}))),"aria-label":"Operator",menuShouldPortal:!0,value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.value||"")}})}});const s=function(e){const t=n.__rest(e.operators,[]),r=()=>"",o=t.select_any_in.sqlFormatOp||r,i=t.select_not_any_in.sqlFormatOp||r;return Object.assign(Object.assign({},t),{select_any_in:Object.assign(Object.assign({},t.select_any_in),{sqlFormatOp:(e,t,r,n,i,a,l,u)=>o(e,t,g(r),n,i,a,l,u)}),select_not_any_in:Object.assign(Object.assign({},t.select_not_any_in),{sqlFormatOp:(e,t,r,n,o,a,l,u)=>i(e,t,g(r),n,o,a,l,u)})})}(a.BasicConfig),c=a.BasicConfig.types.text.widgets.text,d=[...c.operators||[],"select_any_in","select_not_any_in"],f=Object.assign(Object.assign({},c),{operators:d}),p=Object.assign(Object.assign({},a.BasicConfig.types),{text:Object.assign(Object.assign({},a.BasicConfig.types.text),{widgets:Object.assign(Object.assign({},a.BasicConfig.types.text.widgets),{text:f})})});function g(e){return(0,o.isString)(e)?e.split(","):e}t.raqbConfig=Object.assign(Object.assign({},a.BasicConfig),{widgets:t.widgets,settings:t.settings,operators:s,types:p})},45035:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorField=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007),l=r(47716);t.EditorField=e=>{const{label:t,optional:r,tooltip:o,children:s,width:c}=e,d=n.__rest(e,["label","optional","tooltip","children","width"]),f=(0,a.useTheme2)(),p=u(f,c),g=(null==d?void 0:d.htmlFor)||(null===a.ReactUtils||void 0===a.ReactUtils?void 0:a.ReactUtils.getChildId(s)),v=i.default.createElement(i.default.Fragment,null,i.default.createElement("label",{className:p.label,htmlFor:g},t,r&&i.default.createElement("span",{className:p.optional}," - optional"),o&&i.default.createElement(a.Tooltip,{placement:"top",content:o,theme:"info"},i.default.createElement(a.Icon,{name:"info-circle",size:"sm",className:p.icon}))),i.default.createElement(l.Space,{v:.5}));return i.default.createElement("div",{className:p.root},i.default.createElement(a.Field,Object.assign({className:p.field,label:v},d),s))};const u=(0,a.stylesFactory)(((e,t)=>({root:(0,o.css)({minWidth:e.spacing(null!=t?t:0)}),label:(0,o.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),optional:(0,o.css)({fontStyle:"italic",color:e.colors.text.secondary}),field:(0,o.css)({marginBottom:0}),icon:(0,o.css)({color:e.colors.text.secondary,marginLeft:e.spacing(1),":hover":{color:e.colors.text.primary}})})))},66659:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorRow=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007),l=r(79641);t.EditorRow=({children:e})=>{const t=(0,a.useStyles2)(u);return i.default.createElement("div",{className:t.root},i.default.createElement(l.EditorStack,{gap:2},e))};const u=e=>({root:(0,o.css)({padding:e.spacing(1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(1)})})},65286:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorRows=void 0;const n=r(91666).__importDefault(r(85959)),o=r(79641);t.EditorRows=({children:e})=>n.default.createElement(o.EditorStack,{gap:.5,direction:"column"},e)},22644:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GroupByRow=void 0;const n=r(91666).__importStar(r(85959)),o=r(87781),i=r(75399),a=r(3373),l=r(82007),u=r(37392),s=r(18367);function c({options:e}){return function(t,r,a){var c;return n.default.createElement(s.InputGroup,null,n.default.createElement(l.Select,{value:(null===(c=t.property)||void 0===c?void 0:c.name)?(0,o.toOption)(t.property.name):null,"aria-label":"Group by",options:e,menuShouldPortal:!0,onChange:({value:e})=>e&&r((0,i.setGroupByField)(e))}),n.default.createElement(u.AccessoryButton,{"aria-label":"Remove group by column",icon:"times",variant:"secondary",onClick:a}))}}t.GroupByRow=function({sql:e,columns:t,onSqlChange:r}){const o=(0,n.useCallback)((t=>{const n=t.map((e=>{var t;return(0,i.setGroupByField)(null===(t=e.property)||void 0===t?void 0:t.name)})),o=Object.assign(Object.assign({},e),{groupBy:n});r(o)}),[r,e]);return n.default.createElement(a.EditorList,{items:e.groupBy,onChange:o,renderItem:c({options:t})})}},64505:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OrderByRow=void 0;const n=r(91666),o=r(93241),i=n.__importStar(r(85959)),a=r(87781),l=r(82007),u=r(75399),s=r(47716),c=r(84997),d=r(18367),f=[{description:"Sort by ascending",value:"ASC",icon:"sort-amount-up"},{description:"Sort by descending",value:"DESC",icon:"sort-amount-down"}];t.OrderByRow=function({sql:e,onSqlChange:t,columns:r,showOffset:n}){var p,g;const v=(0,i.useCallback)((r=>{const n=Object.assign(Object.assign({},e),{orderByDirection:r});t(n)}),[t,e]),h=(0,i.useCallback)((r=>{const n=Object.assign(Object.assign({},e),{limit:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),m=(0,i.useCallback)((r=>{const n=Object.assign(Object.assign({},e),{offset:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),y=(0,i.useCallback)((r=>{const n=Object.assign(Object.assign({},e),{orderBy:(0,u.setPropertyField)(null==r?void 0:r.value)});null===r&&(n.orderByDirection=void 0),t(n)}),[t,e]);return i.default.createElement(i.default.Fragment,null,i.default.createElement(c.EditorField,{label:"Order by",width:25},i.default.createElement(d.InputGroup,null,i.default.createElement(l.Select,{"aria-label":"Order by",options:r,value:(null===(p=e.orderBy)||void 0===p?void 0:p.property.name)?(0,a.toOption)(e.orderBy.property.name):null,isClearable:!0,menuShouldPortal:!0,onChange:y}),i.default.createElement(s.Space,{h:1.5}),i.default.createElement(l.RadioButtonGroup,{options:f,disabled:!(null===(g=null==e?void 0:e.orderBy)||void 0===g?void 0:g.property.name),value:e.orderByDirection,onChange:v}))),i.default.createElement(c.EditorField,{label:"Limit",optional:!0,width:25},i.default.createElement(l.Input,{type:"number",min:0,id:(0,o.uniqueId)("limit-"),value:e.limit||"",onChange:h})),n&&i.default.createElement(c.EditorField,{label:"Offset",optional:!0,width:25},i.default.createElement(l.Input,{type:"number",id:(0,o.uniqueId)("offset-"),value:e.offset||"",onChange:m})))}},43732:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Preview=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(78131),l=r(82007),u=r(34077);function s(e){return{grow:(0,o.css)({flexGrow:1}),label:(0,o.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),labelWrapper:(0,o.css)({display:"flex",justifyContent:"space-between",paddingBottom:e.spacing(.5)})}}t.Preview=function({rawSql:e}){const[t,r]=(0,a.useCopyToClipboard)(),n=(0,l.useStyles2)(s),o=i.default.createElement("div",{className:n.labelWrapper},i.default.createElement("label",{className:n.label},"Preview"),i.default.createElement(l.IconButton,{tooltip:"Copy to clipboard",onClick:()=>r(e),name:"copy"}));return i.default.createElement(l.Field,{label:o,className:n.grow},i.default.createElement(l.CodeEditor,{language:"sql",height:80,value:(0,u.formatSQL)(e),monacoOptions:{scrollbar:{vertical:"hidden"},scrollBeyondLastLine:!1},readOnly:!0,showMiniMap:!1}))}},302:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLGroupByRow=void 0;const n=r(91666).__importDefault(r(85959)),o=r(22644),i=r(92923);t.SQLGroupByRow=function({fields:e,query:t,onQueryChange:r,db:a}){const{onSqlChange:l}=(0,i.useSqlChange)({query:t,onQueryChange:r,db:a});return n.default.createElement(o.GroupByRow,{columns:e,sql:t.sql,onSqlChange:l})}},27595:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLOrderByRow=void 0;const n=r(91666).__importDefault(r(85959)),o=r(64505),i=r(92923);t.SQLOrderByRow=function({fields:e,query:t,onQueryChange:r,db:a}){var l,u;const{onSqlChange:s}=(0,i.useSqlChange)({query:t,onQueryChange:r,db:a});let c=[];return e&&(c=[{value:"",label:"Selected columns",options:null===(u=null===(l=t.sql)||void 0===l?void 0:l.columns)||void 0===u?void 0:u.map(((e,t)=>{var r,n;const o=e.name?`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>e.name))})`:null===(n=e.parameters)||void 0===n?void 0:n.map((e=>e.name));return{value:o,label:`${t+1} - ${o}`}})),expanded:!0},...e]),n.default.createElement(o.OrderByRow,{sql:t.sql,onSqlChange:s,columns:c})}},1310:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLSelectRow=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(78131),a=r(87781),l=r(50760),u=r(92923);t.SQLSelectRow=function({fields:e,query:t,onQueryChange:r,db:s}){const{onSqlChange:c}=(0,u.useSqlChange)({query:t,onQueryChange:r,db:s}),d=(0,i.useAsync)((()=>n.__awaiter(this,void 0,void 0,(function*(){return(yield s.functions()).map((e=>(0,a.toOption)(e.name)))}))),[s]);return o.default.createElement(l.SelectRow,{columns:e,sql:t.sql,functions:d.value,onSqlChange:c})}},68429:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLWhereRow=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=n.__importDefault(r(90518)),a=r(27251),l=r(92923);t.SQLWhereRow=function({query:e,fields:t,onQueryChange:r,db:u}){const s=(0,i.default)((()=>n.__awaiter(this,void 0,void 0,(function*(){return function(e){const t={};for(const r of e)t[r.value]={type:r.raqbFieldType||"text",valueSources:["value"],mainWidgetProps:{customProps:{icon:r.icon}}};return t}(t)}))),[t]),{onSqlChange:c}=(0,l.useSqlChange)({query:e,onQueryChange:r,db:u});return o.default.createElement(a.WhereRow,{key:JSON.stringify(s.value),config:{fields:s.value||{}},sql:e.sql,onSqlChange:e=>{c(e)}})}},50760:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectRow=void 0;const n=r(91666),o=r(46089),i=r(93241),a=n.__importStar(r(85959)),l=r(87781),u=r(82007),s=r(84997),c=r(97669),d=r(75399),f=r(79641),p={label:"*",value:"*"};t.SelectRow=function({sql:e,columns:t,onSqlChange:r,functions:n}){var o;const h=(0,u.useStyles2)(g),m=[p,...t||[]],y=(0,a.useCallback)(((t,n)=>o=>{var i,a;let l=Object.assign({},t);(null===(i=t.parameters)||void 0===i?void 0:i.length)?l.parameters=t.parameters.map((e=>e.type===c.QueryEditorExpressionType.FunctionParameter?Object.assign(Object.assign({},e),{name:o.value}):e)):l.parameters=[{type:c.QueryEditorExpressionType.FunctionParameter,name:o.value}];const u=Object.assign(Object.assign({},e),{columns:null===(a=e.columns)||void 0===a?void 0:a.map(((e,t)=>t===n?l:e))});r(u)}),[r,e]),b=(0,a.useCallback)(((t,n)=>o=>{var i;const a=Object.assign(Object.assign({},t),{name:null==o?void 0:o.value}),l=Object.assign(Object.assign({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===n?a:e))});r(l)}),[r,e]),E=(0,a.useCallback)((t=>()=>{const n=[...e.columns];n.splice(t,1);const o=Object.assign(Object.assign({},e),{columns:n});r(o)}),[r,e]),O=(0,a.useCallback)((()=>{const t=Object.assign(Object.assign({},e),{columns:[...e.columns,(0,d.createFunctionField)()]});r(t)}),[r,e]);return a.default.createElement(f.EditorStack,{gap:2,alignItems:"end",direction:"column"},null===(o=e.columns)||void 0===o?void 0:o.map(((e,t)=>a.default.createElement("div",{key:t},a.default.createElement(f.EditorStack,{gap:2,alignItems:"end"},a.default.createElement(s.EditorField,{label:"Column",width:25},a.default.createElement(u.Select,{value:v(e),options:m,inputId:`select-column-${t}-${(0,i.uniqueId)()}`,menuShouldPortal:!0,allowCustomValue:!0,onChange:y(e,t)})),a.default.createElement(s.EditorField,{label:"Aggregation",optional:!0,width:25},a.default.createElement(u.Select,{value:e.name?(0,l.toOption)(e.name):null,inputId:`select-aggregation-${t}-${(0,i.uniqueId)()}`,isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0,options:n,onChange:b(e,t)})),a.default.createElement(u.Button,{"aria-label":"Remove",type:"button",icon:"trash-alt",variant:"secondary",size:"md",onClick:E(t)}))))),a.default.createElement(u.Button,{type:"button",onClick:O,variant:"secondary",size:"md",icon:"plus","aria-label":"Add",className:h.addButton}))};const g=()=>({addButton:(0,o.css)({alignSelf:"flex-start"})});function v({parameters:e}){const t=null==e?void 0:e.find((e=>e.type===c.QueryEditorExpressionType.FunctionParameter));return(null==t?void 0:t.name)?(0,l.toOption)(t.name):null}},86659:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VisualEditor=void 0;const n=r(91666),o=n.__importDefault(r(85959)),i=r(78131),a=r(3291),l=r(43732),u=r(302),s=r(27595),c=r(1310),d=r(68429),f=r(66659),p=r(45035),g=r(65286);t.VisualEditor=({query:e,db:t,queryRowFilter:r,onChange:v,onValidate:h,range:m})=>{const y=(0,i.useAsync)((()=>n.__awaiter(void 0,void 0,void 0,(function*(){return yield t.fields(e)}))),[t,e.dataset,e.table]);return o.default.createElement(o.default.Fragment,null,o.default.createElement(g.EditorRows,null,o.default.createElement(f.EditorRow,null,o.default.createElement(c.SQLSelectRow,{fields:y.value||[],query:e,onQueryChange:v,db:t})),r.filter&&o.default.createElement(f.EditorRow,null,o.default.createElement(p.EditorField,{label:"Filter by column value",optional:!0},o.default.createElement(d.SQLWhereRow,{fields:y.value||[],query:e,onQueryChange:v,db:t}))),r.group&&o.default.createElement(f.EditorRow,null,o.default.createElement(p.EditorField,{label:"Group by column"},o.default.createElement(u.SQLGroupByRow,{fields:y.value||[],query:e,onQueryChange:v,db:t}))),r.order&&o.default.createElement(f.EditorRow,null,o.default.createElement(s.SQLOrderByRow,{fields:y.value||[],query:e,onQueryChange:v,db:t})),r.preview&&e.rawSql&&o.default.createElement(f.EditorRow,null,o.default.createElement(l.Preview,{rawSql:e.rawSql}))),o.default.createElement(a.QueryToolbox,{db:t,query:e,onValidate:h,range:m}))}},27251:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WhereRow=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(82961),l=r(11431);function u(e){return`\n    display: flex;\n    gap: 8px;\n    flex-direction: ${e};`}t.WhereRow=function({sql:e,config:t,onSqlChange:r}){const[n,o]=(0,i.useState)(),u=(0,i.useMemo)((()=>Object.assign(Object.assign({},l.raqbConfig),t)),[t]);(0,i.useEffect)((()=>{var t;if(!n){const r=a.Utils.checkTree(a.Utils.loadTree(null!==(t=e.whereJsonTree)&&void 0!==t?t:l.emptyInitTree),u);o(r)}}),[u,e.whereJsonTree,n]),(0,i.useEffect)((()=>{e.whereJsonTree||o(a.Utils.checkTree(a.Utils.loadTree(l.emptyInitTree),u))}),[u,e.whereJsonTree]);const s=(0,i.useCallback)(((t,n)=>{o(t);const i=Object.assign(Object.assign({},e),{whereJsonTree:a.Utils.getTree(t),whereString:a.Utils.sqlFormat(t,n)});r(i)}),[r,e]);return n?i.default.createElement(a.Query,Object.assign({},u,{value:n,onChange:s,renderBuilder:e=>i.default.createElement(a.Builder,Object.assign({},e))})):null},o.injectGlobal`
  .group--header {
    ${u("row")}
  }

  .group-or-rule {
    ${u("column")}
    .rule {
      flex-direction: row;
    }
  }

  .rule--body {
    ${u("row")}
  }

  .group--children {
    ${u("column")}
  }

  .group--conjunctions:empty {
    display: none;
  }
`},97496:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GroupByRow=void 0;var n=r(22644);Object.defineProperty(t,"GroupByRow",{enumerable:!0,get:function(){return n.GroupByRow}})},71963:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryEditorRow=void 0;const n=r(91666).__importDefault(r(85959));t.QueryEditorRow=e=>{var t,r;const o=null!==(t=e.className)&&void 0!==t?t:"width-8",i=null!==(r=e.noFillEnd)&&void 0!==r&&r;return n.default.createElement("div",{className:"gf-form"},e.label&&n.default.createElement("label",{className:`gf-form-label query-keyword ${o}`},e.label),e.children,n.default.createElement("div",{className:"gf-form--grow"},i||n.default.createElement("div",{className:"gf-form-label gf-form-label--grow"})))}},7746:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerLanguageAndSuggestions=t.SQLEditor=void 0;const n=r(91666),o=r(82007),i=n.__importStar(r(85959)),a=r(39110),l=r(52378),u=r(1006),s=r(20395),c=r(55718),d=r(95231),f=r(24404),p=r(31584),g=r(89236),v=r(87781),h=r(28547),m=r(1862),y=r(2441),b=n.__importDefault(r(3357)),E=r(40937),O=new Map,S=new Map;t.SQLEditor=({children:e,onBlur:r,onChange:n,query:a,language:l={id:"sql"},width:u,height:s})=>{const c=(0,i.useRef)(null),d=(0,i.useRef)(),f=(0,i.useMemo)((()=>{const e=(0,g.v4)(),t=`${l.id}-${e}`;return d.current=t,t}),[l.id]);(0,i.useEffect)((()=>()=>{d.current&&S.delete(d.current),(0,y.sqlEditorLog)(`Removing instance cache ${d.current}`,!1,S)}),[]);const v=(0,i.useCallback)((()=>{c.current&&c.current.getAction("editor.action.formatDocument").run()}),[]);return i.default.createElement("div",{style:{width:u}},i.default.createElement(o.CodeEditor,{height:s||"240px",width:u?u-2+"px":void 0,language:f,value:a,onBlur:e=>{n&&n(e,!1),r&&r(e)},showMiniMap:!1,showLineNumbers:!0,onEditorDidMount:(e,r)=>{c.current=e,e.onDidChangeModelContent((t=>{const r=e.getValue();n&&n(r,!1)})),e.addCommand(r.KeyMod.CtrlCmd|r.KeyCode.Enter,(()=>{const t=e.getValue();n&&n(t,!0)})),e.onKeyUp((t=>{84===t.keyCode&&e.trigger(p.TRIGGER_SUGGEST.id,p.TRIGGER_SUGGEST.id,{})})),(0,t.registerLanguageAndSuggestions)(r,l,f)}}),e&&e({formatQuery:v}))},t.registerLanguageAndSuggestions=(e,t,r)=>n.__awaiter(void 0,void 0,void 0,(function*(){const o=((e,t)=>{if("sql"!==(null==t?void 0:t.id)&&!t.loader){(0,y.sqlEditorLog)(`Loading language '${null==t?void 0:t.id}' from Monaco registry`,!1);const r=e.languages.getLanguages().find((({id:e})=>e===(null==t?void 0:t.id)));if(!r)throw Error(`Unknown Monaco language ${null==t?void 0:t.id}`);return Object.assign(Object.assign({completionProvider:E.getStandardSQLCompletionProvider},r),t)}return Object.assign(Object.assign({},b.default),t)})(e,t);if(!o.loader)return;const{language:i,conf:g}=yield o.loader(e);if(e.languages.register({id:r}),e.languages.setMonarchTokensProvider(r,Object.assign({},i)),e.languages.setLanguageConfiguration(r,Object.assign({},g)),o.formatter&&e.languages.registerDocumentFormattingEditProvider(r,{provideDocumentFormattingEdits:e=>{var r;const n=null===(r=t.formatter)||void 0===r?void 0:r.call(t,e.getValue());return[{range:e.getFullModelRange(),text:n||""}]}}),o.completionProvider){const g=o.completionProvider(e,i);!function(e,t,r){var o;O.has(e)||function(e){O.has(e)||O.set(e,{functions:new v.Registry,operators:new v.Registry,suggestionKinds:new v.Registry(u.initSuggestionsKindRegistry),positionResolvers:new v.Registry(m.initStatementPositionResolvers),macros:new v.Registry}),O.get(e)}(e);const i=O.get(e);S.has(t)||S.set(t,new v.Registry((0,h.initStandardSuggestions)(i.functions,i.operators,i.macros)));const a=S.get(t);if(r.supportedFunctions)for(const e of r.supportedFunctions())i.functions.getIfExists(e.id)||i.functions.register(e);if(r.supportedOperators)for(const e of r.supportedOperators())i.operators.getIfExists(e.id)||i.operators.register(Object.assign(Object.assign({},e),{name:e.id}));if(r.supportedMacros)for(const e of r.supportedMacros())i.macros.getIfExists(e.id)||i.macros.register(Object.assign(Object.assign({},e),{name:e.id}));if(r.customStatementPlacement)for(const e of r.customStatementPlacement()){const t=i.positionResolvers.getIfExists(e.id);if(t){const r=t.resolve;t.resolve=(...t)=>{const n=e.resolve(...t);return e.overrideDefault?n:r(...t)||n}}else i.positionResolvers.register(Object.assign(Object.assign({},e),{id:e.id,name:e.id})),i.suggestionKinds.register({id:e.id,name:e.id,kind:[]})}if(r.customSuggestionKinds)for(const e of r.customSuggestionKinds()){if(null===(o=e.applyTo)||void 0===o||o.forEach((t=>{const r=i.suggestionKinds.getIfExists(t);r&&-1===r.kind.indexOf(e.id)&&r.kind.push(e.id)})),e.overrideDefault){const t=a.get(e.id);if(void 0!==t){t.suggestions=e.suggestionsResolver;continue}}a.register({id:e.id,name:e.id,suggestions:e.suggestionsResolver})}if(r.schemas){const e=a.get(s.SuggestionKind.Schemas),t=e.suggestions;e.suggestions=(e,o)=>n.__awaiter(this,void 0,void 0,(function*(){const n=yield t(e,o);if(!r.schemas)return[...n];const i=(yield r.schemas.resolve()).map((e=>{var t;return{label:e.name,insertText:`${null!==(t=e.completion)&&void 0!==t?t:e.name}.`,command:p.TRIGGER_SUGGEST,kind:s.CompletionItemKind.Module,sortText:s.CompletionItemPriority.High}}));return[...n,...i]}))}if(r.tables){const e=a.get(s.SuggestionKind.Tables),t=e.suggestions;e.suggestions=(e,o)=>n.__awaiter(this,void 0,void 0,(function*(){var n,i,a,l,u;const c=yield t(e,o),d=(0,f.getTableToken)(e.currentToken),g=(null!==(i=null===(n=r.tables)||void 0===n?void 0:n.parseName)&&void 0!==i?i:f.defaultTableNameParser)(d),v=(null!==(u=yield null===(l=null===(a=r.tables)||void 0===a?void 0:a.resolve)||void 0===l?void 0:l.call(a,g))&&void 0!==u?u:[]).map((e=>{var t;return{label:e.name,insertText:`${null!==(t=e.completion)&&void 0!==t?t:e.name}${e.completion===e.name?" $0":""}`,insertTextRules:s.CompletionItemInsertTextRule.InsertAsSnippet,command:p.TRIGGER_SUGGEST,kind:s.CompletionItemKind.Field,sortText:s.CompletionItemPriority.MediumHigh}}));return[...c,...v]}))}if(r.columns){const e=a.get(s.SuggestionKind.Columns),t=e.suggestions;e.suggestions=(e,o)=>n.__awaiter(this,void 0,void 0,(function*(){var n,i,a;const l=yield t(e,o),u=(0,f.getTableToken)(e.currentToken);let c;const d=null!==(i=null===(n=r.tables)||void 0===n?void 0:n.parseName)&&void 0!==i?i:f.defaultTableNameParser;u&&u.value&&(c=d(u));let p=[];if(c){const e=yield null===(a=r.columns)||void 0===a?void 0:a.resolve(c);p=e?e.map((e=>{var t;return{label:e.name,insertText:null!==(t=e.completion)&&void 0!==t?t:e.name,kind:s.CompletionItemKind.Field,sortText:s.CompletionItemPriority.High,detail:e.type,documentation:e.description}})):[]}return[...l,...p]}))}}(t.id,r,g);const b=O.get(t.id),E=S.get(r),_=(t,o,i,u)=>n.__awaiter(void 0,void 0,void 0,(function*(){const n=(0,d.linkedTokenBuilder)(e,t,o,r),i=(0,a.getStatementPosition)(n,b.positionResolvers),u=(0,c.getSuggestionKinds)(i,b.suggestionKinds);(0,y.sqlEditorLog)("Statement position",!1,i),(0,y.sqlEditorLog)("Suggestion kinds",!1,u);const s={position:o,currentToken:n,statementPosition:i,kind:u,range:e.Range.fromPositions(o)};return{suggestions:yield(0,l.getStandardSuggestions)(e,n,u,s,E)}}));e.languages.registerCompletionItemProvider(r,Object.assign(Object.assign({},g),{provideCompletionItems:_}))}}))},49846:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLEditorMode=t.CompletionItemInsertTextRule=t.CompletionItemPriority=t.CompletionItemKind=t.SuggestionKind=t.StatementPosition=t.TokenType=t.MacroType=t.OperatorType=t.getStandardSQLCompletionProvider=t.grafanaStandardSQLLanguageConf=t.grafanaStandardSQLLanguage=t.LinkedToken=t.SQLEditorTestUtils=t.SQLEditor=void 0;var n=r(7746);Object.defineProperty(t,"SQLEditor",{enumerable:!0,get:function(){return n.SQLEditor}});var o=r(50859);Object.defineProperty(t,"SQLEditorTestUtils",{enumerable:!0,get:function(){return o.SQLEditorTestUtils}});var i=r(85678);Object.defineProperty(t,"LinkedToken",{enumerable:!0,get:function(){return i.LinkedToken}});var a=r(63178);Object.defineProperty(t,"grafanaStandardSQLLanguage",{enumerable:!0,get:function(){return a.language}}),Object.defineProperty(t,"grafanaStandardSQLLanguageConf",{enumerable:!0,get:function(){return a.conf}});var l=r(40937);Object.defineProperty(t,"getStandardSQLCompletionProvider",{enumerable:!0,get:function(){return l.getStandardSQLCompletionProvider}});var u=r(20395);Object.defineProperty(t,"OperatorType",{enumerable:!0,get:function(){return u.OperatorType}}),Object.defineProperty(t,"MacroType",{enumerable:!0,get:function(){return u.MacroType}}),Object.defineProperty(t,"TokenType",{enumerable:!0,get:function(){return u.TokenType}}),Object.defineProperty(t,"StatementPosition",{enumerable:!0,get:function(){return u.StatementPosition}}),Object.defineProperty(t,"SuggestionKind",{enumerable:!0,get:function(){return u.SuggestionKind}}),Object.defineProperty(t,"CompletionItemKind",{enumerable:!0,get:function(){return u.CompletionItemKind}}),Object.defineProperty(t,"CompletionItemPriority",{enumerable:!0,get:function(){return u.CompletionItemPriority}}),Object.defineProperty(t,"CompletionItemInsertTextRule",{enumerable:!0,get:function(){return u.CompletionItemInsertTextRule}}),Object.defineProperty(t,"SQLEditorMode",{enumerable:!0,get:function(){return u.SQLEditorMode}})},76199:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMonacoMock=void 0,t.getMonacoMock=e=>({editor:{tokenize:(t,r)=>e.get(t)},Range:{containsPosition:(e,t)=>t.lineNumber>=e.startLineNumber&&t.lineNumber<=e.endLineNumber&&t.column>=e.startColumn&&t.column<=e.endColumn},languages:{CompletionItemKind:{Snippet:2,Function:1,Keyword:3},CompletionItemInsertTextRule:{InsertAsSnippet:2}}})},35002:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TextModel=void 0,t.TextModel=function(e){return{getValue:function(t,r){return e},getValueInRange:function(t,r){return e.split("\n")[t.startLineNumber-1].trim().slice(0===t.startColumn?0:t.startColumn-1,t.endColumn-1)},getLineLength:function(t){return e.split("\n")[t-1].trim().length}}}},87039:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multiLineFullQuery=void 0,t.multiLineFullQuery={query:'SELECT column1,\n  FROM table1\n\n  WHERE column1 = "value1"\n  GROUP BY column1 ORDER BY column1 DESC\n  LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"identifier.sql",language:"sql"},{offset:14,type:"delimiter.sql",language:"sql"},{offset:15,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:4,type:"white.sql",language:"sql"},{offset:5,type:"identifier.sql",language:"sql"},{offset:11,type:"white.sql",language:"sql"}],[{offset:0,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"identifier.sql",language:"sql"},{offset:13,type:"white.sql",language:"sql"},{offset:14,type:"operator.sql",language:"sql"},{offset:15,type:"white.sql",language:"sql"},{offset:16,type:"identifier.quote.sql",language:"sql"},{offset:17,type:"identifier.sql",language:"sql"},{offset:23,type:"identifier.quote.sql",language:"sql"},{offset:24,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"keyword.sql",language:"sql"},{offset:8,type:"white.sql",language:"sql"},{offset:9,type:"identifier.sql",language:"sql"},{offset:16,type:"white.sql",language:"sql"},{offset:17,type:"keyword.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"keyword.sql",language:"sql"},{offset:25,type:"white.sql",language:"sql"},{offset:26,type:"identifier.sql",language:"sql"},{offset:33,type:"white.sql",language:"sql"},{offset:34,type:"keyword.sql",language:"sql"},{offset:38,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"number.sql",language:"sql"},{offset:8,type:"delimiter.sql",language:"sql"}]]}},44445:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multiLineFullQueryWithAggregation=void 0,t.multiLineFullQueryWithAggregation={query:'SELECT count(column1),\n  FROM table1\n\n  WHERE column1 = "value1"\n  GROUP BY column1 ORDER BY column1 DESC\n  LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"predefined.sql",language:"sql"},{offset:12,type:"delimiter.parenthesis.sql",language:"sql"},{offset:13,type:"identifier.sql",language:"sql"},{offset:20,type:"delimiter.parenthesis.sql",language:"sql"},{offset:21,type:"delimiter.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:4,type:"white.sql",language:"sql"},{offset:5,type:"identifier.sql",language:"sql"},{offset:11,type:"white.sql",language:"sql"}],[{offset:0,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"identifier.sql",language:"sql"},{offset:13,type:"white.sql",language:"sql"},{offset:14,type:"operator.sql",language:"sql"},{offset:15,type:"white.sql",language:"sql"},{offset:16,type:"identifier.quote.sql",language:"sql"},{offset:17,type:"identifier.sql",language:"sql"},{offset:23,type:"identifier.quote.sql",language:"sql"},{offset:24,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"keyword.sql",language:"sql"},{offset:8,type:"white.sql",language:"sql"},{offset:9,type:"identifier.sql",language:"sql"},{offset:16,type:"white.sql",language:"sql"},{offset:17,type:"keyword.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"keyword.sql",language:"sql"},{offset:25,type:"white.sql",language:"sql"},{offset:26,type:"identifier.sql",language:"sql"},{offset:33,type:"white.sql",language:"sql"},{offset:34,type:"keyword.sql",language:"sql"},{offset:38,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"number.sql",language:"sql"},{offset:8,type:"delimiter.sql",language:"sql"}]]}},56791:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multiLineMultipleColumns=void 0,t.multiLineMultipleColumns={query:'SELECT count(column1), column2\n  FROM table1\n\n  WHERE column1 = "value1"\n  GROUP BY column1 ORDER BY column1, avg(column2) DESC\n  LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"predefined.sql",language:"sql"},{offset:12,type:"delimiter.parenthesis.sql",language:"sql"},{offset:13,type:"identifier.sql",language:"sql"},{offset:20,type:"delimiter.parenthesis.sql",language:"sql"},{offset:21,type:"delimiter.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"identifier.sql",language:"sql"},{offset:30,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:4,type:"white.sql",language:"sql"},{offset:5,type:"identifier.sql",language:"sql"},{offset:11,type:"white.sql",language:"sql"}],[{offset:0,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"identifier.sql",language:"sql"},{offset:13,type:"white.sql",language:"sql"},{offset:14,type:"operator.sql",language:"sql"},{offset:15,type:"white.sql",language:"sql"},{offset:16,type:"identifier.quote.sql",language:"sql"},{offset:17,type:"identifier.sql",language:"sql"},{offset:23,type:"identifier.quote.sql",language:"sql"},{offset:24,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"keyword.sql",language:"sql"},{offset:8,type:"white.sql",language:"sql"},{offset:9,type:"identifier.sql",language:"sql"},{offset:16,type:"white.sql",language:"sql"},{offset:17,type:"keyword.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"keyword.sql",language:"sql"},{offset:25,type:"white.sql",language:"sql"},{offset:26,type:"identifier.sql",language:"sql"},{offset:33,type:"delimiter.sql",language:"sql"},{offset:34,type:"white.sql",language:"sql"},{offset:35,type:"predefined.sql",language:"sql"},{offset:38,type:"delimiter.parenthesis.sql",language:"sql"},{offset:39,type:"identifier.sql",language:"sql"},{offset:46,type:"delimiter.parenthesis.sql",language:"sql"},{offset:47,type:"white.sql",language:"sql"},{offset:48,type:"keyword.sql",language:"sql"},{offset:52,type:"white.sql",language:"sql"}],[{offset:0,type:"keyword.sql",language:"sql"},{offset:5,type:"white.sql",language:"sql"},{offset:6,type:"number.sql",language:"sql"},{offset:8,type:"delimiter.sql",language:"sql"}]]}},55984:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.singleLineEmptyQuery=void 0,t.singleLineEmptyQuery={query:"",tokens:[]}},61668:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.singleLineFullQuery=void 0,t.singleLineFullQuery={query:'SELECT column1, FROM table1 WHERE column1 = "value1" GROUP BY column1 ORDER BY column1 DESC LIMIT 10',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"identifier.sql",language:"sql"},{offset:14,type:"delimiter.sql",language:"sql"},{offset:15,type:"white.sql",language:"sql"},{offset:16,type:"keyword.sql",language:"sql"},{offset:20,type:"white.sql",language:"sql"},{offset:21,type:"identifier.sql",language:"sql"},{offset:27,type:"white.sql",language:"sql"},{offset:28,type:"keyword.sql",language:"sql"},{offset:33,type:"white.sql",language:"sql"},{offset:34,type:"identifier.sql",language:"sql"},{offset:41,type:"white.sql",language:"sql"},{offset:42,type:"operator.sql",language:"sql"},{offset:43,type:"white.sql",language:"sql"},{offset:44,type:"identifier.quote.sql",language:"sql"},{offset:45,type:"identifier.sql",language:"sql"},{offset:51,type:"identifier.quote.sql",language:"sql"},{offset:52,type:"white.sql",language:"sql"},{offset:53,type:"keyword.sql",language:"sql"},{offset:58,type:"white.sql",language:"sql"},{offset:59,type:"keyword.sql",language:"sql"},{offset:61,type:"white.sql",language:"sql"},{offset:62,type:"identifier.sql",language:"sql"},{offset:69,type:"white.sql",language:"sql"},{offset:70,type:"keyword.sql",language:"sql"},{offset:75,type:"white.sql",language:"sql"},{offset:76,type:"keyword.sql",language:"sql"},{offset:78,type:"white.sql",language:"sql"},{offset:79,type:"identifier.sql",language:"sql"},{offset:86,type:"white.sql",language:"sql"},{offset:87,type:"keyword.sql",language:"sql"},{offset:91,type:"white.sql",language:"sql"},{offset:92,type:"keyword.sql",language:"sql"},{offset:97,type:"white.sql",language:"sql"},{offset:98,type:"number.sql",language:"sql"},{offset:100,type:"delimiter.sql",language:"sql"}]]}},8208:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.singleLineFullQueryWithAggregation=void 0,t.singleLineFullQueryWithAggregation={query:'SELECT count(column1), FROM table1 WHERE column1 = "value1" GROUP BY column1 ORDER BY column1 DESC LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"predefined.sql",language:"sql"},{offset:12,type:"delimiter.parenthesis.sql",language:"sql"},{offset:13,type:"identifier.sql",language:"sql"},{offset:20,type:"delimiter.parenthesis.sql",language:"sql"},{offset:21,type:"delimiter.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"keyword.sql",language:"sql"},{offset:27,type:"white.sql",language:"sql"},{offset:28,type:"identifier.sql",language:"sql"},{offset:34,type:"white.sql",language:"sql"},{offset:35,type:"keyword.sql",language:"sql"},{offset:40,type:"white.sql",language:"sql"},{offset:41,type:"identifier.sql",language:"sql"},{offset:48,type:"white.sql",language:"sql"},{offset:49,type:"operator.sql",language:"sql"},{offset:50,type:"white.sql",language:"sql"},{offset:51,type:"identifier.quote.sql",language:"sql"},{offset:52,type:"identifier.sql",language:"sql"},{offset:58,type:"identifier.quote.sql",language:"sql"},{offset:59,type:"white.sql",language:"sql"},{offset:60,type:"keyword.sql",language:"sql"},{offset:65,type:"white.sql",language:"sql"},{offset:66,type:"keyword.sql",language:"sql"},{offset:68,type:"white.sql",language:"sql"},{offset:69,type:"identifier.sql",language:"sql"},{offset:76,type:"white.sql",language:"sql"},{offset:77,type:"keyword.sql",language:"sql"},{offset:82,type:"white.sql",language:"sql"},{offset:83,type:"keyword.sql",language:"sql"},{offset:85,type:"white.sql",language:"sql"},{offset:86,type:"identifier.sql",language:"sql"},{offset:93,type:"white.sql",language:"sql"},{offset:94,type:"keyword.sql",language:"sql"},{offset:98,type:"white.sql",language:"sql"},{offset:99,type:"keyword.sql",language:"sql"},{offset:104,type:"white.sql",language:"sql"},{offset:105,type:"number.sql",language:"sql"},{offset:107,type:"delimiter.sql",language:"sql"}]]}},88840:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.singleLineMultipleColumns=void 0,t.singleLineMultipleColumns={query:'SELECT count(column1), column2 FROM table1 WHERE column1 = "value1" GROUP BY column1 ORDER BY column1, avg(column2) DESC LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"predefined.sql",language:"sql"},{offset:12,type:"delimiter.parenthesis.sql",language:"sql"},{offset:13,type:"identifier.sql",language:"sql"},{offset:20,type:"delimiter.parenthesis.sql",language:"sql"},{offset:21,type:"delimiter.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"identifier.sql",language:"sql"},{offset:30,type:"white.sql",language:"sql"},{offset:31,type:"keyword.sql",language:"sql"},{offset:35,type:"white.sql",language:"sql"},{offset:36,type:"identifier.sql",language:"sql"},{offset:42,type:"white.sql",language:"sql"},{offset:43,type:"keyword.sql",language:"sql"},{offset:48,type:"white.sql",language:"sql"},{offset:49,type:"identifier.sql",language:"sql"},{offset:56,type:"white.sql",language:"sql"},{offset:57,type:"operator.sql",language:"sql"},{offset:58,type:"white.sql",language:"sql"},{offset:59,type:"identifier.quote.sql",language:"sql"},{offset:60,type:"identifier.sql",language:"sql"},{offset:66,type:"identifier.quote.sql",language:"sql"},{offset:67,type:"white.sql",language:"sql"},{offset:68,type:"keyword.sql",language:"sql"},{offset:73,type:"white.sql",language:"sql"},{offset:74,type:"keyword.sql",language:"sql"},{offset:76,type:"white.sql",language:"sql"},{offset:77,type:"identifier.sql",language:"sql"},{offset:84,type:"white.sql",language:"sql"},{offset:85,type:"keyword.sql",language:"sql"},{offset:90,type:"white.sql",language:"sql"},{offset:91,type:"keyword.sql",language:"sql"},{offset:93,type:"white.sql",language:"sql"},{offset:94,type:"identifier.sql",language:"sql"},{offset:101,type:"delimiter.sql",language:"sql"},{offset:102,type:"white.sql",language:"sql"},{offset:103,type:"predefined.sql",language:"sql"},{offset:106,type:"delimiter.parenthesis.sql",language:"sql"},{offset:107,type:"identifier.sql",language:"sql"},{offset:114,type:"delimiter.parenthesis.sql",language:"sql"},{offset:115,type:"white.sql",language:"sql"},{offset:116,type:"keyword.sql",language:"sql"},{offset:120,type:"white.sql",language:"sql"},{offset:121,type:"keyword.sql",language:"sql"},{offset:126,type:"white.sql",language:"sql"},{offset:127,type:"number.sql",language:"sql"},{offset:129,type:"delimiter.sql",language:"sql"}]]}},82309:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.singleLineTwoQueries=void 0,t.singleLineTwoQueries={query:'SELECT column1, FROM table1 WHERE column1 = "value1" GROUP BY column1 ORDER BY column1 DESC LIMIT 10; SELECT column2, FROM table2 WHERE column2 = "value2" GROUP BY column1 ORDER BY column2 DESC LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"identifier.sql",language:"sql"},{offset:14,type:"delimiter.sql",language:"sql"},{offset:15,type:"white.sql",language:"sql"},{offset:16,type:"keyword.sql",language:"sql"},{offset:20,type:"white.sql",language:"sql"},{offset:21,type:"identifier.sql",language:"sql"},{offset:27,type:"white.sql",language:"sql"},{offset:28,type:"keyword.sql",language:"sql"},{offset:33,type:"white.sql",language:"sql"},{offset:34,type:"identifier.sql",language:"sql"},{offset:41,type:"white.sql",language:"sql"},{offset:42,type:"operator.sql",language:"sql"},{offset:43,type:"white.sql",language:"sql"},{offset:44,type:"identifier.quote.sql",language:"sql"},{offset:45,type:"identifier.sql",language:"sql"},{offset:51,type:"identifier.quote.sql",language:"sql"},{offset:52,type:"white.sql",language:"sql"},{offset:53,type:"keyword.sql",language:"sql"},{offset:58,type:"white.sql",language:"sql"},{offset:59,type:"keyword.sql",language:"sql"},{offset:61,type:"white.sql",language:"sql"},{offset:62,type:"identifier.sql",language:"sql"},{offset:69,type:"white.sql",language:"sql"},{offset:70,type:"keyword.sql",language:"sql"},{offset:75,type:"white.sql",language:"sql"},{offset:76,type:"keyword.sql",language:"sql"},{offset:78,type:"white.sql",language:"sql"},{offset:79,type:"identifier.sql",language:"sql"},{offset:86,type:"white.sql",language:"sql"},{offset:87,type:"keyword.sql",language:"sql"},{offset:91,type:"white.sql",language:"sql"},{offset:92,type:"keyword.sql",language:"sql"},{offset:97,type:"white.sql",language:"sql"},{offset:98,type:"number.sql",language:"sql"},{offset:100,type:"delimiter.sql",language:"sql"},{offset:101,type:"white.sql",language:"sql"},{offset:102,type:"keyword.sql",language:"sql"},{offset:108,type:"white.sql",language:"sql"},{offset:109,type:"identifier.sql",language:"sql"},{offset:116,type:"delimiter.sql",language:"sql"},{offset:117,type:"white.sql",language:"sql"},{offset:118,type:"keyword.sql",language:"sql"},{offset:122,type:"white.sql",language:"sql"},{offset:123,type:"identifier.sql",language:"sql"},{offset:129,type:"white.sql",language:"sql"},{offset:130,type:"keyword.sql",language:"sql"},{offset:135,type:"white.sql",language:"sql"},{offset:136,type:"identifier.sql",language:"sql"},{offset:143,type:"white.sql",language:"sql"},{offset:144,type:"operator.sql",language:"sql"},{offset:145,type:"white.sql",language:"sql"},{offset:146,type:"identifier.quote.sql",language:"sql"},{offset:147,type:"identifier.sql",language:"sql"},{offset:153,type:"identifier.quote.sql",language:"sql"},{offset:154,type:"white.sql",language:"sql"},{offset:155,type:"keyword.sql",language:"sql"},{offset:160,type:"white.sql",language:"sql"},{offset:161,type:"keyword.sql",language:"sql"},{offset:163,type:"white.sql",language:"sql"},{offset:164,type:"identifier.sql",language:"sql"},{offset:171,type:"white.sql",language:"sql"},{offset:172,type:"keyword.sql",language:"sql"},{offset:177,type:"white.sql",language:"sql"},{offset:178,type:"keyword.sql",language:"sql"},{offset:180,type:"white.sql",language:"sql"},{offset:181,type:"identifier.sql",language:"sql"},{offset:188,type:"white.sql",language:"sql"},{offset:189,type:"keyword.sql",language:"sql"},{offset:193,type:"white.sql",language:"sql"},{offset:194,type:"keyword.sql",language:"sql"},{offset:199,type:"white.sql",language:"sql"},{offset:200,type:"number.sql",language:"sql"},{offset:202,type:"delimiter.sql",language:"sql"}]]}},65011:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.singleLineTwoQueriesWithAggregation=void 0,t.singleLineTwoQueriesWithAggregation={query:'SELECT count(column1), FROM table1 WHERE column1 = "value1" GROUP BY column1 ORDER BY column1 DESC LIMIT 10; SELECT count(column2), FROM table2 WHERE column2 = "value2" GROUP BY column1 ORDER BY column2 DESC LIMIT 10;',tokens:[[{offset:0,type:"keyword.sql",language:"sql"},{offset:6,type:"white.sql",language:"sql"},{offset:7,type:"predefined.sql",language:"sql"},{offset:12,type:"delimiter.parenthesis.sql",language:"sql"},{offset:13,type:"identifier.sql",language:"sql"},{offset:20,type:"delimiter.parenthesis.sql",language:"sql"},{offset:21,type:"delimiter.sql",language:"sql"},{offset:22,type:"white.sql",language:"sql"},{offset:23,type:"keyword.sql",language:"sql"},{offset:27,type:"white.sql",language:"sql"},{offset:28,type:"identifier.sql",language:"sql"},{offset:34,type:"white.sql",language:"sql"},{offset:35,type:"keyword.sql",language:"sql"},{offset:40,type:"white.sql",language:"sql"},{offset:41,type:"identifier.sql",language:"sql"},{offset:48,type:"white.sql",language:"sql"},{offset:49,type:"operator.sql",language:"sql"},{offset:50,type:"white.sql",language:"sql"},{offset:51,type:"identifier.quote.sql",language:"sql"},{offset:52,type:"identifier.sql",language:"sql"},{offset:58,type:"identifier.quote.sql",language:"sql"},{offset:59,type:"white.sql",language:"sql"},{offset:60,type:"keyword.sql",language:"sql"},{offset:65,type:"white.sql",language:"sql"},{offset:66,type:"keyword.sql",language:"sql"},{offset:68,type:"white.sql",language:"sql"},{offset:69,type:"identifier.sql",language:"sql"},{offset:76,type:"white.sql",language:"sql"},{offset:77,type:"keyword.sql",language:"sql"},{offset:82,type:"white.sql",language:"sql"},{offset:83,type:"keyword.sql",language:"sql"},{offset:85,type:"white.sql",language:"sql"},{offset:86,type:"identifier.sql",language:"sql"},{offset:93,type:"white.sql",language:"sql"},{offset:94,type:"keyword.sql",language:"sql"},{offset:98,type:"white.sql",language:"sql"},{offset:99,type:"keyword.sql",language:"sql"},{offset:104,type:"white.sql",language:"sql"},{offset:105,type:"number.sql",language:"sql"},{offset:107,type:"delimiter.sql",language:"sql"},{offset:108,type:"white.sql",language:"sql"},{offset:109,type:"keyword.sql",language:"sql"},{offset:115,type:"white.sql",language:"sql"},{offset:116,type:"predefined.sql",language:"sql"},{offset:121,type:"delimiter.parenthesis.sql",language:"sql"},{offset:122,type:"identifier.sql",language:"sql"},{offset:129,type:"delimiter.parenthesis.sql",language:"sql"},{offset:130,type:"delimiter.sql",language:"sql"},{offset:131,type:"white.sql",language:"sql"},{offset:132,type:"keyword.sql",language:"sql"},{offset:136,type:"white.sql",language:"sql"},{offset:137,type:"identifier.sql",language:"sql"},{offset:143,type:"white.sql",language:"sql"},{offset:144,type:"keyword.sql",language:"sql"},{offset:149,type:"white.sql",language:"sql"},{offset:150,type:"identifier.sql",language:"sql"},{offset:157,type:"white.sql",language:"sql"},{offset:158,type:"operator.sql",language:"sql"},{offset:159,type:"white.sql",language:"sql"},{offset:160,type:"identifier.quote.sql",language:"sql"},{offset:161,type:"identifier.sql",language:"sql"},{offset:167,type:"identifier.quote.sql",language:"sql"},{offset:168,type:"white.sql",language:"sql"},{offset:169,type:"keyword.sql",language:"sql"},{offset:174,type:"white.sql",language:"sql"},{offset:175,type:"keyword.sql",language:"sql"},{offset:177,type:"white.sql",language:"sql"},{offset:178,type:"identifier.sql",language:"sql"},{offset:185,type:"white.sql",language:"sql"},{offset:186,type:"keyword.sql",language:"sql"},{offset:191,type:"white.sql",language:"sql"},{offset:192,type:"keyword.sql",language:"sql"},{offset:194,type:"white.sql",language:"sql"},{offset:195,type:"identifier.sql",language:"sql"},{offset:202,type:"white.sql",language:"sql"},{offset:203,type:"keyword.sql",language:"sql"},{offset:207,type:"white.sql",language:"sql"},{offset:208,type:"keyword.sql",language:"sql"},{offset:213,type:"white.sql",language:"sql"},{offset:214,type:"number.sql",language:"sql"},{offset:216,type:"delimiter.sql",language:"sql"}]]}},26076:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multiLineMultipleColumns=t.singleLineMultipleColumns=t.singleLineTwoQueriesWithAggregation=t.singleLineTwoQueries=t.singleLineEmptyQuery=t.multiLineFullQueryWithAggregation=t.multiLineFullQuery=t.singleLineFullQueryWithAggregation=t.singleLineFullQuery=void 0;var n=r(61668);Object.defineProperty(t,"singleLineFullQuery",{enumerable:!0,get:function(){return n.singleLineFullQuery}});var o=r(8208);Object.defineProperty(t,"singleLineFullQueryWithAggregation",{enumerable:!0,get:function(){return o.singleLineFullQueryWithAggregation}});var i=r(87039);Object.defineProperty(t,"multiLineFullQuery",{enumerable:!0,get:function(){return i.multiLineFullQuery}});var a=r(44445);Object.defineProperty(t,"multiLineFullQueryWithAggregation",{enumerable:!0,get:function(){return a.multiLineFullQueryWithAggregation}});var l=r(55984);Object.defineProperty(t,"singleLineEmptyQuery",{enumerable:!0,get:function(){return l.singleLineEmptyQuery}});var u=r(82309);Object.defineProperty(t,"singleLineTwoQueries",{enumerable:!0,get:function(){return u.singleLineTwoQueries}});var s=r(65011);Object.defineProperty(t,"singleLineTwoQueriesWithAggregation",{enumerable:!0,get:function(){return s.singleLineTwoQueriesWithAggregation}});var c=r(88840);Object.defineProperty(t,"singleLineMultipleColumns",{enumerable:!0,get:function(){return c.singleLineMultipleColumns}});var d=r(56791);Object.defineProperty(t,"multiLineMultipleColumns",{enumerable:!0,get:function(){return d.multiLineMultipleColumns}})},3357:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});const n={id:"standardSql",extensions:[".sql"],aliases:["sql"],mimetypes:[],loader:()=>Promise.resolve().then((()=>__importStar(r(63178)))),completionProvider:r(40937).getStandardSQLCompletionProvider};t.default=n},52378:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getStandardSuggestions=void 0;const n=r(91666),o=r(71978);t.getStandardSuggestions=(e,t,r,i,a)=>n.__awaiter(void 0,void 0,void 0,(function*(){let n=[];const l=(null==t?void 0:t.isWhiteSpace())||(null==t?void 0:t.isParenthesis())||(null==t?void 0:t.isIdentifier())&&t.value.endsWith(".")||!(null==t?void 0:t.range)?e.Range.fromPositions(i.position):null==t?void 0:t.range;for(const t of[...new Set(r)]){const r=a.getIfExists(t);if(r){const t=yield r.suggestions(Object.assign(Object.assign({},i),{range:l}),e);n=[...n,...t.map((e=>(0,o.toCompletionItem)(e.label,l,Object.assign({kind:e.kind},e))))]}}return Promise.resolve(n)}))},39110:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getStatementPosition=void 0;const n=r(20395);t.getStatementPosition=function(e,t){var r;const o=null==e?void 0:e.getPreviousNonWhiteSpaceToken(),i=null==e?void 0:e.getPreviousKeyword(),a=null===(r=null==e?void 0:e.getPreviousNonWhiteSpaceToken())||void 0===r?void 0:r.is(n.TokenType.Operator,"/"),l=t.list(),u=[];for(const t of l)t.resolve(e,null!=i?i:null,null!=o?o:null,Boolean(a))&&u.push(t.id);return 0===u.length?[n.StatementPosition.Unknown]:u}},63178:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.language=t.conf=t.STD_OPERATORS=t.COMPARISON_OPERATORS=t.NOT_EQUALS=t.EQUALS=t.LOGICAL_OPERATORS=t.OR=t.AND=t.SCHEMA=t.AS=t.WITH=t.LIMIT=t.ASC=t.DESC=t.BY=t.ORDER=t.GROUP=t.WHERE=t.FROM=t.SELECT=void 0,t.SELECT="select",t.FROM="from",t.WHERE="where",t.GROUP="group",t.ORDER="order",t.BY="by",t.DESC="desc",t.ASC="asc",t.LIMIT="limit",t.WITH="with",t.AS="as",t.SCHEMA="schema",t.AND="AND",t.OR="OR",t.LOGICAL_OPERATORS=[t.AND,t.OR],t.EQUALS="=",t.NOT_EQUALS="!=",t.COMPARISON_OPERATORS=[t.EQUALS,t.NOT_EQUALS],t.STD_OPERATORS=[...t.COMPARISON_OPERATORS],t.conf={comments:{lineComment:"--",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}]},t.language={defaultToken:"",tokenPostfix:".sql",ignoreCase:!0,brackets:[{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"}],keywords:["ABORT","ABSOLUTE","ACTION","ADA","ADD","AFTER","ALL","ALLOCATE","ALTER","ALWAYS","ANALYZE","AND","ANY","ARE","AS","ASC","ASSERTION","AT","ATTACH","AUTHORIZATION","AUTOINCREMENT","AVG","BACKUP","BEFORE","BEGIN","BETWEEN","BIT","BIT_LENGTH","BOTH","BREAK","BROWSE","BULK","BY","CASCADE","CASCADED","CASE","CAST","CATALOG","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CHECKPOINT","CLOSE","CLUSTERED","COALESCE","COLLATE","COLLATION","COLUMN","COMMIT","COMPUTE","CONFLICT","CONNECT","CONNECTION","CONSTRAINT","CONSTRAINTS","CONTAINS","CONTAINSTABLE","CONTINUE","CONVERT","CORRESPONDING","COUNT","CREATE","CROSS","CURRENT","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATE","DAY","DBCC","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFERRABLE","DEFERRED","DELETE","DENY","DESC","DESCRIBE","DESCRIPTOR","DETACH","DIAGNOSTICS","DISCONNECT","DISK","DISTINCT","DISTRIBUTED","DO","DOMAIN","DOUBLE","DROP","DUMP","EACH","ELSE","END","END-EXEC","ERRLVL","ESCAPE","EXCEPT","EXCEPTION","EXCLUDE","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXPLAIN","EXTERNAL","EXTRACT","FAIL","FALSE","FETCH","FILE","FILLFACTOR","FILTER","FIRST","FLOAT","FOLLOWING","FOR","FOREIGN","FORTRAN","FOUND","FREETEXT","FREETEXTTABLE","FROM","FULL","FUNCTION","GENERATED","GET","GLOB","GLOBAL","GO","GOTO","GRANT","GROUP","GROUPS","HAVING","HOLDLOCK","HOUR","IDENTITY","IDENTITYCOL","IDENTITY_INSERT","IF","IGNORE","IMMEDIATE","IN","INCLUDE","INDEX","INDEXED","INDICATOR","INITIALLY","INNER","INPUT","INSENSITIVE","INSERT","INSTEAD","INT","INTEGER","INTERSECT","INTERVAL","INTO","IS","ISNULL","ISOLATION","JOIN","KEY","KILL","LANGUAGE","LAST","LEADING","LEFT","LEVEL","LIKE","LIMIT","LINENO","LOAD","LOCAL","LOWER","MATCH","MATERIALIZED","MAX","MERGE","MIN","MINUTE","MODULE","MONTH","NAMES","NATIONAL","NATURAL","NCHAR","NEXT","NO","NOCHECK","NONCLUSTERED","NONE","NOT","NOTHING","NOTNULL","NULL","NULLIF","NULLS","NUMERIC","OCTET_LENGTH","OF","OFF","OFFSET","OFFSETS","ON","ONLY","OPEN","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","OPTION","OR","ORDER","OTHERS","OUTER","OUTPUT","OVER","OVERLAPS","PAD","PARTIAL","PARTITION","PASCAL","PERCENT","PIVOT","PLAN","POSITION","PRAGMA","PRECEDING","PRECISION","PREPARE","PRESERVE","PRIMARY","PRINT","PRIOR","PRIVILEGES","PROC","PROCEDURE","PUBLIC","QUERY","RAISE","RAISERROR","RANGE","READ","READTEXT","REAL","RECONFIGURE","RECURSIVE","REFERENCES","REGEXP","REINDEX","RELATIVE","RELEASE","RENAME","REPLACE","REPLICATION","RESTORE","RESTRICT","RETURN","RETURNING","REVERT","REVOKE","RIGHT","ROLLBACK","ROW","ROWCOUNT","ROWGUIDCOL","ROWS","RULE","SAVE","SAVEPOINT","SCHEMA","SCROLL","SECOND","SECTION","SECURITYAUDIT","SELECT","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","SESSION","SESSION_USER","SET","SETUSER","SHUTDOWN","SIZE","SMALLINT","SOME","SPACE","SQL","SQLCA","SQLCODE","SQLERROR","SQLSTATE","SQLWARNING","STATISTICS","SUBSTRING","SUM","SYSTEM_USER","TABLE","TABLESAMPLE","TEMP","TEMPORARY","TEXTSIZE","THEN","TIES","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TOP","TRAILING","TRAN","TRANSACTION","TRANSLATE","TRANSLATION","TRIGGER","TRIM","TRUE","TRUNCATE","TRY_CONVERT","TSEQUAL","UNBOUNDED","UNION","UNIQUE","UNKNOWN","UNPIVOT","UPDATE","UPDATETEXT","UPPER","USAGE","USE","USER","USING","VACUUM","VALUE","VALUES","VARCHAR","VARYING","VIEW","VIRTUAL","WAITFOR","WHEN","WHENEVER","WHERE","WHILE","WINDOW","WITH","WITHIN GROUP","WITHOUT","WORK","WRITE","WRITETEXT","YEAR","ZONE"],operators:["EXCEPT","INTERSECT","UNION","APPLY","CROSS","FULL","INNER","JOIN","LEFT","OUTER","RIGHT","CONTAINS","FREETEXT","IS","NULL","PIVOT","UNPIVOT","MATCHED"],logicalOperators:["ALL","AND","ANY","BETWEEN","EXISTS","IN","LIKE","NOT","OR","SOME"],comparisonOperators:["<>",">","<",">=","<=","=","!=","&","~","^","%"],builtinFunctions:["AVG","CHECKSUM_AGG","COUNT","COUNT_BIG","GROUPING","GROUPING_ID","MAX","MIN","SUM","STDEV","STDEVP","VAR","VARP","CUME_DIST","FIRST_VALUE","LAG","LAST_VALUE","LEAD","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","COLLATE","COLLATIONPROPERTY","TERTIARY_WEIGHTS","FEDERATION_FILTERING_VALUE","CAST","CONVERT","PARSE","TRY_CAST","TRY_CONVERT","TRY_PARSE","ASYMKEY_ID","ASYMKEYPROPERTY","CERTPROPERTY","CERT_ID","CRYPT_GEN_RANDOM","DECRYPTBYASYMKEY","DECRYPTBYCERT","DECRYPTBYKEY","DECRYPTBYKEYAUTOASYMKEY","DECRYPTBYKEYAUTOCERT","DECRYPTBYPASSPHRASE","ENCRYPTBYASYMKEY","ENCRYPTBYCERT","ENCRYPTBYKEY","ENCRYPTBYPASSPHRASE","HASHBYTES","IS_OBJECTSIGNED","KEY_GUID","KEY_ID","KEY_NAME","SIGNBYASYMKEY","SIGNBYCERT","SYMKEYPROPERTY","VERIFYSIGNEDBYCERT","VERIFYSIGNEDBYASYMKEY","CURSOR_STATUS","DATALENGTH","IDENT_CURRENT","IDENT_INCR","IDENT_SEED","IDENTITY","SQL_VARIANT_PROPERTY","CURRENT_TIMESTAMP","DATEADD","DATEDIFF","DATEFROMPARTS","DATENAME","DATEPART","DATETIME2FROMPARTS","DATETIMEFROMPARTS","DATETIMEOFFSETFROMPARTS","DAY","EOMONTH","GETDATE","GETUTCDATE","ISDATE","MONTH","SMALLDATETIMEFROMPARTS","SWITCHOFFSET","SYSDATETIME","SYSDATETIMEOFFSET","SYSUTCDATETIME","TIMEFROMPARTS","TODATETIMEOFFSET","YEAR","CHOOSE","COALESCE","IIF","NULLIF","ABS","ACOS","ASIN","ATAN","ATN2","CEILING","COS","COT","DEGREES","EXP","FLOOR","LOG","LOG10","PI","POWER","RADIANS","RAND","ROUND","SIGN","SIN","SQRT","SQUARE","TAN","APP_NAME","APPLOCK_MODE","APPLOCK_TEST","ASSEMBLYPROPERTY","COL_LENGTH","COL_NAME","COLUMNPROPERTY","DATABASE_PRINCIPAL_ID","DATABASEPROPERTYEX","DB_ID","DB_NAME","FILE_ID","FILE_IDEX","FILE_NAME","FILEGROUP_ID","FILEGROUP_NAME","FILEGROUPPROPERTY","FILEPROPERTY","FULLTEXTCATALOGPROPERTY","FULLTEXTSERVICEPROPERTY","INDEX_COL","INDEXKEY_PROPERTY","INDEXPROPERTY","OBJECT_DEFINITION","OBJECT_ID","OBJECT_NAME","OBJECT_SCHEMA_NAME","OBJECTPROPERTY","OBJECTPROPERTYEX","ORIGINAL_DB_NAME","PARSENAME","SCHEMA_ID","SCHEMA_NAME","SCOPE_IDENTITY","SERVERPROPERTY","STATS_DATE","TYPE_ID","TYPE_NAME","TYPEPROPERTY","DENSE_RANK","NTILE","RANK","ROW_NUMBER","PUBLISHINGSERVERNAME","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","CERTENCODED","CERTPRIVATEKEY","CURRENT_USER","HAS_DBACCESS","HAS_PERMS_BY_NAME","IS_MEMBER","IS_ROLEMEMBER","IS_SRVROLEMEMBER","LOGINPROPERTY","ORIGINAL_LOGIN","PERMISSIONS","PWDENCRYPT","PWDCOMPARE","SESSION_USER","SESSIONPROPERTY","SUSER_ID","SUSER_NAME","SUSER_SID","SUSER_SNAME","SYSTEM_USER","USER","USER_ID","USER_NAME","ASCII","CHAR","CHARINDEX","CONCAT","DIFFERENCE","FORMAT","LEFT","LEN","LOWER","LTRIM","NCHAR","PATINDEX","QUOTENAME","REPLACE","REPLICATE","REVERSE","RIGHT","RTRIM","SOUNDEX","SPACE","STR","STUFF","SUBSTRING","UNICODE","UPPER","BINARY_CHECKSUM","CHECKSUM","CONNECTIONPROPERTY","CONTEXT_INFO","CURRENT_REQUEST_ID","ERROR_LINE","ERROR_NUMBER","ERROR_MESSAGE","ERROR_PROCEDURE","ERROR_SEVERITY","ERROR_STATE","FORMATMESSAGE","GETANSINULL","GET_FILESTREAM_TRANSACTION_CONTEXT","HOST_ID","HOST_NAME","ISNULL","ISNUMERIC","MIN_ACTIVE_ROWVERSION","NEWID","NEWSEQUENTIALID","ROWCOUNT_BIG","XACT_STATE","TEXTPTR","TEXTVALID","COLUMNS_UPDATED","EVENTDATA","TRIGGER_NESTLEVEL","UPDATE","CHANGETABLE","CHANGE_TRACKING_CONTEXT","CHANGE_TRACKING_CURRENT_VERSION","CHANGE_TRACKING_IS_COLUMN_IN_MASK","CHANGE_TRACKING_MIN_VALID_VERSION","CONTAINSTABLE","FREETEXTTABLE","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","FILETABLEROOTPATH","GETFILENAMESPACEPATH","GETPATHLOCATOR","PATHNAME","GET_TRANSMISSION_STATUS"],builtinVariables:["@@DATEFIRST","@@DBTS","@@LANGID","@@LANGUAGE","@@LOCK_TIMEOUT","@@MAX_CONNECTIONS","@@MAX_PRECISION","@@NESTLEVEL","@@OPTIONS","@@REMSERVER","@@SERVERNAME","@@SERVICENAME","@@SPID","@@TEXTSIZE","@@VERSION","@@CURSOR_ROWS","@@FETCH_STATUS","@@DATEFIRST","@@PROCID","@@ERROR","@@IDENTITY","@@ROWCOUNT","@@TRANCOUNT","@@CONNECTIONS","@@CPU_BUSY","@@IDLE","@@IO_BUSY","@@PACKET_ERRORS","@@PACK_RECEIVED","@@PACK_SENT","@@TIMETICKS","@@TOTAL_ERRORS","@@TOTAL_READ","@@TOTAL_WRITE"],pseudoColumns:["$ACTION","$IDENTITY","$ROWGUID","$PARTITION"],tokenizer:{root:[{include:"@templateVariables"},{include:"@macros"},{include:"@comments"},{include:"@whitespace"},{include:"@pseudoColumns"},{include:"@numbers"},{include:"@strings"},{include:"@complexIdentifiers"},{include:"@scopes"},{include:"@schemaTable"},[/[;,.]/,"delimiter"],[/[()]/,"@brackets"],[/[\w@#$|<|>|=|!|%|&|+|\|-|*|/|~|^]+/,{cases:{"@operators":"operator","@comparisonOperators":"operator","@logicalOperators":"operator","@builtinVariables":"predefined","@builtinFunctions":"predefined","@keywords":"keyword","@default":"identifier"}}]],templateVariables:[[/\$[a-zA-Z0-9]+/,"variable"]],macros:[[/\$__[a-zA-Z0-9-_]+/,"type"]],schemaTable:[[/(\w+)\./,"identifier"],[/(\w+\.\w+)/,"identifier"]],whitespace:[[/\s+/,"white"]],comments:[[/--+.*/,"comment"],[/\/\*/,{token:"comment.quote",next:"@comment"}]],comment:[[/[^*/]+/,"comment"],[/\*\//,{token:"comment.quote",next:"@pop"}],[/./,"comment"]],pseudoColumns:[[/[$][A-Za-z_][\w@#$]*/,{cases:{"@pseudoColumns":"predefined","@default":"identifier"}}]],numbers:[[/0[xX][0-9a-fA-F]*/,"number"],[/[$][+-]*\d*(\.\d*)?/,"number"],[/((\d+(\.\d*)?)|(\.\d+))([eE][\-+]?\d+)?/,"number"]],strings:[[/N'/,{token:"string",next:"@string"}],[/'/,{token:"string",next:"@string"}]],string:[[/[^']+/,"string"],[/''/,"string"],[/'/,{token:"string",next:"@pop"}]],complexIdentifiers:[[/\[/,{token:"identifier.quote",next:"@bracketedIdentifier"}],[/"/,{token:"identifier.quote",next:"@quotedIdentifier"}]],bracketedIdentifier:[[/[^\]]+/,"identifier"],[/]]/,"identifier"],[/]/,{token:"identifier.quote",next:"@pop"}]],quotedIdentifier:[[/[^"]+/,"identifier"],[/""/,"identifier"],[/"/,{token:"identifier.quote",next:"@pop"}]],scopes:[[/BEGIN\s+(DISTRIBUTED\s+)?TRAN(SACTION)?\b/i,"keyword"],[/BEGIN\s+TRY\b/i,{token:"keyword.try"}],[/END\s+TRY\b/i,{token:"keyword.try"}],[/BEGIN\s+CATCH\b/i,{token:"keyword.catch"}],[/END\s+CATCH\b/i,{token:"keyword.catch"}],[/(BEGIN|CASE)\b/i,{token:"keyword.block"}],[/END\b/i,{token:"keyword.block"}],[/WHEN\b/i,{token:"keyword.choice"}],[/THEN\b/i,{token:"keyword.choice"}]]}}},7357:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MACROS=void 0;const n=r(20395),o="column";t.MACROS=[{id:"$__timeFilter(dateColumn)",name:"$__timeFilter(dateColumn)",text:"$__timeFilter",args:[o],type:n.MacroType.Filter,description:"Will be replaced by a time range filter using the specified column name. For example, dateColumn BETWEEN FROM_UNIXTIME(1494410783) AND FROM_UNIXTIME(1494410983)"},{id:"$__timeFrom()",name:"$__timeFrom()",text:"$__timeFrom",args:[],type:n.MacroType.Filter,description:"Will be replaced by the start of the currently active time selection. For example, FROM_UNIXTIME(1494410783)"},{id:"$__timeTo()",name:"$__timeTo()",text:"$__timeTo",args:[],type:n.MacroType.Filter,description:"Will be replaced by the end of the currently active time selection. For example, FROM_UNIXTIME(1494410983)"},{id:"$__timeGroup(dateColumn, '5m')",name:"$__timeGroup(dateColumn, '5m')",text:"$__timeGroup",args:[o,"'5m'"],type:n.MacroType.Value,description:"Will be replaced by an expression usable in GROUP BY clause. For example, *cast(cast(UNIX_TIMESTAMP(dateColumn)/(300) as signed)*300 as signed),*"},{id:"$__table",name:"$__table",text:"$__table",args:[],type:n.MacroType.Table,description:"Will be replaced by the query table."},{id:"$__column",name:"$__column",text:"$__column",args:[],type:n.MacroType.Column,description:"Will be replaced by the query column."}]},40937:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getStandardSQLCompletionProvider=void 0;const n=r(20395),o=r(7357);t.getStandardSQLCompletionProvider=function(e,t){var r,i,a;const l={triggerCharacters:["."," ","$",",","(","'"]};t&&Array.isArray(t.builtinFunctions)&&(l.supportedFunctions=()=>t.builtinFunctions.map((e=>({id:e,name:e}))));const u=[];return(null===(r=null==t?void 0:t.comparisonOperators)||void 0===r?void 0:r.length)&&u.push(...t.comparisonOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:n.OperatorType.Comparison})))),t.logicalOperators=null!==(i=t.logicalOperators)&&void 0!==i?i:t.operators,(null===(a=null==t?void 0:t.logicalOperators)||void 0===a?void 0:a.length)&&u.push(...t.logicalOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:n.OperatorType.Logical})))),l.supportedOperators=()=>u,l.supportedMacros=()=>o.MACROS,l}},28547:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.initStandardSuggestions=void 0;const n=r(18531),o=r(31584),i=r(20395),a=r(63178);function l(e){return{label:e.name,insertText:`${"\\"+e.text}${t=e.args,t?"(".concat(t.map(((e,t)=>`\${${t}:${e}}`)).join(", ")).concat(")"):"()"} `,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Snippet,documentation:e.description,command:o.TRIGGER_SUGGEST};var t}t.initStandardSuggestions=(e,t,r)=>()=>[{id:i.SuggestionKind.SelectKeyword,name:i.SuggestionKind.SelectKeyword,suggestions:(e,t)=>Promise.resolve([{label:"SELECT <column>",insertText:"SELECT $0",insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Snippet,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium},{label:"SELECT <column> FROM <table>",insertText:"SELECT $2 FROM $1",insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Snippet,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium}])},{id:i.SuggestionKind.TemplateVariables,name:i.SuggestionKind.TemplateVariables,suggestions:(e,t)=>{const r=(0,n.getTemplateSrv)();return r?Promise.resolve(r.getVariables().map((e=>{const t=`$${e.name}`,n=r.replace(t);return{label:t,detail:`(Template Variable) ${n}`,kind:i.CompletionItemKind.Snippet,documentation:`(Template Variable) ${n}`,insertText:`\\$${e.name} `,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Low}}))):Promise.resolve([])}},{id:i.SuggestionKind.SelectMacro,name:i.SuggestionKind.SelectMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===i.MacroType.Value||e.type===i.MacroType.Column)).map(l)])},{id:i.SuggestionKind.TableMacro,name:i.SuggestionKind.TableMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===i.MacroType.Table)).map(l)])},{id:i.SuggestionKind.GroupMacro,name:i.SuggestionKind.GroupMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===i.MacroType.Group)).map(l)])},{id:i.SuggestionKind.FilterMacro,name:i.SuggestionKind.FilterMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===i.MacroType.Filter)).map(l)])},{id:i.SuggestionKind.WithKeyword,name:i.SuggestionKind.WithKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WITH <alias> AS ( ... )",insertText:"WITH $1  AS ( $2 )",insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Snippet,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium}])},{id:i.SuggestionKind.StarWildCard,name:i.SuggestionKind.StarWildCard,suggestions:(e,t)=>Promise.resolve([{label:"*",insertText:"* $0",insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Field,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.High}])},{id:i.SuggestionKind.FunctionsWithArguments,name:i.SuggestionKind.FunctionsWithArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}($0)`,documentation:e.description,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Function,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumLow})))])},{id:i.SuggestionKind.FunctionsWithoutArguments,name:i.SuggestionKind.FunctionsWithoutArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}()`,documentation:e.description,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Function,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumHigh})))])},{id:i.SuggestionKind.FromKeyword,name:i.SuggestionKind.FromKeyword,suggestions:(e,t)=>Promise.resolve([{label:"FROM",insertText:"FROM $0",command:o.TRIGGER_SUGGEST,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet,kind:i.CompletionItemKind.Keyword}])},{id:i.SuggestionKind.Schemas,name:i.SuggestionKind.Schemas,suggestions:(e,t)=>Promise.resolve([])},{id:i.SuggestionKind.Tables,name:i.SuggestionKind.Tables,suggestions:(e,t)=>Promise.resolve([])},{id:i.SuggestionKind.Columns,name:i.SuggestionKind.Columns,suggestions:(e,t)=>Promise.resolve([])},{id:i.SuggestionKind.LogicalOperators,name:i.SuggestionKind.LogicalOperators,suggestions:(e,r)=>Promise.resolve(t.list().filter((e=>e.type===i.OperatorType.Logical)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumHigh,kind:i.CompletionItemKind.Operator}))))},{id:i.SuggestionKind.WhereKeyword,name:i.SuggestionKind.WhereKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WHERE",insertText:"WHERE ",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumHigh,kind:i.CompletionItemKind.Keyword}])},{id:i.SuggestionKind.ComparisonOperators,name:i.SuggestionKind.ComparisonOperators,suggestions:(e,r)=>Promise.resolve([...t.list().filter((e=>e.type===i.OperatorType.Comparison)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumHigh,kind:i.CompletionItemKind.Operator}))),{label:"IN (...)",insertText:"IN ( $0 )",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium,kind:i.CompletionItemKind.Operator,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet},{label:"NOT IN (...)",insertText:"NOT IN ( $0 )",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium,kind:i.CompletionItemKind.Operator,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet},{label:"IS",insertText:"IS",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium,kind:i.CompletionItemKind.Operator},{label:"IS NOT",insertText:"IS NOT",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium,kind:i.CompletionItemKind.Operator}])},{id:i.SuggestionKind.GroupByKeywords,name:i.SuggestionKind.GroupByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"GROUP BY",insertText:"GROUP BY ",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumHigh,kind:i.CompletionItemKind.Keyword}])},{id:i.SuggestionKind.OrderByKeywords,name:i.SuggestionKind.OrderByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"ORDER BY",insertText:"ORDER BY ",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.Medium,kind:i.CompletionItemKind.Keyword},{label:"ORDER BY(ascending)",insertText:"ORDER BY $1 ASC ",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumLow,kind:i.CompletionItemKind.Snippet,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet},{label:"ORDER BY(descending)",insertText:"ORDER BY $1 DESC",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumLow,kind:i.CompletionItemKind.Snippet,insertTextRules:i.CompletionItemInsertTextRule.InsertAsSnippet}])},{id:i.SuggestionKind.LimitKeyword,name:i.SuggestionKind.LimitKeyword,suggestions:(e,t)=>Promise.resolve([{label:"LIMIT",insertText:"LIMIT ",command:o.TRIGGER_SUGGEST,sortText:i.CompletionItemPriority.MediumLow,kind:i.CompletionItemKind.Keyword}])},{id:i.SuggestionKind.SortOrderDirectionKeyword,name:i.SuggestionKind.SortOrderDirectionKeyword,suggestions:(e,t)=>Promise.resolve([a.ASC,a.DESC].map((e=>({label:e,insertText:`${e} `,command:o.TRIGGER_SUGGEST,kind:i.CompletionItemKind.Keyword}))))},{id:i.SuggestionKind.NotKeyword,name:i.SuggestionKind.NotKeyword,suggestions:()=>Promise.resolve([{label:"NOT",insertText:"NOT",command:o.TRIGGER_SUGGEST,kind:i.CompletionItemKind.Keyword,sortText:i.CompletionItemPriority.High}])},{id:i.SuggestionKind.BoolValues,name:i.SuggestionKind.BoolValues,suggestions:()=>Promise.resolve(["TRUE","FALSE"].map((e=>({label:e,insertText:`${e}`,command:o.TRIGGER_SUGGEST,kind:i.CompletionItemKind.Keyword,sortText:i.CompletionItemPriority.Medium}))))},{id:i.SuggestionKind.NullValue,name:i.SuggestionKind.NullValue,suggestions:()=>Promise.resolve(["NULL"].map((e=>({label:e,insertText:`${e}`,command:o.TRIGGER_SUGGEST,kind:i.CompletionItemKind.Keyword,sortText:i.CompletionItemPriority.Low}))))}]},1862:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.initStatementPositionResolvers=void 0;const n=r(20395),o=r(63178);t.initStatementPositionResolvers=function(){return[{id:n.StatementPosition.SelectKeyword,name:n.StatementPosition.SelectKeyword,resolve:(e,t,r,i)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(n.TokenType.Keyword,o.SELECT)||e.is(n.TokenType.Keyword,o.SELECT)&&null===e.previous||i||e.isIdentifier()&&(i||null===(null==e?void 0:e.previous))||e.isIdentifier()&&o.SELECT.startsWith(e.value.toLowerCase()))},{id:n.StatementPosition.WithKeyword,name:n.StatementPosition.WithKeyword,resolve:(e,t,r,i)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(n.TokenType.Keyword,o.WITH)&&null===e.previous||e.isIdentifier()&&o.WITH.toLowerCase().startsWith(e.value.toLowerCase()))},{id:n.StatementPosition.AfterSelectKeyword,name:n.StatementPosition.AfterSelectKeyword,resolve:(e,t,r,n)=>Boolean((null==r?void 0:r.value.toLowerCase())===o.SELECT)},{id:n.StatementPosition.AfterSelectArguments,name:n.StatementPosition.AfterSelectArguments,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===o.SELECT&&","===(null==r?void 0:r.value))},{id:n.StatementPosition.AfterSelectFuncFirstArgument,name:n.StatementPosition.AfterSelectFuncFirstArgument,resolve:(e,t,r,i)=>Boolean(((null==t?void 0:t.value.toLowerCase())===o.SELECT||(null==t?void 0:t.value.toLowerCase())===o.AS)&&((null==r?void 0:r.is(n.TokenType.Parenthesis,"("))||(null==e?void 0:e.is(n.TokenType.Parenthesis,"()"))))},{id:n.StatementPosition.AfterWhereFunctionArgument,name:n.StatementPosition.AfterWhereFunctionArgument,resolve:(e,t,r,i)=>Boolean((null==t?void 0:t.is(n.TokenType.Keyword,o.WHERE))&&((null==r?void 0:r.is(n.TokenType.Parenthesis,"("))||(null==e?void 0:e.is(n.TokenType.Parenthesis,"()"))))},{id:n.StatementPosition.AfterGroupBy,name:n.StatementPosition.AfterGroupBy,resolve:(e,t,r,i)=>{var a;return Boolean((null==t?void 0:t.is(n.TokenType.Keyword,o.BY))&&(null===(a=null==t?void 0:t.getPreviousKeyword())||void 0===a?void 0:a.is(n.TokenType.Keyword,o.GROUP))&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())||(null==r?void 0:r.is(n.TokenType.Parenthesis,")"))||(null==r?void 0:r.is(n.TokenType.Parenthesis,"()"))))}},{id:n.StatementPosition.SelectAlias,name:n.StatementPosition.SelectAlias,resolve:(e,t,r,n)=>","===(null==r?void 0:r.value)&&(null==t?void 0:t.value.toLowerCase())===o.AS},{id:n.StatementPosition.FromKeyword,name:n.StatementPosition.FromKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===o.SELECT&&","!==(null==r?void 0:r.value)||((null==e?void 0:e.isKeyword())||(null==e?void 0:e.isIdentifier()))&&o.FROM.toLowerCase().startsWith(e.value.toLowerCase()))},{id:n.StatementPosition.AfterFromKeyword,name:n.StatementPosition.AfterFromKeyword,resolve:(e,t,r,n)=>Boolean(!(null==e?void 0:e.value.includes("."))&&(null==r?void 0:r.value.toLowerCase())===o.FROM)},{id:n.StatementPosition.AfterSchema,name:n.StatementPosition.AfterSchema,resolve:(e,t,r,n)=>((null==e?void 0:e.isWhiteSpace())&&(null==e?void 0:e.next)&&(r=(e=null==e?void 0:e.previous).getPreviousNonWhiteSpaceToken()),Boolean((null==e?void 0:e.isIdentifier())&&(null==e?void 0:e.value.endsWith("."))&&(null==r?void 0:r.value.toLowerCase())===o.FROM))},{id:n.StatementPosition.AfterFrom,name:n.StatementPosition.AfterFrom,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===o.FROM&&(null==r?void 0:r.isDoubleQuotedString())||(null==t?void 0:t.value.toLowerCase())===o.FROM&&(null==r?void 0:r.isIdentifier())||(null==t?void 0:t.value.toLowerCase())===o.FROM&&(null==r?void 0:r.isVariable()))},{id:n.StatementPosition.AfterTable,name:n.StatementPosition.AfterTable,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===o.FROM&&((null==r?void 0:r.isVariable())||""!==(null==r?void 0:r.value)&&(null==r?void 0:r.value.toLowerCase())!==o.FROM))},{id:n.StatementPosition.WhereKeyword,name:n.StatementPosition.WhereKeyword,resolve:(e,t,r,i)=>Boolean((null==t?void 0:t.value.toLowerCase())===o.WHERE&&((null==r?void 0:r.isKeyword())||(null==r?void 0:r.is(n.TokenType.Parenthesis,"("))||(null==r?void 0:r.is(n.TokenType.Operator,o.AND))))},{id:n.StatementPosition.WhereComparisonOperator,name:n.StatementPosition.WhereComparisonOperator,resolve:(e,t,r,i)=>{var a;return Boolean((null==t?void 0:t.value.toLowerCase())===o.WHERE&&!(null===(a=null==r?void 0:r.getPreviousNonWhiteSpaceToken())||void 0===a?void 0:a.isOperator())&&!(null==e?void 0:e.is(n.TokenType.Delimiter,"."))&&!(null==e?void 0:e.isParenthesis())&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())))}},{id:n.StatementPosition.WhereValue,name:n.StatementPosition.WhereValue,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===o.WHERE&&(null==r?void 0:r.isOperator()))},{id:n.StatementPosition.AfterWhereValue,name:n.StatementPosition.AfterWhereValue,resolve:(e,t,r,i)=>{var a,l,u;return Boolean((null==t?void 0:t.value.toLowerCase())===o.WHERE&&((null==r?void 0:r.is(n.TokenType.Operator,"and"))||(null==r?void 0:r.is(n.TokenType.Operator,"or"))||(null==r?void 0:r.isString())||(null==r?void 0:r.isNumber())||(null==r?void 0:r.is(n.TokenType.Parenthesis,")"))||(null==r?void 0:r.is(n.TokenType.Parenthesis,"()"))||(null==r?void 0:r.isTemplateVariable())||(null==r?void 0:r.is(n.TokenType.IdentifierQuote))&&(null===(a=r.getPreviousNonWhiteSpaceToken())||void 0===a?void 0:a.is(n.TokenType.Identifier))&&(null===(u=null===(l=null==r?void 0:r.getPreviousNonWhiteSpaceToken())||void 0===l?void 0:l.getPreviousNonWhiteSpaceToken())||void 0===u?void 0:u.is(n.TokenType.IdentifierQuote))))}},{id:n.StatementPosition.AfterGroupByKeywords,name:n.StatementPosition.AfterGroupByKeywords,resolve:(e,t,r,i)=>{var a;return Boolean((null==t?void 0:t.is(n.TokenType.Keyword,o.BY))&&(null===(a=null==t?void 0:t.getPreviousKeyword())||void 0===a?void 0:a.is(n.TokenType.Keyword,o.GROUP))&&((null==r?void 0:r.is(n.TokenType.Keyword,o.BY))||(null==r?void 0:r.is(n.TokenType.Delimiter,","))))}},{id:n.StatementPosition.AfterGroupByFunctionArgument,name:n.StatementPosition.AfterGroupByFunctionArgument,resolve:(e,t,r,i)=>{var a;return Boolean((null==t?void 0:t.is(n.TokenType.Keyword,o.BY))&&(null===(a=null==t?void 0:t.getPreviousKeyword())||void 0===a?void 0:a.is(n.TokenType.Keyword,o.GROUP))&&((null==r?void 0:r.is(n.TokenType.Parenthesis,"("))||(null==e?void 0:e.is(n.TokenType.Parenthesis,"()"))))}},{id:n.StatementPosition.AfterOrderByKeywords,name:n.StatementPosition.AfterOrderByKeywords,resolve:(e,t,r,i)=>{var a;return Boolean((null==r?void 0:r.is(n.TokenType.Keyword,o.BY))&&(null===(a=null==r?void 0:r.getPreviousKeyword())||void 0===a?void 0:a.is(n.TokenType.Keyword,o.ORDER)))}},{id:n.StatementPosition.AfterOrderByFunction,name:n.StatementPosition.AfterOrderByFunction,resolve:(e,t,r,i)=>{var a,l;return Boolean((null==t?void 0:t.is(n.TokenType.Keyword,o.BY))&&(null===(a=null==t?void 0:t.getPreviousKeyword())||void 0===a?void 0:a.is(n.TokenType.Keyword,o.ORDER))&&(null==r?void 0:r.is(n.TokenType.Parenthesis))&&(null===(l=null==r?void 0:r.getPreviousNonWhiteSpaceToken())||void 0===l?void 0:l.is(n.TokenType.Function)))}},{id:n.StatementPosition.AfterOrderByDirection,name:n.StatementPosition.AfterOrderByDirection,resolve:(e,t,r,i)=>Boolean((null==t?void 0:t.is(n.TokenType.Keyword,o.DESC))||(null==t?void 0:t.is(n.TokenType.Keyword,o.ASC)))},{id:n.StatementPosition.AfterIsOperator,name:n.StatementPosition.AfterIsOperator,resolve:(e,t,r,o)=>Boolean(null==r?void 0:r.is(n.TokenType.Operator,"IS"))},{id:n.StatementPosition.AfterIsNotOperator,name:n.StatementPosition.AfterIsNotOperator,resolve:(e,t,r,o)=>{var i;return Boolean((null==r?void 0:r.is(n.TokenType.Operator,"NOT"))&&(null===(i=r.getPreviousNonWhiteSpaceToken())||void 0===i?void 0:i.is(n.TokenType.Operator,"IS")))}}]}},1006:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.initSuggestionsKindRegistry=void 0;const n=r(20395);t.initSuggestionsKindRegistry=()=>[{id:n.StatementPosition.SelectKeyword,name:n.StatementPosition.SelectKeyword,kind:[n.SuggestionKind.SelectKeyword]},{id:n.StatementPosition.WithKeyword,name:n.StatementPosition.WithKeyword,kind:[n.SuggestionKind.WithKeyword]},{id:n.StatementPosition.AfterSelectKeyword,name:n.StatementPosition.AfterSelectKeyword,kind:[n.SuggestionKind.StarWildCard,n.SuggestionKind.FunctionsWithArguments,n.SuggestionKind.Columns,n.SuggestionKind.SelectMacro]},{id:n.StatementPosition.AfterSelectFuncFirstArgument,name:n.StatementPosition.AfterSelectFuncFirstArgument,kind:[n.SuggestionKind.Columns]},{id:n.StatementPosition.AfterGroupByFunctionArgument,name:n.StatementPosition.AfterGroupByFunctionArgument,kind:[n.SuggestionKind.Columns]},{id:n.StatementPosition.AfterWhereFunctionArgument,name:n.StatementPosition.AfterWhereFunctionArgument,kind:[n.SuggestionKind.Columns]},{id:n.StatementPosition.AfterSelectArguments,name:n.StatementPosition.AfterSelectArguments,kind:[n.SuggestionKind.Columns]},{id:n.StatementPosition.AfterFromKeyword,name:n.StatementPosition.AfterFromKeyword,kind:[n.SuggestionKind.Schemas,n.SuggestionKind.Tables,n.SuggestionKind.TableMacro]},{id:n.StatementPosition.AfterSchema,name:n.StatementPosition.AfterSchema,kind:[n.SuggestionKind.Tables,n.SuggestionKind.TableMacro]},{id:n.StatementPosition.SelectAlias,name:n.StatementPosition.SelectAlias,kind:[n.SuggestionKind.Columns,n.SuggestionKind.FunctionsWithArguments]},{id:n.StatementPosition.FromKeyword,name:n.StatementPosition.FromKeyword,kind:[n.SuggestionKind.FromKeyword]},{id:n.StatementPosition.AfterFrom,name:n.StatementPosition.AfterFrom,kind:[n.SuggestionKind.WhereKeyword,n.SuggestionKind.GroupByKeywords,n.SuggestionKind.OrderByKeywords,n.SuggestionKind.LimitKeyword]},{id:n.StatementPosition.AfterTable,name:n.StatementPosition.AfterTable,kind:[n.SuggestionKind.WhereKeyword,n.SuggestionKind.GroupByKeywords,n.SuggestionKind.OrderByKeywords,n.SuggestionKind.LimitKeyword]},{id:n.StatementPosition.WhereKeyword,name:n.StatementPosition.WhereKeyword,kind:[n.SuggestionKind.Columns,n.SuggestionKind.FilterMacro,n.SuggestionKind.TemplateVariables]},{id:n.StatementPosition.WhereComparisonOperator,name:n.StatementPosition.WhereComparisonOperator,kind:[n.SuggestionKind.ComparisonOperators]},{id:n.StatementPosition.WhereValue,name:n.StatementPosition.WhereValue,kind:[n.SuggestionKind.FilterMacro,n.SuggestionKind.TemplateVariables]},{id:n.StatementPosition.AfterWhereValue,name:n.StatementPosition.AfterWhereValue,kind:[n.SuggestionKind.LogicalOperators,n.SuggestionKind.GroupByKeywords,n.SuggestionKind.OrderByKeywords,n.SuggestionKind.LimitKeyword,n.SuggestionKind.Columns,n.SuggestionKind.TemplateVariables]},{id:n.StatementPosition.AfterGroupByKeywords,name:n.StatementPosition.AfterGroupByKeywords,kind:[n.SuggestionKind.GroupMacro,n.SuggestionKind.Columns]},{id:n.StatementPosition.AfterGroupBy,name:n.StatementPosition.AfterGroupBy,kind:[n.SuggestionKind.OrderByKeywords,n.SuggestionKind.LimitKeyword]},{id:n.StatementPosition.AfterOrderByKeywords,name:n.StatementPosition.AfterOrderByKeywords,kind:[n.SuggestionKind.Columns]},{id:n.StatementPosition.AfterOrderByFunction,name:n.StatementPosition.AfterOrderByFunction,kind:[n.SuggestionKind.SortOrderDirectionKeyword,n.SuggestionKind.LimitKeyword]},{id:n.StatementPosition.AfterOrderByDirection,name:n.StatementPosition.AfterOrderByDirection,kind:[n.SuggestionKind.LimitKeyword]},{id:n.StatementPosition.AfterIsOperator,name:n.StatementPosition.AfterOrderByDirection,kind:[n.SuggestionKind.NotKeyword,n.SuggestionKind.NullValue,n.SuggestionKind.BoolValues]},{id:n.StatementPosition.AfterIsNotOperator,name:n.StatementPosition.AfterOrderByDirection,kind:[n.SuggestionKind.NullValue,n.SuggestionKind.BoolValues]}]},50859:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLEditorTestUtils=void 0;const n=r(91666).__importStar(r(26076)),o=r(35469);t.SQLEditorTestUtils={testData:n,testStatementPosition:o.testStatementPosition}},35469:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.testStatementPosition=void 0;const n=r(87781),o=r(76199),i=r(35002),a=r(39110),l=r(95231);t.testStatementPosition=(e,t,r)=>{describe(`${e}`,(()=>{let u,s;beforeEach((()=>{const e=new Map;t.forEach((t=>e.set(t.query.query,t.query.tokens))),u=(0,o.getMonacoMock)(e),s=new n.Registry((()=>r().map((e=>({id:e.id,name:e.name||e.id,resolve:e.resolve})))))})),t.forEach((t=>{test(`${t.query.query}`,(()=>{!function(e,t,r,n,o){const u=(0,i.TextModel)(e),s=(0,l.linkedTokenBuilder)(n,u,t),c=(0,a.getStatementPosition)(s,o);expect(c).toContain(r)}(t.query.query,{lineNumber:t.position.line,column:t.position.column},e,u,s)}))}))}))}},20395:(e,t)=>{"use strict";var r,n,o,i,a,l,u,s,c;Object.defineProperty(t,"__esModule",{value:!0}),t.SQLEditorMode=t.CompletionItemInsertTextRule=t.CompletionItemKind=t.CompletionItemPriority=t.SuggestionKind=t.StatementPosition=t.TokenType=t.MacroType=t.OperatorType=void 0,(c=t.OperatorType||(t.OperatorType={}))[c.Comparison=0]="Comparison",c[c.Logical=1]="Logical",(s=t.MacroType||(t.MacroType={}))[s.Value=0]="Value",s[s.Filter=1]="Filter",s[s.Group=2]="Group",s[s.Column=3]="Column",s[s.Table=4]="Table",(u=t.TokenType||(t.TokenType={})).Parenthesis="delimiter.parenthesis.sql",u.Whitespace="white.sql",u.Keyword="keyword.sql",u.Delimiter="delimiter.sql",u.Operator="operator.sql",u.Identifier="identifier.sql",u.IdentifierQuote="identifier.quote.sql",u.Type="type.sql",u.Function="predefined.sql",u.Number="number.sql",u.String="string.sql",u.Variable="variable.sql",(l=t.StatementPosition||(t.StatementPosition={})).Unknown="unknown",l.SelectKeyword="selectKeyword",l.WithKeyword="withKeyword",l.AfterSelectKeyword="afterSelectKeyword",l.AfterSelectArguments="afterSelectArguments",l.AfterSelectFuncFirstArgument="afterSelectFuncFirstArgument",l.SelectAlias="selectAlias",l.AfterFromKeyword="afterFromKeyword",l.AfterTable="afterTable",l.SchemaFuncFirstArgument="schemaFuncFirstArgument",l.SchemaFuncExtraArgument="schemaFuncExtraArgument",l.FromKeyword="fromKeyword",l.AfterFrom="afterFrom",l.WhereKeyword="whereKeyword",l.WhereComparisonOperator="whereComparisonOperator",l.WhereValue="whereValue",l.AfterWhereFunctionArgument="afterWhereFunctionArgument",l.AfterGroupByFunctionArgument="afterGroupByFunctionArgument",l.AfterWhereValue="afterWhereValue",l.AfterGroupByKeywords="afterGroupByKeywords",l.AfterGroupBy="afterGroupBy",l.AfterOrderByKeywords="afterOrderByKeywords",l.AfterOrderByFunction="afterOrderByFunction",l.AfterOrderByDirection="afterOrderByDirection",l.AfterIsOperator="afterIsOperator",l.AfterIsNotOperator="afterIsNotOperator",l.AfterSchema="afterSchema",(a=t.SuggestionKind||(t.SuggestionKind={})).Schemas="schemas",a.Tables="tables",a.Columns="columns",a.SelectKeyword="selectKeyword",a.WithKeyword="withKeyword",a.FunctionsWithArguments="functionsWithArguments",a.FromKeyword="fromKeyword",a.WhereKeyword="whereKeyword",a.GroupByKeywords="groupByKeywords",a.OrderByKeywords="orderByKeywords",a.FunctionsWithoutArguments="functionsWithoutArguments",a.LimitKeyword="limitKeyword",a.SortOrderDirectionKeyword="sortOrderDirectionKeyword",a.ComparisonOperators="comparisonOperators",a.LogicalOperators="logicalOperators",a.SelectMacro="selectMacro",a.TableMacro="tableMacro",a.FilterMacro="filterMacro",a.GroupMacro="groupMacro",a.BoolValues="boolValues",a.NullValue="nullValue",a.NotKeyword="notKeyword",a.TemplateVariables="templateVariables",a.StarWildCard="starWildCard",(i=t.CompletionItemPriority||(t.CompletionItemPriority={})).High="a",i.MediumHigh="d",i.Medium="g",i.MediumLow="k",i.Low="q",(o=t.CompletionItemKind||(t.CompletionItemKind={}))[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet",(n=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}))[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet",(r=t.SQLEditorMode||(t.SQLEditorMode={})).Builder="builder",r.Code="code"},85678:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedToken=void 0;const n=r(20395);function o(e,t,r){return e===n.TokenType.Keyword||e===n.TokenType.Operator?t.value.toLowerCase()===r.toString().toLowerCase():t.value===r}t.LinkedToken=class{constructor(e,t,r,n,o){this.type=e,this.value=t,this.range=r,this.previous=n,this.next=o}isKeyword(){return this.type===n.TokenType.Keyword}isWhiteSpace(){return this.type===n.TokenType.Whitespace}isParenthesis(){return this.type===n.TokenType.Parenthesis}isIdentifier(){return this.type===n.TokenType.Identifier}isString(){return this.type===n.TokenType.String}isNumber(){return this.type===n.TokenType.Number}isDoubleQuotedString(){return this.type===n.TokenType.Type}isVariable(){return this.type===n.TokenType.Variable}isFunction(){return this.type===n.TokenType.Function}isOperator(){return this.type===n.TokenType.Operator}isTemplateVariable(){return this.type===n.TokenType.Variable}is(e,t){const r=this.type===e;return void 0!==t?r&&o(e,this,t):r}getPreviousNonWhiteSpaceToken(){let e=this.previous;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.previous}return null}getPreviousOfType(e,t){let r=this.previous;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&o(e,r,t):n)return r;r=r.previous}return null}getPreviousUntil(e,t,r){let n=[],i=this.previous;for(;null!=i;){if(t.some((e=>e===(null==i?void 0:i.type)))){i=i.previous;continue}const a=i.type===e;if(void 0!==r?a&&o(e,i,r):a)return n;i.isWhiteSpace()||n.push(i),i=i.previous}return n}getNextUntil(e,t,r){let n=[],i=this.next;for(;null!=i;){if(t.some((e=>e===(null==i?void 0:i.type)))){i=i.next;continue}const a=i.type===e;if(void 0!==r?a&&o(e,i,r):a)return n;i.isWhiteSpace()||n.push(i),i=i.next}return n}getPreviousKeyword(){let e=this.previous;for(;null!=e;){if(e.isKeyword())return e;e=e.previous}return null}getNextNonWhiteSpaceToken(){let e=this.next;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.next}return null}getNextOfType(e,t){let r=this.next;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&o(e,r,t):n)return r;r=r.next}return null}}},31584:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TRIGGER_SUGGEST=void 0,t.TRIGGER_SUGGEST={id:"editor.action.triggerSuggest",title:""}},2441:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sqlEditorLogger=t.sqlEditorLog=void 0;const n=r(82007);let o={logger:()=>{}};t.sqlEditorLogger=o;let i=()=>{};t.sqlEditorLog=i,n.attachDebugger&&n.createLogger&&(t.sqlEditorLogger=o=(0,n.createLogger)("SQLEditor"),t.sqlEditorLog=i=o.logger,(0,n.attachDebugger)("sqleditor",void 0,o))},55718:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSuggestionKinds=void 0,t.getSuggestionKinds=function(e,t){let r=[];for(let n=0;n<e.length;n++){const o=t.getIfExists(e[n]);o&&(r=r.concat(o.kind))}return r}},95231:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linkedTokenBuilder=void 0;const n=r(20395),o=r(85678);t.linkedTokenBuilder=function(e,t,r,i="sql"){var a;let l=null,u=null;const s=e.editor.tokenize(null!==(a=t.getValue())&&void 0!==a?a:"",i);for(let a=0;a<s.length;a++){const c=s[a];if(!c.length&&u){const e={offset:0,type:n.TokenType.Whitespace,language:i,_tokenBrand:void 0};c.push(e)}for(let n=0;n<c.length;n++){const i=c[n];let s=c.length>n+1?c[n+1].offset+1:t.getLineLength(a+1)+1;const d={startLineNumber:a+1,startColumn:0===i.offset?0:i.offset+1,endLineNumber:a+1,endColumn:s},f=t.getValueInRange(d),p=new o.LinkedToken(i.type,f,d,u,null);e.Range.containsPosition(d,r)&&(l=p),u&&(u.next=p),u=p}}return l}},71978:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toCompletionItem=void 0;const n=r(20395);t.toCompletionItem=(e,t,r={})=>Object.assign({label:e,insertText:e,kind:n.CompletionItemKind.Field,sortText:n.CompletionItemPriority.Medium,range:t},r)},24404:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultTableNameParser=t.getTableToken=t.getNamespaceToken=t.getFromKeywordToken=t.getMetricNameToken=t.getSelectStatisticToken=t.getSelectToken=void 0;const n=r(63178),o=r(20395);t.getSelectToken=e=>{var t;return null!==(t=null==e?void 0:e.getPreviousOfType(o.TokenType.Keyword,n.SELECT))&&void 0!==t?t:null},t.getSelectStatisticToken=e=>{var r;const n=null===(r=(0,t.getSelectToken)(e))||void 0===r?void 0:r.getNextNonWhiteSpaceToken();return(null==n?void 0:n.isVariable())||(null==n?void 0:n.isFunction())?n:null},t.getMetricNameToken=e=>{var r,n;const o=null===(n=null===(r=(0,t.getSelectStatisticToken)(e))||void 0===r?void 0:r.next)||void 0===n?void 0:n.next;return(null==o?void 0:o.isVariable())||(null==o?void 0:o.isIdentifier())?o:null},t.getFromKeywordToken=e=>{const r=(0,t.getSelectToken)(e);return null==r?void 0:r.getNextOfType(o.TokenType.Keyword,n.FROM)},t.getNamespaceToken=e=>{var r,i;const a=(0,t.getFromKeywordToken)(e),l=null==a?void 0:a.getNextNonWhiteSpaceToken();if((null==l?void 0:l.isDoubleQuotedString())||(null==l?void 0:l.isVariable())&&(null==l?void 0:l.value.toUpperCase())!==n.SCHEMA)return l;if((null==l?void 0:l.isKeyword())&&(null===(r=l.next)||void 0===r?void 0:r.is(o.TokenType.Parenthesis,"("))){const e=null===(i=l.next)||void 0===i?void 0:i.next;if((null==e?void 0:e.isDoubleQuotedString())||(null==e?void 0:e.isVariable()))return e}return null},t.getTableToken=e=>{var r;const n=(0,t.getFromKeywordToken)(e),i=null==n?void 0:n.getNextNonWhiteSpaceToken();return(null==i?void 0:i.isVariable())||(null==i?void 0:i.isKeyword())&&(null===(r=i.next)||void 0===r?void 0:r.is(o.TokenType.Parenthesis,"("))?null:i},t.defaultTableNameParser=e=>{const t=null==e?void 0:e.value.split(".");return 1===(null==t?void 0:t.length)?{table:t[0]}:2===(null==t?void 0:t.length)?{schema:t[0],table:t[1]}:null}},57299:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Segment=void 0;const n=r(91666),o=n.__importStar(r(85959)),i=r(82007),a=r(38692);t.Segment=function(e){const{delay:t,onDebounce:r,value:l,options:u}=e,s=n.__rest(e,["delay","onDebounce","value","options"]),[c,d]=o.default.useState(l),f=(0,a.useDebounce)(c,t);return(0,o.useEffect)((()=>r(f)),[f]),(0,o.useEffect)((()=>d(l)),[l]),o.default.createElement(i.Segment,Object.assign({options:u,onChange:e=>d(e.value),value:c},s))}},35259:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryModellerBase=void 0;const n=r(87781),o=r(76999);t.QueryModellerBase=class{constructor(e,t){this.categories=[],this.operationsRegistry=new n.Registry((()=>e)),this.innerQueryPlaceholder=t||"<query>"}setOperationCategories(e){this.categories=e}getOperationsForCategory(e){return this.operationsRegistry.list().filter((t=>t.category===e&&!t.hideFromList))}getAlternativeOperations(e){return this.operationsRegistry.list().filter((t=>t.alternativesKey&&t.alternativesKey===e))}getCategories(){return this.categories}getOperationDefinition(e){return this.operationsRegistry.getIfExists(e)}hasBinaryOp(e){return void 0!==e.operations.find((e=>{const t=this.getOperationDefinition(e.id);return(null==t?void 0:t.category)===o.BINARY_OPERATIONS_KEY}))}}},27428:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isConflictingLabelFilter=t.LabelFilterItem=void 0;const n=r(91666),o=r(93241),i=n.__importStar(r(85959)),a=r(89236),l=r(87781),u=r(75174),s=r(82007),c=r(18367),d=r(37392);t.LabelFilterItem=function({item:e,items:t,defaultOp:r,onChange:g,onDelete:v,onGetLabelNames:h,onGetLabelValues:m,invalidLabel:y,invalidValue:b,multiValueSeparator:E="|"}){var O;const[S,_]=(0,i.useState)({}),[w,T]=(0,i.useState)(!1),[P,C]=(0,i.useState)(!1),I=(t=e.op)=>{var r;return null===(r=f.find((e=>e.label===t)))||void 0===r?void 0:r.isMultiValue},A=e=>e?e.indexOf(E)>0?e.split(E):[e]:[],R=p(e,t),{current:x}=(0,i.useRef)((0,a.v4)());return i.default.createElement("div",{"data-testid":"visual-query-builder-dimensions-filter-item"},i.default.createElement(s.InlineField,{error:"You have conflicting label filters",invalid:!!R||void 0},i.default.createElement(c.InputGroup,null,i.default.createElement(s.Select,{placeholder:"Select label","data-testid":u.selectors.components.QueryBuilder.labelSelect,inputId:`visual-query-builder-dimensions-filter-item-key-${x}`,width:"auto",value:e.label?(0,l.toOption)(e.label):null,allowCustomValue:!0,onOpenMenu:()=>n.__awaiter(this,void 0,void 0,(function*(){_({isLoadingLabelNames:!0});const t=yield h(e);T(!0),_({labelNames:t,isLoadingLabelNames:void 0})})),onCloseMenu:()=>{T(!1)},isOpen:w,isLoading:S.isLoadingLabelNames,options:S.labelNames,onChange:t=>{var n;t.value&&g(Object.assign(Object.assign({},e),{op:null!==(n=e.op)&&void 0!==n?n:r,label:t.value}))},invalid:R||y}),i.default.createElement(s.Select,{"data-testid":u.selectors.components.QueryBuilder.matchOperatorSelect,value:(0,l.toOption)(null!==(O=e.op)&&void 0!==O?O:r),options:f,width:"auto",onChange:t=>{t.value&&g(Object.assign(Object.assign({},e),{op:t.value,value:I(t.value)?e.value:A(null==e?void 0:e.value)[0]}))},invalid:R}),i.default.createElement(s.Select,{placeholder:"Select value","data-testid":u.selectors.components.QueryBuilder.valueSelect,inputId:`visual-query-builder-dimensions-filter-item-value-${x}`,width:"auto",value:I()?A(null==e?void 0:e.value).map(l.toOption):A(null==e?void 0:e.value).map(l.toOption)[0],allowCustomValue:!0,onOpenMenu:()=>n.__awaiter(this,void 0,void 0,(function*(){_({isLoadingLabelValues:!0});const t=yield m(e);_(Object.assign(Object.assign({},S),{labelValues:t,isLoadingLabelValues:void 0})),C(!0)})),onCloseMenu:()=>{C(!1)},isOpen:P,isMulti:I(),isLoading:S.isLoadingLabelValues,options:(()=>{const t=S.labelValues?[...S.labelValues]:[],r=A(null==e?void 0:e.value).map(l.toOption);return(0,o.uniqBy)([...r,...t],"value")})(),onChange:t=>{var n,o;if(t.value)g(Object.assign(Object.assign({},e),{value:t.value,op:null!==(n=e.op)&&void 0!==n?n:r}));else{const n=t.map((e=>e.value?e.value:void 0)).filter((e=>void 0!==e)).join(E);g(Object.assign(Object.assign({},e),{value:n,op:null!==(o=e.op)&&void 0!==o?o:r}))}},invalid:R||b}),i.default.createElement(d.AccessoryButton,{"aria-label":"remove",icon:"times",variant:"secondary",onClick:v}))))};const f=[{label:"=",value:"=",description:"Equals",isMultiValue:!1},{label:"!=",value:"!=",description:"Does not equal",isMultiValue:!1},{label:"=~",value:"=~",description:"Matches regex",isMultiValue:!0},{label:"!~",value:"!~",description:"Does not match regex",isMultiValue:!0}];function p(e,t){if(!e.label||!e.op||!e.value)return!1;if(t.length<2)return!1;const r=e.op.toString().startsWith("!");return t.filter((t=>t.label===e.label&&t.value===e.value&&t.op!==e.op)).some((e=>{var t,n;return!(!r||!1!==(null===(t=null==e?void 0:e.op)||void 0===t?void 0:t.toString().startsWith("!")))||!(!1!==r||!(null===(n=null==e?void 0:e.op)||void 0===n?void 0:n.toString().startsWith("!")))}))}t.isConflictingLabelFilter=p},43930:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LabelFilters=t.MISSING_LABEL_FILTER_ERROR_MESSAGE=void 0;const n=r(91666),o=r(93241),i=n.__importStar(r(85959)),a=r(84997),l=r(99398),u=r(3373),s=r(27428);t.MISSING_LABEL_FILTER_ERROR_MESSAGE="Select at least 1 label filter (label and value)",t.LabelFilters=function({labelsFilters:e,onChange:r,onGetLabelNames:n,onGetLabelValues:c,labelFilterRequired:d,multiValueSeparator:f}){const[p,g]=(0,i.useState)([{op:"="}]);(0,i.useEffect)((()=>{e.length>0?g(e):g([{op:"="}])}),[e]);const v=p.some((e=>e.label&&e.value));return i.default.createElement(l.EditorFieldGroup,null,i.default.createElement(a.EditorField,{label:"Label filters",error:t.MISSING_LABEL_FILTER_ERROR_MESSAGE,invalid:d&&!v},i.default.createElement(u.EditorList,{items:p,onChange:t=>{g(t);const n=t.filter((e=>void 0!==e.label&&void 0!==e.value));(0,o.isEqual)(n,e)||r(n)},renderItem:(e,t,r)=>i.default.createElement(s.LabelFilterItem,{item:e,items:p,defaultOp:"=",onChange:t,onDelete:r,onGetLabelNames:n,onGetLabelValues:c,invalidLabel:d&&!e.label,invalidValue:d&&!e.value,multiValueSeparator:f})})))}},62651:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationEditor=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(75206),l=r(82007),u=r(10271);t.OperationEditor=function({operation:e,index:t,onRemove:r,onChange:n,onRunQuery:c,queryModeller:d,query:f,datasource:p,flash:g,highlight:v,timeRange:h,isConflictingOperation:m}){const y=d.getOperationDefinition(e.id),b=(0,l.useTheme2)(),E=!!m&&m(e,f.operations),O=s(b,E);if(!y)return i.default.createElement("span",null,"Operation ",e.id," not found");const S=e=>{if(!e)return!!E||void 0};return i.default.createElement(a.Draggable,{draggableId:`operation-${t}`,index:t},((a,s)=>i.default.createElement(l.InlineField,{error:"You have conflicting label filters",invalid:S(s.isDragging),className:(0,o.cx)(O.error,O.cardWrapper)},i.default.createElement(u.OperationEditorBody,{provided:a,flash:g,highlight:v,isConflicting:E,index:t,operation:e,definition:y,onChange:n,onRemove:r,queryModeller:d,query:f,timeRange:h,onRunQuery:c,datasource:p}))))};const s=(e,t)=>({cardWrapper:(0,o.css)({alignItems:"stretch"}),error:(0,o.css)({marginBottom:e.spacing(1)})})},10271:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationEditorBody=void 0;const n=r(91666).__importStar(r(85959)),o=r(82007),i=r(46089),a=r(65171),l=r(75340),u=r(89236),s=r(2202);t.OperationEditorBody=function({provided:e,flash:t,isConflicting:r,highlight:f,index:p,queryModeller:g,onChange:v,onRemove:h,operation:m,definition:y,query:b,timeRange:E,onRunQuery:O,datasource:S}){const _=(0,o.useTheme2)(),w=c(_,r),T=function(e){const[t,r]=(0,n.useState)(!0);return(0,n.useEffect)((()=>{let t;return e?t=setTimeout((()=>{r(!1)}),1e3):r(!0),()=>clearTimeout(t)}),[e]),t&&e}(t),{current:P}=(0,n.useRef)((0,u.v4)()),C=(e,t)=>{const r=Object.assign(Object.assign({},m),{params:[...m.params]});r.params[e]=t,d(y,r,p,e,v)},I=()=>{const e=Object.assign(Object.assign({},m),{params:[...m.params,""]});d(y,e,p,m.params.length,v)};let A;if(y.params.length>0){const e=y.params[y.params.length-1];e.restParam&&(A=function(e,t,r,i,a){return n.default.createElement("div",{className:a.restParam,key:`${i}-2`},n.default.createElement(o.Button,{size:"sm",icon:"plus",title:`Add ${e.name}`.trimEnd(),variant:"secondary",onClick:t,"data-testid":`operations.${r}.add-rest-param`},e.name))}(e,I,p,m.params.length,w))}return n.default.createElement("div",Object.assign({className:(0,i.cx)(w.card,(T||f)&&w.cardHighlight,r&&w.cardError),ref:e.innerRef},e.draggableProps,{"data-testid":`operations.${p}.wrapper`}),n.default.createElement(a.OperationHeader,{operation:m,dragHandleProps:e.dragHandleProps,definition:y,index:p,onChange:v,onRemove:h,queryModeller:g}),n.default.createElement("div",{className:w.body},m.params.map(((e,t)=>{const r=y.params[Math.min(y.params.length-1,t)],i=(0,l.getOperationParamEditor)(r);return n.default.createElement("div",{className:w.paramRow,key:`${t}-1`},!r.hideName&&n.default.createElement("div",{className:w.paramName},n.default.createElement("label",{htmlFor:(0,l.getOperationParamId)(P,t)},r.name),r.description&&n.default.createElement(o.Tooltip,{placement:"top",content:r.description,theme:"info"},n.default.createElement(o.Icon,{name:"info-circle",size:"sm",className:w.infoIcon}))),n.default.createElement("div",{className:w.paramValue},n.default.createElement(s.EditorStack,{gap:.5,direction:"row",alignItems:"center",wrap:!1},n.default.createElement(i,{index:t,paramDef:r,value:m.params[t],operation:m,operationId:P,onChange:C,onRunQuery:O,query:b,datasource:S,timeRange:E,queryModeller:g}),r.restParam&&(m.params.length>y.params.length||r.optional)&&n.default.createElement(o.Button,{"data-testid":`operations.${p}.remove-rest-param`,size:"sm",fill:"text",icon:"times",variant:"secondary",title:`Remove ${r.name}`,onClick:()=>(e=>{const t=Object.assign(Object.assign({},m),{params:[...m.params.slice(0,e),...m.params.slice(e+1)]});d(y,t,p,e,v)})(t)}))))}))),A,p<b.operations.length-1&&n.default.createElement("div",{className:w.arrow},n.default.createElement("div",{className:w.arrowLine}),n.default.createElement("div",{className:w.arrowArrow})))};const c=(e,t)=>({cardWrapper:(0,i.css)({alignItems:"stretch"}),error:(0,i.css)({marginBottom:e.spacing(1)}),card:(0,i.css)({background:e.colors.background.primary,border:`1px solid ${e.colors.border.medium}`,cursor:"grab",borderRadius:e.shape.radius.default,position:"relative",transition:"all 0.5s ease-in 0s",height:t?"auto":"100%"}),cardError:(0,i.css)({boxShadow:`0px 0px 4px 0px ${e.colors.warning.main}`,border:`1px solid ${e.colors.warning.main}`}),cardHighlight:(0,i.css)({boxShadow:`0px 0px 4px 0px ${e.colors.primary.border}`,border:`1px solid ${e.colors.primary.border}`}),infoIcon:(0,i.css)({marginLeft:e.spacing(.5),color:e.colors.text.secondary,":hover":{color:e.colors.text.primary}}),body:(0,i.css)({margin:e.spacing(1,1,.5,1),display:"table"}),paramRow:(0,i.css)({label:"paramRow",display:"table-row",verticalAlign:"middle"}),paramName:(0,i.css)({display:"table-cell",padding:e.spacing(0,1,0,0),fontSize:e.typography.bodySmall.fontSize,fontWeight:e.typography.fontWeightMedium,verticalAlign:"middle",height:"32px"}),paramValue:(0,i.css)({label:"paramValue",display:"table-cell",verticalAlign:"middle"}),restParam:(0,i.css)({padding:e.spacing(0,1,1,1)}),arrow:(0,i.css)({position:"absolute",top:"0",right:"-18px",display:"flex"}),arrowLine:(0,i.css)({height:"2px",width:"8px",backgroundColor:e.colors.border.strong,position:"relative",top:"14px"}),arrowArrow:(0,i.css)({width:0,height:0,borderTop:"5px solid transparent",borderBottom:"5px solid transparent",borderLeft:`7px solid ${e.colors.border.strong}`,position:"relative",top:"10px"})});function d(e,t,r,n,o){e.paramChangedHandler?o(r,e.paramChangedHandler(n,t,e)):o(r,t)}},67553:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationExplainedBox=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(87781),l=r(82007);t.OperationExplainedBox=function({title:e,stepNumber:t,markdown:r,children:n}){const o=(0,l.useStyles2)(u);return i.default.createElement("div",{className:o.box},void 0!==t&&i.default.createElement("div",{className:o.stepNumber},t),i.default.createElement("div",{className:o.boxInner},e&&i.default.createElement("div",{className:o.header},i.default.createElement("span",null,e)),i.default.createElement("div",{className:o.body},r&&i.default.createElement("div",{dangerouslySetInnerHTML:{__html:(0,a.renderMarkdown)(r)}}),n)))};const u=e=>({box:(0,o.css)({background:e.colors.background.secondary,padding:e.spacing(1),borderRadius:e.shape.radius.default,position:"relative"}),boxInner:(0,o.css)({marginLeft:e.spacing(4)}),stepNumber:(0,o.css)({fontWeight:e.typography.fontWeightMedium,background:e.colors.secondary.main,width:"20px",height:"20px",borderRadius:e.shape.radius.circle,display:"flex",alignItems:"center",justifyContent:"center",position:"absolute",top:"10px",left:"11px",fontSize:e.typography.bodySmall.fontSize}),header:(0,o.css)({paddingBottom:e.spacing(.5),display:"flex",alignItems:"center",fontFamily:e.typography.fontFamilyMonospace}),body:(0,o.css)({color:e.colors.text.secondary,"p:last-child":{margin:0},a:{color:e.colors.text.link,textDecoration:"underline"}})})},65171:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationHeader=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(82007),l=r(54606),u=r(89464);t.OperationHeader=i.default.memo((({operation:e,definition:t,index:r,onChange:n,onRemove:o,queryModeller:c,dragHandleProps:d})=>{var f;const p=(0,a.useStyles2)(s),[g,v]=(0,i.useState)({}),h=()=>{if(g.isOpen)v(Object.assign(Object.assign({},g),{isOpen:!1}));else{const e=c.getAlternativeOperations(t.alternativesKey).map((e=>({label:e.name,value:e})));v({isOpen:!0,alternatives:e})}};return i.default.createElement("div",{className:p.header},!g.isOpen&&i.default.createElement(i.default.Fragment,null,i.default.createElement("div",Object.assign({},d),null!==(f=t.name)&&void 0!==f?f:t.id),i.default.createElement(u.FlexItem,{grow:1}),i.default.createElement("div",{className:`${p.operationHeaderButtons} operation-header-show-on-hover`},i.default.createElement(a.Button,{icon:"angle-down",size:"sm",onClick:h,fill:"text",variant:"secondary",title:"Click to view alternative operations"}),i.default.createElement(l.OperationInfoButton,{definition:t,operation:e,innerQueryPlaceholder:c.innerQueryPlaceholder}),i.default.createElement(a.Button,{icon:"times",size:"sm",onClick:()=>o(r),fill:"text",variant:"secondary",title:"Remove operation"}))),g.isOpen&&i.default.createElement("div",{className:p.selectWrapper},i.default.createElement(a.Select,{autoFocus:!0,openMenuOnFocus:!0,placeholder:"Replace with",options:g.alternatives,isOpen:!0,onCloseMenu:h,onChange:o=>{if(o.value){const i=c.getOperationDefinition(o.value.id),a=[...i.defaultParams];for(let r=0;r<Math.min(e.params.length,a.length);r++)i.params[r].type===t.params[r].type&&(a[r]=e.params[r]);const l=Object.assign(Object.assign({},e),{params:a,id:o.value.id});n(r,t.changeTypeHandler?t.changeTypeHandler(l,i):l)}}})))})),t.OperationHeader.displayName="OperationHeader";const s=e=>({header:(0,o.css)({borderBottom:`1px solid ${e.colors.border.medium}`,padding:e.spacing(.5,.5,.5,1),display:"flex",alignItems:"center"}),operationHeaderButtons:(0,o.css)({opacity:1}),selectWrapper:(0,o.css)({paddingRight:e.spacing(2)})})},54606:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationInfoButton=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(67223),l=r(87781),u=r(82007),s=r(89464);t.OperationInfoButton=i.default.memo((({definition:e,operation:t,innerQueryPlaceholder:r})=>{const n=(0,u.useStyles2)(c),[o,d]=(0,i.useState)(!1),{getTooltipProps:f,setTooltipRef:p,setTriggerRef:g,visible:v}=(0,a.usePopperTooltip)({placement:"top",visible:o,offset:[0,16],onVisibleChange:d,interactive:!0,trigger:["click"]});return i.default.createElement(i.default.Fragment,null,i.default.createElement(u.Button,{title:"Click to show description",ref:g,icon:"info-circle",size:"sm",variant:"secondary",fill:"text"}),v&&i.default.createElement(u.Portal,null,i.default.createElement("div",Object.assign({ref:p},f(),{className:n.docBox}),i.default.createElement("div",{className:n.docBoxHeader},i.default.createElement("span",null,e.renderer(t,e,r)),i.default.createElement(s.FlexItem,{grow:1}),i.default.createElement(u.Button,{icon:"times",onClick:()=>d(!1),fill:"text",variant:"secondary",title:"Remove operation"})),i.default.createElement("div",{className:n.docBoxBody,dangerouslySetInnerHTML:{__html:(h=e,m=t,(0,l.renderMarkdown)(h.explainHandler?h.explainHandler(m,h):null!==(y=h.documentation)&&void 0!==y?y:"no docs"))}}))));var h,m,y})),t.OperationInfoButton.displayName="OperationDocs";const c=e=>({docBox:(0,o.css)({overflow:"hidden",background:e.colors.background.primary,border:`1px solid ${e.colors.border.strong}`,boxShadow:e.shadows.z3,maxWidth:"600px",padding:e.spacing(1),borderRadius:e.shape.radius.default,zIndex:e.zIndex.tooltip}),docBoxHeader:(0,o.css)({fontSize:e.typography.h5.fontSize,fontFamily:e.typography.fontFamilyMonospace,paddingBottom:e.spacing(1),display:"flex",alignItems:"center"}),docBoxBody:(0,o.css)({marginBottom:e.spacing(-1),color:e.colors.text.secondary}),signature:(0,o.css)({fontSize:e.typography.bodySmall.fontSize,fontFamily:e.typography.fontFamilyMonospace}),dropdown:(0,o.css)({opacity:0,color:e.colors.text.secondary})})},21326:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationList=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(75206),l=r(78131),u=r(82007),s=r(62651),c=r(2202);t.OperationList=function({query:e,datasource:t,queryModeller:r,onChange:n,onRunQuery:o,highlightedOp:f,timeRange:p,isConflictingOperation:g}){const v=(0,u.useStyles2)(d),{operations:h}=e,m=function(e){const t=(0,l.useMountedState)(),r=(0,l.usePrevious)(e);if(!t())return e.map((()=>!1));if(!r)return e.map((()=>!0));let n=[];if(r.length-1===e.length&&e.every((e=>r.includes(e))))return e.map((()=>!1));if(r.length+1===e.length&&r.every((t=>e.includes(t)))){const t=e.find((e=>!r.includes(e)));n=e.map((e=>e===t))}else n=e.map(((e,t)=>{var n,o,i;return!((o=e.id)===(i=null===(n=r[t])||void 0===n?void 0:n.id)||`__${o}_by`===i||o===`__${i}_by`)}));return n}(h),[y,b]=(0,i.useState)(!1),E=(t,r)=>{const o=[...h];o.splice(t,1,r),n(Object.assign(Object.assign({},e),{operations:o}))},O=t=>{const r=[...h.slice(0,t),...h.slice(t+1)];n(Object.assign(Object.assign({},e),{operations:r}))},S=r.getCategories().map((e=>({value:e,label:e,items:r.getOperationsForCategory(e).map((e=>({value:e.id,label:e.name,isLeaf:!0})))})));return i.default.createElement(c.EditorStack,{gap:1,direction:"column"},i.default.createElement(c.EditorStack,{gap:1},h.length>0&&i.default.createElement(a.DragDropContext,{onDragEnd:t=>{if(!t.destination)return;const r=[...h],o=r[t.source.index];r.splice(t.source.index,1),r.splice(t.destination.index,0,o),n(Object.assign(Object.assign({},e),{operations:r}))}},i.default.createElement(a.Droppable,{droppableId:"sortable-field-mappings",direction:"horizontal"},(n=>i.default.createElement("div",Object.assign({className:v.operationList,ref:n.innerRef},n.droppableProps),h.map(((n,a)=>i.default.createElement(s.OperationEditor,{key:n.id+JSON.stringify(n.params)+a,queryModeller:r,index:a,operation:n,query:e,datasource:t,onChange:E,onRemove:O,onRunQuery:o,flash:m[a],highlight:f===n,timeRange:p,isConflictingOperation:g}))),n.placeholder)))),i.default.createElement("div",{className:v.addButton},y?i.default.createElement(u.Cascader,{options:S,onSelect:t=>{const o=r.getOperationDefinition(t);o&&(n(o.addOperationHandler(o,e,r)),b(!1))},onBlur:()=>{b(!1)},autoFocus:!0,alwaysOpen:!0,hideActiveLevelLabel:!0,placeholder:"Search"}):i.default.createElement(u.Button,{icon:"plus",variant:"secondary",onClick:()=>b(!0),title:"Add operation"},"Operations"))))};const d=e=>({heading:(0,o.css)({label:"heading",fontSize:12,fontWeight:e.typography.fontWeightMedium,marginBottom:0}),operationList:(0,o.css)({label:"operationList",display:"flex",flexWrap:"wrap",gap:e.spacing(2)}),addButton:(0,o.css)({label:"addButton",width:126,paddingBottom:e.spacing(1)})})},82694:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationListExplained=void 0;const n=r(91666).__importDefault(r(85959)),o=r(67553),i=r(5213);t.OperationListExplained=function({query:e,queryModeller:t,stepNumber:r,language:a,onMouseEnter:l,onMouseLeave:u}){return n.default.createElement(n.default.Fragment,null,e.operations.map(((e,s)=>{var c;const d=t.getOperationDefinition(e.id);if(!d)return`Operation ${e.id} not found`;const f=d.renderer(e,d,t.innerQueryPlaceholder),p=d.explainHandler?d.explainHandler(e,d):null!==(c=d.documentation)&&void 0!==c?c:"no docs";return n.default.createElement("div",{key:s,onMouseEnter:()=>null==l?void 0:l(e,s),onMouseLeave:()=>null==u?void 0:u(e,s)},n.default.createElement(o.OperationExplainedBox,{stepNumber:s+r,title:n.default.createElement(i.RawQuery,{query:f,language:a}),markdown:p}))})))}},75340:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getOperationParamId=t.getOperationParamEditor=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(87781),l=r(82007),u=r(2202);function s(e){var t;return i.default.createElement(l.AutoSizeInput,{id:p(e.operationId,e.index),defaultValue:null===(t=e.value)||void 0===t?void 0:t.toString(),minWidth:e.paramDef.minWidth,placeholder:e.paramDef.placeholder,title:e.paramDef.description,maxWidth:3*(e.paramDef.minWidth||20),onCommitChange:t=>{e.onChange(e.index,t.currentTarget.value),e.paramDef.runQueryOnEnter&&"keydown"===t.type&&e.onRunQuery()}})}function c(e){return i.default.createElement(l.Checkbox,{id:p(e.operationId,e.index),value:Boolean(e.value),onChange:t=>e.onChange(e.index,t.currentTarget.checked)})}function d({paramDef:e,value:t,index:r,operationId:n,onChange:o}){var s,c;const d=(0,l.useStyles2)(f);let g=e.options;(null===(s=g[0])||void 0===s?void 0:s.label)||(g=e.options.map((e=>({label:e.toString(),value:e}))));let v=null!==(c=g.find((e=>e.value===t)))&&void 0!==c?c:(0,a.toOption)(t);return!t&&e.optional?i.default.createElement("div",{className:d.optionalParam},i.default.createElement(l.Button,{size:"sm",variant:"secondary",title:`Add ${e.name}`,icon:"plus",onClick:()=>o(r,g[0].value)},e.name)):i.default.createElement(u.EditorStack,{gap:.5,direction:"row",alignItems:"center"},i.default.createElement(l.Select,{id:p(n,r),value:v,options:g,placeholder:e.placeholder,allowCustomValue:!0,onChange:e=>o(r,e.value),width:e.minWidth||"auto"}),e.optional&&i.default.createElement(l.Button,{"data-testid":`operations.${r}.remove-param`,size:"sm",fill:"text",icon:"times",variant:"secondary",title:`Remove ${e.name}`,onClick:()=>o(r,"")}))}t.getOperationParamEditor=function(e){return e.editor?e.editor:e.options?d:"boolean"===e.type?c:s};const f=e=>({optionalParam:(0,o.css)({marginTop:e.spacing(1)})});function p(e,t){return`operations.${e}.param.${t}`}t.getOperationParamId=p},76790:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OperationsEditorRow=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(82007),l=r(2202);t.OperationsEditorRow=function({children:e}){const t=(0,a.useStyles2)(u);return i.default.createElement("div",{className:t.root},i.default.createElement(l.EditorStack,{gap:1},e))};const u=e=>({root:(0,o.css)({padding:e.spacing(1,1,0,1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.radius.default})})},61112:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryBuilderHints=void 0;const n=r(91666),o=r(46089),i=n.__importStar(r(85959)),a=r(18531),l=r(82007);t.QueryBuilderHints=({datasource:e,query:t,onChange:r,data:n,queryModeller:o,buildVisualQueryFromString:s,buildDataQueryFromQueryString:c,buildQueryStringFromDataQuery:d})=>{const[f,p]=(0,i.useState)([]),g=(0,l.useStyles2)(u);return(0,i.useEffect)((()=>{var r;const i=c(o.renderQuery(t)),a=null===(r=e.getQueryHints)||void 0===r?void 0:r.call(e,i,(null==n?void 0:n.series)||[]).filter((e=>{var t;return null===(t=e.fix)||void 0===t?void 0:t.action}));p(null!=a?a:[])}),[e,t,n,o,c]),i.default.createElement(i.default.Fragment,null,f.length>0&&i.default.createElement("div",{className:g.container},f.map((n=>{var u,f,p,v;return i.default.createElement(l.Tooltip,{content:`${n.label} ${null===(u=n.fix)||void 0===u?void 0:u.label}`,key:n.type},i.default.createElement(l.Button,{onClick:()=>{var i,l,u;if((0,a.reportInteraction)("grafana_query_builder_hints_clicked",{hint:n.type,datasourceType:e.type}),null===(i=null==n?void 0:n.fix)||void 0===i?void 0:i.action){const i=c(o.renderQuery(t)),a=null===(l=e.modifyQuery)||void 0===l?void 0:l.call(e,i,n.fix.action);if(a){const e=s(null!==(u=d(a))&&void 0!==u?u:"");return r(e.query)}}},fill:"outline",size:"sm",className:g.hint},"hint: ",(null===(f=n.fix)||void 0===f?void 0:f.title)||(null===(v=null===(p=n.fix)||void 0===p?void 0:p.action)||void 0===v?void 0:v.type.toLowerCase().replace("_"," "))))}))))},t.QueryBuilderHints.displayName="QueryBuilderHints";const u=e=>({container:o.css`
      display: flex;
      align-items: start;
    `,hint:o.css`
      margin-right: ${e.spacing(1)};
    `})},19653:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryEditorModeToggle=void 0;const n=r(91666).__importDefault(r(85959)),o=r(82007),i=r(76999),a=[{label:"Builder",value:i.QueryEditorMode.Builder},{label:"Code",value:i.QueryEditorMode.Code}];t.QueryEditorModeToggle=function({mode:e,onChange:t}){return n.default.createElement("div",{"data-testid":"QueryEditorModeToggle"},n.default.createElement(o.RadioButtonGroup,{options:a,size:"sm",value:e,onChange:t}))}},6454:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryHeaderSwitch=void 0;const n=r(91666),o=r(46089),i=r(93241),a=n.__importStar(r(85959)),l=r(82007),u=r(2202);t.QueryHeaderSwitch=function(e){var{label:t}=e,r=n.__rest(e,["label"]);const o=t.replace(" ","-"),c=(0,a.useRef)((0,i.uniqueId)(`switch-${o}`)),d=(0,l.useStyles2)(s);return a.default.createElement(u.EditorStack,{gap:1},a.default.createElement("label",{htmlFor:c.current,className:d.switchLabel},t),a.default.createElement(l.Switch,Object.assign({},r,{id:c.current})))};const s=e=>({switchLabel:(0,o.css)({color:e.colors.text.secondary,cursor:"pointer",fontSize:e.typography.bodySmall.fontSize,"&:hover":{color:e.colors.text.primary}})})},73307:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QueryOptionGroup=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(85959)),a=r(78131),l=r(87781),u=r(18531),s=r(82007),c=r(2202);t.QueryOptionGroup=function({title:e,children:t,collapsedInfo:r,queryStats:n}){const[o,l]=(0,a.useToggle)(!1),p=(0,s.useStyles2)(d);return i.default.createElement("div",{className:p.wrapper},i.default.createElement(s.Collapse,{className:p.collapse,collapsible:!0,isOpen:o,onToggle:l,label:i.default.createElement(c.EditorStack,{gap:0},i.default.createElement("h6",{className:p.title},e),!o&&i.default.createElement("div",{className:p.description},r.map(((e,t)=>i.default.createElement("span",{key:t},e)))))},i.default.createElement("div",{className:p.body},t)),n&&u.config.featureToggles.lokiQuerySplitting&&i.default.createElement(s.Tooltip,{content:"Note: the query will be split into multiple parts and executed in sequence. Query limits will only apply each individual part."},i.default.createElement(s.Icon,{tabIndex:0,name:"info-circle",className:p.tooltip,size:"sm"})),n&&i.default.createElement("p",{className:p.stats},f(n)))};const d=e=>({collapse:(0,o.css)({backgroundColor:"unset",border:"unset",marginBottom:0,"> button":{padding:e.spacing(0,1)}}),wrapper:(0,o.css)({width:"100%",display:"flex",justifyContent:"space-between",alignItems:"baseline"}),title:(0,o.css)({flexGrow:1,overflow:"hidden",fontSize:e.typography.bodySmall.fontSize,fontWeight:e.typography.fontWeightMedium,margin:0}),description:(0,o.css)({color:e.colors.text.secondary,fontSize:e.typography.bodySmall.fontSize,fontWeight:e.typography.bodySmall.fontWeight,paddingLeft:e.spacing(2),gap:e.spacing(2),display:"flex"}),body:(0,o.css)({display:"flex",gap:e.spacing(2),flexWrap:"wrap"}),stats:(0,o.css)({margin:"0px",color:e.colors.text.secondary,fontSize:e.typography.bodySmall.fontSize}),tooltip:(0,o.css)({marginRight:e.spacing(.25)})}),f=e=>e.message?e.message:`This query will process approximately ${p(e)}.`,p=e=>{const{text:t,suffix:r}=(0,l.getValueFormat)("bytes")(e.bytes,1);return t+r}},5213:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RawQuery=void 0;const n=r(91666),o=r(46089),i=n.__importDefault(r(28146)),a=n.__importDefault(r(85959)),l=r(87781),u=r(82007);t.RawQuery=function({query:e,language:t,className:r}){const n=(0,u.useTheme2)(),c=s(n),d=i.default.highlight(e,t.grammar,t.name);return a.default.createElement("div",{className:(0,o.cx)(c.editorField,"prism-syntax-highlight",r),"aria-label":"selector",dangerouslySetInnerHTML:{__html:l.textUtil.sanitize(d)}})};const s=e=>({editorField:(0,o.css)({fontFamily:e.typography.fontFamilyMonospace,fontSize:e.typography.bodySmall.fontSize})})},5034:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BINARY_OPERATIONS_KEY=t.QueryEditorMode=t.RawQuery=t.QueryOptionGroup=t.QueryHeaderSwitch=t.QueryEditorModeToggle=t.QueryBuilderHints=t.OperationsEditorRow=t.OperationListExplained=t.OperationList=t.OperationExplainedBox=t.LabelFilters=t.QueryModellerBase=void 0;var n=r(35259);Object.defineProperty(t,"QueryModellerBase",{enumerable:!0,get:function(){return n.QueryModellerBase}});var o=r(43930);Object.defineProperty(t,"LabelFilters",{enumerable:!0,get:function(){return o.LabelFilters}});var i=r(67553);Object.defineProperty(t,"OperationExplainedBox",{enumerable:!0,get:function(){return i.OperationExplainedBox}});var a=r(21326);Object.defineProperty(t,"OperationList",{enumerable:!0,get:function(){return a.OperationList}});var l=r(82694);Object.defineProperty(t,"OperationListExplained",{enumerable:!0,get:function(){return l.OperationListExplained}});var u=r(76790);Object.defineProperty(t,"OperationsEditorRow",{enumerable:!0,get:function(){return u.OperationsEditorRow}});var s=r(61112);Object.defineProperty(t,"QueryBuilderHints",{enumerable:!0,get:function(){return s.QueryBuilderHints}});var c=r(19653);Object.defineProperty(t,"QueryEditorModeToggle",{enumerable:!0,get:function(){return c.QueryEditorModeToggle}});var d=r(6454);Object.defineProperty(t,"QueryHeaderSwitch",{enumerable:!0,get:function(){return d.QueryHeaderSwitch}});var f=r(73307);Object.defineProperty(t,"QueryOptionGroup",{enumerable:!0,get:function(){return f.QueryOptionGroup}});var p=r(5213);Object.defineProperty(t,"RawQuery",{enumerable:!0,get:function(){return p.RawQuery}});var g=r(76999);Object.defineProperty(t,"QueryEditorMode",{enumerable:!0,get:function(){return g.QueryEditorMode}}),Object.defineProperty(t,"BINARY_OPERATIONS_KEY",{enumerable:!0,get:function(){return g.BINARY_OPERATIONS_KEY}})},76999:(e,t)=>{"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.BINARY_OPERATIONS_KEY=t.QueryEditorMode=void 0,(r=t.QueryEditorMode||(t.QueryEditorMode={})).Code="code",r.Builder="builder",t.BINARY_OPERATIONS_KEY="Binary operations"},62184:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomHeadersSettings=t.CertificationKey=t.InlineSwitch=t.formatDate=t.DatePickerWithInput=t.DatePicker=t.Segment=t.DebounceInput=t.QueryEditorRow=t.AsyncButtonCascader=void 0;const n=r(91666);var o=r(57751);Object.defineProperty(t,"AsyncButtonCascader",{enumerable:!0,get:function(){return o.AsyncButtonCascader}});var i=r(71963);Object.defineProperty(t,"QueryEditorRow",{enumerable:!0,get:function(){return i.QueryEditorRow}});var a=r(61315);Object.defineProperty(t,"DebounceInput",{enumerable:!0,get:function(){return a.DebounceInput}});var l=r(57299);Object.defineProperty(t,"Segment",{enumerable:!0,get:function(){return l.Segment}});var u=r(80341);Object.defineProperty(t,"DatePicker",{enumerable:!0,get:function(){return u.DatePicker}});var s=r(16631);Object.defineProperty(t,"DatePickerWithInput",{enumerable:!0,get:function(){return s.DatePickerWithInput}}),Object.defineProperty(t,"formatDate",{enumerable:!0,get:function(){return s.formatDate}}),n.__exportStar(r(83783),t),n.__exportStar(r(96674),t),n.__exportStar(r(97353),t);var c=r(82007);Object.defineProperty(t,"InlineSwitch",{enumerable:!0,get:function(){return c.InlineSwitch}}),Object.defineProperty(t,"CertificationKey",{enumerable:!0,get:function(){return c.CertificationKey}}),n.__exportStar(r(2202),t),n.__exportStar(r(15134),t);var d=r(81751);Object.defineProperty(t,"CustomHeadersSettings",{enumerable:!0,get:function(){return d.CustomHeadersSettings}}),n.__exportStar(r(5034),t),n.__exportStar(r(49846),t)},68352:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSearchFilterScopedVar=t.containsSearchFilter=t.SEARCH_FILTER_VARIABLE=t.SqlDatasource=void 0;const n=r(91666),o=r(31269),i=r(46022),a=r(87781),l=r(18531),u=r(94424),s=r(37079);class c extends l.DataSourceWithBackend{constructor(e,t=(0,l.getTemplateSrv)()){super(e),this.templateSrv=t,this.annotations={},this.interpolateVariable=(e,t)=>"string"==typeof e?t.multi||t.includeAll?this.getQueryModel().quoteLiteral(e):e:"number"==typeof e?e:Array.isArray(e)?e.map((e=>this.getQueryModel().quoteLiteral(e))).join(","):e,this.name=e.name,this.id=e.id;const r=e.jsonData||{};this.interval=r.timeInterval||"1m",this.db=this.getDB()}interpolateVariablesInQueries(e,t){let r=e;return e&&e.length>0&&(r=e.map((e=>Object.assign(Object.assign({},e),{datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),rawQuery:!0})))),r}filterQuery(e){return!e.hide}applyTemplateVariables(e,t){const r=this.getQueryModel(e,this.templateSrv,t),n=this.clean(r.interpolate());return{refId:e.refId,datasource:this.getRef(),rawSql:n,format:e.format}}clean(e){return e.replace(/''/g,"'")}metricFindQuery(e,r){return n.__awaiter(this,void 0,void 0,(function*(){const n=this.templateSrv.replace(e,(0,t.getSearchFilterScopedVar)({query:e,wildcardChar:"%",options:r}),this.interpolateVariable),o={refId:"tempvar",datasource:this.getRef(),rawSql:n,format:s.QueryFormat.Table},i=yield this.runMetaQuery(o,r);return this.getResponseParser().transformMetricFindResponse(i)}))}runSql(e,t){return n.__awaiter(this,void 0,void 0,(function*(){const r=yield this.runMetaQuery({rawSql:e,format:s.QueryFormat.Table,refId:null==t?void 0:t.refId},t);return new a.DataFrameView(r)}))}runMetaQuery(e,t){var r,n;const a=e.refId||"meta",u=[Object.assign(Object.assign({},e),{datasource:e.datasource||this.getRef(),refId:a})];return(0,o.lastValueFrom)((0,l.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",data:{from:null===(r=null==t?void 0:t.range)||void 0===r?void 0:r.from.valueOf().toString(),to:null===(n=null==t?void 0:t.range)||void 0===n?void 0:n.to.valueOf().toString(),queries:u},requestId:a}).pipe((0,i.map)((e=>(0,l.toDataQueryResponse)(e,u).data[0]))))}testDatasource(){return(0,o.lastValueFrom)((0,l.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",data:{from:"5m",to:"now",queries:[{refId:"A",intervalMs:1,maxDataPoints:1,datasource:this.getRef(),datasourceId:this.id,rawSql:"SELECT 1",format:"table"}]}}).pipe((0,i.map)((()=>({status:"success",message:"Database Connection OK"}))),(0,i.catchError)((e=>(0,o.of)(e)))))}targetContainsTemplate(e){let t=e.rawSql;return u.MACRO_NAMES.forEach((e=>{t=(null==t?void 0:t.replace(e,""))||""})),this.templateSrv.containsTemplate(t)}}t.SqlDatasource=c,t.SEARCH_FILTER_VARIABLE="__searchFilter",t.containsSearchFilter=e=>!(!e||"string"!=typeof e)&&-1!==e.indexOf(t.SEARCH_FILTER_VARIABLE),t.getSearchFilterScopedVar=e=>{const{query:r,wildcardChar:n}=e;if(!(0,t.containsSearchFilter)(r))return{};let{options:o}=e;return o=o||{searchFilter:""},{__searchFilter:{value:o.searchFilter?`${o.searchFilter}${n}`:`${n}`,text:""}}}},94424:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MACRO_NAMES=void 0,t.MACRO_NAMES=["$__time","$__timeEpoch","$__timeFilter","$__timeFrom","$__timeTo","$__timeGroup","$__timeGroupAlias","$__unixEpochFilter","$__unixEpochNanoFilter","$__unixEpochNanoFrom","$__unixEpochNanoTo","$__unixEpochGroup","$__unixEpochGroupAlias"]},38692:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.useDebounce=t.DEFAULT_DELAY=void 0;const n=r(85959);t.DEFAULT_DELAY=275,t.useDebounce=(e,r=t.DEFAULT_DELAY)=>{const[o,i]=(0,n.useState)(e);return(0,n.useEffect)((()=>{const t=setTimeout((()=>{i(e)}),r);return()=>{clearTimeout(t)}}),[e]),o}},65991:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SqlDatasource=void 0,r(91666).__exportStar(r(62184),t);var n=r(68352);Object.defineProperty(t,"SqlDatasource",{enumerable:!0,get:function(){return n.SqlDatasource}})},59841:(e,t,r)=>{"use strict";r.r(t),r.d(t,{default:()=>Pr});var n=r(85959),o=r.n(n);function i(e){return i="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i(e)}function a(e){var t=function(e){if("object"!==i(e)||null===e)return e;var t=e[Symbol.toPrimitive];if(void 0!==t){var r=t.call(e,"string");if("object"!==i(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return String(e)}(e);return"symbol"===i(t)?t:String(t)}function l(e,t,r){return(t=a(t))in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function u(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function s(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?u(Object(r),!0).forEach((function(t){l(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):u(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function c(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function d(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,a(n.key),n)}}function f(e,t,r){return t&&d(e.prototype,t),r&&d(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function p(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function g(e,t){return g=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},g(e,t)}function v(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&g(e,t)}function h(e){return h=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},h(e)}function m(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var r,n=h(e);if(t){var o=h(this).constructor;r=Reflect.construct(n,arguments,o)}else r=n.apply(this,arguments);return function(e,t){if(t&&("object"===i(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return p(e)}(this,r)}}var y=r(48398),b=r.n(y);function E(e,t){if(!e)return!1;if(e.contains)return e.contains(t);for(var r=t;r;){if(r===e)return!0;r=r.parentNode}return!1}function O(e){return e instanceof HTMLElement||e instanceof SVGElement}var S=r(24958),_=function(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];var n=t.filter(Boolean);return n.length<=1?n[0]:function(e){t.forEach((function(t){!function(e,t){"function"==typeof e?e(t):"object"===i(e)&&e&&"current"in e&&(e.current=t)}(t,e)}))}};function w(e,t,r,n){var o=b().unstable_batchedUpdates?function(e){b().unstable_batchedUpdates(r,e)}:r;return null!=e&&e.addEventListener&&e.addEventListener(t,o,n),{remove:function(){null!=e&&e.removeEventListener&&e.removeEventListener(t,o,n)}}}Number(n.version.split(".")[0]);const T=(0,n.forwardRef)((function(e,t){var r=e.didUpdate,o=e.getContainer,i=e.children,a=(0,n.useRef)(),l=(0,n.useRef)();(0,n.useImperativeHandle)(t,(function(){return{}}));var u=(0,n.useRef)(!1);return!u.current&&"undefined"!=typeof window&&window.document&&window.document.createElement&&(l.current=o(),a.current=l.current.parentNode,u.current=!0),(0,n.useEffect)((function(){null==r||r(e)})),(0,n.useEffect)((function(){return null===l.current.parentNode&&null!==a.current&&a.current.appendChild(l.current),function(){var e;null===(e=l.current)||void 0===e||null===(e=e.parentNode)||void 0===e||e.removeChild(l.current)}}),[]),l.current?b().createPortal(i,l.current):null}));var P=r(71633),C=r.n(P);function I(e,t,r){return r?e[0]===t[0]:e[0]===t[0]&&e[1]===t[1]}var A=r(49257);function R(e,t){if(null==e)return{};var r,n,o=(0,A.A)(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}var x,N=r(56182),D=r.n(N);function L(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function j(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var r=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=r){var n,o,i,a,l=[],u=!0,s=!1;try{if(i=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;u=!1}else for(;!(u=(n=i.call(r)).done)&&(l.push(n.value),l.length!==t);u=!0);}catch(e){s=!0,o=e}finally{try{if(!u&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(s)throw o}}return l}}(e,t)||function(e,t){if(e){if("string"==typeof e)return L(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?L(e,t):void 0}}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function M(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function k(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?M(Object(r),!0).forEach((function(t){q(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):M(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function F(e){return F="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},F(e)}function q(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}var V={Webkit:"-webkit-",Moz:"-moz-",ms:"-ms-",O:"-o-"};function B(){if(void 0!==x)return x;x="";var e=document.createElement("p").style;for(var t in V)t+"Transform"in e&&(x=t);return x}function U(){return B()?"".concat(B(),"TransitionProperty"):"transitionProperty"}function W(){return B()?"".concat(B(),"Transform"):"transform"}function G(e,t){var r=U();r&&(e.style[r]=t,"transitionProperty"!==r&&(e.style.transitionProperty=t))}function H(e,t){var r=W();r&&(e.style[r]=t,"transform"!==r&&(e.style.transform=t))}var K,$=/matrix\((.*)\)/,z=/matrix3d\((.*)\)/;function Y(e){var t=e.style.display;e.style.display="none",e.offsetHeight,e.style.display=t}function Q(e,t,r){var n=r;if("object"!==F(t))return void 0!==n?("number"==typeof n&&(n="".concat(n,"px")),void(e.style[t]=n)):K(e,t);for(var o in t)t.hasOwnProperty(o)&&Q(e,o,t[o])}function X(e,t){var r=e["page".concat(t?"Y":"X","Offset")],n="scroll".concat(t?"Top":"Left");if("number"!=typeof r){var o=e.document;"number"!=typeof(r=o.documentElement[n])&&(r=o.body[n])}return r}function J(e){return X(e)}function Z(e){return X(e,!0)}function ee(e){var t=function(e){var t,r,n,o=e.ownerDocument,i=o.body,a=o&&o.documentElement;return t=e.getBoundingClientRect(),r=Math.floor(t.left),n=Math.floor(t.top),{left:r-=a.clientLeft||i.clientLeft||0,top:n-=a.clientTop||i.clientTop||0}}(e),r=e.ownerDocument,n=r.defaultView||r.parentWindow;return t.left+=J(n),t.top+=Z(n),t}function te(e){return null!=e&&e==e.window}function re(e){return te(e)?e.document:9===e.nodeType?e:e.ownerDocument}var ne=new RegExp("^(".concat(/[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source,")(?!px)[a-z%]+$"),"i"),oe=/^(top|right|bottom|left)$/,ie="currentStyle",ae="runtimeStyle",le="left";function ue(e,t){return"left"===e?t.useCssRight?"right":e:t.useCssBottom?"bottom":e}function se(e){return"left"===e?"right":"right"===e?"left":"top"===e?"bottom":"bottom"===e?"top":void 0}function ce(e,t,r){"static"===Q(e,"position")&&(e.style.position="relative");var n=-999,o=-999,i=ue("left",r),a=ue("top",r),l=se(i),u=se(a);"left"!==i&&(n=999),"top"!==a&&(o=999);var s,c="",d=ee(e);("left"in t||"top"in t)&&(c=(s=e).style.transitionProperty||s.style[U()]||"",G(e,"none")),"left"in t&&(e.style[l]="",e.style[i]="".concat(n,"px")),"top"in t&&(e.style[u]="",e.style[a]="".concat(o,"px")),Y(e);var f=ee(e),p={};for(var g in t)if(t.hasOwnProperty(g)){var v=ue(g,r),h="left"===g?n:o,m=d[g]-f[g];p[v]=v===g?h+m:h-m}Q(e,p),Y(e),("left"in t||"top"in t)&&G(e,c);var y={};for(var b in t)if(t.hasOwnProperty(b)){var E=ue(b,r),O=t[b]-d[b];y[E]=b===E?p[E]+O:p[E]-O}Q(e,y)}function de(e,t){for(var r=0;r<e.length;r++)t(e[r])}function fe(e){return"border-box"===K(e,"boxSizing")}"undefined"!=typeof window&&(K=window.getComputedStyle?function(e,t,r){var n=r,o="",i=re(e);return(n=n||i.defaultView.getComputedStyle(e,null))&&(o=n.getPropertyValue(t)||n[t]),o}:function(e,t){var r=e[ie]&&e[ie][t];if(ne.test(r)&&!oe.test(t)){var n=e.style,o=n[le],i=e[ae][le];e[ae][le]=e[ie][le],n[le]="fontSize"===t?"1em":r||0,r=n.pixelLeft+"px",n[le]=o,e[ae][le]=i}return""===r?"auto":r});var pe=["margin","border","padding"],ge=-1,ve=2,he=1;function me(e,t,r){var n,o,i,a=0;for(o=0;o<t.length;o++)if(n=t[o])for(i=0;i<r.length;i++){var l;l="border"===n?"".concat(n).concat(r[i],"Width"):n+r[i],a+=parseFloat(K(e,l))||0}return a}var ye={getParent:function(e){var t=e;do{t=11===t.nodeType&&t.host?t.host:t.parentNode}while(t&&1!==t.nodeType&&9!==t.nodeType);return t}};function be(e,t,r){var n=r;if(te(e))return"width"===t?ye.viewportWidth(e):ye.viewportHeight(e);if(9===e.nodeType)return"width"===t?ye.docWidth(e):ye.docHeight(e);var o="width"===t?["Left","Right"]:["Top","Bottom"],i="width"===t?Math.floor(e.getBoundingClientRect().width):Math.floor(e.getBoundingClientRect().height),a=fe(e),l=0;(null==i||i<=0)&&(i=void 0,(null==(l=K(e,t))||Number(l)<0)&&(l=e.style[t]||0),l=Math.floor(parseFloat(l))||0),void 0===n&&(n=a?he:ge);var u=void 0!==i||a,s=i||l;return n===ge?u?s-me(e,["border","padding"],o):l:u?n===he?s:s+(n===ve?-me(e,["border"],o):me(e,["margin"],o)):l+me(e,pe.slice(n),o)}de(["Width","Height"],(function(e){ye["doc".concat(e)]=function(t){var r=t.document;return Math.max(r.documentElement["scroll".concat(e)],r.body["scroll".concat(e)],ye["viewport".concat(e)](r))},ye["viewport".concat(e)]=function(t){var r="client".concat(e),n=t.document,o=n.body,i=n.documentElement[r];return"CSS1Compat"===n.compatMode&&i||o&&o[r]||i}}));var Ee={position:"absolute",visibility:"hidden",display:"block"};function Oe(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];var n,o=t[0];return 0!==o.offsetWidth?n=be.apply(void 0,t):function(e,r){var o,i={},a=e.style;for(o in r)r.hasOwnProperty(o)&&(i[o]=a[o],a[o]=r[o]);for(o in function(){n=be.apply(void 0,t)}.call(e),r)r.hasOwnProperty(o)&&(a[o]=i[o])}(o,Ee),n}function Se(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);return e}de(["width","height"],(function(e){var t=e.charAt(0).toUpperCase()+e.slice(1);ye["outer".concat(t)]=function(t,r){return t&&Oe(t,e,r?0:he)};var r="width"===e?["Left","Right"]:["Top","Bottom"];ye[e]=function(t,n){var o=n;return void 0!==o?t?(fe(t)&&(o+=me(t,["padding","border"],r)),Q(t,e,o)):void 0:t&&Oe(t,e,ge)}}));var _e={getWindow:function(e){if(e&&e.document&&e.setTimeout)return e;var t=e.ownerDocument||e;return t.defaultView||t.parentWindow},getDocument:re,offset:function(e,t,r){if(void 0===t)return ee(e);!function(e,t,r){if(r.ignoreShake){var n=ee(e),o=n.left.toFixed(0),i=n.top.toFixed(0),a=t.left.toFixed(0),l=t.top.toFixed(0);if(o===a&&i===l)return}r.useCssRight||r.useCssBottom?ce(e,t,r):r.useCssTransform&&W()in document.body.style?function(e,t){var r=ee(e),n=function(e){var t=window.getComputedStyle(e,null),r=t.getPropertyValue("transform")||t.getPropertyValue(W());if(r&&"none"!==r){var n=r.replace(/[^0-9\-.,]/g,"").split(",");return{x:parseFloat(n[12]||n[4],0),y:parseFloat(n[13]||n[5],0)}}return{x:0,y:0}}(e),o={x:n.x,y:n.y};"left"in t&&(o.x=n.x+t.left-r.left),"top"in t&&(o.y=n.y+t.top-r.top),function(e,t){var r=window.getComputedStyle(e,null),n=r.getPropertyValue("transform")||r.getPropertyValue(W());if(n&&"none"!==n){var o,i=n.match($);i?((o=(i=i[1]).split(",").map((function(e){return parseFloat(e,10)})))[4]=t.x,o[5]=t.y,H(e,"matrix(".concat(o.join(","),")"))):((o=n.match(z)[1].split(",").map((function(e){return parseFloat(e,10)})))[12]=t.x,o[13]=t.y,H(e,"matrix3d(".concat(o.join(","),")")))}else H(e,"translateX(".concat(t.x,"px) translateY(").concat(t.y,"px) translateZ(0)"))}(e,o)}(e,t):ce(e,t,r)}(e,t,r||{})},isWindow:te,each:de,css:Q,clone:function(e){var t,r={};for(t in e)e.hasOwnProperty(t)&&(r[t]=e[t]);if(e.overflow)for(t in e)e.hasOwnProperty(t)&&(r.overflow[t]=e.overflow[t]);return r},mix:Se,getWindowScrollLeft:function(e){return J(e)},getWindowScrollTop:function(e){return Z(e)},merge:function(){for(var e={},t=0;t<arguments.length;t++)_e.mix(e,t<0||arguments.length<=t?void 0:arguments[t]);return e},viewportWidth:0,viewportHeight:0};Se(_e,ye);var we=_e.getParent;function Te(e){if(_e.isWindow(e)||9===e.nodeType)return null;var t,r=_e.getDocument(e).body,n=_e.css(e,"position");if("fixed"!==n&&"absolute"!==n)return"html"===e.nodeName.toLowerCase()?null:we(e);for(t=we(e);t&&t!==r&&9!==t.nodeType;t=we(t))if("static"!==(n=_e.css(t,"position")))return t;return null}var Pe=_e.getParent;function Ce(e,t){for(var r={left:0,right:1/0,top:0,bottom:1/0},n=Te(e),o=_e.getDocument(e),i=o.defaultView||o.parentWindow,a=o.body,l=o.documentElement;n;){if(-1!==navigator.userAgent.indexOf("MSIE")&&0===n.clientWidth||n===a||n===l||"visible"===_e.css(n,"overflow")){if(n===a||n===l)break}else{var u=_e.offset(n);u.left+=n.clientLeft,u.top+=n.clientTop,r.top=Math.max(r.top,u.top),r.right=Math.min(r.right,u.left+n.clientWidth),r.bottom=Math.min(r.bottom,u.top+n.clientHeight),r.left=Math.max(r.left,u.left)}n=Te(n)}var s=null;_e.isWindow(e)||9===e.nodeType||(s=e.style.position,"absolute"===_e.css(e,"position")&&(e.style.position="fixed"));var c=_e.getWindowScrollLeft(i),d=_e.getWindowScrollTop(i),f=_e.viewportWidth(i),p=_e.viewportHeight(i),g=l.scrollWidth,v=l.scrollHeight,h=window.getComputedStyle(a);if("hidden"===h.overflowX&&(g=i.innerWidth),"hidden"===h.overflowY&&(v=i.innerHeight),e.style&&(e.style.position=s),t||function(e){if(_e.isWindow(e)||9===e.nodeType)return!1;var t=_e.getDocument(e),r=t.body,n=null;for(n=Pe(e);n&&n!==r&&n!==t;n=Pe(n))if("fixed"===_e.css(n,"position"))return!0;return!1}(e))r.left=Math.max(r.left,c),r.top=Math.max(r.top,d),r.right=Math.min(r.right,c+f),r.bottom=Math.min(r.bottom,d+p);else{var m=Math.max(g,c+f);r.right=Math.min(r.right,m);var y=Math.max(v,d+p);r.bottom=Math.min(r.bottom,y)}return r.top>=0&&r.left>=0&&r.bottom>r.top&&r.right>r.left?r:null}function Ie(e){var t,r,n;if(_e.isWindow(e)||9===e.nodeType){var o=_e.getWindow(e);t={left:_e.getWindowScrollLeft(o),top:_e.getWindowScrollTop(o)},r=_e.viewportWidth(o),n=_e.viewportHeight(o)}else t=_e.offset(e),r=_e.outerWidth(e),n=_e.outerHeight(e);return t.width=r,t.height=n,t}function Ae(e,t){var r=t.charAt(0),n=t.charAt(1),o=e.width,i=e.height,a=e.left,l=e.top;return"c"===r?l+=i/2:"b"===r&&(l+=i),"c"===n?a+=o/2:"r"===n&&(a+=o),{left:a,top:l}}function Re(e,t,r,n,o){var i=Ae(t,r[1]),a=Ae(e,r[0]),l=[a.left-i.left,a.top-i.top];return{left:Math.round(e.left-l[0]+n[0]-o[0]),top:Math.round(e.top-l[1]+n[1]-o[1])}}function xe(e,t,r){return e.left<r.left||e.left+t.width>r.right}function Ne(e,t,r){return e.top<r.top||e.top+t.height>r.bottom}function De(e,t,r){var n=[];return _e.each(e,(function(e){n.push(e.replace(t,(function(e){return r[e]})))})),n}function Le(e,t){return e[t]=-e[t],e}function je(e,t){return(/%$/.test(e)?parseInt(e.substring(0,e.length-1),10)/100*t:parseInt(e,10))||0}function Me(e,t){e[0]=je(e[0],t.width),e[1]=je(e[1],t.height)}function ke(e,t,r,n){var o=r.points,i=r.offset||[0,0],a=r.targetOffset||[0,0],l=r.overflow,u=r.source||e;i=[].concat(i),a=[].concat(a);var s={},c=0,d=Ce(u,!(!(l=l||{})||!l.alwaysByViewport)),f=Ie(u);Me(i,f),Me(a,t);var p=Re(f,t,o,i,a),g=_e.merge(f,p);if(d&&(l.adjustX||l.adjustY)&&n){if(l.adjustX&&xe(p,f,d)){var v=De(o,/[lr]/gi,{l:"r",r:"l"}),h=Le(i,0),m=Le(a,0);(function(e,t,r){return e.left>r.right||e.left+t.width<r.left})(Re(f,t,v,h,m),f,d)||(c=1,o=v,i=h,a=m)}if(l.adjustY&&Ne(p,f,d)){var y=De(o,/[tb]/gi,{t:"b",b:"t"}),b=Le(i,1),E=Le(a,1);(function(e,t,r){return e.top>r.bottom||e.top+t.height<r.top})(Re(f,t,y,b,E),f,d)||(c=1,o=y,i=b,a=E)}c&&(p=Re(f,t,o,i,a),_e.mix(g,p));var O=xe(p,f,d),S=Ne(p,f,d);if(O||S){var _=o;O&&(_=De(o,/[lr]/gi,{l:"r",r:"l"})),S&&(_=De(o,/[tb]/gi,{t:"b",b:"t"})),o=_,i=r.offset||[0,0],a=r.targetOffset||[0,0]}s.adjustX=l.adjustX&&O,s.adjustY=l.adjustY&&S,(s.adjustX||s.adjustY)&&(g=function(e,t,r,n){var o=_e.clone(e),i={width:t.width,height:t.height};return n.adjustX&&o.left<r.left&&(o.left=r.left),n.resizeWidth&&o.left>=r.left&&o.left+i.width>r.right&&(i.width-=o.left+i.width-r.right),n.adjustX&&o.left+i.width>r.right&&(o.left=Math.max(r.right-i.width,r.left)),n.adjustY&&o.top<r.top&&(o.top=r.top),n.resizeHeight&&o.top>=r.top&&o.top+i.height>r.bottom&&(i.height-=o.top+i.height-r.bottom),n.adjustY&&o.top+i.height>r.bottom&&(o.top=Math.max(r.bottom-i.height,r.top)),_e.mix(o,i)}(p,f,d,s))}return g.width!==f.width&&_e.css(u,"width",_e.width(u)+g.width-f.width),g.height!==f.height&&_e.css(u,"height",_e.height(u)+g.height-f.height),_e.offset(u,{left:g.left,top:g.top},{useCssRight:r.useCssRight,useCssBottom:r.useCssBottom,useCssTransform:r.useCssTransform,ignoreShake:r.ignoreShake}),{points:o,offset:i,targetOffset:a,overflow:s}}function Fe(e,t,r){var n=r.target||t,o=Ie(n),i=!function(e,t){var r=Ce(e,t),n=Ie(e);return!r||n.left+n.width<=r.left||n.top+n.height<=r.top||n.left>=r.right||n.top>=r.bottom}(n,r.overflow&&r.overflow.alwaysByViewport);return ke(e,o,r,i)}Fe.__getOffsetParent=Te,Fe.__getVisibleRectForElement=Ce;var qe={},Ve=[];function Be(e,t){}function Ue(e,t){}function We(e,t,r){t||qe[r]||(e(!1,r),qe[r]=!0)}function Ge(e,t){We(Be,e,t)}Ge.preMessage=function(e){Ve.push(e)},Ge.resetWarned=function(){qe={}},Ge.noteOnce=function(e,t){We(Ue,e,t)};const He=Ge;var Ke="undefined"!=typeof window&&window.document&&window.document.createElement?n.useLayoutEffect:n.useEffect;const $e=function(e,t){var r=n.useRef(!0);Ke((function(){return e(r.current)}),t),Ke((function(){return r.current=!1,function(){r.current=!0}}),[])};function ze(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];var n=t.filter((function(e){return e}));return n.length<=1?n[0]:function(e){t.forEach((function(t){!function(e,t){"function"==typeof e?e(t):"object"===i(e)&&e&&"current"in e&&(e.current=t)}(t,e)}))}}r(84271);var Ye=function(){if("undefined"!=typeof Map)return Map;function e(e,t){var r=-1;return e.some((function(e,n){return e[0]===t&&(r=n,!0)})),r}return function(){function t(){this.__entries__=[]}return Object.defineProperty(t.prototype,"size",{get:function(){return this.__entries__.length},enumerable:!0,configurable:!0}),t.prototype.get=function(t){var r=e(this.__entries__,t),n=this.__entries__[r];return n&&n[1]},t.prototype.set=function(t,r){var n=e(this.__entries__,t);~n?this.__entries__[n][1]=r:this.__entries__.push([t,r])},t.prototype.delete=function(t){var r=this.__entries__,n=e(r,t);~n&&r.splice(n,1)},t.prototype.has=function(t){return!!~e(this.__entries__,t)},t.prototype.clear=function(){this.__entries__.splice(0)},t.prototype.forEach=function(e,t){void 0===t&&(t=null);for(var r=0,n=this.__entries__;r<n.length;r++){var o=n[r];e.call(t,o[1],o[0])}},t}()}(),Qe="undefined"!=typeof window&&"undefined"!=typeof document&&window.document===document,Xe=void 0!==r.g&&r.g.Math===Math?r.g:"undefined"!=typeof self&&self.Math===Math?self:"undefined"!=typeof window&&window.Math===Math?window:Function("return this")(),Je="function"==typeof requestAnimationFrame?requestAnimationFrame.bind(Xe):function(e){return setTimeout((function(){return e(Date.now())}),1e3/60)},Ze=["top","right","bottom","left","width","height","size","weight"],et="undefined"!=typeof MutationObserver,tt=function(){function e(){this.connected_=!1,this.mutationEventsAdded_=!1,this.mutationsObserver_=null,this.observers_=[],this.onTransitionEnd_=this.onTransitionEnd_.bind(this),this.refresh=function(e,t){var r=!1,n=!1,o=0;function i(){r&&(r=!1,e()),n&&l()}function a(){Je(i)}function l(){var e=Date.now();if(r){if(e-o<2)return;n=!0}else r=!0,n=!1,setTimeout(a,t);o=e}return l}(this.refresh.bind(this),20)}return e.prototype.addObserver=function(e){~this.observers_.indexOf(e)||this.observers_.push(e),this.connected_||this.connect_()},e.prototype.removeObserver=function(e){var t=this.observers_,r=t.indexOf(e);~r&&t.splice(r,1),!t.length&&this.connected_&&this.disconnect_()},e.prototype.refresh=function(){this.updateObservers_()&&this.refresh()},e.prototype.updateObservers_=function(){var e=this.observers_.filter((function(e){return e.gatherActive(),e.hasActive()}));return e.forEach((function(e){return e.broadcastActive()})),e.length>0},e.prototype.connect_=function(){Qe&&!this.connected_&&(document.addEventListener("transitionend",this.onTransitionEnd_),window.addEventListener("resize",this.refresh),et?(this.mutationsObserver_=new MutationObserver(this.refresh),this.mutationsObserver_.observe(document,{attributes:!0,childList:!0,characterData:!0,subtree:!0})):(document.addEventListener("DOMSubtreeModified",this.refresh),this.mutationEventsAdded_=!0),this.connected_=!0)},e.prototype.disconnect_=function(){Qe&&this.connected_&&(document.removeEventListener("transitionend",this.onTransitionEnd_),window.removeEventListener("resize",this.refresh),this.mutationsObserver_&&this.mutationsObserver_.disconnect(),this.mutationEventsAdded_&&document.removeEventListener("DOMSubtreeModified",this.refresh),this.mutationsObserver_=null,this.mutationEventsAdded_=!1,this.connected_=!1)},e.prototype.onTransitionEnd_=function(e){var t=e.propertyName,r=void 0===t?"":t;Ze.some((function(e){return!!~r.indexOf(e)}))&&this.refresh()},e.getInstance=function(){return this.instance_||(this.instance_=new e),this.instance_},e.instance_=null,e}(),rt=function(e,t){for(var r=0,n=Object.keys(t);r<n.length;r++){var o=n[r];Object.defineProperty(e,o,{value:t[o],enumerable:!1,writable:!1,configurable:!0})}return e},nt=function(e){return e&&e.ownerDocument&&e.ownerDocument.defaultView||Xe},ot=st(0,0,0,0);function it(e){return parseFloat(e)||0}function at(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];return t.reduce((function(t,r){return t+it(e["border-"+r+"-width"])}),0)}var lt="undefined"!=typeof SVGGraphicsElement?function(e){return e instanceof nt(e).SVGGraphicsElement}:function(e){return e instanceof nt(e).SVGElement&&"function"==typeof e.getBBox};function ut(e){return Qe?lt(e)?function(e){var t=e.getBBox();return st(0,0,t.width,t.height)}(e):function(e){var t=e.clientWidth,r=e.clientHeight;if(!t&&!r)return ot;var n=nt(e).getComputedStyle(e),o=function(e){for(var t={},r=0,n=["top","right","bottom","left"];r<n.length;r++){var o=n[r],i=e["padding-"+o];t[o]=it(i)}return t}(n),i=o.left+o.right,a=o.top+o.bottom,l=it(n.width),u=it(n.height);if("border-box"===n.boxSizing&&(Math.round(l+i)!==t&&(l-=at(n,"left","right")+i),Math.round(u+a)!==r&&(u-=at(n,"top","bottom")+a)),!function(e){return e===nt(e).document.documentElement}(e)){var s=Math.round(l+i)-t,c=Math.round(u+a)-r;1!==Math.abs(s)&&(l-=s),1!==Math.abs(c)&&(u-=c)}return st(o.left,o.top,l,u)}(e):ot}function st(e,t,r,n){return{x:e,y:t,width:r,height:n}}var ct=function(){function e(e){this.broadcastWidth=0,this.broadcastHeight=0,this.contentRect_=st(0,0,0,0),this.target=e}return e.prototype.isActive=function(){var e=ut(this.target);return this.contentRect_=e,e.width!==this.broadcastWidth||e.height!==this.broadcastHeight},e.prototype.broadcastRect=function(){var e=this.contentRect_;return this.broadcastWidth=e.width,this.broadcastHeight=e.height,e},e}(),dt=function(e,t){var r,n,o,i,a,l,u,s=(n=(r=t).x,o=r.y,i=r.width,a=r.height,l="undefined"!=typeof DOMRectReadOnly?DOMRectReadOnly:Object,u=Object.create(l.prototype),rt(u,{x:n,y:o,width:i,height:a,top:o,right:n+i,bottom:a+o,left:n}),u);rt(this,{target:e,contentRect:s})},ft=function(){function e(e,t,r){if(this.activeObservations_=[],this.observations_=new Ye,"function"!=typeof e)throw new TypeError("The callback provided as parameter 1 is not a function.");this.callback_=e,this.controller_=t,this.callbackCtx_=r}return e.prototype.observe=function(e){if(!arguments.length)throw new TypeError("1 argument required, but only 0 present.");if("undefined"!=typeof Element&&Element instanceof Object){if(!(e instanceof nt(e).Element))throw new TypeError('parameter 1 is not of type "Element".');var t=this.observations_;t.has(e)||(t.set(e,new ct(e)),this.controller_.addObserver(this),this.controller_.refresh())}},e.prototype.unobserve=function(e){if(!arguments.length)throw new TypeError("1 argument required, but only 0 present.");if("undefined"!=typeof Element&&Element instanceof Object){if(!(e instanceof nt(e).Element))throw new TypeError('parameter 1 is not of type "Element".');var t=this.observations_;t.has(e)&&(t.delete(e),t.size||this.controller_.removeObserver(this))}},e.prototype.disconnect=function(){this.clearActive(),this.observations_.clear(),this.controller_.removeObserver(this)},e.prototype.gatherActive=function(){var e=this;this.clearActive(),this.observations_.forEach((function(t){t.isActive()&&e.activeObservations_.push(t)}))},e.prototype.broadcastActive=function(){if(this.hasActive()){var e=this.callbackCtx_,t=this.activeObservations_.map((function(e){return new dt(e.target,e.broadcastRect())}));this.callback_.call(e,t,e),this.clearActive()}},e.prototype.clearActive=function(){this.activeObservations_.splice(0)},e.prototype.hasActive=function(){return this.activeObservations_.length>0},e}(),pt="undefined"!=typeof WeakMap?new WeakMap:new Ye,gt=function e(t){if(!(this instanceof e))throw new TypeError("Cannot call a class as a function.");if(!arguments.length)throw new TypeError("1 argument required, but only 0 present.");var r=tt.getInstance(),n=new ft(t,r,this);pt.set(this,n)};["observe","unobserve","disconnect"].forEach((function(e){gt.prototype[e]=function(){var t;return(t=pt.get(this))[e].apply(t,arguments)}}));const vt=void 0!==Xe.ResizeObserver?Xe.ResizeObserver:gt;function ht(e,t){var r=null,n=null,o=new vt((function(e){var o=j(e,1)[0].target;if(document.documentElement.contains(o)){var i=o.getBoundingClientRect(),a=i.width,l=i.height,u=Math.floor(a),s=Math.floor(l);r===u&&n===s||Promise.resolve().then((function(){t({width:u,height:s})})),r=u,n=s}}));return e&&o.observe(e),function(){o.disconnect()}}function mt(e){return"function"!=typeof e?null:e()}function yt(e){return"object"===i(e)&&e?e:null}var bt=function(e,t){var r=e.children,n=e.disabled,a=e.target,l=e.align,u=e.onAlign,s=e.monitorWindowResize,c=e.monitorBufferTime,d=void 0===c?0:c,f=o().useRef({}),p=o().useRef(),g=o().Children.only(r),v=o().useRef({});v.current.disabled=n,v.current.target=a,v.current.align=l,v.current.onAlign=u;var h=function(e,t){var r=o().useRef(!1),n=o().useRef(null);function i(){window.clearTimeout(n.current)}return[function e(o){if(i(),r.current&&!0!==o)n.current=window.setTimeout((function(){r.current=!1,e()}),t);else{if(!1===function(){var e=v.current,t=e.disabled,r=e.target,n=e.align,o=e.onAlign,i=p.current;if(!t&&r&&i){var a,l=mt(r),u=yt(r);f.current.element=l,f.current.point=u,f.current.align=n;var s=document.activeElement;return l&&function(e){if(!e)return!1;if(e instanceof Element){if(e.offsetParent)return!0;if(e.getBBox){var t=e.getBBox(),r=t.width,n=t.height;if(r||n)return!0}if(e.getBoundingClientRect){var o=e.getBoundingClientRect(),i=o.width,a=o.height;if(i||a)return!0}}return!1}(l)?a=Fe(i,l,n):u&&(a=function(e,t,r){var n,o,i=_e.getDocument(e),a=i.defaultView||i.parentWindow,l=_e.getWindowScrollLeft(a),u=_e.getWindowScrollTop(a),s=_e.viewportWidth(a),c=_e.viewportHeight(a),d={left:n="pageX"in t?t.pageX:l+t.clientX,top:o="pageY"in t?t.pageY:u+t.clientY,width:0,height:0},f=n>=0&&n<=l+s&&o>=0&&o<=u+c,p=[r.points[0],"cc"];return ke(e,d,k(k({},r),{},{points:p}),f)}(i,u,n)),function(e,t){e!==document.activeElement&&function(e,t){if(!e)return!1;if(e.contains)return e.contains(t);for(var r=t;r;){if(r===e)return!0;r=r.parentNode}return!1}(t,e)&&"function"==typeof e.focus&&e.focus()}(s,i),o&&a&&o(i,a),!0}return!1}())return;r.current=!0,n.current=window.setTimeout((function(){r.current=!1}),t)}},function(){r.current=!1,i()}]}(0,d),m=j(h,2),y=m[0],E=m[1],O=j(o().useState(),2),S=O[0],_=O[1],w=j(o().useState(),2),T=w[0],P=w[1];return $e((function(){_(mt(a)),P(yt(a))})),o().useEffect((function(){var e,t;f.current.element===S&&((e=f.current.point)===(t=T)||e&&t&&("pageX"in t&&"pageY"in t?e.pageX===t.pageX&&e.pageY===t.pageY:"clientX"in t&&"clientY"in t&&e.clientX===t.clientX&&e.clientY===t.clientY))&&function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=new Set;return function e(t,o){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1,l=n.has(t);if(He(!l,"Warning: There may be circular references"),l)return!1;if(t===o)return!0;if(r&&a>1)return!1;n.add(t);var u=a+1;if(Array.isArray(t)){if(!Array.isArray(o)||t.length!==o.length)return!1;for(var s=0;s<t.length;s++)if(!e(t[s],o[s],u))return!1;return!0}if(t&&o&&"object"===i(t)&&"object"===i(o)){var c=Object.keys(t);return c.length===Object.keys(o).length&&c.every((function(r){return e(t[r],o[r],u)}))}return!1}(e,t)}(f.current.align,l)||y()})),o().useEffect((function(){return ht(p.current,y)}),[p.current]),o().useEffect((function(){return ht(S,y)}),[S]),o().useEffect((function(){n?E():y()}),[n]),o().useEffect((function(){if(s){var e=function(e,t,r,n){var o=b().unstable_batchedUpdates?function(e){b().unstable_batchedUpdates(r,e)}:r;return null!=e&&e.addEventListener&&e.addEventListener(t,o,n),{remove:function(){null!=e&&e.removeEventListener&&e.removeEventListener(t,o,n)}}}(window,"resize",y);return e.remove}}),[s]),o().useEffect((function(){return function(){E()}}),[]),o().useImperativeHandle(t,(function(){return{forceAlign:function(){return y(!0)}}})),o().isValidElement(g)&&(g=o().cloneElement(g,{ref:ze(g.ref,p)})),g},Et=o().forwardRef(bt);Et.displayName="Align";const Ot=Et;function St(e){return e instanceof HTMLElement||e instanceof SVGElement}r(57128);Number(n.version.split(".")[0]);var _t=!("undefined"==typeof window||!window.document||!window.document.createElement);function wt(e,t){var r={};return r[e.toLowerCase()]=t.toLowerCase(),r["Webkit".concat(e)]="webkit".concat(t),r["Moz".concat(e)]="moz".concat(t),r["ms".concat(e)]="MS".concat(t),r["O".concat(e)]="o".concat(t.toLowerCase()),r}var Tt,Pt,Ct,It=(Tt=_t,Pt="undefined"!=typeof window?window:{},Ct={animationend:wt("Animation","AnimationEnd"),transitionend:wt("Transition","TransitionEnd")},Tt&&("AnimationEvent"in Pt||delete Ct.animationend.animation,"TransitionEvent"in Pt||delete Ct.transitionend.transition),Ct),At={};if(_t){var Rt=document.createElement("div");At=Rt.style}var xt={};function Nt(e){if(xt[e])return xt[e];var t=It[e];if(t)for(var r=Object.keys(t),n=r.length,o=0;o<n;o+=1){var i=r[o];if(Object.prototype.hasOwnProperty.call(t,i)&&i in At)return xt[e]=t[i],xt[e]}return""}var Dt=Nt("animationend"),Lt=Nt("transitionend"),jt=!(!Dt||!Lt);function Mt(e,t){return e?"object"===i(e)?e[t.replace(/-\w/g,(function(e){return e[1].toUpperCase()}))]:"".concat(e,"-").concat(t):null}var kt="none",Ft="appear",qt="enter",Vt="leave";const Bt=function(e){var t=e,r=!!n.forwardRef;function a(e){return!(!e.motionName||!t)}"object"===i(e)&&(t=e.transitionSupport,r="forwardRef"in e?e.forwardRef:r);var u=function(e){v(r,e);var t=m(r);function r(){var e;return c(this,r),(e=t.apply(this,arguments)).$cacheEle=null,e.node=null,e.raf=null,e.destroyed=!1,e.deadlineId=null,e.state={status:kt,statusActive:!1,newStatus:!1,statusStyle:null},e.onDomUpdate=function(){var t=e.state,r=t.status,n=t.newStatus,o=e.props,i=o.onAppearStart,l=o.onEnterStart,u=o.onLeaveStart,s=o.onAppearActive,c=o.onEnterActive,d=o.onLeaveActive,f=o.motionAppear,p=o.motionEnter,g=o.motionLeave;if(a(e.props)){var v=e.getElement();e.$cacheEle!==v&&(e.removeEventListener(e.$cacheEle),e.addEventListener(v),e.$cacheEle=v),n&&r===Ft&&f?e.updateStatus(i,null,null,(function(){e.updateActiveStatus(s,Ft)})):n&&r===qt&&p?e.updateStatus(l,null,null,(function(){e.updateActiveStatus(c,qt)})):n&&r===Vt&&g&&e.updateStatus(u,null,null,(function(){e.updateActiveStatus(d,Vt)}))}},e.onMotionEnd=function(t){if(!t||t.deadline||t.target===e.getElement()){var r=e.state,n=r.status,o=r.statusActive,i=e.props,a=i.onAppearEnd,l=i.onEnterEnd,u=i.onLeaveEnd;n===Ft&&o?e.updateStatus(a,{status:kt},t):n===qt&&o?e.updateStatus(l,{status:kt},t):n===Vt&&o&&e.updateStatus(u,{status:kt},t)}},e.setNodeRef=function(t){var r=e.props.internalRef;e.node=t,function(e,t){"function"==typeof e?e(t):"object"===i(e)&&e&&"current"in e&&(e.current=t)}(r,t)},e.getElement=function(){try{return function(e){return e&&"object"===i(e)&&St(e.nativeElement)?e.nativeElement:St(e)?e:null}(t=e.node||p(e))||(t instanceof o().Component?null===(r=b().findDOMNode)||void 0===r?void 0:r.call(b(),t):null)}catch(t){return e.$cacheEle}var t,r},e.addEventListener=function(t){t&&(t.addEventListener(Lt,e.onMotionEnd),t.addEventListener(Dt,e.onMotionEnd))},e.removeEventListener=function(t){t&&(t.removeEventListener(Lt,e.onMotionEnd),t.removeEventListener(Dt,e.onMotionEnd))},e.updateStatus=function(t,r,n,o){var a,l=t?t(e.getElement(),n):null;!1===l||e.destroyed||(o&&(a=function(){e.nextFrame(o)}),e.setState(s({statusStyle:"object"===i(l)?l:null,newStatus:!1},r),a))},e.updateActiveStatus=function(t,r){e.nextFrame((function(){if(e.state.status===r){var n=e.props.motionDeadline;e.updateStatus(t,{statusActive:!0}),n>0&&(e.deadlineId=setTimeout((function(){e.onMotionEnd({deadline:!0})}),n))}}))},e.nextFrame=function(t){e.cancelNextFrame(),e.raf=D()(t)},e.cancelNextFrame=function(){e.raf&&(D().cancel(e.raf),e.raf=null)},e}return f(r,[{key:"componentDidMount",value:function(){this.onDomUpdate()}},{key:"componentDidUpdate",value:function(){this.onDomUpdate()}},{key:"componentWillUnmount",value:function(){this.destroyed=!0,this.removeEventListener(this.$cacheEle),this.cancelNextFrame(),clearTimeout(this.deadlineId)}},{key:"render",value:function(){var e,t=this.state,r=t.status,n=t.statusActive,o=t.statusStyle,i=this.props,u=i.children,c=i.motionName,d=i.visible,f=i.removeOnLeave,p=i.leavedClassName,g=i.eventProps;return u?r!==kt&&a(this.props)?u(s(s({},g),{},{className:C()(Mt(c,r),(e={},l(e,Mt(c,"".concat(r,"-active")),n),l(e,c,"string"==typeof c),e)),style:o}),this.setNodeRef):d?u(s({},g),this.setNodeRef):f?null:u(s(s({},g),{},{className:p}),this.setNodeRef):null}}],[{key:"getDerivedStateFromProps",value:function(e,t){var r=t.prevProps,n=t.status;if(!a(e))return{};var o=e.visible,i=e.motionAppear,l=e.motionEnter,u=e.motionLeave,s=e.motionLeaveImmediately,c={prevProps:e};return(n===Ft&&!i||n===qt&&!l||n===Vt&&!u)&&(c.status=kt,c.statusActive=!1,c.newStatus=!1),!r&&o&&i&&(c.status=Ft,c.statusActive=!1,c.newStatus=!0),r&&!r.visible&&o&&l&&(c.status=qt,c.statusActive=!1,c.newStatus=!0),(r&&r.visible&&!o&&u||!r&&s&&!o&&u)&&(c.status=Vt,c.statusActive=!1,c.newStatus=!0),c}}]),r}(n.Component);return u.defaultProps={visible:!0,motionEnter:!0,motionAppear:!0,motionLeave:!0,removeOnLeave:!0},r?n.forwardRef((function(e,t){return n.createElement(u,Object.assign({internalRef:t},e))})):u}(jt);var Ut="add",Wt="keep",Gt="remove",Ht="removed";function Kt(e){var t;return s(s({},t=e&&"object"===i(e)&&"key"in e?e:{key:e}),{},{key:String(t.key)})}function $t(){return(arguments.length>0&&void 0!==arguments[0]?arguments[0]:[]).map(Kt)}var zt=["eventProps","visible","children","motionName","motionAppear","motionEnter","motionLeave","motionLeaveImmediately","motionDeadline","removeOnLeave","leavedClassName","onAppearStart","onAppearActive","onAppearEnd","onEnterStart","onEnterActive","onEnterEnd","onLeaveStart","onLeaveActive","onLeaveEnd"];!function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Bt,r=function(r){v(i,r);var o=m(i);function i(){var e;return c(this,i),(e=o.apply(this,arguments)).state={keyEntities:[]},e.removeKey=function(t){e.setState((function(e){return{keyEntities:e.keyEntities.map((function(e){return e.key!==t?e:s(s({},e),{},{status:Ht})}))}}))},e}return f(i,[{key:"render",value:function(){var e=this,r=this.state.keyEntities,o=this.props,i=o.component,a=o.children,l=R(o,["component","children"]),u=i||n.Fragment,s={};return zt.forEach((function(e){s[e]=l[e],delete l[e]})),delete l.keys,n.createElement(u,Object.assign({},l),r.map((function(r){var o=r.status,i=R(r,["status"]),l=o===Ut||o===Wt;return n.createElement(t,Object.assign({},s,{key:i.key,visible:l,eventProps:i,onLeaveEnd:function(){s.onLeaveEnd&&s.onLeaveEnd.apply(s,arguments),e.removeKey(i.key)}}),a)})))}}],[{key:"getDerivedStateFromProps",value:function(t,r){var n=t.keys,o=r.keyEntities,i=$t(n);if(!e)return{keyEntities:i.map((function(e){return s(s({},e),{},{status:Wt})}))};var a=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],r=[],n=0,o=t.length,i=$t(e),a=$t(t);i.forEach((function(e){for(var t=!1,i=n;i<o;i+=1){var l=a[i];if(l.key===e.key){n<i&&(r=r.concat(a.slice(n,i).map((function(e){return s(s({},e),{},{status:Ut})}))),n=i),r.push(s(s({},l),{},{status:Wt})),n+=1,t=!0;break}}t||r.push(s(s({},e),{},{status:Gt}))})),n<o&&(r=r.concat(a.slice(n).map((function(e){return s(s({},e),{},{status:Ut})}))));var l={};return r.forEach((function(e){var t=e.key;l[t]=(l[t]||0)+1})),Object.keys(l).filter((function(e){return l[e]>1})).forEach((function(e){(r=r.filter((function(t){var r=t.key,n=t.status;return r!==e||n!==Gt}))).forEach((function(t){t.key===e&&(t.status=Wt)}))})),r}(o,i),l=o.length;return{keyEntities:a.filter((function(e){for(var t=null,r=0;r<l;r+=1){var n=o[r];if(n.key===e.key){t=n;break}}return!t||t.status!==Ht||e.status!==Gt}))}}}]),i}(n.Component);r.defaultProps={component:"div"}}(jt);const Yt=Bt;var Qt=n.forwardRef((function(e,t){var r=e.prefixCls,o=e.className,i=e.style,a=e.children,l=e.onMouseEnter,u=e.onMouseLeave,s=e.onMouseDown,c=e.onTouchStart,d=a;return n.Children.count(a)>1&&(d=n.createElement("div",{className:"".concat(r,"-content")},a)),n.createElement("div",{ref:t,className:o,onMouseEnter:l,onMouseLeave:u,onMouseDown:s,onTouchStart:c,style:i},d)}));Qt.displayName="PopupInner";const Xt=Qt;function Jt(e){var t=e.prefixCls,r=e.motion,n=e.animation,o=e.transitionName;return r||(n?{motionName:"".concat(t,"-").concat(n)}:o?{motionName:o}:null)}function Zt(e){return e&&e.motionName}var er=function(e){v(r,e);var t=m(r);function r(){var e;return c(this,r),(e=t.apply(this,arguments)).state={targetWidth:void 0,targetHeight:void 0,status:null,prevVisible:null,alignClassName:null,inMotion:!1},e.popupRef=o().createRef(),e.alignRef=o().createRef(),e.nextFrameState=null,e.nextFrameId=null,e.onAlign=function(t,r){var n=e.state.status,o=e.props,i=o.getClassNameFromAlign,a=o.onAlign,l=i(r);"align"===n?e.setState({alignClassName:l,status:"aligned"},(function(){e.alignRef.current.forceAlign()})):"aligned"===n?(e.setState({alignClassName:l,status:"afterAlign"}),a(t,r)):e.setState({alignClassName:l})},e.onMotionEnd=function(){var t=e.props.visible;e.setState({status:t?"AfterMotion":"stable",inMotion:!1})},e.setStateOnNextFrame=function(t){e.cancelFrameState(),e.nextFrameState=s(s({},e.nextFrameState),t),e.nextFrameId=D()((function(){var t=s({},e.nextFrameState);e.nextFrameState=null,e.setState(t)}))},e.getMotion=function(){return s({},Jt(e.props))},e.getAlignTarget=function(){var t=e.props,r=t.point,n=t.getRootDomNode;return r||n},e.cancelFrameState=function(){D().cancel(e.nextFrameId)},e.renderPopupElement=function(){var t=e.state,r=t.status,n=t.targetHeight,i=t.targetWidth,a=t.alignClassName,l=e.props,u=l.prefixCls,c=l.className,d=l.style,f=l.stretch,p=l.visible,g=l.align,v=l.destroyPopupOnHide,h=l.onMouseEnter,m=l.onMouseLeave,y=l.onMouseDown,b=l.onTouchStart,E=l.children,O=C()(u,c,a),S="".concat(u,"-hidden"),w={};f&&(-1!==f.indexOf("height")?w.height=n:-1!==f.indexOf("minHeight")&&(w.minHeight=n),-1!==f.indexOf("width")?w.width=i:-1!==f.indexOf("minWidth")&&(w.minWidth=i));var T=s(s(s(s({},w),e.getZIndexStyle()),d),{},{opacity:"stable"!==r&&p?0:void 0,pointerEvents:"stable"!==r&&p?"none":void 0}),P=e.getMotion(),I=p;p&&"beforeMotion"!==r&&"motion"!==r&&"stable"!==r&&(P.motionAppear=!1,P.motionEnter=!1,P.motionLeave=!1),"afterAlign"!==r&&"beforeMotion"!==r||(I=!1),["onEnterStart","onAppearStart","onLeaveStart"].forEach((function(t){var r=null==P?void 0:P[t];P[t]=function(){for(var t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];null==r||r.apply(void 0,n),e.setState({inMotion:!0})}}));var A=!p||"align"!==r&&"aligned"!==r&&"stable"!==r,R=!0;return"stable"===r&&(R=p),v&&!R?null:o().createElement(Yt,Object.assign({visible:I},P,{removeOnLeave:!1,onEnterEnd:e.onMotionEnd,onLeaveEnd:e.onMotionEnd,leavedClassName:S}),(function(t,r){var n=t.style,i=t.className;return o().createElement(Ot,{target:e.getAlignTarget(),key:"popup",ref:e.alignRef,monitorWindowResize:!0,disabled:A,align:g,onAlign:e.onAlign},o().createElement(Xt,{prefixCls:u,className:C()(O,i),ref:_(r,e.popupRef),onMouseEnter:h,onMouseLeave:m,onMouseDown:y,onTouchStart:b,style:s(s({},T),n)},E))}))},e.renderMaskElement=function(){var t=e.props,r=t.mask,n=t.maskMotion,i=t.maskTransitionName,a=t.maskAnimation,l=t.prefixCls,u=t.visible;if(!r)return null;var c={};return n&&n.motionName&&(c=s({motionAppear:!0},Jt({motion:n,prefixCls:l,transitionName:i,animation:a}))),o().createElement(Yt,Object.assign({},c,{visible:u,removeOnLeave:!0}),(function(t){var r=t.className;return o().createElement("div",{style:e.getZIndexStyle(),key:"mask",className:C()("".concat(l,"-mask"),r)})}))},e}return f(r,[{key:"componentDidMount",value:function(){this.componentDidUpdate()}},{key:"componentDidUpdate",value:function(){var e=this.state.status,t=this.props,r=t.getRootDomNode,n=t.visible,o=t.stretch;if(this.cancelFrameState(),n&&"stable"!==e)switch(e){case null:this.setStateOnNextFrame({status:o?"measure":"align"});break;case"afterAlign":this.setStateOnNextFrame({status:Zt(this.getMotion())?"beforeMotion":"stable"});break;case"AfterMotion":this.setStateOnNextFrame({status:"stable"});break;default:var i=["measure","align",null,"beforeMotion","motion"],a=i.indexOf(e),l=i[a+1];-1!==a&&l&&this.setStateOnNextFrame({status:l})}if("measure"===e){var u=r();u&&this.setStateOnNextFrame({targetHeight:u.offsetHeight,targetWidth:u.offsetWidth})}}},{key:"componentWillUnmount",value:function(){this.cancelFrameState()}},{key:"getZIndexStyle",value:function(){return{zIndex:this.props.zIndex}}},{key:"render",value:function(){return o().createElement("div",null,this.renderMaskElement(),this.renderPopupElement())}}],[{key:"getDerivedStateFromProps",value:function(e,t){var r=e.visible,n=R(e,["visible"]),o=t.prevVisible,i=t.status,a=t.inMotion,l={prevVisible:r,status:i},u=Jt(n);return null===o&&!1===r?(l.status="stable",l.inMotion=!1):r!==o&&(l.inMotion=!1,r||Zt(u)&&a?l.status=null:l.status="stable",r&&(l.alignClassName=null)),l}}]),r}(n.Component);const tr=er,rr=n.createContext(null);function nr(){}var or=["onClick","onMouseDown","onTouchStart","onMouseEnter","onMouseLeave","onFocus","onBlur","onContextMenu"];const ir=(ar=T,lr=function(e){v(r,e);var t=m(r);function r(e){var n,a;return c(this,r),(n=t.call(this,e)).popupRef=o().createRef(),n.triggerRef=o().createRef(),n.onMouseEnter=function(e){var t=n.props.mouseEnterDelay;n.fireEvents("onMouseEnter",e),n.delaySetPopupVisible(!0,t,t?null:e)},n.onMouseMove=function(e){n.fireEvents("onMouseMove",e),n.setPoint(e)},n.onMouseLeave=function(e){n.fireEvents("onMouseLeave",e),n.delaySetPopupVisible(!1,n.props.mouseLeaveDelay)},n.onPopupMouseEnter=function(){n.clearDelayTimer()},n.onPopupMouseLeave=function(e){e.relatedTarget&&!e.relatedTarget.setTimeout&&n.popupRef.current&&n.popupRef.current.popupRef.current&&E(n.popupRef.current.popupRef.current,e.relatedTarget)||n.delaySetPopupVisible(!1,n.props.mouseLeaveDelay)},n.onFocus=function(e){n.fireEvents("onFocus",e),n.clearDelayTimer(),n.isFocusToShow()&&(n.focusTime=Date.now(),n.delaySetPopupVisible(!0,n.props.focusDelay))},n.onMouseDown=function(e){n.fireEvents("onMouseDown",e),n.preClickTime=Date.now()},n.onTouchStart=function(e){n.fireEvents("onTouchStart",e),n.preTouchTime=Date.now()},n.onBlur=function(e){n.fireEvents("onBlur",e),n.clearDelayTimer(),n.isBlurToHide()&&n.delaySetPopupVisible(!1,n.props.blurDelay)},n.onContextMenu=function(e){e.preventDefault(),n.fireEvents("onContextMenu",e),n.setPopupVisible(!0,e)},n.onContextMenuClose=function(){n.isContextMenuToShow()&&n.close()},n.onClick=function(e){if(n.fireEvents("onClick",e),n.focusTime){var t;if(n.preClickTime&&n.preTouchTime?t=Math.min(n.preClickTime,n.preTouchTime):n.preClickTime?t=n.preClickTime:n.preTouchTime&&(t=n.preTouchTime),Math.abs(t-n.focusTime)<20)return;n.focusTime=0}n.preClickTime=0,n.preTouchTime=0,n.isClickToShow()&&(n.isClickToHide()||n.isBlurToHide())&&e&&e.preventDefault&&e.preventDefault();var r=!n.state.popupVisible;(n.isClickToHide()&&!r||r&&n.isClickToShow())&&n.setPopupVisible(!n.state.popupVisible,e)},n.onPopupMouseDown=function(){var e;n.hasPopupMouseDown=!0,clearTimeout(n.mouseDownTimeout),n.mouseDownTimeout=window.setTimeout((function(){n.hasPopupMouseDown=!1}),0),n.context&&(e=n.context).onPopupMouseDown.apply(e,arguments)},n.onDocumentClick=function(e){if(!n.props.mask||n.props.maskClosable){var t=e.target,r=n.getRootDomNode(),o=n.getPopupDomNode();E(r,t)||E(o,t)||n.hasPopupMouseDown||n.close()}},n.getRootDomNode=function(){var e=n.props.getTriggerDOMNode;if(e)return e(n.triggerRef.current);try{var t=function(e){var t,r=function(e){return e&&"object"===i(e)&&O(e.nativeElement)?e.nativeElement:O(e)?e:null}(e);return r||(e instanceof o().Component?null===(t=b().findDOMNode)||void 0===t?void 0:t.call(b(),e):null)}(n.triggerRef.current);if(t)return t}catch(e){}return b().findDOMNode(p(n))},n.getPopupClassNameFromAlign=function(e){var t=[],r=n.props,o=r.popupPlacement,i=r.builtinPlacements,a=r.prefixCls,l=r.alignPoint,u=r.getPopupClassNameFromAlign;return o&&i&&t.push(function(e,t,r,n){for(var o=r.points,i=Object.keys(e),a=0;a<i.length;a+=1){var l=i[a];if(I(e[l].points,o,n))return"".concat(t,"-placement-").concat(l)}return""}(i,a,e,l)),u&&t.push(u(e)),t.join(" ")},n.getComponent=function(){var e=n.props,t=e.prefixCls,r=e.destroyPopupOnHide,i=e.popupClassName,a=e.onPopupAlign,l=e.popupMotion,u=e.popupAnimation,s=e.popupTransitionName,c=e.popupStyle,d=e.mask,f=e.maskAnimation,p=e.maskTransitionName,g=e.maskMotion,v=e.zIndex,h=e.popup,m=e.stretch,y=e.alignPoint,b=n.state,E=b.popupVisible,O=b.point,S=n.getPopupAlign(),_={};return n.isMouseEnterToShow()&&(_.onMouseEnter=n.onPopupMouseEnter),n.isMouseLeaveToHide()&&(_.onMouseLeave=n.onPopupMouseLeave),_.onMouseDown=n.onPopupMouseDown,_.onTouchStart=n.onPopupMouseDown,o().createElement(tr,Object.assign({prefixCls:t,destroyPopupOnHide:r,visible:E,point:y&&O,className:i,align:S,onAlign:a,animation:u,getClassNameFromAlign:n.getPopupClassNameFromAlign},_,{stretch:m,getRootDomNode:n.getRootDomNode,style:c,mask:d,zIndex:v,transitionName:s,maskAnimation:f,maskTransitionName:p,maskMotion:g,ref:n.popupRef,motion:l}),"function"==typeof h?h():h)},n.getContainer=function(){var e=p(n).props,t=document.createElement("div");return t.style.position="absolute",t.style.top="0",t.style.left="0",t.style.width="100%",(e.getPopupContainer?e.getPopupContainer(n.getRootDomNode()):e.getDocument().body).appendChild(t),t},n.setPoint=function(e){n.props.alignPoint&&e&&n.setState({point:{pageX:e.pageX,pageY:e.pageY}})},n.handlePortalUpdate=function(){n.state.prevPopupVisible!==n.state.popupVisible&&n.props.afterPopupVisibleChange(n.state.popupVisible)},a="popupVisible"in e?!!e.popupVisible:!!e.defaultPopupVisible,n.state={prevPopupVisible:a,popupVisible:a},or.forEach((function(e){n["fire".concat(e)]=function(t){n.fireEvents(e,t)}})),n}return f(r,[{key:"componentDidMount",value:function(){this.componentDidUpdate()}},{key:"componentDidUpdate",value:function(){var e,t=this.props;if(this.state.popupVisible)return this.clickOutsideHandler||!this.isClickToHide()&&!this.isContextMenuToShow()||(e=t.getDocument(),this.clickOutsideHandler=w(e,"mousedown",this.onDocumentClick)),this.touchOutsideHandler||(e=e||t.getDocument(),this.touchOutsideHandler=w(e,"touchstart",this.onDocumentClick)),!this.contextMenuOutsideHandler1&&this.isContextMenuToShow()&&(e=e||t.getDocument(),this.contextMenuOutsideHandler1=w(e,"scroll",this.onContextMenuClose)),void(!this.contextMenuOutsideHandler2&&this.isContextMenuToShow()&&(this.contextMenuOutsideHandler2=w(window,"blur",this.onContextMenuClose)));this.clearOutsideHandler()}},{key:"componentWillUnmount",value:function(){this.clearDelayTimer(),this.clearOutsideHandler(),clearTimeout(this.mouseDownTimeout)}},{key:"getPopupDomNode",value:function(){return this.popupRef.current&&this.popupRef.current.popupRef.current?this.popupRef.current.popupRef.current:null}},{key:"getPopupAlign",value:function(){var e=this.props,t=e.popupPlacement,r=e.popupAlign,n=e.builtinPlacements;return t&&n?function(e,t,r){return s(s({},e[t]||{}),r)}(n,t,r):r}},{key:"setPopupVisible",value:function(e,t){var r=this.props.alignPoint,n=this.state.popupVisible;this.clearDelayTimer(),n!==e&&("popupVisible"in this.props||this.setState({popupVisible:e,prevPopupVisible:n}),this.props.onPopupVisibleChange(e)),r&&t&&this.setPoint(t)}},{key:"delaySetPopupVisible",value:function(e,t,r){var n=this,o=1e3*t;if(this.clearDelayTimer(),o){var i=r?{pageX:r.pageX,pageY:r.pageY}:null;this.delayTimer=window.setTimeout((function(){n.setPopupVisible(e,i),n.clearDelayTimer()}),o)}else this.setPopupVisible(e,r)}},{key:"clearDelayTimer",value:function(){this.delayTimer&&(clearTimeout(this.delayTimer),this.delayTimer=null)}},{key:"clearOutsideHandler",value:function(){this.clickOutsideHandler&&(this.clickOutsideHandler.remove(),this.clickOutsideHandler=null),this.contextMenuOutsideHandler1&&(this.contextMenuOutsideHandler1.remove(),this.contextMenuOutsideHandler1=null),this.contextMenuOutsideHandler2&&(this.contextMenuOutsideHandler2.remove(),this.contextMenuOutsideHandler2=null),this.touchOutsideHandler&&(this.touchOutsideHandler.remove(),this.touchOutsideHandler=null)}},{key:"createTwoChains",value:function(e){var t=this.props.children.props,r=this.props;return t[e]&&r[e]?this["fire".concat(e)]:t[e]||r[e]}},{key:"isClickToShow",value:function(){var e=this.props,t=e.action,r=e.showAction;return-1!==t.indexOf("click")||-1!==r.indexOf("click")}},{key:"isContextMenuToShow",value:function(){var e=this.props,t=e.action,r=e.showAction;return-1!==t.indexOf("contextMenu")||-1!==r.indexOf("contextMenu")}},{key:"isClickToHide",value:function(){var e=this.props,t=e.action,r=e.hideAction;return-1!==t.indexOf("click")||-1!==r.indexOf("click")}},{key:"isMouseEnterToShow",value:function(){var e=this.props,t=e.action,r=e.showAction;return-1!==t.indexOf("hover")||-1!==r.indexOf("mouseEnter")}},{key:"isMouseLeaveToHide",value:function(){var e=this.props,t=e.action,r=e.hideAction;return-1!==t.indexOf("hover")||-1!==r.indexOf("mouseLeave")}},{key:"isFocusToShow",value:function(){var e=this.props,t=e.action,r=e.showAction;return-1!==t.indexOf("focus")||-1!==r.indexOf("focus")}},{key:"isBlurToHide",value:function(){var e=this.props,t=e.action,r=e.hideAction;return-1!==t.indexOf("focus")||-1!==r.indexOf("blur")}},{key:"forcePopupAlign",value:function(){this.state.popupVisible&&this.popupRef.current&&this.popupRef.current.alignRef.current&&this.popupRef.current.alignRef.current.forceAlign()}},{key:"fireEvents",value:function(e,t){var r=this.props.children.props[e];r&&r(t);var n=this.props[e];n&&n(t)}},{key:"close",value:function(){this.setPopupVisible(!1)}},{key:"render",value:function(){var e=this.state.popupVisible,t=this.props,r=t.children,n=t.forceRender,i=t.alignPoint,a=t.className,l=t.autoDestroy,u=o().Children.only(r),c={key:"trigger"};this.isContextMenuToShow()?c.onContextMenu=this.onContextMenu:c.onContextMenu=this.createTwoChains("onContextMenu"),this.isClickToHide()||this.isClickToShow()?(c.onClick=this.onClick,c.onMouseDown=this.onMouseDown,c.onTouchStart=this.onTouchStart):(c.onClick=this.createTwoChains("onClick"),c.onMouseDown=this.createTwoChains("onMouseDown"),c.onTouchStart=this.createTwoChains("onTouchStart")),this.isMouseEnterToShow()?(c.onMouseEnter=this.onMouseEnter,i&&(c.onMouseMove=this.onMouseMove)):c.onMouseEnter=this.createTwoChains("onMouseEnter"),this.isMouseLeaveToHide()?c.onMouseLeave=this.onMouseLeave:c.onMouseLeave=this.createTwoChains("onMouseLeave"),this.isFocusToShow()||this.isBlurToHide()?(c.onFocus=this.onFocus,c.onBlur=this.onBlur):(c.onFocus=this.createTwoChains("onFocus"),c.onBlur=this.createTwoChains("onBlur"));var d=C()(u&&u.props&&u.props.className,a);d&&(c.className=d);var f,p,g,v,h=s({},c);f=u,("function"!=typeof(v=(0,S.isMemo)(f)?f.type.type:f.type)||null!==(p=v.prototype)&&void 0!==p&&p.render||v.$$typeof===S.ForwardRef)&&("function"!=typeof f||null!==(g=f.prototype)&&void 0!==g&&g.render||f.$$typeof===S.ForwardRef)&&(h.ref=_(this.triggerRef,u.ref));var m,y=o().cloneElement(u,h);return(e||this.popupRef.current||n)&&(m=o().createElement(ar,{key:"portal",getContainer:this.getContainer,didUpdate:this.handlePortalUpdate},this.getComponent())),!e&&l&&(m=null),o().createElement(rr.Provider,{value:{onPopupMouseDown:this.onPopupMouseDown}},y,m)}}],[{key:"getDerivedStateFromProps",value:function(e,t){var r=e.popupVisible,n={};return void 0!==r&&t.popupVisible!==r&&(n.popupVisible=r,n.prevPopupVisible=t.popupVisible),n}}]),r}(o().Component),lr.contextType=rr,lr.defaultProps={prefixCls:"rc-trigger-popup",getPopupClassNameFromAlign:function(){return""},getDocument:function(){return window.document},onPopupVisibleChange:nr,afterPopupVisibleChange:nr,onPopupAlign:nr,popupClassName:"",mouseEnterDelay:0,mouseLeaveDelay:.1,focusDelay:0,blurDelay:.15,popupStyle:{},destroyPopupOnHide:!1,popupAlign:{},defaultPopupVisible:!1,mask:!1,maskClosable:!0,action:[],showAction:[],hideAction:[],autoDestroy:!1},lr);var ar,lr,ur=r(20567),sr=r.n(ur),cr={MAC_ENTER:3,BACKSPACE:8,TAB:9,NUM_CENTER:12,ENTER:13,SHIFT:16,CTRL:17,ALT:18,PAUSE:19,CAPS_LOCK:20,ESC:27,SPACE:32,PAGE_UP:33,PAGE_DOWN:34,END:35,HOME:36,LEFT:37,UP:38,RIGHT:39,DOWN:40,PRINT_SCREEN:44,INSERT:45,DELETE:46,ZERO:48,ONE:49,TWO:50,THREE:51,FOUR:52,FIVE:53,SIX:54,SEVEN:55,EIGHT:56,NINE:57,QUESTION_MARK:63,A:65,B:66,C:67,D:68,E:69,F:70,G:71,H:72,I:73,J:74,K:75,L:76,M:77,N:78,O:79,P:80,Q:81,R:82,S:83,T:84,U:85,V:86,W:87,X:88,Y:89,Z:90,META:91,WIN_KEY_RIGHT:92,CONTEXT_MENU:93,NUM_ZERO:96,NUM_ONE:97,NUM_TWO:98,NUM_THREE:99,NUM_FOUR:100,NUM_FIVE:101,NUM_SIX:102,NUM_SEVEN:103,NUM_EIGHT:104,NUM_NINE:105,NUM_MULTIPLY:106,NUM_PLUS:107,NUM_MINUS:109,NUM_PERIOD:110,NUM_DIVISION:111,F1:112,F2:113,F3:114,F4:115,F5:116,F6:117,F7:118,F8:119,F9:120,F10:121,F11:122,F12:123,NUMLOCK:144,SEMICOLON:186,DASH:189,EQUALS:187,COMMA:188,PERIOD:190,SLASH:191,APOSTROPHE:192,SINGLE_QUOTE:222,OPEN_SQUARE_BRACKET:219,BACKSLASH:220,CLOSE_SQUARE_BRACKET:221,WIN_KEY:224,MAC_FF_META:224,WIN_IME:229,isTextModifyingKeyEvent:function(e){var t=e.keyCode;if(e.altKey&&!e.ctrlKey||e.metaKey||t>=cr.F1&&t<=cr.F12)return!1;switch(t){case cr.ALT:case cr.CAPS_LOCK:case cr.CONTEXT_MENU:case cr.CTRL:case cr.DOWN:case cr.END:case cr.ESC:case cr.HOME:case cr.INSERT:case cr.LEFT:case cr.MAC_FF_META:case cr.META:case cr.NUMLOCK:case cr.NUM_CENTER:case cr.PAGE_DOWN:case cr.PAGE_UP:case cr.PAUSE:case cr.PRINT_SCREEN:case cr.RIGHT:case cr.SHIFT:case cr.UP:case cr.WIN_KEY:case cr.WIN_KEY_RIGHT:return!1;default:return!0}},isCharacterKey:function(e){if(e>=cr.ZERO&&e<=cr.NINE)return!0;if(e>=cr.NUM_ZERO&&e<=cr.NUM_MULTIPLY)return!0;if(e>=cr.A&&e<=cr.Z)return!0;if(-1!==window.navigator.userAgent.indexOf("WebKit")&&0===e)return!0;switch(e){case cr.SPACE:case cr.QUESTION_MARK:case cr.NUM_PLUS:case cr.NUM_MINUS:case cr.NUM_PERIOD:case cr.NUM_DIVISION:case cr.SEMICOLON:case cr.DASH:case cr.EQUALS:case cr.COMMA:case cr.PERIOD:case cr.SLASH:case cr.APOSTROPHE:case cr.SINGLE_QUOTE:case cr.OPEN_SQUARE_BRACKET:case cr.BACKSLASH:case cr.CLOSE_SQUARE_BRACKET:return!0;default:return!1}}};const dr=cr;var fr=r(442),pr=r.n(fr);function gr(e){return gr="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},gr(e)}function vr(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function hr(e){return hr=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},hr(e)}function mr(e,t){return mr=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},mr(e,t)}var yr=function(e){function t(){var e;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,t),(e=function(e,t){return!t||"object"!==gr(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}(this,hr(t).apply(this,arguments))).menuItems={},e.saveMenuItem=function(t){return function(r){e.menuItems[t]=r}},e}var r,o;return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&mr(e,t)}(t,e),r=t,o=[{key:"componentDidMount",value:function(){this.scrollActiveItemToView()}},{key:"componentDidUpdate",value:function(e){!e.visible&&this.props.visible&&this.scrollActiveItemToView()}},{key:"getFieldName",value:function(e){var t=this.props,r=t.fieldNames,n=t.defaultFieldNames;return r[e]||n[e]}},{key:"getOption",value:function(e,t){var r=this.props,o=r.prefixCls,i=r.expandTrigger,a=r.expandIcon,l=r.loadingIcon,u=this.props.onSelect.bind(this,e,t),s={onClick:u,onDoubleClick:this.props.onItemDoubleClick.bind(this,e,t)},c="".concat(o,"-menu-item"),d=null,f=e[this.getFieldName("children")]&&e[this.getFieldName("children")].length>0;(f||!1===e.isLeaf)&&(c+=" ".concat(o,"-menu-item-expand"),e.loading||(d=n.createElement("span",{className:"".concat(o,"-menu-item-expand-icon")},a))),"hover"!==i||!f&&!1!==e.isLeaf||(s={onMouseEnter:this.delayOnSelect.bind(this,u),onMouseLeave:this.delayOnSelect.bind(this),onClick:u}),this.isActiveOption(e,t)&&(c+=" ".concat(o,"-menu-item-active"),s.ref=this.saveMenuItem(t)),e.disabled&&(c+=" ".concat(o,"-menu-item-disabled"));var p=null;e.loading&&(c+=" ".concat(o,"-menu-item-loading"),p=l||null);var g="";return"title"in e?g=e.title:"string"==typeof e[this.getFieldName("label")]&&(g=e[this.getFieldName("label")]),n.createElement("li",Object.assign({key:e[this.getFieldName("value")],className:c,title:g},s,{role:"menuitem",onMouseDown:function(e){return e.preventDefault()}}),e[this.getFieldName("label")],d,p)}},{key:"getActiveOptions",value:function(e){var t=this,r=this.props.options,n=e||this.props.activeValue;return pr()(r,(function(e,r){return e[t.getFieldName("value")]===n[r]}),{childrenKeyName:this.getFieldName("children")})}},{key:"getShowOptions",value:function(){var e=this,t=this.props.options,r=this.getActiveOptions().map((function(t){return t[e.getFieldName("children")]})).filter((function(e){return!!e}));return r.unshift(t),r}},{key:"delayOnSelect",value:function(e){for(var t=this,r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];this.delayTimer&&(clearTimeout(this.delayTimer),this.delayTimer=null),"function"==typeof e&&(this.delayTimer=window.setTimeout((function(){e(n),t.delayTimer=null}),150))}},{key:"scrollActiveItemToView",value:function(){for(var e=this.getShowOptions().length,t=0;t<e;t++){var r=this.menuItems[t];r&&r.parentElement&&(r.parentElement.scrollTop=r.offsetTop)}}},{key:"isActiveOption",value:function(e,t){var r=this.props.activeValue;return(void 0===r?[]:r)[t]===e[this.getFieldName("value")]}},{key:"render",value:function(){var e=this,t=this.props,r=t.prefixCls,o=t.dropdownMenuColumnStyle;return n.createElement("div",null,this.getShowOptions().map((function(t,i){return n.createElement("ul",{className:"".concat(r,"-menu"),key:i,style:o},t.map((function(t){return e.getOption(t,i)})))})))}}],o&&vr(r.prototype,o),t}(n.Component);yr.defaultProps={options:[],value:[],activeValue:[],onSelect:function(){},prefixCls:"rc-cascader-menus",visible:!1,expandTrigger:"click"};const br=yr;function Er(e){return Er="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},Er(e)}function Or(e){return function(e){if(Array.isArray(e)){for(var t=0,r=new Array(e.length);t<e.length;t++)r[t]=e[t];return r}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}function Sr(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function _r(e){return _r=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},_r(e)}function wr(e,t){return wr=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},wr(e,t)}var Tr=function(e){function t(e){var r;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,t),(r=function(e,t){return!t||"object"!==Er(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}(this,_r(t).call(this,e))).setPopupVisible=function(e){var t=r.state.value;"popupVisible"in r.props||r.setState({popupVisible:e}),e&&!r.state.popupVisible&&r.setState({activeValue:t}),r.props.onPopupVisibleChange(e)},r.handleChange=function(e,t,n){var o=t.visible;"keydown"===n.type&&n.keyCode!==dr.ENTER||(r.props.onChange(e.map((function(e){return e[r.getFieldName("value")]})),e),r.setPopupVisible(o))},r.handlePopupVisibleChange=function(e){r.setPopupVisible(e)},r.handleMenuSelect=function(e,t,n){var o=r.trigger.getRootDomNode();o&&o.focus&&o.focus();var i=r.props,a=i.changeOnSelect,l=i.loadData,u=i.expandTrigger;if(e&&!e.disabled){var s=r.state.activeValue;(s=s.slice(0,t+1))[t]=e[r.getFieldName("value")];var c=r.getActiveOptions(s);if(!1===e.isLeaf&&!e[r.getFieldName("children")]&&l)return a&&r.handleChange(c,{visible:!0},n),r.setState({activeValue:s}),void l(c);var d={};e[r.getFieldName("children")]&&e[r.getFieldName("children")].length?!a||"click"!==n.type&&"keydown"!==n.type||("hover"===u?r.handleChange(c,{visible:!1},n):r.handleChange(c,{visible:!0},n),d.value=s):(r.handleChange(c,{visible:!1},n),d.value=s),d.activeValue=s,("value"in r.props||"keydown"===n.type&&n.keyCode!==dr.ENTER)&&delete d.value,r.setState(d)}},r.handleItemDoubleClick=function(){r.props.changeOnSelect&&r.setPopupVisible(!1)},r.handleKeyDown=function(e){var t=r.props.children;if(t&&t.props.onKeyDown)t.props.onKeyDown(e);else{var n=Or(r.state.activeValue),o=n.length-1<0?0:n.length-1,i=r.getCurrentLevelOptions(),a=i.map((function(e){return e[r.getFieldName("value")]})).indexOf(n[o]);if(e.keyCode===dr.DOWN||e.keyCode===dr.UP||e.keyCode===dr.LEFT||e.keyCode===dr.RIGHT||e.keyCode===dr.ENTER||e.keyCode===dr.SPACE||e.keyCode===dr.BACKSPACE||e.keyCode===dr.ESC||e.keyCode===dr.TAB)if(r.state.popupVisible||e.keyCode===dr.BACKSPACE||e.keyCode===dr.LEFT||e.keyCode===dr.RIGHT||e.keyCode===dr.ESC||e.keyCode===dr.TAB){if(e.keyCode===dr.DOWN||e.keyCode===dr.UP){e.preventDefault();var l=a;l=-1!==l?e.keyCode===dr.DOWN?(l+=1)>=i.length?0:l:(l-=1)<0?i.length-1:l:0,n[o]=i[l][r.getFieldName("value")]}else if(e.keyCode===dr.LEFT||e.keyCode===dr.BACKSPACE)e.preventDefault(),n.splice(n.length-1,1);else if(e.keyCode===dr.RIGHT)e.preventDefault(),i[a]&&i[a][r.getFieldName("children")]&&n.push(i[a][r.getFieldName("children")][0][r.getFieldName("value")]);else if(e.keyCode===dr.ESC||e.keyCode===dr.TAB)return void r.setPopupVisible(!1);n&&0!==n.length||r.setPopupVisible(!1);var u=r.getActiveOptions(n),s=u[u.length-1];r.handleMenuSelect(s,u.length-1,e),r.props.onKeyDown&&r.props.onKeyDown(e)}else r.setPopupVisible(!0)}},r.saveTrigger=function(e){r.trigger=e};var n=[];return"value"in e?n=e.value||[]:"defaultValue"in e&&(n=e.defaultValue||[]),sr()(!("filedNames"in e),"`filedNames` of Cascader is a typo usage and deprecated, please use `fieldNames` instead."),r.state={popupVisible:e.popupVisible,activeValue:n,value:n,prevProps:e},r.defaultFieldNames={label:"label",value:"value",children:"children"},r}var r,o,i;return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&wr(e,t)}(t,e),r=t,i=[{key:"getDerivedStateFromProps",value:function(e,t){var r=t.prevProps,n={prevProps:e};return"value"in e&&!function(e,t){if(e===t)return!0;if(!e||!t)return!1;var r=e.length;if(t.length!==r)return!1;for(var n=0;n<r;n++)if(e[n]!==t[n])return!1;return!0}((void 0===r?{}:r).value,e.value)&&(n.value=e.value||[],"loadData"in e||(n.activeValue=e.value||[])),"popupVisible"in e&&(n.popupVisible=e.popupVisible),n}}],(o=[{key:"getPopupDOMNode",value:function(){return this.trigger.getPopupDomNode()}},{key:"getFieldName",value:function(e){var t=this.defaultFieldNames,r=this.props,n=r.fieldNames,o=r.filedNames;return"filedNames"in this.props?o[e]||t[e]:n[e]||t[e]}},{key:"getFieldNames",value:function(){var e=this.props,t=e.fieldNames,r=e.filedNames;return"filedNames"in this.props?r:t}},{key:"getCurrentLevelOptions",value:function(){var e=this,t=this.props.options,r=void 0===t?[]:t,n=this.state.activeValue,o=void 0===n?[]:n,i=pr()(r,(function(t,r){return t[e.getFieldName("value")]===o[r]}),{childrenKeyName:this.getFieldName("children")});return i[i.length-2]?i[i.length-2][this.getFieldName("children")]:Or(r).filter((function(e){return!e.disabled}))}},{key:"getActiveOptions",value:function(e){var t=this;return pr()(this.props.options||[],(function(r,n){return r[t.getFieldName("value")]===e[n]}),{childrenKeyName:this.getFieldName("children")})}},{key:"render",value:function(){var e=this.props,t=e.prefixCls,r=e.transitionName,o=e.popupClassName,i=e.options,a=void 0===i?[]:i,l=e.disabled,u=e.builtinPlacements,s=e.popupPlacement,c=e.children,d=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["prefixCls","transitionName","popupClassName","options","disabled","builtinPlacements","popupPlacement","children"]),f=n.createElement("div",null),p="";return a&&a.length>0?f=n.createElement(br,Object.assign({},this.props,{fieldNames:this.getFieldNames(),defaultFieldNames:this.defaultFieldNames,activeValue:this.state.activeValue,onSelect:this.handleMenuSelect,onItemDoubleClick:this.handleItemDoubleClick,visible:this.state.popupVisible})):p=" ".concat(t,"-menus-empty"),n.createElement(ir,Object.assign({ref:this.saveTrigger},d,{popupPlacement:s,builtinPlacements:u,popupTransitionName:r,action:l?[]:["click"],popupVisible:!l&&this.state.popupVisible,onPopupVisibleChange:this.handlePopupVisibleChange,prefixCls:"".concat(t,"-menus"),popupClassName:o+p,popup:f}),n.cloneElement(c,{onKeyDown:this.handleKeyDown,tabIndex:l?void 0:0}))}}])&&Sr(r.prototype,o),i&&Sr(r,i),t}(n.Component);Tr.defaultProps={onChange:function(){},onPopupVisibleChange:function(){},disabled:!1,transitionName:"",prefixCls:"rc-cascader",popupClassName:"",popupPlacement:"bottomLeft",builtinPlacements:{bottomLeft:{points:["tl","bl"],offset:[0,4],overflow:{adjustX:1,adjustY:1}},topLeft:{points:["bl","tl"],offset:[0,-4],overflow:{adjustX:1,adjustY:1}},bottomRight:{points:["tr","br"],offset:[0,4],overflow:{adjustX:1,adjustY:1}},topRight:{points:["br","tr"],offset:[0,-4],overflow:{adjustX:1,adjustY:1}}},expandTrigger:"click",fieldNames:{label:"label",value:"value",children:"children"},expandIcon:">"};const Pr=Tr},3044:(e,t)=>{"use strict";var r=Symbol.for("react.element"),n=Symbol.for("react.portal"),o=Symbol.for("react.fragment"),i=Symbol.for("react.strict_mode"),a=Symbol.for("react.profiler"),l=Symbol.for("react.provider"),u=Symbol.for("react.context"),s=Symbol.for("react.server_context"),c=Symbol.for("react.forward_ref"),d=Symbol.for("react.suspense"),f=Symbol.for("react.suspense_list"),p=Symbol.for("react.memo"),g=Symbol.for("react.lazy");Symbol.for("react.offscreen");Symbol.for("react.module.reference"),t.isFragment=function(e){return function(e){if("object"==typeof e&&null!==e){var t=e.$$typeof;switch(t){case r:switch(e=e.type){case o:case a:case i:case d:case f:return e;default:switch(e=e&&e.$$typeof){case s:case u:case c:case g:case p:case l:return e;default:return t}}case n:return t}}}(e)===o}},57128:(e,t,r)=>{"use strict";e.exports=r(3044)},92290:(e,t)=>{"use strict";var r=Symbol.for("react.element"),n=Symbol.for("react.portal"),o=Symbol.for("react.fragment"),i=Symbol.for("react.strict_mode"),a=Symbol.for("react.profiler"),l=Symbol.for("react.provider"),u=Symbol.for("react.context"),s=Symbol.for("react.server_context"),c=Symbol.for("react.forward_ref"),d=Symbol.for("react.suspense"),f=Symbol.for("react.suspense_list"),p=Symbol.for("react.memo"),g=Symbol.for("react.lazy");Symbol.for("react.offscreen");function v(e){if("object"==typeof e&&null!==e){var t=e.$$typeof;switch(t){case r:switch(e=e.type){case o:case a:case i:case d:case f:return e;default:switch(e=e&&e.$$typeof){case s:case u:case c:case g:case p:case l:return e;default:return t}}case n:return t}}}Symbol.for("react.module.reference"),t.ForwardRef=c,t.isFragment=function(e){return v(e)===o},t.isMemo=function(e){return v(e)===p}},24958:(e,t,r)=>{"use strict";e.exports=r(92290)},48746:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666).__importDefault(r(18001));t.default=function(e){return e.prototype?e:n.default(e)}},47615:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.divWrapper=void 0;var n=r(91666),o=n.__importStar(r(85959)),i=n.__importDefault(r(48746)),a=o.createElement,l=function(e,t,r,o){var i;return a(e,t?n.__assign(((i={})[t]=o,i),r):n.__assign(n.__assign({},o),r))};t.divWrapper=function(e,t,r,n){return a("div",null,l(e,t,r,n))},t.default=function(e,t,r){void 0===r&&(r=l);var n=function(o,l,u){void 0===l&&(l=t),void 0===u&&(u=null);var s="string"==typeof o;if(s)return function(e){return n(e,o||t,l)};var c=function(t){return a(e,u,(function(e){return r(o,l,t,e)}))};return s?i.default(c):c};return n}},520:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666).__importDefault(r(74027)),o=function(e){return[e]};t.default=function(e,t){return void 0===t&&(t=o),function(r){return n.default(r,e.apply(void 0,t(r)))}}},13167:(e,t,r)=>{"use strict";var n=r(91666);n.__importDefault(r(74027)).default,n.__importDefault(r(47615)).default,n.__importDefault(r(520)).default},74027:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666),o=r(85959),i=parseInt(o.version.substr(0,o.version.indexOf(".")))>15;t.default=function(e,t){for(var r=[],a=2;a<arguments.length;a++)r[a-2]=arguments[a];var l=e.render,u=e.children,s=void 0===u?l:u,c=e.component,d=e.comp,f=void 0===d?c:d;return"function"==typeof s?s.apply(void 0,n.__spreadArrays([t],r)):f?o.createElement(f,t):s instanceof Array?i?s:o.createElement.apply(void 0,n.__spreadArrays(["div",null],s)):s&&s instanceof Object?"string"==typeof s.type?s:o.cloneElement(s,Object.assign({},s.props,t)):s||null}},18001:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666),o=n.__importStar(r(85959));t.default=function(e){var t=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return n.__extends(r,t),r.prototype.render=function(){return e(this.props,this.context)},r}(o.Component);return t}},78131:(e,t,r)=>{"use strict";r.r(t),r.d(t,{createBreakpoint:()=>xe,createGlobalState:()=>vr,createMemo:()=>o,createReducer:()=>u,createReducerContext:()=>i,createStateContext:()=>s,ensuredForwardRef:()=>ue,useAsync:()=>p,useAsyncFn:()=>f,useAsyncRetry:()=>g,useAudio:()=>y,useBattery:()=>C,useBeforeUnload:()=>I,useBoolean:()=>x,useClickAway:()=>D,useCookie:()=>M,useCopyToClipboard:()=>q,useCounter:()=>G,useCss:()=>J,useCustomCompareEffect:()=>Z,useDebounce:()=>te,useDeepCompareEffect:()=>re,useDefault:()=>ne,useDrop:()=>oe,useDropArea:()=>ie,useEffectOnce:()=>ae,useEnsuredForwardedRef:()=>le,useError:()=>pe,useEvent:()=>fe,useFavicon:()=>ge,useFirstMountState:()=>a,useFullscreen:()=>me,useGeolocation:()=>ye,useGetSet:()=>W,useGetSetState:()=>be,useHarmonicIntervalFn:()=>Se,useHash:()=>hr,useHover:()=>we,useHoverDirty:()=>Te,useIdle:()=>Ce,useIntersection:()=>Ie,useInterval:()=>Ae,useIsomorphicLayoutEffect:()=>Y,useKey:()=>Re,useKeyPress:()=>Ne,useKeyPressEvent:()=>De,useLatest:()=>Le,useLifecycles:()=>je,useList:()=>Me,useLocalStorage:()=>ke,useLocation:()=>Be,useLockBodyScroll:()=>ze,useLogger:()=>Ye,useLongPress:()=>Xe,useMap:()=>Je,useMeasure:()=>fr,useMedia:()=>Ze,useMediaDevices:()=>et,useMediatedState:()=>tt,useMethods:()=>rt,useMotion:()=>ot,useMount:()=>it,useMountedState:()=>d,useMouse:()=>ut,useMouseHovered:()=>ct,useMouseWheel:()=>dt,useMultiStateValidator:()=>ur,useNetworkState:()=>vt,useNumber:()=>ht,useObservable:()=>mt,useOrientation:()=>bt,usePageLeave:()=>Et,usePermission:()=>Ot,usePrevious:()=>St,usePreviousDistinct:()=>wt,usePromise:()=>Tt,useQueue:()=>Pt,useRaf:()=>Ct,useRafLoop:()=>It,useRafState:()=>lt,useRendersCount:()=>pr,useScratch:()=>xt,useScroll:()=>Nt,useScrollbarWidth:()=>lr,useScrolling:()=>Dt,useSearchParam:()=>Rt,useSessionStorage:()=>Lt,useSet:()=>gr,useSetState:()=>v,useShallowCompareEffect:()=>kt,useSize:()=>Bt,useSlider:()=>Ut,useSpeech:()=>Gt,useStartTyping:()=>Ht,useStateList:()=>$t,useStateValidator:()=>ir,useStateWithHistory:()=>Kt,useThrottle:()=>zt,useThrottleFn:()=>Yt,useTimeout:()=>Qt,useTimeoutFn:()=>ee,useTitle:()=>Jt,useToggle:()=>R,useTween:()=>er,useUnmount:()=>at,useUnmountPromise:()=>tr,useUpdate:()=>B,useUpdateEffect:()=>l,useUpsert:()=>rr,useVibrate:()=>nr,useVideo:()=>or,useWindowScroll:()=>sr,useWindowSize:()=>cr});var n=r(85959);const o=function(e){return function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];return(0,n.useMemo)((function(){return e.apply(void 0,t)}),t)}},i=function(e,t){var r=(0,n.createContext)(void 0);return[function(){var e=(0,n.useContext)(r);if(null==e)throw new Error("useReducerContext must be used inside a ReducerProvider.");return e},function(o){var i=o.children,a=o.initialState;return function(e,t){return(0,n.createElement)(r.Provider,e,t)}({value:(0,n.useReducer)(e,void 0!==a?a:t)},i)},r]};function a(){var e=(0,n.useRef)(!0);return e.current?(e.current=!1,!0):e.current}const l=function(e,t){var r=a();(0,n.useEffect)((function(){if(!r)return e()}),t)},u=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r,o=(r=e,function(e,t){return r.reduceRight((function(t,r){return r(e)(t)}),t)});return function(e,t,r){void 0===r&&(r=function(e){return e});var i=(0,n.useRef)(r(t)),a=(0,n.useState)(i.current)[1],u=(0,n.useCallback)((function(t){return i.current=e(i.current,t),a(i.current),t}),[e]),s=(0,n.useRef)(o({getState:function(){return i.current},dispatch:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return s.current.apply(s,e)}},u));return l((function(){s.current=o({getState:function(){return i.current},dispatch:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return s.current.apply(s,e)}},u)}),[u]),[i.current,s.current]}},s=function(e){var t=(0,n.createContext)(void 0);return[function(){var e=(0,n.useContext)(t);if(null==e)throw new Error("useStateContext must be used inside a StateProvider.");return e},function(r){var o=r.children,i=r.initialValue;return function(e,r){return(0,n.createElement)(t.Provider,e,r)}({value:(0,n.useState)(void 0!==i?i:e)},o)},t]};var c=r(91666);function d(){var e=(0,n.useRef)(!1),t=(0,n.useCallback)((function(){return e.current}),[]);return(0,n.useEffect)((function(){return e.current=!0,function(){e.current=!1}}),[]),t}function f(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var o=(0,n.useRef)(0),i=d(),a=(0,n.useState)(r),l=a[0],u=a[1],s=(0,n.useCallback)((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var n=++o.current;return l.loading||u((function(e){return(0,c.__assign)((0,c.__assign)({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return i()&&n===o.current&&u({value:e,loading:!1}),e}),(function(e){return i()&&n===o.current&&u({error:e,loading:!1}),e}))}),t);return[l,s]}function p(e,t){void 0===t&&(t=[]);var r=f(e,t,{loading:!0}),o=r[0],i=r[1];return(0,n.useEffect)((function(){i()}),[i]),o}const g=function(e,t){void 0===t&&(t=[]);var r=(0,n.useState)(0),o=r[0],i=r[1],a=p(e,(0,c.__spreadArrays)(t,[o])),l=a.loading,u=(0,n.useCallback)((function(){l||i((function(e){return e+1}))}),(0,c.__spreadArrays)(t,[l]));return(0,c.__assign)((0,c.__assign)({},a),{retry:u})},v=function(e){void 0===e&&(e={});var t=(0,n.useState)(e),r=t[0],o=t[1];return[r,(0,n.useCallback)((function(e){o((function(t){return Object.assign({},t,e instanceof Function?e(t):e)}))}),[])]};function h(e){for(var t=[],r=0;r<e.length;r++)t.push({start:e.start(r),end:e.end(r)});return t}function m(e){return function(t){var r,o;o=n.isValidElement(t)?(r=t).props:t;var i=v({buffered:[],time:0,duration:0,paused:!0,muted:!1,volume:1,playing:!1}),a=i[0],l=i[1],u=(0,n.useRef)(null),s=function(e,t){return function(r){try{t&&t(r)}finally{e&&e(r)}}},d=function(){return l({paused:!1})},f=function(){return l({playing:!0})},p=function(){return l({playing:!1})},g=function(){return l({paused:!0,playing:!1})},m=function(){var e=u.current;e&&l({muted:e.muted,volume:e.volume})},y=function(){var e=u.current;if(e){var t=e.duration,r=e.buffered;l({duration:t,buffered:h(r)})}},b=function(){var e=u.current;e&&l({time:e.currentTime})},E=function(){var e=u.current;e&&l({buffered:h(e.buffered)})};r=r?n.cloneElement(r,(0,c.__assign)((0,c.__assign)({controls:!1},o),{ref:u,onPlay:s(o.onPlay,d),onPlaying:s(o.onPlaying,f),onWaiting:s(o.onWaiting,p),onPause:s(o.onPause,g),onVolumeChange:s(o.onVolumeChange,m),onDurationChange:s(o.onDurationChange,y),onTimeUpdate:s(o.onTimeUpdate,b),onProgress:s(o.onProgress,E)})):n.createElement(e,(0,c.__assign)((0,c.__assign)({controls:!1},o),{ref:u,onPlay:s(o.onPlay,d),onPlaying:s(o.onPlaying,f),onWaiting:s(o.onWaiting,p),onPause:s(o.onPause,g),onVolumeChange:s(o.onVolumeChange,m),onDurationChange:s(o.onDurationChange,y),onTimeUpdate:s(o.onTimeUpdate,b),onProgress:s(o.onProgress,E)}));var O=!1,S={play:function(){var e=u.current;if(e&&!O){var t=e.play();if("object"==typeof t){O=!0;var r=function(){O=!1};t.then(r,r)}return t}},pause:function(){var e=u.current;if(e&&!O)return e.pause()},seek:function(e){var t=u.current;t&&void 0!==a.duration&&(e=Math.min(a.duration,Math.max(0,e)),t.currentTime=e)},volume:function(e){var t=u.current;t&&(e=Math.min(1,Math.max(0,e)),t.volume=e,l({volume:e}))},mute:function(){var e=u.current;e&&(e.muted=!0)},unmute:function(){var e=u.current;e&&(e.muted=!1)}};return(0,n.useEffect)((function(){var e=u.current;e&&(l({volume:e.volume,muted:e.muted,paused:e.paused}),o.autoPlay&&e.paused&&S.play())}),[o.src]),[r,a,S,u]}}const y=m("audio");var b=function(){};function E(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];e&&e.addEventListener&&e.addEventListener.apply(e,t)}function O(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];e&&e.removeEventListener&&e.removeEventListener.apply(e,t)}var S="undefined"!=typeof window,_="undefined"!=typeof navigator,w=r(92194);const T=r.n(w)();var P=_?navigator:void 0;const C=P&&"function"==typeof P.getBattery?function(){var e=(0,n.useState)({isSupported:!0,fetched:!1}),t=e[0],r=e[1];return(0,n.useEffect)((function(){var e=!0,n=null,o=function(){if(e&&n){var o={isSupported:!0,fetched:!0,level:n.level,charging:n.charging,dischargingTime:n.dischargingTime,chargingTime:n.chargingTime};!T(t,o)&&r(o)}};return P.getBattery().then((function(t){e&&(E(n=t,"chargingchange",o),E(n,"chargingtimechange",o),E(n,"dischargingtimechange",o),E(n,"levelchange",o),o())})),function(){e=!1,n&&(O(n,"chargingchange",o),O(n,"chargingtimechange",o),O(n,"dischargingtimechange",o),O(n,"levelchange",o))}}),[]),t}:function(){return{isSupported:!1}},I=function(e,t){void 0===e&&(e=!0);var r=(0,n.useCallback)((function(r){if("function"!=typeof e||e())return r.preventDefault(),t&&(r.returnValue=t),t}),[e,t]);(0,n.useEffect)((function(){if(e)return E(window,"beforeunload",r),function(){return O(window,"beforeunload",r)}}),[e,r])};var A=function(e,t){return"boolean"==typeof t?t:!e};const R=function(e){return(0,n.useReducer)(A,e)},x=R;var N=["mousedown","touchstart"];const D=function(e,t,r){void 0===r&&(r=N);var o=(0,n.useRef)(t);(0,n.useEffect)((function(){o.current=t}),[t]),(0,n.useEffect)((function(){for(var t=function(t){var r=e.current;r&&!r.contains(t.target)&&o.current(t)},n=0,i=r;n<i.length;n++){var a=i[n];E(document,a,t)}return function(){for(var e=0,n=r;e<n.length;e++){var o=n[e];O(document,o,t)}}}),[r,e])};var L=r(92299),j=r.n(L);const M=function(e){var t=(0,n.useState)((function(){return j().get(e)||null})),r=t[0],o=t[1];return[r,(0,n.useCallback)((function(t,r){j().set(e,t,r),o(t)}),[e]),(0,n.useCallback)((function(){j().remove(e),o(null)}),[e])]};var k=r(35489),F=r.n(k);const q=function(){var e=d(),t=v({value:void 0,error:void 0,noUserInteraction:!0}),r=t[0],o=t[1];return[r,(0,n.useCallback)((function(t){var r,n;if(e())try{if("string"!=typeof t&&"number"!=typeof t){var i=new Error("Cannot copy typeof "+typeof t+" to clipboard, must be a string");return void o({value:t,error:i,noUserInteraction:!0})}if(""===t)return i=new Error("Cannot copy empty string to clipboard."),void o({value:t,error:i,noUserInteraction:!0});n=t.toString(),r=F()(n),o({value:n,error:void 0,noUserInteraction:r})}catch(i){o({value:n,error:i,noUserInteraction:r})}}),[])]};var V=function(e){return(e+1)%1e6};function B(){return(0,n.useReducer)(V,0)[1]}function U(e,t){return"function"==typeof e?e.length?e(t):e():e}function W(e){var t=(0,n.useRef)(U(e)),r=B();return(0,n.useMemo)((function(){return[function(){return t.current},function(e){t.current=U(e,t.current),r()}]}),[])}function G(e,t,r){void 0===e&&(e=0),void 0===t&&(t=null),void 0===r&&(r=null);var o=U(e);"number"!=typeof o&&console.error("initialValue has to be a number, got "+typeof e),"number"==typeof r?o=Math.max(o,r):null!==r&&console.error("min has to be a number, got "+typeof r),"number"==typeof t?o=Math.min(o,t):null!==t&&console.error("max has to be a number, got "+typeof t);var i=W(o),a=i[0],l=i[1];return[a(),(0,n.useMemo)((function(){var e=function(e){var n=a(),o=U(e,n);n!==o&&("number"==typeof r&&(o=Math.max(o,r)),"number"==typeof t&&(o=Math.min(o,t)),n!==o&&l(o))};return{get:a,set:e,inc:function(t){void 0===t&&(t=1);var r=U(t,a());"number"!=typeof r&&console.error("delta has to be a number or function returning a number, got "+typeof r),e((function(e){return e+r}))},dec:function(t){void 0===t&&(t=1);var r=U(t,a());"number"!=typeof r&&console.error("delta has to be a number or function returning a number, got "+typeof r),e((function(e){return e-r}))},reset:function(t){void 0===t&&(t=o);var r=U(t,a());"number"!=typeof r&&console.error("value has to be a number or function returning a number, got "+typeof r),o=r,e(r)}}}),[o,r,t])]}var H=r(21433),K=r(80499),$=r(55463),z=r(46330);const Y=S?n.useLayoutEffect:n.useEffect;var Q=(0,H.v)();(0,K.v)(Q),(0,$.v)(Q);var X=0;const J=function(e){var t=(0,n.useMemo)((function(){return"react-use-css-"+(X++).toString(36)}),[]),r=(0,n.useMemo)((function(){return new Q.VSheet}),[]);return Y((function(){var n={};return(0,z.J)(n,e,"."+t,""),r.diff(n),function(){r.diff({})}})),t},Z=function(e,t,r){var o=(0,n.useRef)(void 0);o.current&&r(t,o.current)||(o.current=t),(0,n.useEffect)(e,o.current)};function ee(e,t){void 0===t&&(t=0);var r=(0,n.useRef)(!1),o=(0,n.useRef)(),i=(0,n.useRef)(e),a=(0,n.useCallback)((function(){return r.current}),[]),l=(0,n.useCallback)((function(){r.current=!1,o.current&&clearTimeout(o.current),o.current=setTimeout((function(){r.current=!0,i.current()}),t)}),[t]),u=(0,n.useCallback)((function(){r.current=null,o.current&&clearTimeout(o.current)}),[]);return(0,n.useEffect)((function(){i.current=e}),[e]),(0,n.useEffect)((function(){return l(),u}),[t]),[a,u,l]}function te(e,t,r){void 0===t&&(t=0),void 0===r&&(r=[]);var o=ee(e,t),i=o[0],a=o[1],l=o[2];return(0,n.useEffect)(l,r),[i,a]}const re=function(e,t){Z(e,t,T)},ne=function(e,t){var r=(0,n.useState)(t),o=r[0],i=r[1];return null==o?[e,i]:[o,i]},oe=function(e,t){void 0===e&&(e={}),void 0===t&&(t=[]);var r=e.onFiles,o=e.onText,i=e.onUri,a=(0,n.useState)(!1),l=a[0],u=a[1],s=(0,n.useCallback)(u,[]),d=(0,n.useMemo)((function(){return function(e){return function(t,r){var n=t.getData("text/uri-list");if(n)(e.onUri||b)(n,r);else if(t.files&&t.files.length)(e.onFiles||b)(Array.from(t.files),r);else if(r.clipboardData){var o=r.clipboardData.getData("text");(e.onText||b)(o,r)}}}(e)}),[r,o,i]);return(0,n.useEffect)((function(){var e=function(e){e.preventDefault(),s(!0)},t=function(e){e.preventDefault(),s(!0)},r=function(){s(!1)},n=function(){s(!1)},i=function(e){e.preventDefault(),s(!1),d(e.dataTransfer,e)},a=function(e){d(e.clipboardData,e)};return E(document,"dragover",e),E(document,"dragenter",t),E(document,"dragleave",r),E(document,"dragexit",n),E(document,"drop",i),o&&E(document,"paste",a),function(){O(document,"dragover",e),O(document,"dragenter",t),O(document,"dragleave",r),O(document,"dragexit",n),O(document,"drop",i),O(document,"paste",a)}}),(0,c.__spreadArrays)([d],t)),{over:l}},ie=function(e){void 0===e&&(e={});var t=e.onFiles,r=e.onText,o=e.onUri,i=d(),a=(0,n.useState)(!1),l=a[0],u=a[1],s=(0,n.useMemo)((function(){return function(e,t){return function(r,n){var o=r.getData("text/uri-list");o?(e.onUri||b)(o,n):r.files&&r.files.length?(e.onFiles||b)(Array.from(r.files),n):r.items&&r.items.length&&r.items[0].getAsString((function(r){t&&(e.onText||b)(r,n)}))}}(e,i())}),[t,r,o]),c=(0,n.useMemo)((function(){return function(e,t){return{onDragOver:function(e){e.preventDefault()},onDragEnter:function(e){e.preventDefault(),t(!0)},onDragLeave:function(){t(!1)},onDrop:function(r){r.preventDefault(),r.persist(),t(!1),e(r.dataTransfer,r)},onPaste:function(t){t.persist(),e(t.clipboardData,t)}}}(s,u)}),[s,u]);return[c,{over:l}]},ae=function(e){(0,n.useEffect)(e,[])};function le(e){var t=(0,n.useRef)(e&&e.current);return(0,n.useEffect)((function(){e&&(e.current=t.current)}),[e]),t}function ue(e){return(0,n.forwardRef)((function(t,r){var n=le(r);return e(t,n)}))}var se=S?window:null,ce=function(e){return!!e.addEventListener},de=function(e){return!!e.on};const fe=function(e,t,r,o){void 0===r&&(r=se),(0,n.useEffect)((function(){if(t&&r)return ce(r)?E(r,e,t,o):de(r)&&r.on(e,t,o),function(){ce(r)?O(r,e,t,o):de(r)&&r.off(e,t,o)}}),[e,t,r,JSON.stringify(o)])},pe=function(){var e=(0,n.useState)(null),t=e[0],r=e[1];return(0,n.useEffect)((function(){if(t)throw t}),[t]),(0,n.useCallback)((function(e){r(e)}),[])},ge=function(e){(0,n.useEffect)((function(){var t=document.querySelector("link[rel*='icon']")||document.createElement("link");t.type="image/x-icon",t.rel="shortcut icon",t.href=e,document.getElementsByTagName("head")[0].appendChild(t)}),[e])};var ve=r(6776),he=r.n(ve);const me=function(e,t,r){void 0===r&&(r={});var o=r.video,i=r.onClose,a=void 0===i?b:i,l=(0,n.useState)(t),u=l[0],s=l[1];return Y((function(){if(t&&e.current){var r=function(){(null==o?void 0:o.current)&&O(o.current,"webkitendfullscreen",r),a()},n=function(){if(he().isEnabled){var e=he().isFullscreen;s(e),e||a()}};if(he().isEnabled){try{he().request(e.current),s(!0)}catch(e){a(e),s(!1)}he().on("change",n)}else o&&o.current&&o.current.webkitEnterFullscreen?(o.current.webkitEnterFullscreen(),E(o.current,"webkitendfullscreen",r),s(!0)):(a(),s(!1));return function(){if(s(!1),he().isEnabled)try{he().off("change",n),he().exit()}catch(e){}else o&&o.current&&o.current.webkitExitFullscreen&&(O(o.current,"webkitendfullscreen",r),o.current.webkitExitFullscreen())}}}),[t,o,e]),u},ye=function(e){var t,r=(0,n.useState)({loading:!0,accuracy:null,altitude:null,altitudeAccuracy:null,heading:null,latitude:null,longitude:null,speed:null,timestamp:Date.now()}),o=r[0],i=r[1],a=!0,l=function(e){a&&i({loading:!1,accuracy:e.coords.accuracy,altitude:e.coords.altitude,altitudeAccuracy:e.coords.altitudeAccuracy,heading:e.coords.heading,latitude:e.coords.latitude,longitude:e.coords.longitude,speed:e.coords.speed,timestamp:e.timestamp})},u=function(e){return a&&i((function(t){return(0,c.__assign)((0,c.__assign)({},t),{loading:!1,error:e})}))};return(0,n.useEffect)((function(){return navigator.geolocation.getCurrentPosition(l,u,e),t=navigator.geolocation.watchPosition(l,u,e),function(){a=!1,navigator.geolocation.clearWatch(t)}}),[]),o},be=function(e){void 0===e&&(e={});var t=B(),r=(0,n.useRef)((0,c.__assign)({},e));return[(0,n.useCallback)((function(){return r.current}),[]),(0,n.useCallback)((function(e){e&&(Object.assign(r.current,e),t())}),[])]};var Ee=0,Oe={};const Se=function(e,t){void 0===t&&(t=0);var r=(0,n.useRef)((function(){}));(0,n.useEffect)((function(){r.current=e})),(0,n.useEffect)((function(){if(null!==t){var e=function(e,t){var r,n=Ee++;if(Oe[t])Oe[t].listeners[n]=e;else{var o=setInterval((function(){for(var e,r=Oe[t].listeners,n=!1,o=0,i=Object.values(r);o<i.length;o++){var a=i[o];try{a()}catch(t){n=!0,e=t}}if(n)throw e}),t);Oe[t]={ms:t,timer:o,listeners:(r={},r[n]=e,r)}}return{bucket:Oe[t],id:n}}((function(){return r.current()}),t);return function(){return function(e){var t=e.bucket,r=e.id;delete t.listeners[r];var n=!1;for(var o in t.listeners){n=!0;break}n||(clearInterval(t.timer),delete Oe[t.ms])}(e)}}}),[t])};var _e=n.useState;const we=function(e){var t,r,o=_e(!1),i=o[0],a=o[1];return"function"==typeof e&&(e=e(i)),[n.cloneElement(e,{onMouseEnter:(r=e.props.onMouseEnter,function(e){(r||b)(e),a(!0)}),onMouseLeave:(t=e.props.onMouseLeave,function(e){(t||b)(e),a(!1)})}),i]},Te=function(e,t){void 0===t&&(t=!0);var r=(0,n.useState)(!1),o=r[0],i=r[1];return(0,n.useEffect)((function(){var r=function(){return i(!0)},n=function(){return i(!1)};t&&e&&e.current&&(E(e.current,"mouseover",r),E(e.current,"mouseout",n));var o=e.current;return function(){t&&o&&(O(o,"mouseover",r),O(o,"mouseout",n))}}),[t,e]),o};var Pe=["mousemove","mousedown","resize","keydown","touchstart","wheel"];const Ce=function(e,t,r){void 0===e&&(e=6e4),void 0===t&&(t=!1),void 0===r&&(r=Pe);var o=(0,n.useState)(t),i=o[0],a=o[1];return(0,n.useEffect)((function(){for(var t,n=!0,o=i,l=function(e){n&&(o=e,a(e))},u=function(e,t,r,n){var o,i=!1,a=0;function l(){o&&clearTimeout(o)}function u(){for(var u=arguments.length,s=new Array(u),c=0;c<u;c++)s[c]=arguments[c];var d=this,f=Date.now()-a;function p(){a=Date.now(),r.apply(d,s)}i||(n&&!o&&p(),l(),void 0===n&&f>e?p():!0!==t&&(o=setTimeout(n?function(){o=void 0}:p,void 0===n?e-f:e)))}return"boolean"!=typeof t&&(n=r,r=t,t=void 0),u.cancel=function(){l(),i=!0},u}(50,(function(){o&&l(!1),clearTimeout(t),t=setTimeout((function(){return l(!0)}),e)})),s=function(){document.hidden||u()},c=0;c<r.length;c++)E(window,r[c],u);return E(document,"visibilitychange",s),t=setTimeout((function(){return l(!0)}),e),function(){n=!1;for(var e=0;e<r.length;e++)O(window,r[e],u);O(document,"visibilitychange",s)}}),[e,r]),i},Ie=function(e,t){var r=(0,n.useState)(null),o=r[0],i=r[1];return(0,n.useEffect)((function(){if(e.current&&"function"==typeof IntersectionObserver){var r=new IntersectionObserver((function(e){i(e[0])}),t);return r.observe(e.current),function(){i(null),r.disconnect()}}return function(){}}),[e.current,t.threshold,t.root,t.rootMargin]),o},Ae=function(e,t){var r=(0,n.useRef)((function(){}));(0,n.useEffect)((function(){r.current=e})),(0,n.useEffect)((function(){if(null!==t){var e=setInterval((function(){return r.current()}),t||0);return function(){return clearInterval(e)}}}),[t])},Re=function(e,t,r,o){void 0===t&&(t=b),void 0===r&&(r={}),void 0===o&&(o=[e]);var i=r.event,a=void 0===i?"keydown":i,l=r.target,u=r.options,s=(0,n.useMemo)((function(){var r,n="function"==typeof(r=e)?r:"string"==typeof r?function(e){return e.key===r}:r?function(){return!0}:function(){return!1};return function(e){if(n(e))return t(e)}}),o);fe(a,s,l,u)},xe=function(e){return void 0===e&&(e={laptopL:1440,laptop:1024,tablet:768}),function(){var t=(0,n.useState)(S?window.innerWidth:0),r=t[0],o=t[1];(0,n.useEffect)((function(){var e=function(){o(window.innerWidth)};return e(),E(window,"resize",e),function(){O(window,"resize",e)}}));var i=(0,n.useMemo)((function(){return Object.entries(e).sort((function(e,t){return e[1]>=t[1]?1:-1}))}),[e]),a=i.reduce((function(e,t){var n=t[0],o=t[1];return r>=o?n:e}),i[0][0]);return a}},Ne=function(e){var t=(0,n.useState)([!1,null]),r=t[0],o=t[1];return Re(e,(function(e){return o([!0,e])}),{event:"keydown"},[r]),Re(e,(function(e){return o([!1,e])}),{event:"keyup"},[r]),r},De=function(e,t,r,n){void 0===n&&(n=Ne);var o=n(e),i=o[0],a=o[1];l((function(){!i&&r?r(a):i&&t&&t(a)}),[i])},Le=function(e){var t=(0,n.useRef)(e);return t.current=e,t},je=function(e,t){(0,n.useEffect)((function(){return e&&e(),function(){t&&t()}}),[])},Me=function(e){void 0===e&&(e=[]);var t=(0,n.useRef)(U(e)),r=B(),o=(0,n.useMemo)((function(){var n={set:function(e){t.current=U(e,t.current),r()},push:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];e.length&&o.set((function(t){return t.concat(e)}))},updateAt:function(e,t){o.set((function(r){var n=r.slice();return n[e]=t,n}))},insertAt:function(e,t){o.set((function(r){var n=r.slice();return e>n.length?n[e]=t:n.splice(e,0,t),n}))},update:function(e,t){o.set((function(r){return r.map((function(r){return e(r,t)?t:r}))}))},updateFirst:function(e,r){var n=t.current.findIndex((function(t){return e(t,r)}));n>=0&&o.updateAt(n,r)},upsert:function(e,r){var n=t.current.findIndex((function(t){return e(t,r)}));n>=0?o.updateAt(n,r):o.push(r)},sort:function(e){o.set((function(t){return t.slice().sort(e)}))},filter:function(e,t){o.set((function(r){return r.slice().filter(e,t)}))},removeAt:function(e){o.set((function(t){var r=t.slice();return r.splice(e,1),r}))},clear:function(){o.set([])},reset:function(){o.set(U(e).slice())}};return n.remove=n.removeAt,n}),[]);return[t.current,o]},ke=function(e,t,r){if(!S)return[t,b,b];if(!e)throw new Error("useLocalStorage key may not be falsy");var o=r?r.raw?function(e){return e}:r.deserializer:JSON.parse,i=(0,n.useRef)((function(e){try{var n=r?r.raw?String:r.serializer:JSON.stringify,i=localStorage.getItem(e);return null!==i?o(i):(t&&localStorage.setItem(e,n(t)),t)}catch(e){return t}})),a=(0,n.useState)((function(){return i.current(e)})),l=a[0],u=a[1];(0,n.useLayoutEffect)((function(){return u(i.current(e))}),[e]);var s=(0,n.useCallback)((function(t){try{var n="function"==typeof t?t(l):t;if(void 0===n)return;var i;i=r?r.raw?"string"==typeof n?n:JSON.stringify(n):r.serializer?r.serializer(n):JSON.stringify(n):JSON.stringify(n),localStorage.setItem(e,i),u(o(i))}catch(e){}}),[e,u]),c=(0,n.useCallback)((function(){try{localStorage.removeItem(e),u(void 0)}catch(e){}}),[e,u]);return[l,s,c]};var Fe=function(e){var t=window.history,r=t[e];t[e]=function(t){var n=r.apply(this,arguments),o=new Event(e.toLowerCase());return o.state=t,window.dispatchEvent(o),n}};S&&(Fe("pushState"),Fe("replaceState"));var qe=function(e){var t=window.history,r=t.state,n=t.length,o=window.location;return{trigger:e,state:r,length:n,hash:o.hash,host:o.host,hostname:o.hostname,href:o.href,origin:o.origin,pathname:o.pathname,port:o.port,protocol:o.protocol,search:o.search}},Ve="function"==typeof Event;const Be=S&&Ve?function(){var e=(0,n.useState)(qe("load")),t=e[0],r=e[1];return(0,n.useEffect)((function(){var e=function(){return r(qe("popstate"))},t=function(){return r(qe("pushstate"))},n=function(){return r(qe("replacestate"))};return E(window,"popstate",e),E(window,"pushstate",t),E(window,"replacestate",n),function(){O(window,"popstate",e),O(window,"pushstate",t),O(window,"replacestate",n)}}),[]),t}:function(){return{trigger:"load",length:1}};function Ue(e){if(!e)return null;if("BODY"===e.tagName)return e;if("IFRAME"===e.tagName){var t=e.contentDocument;return t?t.body:null}return e.offsetParent?Ue(e.offsetParent):null}function We(e){var t=e||window.event;return t.touches.length>1||(t.preventDefault&&t.preventDefault(),!1)}var Ge=S&&window.navigator&&window.navigator.platform&&/iP(ad|hone|od)/.test(window.navigator.platform),He=new Map,Ke="object"==typeof document?document:void 0,$e=!1;const ze=Ke?function(e,t){void 0===e&&(e=!0);var r=(0,n.useRef)(Ke.body);t=t||r;var o=function(e){var t=He.get(e);t&&(1===t.counter?(He.delete(e),Ge?(e.ontouchmove=null,$e&&(O(document,"touchmove",We),$e=!1)):e.style.overflow=t.initialOverflow):He.set(e,{counter:t.counter-1,initialOverflow:t.initialOverflow}))};(0,n.useEffect)((function(){var r=Ue(t.current);r&&(e?function(e){var t=He.get(e);t?He.set(e,{counter:t.counter+1,initialOverflow:t.initialOverflow}):(He.set(e,{counter:1,initialOverflow:e.style.overflow}),Ge?$e||(E(document,"touchmove",We,{passive:!1}),$e=!0):e.style.overflow="hidden")}(r):o(r))}),[e,t.current]),(0,n.useEffect)((function(){var e=Ue(t.current);if(e)return function(){o(e)}}),[])}:function(e,t){void 0===e&&(e=!0)},Ye=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];ae((function(){return console.log.apply(console,(0,c.__spreadArrays)([e+" mounted"],t)),function(){return console.log(e+" unmounted")}})),l((function(){console.log.apply(console,(0,c.__spreadArrays)([e+" updated"],t))}))};var Qe=function(e){(function(e){return"touches"in e})(e)&&e.touches.length<2&&e.preventDefault&&e.preventDefault()};const Xe=function(e,t){var r=void 0===t?{}:t,o=r.isPreventDefault,i=void 0===o||o,a=r.delay,l=void 0===a?300:a,u=(0,n.useRef)(),s=(0,n.useRef)(),c=(0,n.useCallback)((function(t){i&&t.target&&(E(t.target,"touchend",Qe,{passive:!1}),s.current=t.target),u.current=setTimeout((function(){return e(t)}),l)}),[e,l,i]),d=(0,n.useCallback)((function(){u.current&&clearTimeout(u.current),i&&s.current&&O(s.current,"touchend",Qe)}),[i]);return{onMouseDown:function(e){return c(e)},onTouchStart:function(e){return c(e)},onMouseUp:d,onMouseLeave:d,onTouchEnd:d}},Je=function(e){void 0===e&&(e={});var t=(0,n.useState)(e),r=t[0],o=t[1],i=(0,n.useMemo)((function(){return{set:function(e,t){o((function(r){var n;return(0,c.__assign)((0,c.__assign)({},r),((n={})[e]=t,n))}))},setAll:function(e){o(e)},remove:function(e){o((function(t){var r=t,n=e;return r[n],(0,c.__rest)(r,["symbol"==typeof n?n:n+""])}))},reset:function(){return o(e)}}}),[o]),a=(0,c.__assign)({get:(0,n.useCallback)((function(e){return r[e]}),[r])},i);return[r,a]},Ze=function(e,t){void 0===t&&(t=!1);var r=(0,n.useState)(S?function(){return window.matchMedia(e).matches}:t),o=r[0],i=r[1];return(0,n.useEffect)((function(){var t=!0,r=window.matchMedia(e),n=function(){t&&i(!!r.matches)};return r.addListener(n),i(r.matches),function(){t=!1,r.removeListener(n)}}),[e]),o},et=_&&navigator.mediaDevices?function(){var e=(0,n.useState)({}),t=e[0],r=e[1];return(0,n.useEffect)((function(){var e=!0,t=function(){navigator.mediaDevices.enumerateDevices().then((function(t){e&&r({devices:t.map((function(e){return{deviceId:e.deviceId,groupId:e.groupId,kind:e.kind,label:e.label}}))})})).catch(b)};return E(navigator.mediaDevices,"devicechange",t),t(),function(){e=!1,O(navigator.mediaDevices,"devicechange",t)}}),[]),t}:function(){return{}};function tt(e,t){var r=(0,n.useRef)(e),o=(0,n.useState)(t),i=o[0],a=o[1];return[i,(0,n.useCallback)((function(e){2===r.current.length?r.current(e,a):a(r.current(e))}),[i])]}const rt=function(e,t){var r=(0,n.useMemo)((function(){return function(t,r){var n;return(n=e(t))[r.type].apply(n,r.payload)}}),[e]),o=(0,n.useReducer)(r,t),i=o[0],a=o[1],l=(0,n.useMemo)((function(){return Object.keys(e(t)).reduce((function(e,t){return e[t]=function(){for(var e=[],r=0;r<arguments.length;r++)e[r]=arguments[r];return a({type:t,payload:e})},e}),{})}),[e,t]);return[i,l]};var nt={acceleration:{x:null,y:null,z:null},accelerationIncludingGravity:{x:null,y:null,z:null},rotationRate:{alpha:null,beta:null,gamma:null},interval:16};const ot=function(e){void 0===e&&(e=nt);var t=(0,n.useState)(e),r=t[0],o=t[1];return(0,n.useEffect)((function(){var e=function(e){var t=e.acceleration,r=e.accelerationIncludingGravity,n=e.rotationRate,i=e.interval;o({acceleration:{x:t.x,y:t.y,z:t.z},accelerationIncludingGravity:{x:r.x,y:r.y,z:r.z},rotationRate:{alpha:n.alpha,beta:n.beta,gamma:n.gamma},interval:i})};return E(window,"devicemotion",e),function(){O(window,"devicemotion",e)}}),[]),r},it=function(e){ae((function(){e()}))},at=function(e){var t=(0,n.useRef)(e);t.current=e,ae((function(){return function(){return t.current()}}))},lt=function(e){var t=(0,n.useRef)(0),r=(0,n.useState)(e),o=r[0],i=r[1],a=(0,n.useCallback)((function(e){cancelAnimationFrame(t.current),t.current=requestAnimationFrame((function(){i(e)}))}),[]);return at((function(){cancelAnimationFrame(t.current)})),[o,a]},ut=function(e){var t=lt({docX:0,docY:0,posX:0,posY:0,elX:0,elY:0,elH:0,elW:0}),r=t[0],o=t[1];return(0,n.useEffect)((function(){var t=function(t){if(e&&e.current){var r=e.current.getBoundingClientRect(),n=r.left,i=r.top,a=r.width,l=r.height,u=n+window.pageXOffset,s=i+window.pageYOffset,c=t.pageX-u,d=t.pageY-s;o({docX:t.pageX,docY:t.pageY,posX:u,posY:s,elX:c,elY:d,elH:l,elW:a})}};return E(document,"mousemove",t),function(){O(document,"mousemove",t)}}),[e]),r};var st={current:null};const ct=function(e,t){void 0===t&&(t={});var r=!!t.whenHovered,n=!!t.bound,o=Te(e,r),i=ut(r&&!o?st:e);return n&&(i.elX=Math.max(0,Math.min(i.elX,i.elW)),i.elY=Math.max(0,Math.min(i.elY,i.elH))),i},dt=function(){var e=(0,n.useState)(0),t=e[0],r=e[1];return(0,n.useEffect)((function(){var e=function(e){r(e.deltaY+t)};return E(window,"wheel",e,!1),function(){return O(window,"wheel",e)}})),t};var ft=_?navigator:void 0,pt=ft&&(ft.connection||ft.mozConnection||ft.webkitConnection);function gt(e){var t=null==ft?void 0:ft.onLine,r=null==e?void 0:e.online;return{online:t,previous:r,since:t!==r?new Date:null==e?void 0:e.since,downlink:null==pt?void 0:pt.downlink,downlinkMax:null==pt?void 0:pt.downlinkMax,effectiveType:null==pt?void 0:pt.effectiveType,rtt:null==pt?void 0:pt.rtt,saveData:null==pt?void 0:pt.saveData,type:null==pt?void 0:pt.type}}function vt(e){var t=(0,n.useState)(null!=e?e:gt),r=t[0],o=t[1];return(0,n.useEffect)((function(){var e=function(){o(gt)};return E(window,"online",e,{passive:!0}),E(window,"offline",e,{passive:!0}),pt&&E(pt,"change",e,{passive:!0}),function(){O(window,"online",e),O(window,"offline",e),pt&&O(pt,"change",e)}}),[]),r}const ht=G,mt=function(e,t){var r=(0,n.useState)(t),o=r[0],i=r[1];return Y((function(){var t=e.subscribe(i);return function(){return t.unsubscribe()}}),[e]),o};var yt={angle:0,type:"landscape-primary"};const bt=function(e){void 0===e&&(e=yt);var t=(0,n.useState)(e),r=t[0],o=t[1];return(0,n.useEffect)((function(){var t=window.screen,r=!0,n=function(){if(r){var n=t.orientation;if(n){var i=n.angle,a=n.type;o({angle:i,type:a})}else void 0!==window.orientation?o({angle:"number"==typeof window.orientation?window.orientation:0,type:""}):o(e)}};return E(window,"orientationchange",n),n(),function(){r=!1,O(window,"orientationchange",n)}}),[]),r},Et=function(e,t){void 0===t&&(t=[]),(0,n.useEffect)((function(){if(e){var t=function(t){var r=(t=t||window.event).relatedTarget||t.toElement;r&&"HTML"!==r.nodeName||e()};return E(document,"mouseout",t),function(){O(document,"mouseout",t)}}}),t)},Ot=function(e){var t=(0,n.useState)(""),r=t[0],o=t[1];return(0,n.useEffect)((function(){var t=!0,r=null,n=function(){t&&o((function(){var e;return null!==(e=null==r?void 0:r.state)&&void 0!==e?e:""}))};return navigator.permissions.query(e).then((function(e){E(r=e,"change",n),n()})).catch(b),function(){r&&O(r,"change",n),t=!1,r=null}}),[e]),r};function St(e){var t=(0,n.useRef)();return(0,n.useEffect)((function(){t.current=e})),t.current}var _t=function(e,t){return e===t};function wt(e,t){void 0===t&&(t=_t);var r=(0,n.useRef)(),o=(0,n.useRef)(e);return a()||t(o.current,e)||(r.current=o.current,o.current=e),r.current}const Tt=function(){var e=d();return(0,n.useCallback)((function(t){return new Promise((function(r,n){t.then((function(t){e()&&r(t)}),(function(t){e()&&n(t)}))}))}),[])},Pt=function(e){void 0===e&&(e=[]);var t=(0,n.useState)(e),r=t[0],o=t[1];return{add:function(e){o((function(t){return(0,c.__spreadArrays)(t,[e])}))},remove:function(){var e;return o((function(t){var r=t[0],n=t.slice(1);return e=r,n})),e},get first(){return r[0]},get last(){return r[r.length-1]},get size(){return r.length}}},Ct=function(e,t){void 0===e&&(e=1e12),void 0===t&&(t=0);var r=(0,n.useState)(0),o=r[0],i=r[1];return Y((function(){var r,n,o,a=function(){var t=Math.min(1,(Date.now()-o)/e);i(t),l()},l=function(){r=requestAnimationFrame(a)},u=setTimeout((function(){n=setTimeout((function(){cancelAnimationFrame(r),i(1)}),e),o=Date.now(),l()}),t);return function(){clearTimeout(n),clearTimeout(u),cancelAnimationFrame(r)}}),[e,t]),o};function It(e,t){void 0===t&&(t=!0);var r=(0,n.useRef)(null),o=(0,n.useRef)(!1),i=(0,n.useRef)(e);i.current=e;var a=(0,n.useCallback)((function(e){o.current&&(i.current(e),r.current=requestAnimationFrame(a))}),[]),l=(0,n.useMemo)((function(){return[function(){o.current&&(o.current=!1,r.current&&cancelAnimationFrame(r.current))},function(){o.current||(o.current=!0,r.current=requestAnimationFrame(a))},function(){return o.current}]}),[]);return(0,n.useEffect)((function(){return t&&l[1](),l[0]}),[]),l}var At=function(e,t){return new URLSearchParams(e).get(t)};const Rt=S?function(e){var t=window.location,r=(0,n.useState)((function(){return At(t.search,e)})),o=r[0],i=r[1];return(0,n.useEffect)((function(){var r=function(){i(At(t.search,e))};return E(window,"popstate",r),E(window,"pushstate",r),E(window,"replacestate",r),function(){O(window,"popstate",r),O(window,"pushstate",r),O(window,"replacestate",r)}}),[]),o}:function(){return null};r(13167);const xt=function(e){void 0===e&&(e={});var t=e.disabled,r=Le(e),o=(0,n.useState)({isScratching:!1}),i=o[0],a=o[1],l=(0,n.useRef)(i),u=(0,n.useRef)(!1),s=(0,n.useRef)(null),d=(0,n.useState)(null),f=d[0],p=d[1];return(0,n.useEffect)((function(){if(!t&&f){var e,n,o=function(e,t){cancelAnimationFrame(s.current),s.current=requestAnimationFrame((function(){var n=f.getBoundingClientRect(),o=n.left,i=n.top,u=o+window.scrollX,s=i+window.scrollY,d=e-u,p=t-s;a((function(e){var t=(0,c.__assign)((0,c.__assign)({},e),{dx:d-(e.x||0),dy:p-(e.y||0),end:Date.now(),isScratching:!0});return l.current=t,(r.current.onScratch||b)(t),t}))}))},i=function(e){o(e.pageX,e.pageY)},d=function(e){o(e.changedTouches[0].pageX,e.changedTouches[0].pageY)},p=function(){u.current&&(u.current=!1,l.current=(0,c.__assign)((0,c.__assign)({},l.current),{isScratching:!1}),(r.current.onScratchEnd||b)(l.current),a({isScratching:!1}),O(window,"mousemove",i),O(window,"touchmove",d),O(window,"mouseup",e),O(window,"touchend",n))};e=p,n=p;var g=function(t,o){if(u.current){var s=f.getBoundingClientRect(),c=s.left,p=s.top,g=c+window.scrollX,v=p+window.scrollY,h=t-g,m=o-v,y=Date.now(),O={isScratching:!0,start:y,end:y,docX:t,docY:o,x:h,y:m,dx:0,dy:0,elH:f.offsetHeight,elW:f.offsetWidth,elX:g,elY:v};l.current=O,(r.current.onScratchStart||b)(O),a(O),E(window,"mousemove",i),E(window,"touchmove",d),E(window,"mouseup",e),E(window,"touchend",n)}},v=function(e){u.current=!0,g(e.pageX,e.pageY)},h=function(e){u.current=!0,g(e.changedTouches[0].pageX,e.changedTouches[0].pageY)};return E(f,"mousedown",v),E(f,"touchstart",h),function(){O(f,"mousedown",v),O(f,"touchstart",h),O(window,"mousemove",i),O(window,"touchmove",d),O(window,"mouseup",e),O(window,"touchend",n),s.current&&cancelAnimationFrame(s.current),s.current=null,u.current=!1,l.current={isScratching:!1},a(l.current)}}}),[f,t,r]),[p,i]},Nt=function(e){var t=lt({x:0,y:0}),r=t[0],o=t[1];return(0,n.useEffect)((function(){var t=function(){e.current&&o({x:e.current.scrollLeft,y:e.current.scrollTop})};return e.current&&E(e.current,"scroll",t,{capture:!1,passive:!0}),function(){e.current&&O(e.current,"scroll",t)}}),[e]),r},Dt=function(e){var t=(0,n.useState)(!1),r=t[0],o=t[1];return(0,n.useEffect)((function(){if(e.current){var t,r=function(){o(!0),clearTimeout(t),t=setTimeout((function(){o(!1)}),150)};return E(e.current,"scroll",r,!1),function(){e.current&&O(e.current,"scroll",r,!1)}}return function(){}}),[e]),r},Lt=function(e,t,r){if(!S)return[t,function(){}];var o=(0,n.useState)((function(){try{var n=sessionStorage.getItem(e);return"string"!=typeof n?(sessionStorage.setItem(e,r?String(t):JSON.stringify(t)),t):r?n:JSON.parse(n||"null")}catch(e){return t}})),i=o[0],a=o[1];return(0,n.useEffect)((function(){try{var t=r?String(i):JSON.stringify(i);sessionStorage.setItem(e,t)}catch(e){}})),[i,a]};var jt=r(76511),Mt=function(e,t){return e.every((function(e,r){return(0,jt.L)(e,t[r])}))};const kt=function(e,t){Z(e,t,Mt)};var Ft=n.useState,qt=n.useEffect,Vt=n.useRef;const Bt=function(e,t){var r=void 0===t?{}:t,o=r.width,i=void 0===o?1/0:o,a=r.height,l=void 0===a?1/0:a;if(!S)return["function"==typeof e?e({width:i,height:l}):e,{width:i,height:l}];var u=Ft({width:i,height:l}),s=u[0],d=u[1];"function"==typeof e&&(e=e(s));var f=e.props.style||{},p=Vt(null),g=null,v=function(){var e=p.current,t=e?{width:e.offsetWidth,height:e.offsetHeight}:{width:i,height:l};d(t)},h=function(e){E(e,"resize",v),setTimeout(v,35)};return qt((function(){var e=p.current;if(e){if(e.contentWindow)g=e.contentWindow,h(g);else{var t=function(){E(e,"load",t),g=e.contentWindow,h(g)};O(e,"load",t)}return function(){g&&g.removeEventListener&&O(g,"resize",v)}}}),[]),f.position="relative",[n.cloneElement.apply(n,(0,c.__spreadArrays)([e,{style:f}],(0,c.__spreadArrays)([n.createElement("iframe",{ref:p,style:{background:"transparent",border:"none",height:"100%",left:0,position:"absolute",top:0,width:"100%",zIndex:-1}})],n.Children.toArray(e.props.children)))),s]},Ut=function(e,t){void 0===t&&(t={});var r=d(),o=(0,n.useRef)(!1),i=(0,n.useRef)(0),a=(0,n.useRef)(0),l=v({isSliding:!1,value:0}),u=l[0],s=l[1];return i.current=u.value,(0,n.useEffect)((function(){if(S){var n=void 0===t.styles||t.styles,l=void 0!==t.reverse&&t.reverse;e.current&&n&&(e.current.style.userSelect="none");var u=function(){!o.current&&r()&&((t.onScrubStart||b)(),o.current=!0,s({isSliding:!0}),v())},c=function(){o.current&&r()&&((t.onScrubStop||b)(i.current),o.current=!1,s({isSliding:!1}),h())},d=function(e){u(),f(e)},f=t.vertical?function(e){return m(e.clientY)}:function(e){return m(e.clientX)},p=function(e){u(),g(e)},g=t.vertical?function(e){return m(e.changedTouches[0].clientY)}:function(e){return m(e.changedTouches[0].clientX)},v=function(){E(document,"mousemove",f),E(document,"mouseup",c),E(document,"touchmove",g),E(document,"touchend",c)},h=function(){O(document,"mousemove",f),O(document,"mouseup",c),O(document,"touchmove",g),O(document,"touchend",c)},m=function(n){cancelAnimationFrame(a.current),a.current=requestAnimationFrame((function(){if(r()&&e.current){var o=e.current.getBoundingClientRect(),i=t.vertical?o.top:o.left,a=t.vertical?o.height:o.width;if(!a)return;var u=(n-i)/a;u>1?u=1:u<0&&(u=0),l&&(u=1-u),s({value:u}),(t.onScrub||b)(u)}}))};return E(e.current,"mousedown",d),E(e.current,"touchstart",p),function(){O(e.current,"mousedown",d),O(e.current,"touchstart",p)}}}),[e,t.vertical]),u};var Wt;!function(e){e[e.init=0]="init",e[e.play=1]="play",e[e.pause=2]="pause",e[e.end=3]="end"}(Wt||(Wt={}));const Gt=function(e,t){var r=(0,n.useRef)(!1),o=(0,n.useState)((function(){var e=t.voice||{},r=e.lang,n=void 0===r?"default":r,o=e.name,i=void 0===o?"":o;return{isPlaying:!1,status:Wt[Wt.init],lang:t.lang||"default",voiceInfo:{lang:n,name:i},rate:t.rate||1,pitch:t.pitch||1,volume:t.volume||1}})),i=o[0],a=o[1],l=(0,n.useCallback)((function(){r.current&&a((function(e){return(0,c.__assign)((0,c.__assign)({},e),{isPlaying:!0,status:Wt[Wt.play]})}))}),[]),u=(0,n.useCallback)((function(){r.current&&a((function(e){return(0,c.__assign)((0,c.__assign)({},e),{isPlaying:!1,status:Wt[Wt.pause]})}))}),[]),s=(0,n.useCallback)((function(){r.current&&a((function(e){return(0,c.__assign)((0,c.__assign)({},e),{isPlaying:!1,status:Wt[Wt.end]})}))}),[]);return(0,n.useEffect)((function(){r.current=!0;var n=new SpeechSynthesisUtterance(e);return t.lang&&(n.lang=t.lang),t.voice&&(n.voice=t.voice),n.rate=t.rate||1,n.pitch=t.pitch||1,n.volume=t.volume||1,n.onstart=l,n.onpause=u,n.onresume=l,n.onend=s,window.speechSynthesis.speak(n),function(){r.current=!1}}),[]),i},Ht=function(e){Y((function(){var t=function(t){var r,n,o,i,a;!function(){var e=document.activeElement,t=document.body;if(!e)return!1;if(e===t)return!1;switch(e.tagName){case"INPUT":case"TEXTAREA":return!0}return e.hasAttribute("contenteditable")}()&&(n=(r=t).keyCode,o=r.metaKey,i=r.ctrlKey,a=r.altKey,!(o||i||a)&&(n>=48&&n<=57||n>=65&&n<=90))&&e(t)};return E(document,"keydown",t),function(){O(document,"keydown",t)}}),[])};function Kt(e,t,r){if(void 0===t&&(t=10),t<1)throw new Error("Capacity has to be greater than 1, got '"+t+"'");var o=a(),i=(0,n.useState)(e),l=i[0],u=i[1],s=(0,n.useRef)(null!=r?r:[]),c=(0,n.useRef)(0);return o&&(s.current.length?(s.current[s.current.length-1]!==e&&s.current.push(e),s.current.length>t&&(s.current=s.current.slice(s.current.length-t))):s.current.push(e),c.current=s.current.length&&s.current.length-1),[l,(0,n.useCallback)((function(e){u((function(r){return(e=U(e,r))!==r&&(c.current<s.current.length-1&&(s.current=s.current.slice(0,c.current+1)),c.current=s.current.push(e)-1,s.current.length>t&&(s.current=s.current.slice(s.current.length-t))),e}))}),[l,t]),(0,n.useMemo)((function(){return{history:s.current,position:c.current,capacity:t,back:function(e){void 0===e&&(e=1),c.current&&u((function(){return c.current-=Math.min(e,c.current),s.current[c.current]}))},forward:function(e){void 0===e&&(e=1),c.current!==s.current.length-1&&u((function(){return c.current=Math.min(c.current+e,s.current.length-1),s.current[c.current]}))},go:function(e){e!==c.current&&u((function(){return c.current=e<0?Math.max(s.current.length+e,0):Math.min(s.current.length-1,e),s.current[c.current]}))}}}),[l])]}function $t(e){void 0===e&&(e=[]);var t=d(),r=B(),o=(0,n.useRef)(0);l((function(){e.length<=o.current&&(o.current=e.length-1,r())}),[e.length]);var i=(0,n.useMemo)((function(){return{next:function(){return i.setStateAt(o.current+1)},prev:function(){return i.setStateAt(o.current-1)},setStateAt:function(n){t()&&e.length&&n!==o.current&&(o.current=n>=0?n%e.length:e.length+n%e.length,r())},setState:function(n){if(t()){var i=e.length?e.indexOf(n):-1;if(-1===i)throw new Error("State '"+n+"' is not a valid state (does not exist in state list)");o.current=i,r()}}}}),[e]);return(0,c.__assign)({state:e[o.current],currentIndex:o.current},i)}const zt=function(e,t){void 0===t&&(t=200);var r=(0,n.useState)(e),o=r[0],i=r[1],a=(0,n.useRef)(),l=(0,n.useRef)(null),u=(0,n.useRef)(0);return(0,n.useEffect)((function(){if(a.current)l.current=e,u.current=!0;else{i(e);var r=function(){u.current?(u.current=!1,i(l.current),a.current=setTimeout(r,t)):a.current=void 0};a.current=setTimeout(r,t)}}),[e]),at((function(){a.current&&clearTimeout(a.current)})),o},Yt=function(e,t,r){void 0===t&&(t=200);var o=(0,n.useState)(null),i=o[0],a=o[1],l=(0,n.useRef)(),u=(0,n.useRef)();return(0,n.useEffect)((function(){if(l.current)u.current=r;else{a(e.apply(void 0,r));var n=function(){u.current?(a(e.apply(void 0,u.current)),u.current=void 0,l.current=setTimeout(n,t)):l.current=void 0};l.current=setTimeout(n,t)}}),r),at((function(){l.current&&clearTimeout(l.current)})),i};function Qt(e){return void 0===e&&(e=0),ee(B(),e)}var Xt={restoreOnUnmount:!1};const Jt="undefined"!=typeof document?function(e,t){void 0===t&&(t=Xt);var r=(0,n.useRef)(document.title);document.title!==e&&(document.title=e),(0,n.useEffect)((function(){return t&&t.restoreOnUnmount?function(){document.title=r.current}:void 0}),[])}:function(e){};var Zt=r(84650);const er=function(e,t,r){return void 0===e&&(e="inCirc"),void 0===t&&(t=200),void 0===r&&(r=0),(0,Zt.c[e])(Ct(t,r))},tr=function(){var e=(0,n.useRef)(!1);return ae((function(){return function(){e.current=!0}})),(0,n.useMemo)((function(){return function(t,r){return new Promise((function(n,o){t.then((function(t){e.current||n(t)}),(function(t){e.current?r?r(t):console.error("useUnmountPromise",t):o(t)}))}))}}),[])};function rr(e,t){void 0===t&&(t=[]);var r=Me(t),n=r[0],o=r[1];return[n,(0,c.__assign)((0,c.__assign)({},o),{upsert:function(t){o.upsert(e,t)}})]}const nr=_&&"vibrate"in navigator?function(e,t,r){void 0===e&&(e=!0),void 0===t&&(t=[1e3,1e3]),void 0===r&&(r=!0),(0,n.useEffect)((function(){var n;if(e&&(navigator.vibrate(t),r)){var o=t instanceof Array?t.reduce((function(e,t){return e+t})):t;n=setInterval((function(){navigator.vibrate(t)}),o)}return function(){e&&(navigator.vibrate(0),r&&clearInterval(n))}}),[e])}:b,or=m("video");function ir(e,t,r){void 0===r&&(r=[void 0]);var o=(0,n.useRef)(t),i=(0,n.useRef)(e);o.current=t,i.current=e;var a=(0,n.useState)(r),l=a[0],u=a[1],s=(0,n.useCallback)((function(){o.current.length>=2?o.current(i.current,u):u(o.current(i.current))}),[u]);return(0,n.useEffect)((function(){s()}),[e]),[l,s]}var ar=function(e){if("undefined"==typeof document)return 0;if(document.body&&(!document.readyState||"loading"!==document.readyState)){if(!0!==e&&"number"==typeof ar.__cache)return ar.__cache;var t=document.createElement("div"),r=t.style;r.display="block",r.position="absolute",r.width="100px",r.height="100px",r.left="-999px",r.top="-999px",r.overflow="scroll",document.body.insertBefore(t,null);var n=t.clientWidth;if(0!==n)return ar.__cache=100-n,document.body.removeChild(t),ar.__cache;document.body.removeChild(t)}};function lr(){var e=(0,n.useState)(ar()),t=e[0],r=e[1];return(0,n.useEffect)((function(){if(void 0===t){var e=requestAnimationFrame((function(){r(ar())}));return function(){return cancelAnimationFrame(e)}}}),[]),t}function ur(e,t,r){if(void 0===r&&(r=[void 0]),"object"!=typeof e)throw new Error("states expected to be an object or array, got "+typeof e);var o=(0,n.useRef)(t),i=(0,n.useRef)(e);o.current=t,i.current=e;var a=(0,n.useState)(r),l=a[0],u=a[1],s=(0,n.useCallback)((function(){o.current.length>=2?o.current(i.current,u):u(o.current(i.current))}),[u]);return(0,n.useEffect)((function(){s()}),Object.values(e)),[l,s]}const sr=function(){var e=lt((function(){return{x:S?window.pageXOffset:0,y:S?window.pageYOffset:0}})),t=e[0],r=e[1];return(0,n.useEffect)((function(){var e=function(){r((function(e){var t=window.pageXOffset,r=window.pageYOffset;return e.x!==t||e.y!==r?{x:t,y:r}:e}))};return e(),E(window,"scroll",e,{capture:!1,passive:!0}),function(){O(window,"scroll",e)}}),[]),t},cr=function(e,t){void 0===e&&(e=1/0),void 0===t&&(t=1/0);var r=lt({width:S?window.innerWidth:e,height:S?window.innerHeight:t}),o=r[0],i=r[1];return(0,n.useEffect)((function(){if(S){var e=function(){i({width:window.innerWidth,height:window.innerHeight})};return E(window,"resize",e),function(){O(window,"resize",e)}}}),[]),o};var dr={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};const fr=S&&void 0!==window.ResizeObserver?function(){var e=(0,n.useState)(null),t=e[0],r=e[1],o=(0,n.useState)(dr),i=o[0],a=o[1],l=(0,n.useMemo)((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,i=t.height,l=t.top,u=t.left,s=t.bottom,c=t.right;a({x:r,y:n,width:o,height:i,top:l,left:u,bottom:s,right:c})}}))}),[]);return Y((function(){if(t)return l.observe(t),function(){l.disconnect()}}),[t]),[r,i]}:function(){return[b,dr]};function pr(){return++(0,n.useRef)(0).current}const gr=function(e){void 0===e&&(e=new Set);var t=(0,n.useState)(e),r=t[0],o=t[1],i=(0,n.useMemo)((function(){return{add:function(e){return o((function(t){return new Set((0,c.__spreadArrays)(Array.from(t),[e]))}))},remove:function(e){return o((function(t){return new Set(Array.from(t).filter((function(t){return t!==e})))}))},toggle:function(e){return o((function(t){return t.has(e)?new Set(Array.from(t).filter((function(t){return t!==e}))):new Set((0,c.__spreadArrays)(Array.from(t),[e]))}))},reset:function(){return o(e)}}}),[o]),a=(0,c.__assign)({has:(0,n.useCallback)((function(e){return r.has(e)}),[r])},i);return[r,a]};function vr(e){var t={state:e instanceof Function?e():e,setState:function(e){t.state=U(e,t.state),t.setters.forEach((function(e){return e(t.state)}))},setters:[]};return function(){var e=(0,n.useState)(t.state),r=e[0],o=e[1];return ae((function(){return function(){t.setters=t.setters.filter((function(e){return e!==o}))}})),Y((function(){t.setters.includes(o)||t.setters.push(o)})),[r,t.setState]}}var hr=function(){var e=(0,n.useState)((function(){return window.location.hash})),t=e[0],r=e[1],o=(0,n.useCallback)((function(){r(window.location.hash)}),[]);je((function(){E(window,"hashchange",o)}),(function(){O(window,"hashchange",o)}));var i=(0,n.useCallback)((function(e){e!==t&&(window.location.hash=e)}),[t]);return[t,i]}},90518:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666),o=r(85959),i=n.__importDefault(r(85542));t.default=function(e,t){void 0===t&&(t=[]);var r=i.default(e,t,{loading:!0}),n=r[0],a=r[1];return o.useEffect((function(){a()}),[a]),n}},85542:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666),o=r(85959),i=n.__importDefault(r(25241));t.default=function(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var a=o.useRef(0),l=i.default(),u=o.useState(r),s=u[0],c=u[1],d=o.useCallback((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var o=++a.current;return s.loading||c((function(e){return n.__assign(n.__assign({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return l()&&o===a.current&&c({value:e,loading:!1}),e}),(function(e){return l()&&o===a.current&&c({error:e,loading:!1}),e}))}),t);return[s,d]}},52087:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(91666),o=r(85959),i=n.__importDefault(r(81069));t.default=function(e,t,r){void 0===t&&(t=0),void 0===r&&(r=[]);var n=i.default(e,t),a=n[0],l=n[1],u=n[2];return o.useEffect(u,r),[a,l]}},25241:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(85959);t.default=function(){var e=n.useRef(!1),t=n.useCallback((function(){return e.current}),[]);return n.useEffect((function(){return e.current=!0,function(){e.current=!1}}),[]),t}},81069:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(85959);t.default=function(e,t){void 0===t&&(t=0);var r=n.useRef(!1),o=n.useRef(),i=n.useRef(e),a=n.useCallback((function(){return r.current}),[]),l=n.useCallback((function(){r.current=!1,o.current&&clearTimeout(o.current),o.current=setTimeout((function(){r.current=!0,i.current()}),t)}),[t]),u=n.useCallback((function(){r.current=null,o.current&&clearTimeout(o.current)}),[]);return n.useEffect((function(){i.current=e}),[e]),n.useEffect((function(){return l(),u}),[t]),[a,u,l]}},89236:(e,t,r)=>{"use strict";var n;r.r(t),r.d(t,{NIL:()=>R,parse:()=>h,stringify:()=>c,v1:()=>v,v3:()=>T,v4:()=>P,v5:()=>A,validate:()=>l,version:()=>x});var o=new Uint8Array(16);function i(){if(!n&&!(n="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return n(o)}const a=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i,l=function(e){return"string"==typeof e&&a.test(e)};for(var u=[],s=0;s<256;++s)u.push((s+256).toString(16).substr(1));const c=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(u[e[t+0]]+u[e[t+1]]+u[e[t+2]]+u[e[t+3]]+"-"+u[e[t+4]]+u[e[t+5]]+"-"+u[e[t+6]]+u[e[t+7]]+"-"+u[e[t+8]]+u[e[t+9]]+"-"+u[e[t+10]]+u[e[t+11]]+u[e[t+12]]+u[e[t+13]]+u[e[t+14]]+u[e[t+15]]).toLowerCase();if(!l(r))throw TypeError("Stringified UUID is invalid");return r};var d,f,p=0,g=0;const v=function(e,t,r){var n=t&&r||0,o=t||new Array(16),a=(e=e||{}).node||d,l=void 0!==e.clockseq?e.clockseq:f;if(null==a||null==l){var u=e.random||(e.rng||i)();null==a&&(a=d=[1|u[0],u[1],u[2],u[3],u[4],u[5]]),null==l&&(l=f=16383&(u[6]<<8|u[7]))}var s=void 0!==e.msecs?e.msecs:Date.now(),v=void 0!==e.nsecs?e.nsecs:g+1,h=s-p+(v-g)/1e4;if(h<0&&void 0===e.clockseq&&(l=l+1&16383),(h<0||s>p)&&void 0===e.nsecs&&(v=0),v>=1e4)throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");p=s,g=v,f=l;var m=(1e4*(268435455&(s+=122192928e5))+v)%4294967296;o[n++]=m>>>24&255,o[n++]=m>>>16&255,o[n++]=m>>>8&255,o[n++]=255&m;var y=s/4294967296*1e4&268435455;o[n++]=y>>>8&255,o[n++]=255&y,o[n++]=y>>>24&15|16,o[n++]=y>>>16&255,o[n++]=l>>>8|128,o[n++]=255&l;for(var b=0;b<6;++b)o[n+b]=a[b];return t||c(o)},h=function(e){if(!l(e))throw TypeError("Invalid UUID");var t,r=new Uint8Array(16);return r[0]=(t=parseInt(e.slice(0,8),16))>>>24,r[1]=t>>>16&255,r[2]=t>>>8&255,r[3]=255&t,r[4]=(t=parseInt(e.slice(9,13),16))>>>8,r[5]=255&t,r[6]=(t=parseInt(e.slice(14,18),16))>>>8,r[7]=255&t,r[8]=(t=parseInt(e.slice(19,23),16))>>>8,r[9]=255&t,r[10]=(t=parseInt(e.slice(24,36),16))/1099511627776&255,r[11]=t/4294967296&255,r[12]=t>>>24&255,r[13]=t>>>16&255,r[14]=t>>>8&255,r[15]=255&t,r};function m(e,t,r){function n(e,n,o,i){if("string"==typeof e&&(e=function(e){e=unescape(encodeURIComponent(e));for(var t=[],r=0;r<e.length;++r)t.push(e.charCodeAt(r));return t}(e)),"string"==typeof n&&(n=h(n)),16!==n.length)throw TypeError("Namespace must be array-like (16 iterable integer values, 0-255)");var a=new Uint8Array(16+e.length);if(a.set(n),a.set(e,n.length),(a=r(a))[6]=15&a[6]|t,a[8]=63&a[8]|128,o){i=i||0;for(var l=0;l<16;++l)o[i+l]=a[l];return o}return c(a)}try{n.name=e}catch(e){}return n.DNS="6ba7b810-9dad-11d1-80b4-00c04fd430c8",n.URL="6ba7b811-9dad-11d1-80b4-00c04fd430c8",n}function y(e){return 14+(e+64>>>9<<4)+1}function b(e,t){var r=(65535&e)+(65535&t);return(e>>16)+(t>>16)+(r>>16)<<16|65535&r}function E(e,t,r,n,o,i){return b((a=b(b(t,e),b(n,i)))<<(l=o)|a>>>32-l,r);var a,l}function O(e,t,r,n,o,i,a){return E(t&r|~t&n,e,t,o,i,a)}function S(e,t,r,n,o,i,a){return E(t&n|r&~n,e,t,o,i,a)}function _(e,t,r,n,o,i,a){return E(t^r^n,e,t,o,i,a)}function w(e,t,r,n,o,i,a){return E(r^(t|~n),e,t,o,i,a)}const T=m("v3",48,(function(e){if("string"==typeof e){var t=unescape(encodeURIComponent(e));e=new Uint8Array(t.length);for(var r=0;r<t.length;++r)e[r]=t.charCodeAt(r)}return function(e){for(var t=[],r=32*e.length,n="0123456789abcdef",o=0;o<r;o+=8){var i=e[o>>5]>>>o%32&255,a=parseInt(n.charAt(i>>>4&15)+n.charAt(15&i),16);t.push(a)}return t}(function(e,t){e[t>>5]|=128<<t%32,e[y(t)-1]=t;for(var r=1732584193,n=-271733879,o=-1732584194,i=271733878,a=0;a<e.length;a+=16){var l=r,u=n,s=o,c=i;r=O(r,n,o,i,e[a],7,-680876936),i=O(i,r,n,o,e[a+1],12,-389564586),o=O(o,i,r,n,e[a+2],17,606105819),n=O(n,o,i,r,e[a+3],22,-1044525330),r=O(r,n,o,i,e[a+4],7,-176418897),i=O(i,r,n,o,e[a+5],12,1200080426),o=O(o,i,r,n,e[a+6],17,-1473231341),n=O(n,o,i,r,e[a+7],22,-45705983),r=O(r,n,o,i,e[a+8],7,1770035416),i=O(i,r,n,o,e[a+9],12,-1958414417),o=O(o,i,r,n,e[a+10],17,-42063),n=O(n,o,i,r,e[a+11],22,-1990404162),r=O(r,n,o,i,e[a+12],7,1804603682),i=O(i,r,n,o,e[a+13],12,-40341101),o=O(o,i,r,n,e[a+14],17,-1502002290),r=S(r,n=O(n,o,i,r,e[a+15],22,1236535329),o,i,e[a+1],5,-165796510),i=S(i,r,n,o,e[a+6],9,-1069501632),o=S(o,i,r,n,e[a+11],14,643717713),n=S(n,o,i,r,e[a],20,-373897302),r=S(r,n,o,i,e[a+5],5,-701558691),i=S(i,r,n,o,e[a+10],9,38016083),o=S(o,i,r,n,e[a+15],14,-660478335),n=S(n,o,i,r,e[a+4],20,-405537848),r=S(r,n,o,i,e[a+9],5,568446438),i=S(i,r,n,o,e[a+14],9,-1019803690),o=S(o,i,r,n,e[a+3],14,-187363961),n=S(n,o,i,r,e[a+8],20,1163531501),r=S(r,n,o,i,e[a+13],5,-1444681467),i=S(i,r,n,o,e[a+2],9,-51403784),o=S(o,i,r,n,e[a+7],14,1735328473),r=_(r,n=S(n,o,i,r,e[a+12],20,-1926607734),o,i,e[a+5],4,-378558),i=_(i,r,n,o,e[a+8],11,-2022574463),o=_(o,i,r,n,e[a+11],16,1839030562),n=_(n,o,i,r,e[a+14],23,-35309556),r=_(r,n,o,i,e[a+1],4,-1530992060),i=_(i,r,n,o,e[a+4],11,1272893353),o=_(o,i,r,n,e[a+7],16,-155497632),n=_(n,o,i,r,e[a+10],23,-1094730640),r=_(r,n,o,i,e[a+13],4,681279174),i=_(i,r,n,o,e[a],11,-358537222),o=_(o,i,r,n,e[a+3],16,-722521979),n=_(n,o,i,r,e[a+6],23,76029189),r=_(r,n,o,i,e[a+9],4,-640364487),i=_(i,r,n,o,e[a+12],11,-421815835),o=_(o,i,r,n,e[a+15],16,530742520),r=w(r,n=_(n,o,i,r,e[a+2],23,-995338651),o,i,e[a],6,-198630844),i=w(i,r,n,o,e[a+7],10,1126891415),o=w(o,i,r,n,e[a+14],15,-1416354905),n=w(n,o,i,r,e[a+5],21,-57434055),r=w(r,n,o,i,e[a+12],6,1700485571),i=w(i,r,n,o,e[a+3],10,-1894986606),o=w(o,i,r,n,e[a+10],15,-1051523),n=w(n,o,i,r,e[a+1],21,-2054922799),r=w(r,n,o,i,e[a+8],6,1873313359),i=w(i,r,n,o,e[a+15],10,-30611744),o=w(o,i,r,n,e[a+6],15,-1560198380),n=w(n,o,i,r,e[a+13],21,1309151649),r=w(r,n,o,i,e[a+4],6,-145523070),i=w(i,r,n,o,e[a+11],10,-1120210379),o=w(o,i,r,n,e[a+2],15,718787259),n=w(n,o,i,r,e[a+9],21,-343485551),r=b(r,l),n=b(n,u),o=b(o,s),i=b(i,c)}return[r,n,o,i]}(function(e){if(0===e.length)return[];for(var t=8*e.length,r=new Uint32Array(y(t)),n=0;n<t;n+=8)r[n>>5]|=(255&e[n/8])<<n%32;return r}(e),8*e.length))})),P=function(e,t,r){var n=(e=e||{}).random||(e.rng||i)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,t){r=r||0;for(var o=0;o<16;++o)t[r+o]=n[o];return t}return c(n)};function C(e,t,r,n){switch(e){case 0:return t&r^~t&n;case 1:case 3:return t^r^n;case 2:return t&r^t&n^r&n}}function I(e,t){return e<<t|e>>>32-t}const A=m("v5",80,(function(e){var t=[1518500249,1859775393,2400959708,3395469782],r=[1732584193,4023233417,2562383102,271733878,3285377520];if("string"==typeof e){var n=unescape(encodeURIComponent(e));e=[];for(var o=0;o<n.length;++o)e.push(n.charCodeAt(o))}else Array.isArray(e)||(e=Array.prototype.slice.call(e));e.push(128);for(var i=e.length/4+2,a=Math.ceil(i/16),l=new Array(a),u=0;u<a;++u){for(var s=new Uint32Array(16),c=0;c<16;++c)s[c]=e[64*u+4*c]<<24|e[64*u+4*c+1]<<16|e[64*u+4*c+2]<<8|e[64*u+4*c+3];l[u]=s}l[a-1][14]=8*(e.length-1)/Math.pow(2,32),l[a-1][14]=Math.floor(l[a-1][14]),l[a-1][15]=8*(e.length-1)&4294967295;for(var d=0;d<a;++d){for(var f=new Uint32Array(80),p=0;p<16;++p)f[p]=l[d][p];for(var g=16;g<80;++g)f[g]=I(f[g-3]^f[g-8]^f[g-14]^f[g-16],1);for(var v=r[0],h=r[1],m=r[2],y=r[3],b=r[4],E=0;E<80;++E){var O=Math.floor(E/20),S=I(v,5)+C(O,h,m,y)+b+t[O]+f[E]>>>0;b=y,y=m,m=I(h,30)>>>0,h=v,v=S}r[0]=r[0]+v>>>0,r[1]=r[1]+h>>>0,r[2]=r[2]+m>>>0,r[3]=r[3]+y>>>0,r[4]=r[4]+b>>>0}return[r[0]>>24&255,r[0]>>16&255,r[0]>>8&255,255&r[0],r[1]>>24&255,r[1]>>16&255,r[1]>>8&255,255&r[1],r[2]>>24&255,r[2]>>16&255,r[2]>>8&255,255&r[2],r[3]>>24&255,r[3]>>16&255,r[3]>>8&255,255&r[3],r[4]>>24&255,r[4]>>16&255,r[4]>>8&255,255&r[4]]})),R="00000000-0000-0000-0000-000000000000",x=function(e){if(!l(e))throw TypeError("Invalid UUID");return parseInt(e.substr(14,1),16)}},75206:(e,t,r)=>{"use strict";r.r(t),r.d(t,{DragDropContext:()=>Pn,Draggable:()=>Bn,Droppable:()=>so,useKeyboardSensor:()=>on,useMouseSensor:()=>tn,useTouchSensor:()=>sn});var n=r(85959),o=r.n(n),i=r(48398),a=r.n(i),l=r(7694),u=r(30200);function s(e,t){var r=(0,n.useState)((function(){return{inputs:t,result:e()}}))[0],o=(0,n.useRef)(!0),i=(0,n.useRef)(r),a=o.current||Boolean(t&&i.current.inputs&&function(e,t){if(e.length!==t.length)return!1;for(var r=0;r<e.length;r++)if(e[r]!==t[r])return!1;return!0}(t,i.current.inputs))?i.current:{inputs:t,result:e()};return(0,n.useEffect)((function(){o.current=!1,i.current=a}),[a]),a.result}var c=s,d=function(e,t){return s((function(){return e}),t)},f=function(e){var t=e.top,r=e.right,n=e.bottom,o=e.left;return{top:t,right:r,bottom:n,left:o,width:r-o,height:n-t,x:o,y:t,center:{x:(r+o)/2,y:(n+t)/2}}},p=function(e,t){return{top:e.top-t.top,left:e.left-t.left,bottom:e.bottom+t.bottom,right:e.right+t.right}},g=function(e,t){return{top:e.top+t.top,left:e.left+t.left,bottom:e.bottom-t.bottom,right:e.right-t.right}},v={top:0,right:0,bottom:0,left:0},h=function(e){var t=e.borderBox,r=e.margin,n=void 0===r?v:r,o=e.border,i=void 0===o?v:o,a=e.padding,l=void 0===a?v:a,u=f(p(t,n)),s=f(g(t,i)),c=f(g(s,l));return{marginBox:u,borderBox:f(t),paddingBox:s,contentBox:c,margin:n,border:i,padding:l}},m=function(e){var t=e.slice(0,-2);if("px"!==e.slice(-2))return 0;var r=Number(t);return isNaN(r)&&function(){throw new Error("Invariant failed")}(),r},y=function(e,t){var r,n,o=e.borderBox,i=e.border,a=e.margin,l=e.padding,u=(n=t,{top:(r=o).top+n.y,left:r.left+n.x,bottom:r.bottom+n.y,right:r.right+n.x});return h({borderBox:u,border:i,margin:a,padding:l})},b=function(e,t){return void 0===t&&(t={x:window.pageXOffset,y:window.pageYOffset}),y(e,t)},E=function(e,t){var r={top:m(t.marginTop),right:m(t.marginRight),bottom:m(t.marginBottom),left:m(t.marginLeft)},n={top:m(t.paddingTop),right:m(t.paddingRight),bottom:m(t.paddingBottom),left:m(t.paddingLeft)},o={top:m(t.borderTopWidth),right:m(t.borderRightWidth),bottom:m(t.borderBottomWidth),left:m(t.borderLeftWidth)};return h({borderBox:e,margin:r,padding:n,border:o})},O=function(e){var t=e.getBoundingClientRect(),r=window.getComputedStyle(e);return E(t,r)},S=Number.isNaN||function(e){return"number"==typeof e&&e!=e};function _(e,t){if(e.length!==t.length)return!1;for(var r=0;r<e.length;r++)if(!((n=e[r])===(o=t[r])||S(n)&&S(o)))return!1;var n,o;return!0}function w(e,t){void 0===t&&(t=_);var r=null;function n(){for(var n=[],o=0;o<arguments.length;o++)n[o]=arguments[o];if(r&&r.lastThis===this&&t(n,r.lastArgs))return r.lastResult;var i=e.apply(this,n);return r={lastResult:i,lastArgs:n,lastThis:this},i}return n.clear=function(){r=null},n}const T=function(e){var t=[],r=null,n=function(){for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];t=o,r||(r=requestAnimationFrame((function(){r=null,e.apply(void 0,t)})))};return n.cancel=function(){r&&(cancelAnimationFrame(r),r=null)},n};function P(){return P=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)({}).hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},P.apply(null,arguments)}function C(e,t){}function I(){}function A(e,t,r){const n=t.map((t=>{const n=(o=r,i=t.options,{...o,...i});var o,i;return e.addEventListener(t.eventName,t.fn,n),function(){e.removeEventListener(t.eventName,t.fn,n)}}));return function(){n.forEach((e=>{e()}))}}C.bind(null,"warn"),C.bind(null,"error");const R=!0,x="Invariant failed";class N extends Error{}function D(e,t){throw new N(R?x:`${x}: ${t||""}`)}N.prototype.toString=function(){return this.message};class L extends o().Component{constructor(...e){super(...e),this.callbacks=null,this.unbind=I,this.onWindowError=e=>{const t=this.getCallbacks();t.isDragging()&&t.tryAbort(),e.error instanceof N&&e.preventDefault()},this.getCallbacks=()=>{if(!this.callbacks)throw new Error("Unable to find AppCallbacks in <ErrorBoundary/>");return this.callbacks},this.setCallbacks=e=>{this.callbacks=e}}componentDidMount(){this.unbind=A(window,[{eventName:"error",fn:this.onWindowError}])}componentDidCatch(e){if(!(e instanceof N))throw e;this.setState({})}componentWillUnmount(){this.unbind()}render(){return this.props.children(this.setCallbacks)}}const j=e=>e+1,M=(e,t)=>{const r=e.droppableId===t.droppableId,n=j(e.index),o=j(t.index);return r?`\n      You have moved the item from position ${n}\n      to position ${o}\n    `:`\n    You have moved the item from position ${n}\n    in list ${e.droppableId}\n    to list ${t.droppableId}\n    in position ${o}\n  `},k=(e,t,r)=>t.droppableId===r.droppableId?`\n      The item ${e}\n      has been combined with ${r.draggableId}`:`\n      The item ${e}\n      in list ${t.droppableId}\n      has been combined with ${r.draggableId}\n      in list ${r.droppableId}\n    `,F=e=>`\n  The item has returned to its starting position\n  of ${j(e.index)}\n`,q={dragHandleUsageInstructions:"\n  Press space bar to start a drag.\n  When dragging you can use the arrow keys to move the item around and escape to cancel.\n  Some screen readers may require you to be in focus mode or to use your pass through key\n",onDragStart:e=>`\n  You have lifted an item in position ${j(e.source.index)}\n`,onDragUpdate:e=>{const t=e.destination;if(t)return M(e.source,t);const r=e.combine;return r?k(e.draggableId,e.source,r):"You are over an area that cannot be dropped on"},onDragEnd:e=>{if("CANCEL"===e.reason)return`\n      Movement cancelled.\n      ${F(e.source)}\n    `;const t=e.destination,r=e.combine;return t?`\n      You have dropped the item.\n      ${M(e.source,t)}\n    `:r?`\n      You have dropped the item.\n      ${k(e.draggableId,e.source,r)}\n    `:`\n    The item has been dropped while not over a drop area.\n    ${F(e.source)}\n  `}},V={x:0,y:0},B=(e,t)=>({x:e.x+t.x,y:e.y+t.y}),U=(e,t)=>({x:e.x-t.x,y:e.y-t.y}),W=(e,t)=>e.x===t.x&&e.y===t.y,G=e=>({x:0!==e.x?-e.x:0,y:0!==e.y?-e.y:0}),H=(e,t,r=0)=>"x"===e?{x:t,y:r}:{x:r,y:t},K=(e,t)=>Math.sqrt((t.x-e.x)**2+(t.y-e.y)**2),$=(e,t)=>Math.min(...t.map((t=>K(e,t)))),z=e=>t=>({x:e(t.x),y:e(t.y)}),Y=(e,t)=>({top:e.top+t.y,left:e.left+t.x,bottom:e.bottom+t.y,right:e.right+t.x}),Q=e=>[{x:e.left,y:e.top},{x:e.right,y:e.top},{x:e.left,y:e.bottom},{x:e.right,y:e.bottom}],X=(e,t)=>t&&t.shouldClipSubject?((e,t)=>{const r=f({top:Math.max(t.top,e.top),right:Math.min(t.right,e.right),bottom:Math.min(t.bottom,e.bottom),left:Math.max(t.left,e.left)});return r.width<=0||r.height<=0?null:r})(t.pageMarginBox,e):f(e);var J=({page:e,withPlaceholder:t,axis:r,frame:n})=>{const o=((e,t)=>t?Y(e,t.scroll.diff.displacement):e)(e.marginBox,n),i=((e,t,r)=>r&&r.increasedBy?{...e,[t.end]:e[t.end]+r.increasedBy[t.line]}:e)(o,r,t);return{page:e,withPlaceholder:t,active:X(i,n)}},Z=(e,t)=>{e.frame||D();const r=e.frame,n=U(t,r.scroll.initial),o=G(n),i={...r,scroll:{initial:r.scroll.initial,current:t,diff:{value:n,displacement:o},max:r.scroll.max}},a=J({page:e.subject.page,withPlaceholder:e.subject.withPlaceholder,axis:e.axis,frame:i});return{...e,frame:i,subject:a}};const ee=w((e=>e.reduce(((e,t)=>(e[t.descriptor.id]=t,e)),{}))),te=w((e=>e.reduce(((e,t)=>(e[t.descriptor.id]=t,e)),{}))),re=w((e=>Object.values(e))),ne=w((e=>Object.values(e)));var oe=w(((e,t)=>{const r=ne(t).filter((t=>e===t.descriptor.droppableId)).sort(((e,t)=>e.descriptor.index-t.descriptor.index));return r}));function ie(e){return e.at&&"REORDER"===e.at.type?e.at.destination:null}function ae(e){return e.at&&"COMBINE"===e.at.type?e.at.combine:null}var le=w(((e,t)=>t.filter((t=>t.descriptor.id!==e.descriptor.id)))),ue=(e,t)=>e.descriptor.droppableId===t.descriptor.id;const se={point:V,value:0},ce={invisible:{},visible:{},all:[]},de={displaced:ce,displacedBy:se,at:null};var fe=(e,t)=>r=>e<=r&&r<=t,pe=e=>{const t=fe(e.top,e.bottom),r=fe(e.left,e.right);return n=>{if(t(n.top)&&t(n.bottom)&&r(n.left)&&r(n.right))return!0;const o=t(n.top)||t(n.bottom),i=r(n.left)||r(n.right);if(o&&i)return!0;const a=n.top<e.top&&n.bottom>e.bottom,l=n.left<e.left&&n.right>e.right;return!(!a||!l)||(a&&i||l&&o)}},ge=e=>{const t=fe(e.top,e.bottom),r=fe(e.left,e.right);return e=>t(e.top)&&t(e.bottom)&&r(e.left)&&r(e.right)};const ve={direction:"vertical",line:"y",crossAxisLine:"x",start:"top",end:"bottom",size:"height",crossAxisStart:"left",crossAxisEnd:"right",crossAxisSize:"width"},he={direction:"horizontal",line:"x",crossAxisLine:"y",start:"left",end:"right",size:"width",crossAxisStart:"top",crossAxisEnd:"bottom",crossAxisSize:"height"},me=({target:e,destination:t,viewport:r,withDroppableDisplacement:n,isVisibleThroughFrameFn:o})=>{const i=n?((e,t)=>{const r=t.frame?t.frame.scroll.diff.displacement:V;return Y(e,r)})(e,t):e;return((e,t,r)=>!!t.subject.active&&r(t.subject.active)(e))(i,t,o)&&((e,t,r)=>r(t)(e))(i,r,o)},ye=e=>me({...e,isVisibleThroughFrameFn:pe}),be=e=>me({...e,isVisibleThroughFrameFn:ge}),Ee=(e,t,r)=>{if("boolean"==typeof r)return r;if(!t)return!0;const{invisible:n,visible:o}=t;if(n[e])return!1;const i=o[e];return!i||i.shouldAnimate};function Oe({afterDragging:e,destination:t,displacedBy:r,viewport:n,forceShouldAnimate:o,last:i}){return e.reduce((function(e,a){const l=function(e,t){const r=e.page.marginBox,n={top:t.point.y,right:0,bottom:0,left:t.point.x};return f(p(r,n))}(a,r),u=a.descriptor.id;if(e.all.push(u),!ye({target:l,destination:t,viewport:n,withDroppableDisplacement:!0}))return e.invisible[a.descriptor.id]=!0,e;const s={draggableId:u,shouldAnimate:Ee(u,i,o)};return e.visible[u]=s,e}),{all:[],visible:{},invisible:{}})}function Se({insideDestination:e,inHomeList:t,displacedBy:r,destination:n}){const o=function(e,t){if(!e.length)return 0;const r=e[e.length-1].descriptor.index;return t.inHomeList?r:r+1}(e,{inHomeList:t});return{displaced:ce,displacedBy:r,at:{type:"REORDER",destination:{droppableId:n.descriptor.id,index:o}}}}function _e({draggable:e,insideDestination:t,destination:r,viewport:n,displacedBy:o,last:i,index:a,forceShouldAnimate:l}){const u=ue(e,r);if(null==a)return Se({insideDestination:t,inHomeList:u,displacedBy:o,destination:r});const s=t.find((e=>e.descriptor.index===a));if(!s)return Se({insideDestination:t,inHomeList:u,displacedBy:o,destination:r});const c=le(e,t),d=t.indexOf(s);return{displaced:Oe({afterDragging:c.slice(d),destination:r,displacedBy:o,last:i,viewport:n.frame,forceShouldAnimate:l}),displacedBy:o,at:{type:"REORDER",destination:{droppableId:r.descriptor.id,index:a}}}}function we(e,t){return Boolean(t.effected[e])}const Te=(e,t)=>t.margin[e.start]+t.borderBox[e.size]/2,Pe=(e,t,r)=>t[e.crossAxisStart]+r.margin[e.crossAxisStart]+r.borderBox[e.crossAxisSize]/2,Ce=({axis:e,moveRelativeTo:t,isMoving:r})=>H(e.line,t.marginBox[e.end]+Te(e,r),Pe(e,t.marginBox,r)),Ie=({axis:e,moveRelativeTo:t,isMoving:r})=>H(e.line,t.marginBox[e.start]-((e,t)=>t.margin[e.end]+t.borderBox[e.size]/2)(e,r),Pe(e,t.marginBox,r));var Ae=(e,t)=>{const r=e.frame;return r?B(t,r.scroll.diff.displacement):t},Re=e=>{const t=(({impact:e,draggable:t,droppable:r,draggables:n,afterCritical:o})=>{const i=t.page.borderBox.center,a=e.at;return r&&a?"REORDER"===a.type?(({impact:e,draggable:t,draggables:r,droppable:n,afterCritical:o})=>{const i=oe(n.descriptor.id,r),a=t.page,l=n.axis;if(!i.length)return(({axis:e,moveInto:t,isMoving:r})=>H(e.line,t.contentBox[e.start]+Te(e,r),Pe(e,t.contentBox,r)))({axis:l,moveInto:n.page,isMoving:a});const{displaced:u,displacedBy:s}=e,c=u.all[0];if(c){const e=r[c];if(we(c,o))return Ie({axis:l,moveRelativeTo:e.page,isMoving:a});const t=y(e.page,s.point);return Ie({axis:l,moveRelativeTo:t,isMoving:a})}const d=i[i.length-1];if(d.descriptor.id===t.descriptor.id)return a.borderBox.center;if(we(d.descriptor.id,o)){const e=y(d.page,G(o.displacedBy.point));return Ce({axis:l,moveRelativeTo:e,isMoving:a})}return Ce({axis:l,moveRelativeTo:d.page,isMoving:a})})({impact:e,draggable:t,draggables:n,droppable:r,afterCritical:o}):(({afterCritical:e,impact:t,draggables:r})=>{const n=ae(t);n||D();const o=n.draggableId,i=r[o].page.borderBox.center,a=(({displaced:e,afterCritical:t,combineWith:r,displacedBy:n})=>{const o=Boolean(e.visible[r]||e.invisible[r]);return we(r,t)?o?V:G(n.point):o?n.point:V})({displaced:t.displaced,afterCritical:e,combineWith:o,displacedBy:t.displacedBy});return B(i,a)})({impact:e,draggables:n,afterCritical:o}):i})(e),r=e.droppable;return r?Ae(r,t):t},xe=(e,t)=>{const r=U(t,e.scroll.initial),n=G(r);return{frame:f({top:t.y,bottom:t.y+e.frame.height,left:t.x,right:t.x+e.frame.width}),scroll:{initial:e.scroll.initial,max:e.scroll.max,current:t,diff:{value:r,displacement:n}}}};function Ne(e,t){return e.map((e=>t[e]))}var De=({pageBorderBoxCenter:e,draggable:t,viewport:r})=>{const n=((e,t)=>B(e.scroll.diff.displacement,t))(r,e),o=U(n,t.page.borderBox.center);return B(t.client.borderBox.center,o)},Le=({draggable:e,destination:t,newPageBorderBoxCenter:r,viewport:n,withDroppableDisplacement:o,onlyOnMainAxis:i=!1})=>{const a=U(r,e.page.borderBox.center),l={target:Y(e.page.borderBox,a),destination:t,withDroppableDisplacement:o,viewport:n};return i?(e=>{return me({...e,isVisibleThroughFrameFn:(t=e.destination.axis,e=>{const r=fe(e.top,e.bottom),n=fe(e.left,e.right);return e=>t===ve?r(e.top)&&r(e.bottom):n(e.left)&&n(e.right)})});var t})(l):be(l)},je=({isMovingForward:e,draggable:t,destination:r,draggables:n,previousImpact:o,viewport:i,previousPageBorderBoxCenter:a,previousClientSelection:l,afterCritical:u})=>{if(!r.isEnabled)return null;const s=oe(r.descriptor.id,n),c=ue(t,r),d=(({isMovingForward:e,draggable:t,destination:r,insideDestination:n,previousImpact:o})=>{if(!r.isCombineEnabled)return null;if(!ie(o))return null;function i(e){const t={type:"COMBINE",combine:{draggableId:e,droppableId:r.descriptor.id}};return{...o,at:t}}const a=o.displaced.all,l=a.length?a[0]:null;if(e)return l?i(l):null;const u=le(t,n);if(!l)return u.length?i(u[u.length-1].descriptor.id):null;const s=u.findIndex((e=>e.descriptor.id===l));-1===s&&D();const c=s-1;return c<0?null:i(u[c].descriptor.id)})({isMovingForward:e,draggable:t,destination:r,insideDestination:s,previousImpact:o})||(({isMovingForward:e,isInHomeList:t,draggable:r,draggables:n,destination:o,insideDestination:i,previousImpact:a,viewport:l,afterCritical:u})=>{const s=a.at;if(s||D(),"REORDER"===s.type){const n=(({isMovingForward:e,isInHomeList:t,insideDestination:r,location:n})=>{if(!r.length)return null;const o=n.index,i=e?o+1:o-1,a=r[0].descriptor.index,l=r[r.length-1].descriptor.index;return i<a||i>(t?l:l+1)?null:i})({isMovingForward:e,isInHomeList:t,location:s.destination,insideDestination:i});return null==n?null:_e({draggable:r,insideDestination:i,destination:o,viewport:l,last:a.displaced,displacedBy:a.displacedBy,index:n})}const c=(({isMovingForward:e,destination:t,draggables:r,combine:n,afterCritical:o})=>{if(!t.isCombineEnabled)return null;const i=n.draggableId,a=r[i].descriptor.index;return we(i,o)?e?a:a-1:e?a+1:a})({isMovingForward:e,destination:o,displaced:a.displaced,draggables:n,combine:s.combine,afterCritical:u});return null==c?null:_e({draggable:r,insideDestination:i,destination:o,viewport:l,last:a.displaced,displacedBy:a.displacedBy,index:c})})({isMovingForward:e,isInHomeList:c,draggable:t,draggables:n,destination:r,insideDestination:s,previousImpact:o,viewport:i,afterCritical:u});if(!d)return null;const f=Re({impact:d,draggable:t,droppable:r,draggables:n,afterCritical:u});if(Le({draggable:t,destination:r,newPageBorderBoxCenter:f,viewport:i.frame,withDroppableDisplacement:!1,onlyOnMainAxis:!0}))return{clientSelection:De({pageBorderBoxCenter:f,draggable:t,viewport:i}),impact:d,scrollJumpRequest:null};const p=U(f,a),g=(({impact:e,viewport:t,destination:r,draggables:n,maxScrollChange:o})=>{const i=xe(t,B(t.scroll.current,o)),a=r.frame?Z(r,B(r.frame.scroll.current,o)):r,l=e.displaced,u=Oe({afterDragging:Ne(l.all,n),destination:r,displacedBy:e.displacedBy,viewport:i.frame,last:l,forceShouldAnimate:!1}),s=Oe({afterDragging:Ne(l.all,n),destination:a,displacedBy:e.displacedBy,viewport:t.frame,last:l,forceShouldAnimate:!1}),c={},d={},f=[l,u,s];return l.all.forEach((e=>{const t=function(e,t){for(let r=0;r<t.length;r++){const n=t[r].visible[e];if(n)return n}return null}(e,f);t?d[e]=t:c[e]=!0})),{...e,displaced:{all:l.all,invisible:c,visible:d}}})({impact:d,viewport:i,destination:r,draggables:n,maxScrollChange:p});return{clientSelection:l,impact:g,scrollJumpRequest:p}};const Me=e=>{const t=e.subject.active;return t||D(),t},ke=(e,t)=>{const r=e.page.borderBox.center;return we(e.descriptor.id,t)?U(r,t.displacedBy.point):r},Fe=(e,t)=>{const r=e.page.borderBox;return we(e.descriptor.id,t)?Y(r,G(t.displacedBy.point)):r};var qe=w((function(e,t){const r=t[e.line];return{value:r,point:H(e.line,r)}}));const Ve=(e,t)=>({...e,scroll:{...e.scroll,max:t}}),Be=(e,t,r)=>{const n=e.frame;ue(t,e)&&D(),e.subject.withPlaceholder&&D();const o=qe(e.axis,t.displaceBy).point,i=((e,t,r)=>{const n=e.axis;if("virtual"===e.descriptor.mode)return H(n.line,t[n.line]);const o=e.subject.page.contentBox[n.size],i=oe(e.descriptor.id,r).reduce(((e,t)=>e+t.client.marginBox[n.size]),0)+t[n.line]-o;return i<=0?null:H(n.line,i)})(e,o,r),a={placeholderSize:o,increasedBy:i,oldFrameMaxScroll:e.frame?e.frame.scroll.max:null};if(!n){const t=J({page:e.subject.page,withPlaceholder:a,axis:e.axis,frame:e.frame});return{...e,subject:t}}const l=i?B(n.scroll.max,i):n.scroll.max,u=Ve(n,l),s=J({page:e.subject.page,withPlaceholder:a,axis:e.axis,frame:u});return{...e,subject:s,frame:u}};var Ue=e=>{const t=e.at;return t?"REORDER"===t.type?t.destination.droppableId:t.combine.droppableId:null},We=({state:e,type:t})=>{const r=((e,t)=>{const r=Ue(e);return r?t[r]:null})(e.impact,e.dimensions.droppables),n=Boolean(r),o=e.dimensions.droppables[e.critical.droppable.id],i=r||o,a=i.axis.direction,l="vertical"===a&&("MOVE_UP"===t||"MOVE_DOWN"===t)||"horizontal"===a&&("MOVE_LEFT"===t||"MOVE_RIGHT"===t);if(l&&!n)return null;const u="MOVE_DOWN"===t||"MOVE_RIGHT"===t,s=e.dimensions.draggables[e.critical.draggable.id],c=e.current.page.borderBoxCenter,{draggables:d,droppables:f}=e.dimensions;return l?je({isMovingForward:u,previousPageBorderBoxCenter:c,draggable:s,destination:i,draggables:d,viewport:e.viewport,previousClientSelection:e.current.client.selection,previousImpact:e.impact,afterCritical:e.afterCritical}):(({isMovingForward:e,previousPageBorderBoxCenter:t,draggable:r,isOver:n,draggables:o,droppables:i,viewport:a,afterCritical:l})=>{const u=(({isMovingForward:e,pageBorderBoxCenter:t,source:r,droppables:n,viewport:o})=>{const i=r.subject.active;if(!i)return null;const a=r.axis,l=fe(i[a.start],i[a.end]),u=re(n).filter((e=>e!==r)).filter((e=>e.isEnabled)).filter((e=>Boolean(e.subject.active))).filter((e=>pe(o.frame)(Me(e)))).filter((t=>{const r=Me(t);return e?i[a.crossAxisEnd]<r[a.crossAxisEnd]:r[a.crossAxisStart]<i[a.crossAxisStart]})).filter((e=>{const t=Me(e),r=fe(t[a.start],t[a.end]);return l(t[a.start])||l(t[a.end])||r(i[a.start])||r(i[a.end])})).sort(((t,r)=>{const n=Me(t)[a.crossAxisStart],o=Me(r)[a.crossAxisStart];return e?n-o:o-n})).filter(((e,t,r)=>Me(e)[a.crossAxisStart]===Me(r[0])[a.crossAxisStart]));if(!u.length)return null;if(1===u.length)return u[0];const s=u.filter((e=>fe(Me(e)[a.start],Me(e)[a.end])(t[a.line])));return 1===s.length?s[0]:s.length>1?s.sort(((e,t)=>Me(e)[a.start]-Me(t)[a.start]))[0]:u.sort(((e,r)=>{const n=$(t,Q(Me(e))),o=$(t,Q(Me(r)));return n!==o?n-o:Me(e)[a.start]-Me(r)[a.start]}))[0]})({isMovingForward:e,pageBorderBoxCenter:t,source:n,droppables:i,viewport:a});if(!u)return null;const s=oe(u.descriptor.id,o),c=(({pageBorderBoxCenter:e,viewport:t,destination:r,insideDestination:n,afterCritical:o})=>{const i=n.filter((e=>be({target:Fe(e,o),destination:r,viewport:t.frame,withDroppableDisplacement:!0}))).sort(((t,n)=>{const i=K(e,Ae(r,ke(t,o))),a=K(e,Ae(r,ke(n,o)));return i<a?-1:a<i?1:t.descriptor.index-n.descriptor.index}));return i[0]||null})({pageBorderBoxCenter:t,viewport:a,destination:u,insideDestination:s,afterCritical:l}),d=(({previousPageBorderBoxCenter:e,moveRelativeTo:t,insideDestination:r,draggable:n,draggables:o,destination:i,viewport:a,afterCritical:l})=>{if(!t){if(r.length)return null;const e={displaced:ce,displacedBy:se,at:{type:"REORDER",destination:{droppableId:i.descriptor.id,index:0}}},t=Re({impact:e,draggable:n,droppable:i,draggables:o,afterCritical:l}),u=ue(n,i)?i:Be(i,n,o);return Le({draggable:n,destination:u,newPageBorderBoxCenter:t,viewport:a.frame,withDroppableDisplacement:!1,onlyOnMainAxis:!0})?e:null}const u=Boolean(e[i.axis.line]<=t.page.borderBox.center[i.axis.line]),s=(()=>{const e=t.descriptor.index;return t.descriptor.id===n.descriptor.id||u?e:e+1})(),c=qe(i.axis,n.displaceBy);return _e({draggable:n,insideDestination:r,destination:i,viewport:a,displacedBy:c,last:ce,index:s})})({previousPageBorderBoxCenter:t,destination:u,draggable:r,draggables:o,moveRelativeTo:c,insideDestination:s,viewport:a,afterCritical:l});if(!d)return null;const f=Re({impact:d,draggable:r,droppable:u,draggables:o,afterCritical:l});return{clientSelection:De({pageBorderBoxCenter:f,draggable:r,viewport:a}),impact:d,scrollJumpRequest:null}})({isMovingForward:u,previousPageBorderBoxCenter:c,draggable:s,isOver:i,draggables:d,droppables:f,viewport:e.viewport,afterCritical:e.afterCritical})};function Ge(e){return"DRAGGING"===e.phase||"COLLECTING"===e.phase}function He(e){const t=fe(e.top,e.bottom),r=fe(e.left,e.right);return function(e){return t(e.y)&&r(e.x)}}const Ke=(e,t)=>f(Y(e,t));function $e({displaced:e,id:t}){return Boolean(e.visible[t]||e.invisible[t])}var ze=({pageOffset:e,draggable:t,draggables:r,droppables:n,previousImpact:o,viewport:i,afterCritical:a})=>{const l=Ke(t.page.borderBox,e),u=function({pageBorderBox:e,draggable:t,droppables:r}){const n=re(r).filter((t=>{if(!t.isEnabled)return!1;const r=t.subject.active;if(!r)return!1;if(o=r,!((n=e).left<o.right&&n.right>o.left&&n.top<o.bottom&&n.bottom>o.top))return!1;var n,o;if(He(r)(e.center))return!0;const i=t.axis,a=r.center[i.crossAxisLine],l=e[i.crossAxisStart],u=e[i.crossAxisEnd],s=fe(r[i.crossAxisStart],r[i.crossAxisEnd]),c=s(l),d=s(u);return!c&&!d||(c?l<a:u>a)}));return n.length?1===n.length?n[0].descriptor.id:function({pageBorderBox:e,draggable:t,candidates:r}){const n=t.page.borderBox.center,o=r.map((t=>{const r=t.axis,o=H(t.axis.line,e.center[r.line],t.page.borderBox.center[r.crossAxisLine]);return{id:t.descriptor.id,distance:K(n,o)}})).sort(((e,t)=>t.distance-e.distance));return o[0]?o[0].id:null}({pageBorderBox:e,draggable:t,candidates:n}):null}({pageBorderBox:l,draggable:t,droppables:n});if(!u)return de;const s=n[u],c=oe(s.descriptor.id,r),d=((e,t)=>{const r=e.frame;return r?Ke(t,r.scroll.diff.value):t})(s,l);return(({draggable:e,pageBorderBoxWithDroppableScroll:t,previousImpact:r,destination:n,insideDestination:o,afterCritical:i})=>{if(!n.isCombineEnabled)return null;const a=n.axis,l=qe(n.axis,e.displaceBy),u=l.value,s=t[a.start],c=t[a.end],d=le(e,o).find((e=>{const t=e.descriptor.id,n=e.page.borderBox,o=n[a.size]/4,l=we(t,i),d=$e({displaced:r.displaced,id:t});return l?d?c>n[a.start]+o&&c<n[a.end]-o:s>n[a.start]-u+o&&s<n[a.end]-u-o:d?c>n[a.start]+u+o&&c<n[a.end]+u-o:s>n[a.start]+o&&s<n[a.end]-o}));return d?{displacedBy:l,displaced:r.displaced,at:{type:"COMBINE",combine:{draggableId:d.descriptor.id,droppableId:n.descriptor.id}}}:null})({pageBorderBoxWithDroppableScroll:d,draggable:t,previousImpact:o,destination:s,insideDestination:c,afterCritical:a})||(({pageBorderBoxWithDroppableScroll:e,draggable:t,destination:r,insideDestination:n,last:o,viewport:i,afterCritical:a})=>{const l=r.axis,u=qe(r.axis,t.displaceBy),s=u.value,c=e[l.start],d=e[l.end],f=function({draggable:e,closest:t,inHomeList:r}){return t?r&&t.descriptor.index>e.descriptor.index?t.descriptor.index-1:t.descriptor.index:null}({draggable:t,closest:le(t,n).find((e=>{const t=e.descriptor.id,r=e.page.borderBox.center[l.line],n=we(t,a),i=$e({displaced:o,id:t});return n?i?d<=r:c<r-s:i?d<=r+s:c<r}))||null,inHomeList:ue(t,r)});return _e({draggable:t,insideDestination:n,destination:r,viewport:i,last:o,displacedBy:u,index:f})})({pageBorderBoxWithDroppableScroll:d,draggable:t,destination:s,insideDestination:c,last:o.displaced,viewport:i,afterCritical:a})},Ye=(e,t)=>({...e,[t.descriptor.id]:t});var Qe=({state:e,clientSelection:t,dimensions:r,viewport:n,impact:o,scrollJumpRequest:i})=>{const a=n||e.viewport,l=r||e.dimensions,u=t||e.current.client.selection,s=U(u,e.initial.client.selection),c={offset:s,selection:u,borderBoxCenter:B(e.initial.client.borderBoxCenter,s)},d={selection:B(c.selection,a.scroll.current),borderBoxCenter:B(c.borderBoxCenter,a.scroll.current),offset:B(c.offset,a.scroll.diff.value)},f={client:c,page:d};if("COLLECTING"===e.phase)return{...e,dimensions:l,viewport:a,current:f};const p=l.draggables[e.critical.draggable.id],g=o||ze({pageOffset:d.offset,draggable:p,draggables:l.draggables,droppables:l.droppables,previousImpact:e.impact,viewport:a,afterCritical:e.afterCritical}),v=(({draggable:e,draggables:t,droppables:r,previousImpact:n,impact:o})=>{const i=(({previousImpact:e,impact:t,droppables:r})=>{const n=Ue(e),o=Ue(t);if(!n)return r;if(n===o)return r;const i=r[n];if(!i.subject.withPlaceholder)return r;const a=(e=>{const t=e.subject.withPlaceholder;t||D();const r=e.frame;if(!r){const t=J({page:e.subject.page,axis:e.axis,frame:null,withPlaceholder:null});return{...e,subject:t}}const n=t.oldFrameMaxScroll;n||D();const o=Ve(r,n),i=J({page:e.subject.page,axis:e.axis,frame:o,withPlaceholder:null});return{...e,subject:i,frame:o}})(i);return Ye(r,a)})({previousImpact:n,impact:o,droppables:r}),a=Ue(o);if(!a)return i;const l=r[a];if(ue(e,l))return i;if(l.subject.withPlaceholder)return i;const u=Be(l,e,t);return Ye(i,u)})({draggable:p,impact:g,previousImpact:e.impact,draggables:l.draggables,droppables:l.droppables});return{...e,current:f,dimensions:{draggables:l.draggables,droppables:v},impact:g,viewport:a,scrollJumpRequest:i||null,forceShouldAnimate:!i&&null}},Xe=({impact:e,viewport:t,draggables:r,destination:n,forceShouldAnimate:o})=>{const i=e.displaced,a=function(e,t){return e.map((e=>t[e]))}(i.all,r),l=Oe({afterDragging:a,destination:n,displacedBy:e.displacedBy,viewport:t.frame,forceShouldAnimate:o,last:i});return{...e,displaced:l}},Je=({impact:e,draggable:t,droppable:r,draggables:n,viewport:o,afterCritical:i})=>{const a=Re({impact:e,draggable:t,draggables:n,droppable:r,afterCritical:i});return De({pageBorderBoxCenter:a,draggable:t,viewport:o})},Ze=({state:e,dimensions:t,viewport:r})=>{"SNAP"!==e.movementMode&&D();const n=e.impact,o=r||e.viewport,i=t||e.dimensions,{draggables:a,droppables:l}=i,u=a[e.critical.draggable.id],s=Ue(n);s||D();const c=l[s],d=Xe({impact:n,viewport:o,destination:c,draggables:a}),f=Je({impact:d,draggable:u,droppable:c,draggables:a,viewport:o,afterCritical:e.afterCritical});return Qe({impact:d,clientSelection:f,state:e,dimensions:i,viewport:o})},et=({draggable:e,home:t,draggables:r,viewport:n})=>{const o=qe(t.axis,e.displaceBy),i=oe(t.descriptor.id,r),a=i.indexOf(e);-1===a&&D();const l=i.slice(a+1),u=l.reduce(((e,t)=>(e[t.descriptor.id]=!0,e)),{}),s={inVirtualList:"virtual"===t.descriptor.mode,displacedBy:o,effected:u};var c;return{impact:{displaced:Oe({afterDragging:l,destination:t,displacedBy:o,last:null,viewport:n.frame,forceShouldAnimate:!1}),displacedBy:o,at:{type:"REORDER",destination:(c=e.descriptor,{index:c.index,droppableId:c.droppableId})}},afterCritical:s}};const tt=e=>"SNAP"===e.movementMode,rt=(e,t,r)=>{const n=((e,t)=>({draggables:e.draggables,droppables:Ye(e.droppables,t)}))(e.dimensions,t);return!tt(e)||r?Qe({state:e,dimensions:n}):Ze({state:e,dimensions:n})};function nt(e){return e.isDragging&&"SNAP"===e.movementMode?{...e,scrollJumpRequest:null}:e}const ot={phase:"IDLE",completed:null,shouldFlush:!1};var it=(e=ot,t)=>{if("FLUSH"===t.type)return{...ot,shouldFlush:!0};if("INITIAL_PUBLISH"===t.type){"IDLE"!==e.phase&&D();const{critical:r,clientSelection:n,viewport:o,dimensions:i,movementMode:a}=t.payload,l=i.draggables[r.draggable.id],u=i.droppables[r.droppable.id],s={selection:n,borderBoxCenter:l.client.borderBox.center,offset:V},c={client:s,page:{selection:B(s.selection,o.scroll.initial),borderBoxCenter:B(s.selection,o.scroll.initial),offset:B(s.selection,o.scroll.diff.value)}},d=re(i.droppables).every((e=>!e.isFixedOnPage)),{impact:f,afterCritical:p}=et({draggable:l,home:u,draggables:i.draggables,viewport:o});return{phase:"DRAGGING",isDragging:!0,critical:r,movementMode:a,dimensions:i,initial:c,current:c,isWindowScrollAllowed:d,impact:f,afterCritical:p,onLiftImpact:f,viewport:o,scrollJumpRequest:null,forceShouldAnimate:null}}if("COLLECTION_STARTING"===t.type)return"COLLECTING"===e.phase||"DROP_PENDING"===e.phase?e:("DRAGGING"!==e.phase&&D(),{...e,phase:"COLLECTING"});if("PUBLISH_WHILE_DRAGGING"===t.type)return"COLLECTING"!==e.phase&&"DROP_PENDING"!==e.phase&&D(),(({state:e,published:t})=>{const r=t.modified.map((t=>{const r=e.dimensions.droppables[t.droppableId];return Z(r,t.scroll)})),n={...e.dimensions.droppables,...ee(r)},o=te((({additions:e,updatedDroppables:t,viewport:r})=>{const n=r.scroll.diff.value;return e.map((e=>{const o=e.descriptor.droppableId,i=(e=>{const t=e.frame;return t||D(),t})(t[o]),a=i.scroll.diff.value,l=(({draggable:e,offset:t,initialWindowScroll:r})=>{const n=y(e.client,t),o=b(n,r);return{...e,placeholder:{...e.placeholder,client:n},client:n,page:o}})({draggable:e,offset:B(n,a),initialWindowScroll:r.scroll.initial});return l}))})({additions:t.additions,updatedDroppables:n,viewport:e.viewport})),i={...e.dimensions.draggables,...o};t.removals.forEach((e=>{delete i[e]}));const a={droppables:n,draggables:i},l=Ue(e.impact),u=l?a.droppables[l]:null,s=a.draggables[e.critical.draggable.id],c=a.droppables[e.critical.droppable.id],{impact:d,afterCritical:f}=et({draggable:s,home:c,draggables:i,viewport:e.viewport}),p=u&&u.isCombineEnabled?e.impact:d,g=ze({pageOffset:e.current.page.offset,draggable:a.draggables[e.critical.draggable.id],draggables:a.draggables,droppables:a.droppables,previousImpact:p,viewport:e.viewport,afterCritical:f}),v={...e,phase:"DRAGGING",impact:g,onLiftImpact:d,dimensions:a,afterCritical:f,forceShouldAnimate:!1};return"COLLECTING"===e.phase?v:{...v,phase:"DROP_PENDING",reason:e.reason,isWaiting:!1}})({state:e,published:t.payload});if("MOVE"===t.type){if("DROP_PENDING"===e.phase)return e;Ge(e)||D();const{client:r}=t.payload;return W(r,e.current.client.selection)?e:Qe({state:e,clientSelection:r,impact:tt(e)?e.impact:null})}if("UPDATE_DROPPABLE_SCROLL"===t.type){if("DROP_PENDING"===e.phase)return nt(e);if("COLLECTING"===e.phase)return nt(e);Ge(e)||D();const{id:r,newScroll:n}=t.payload,o=e.dimensions.droppables[r];if(!o)return e;const i=Z(o,n);return rt(e,i,!1)}if("UPDATE_DROPPABLE_IS_ENABLED"===t.type){if("DROP_PENDING"===e.phase)return e;Ge(e)||D();const{id:r,isEnabled:n}=t.payload,o=e.dimensions.droppables[r];o||D(),o.isEnabled===n&&D();const i={...o,isEnabled:n};return rt(e,i,!0)}if("UPDATE_DROPPABLE_IS_COMBINE_ENABLED"===t.type){if("DROP_PENDING"===e.phase)return e;Ge(e)||D();const{id:r,isCombineEnabled:n}=t.payload,o=e.dimensions.droppables[r];o||D(),o.isCombineEnabled===n&&D();const i={...o,isCombineEnabled:n};return rt(e,i,!0)}if("MOVE_BY_WINDOW_SCROLL"===t.type){if("DROP_PENDING"===e.phase||"DROP_ANIMATING"===e.phase)return e;Ge(e)||D(),e.isWindowScrollAllowed||D();const r=t.payload.newScroll;if(W(e.viewport.scroll.current,r))return nt(e);const n=xe(e.viewport,r);return tt(e)?Ze({state:e,viewport:n}):Qe({state:e,viewport:n})}if("UPDATE_VIEWPORT_MAX_SCROLL"===t.type){if(!Ge(e))return e;const r=t.payload.maxScroll;if(W(r,e.viewport.scroll.max))return e;const n={...e.viewport,scroll:{...e.viewport.scroll,max:r}};return{...e,viewport:n}}if("MOVE_UP"===t.type||"MOVE_DOWN"===t.type||"MOVE_LEFT"===t.type||"MOVE_RIGHT"===t.type){if("COLLECTING"===e.phase||"DROP_PENDING"===e.phase)return e;"DRAGGING"!==e.phase&&D();const r=We({state:e,type:t.type});return r?Qe({state:e,impact:r.impact,clientSelection:r.clientSelection,scrollJumpRequest:r.scrollJumpRequest}):e}if("DROP_PENDING"===t.type){const r=t.payload.reason;return"COLLECTING"!==e.phase&&D(),{...e,phase:"DROP_PENDING",isWaiting:!0,reason:r}}if("DROP_ANIMATE"===t.type){const{completed:r,dropDuration:n,newHomeClientOffset:o}=t.payload;return"DRAGGING"!==e.phase&&"DROP_PENDING"!==e.phase&&D(),{phase:"DROP_ANIMATING",completed:r,dropDuration:n,newHomeClientOffset:o,dimensions:e.dimensions}}if("DROP_COMPLETE"===t.type){const{completed:e}=t.payload;return{phase:"IDLE",completed:e,shouldFlush:!1}}return e};function at(e,t){return e instanceof Object&&"type"in e&&e.type===t}const lt=e=>({type:"LIFT",payload:e}),ut=e=>({type:"PUBLISH_WHILE_DRAGGING",payload:e}),st=()=>({type:"COLLECTION_STARTING",payload:null}),ct=e=>({type:"UPDATE_DROPPABLE_SCROLL",payload:e}),dt=e=>({type:"UPDATE_DROPPABLE_IS_ENABLED",payload:e}),ft=e=>({type:"UPDATE_DROPPABLE_IS_COMBINE_ENABLED",payload:e}),pt=e=>({type:"MOVE",payload:e}),gt=()=>({type:"MOVE_UP",payload:null}),vt=()=>({type:"MOVE_DOWN",payload:null}),ht=()=>({type:"MOVE_RIGHT",payload:null}),mt=()=>({type:"MOVE_LEFT",payload:null}),yt=()=>({type:"FLUSH",payload:null}),bt=e=>({type:"DROP_COMPLETE",payload:e}),Et=e=>({type:"DROP",payload:e}),Ot="cubic-bezier(.2,1,.1,1)",St=0,_t=.7,wt=.75,Tt={outOfTheWay:.2,minDropTime:.33,maxDropTime:.55},Pt=`${Tt.outOfTheWay}s cubic-bezier(0.2, 0, 0, 1)`,Ct={fluid:`opacity ${Pt}`,snap:`transform ${Pt}, opacity ${Pt}`,drop:e=>{const t=`${e}s ${Ot}`;return`transform ${t}, opacity ${t}`},outOfTheWay:`transform ${Pt}`,placeholder:`height ${Pt}, width ${Pt}, margin ${Pt}`},It=e=>W(e,V)?void 0:`translate(${e.x}px, ${e.y}px)`,At=It,Rt=(e,t)=>{const r=It(e);if(r)return t?`${r} scale(${wt})`:r},{minDropTime:xt,maxDropTime:Nt}=Tt,Dt=Nt-xt,Lt=({getState:e,dispatch:t})=>r=>n=>{if(!at(n,"DROP"))return void r(n);const o=e(),i=n.payload.reason;if("COLLECTING"===o.phase)return void t((a={reason:i},{type:"DROP_PENDING",payload:a}));var a;if("IDLE"===o.phase)return;"DROP_PENDING"===o.phase&&o.isWaiting&&D(),"DRAGGING"!==o.phase&&"DROP_PENDING"!==o.phase&&D();const l=o.critical,u=o.dimensions,s=u.draggables[o.critical.draggable.id],{impact:c,didDropInsideDroppable:d}=(({draggables:e,reason:t,lastImpact:r,home:n,viewport:o,onLiftImpact:i})=>r.at&&"DROP"===t?"REORDER"===r.at.type?{impact:r,didDropInsideDroppable:!0}:{impact:{...r,displaced:ce},didDropInsideDroppable:!0}:{impact:Xe({draggables:e,impact:i,destination:n,viewport:o,forceShouldAnimate:!0}),didDropInsideDroppable:!1})({reason:i,lastImpact:o.impact,afterCritical:o.afterCritical,onLiftImpact:o.onLiftImpact,home:o.dimensions.droppables[o.critical.droppable.id],viewport:o.viewport,draggables:o.dimensions.draggables}),f=d?ie(c):null,p=d?ae(c):null,g={index:l.draggable.index,droppableId:l.droppable.id},v={draggableId:s.descriptor.id,type:s.descriptor.type,source:g,reason:i,mode:o.movementMode,destination:f,combine:p},h=(({impact:e,draggable:t,dimensions:r,viewport:n,afterCritical:o})=>{const{draggables:i,droppables:a}=r,l=Ue(e),u=l?a[l]:null,s=a[t.descriptor.droppableId],c=Je({impact:e,draggable:t,draggables:i,afterCritical:o,droppable:u||s,viewport:n});return U(c,t.client.borderBox.center)})({impact:c,draggable:s,dimensions:u,viewport:o.viewport,afterCritical:o.afterCritical}),m={critical:o.critical,afterCritical:o.afterCritical,result:v,impact:c};if(W(o.current.client.offset,h)&&!Boolean(v.combine))return void t(bt({completed:m}));const y=(({current:e,destination:t,reason:r})=>{const n=K(e,t);if(n<=0)return xt;if(n>=1500)return Nt;const o=xt+Dt*(n/1500);return Number(("CANCEL"===r?.6*o:o).toFixed(2))})({current:o.current.client.offset,destination:h,reason:i});t((e=>({type:"DROP_ANIMATE",payload:e}))({newHomeClientOffset:h,dropDuration:y,completed:m}))};var jt=()=>({x:window.pageXOffset,y:window.pageYOffset});const Mt=e=>{const t=function({onWindowScroll:e}){const t=T((function(){e(jt())})),r=function(e){return{eventName:"scroll",options:{passive:!0,capture:!1},fn:t=>{t.target!==window&&t.target!==window.document||e()}}}(t);let n=I;function o(){return n!==I}return{start:function(){o()&&D(),n=A(window,[r])},stop:function(){o()||D(),t.cancel(),n(),n=I},isActive:o}}({onWindowScroll:t=>{e.dispatch({type:"MOVE_BY_WINDOW_SCROLL",payload:{newScroll:t}})}});return e=>r=>{!t.isActive()&&at(r,"INITIAL_PUBLISH")&&t.start(),t.isActive()&&(e=>at(e,"DROP_COMPLETE")||at(e,"DROP_ANIMATE")||at(e,"FLUSH"))(r)&&t.stop(),e(r)}};const kt=(e,t)=>{t()},Ft=(e,t)=>({draggableId:e.draggable.id,type:e.droppable.type,source:{droppableId:e.droppable.id,index:e.draggable.index},mode:t});function qt(e,t,r,n){if(!e)return void r(n(t));const o=(e=>{let t=!1,r=!1;const n=setTimeout((()=>{r=!0})),o=o=>{t||r||(t=!0,e(o),clearTimeout(n))};return o.wasCalled=()=>t,o})(r);e(t,{announce:o}),o.wasCalled()||r(n(t))}var Vt=(e,t)=>{const r=((e,t)=>{const r=(()=>{const e=[];return{add:t=>{const r=setTimeout((()=>(t=>{const r=e.findIndex((e=>e.timerId===t));-1===r&&D();const[n]=e.splice(r,1);n.callback()})(r))),n={timerId:r,callback:t};e.push(n)},flush:()=>{if(!e.length)return;const t=[...e];e.length=0,t.forEach((e=>{clearTimeout(e.timerId),e.callback()}))}}})();let n=null;const o=r=>{n||D(),n=null,kt(0,(()=>qt(e().onDragEnd,r,t,q.onDragEnd)))};return{beforeCapture:(t,r)=>{n&&D(),kt(0,(()=>{const n=e().onBeforeCapture;n&&n({draggableId:t,mode:r})}))},beforeStart:(t,r)=>{n&&D(),kt(0,(()=>{const n=e().onBeforeDragStart;n&&n(Ft(t,r))}))},start:(o,i)=>{n&&D();const a=Ft(o,i);n={mode:i,lastCritical:o,lastLocation:a.source,lastCombine:null},r.add((()=>{kt(0,(()=>qt(e().onDragStart,a,t,q.onDragStart)))}))},update:(o,i)=>{const a=ie(i),l=ae(i);n||D();const u=!((e,t)=>{if(e===t)return!0;const r=e.draggable.id===t.draggable.id&&e.draggable.droppableId===t.draggable.droppableId&&e.draggable.type===t.draggable.type&&e.draggable.index===t.draggable.index,n=e.droppable.id===t.droppable.id&&e.droppable.type===t.droppable.type;return r&&n})(o,n.lastCritical);u&&(n.lastCritical=o);const s=(d=a,!(null==(c=n.lastLocation)&&null==d||null!=c&&null!=d&&c.droppableId===d.droppableId&&c.index===d.index));var c,d;s&&(n.lastLocation=a);const f=!((e,t)=>null==e&&null==t||null!=e&&null!=t&&e.draggableId===t.draggableId&&e.droppableId===t.droppableId)(n.lastCombine,l);if(f&&(n.lastCombine=l),!u&&!s&&!f)return;const p={...Ft(o,n.mode),combine:l,destination:a};r.add((()=>{kt(0,(()=>qt(e().onDragUpdate,p,t,q.onDragUpdate)))}))},flush:()=>{n||D(),r.flush()},drop:o,abort:()=>{if(!n)return;const e={...Ft(n.lastCritical,n.mode),combine:null,destination:null,reason:"CANCEL"};o(e)}}})(e,t);return e=>t=>n=>{if(at(n,"BEFORE_INITIAL_CAPTURE"))return void r.beforeCapture(n.payload.draggableId,n.payload.movementMode);if(at(n,"INITIAL_PUBLISH")){const e=n.payload.critical;return r.beforeStart(e,n.payload.movementMode),t(n),void r.start(e,n.payload.movementMode)}if(at(n,"DROP_COMPLETE")){const e=n.payload.completed.result;return r.flush(),t(n),void r.drop(e)}if(t(n),at(n,"FLUSH"))return void r.abort();const o=e.getState();"DRAGGING"===o.phase&&r.update(o.critical,o.impact)}};const Bt=e=>t=>r=>{if(!at(r,"DROP_ANIMATION_FINISHED"))return void t(r);const n=e.getState();"DROP_ANIMATING"!==n.phase&&D(),e.dispatch(bt({completed:n.completed}))},Ut=e=>{let t=null,r=null;return n=>o=>{if((at(o,"FLUSH")||at(o,"DROP_COMPLETE")||at(o,"DROP_ANIMATION_FINISHED"))&&(r&&(cancelAnimationFrame(r),r=null),t&&(t(),t=null)),n(o),!at(o,"DROP_ANIMATE"))return;const i={eventName:"scroll",options:{capture:!0,passive:!1,once:!0},fn:function(){"DROP_ANIMATING"===e.getState().phase&&e.dispatch({type:"DROP_ANIMATION_FINISHED",payload:null})}};r=requestAnimationFrame((()=>{r=null,t=A(window,[i])}))}};const Wt=e=>t=>r=>{if(t(r),!at(r,"PUBLISH_WHILE_DRAGGING"))return;const n=e.getState();"DROP_PENDING"===n.phase&&(n.isWaiting||e.dispatch(Et({reason:n.reason})))},Gt=l.compose;var Ht=({dimensionMarshal:e,focusMarshal:t,styleMarshal:r,getResponders:n,announce:o,autoScroller:i})=>{return(0,l.createStore)(it,Gt((0,l.applyMiddleware)((a=r,()=>e=>t=>{at(t,"INITIAL_PUBLISH")&&a.dragging(),at(t,"DROP_ANIMATE")&&a.dropping(t.payload.completed.result.reason),(at(t,"FLUSH")||at(t,"DROP_COMPLETE"))&&a.resting(),e(t)}),(e=>()=>t=>r=>{(at(r,"DROP_COMPLETE")||at(r,"FLUSH")||at(r,"DROP_ANIMATE"))&&e.stopPublishing(),t(r)})(e),(e=>({getState:t,dispatch:r})=>n=>o=>{if(!at(o,"LIFT"))return void n(o);const{id:i,clientSelection:a,movementMode:l}=o.payload,u=t();"DROP_ANIMATING"===u.phase&&r(bt({completed:u.completed})),"IDLE"!==t().phase&&D(),r(yt()),r({type:"BEFORE_INITIAL_CAPTURE",payload:{draggableId:i,movementMode:l}});const s={draggableId:i,scrollOptions:{shouldPublishImmediately:"SNAP"===l}},{critical:c,dimensions:d,viewport:f}=e.startPublishing(s);r({type:"INITIAL_PUBLISH",payload:{critical:c,dimensions:d,clientSelection:a,movementMode:l,viewport:f}})})(e),Lt,Bt,Ut,Wt,(e=>t=>r=>n=>{if((e=>at(e,"DROP_COMPLETE")||at(e,"DROP_ANIMATE")||at(e,"FLUSH"))(n))return e.stop(),void r(n);if(at(n,"INITIAL_PUBLISH")){r(n);const o=t.getState();return"DRAGGING"!==o.phase&&D(),void e.start(o)}r(n),e.scroll(t.getState())})(i),Mt,(e=>{let t=!1;return()=>r=>n=>{if(at(n,"INITIAL_PUBLISH"))return t=!0,e.tryRecordFocus(n.payload.critical.draggable.id),r(n),void e.tryRestoreFocusRecorded();if(r(n),t){if(at(n,"FLUSH"))return t=!1,void e.tryRestoreFocusRecorded();if(at(n,"DROP_COMPLETE")){t=!1;const r=n.payload.completed.result;r.combine&&e.tryShiftRecord(r.draggableId,r.combine.draggableId),e.tryRestoreFocusRecorded()}}}})(t),Vt(n,o))));var a},Kt=({scrollHeight:e,scrollWidth:t,height:r,width:n})=>{const o=U({x:t,y:e},{x:n,y:r});return{x:Math.max(0,o.x),y:Math.max(0,o.y)}},$t=()=>{const e=document.documentElement;return e||D(),e},zt=()=>{const e=$t();return Kt({scrollHeight:e.scrollHeight,scrollWidth:e.scrollWidth,width:e.clientWidth,height:e.clientHeight})};function Yt(e,t,r){return r.descriptor.id!==t.id&&(r.descriptor.type===t.type&&"virtual"===e.droppable.getById(r.descriptor.droppableId).descriptor.mode)}var Qt=(e,t)=>{let r=null;const n=function({registry:e,callbacks:t}){let r={additions:{},removals:{},modified:{}},n=null;const o=()=>{n||(t.collectionStarting(),n=requestAnimationFrame((()=>{n=null;const{additions:o,removals:i,modified:a}=r,l=Object.keys(o).map((t=>e.draggable.getById(t).getDimension(V))).sort(((e,t)=>e.descriptor.index-t.descriptor.index)),u=Object.keys(a).map((t=>({droppableId:t,scroll:e.droppable.getById(t).callbacks.getScrollWhileDragging()}))),s={additions:l,removals:Object.keys(i),modified:u};r={additions:{},removals:{},modified:{}},t.publish(s)})))};return{add:e=>{const t=e.descriptor.id;r.additions[t]=e,r.modified[e.descriptor.droppableId]=!0,r.removals[t]&&delete r.removals[t],o()},remove:e=>{const t=e.descriptor;r.removals[t.id]=!0,r.modified[t.droppableId]=!0,r.additions[t.id]&&delete r.additions[t.id],o()},stop:()=>{n&&(cancelAnimationFrame(n),n=null,r={additions:{},removals:{},modified:{}})}}}({callbacks:{publish:t.publishWhileDragging,collectionStarting:t.collectionStarting},registry:e}),o=t=>{r||D();const o=r.critical.draggable;"ADDITION"===t.type&&Yt(e,o,t.value)&&n.add(t.value),"REMOVAL"===t.type&&Yt(e,o,t.value)&&n.remove(t.value)},i={updateDroppableIsEnabled:(n,o)=>{e.droppable.exists(n)||D(),r&&t.updateDroppableIsEnabled({id:n,isEnabled:o})},updateDroppableIsCombineEnabled:(n,o)=>{r&&(e.droppable.exists(n)||D(),t.updateDroppableIsCombineEnabled({id:n,isCombineEnabled:o}))},scrollDroppable:(t,n)=>{r&&e.droppable.getById(t).callbacks.scroll(n)},updateDroppableScroll:(n,o)=>{r&&(e.droppable.exists(n)||D(),t.updateDroppableScroll({id:n,newScroll:o}))},startPublishing:t=>{r&&D();const n=e.draggable.getById(t.draggableId),i=e.droppable.getById(n.descriptor.droppableId),a={draggable:n.descriptor,droppable:i.descriptor},l=e.subscribe(o);return r={critical:a,unsubscribe:l},(({critical:e,scrollOptions:t,registry:r})=>{const n=(()=>{const e=jt(),t=zt(),r=e.y,n=e.x,o=$t(),i=o.clientWidth,a=o.clientHeight;return{frame:f({top:r,left:n,right:n+i,bottom:r+a}),scroll:{initial:e,current:e,max:t,diff:{value:V,displacement:V}}}})(),o=n.scroll.current,i=e.droppable,a=r.droppable.getAllByType(i.type).map((e=>e.callbacks.getDimensionAndWatchScroll(o,t))),l=r.draggable.getAllByType(e.draggable.type).map((e=>e.getDimension(o)));return{dimensions:{draggables:te(l),droppables:ee(a)},critical:e,viewport:n}})({critical:a,registry:e,scrollOptions:t.scrollOptions})},stopPublishing:()=>{if(!r)return;n.stop();const t=r.critical.droppable;e.droppable.getAllByType(t.type).forEach((e=>e.callbacks.dragStopped())),r.unsubscribe(),r=null}};return i},Xt=(e,t)=>"IDLE"===e.phase||"DROP_ANIMATING"===e.phase&&e.completed.result.draggableId!==t&&"DROP"===e.completed.result.reason,Jt=e=>{window.scrollBy(e.x,e.y)};const Zt=w((e=>re(e).filter((e=>!!e.isEnabled&&!!e.frame))));const er={startFromPercentage:.25,maxScrollAtPercentage:.05,maxPixelScroll:28,ease:e=>e**2,durationDampening:{stopDampeningAt:1200,accelerateAt:360},disabled:!1};var tr=({startOfRange:e,endOfRange:t,current:r})=>{const n=t-e;return 0===n?0:(r-e)/n},rr=({distanceToEdge:e,thresholds:t,dragStartTime:r,shouldUseTimeDampening:n,getAutoScrollerOptions:o})=>{const i=((e,t,r=()=>er)=>{const n=r();if(e>t.startScrollingFrom)return 0;if(e<=t.maxScrollValueAt)return n.maxPixelScroll;if(e===t.startScrollingFrom)return 1;const o=1-tr({startOfRange:t.maxScrollValueAt,endOfRange:t.startScrollingFrom,current:e}),i=n.maxPixelScroll*n.ease(o);return Math.ceil(i)})(e,t,o);return 0===i?0:n?Math.max(((e,t,r)=>{const n=r(),o=n.durationDampening.accelerateAt,i=n.durationDampening.stopDampeningAt,a=t,l=i,u=Date.now()-a;if(u>=i)return e;if(u<o)return 1;const s=tr({startOfRange:o,endOfRange:l,current:u}),c=e*n.ease(s);return Math.ceil(c)})(i,r,o),1):i},nr=({container:e,distanceToEdges:t,dragStartTime:r,axis:n,shouldUseTimeDampening:o,getAutoScrollerOptions:i})=>{const a=((e,t,r=()=>er)=>{const n=r();return{startScrollingFrom:e[t.size]*n.startFromPercentage,maxScrollValueAt:e[t.size]*n.maxScrollAtPercentage}})(e,n,i);return t[n.end]<t[n.start]?rr({distanceToEdge:t[n.end],thresholds:a,dragStartTime:r,shouldUseTimeDampening:o,getAutoScrollerOptions:i}):-1*rr({distanceToEdge:t[n.start],thresholds:a,dragStartTime:r,shouldUseTimeDampening:o,getAutoScrollerOptions:i})};const or=z((e=>0===e?0:e));var ir=({dragStartTime:e,container:t,subject:r,center:n,shouldUseTimeDampening:o,getAutoScrollerOptions:i})=>{const a={top:n.y-t.top,right:t.right-n.x,bottom:t.bottom-n.y,left:n.x-t.left},l=nr({container:t,distanceToEdges:a,dragStartTime:e,axis:ve,shouldUseTimeDampening:o,getAutoScrollerOptions:i}),u=nr({container:t,distanceToEdges:a,dragStartTime:e,axis:he,shouldUseTimeDampening:o,getAutoScrollerOptions:i}),s=or({x:u,y:l});if(W(s,V))return null;const c=(({container:e,subject:t,proposedScroll:r})=>{const n=t.height>e.height,o=t.width>e.width;return o||n?o&&n?null:{x:o?0:r.x,y:n?0:r.y}:r})({container:t,subject:r,proposedScroll:s});return c?W(c,V)?null:c:null};const ar=z((e=>0===e?0:e>0?1:-1)),lr=(()=>{const e=(e,t)=>e<0?e:e>t?e-t:0;return({current:t,max:r,change:n})=>{const o=B(t,n),i={x:e(o.x,r.x),y:e(o.y,r.y)};return W(i,V)?null:i}})(),ur=({max:e,current:t,change:r})=>{const n={x:Math.max(t.x,e.x),y:Math.max(t.y,e.y)},o=ar(r),i=lr({max:n,current:t,change:o});return!i||0!==o.x&&0===i.x||0!==o.y&&0===i.y},sr=(e,t)=>ur({current:e.scroll.current,max:e.scroll.max,change:t}),cr=(e,t)=>{const r=e.frame;return!!r&&ur({current:r.scroll.current,max:r.scroll.max,change:t})};var dr=({state:e,dragStartTime:t,shouldUseTimeDampening:r,scrollWindow:n,scrollDroppable:o,getAutoScrollerOptions:i})=>{const a=e.current.page.borderBoxCenter,l=e.dimensions.draggables[e.critical.draggable.id].page.marginBox;if(e.isWindowScrollAllowed){const o=(({viewport:e,subject:t,center:r,dragStartTime:n,shouldUseTimeDampening:o,getAutoScrollerOptions:i})=>{const a=ir({dragStartTime:n,container:e.frame,subject:t,center:r,shouldUseTimeDampening:o,getAutoScrollerOptions:i});return a&&sr(e,a)?a:null})({dragStartTime:t,viewport:e.viewport,subject:l,center:a,shouldUseTimeDampening:r,getAutoScrollerOptions:i});if(o)return void n(o)}const u=(({center:e,destination:t,droppables:r})=>{if(t){const e=r[t];return e.frame?e:null}const n=((e,t)=>{const r=Zt(t).find((t=>(t.frame||D(),He(t.frame.pageMarginBox)(e))))||null;return r})(e,r);return n})({center:a,destination:Ue(e.impact),droppables:e.dimensions.droppables});if(!u)return;const s=(({droppable:e,subject:t,center:r,dragStartTime:n,shouldUseTimeDampening:o,getAutoScrollerOptions:i})=>{const a=e.frame;if(!a)return null;const l=ir({dragStartTime:n,container:a.pageMarginBox,subject:t,center:r,shouldUseTimeDampening:o,getAutoScrollerOptions:i});return l&&cr(e,l)?l:null})({dragStartTime:t,droppable:u,subject:l,center:a,shouldUseTimeDampening:r,getAutoScrollerOptions:i});s&&o(u.descriptor.id,s)},fr=({move:e,scrollDroppable:t,scrollWindow:r})=>n=>{const o=n.scrollJumpRequest;if(!o)return;const i=Ue(n.impact);i||D();const a=((e,r)=>{if(!cr(e,r))return r;const n=((e,t)=>{const r=e.frame;return r&&cr(e,t)?lr({current:r.scroll.current,max:r.scroll.max,change:t}):null})(e,r);if(!n)return t(e.descriptor.id,r),null;const o=U(r,n);return t(e.descriptor.id,o),U(r,o)})(n.dimensions.droppables[i],o);if(!a)return;const l=n.viewport,u=((e,t,n)=>{if(!e)return n;if(!sr(t,n))return n;const o=((e,t)=>{if(!sr(e,t))return null;const r=e.scroll.max,n=e.scroll.current;return lr({current:n,max:r,change:t})})(t,n);if(!o)return r(n),null;const i=U(n,o);return r(i),U(n,i)})(n.isWindowScrollAllowed,l,a);u&&((t,r)=>{const n=B(t.current.client.selection,r);e({client:n})})(n,u)},pr=({scrollDroppable:e,scrollWindow:t,move:r,getAutoScrollerOptions:n})=>{const o=(({scrollWindow:e,scrollDroppable:t,getAutoScrollerOptions:r=()=>er})=>{const n=T(e),o=T(t);let i=null;const a=e=>{i||D();const{shouldUseTimeDampening:t,dragStartTime:a}=i;dr({state:e,scrollWindow:n,scrollDroppable:o,dragStartTime:a,shouldUseTimeDampening:t,getAutoScrollerOptions:r})};return{start:e=>{i&&D();const t=Date.now();let n=!1;const o=()=>{n=!0};dr({state:e,dragStartTime:0,shouldUseTimeDampening:!1,scrollWindow:o,scrollDroppable:o,getAutoScrollerOptions:r}),i={dragStartTime:t,shouldUseTimeDampening:n},n&&a(e)},stop:()=>{i&&(n.cancel(),o.cancel(),i=null)},scroll:a}})({scrollWindow:t,scrollDroppable:e,getAutoScrollerOptions:n}),i=fr({move:r,scrollWindow:t,scrollDroppable:e});return{scroll:e=>{n().disabled||"DRAGGING"!==e.phase||("FLUID"!==e.movementMode?e.scrollJumpRequest&&i(e):o.scroll(e))},start:o.start,stop:o.stop}};const gr="data-rfd",vr=(()=>{const e=`${gr}-drag-handle`;return{base:e,draggableId:`${e}-draggable-id`,contextId:`${e}-context-id`}})(),hr=(()=>{const e=`${gr}-draggable`;return{base:e,contextId:`${e}-context-id`,id:`${e}-id`}})(),mr=(()=>{const e=`${gr}-droppable`;return{base:e,contextId:`${e}-context-id`,id:`${e}-id`}})(),yr={contextId:`${gr}-scroll-container-context-id`},br=(e,t)=>e.map((e=>{const r=e.styles[t];return r?`${e.selector} { ${r} }`:""})).join(" ");var Er=e=>{const t=(r=e,e=>`[${e}="${r}"]`);var r;const n=(()=>{const e="\n      cursor: -webkit-grab;\n      cursor: grab;\n    ";return{selector:t(vr.contextId),styles:{always:"\n          -webkit-touch-callout: none;\n          -webkit-tap-highlight-color: rgba(0,0,0,0);\n          touch-action: manipulation;\n        ",resting:e,dragging:"pointer-events: none;",dropAnimating:e}}})(),o=[(()=>{const e=`\n      transition: ${Ct.outOfTheWay};\n    `;return{selector:t(hr.contextId),styles:{dragging:e,dropAnimating:e,userCancel:e}}})(),n,{selector:t(mr.contextId),styles:{always:"overflow-anchor: none;"}},{selector:"body",styles:{dragging:"\n        cursor: grabbing;\n        cursor: -webkit-grabbing;\n        user-select: none;\n        -webkit-user-select: none;\n        -moz-user-select: none;\n        -ms-user-select: none;\n        overflow-anchor: none;\n      "}}];return{always:br(o,"always"),resting:br(o,"resting"),dragging:br(o,"dragging"),dropAnimating:br(o,"dropAnimating"),userCancel:br(o,"userCancel")}};const Or="undefined"!=typeof window&&void 0!==window.document&&void 0!==window.document.createElement?n.useLayoutEffect:n.useEffect,Sr=()=>{const e=document.querySelector("head");return e||D(),e},_r=e=>{const t=document.createElement("style");return e&&t.setAttribute("nonce",e),t.type="text/css",t};function wr(e,t){return Array.from(e.querySelectorAll(t))}var Tr=e=>e&&e.ownerDocument&&e.ownerDocument.defaultView?e.ownerDocument.defaultView:window;function Pr(e){return e instanceof Tr(e).HTMLElement}function Cr(){const e={draggables:{},droppables:{}},t=[];function r(e){t.length&&t.forEach((t=>t(e)))}function n(t){return e.draggables[t]||null}function o(t){return e.droppables[t]||null}return{draggable:{register:t=>{e.draggables[t.descriptor.id]=t,r({type:"ADDITION",value:t})},update:(t,r)=>{const n=e.draggables[r.descriptor.id];n&&n.uniqueId===t.uniqueId&&(delete e.draggables[r.descriptor.id],e.draggables[t.descriptor.id]=t)},unregister:t=>{const o=t.descriptor.id,i=n(o);i&&t.uniqueId===i.uniqueId&&(delete e.draggables[o],e.droppables[t.descriptor.droppableId]&&r({type:"REMOVAL",value:t}))},getById:function(e){const t=n(e);return t||D(),t},findById:n,exists:e=>Boolean(n(e)),getAllByType:t=>Object.values(e.draggables).filter((e=>e.descriptor.type===t))},droppable:{register:t=>{e.droppables[t.descriptor.id]=t},unregister:t=>{const r=o(t.descriptor.id);r&&t.uniqueId===r.uniqueId&&delete e.droppables[t.descriptor.id]},getById:function(e){const t=o(e);return t||D(),t},findById:o,exists:e=>Boolean(o(e)),getAllByType:t=>Object.values(e.droppables).filter((e=>e.descriptor.type===t))},subscribe:function(e){return t.push(e),function(){const r=t.indexOf(e);-1!==r&&t.splice(r,1)}},clean:function(){e.draggables={},e.droppables={},t.length=0}}}var Ir=o().createContext(null),Ar=()=>{const e=document.body;return e||D(),e};const Rr={position:"absolute",width:"1px",height:"1px",margin:"-1px",border:"0",padding:"0",overflow:"hidden",clip:"rect(0 0 0 0)","clip-path":"inset(100%)"},xr=e=>`rfd-announcement-${e}`,Nr={separator:"::"};function Dr(e,t=Nr){const r=o().useId();return c((()=>`${e}${t.separator}${r}`),[t.separator,e,r])}var Lr=o().createContext(null);function jr(e){const t=(0,n.useRef)(e);return(0,n.useEffect)((()=>{t.current=e})),t}function Mr(e){return"IDLE"!==e.phase&&"DROP_ANIMATING"!==e.phase&&e.isDragging}const kr=9,Fr=13,qr=27,Vr=32,Br=33,Ur=34,Wr=35,Gr=36,Hr=37,Kr=38,$r=39,zr=40,Yr={[Fr]:!0,[kr]:!0};var Qr=e=>{Yr[e.keyCode]&&e.preventDefault()};const Xr=(()=>{const e="visibilitychange";return"undefined"==typeof document?e:[e,`ms${e}`,`webkit${e}`,`moz${e}`,`o${e}`].find((e=>`on${e}`in document))||e})(),Jr=0,Zr=5,en={type:"IDLE"};function tn(e){const t=(0,n.useRef)(en),r=(0,n.useRef)(I),o=c((()=>({eventName:"mousedown",fn:function(t){if(t.defaultPrevented)return;if(t.button!==Jr)return;if(t.ctrlKey||t.metaKey||t.shiftKey||t.altKey)return;const n=e.findClosestDraggableId(t);if(!n)return;const o=e.tryGetLock(n,l,{sourceEvent:t});if(!o)return;t.preventDefault();const i={x:t.clientX,y:t.clientY};r.current(),f(o,i)}})),[e]),i=c((()=>({eventName:"webkitmouseforcewillbegin",fn:t=>{if(t.defaultPrevented)return;const r=e.findClosestDraggableId(t);if(!r)return;const n=e.findOptionsForDraggable(r);n&&(n.shouldRespectForcePress||e.canGetLock(r)&&t.preventDefault())}})),[e]),a=d((function(){r.current=A(window,[i,o],{passive:!1,capture:!0})}),[i,o]),l=d((()=>{"IDLE"!==t.current.type&&(t.current=en,r.current(),a())}),[a]),u=d((()=>{const e=t.current;l(),"DRAGGING"===e.type&&e.actions.cancel({shouldBlockNextClick:!0}),"PENDING"===e.type&&e.actions.abort()}),[l]),s=d((function(){const e=function({cancel:e,completed:t,getPhase:r,setPhase:n}){return[{eventName:"mousemove",fn:e=>{const{button:t,clientX:o,clientY:i}=e;if(t!==Jr)return;const a={x:o,y:i},l=r();if("DRAGGING"===l.type)return e.preventDefault(),void l.actions.move(a);if("PENDING"!==l.type&&D(),u=l.point,s=a,!(Math.abs(s.x-u.x)>=Zr||Math.abs(s.y-u.y)>=Zr))return;var u,s;e.preventDefault();const c=l.actions.fluidLift(a);n({type:"DRAGGING",actions:c})}},{eventName:"mouseup",fn:n=>{const o=r();"DRAGGING"===o.type?(n.preventDefault(),o.actions.drop({shouldBlockNextClick:!0}),t()):e()}},{eventName:"mousedown",fn:t=>{"DRAGGING"===r().type&&t.preventDefault(),e()}},{eventName:"keydown",fn:t=>{if("PENDING"!==r().type)return t.keyCode===qr?(t.preventDefault(),void e()):void Qr(t);e()}},{eventName:"resize",fn:e},{eventName:"scroll",options:{passive:!0,capture:!1},fn:()=>{"PENDING"===r().type&&e()}},{eventName:"webkitmouseforcedown",fn:t=>{const n=r();"IDLE"===n.type&&D(),n.actions.shouldRespectForcePress()?e():t.preventDefault()}},{eventName:Xr,fn:e}]}({cancel:u,completed:l,getPhase:()=>t.current,setPhase:e=>{t.current=e}});r.current=A(window,e,{capture:!0,passive:!1})}),[u,l]),f=d((function(e,r){"IDLE"!==t.current.type&&D(),t.current={type:"PENDING",point:r,actions:e},s()}),[s]);Or((function(){return a(),function(){r.current()}}),[a])}function rn(){}const nn={[Ur]:!0,[Br]:!0,[Gr]:!0,[Wr]:!0};function on(e){const t=(0,n.useRef)(rn),r=c((()=>({eventName:"keydown",fn:function(r){if(r.defaultPrevented)return;if(r.keyCode!==Vr)return;const n=e.findClosestDraggableId(r);if(!n)return;const i=e.tryGetLock(n,u,{sourceEvent:r});if(!i)return;r.preventDefault();let a=!0;const l=i.snapLift();function u(){a||D(),a=!1,t.current(),o()}t.current(),t.current=A(window,function(e,t){function r(){t(),e.cancel()}return[{eventName:"keydown",fn:n=>n.keyCode===qr?(n.preventDefault(),void r()):n.keyCode===Vr?(n.preventDefault(),t(),void e.drop()):n.keyCode===zr?(n.preventDefault(),void e.moveDown()):n.keyCode===Kr?(n.preventDefault(),void e.moveUp()):n.keyCode===$r?(n.preventDefault(),void e.moveRight()):n.keyCode===Hr?(n.preventDefault(),void e.moveLeft()):void(nn[n.keyCode]?n.preventDefault():Qr(n))},{eventName:"mousedown",fn:r},{eventName:"mouseup",fn:r},{eventName:"click",fn:r},{eventName:"touchstart",fn:r},{eventName:"resize",fn:r},{eventName:"wheel",fn:r,options:{passive:!0}},{eventName:Xr,fn:r}]}(l,u),{capture:!0,passive:!1})}})),[e]),o=d((function(){t.current=A(window,[r],{passive:!1,capture:!0})}),[r]);Or((function(){return o(),function(){t.current()}}),[o])}const an={type:"IDLE"},ln=120,un=.15;function sn(e){const t=(0,n.useRef)(an),r=(0,n.useRef)(I),o=d((function(){return t.current}),[]),i=d((function(e){t.current=e}),[]),a=c((()=>({eventName:"touchstart",fn:function(t){if(t.defaultPrevented)return;const n=e.findClosestDraggableId(t);if(!n)return;const o=e.tryGetLock(n,u,{sourceEvent:t});if(!o)return;const i=t.touches[0],{clientX:a,clientY:l}=i,s={x:a,y:l};r.current(),g(o,s)}})),[e]),l=d((function(){r.current=A(window,[a],{capture:!0,passive:!1})}),[a]),u=d((()=>{const e=t.current;"IDLE"!==e.type&&("PENDING"===e.type&&clearTimeout(e.longPressTimerId),i(an),r.current(),l())}),[l,i]),s=d((()=>{const e=t.current;u(),"DRAGGING"===e.type&&e.actions.cancel({shouldBlockNextClick:!0}),"PENDING"===e.type&&e.actions.abort()}),[u]),f=d((function(){const e={capture:!0,passive:!1},t={cancel:s,completed:u,getPhase:o},n=A(window,function({cancel:e,completed:t,getPhase:r}){return[{eventName:"touchmove",options:{capture:!1},fn:t=>{const n=r();if("DRAGGING"!==n.type)return void e();n.hasMoved=!0;const{clientX:o,clientY:i}=t.touches[0],a={x:o,y:i};t.preventDefault(),n.actions.move(a)}},{eventName:"touchend",fn:n=>{const o=r();"DRAGGING"===o.type?(n.preventDefault(),o.actions.drop({shouldBlockNextClick:!0}),t()):e()}},{eventName:"touchcancel",fn:t=>{"DRAGGING"===r().type?(t.preventDefault(),e()):e()}},{eventName:"touchforcechange",fn:t=>{const n=r();"IDLE"===n.type&&D();const o=t.touches[0];if(!o)return;if(!(o.force>=un))return;const i=n.actions.shouldRespectForcePress();if("PENDING"!==n.type)return i?n.hasMoved?void t.preventDefault():void e():void t.preventDefault();i&&e()}},{eventName:Xr,fn:e}]}(t),e),i=A(window,function({cancel:e,getPhase:t}){return[{eventName:"orientationchange",fn:e},{eventName:"resize",fn:e},{eventName:"contextmenu",fn:e=>{e.preventDefault()}},{eventName:"keydown",fn:r=>{"DRAGGING"===t().type?(r.keyCode===qr&&r.preventDefault(),e()):e()}},{eventName:Xr,fn:e}]}(t),e);r.current=function(){n(),i()}}),[s,o,u]),p=d((function(){const e=o();"PENDING"!==e.type&&D();const t=e.actions.fluidLift(e.point);i({type:"DRAGGING",actions:t,hasMoved:!1})}),[o,i]),g=d((function(e,t){"IDLE"!==o().type&&D();const r=setTimeout(p,ln);i({type:"PENDING",point:t,actions:e,longPressTimerId:r}),f()}),[f,o,i,p]);Or((function(){return l(),function(){r.current();const e=o();"PENDING"===e.type&&(clearTimeout(e.longPressTimerId),i(an))}}),[o,l,i]),Or((function(){return A(window,[{eventName:"touchmove",fn:()=>{},options:{capture:!1,passive:!1}}])}),[])}const cn=["input","button","textarea","select","option","optgroup","video","audio"];function dn(e,t){if(null==t)return!1;if(cn.includes(t.tagName.toLowerCase()))return!0;const r=t.getAttribute("contenteditable");return"true"===r||""===r||t!==e&&dn(e,t.parentElement)}function fn(e,t){const r=t.target;return!!Pr(r)&&dn(e,r)}var pn=e=>f(e.getBoundingClientRect()).center;const gn=(()=>{const e="matches";return"undefined"==typeof document?e:[e,"msMatchesSelector","webkitMatchesSelector"].find((e=>e in Element.prototype))||e})();function vn(e,t){return null==e?null:e[gn](t)?e:vn(e.parentElement,t)}function hn(e,t){return e.closest?e.closest(t):vn(e,t)}function mn(e){e.preventDefault()}function yn({expected:e,phase:t,isLockActive:r,shouldWarn:n}){return!!r()&&e===t}function bn({lockAPI:e,store:t,registry:r,draggableId:n}){if(e.isClaimed())return!1;const o=r.draggable.findById(n);return!!o&&!!o.options.isEnabled&&!!Xt(t.getState(),n)}const En=[tn,on,sn];function On({contextId:e,store:t,registry:r,customSensors:o,enableDefaultSensors:i}){const a=[...i?En:[],...o||[]],l=(0,n.useState)((()=>function(){let e=null;function t(){e||D(),e=null}return{isClaimed:function(){return Boolean(e)},isActive:function(t){return t===e},claim:function(t){e&&D();const r={abandon:t};return e=r,r},release:t,tryAbandon:function(){e&&(e.abandon(),t())}}}()))[0],u=d((function(e,t){Mr(e)&&!Mr(t)&&l.tryAbandon()}),[l]);Or((function(){let e=t.getState();return t.subscribe((()=>{const r=t.getState();u(e,r),e=r}))}),[l,t,u]),Or((()=>l.tryAbandon),[l.tryAbandon]);const s=d((e=>bn({lockAPI:l,registry:r,store:t,draggableId:e})),[l,r,t]),f=d(((n,o,i)=>function({lockAPI:e,contextId:t,store:r,registry:n,draggableId:o,forceSensorStop:i,sourceEvent:a}){if(!bn({lockAPI:e,store:r,registry:n,draggableId:o}))return null;const l=n.draggable.getById(o),u=function(e,t){const r=`[${hr.contextId}="${e}"]`,n=wr(document,r).find((e=>e.getAttribute(hr.id)===t));return n&&Pr(n)?n:null}(t,l.descriptor.id);if(!u)return null;if(a&&!l.options.canDragInteractiveElements&&fn(u,a))return null;const s=e.claim(i||I);let c="PRE_DRAG";function d(){return l.options.shouldRespectForcePress}function f(){return e.isActive(s)}const p=function(e,t){yn({expected:e,phase:c,isLockActive:f,shouldWarn:!0})&&r.dispatch(t())}.bind(null,"DRAGGING");function g(t){function n(){e.release(),c="COMPLETED"}function o(e,o={shouldBlockNextClick:!1}){if(t.cleanup(),o.shouldBlockNextClick){const e=A(window,[{eventName:"click",fn:mn,options:{once:!0,passive:!1,capture:!0}}]);setTimeout(e)}n(),r.dispatch(Et({reason:e}))}return"PRE_DRAG"!==c&&(n(),D()),r.dispatch(lt(t.liftActionArgs)),c="DRAGGING",{isActive:()=>yn({expected:"DRAGGING",phase:c,isLockActive:f,shouldWarn:!1}),shouldRespectForcePress:d,drop:e=>o("DROP",e),cancel:e=>o("CANCEL",e),...t.actions}}return{isActive:()=>yn({expected:"PRE_DRAG",phase:c,isLockActive:f,shouldWarn:!1}),shouldRespectForcePress:d,fluidLift:function(e){const t=T((e=>{p((()=>pt({client:e})))}));return{...g({liftActionArgs:{id:o,clientSelection:e,movementMode:"FLUID"},cleanup:()=>t.cancel(),actions:{move:t}}),move:t}},snapLift:function(){const e={moveUp:()=>p(gt),moveRight:()=>p(ht),moveDown:()=>p(vt),moveLeft:()=>p(mt)};return g({liftActionArgs:{id:o,clientSelection:pn(u),movementMode:"SNAP"},cleanup:I,actions:e})},abort:function(){yn({expected:"PRE_DRAG",phase:c,isLockActive:f,shouldWarn:!0})&&e.release()}}}({lockAPI:l,registry:r,contextId:e,store:t,draggableId:n,forceSensorStop:o||null,sourceEvent:i&&i.sourceEvent?i.sourceEvent:null})),[e,l,r,t]),p=d((t=>function(e,t){const r=function(e,t){const r=t.target;if(!((n=r)instanceof Tr(n).Element))return null;var n;const o=function(e){return`[${vr.contextId}="${e}"]`}(e),i=hn(r,o);return i&&Pr(i)?i:null}(e,t);return r?r.getAttribute(vr.draggableId):null}(e,t)),[e]),g=d((e=>{const t=r.draggable.findById(e);return t?t.options:null}),[r.draggable]),v=d((function(){l.isClaimed()&&(l.tryAbandon(),"IDLE"!==t.getState().phase&&t.dispatch(yt()))}),[l,t]),h=d((()=>l.isClaimed()),[l]),m=c((()=>({canGetLock:s,tryGetLock:f,findClosestDraggableId:p,findOptionsForDraggable:g,tryReleaseLock:v,isLockClaimed:h})),[s,f,p,g,v,h]);for(let e=0;e<a.length;e++)a[e](m)}const Sn=e=>({onBeforeCapture:t=>{(0,i.flushSync)((()=>{e.onBeforeCapture&&e.onBeforeCapture(t)}))},onBeforeDragStart:e.onBeforeDragStart,onDragStart:e.onDragStart,onDragEnd:e.onDragEnd,onDragUpdate:e.onDragUpdate}),_n=e=>({...er,...e.autoScrollerOptions,durationDampening:{...er.durationDampening,...e.autoScrollerOptions}});function wn(e){return e.current||D(),e.current}function Tn(e){const{contextId:t,setCallbacks:r,sensors:i,nonce:a,dragHandleUsageInstructions:s}=e,f=(0,n.useRef)(null),p=jr(e),g=d((()=>Sn(p.current)),[p]),v=d((()=>_n(p.current)),[p]),h=function(e){const t=c((()=>xr(e)),[e]),r=(0,n.useRef)(null);return(0,n.useEffect)((function(){const e=document.createElement("div");return r.current=e,e.id=t,e.setAttribute("aria-live","assertive"),e.setAttribute("aria-atomic","true"),P(e.style,Rr),Ar().appendChild(e),function(){setTimeout((function(){const t=Ar();t.contains(e)&&t.removeChild(e),e===r.current&&(r.current=null)}))}}),[t]),d((e=>{const t=r.current;t&&(t.textContent=e)}),[])}(t),m=function({contextId:e,text:t}){const r=Dr("hidden-text",{separator:"-"}),o=c((()=>function({contextId:e,uniqueId:t}){return`rfd-hidden-text-${e}-${t}`}({contextId:e,uniqueId:r})),[r,e]);return(0,n.useEffect)((function(){const e=document.createElement("div");return e.id=o,e.textContent=t,e.style.display="none",Ar().appendChild(e),function(){const t=Ar();t.contains(e)&&t.removeChild(e)}}),[o,t]),o}({contextId:t,text:s}),y=function(e,t){const r=c((()=>Er(e)),[e]),o=(0,n.useRef)(null),i=(0,n.useRef)(null),a=d(w((e=>{const t=i.current;t||D(),t.textContent=e})),[]),l=d((e=>{const t=o.current;t||D(),t.textContent=e}),[]);Or((()=>{(o.current||i.current)&&D();const n=_r(t),u=_r(t);return o.current=n,i.current=u,n.setAttribute(`${gr}-always`,e),u.setAttribute(`${gr}-dynamic`,e),Sr().appendChild(n),Sr().appendChild(u),l(r.always),a(r.resting),()=>{const e=e=>{const t=e.current;t||D(),Sr().removeChild(t),e.current=null};e(o),e(i)}}),[t,l,a,r.always,r.resting,e]);const u=d((()=>a(r.dragging)),[a,r.dragging]),s=d((e=>{a("DROP"!==e?r.userCancel:r.dropAnimating)}),[a,r.dropAnimating,r.userCancel]),f=d((()=>{i.current&&a(r.resting)}),[a,r.resting]);return c((()=>({dragging:u,dropping:s,resting:f})),[u,s,f])}(t,a),b=d((e=>{wn(f).dispatch(e)}),[]),E=c((()=>(0,l.bindActionCreators)({publishWhileDragging:ut,updateDroppableScroll:ct,updateDroppableIsEnabled:dt,updateDroppableIsCombineEnabled:ft,collectionStarting:st},b)),[b]),O=function(){const e=c(Cr,[]);return(0,n.useEffect)((()=>function(){e.clean()}),[e]),e}(),S=c((()=>Qt(O,E)),[O,E]),_=c((()=>pr({scrollWindow:Jt,scrollDroppable:S.scrollDroppable,getAutoScrollerOptions:v,...(0,l.bindActionCreators)({move:pt},b)})),[S.scrollDroppable,b,v]),T=function(e){const t=(0,n.useRef)({}),r=(0,n.useRef)(null),o=(0,n.useRef)(null),i=(0,n.useRef)(!1),a=d((function(e,r){const n={id:e,focus:r};return t.current[e]=n,function(){const r=t.current;r[e]!==n&&delete r[e]}}),[]),l=d((function(t){const r=function(e,t){const r=`[${vr.contextId}="${e}"]`,n=wr(document,r);if(!n.length)return null;const o=n.find((e=>e.getAttribute(vr.draggableId)===t));return o&&Pr(o)?o:null}(e,t);r&&r!==document.activeElement&&r.focus()}),[e]),u=d((function(e,t){r.current===e&&(r.current=t)}),[]),s=d((function(){o.current||i.current&&(o.current=requestAnimationFrame((()=>{o.current=null;const e=r.current;e&&l(e)})))}),[l]),f=d((function(e){r.current=null;const t=document.activeElement;t&&t.getAttribute(vr.draggableId)===e&&(r.current=e)}),[]);return Or((()=>(i.current=!0,function(){i.current=!1;const e=o.current;e&&cancelAnimationFrame(e)})),[]),c((()=>({register:a,tryRecordFocus:f,tryRestoreFocusRecorded:s,tryShiftRecord:u})),[a,f,s,u])}(t),C=c((()=>Ht({announce:h,autoScroller:_,dimensionMarshal:S,focusMarshal:T,getResponders:g,styleMarshal:y})),[h,_,S,T,g,y]);f.current=C;const I=d((()=>{const e=wn(f);"IDLE"!==e.getState().phase&&e.dispatch(yt())}),[]),A=d((()=>{const e=wn(f).getState();return"DROP_ANIMATING"===e.phase||"IDLE"!==e.phase&&e.isDragging}),[]);r(c((()=>({isDragging:A,tryAbort:I})),[A,I]));const R=d((e=>Xt(wn(f).getState(),e)),[]),x=d((()=>Ge(wn(f).getState())),[]),N=c((()=>({marshal:S,focus:T,contextId:t,canLift:R,isMovementAllowed:x,dragHandleUsageInstructionsId:m,registry:O})),[t,S,m,T,R,x,O]);return On({contextId:t,store:C,registry:O,customSensors:i||null,enableDefaultSensors:!1!==e.enableDefaultSensors}),(0,n.useEffect)((()=>I),[I]),o().createElement(Lr.Provider,{value:N},o().createElement(u.Provider,{context:Ir,store:C},e.children))}function Pn(e){const t=o().useId(),r=e.dragHandleUsageInstructions||q.dragHandleUsageInstructions;return o().createElement(L,null,(n=>o().createElement(Tn,{nonce:e.nonce,contextId:t,setCallbacks:n,dragHandleUsageInstructions:r,enableDefaultSensors:e.enableDefaultSensors,sensors:e.sensors,onBeforeCapture:e.onBeforeCapture,onBeforeDragStart:e.onBeforeDragStart,onDragStart:e.onDragStart,onDragUpdate:e.onDragUpdate,onDragEnd:e.onDragEnd,autoScrollerOptions:e.autoScrollerOptions},e.children)))}const Cn=5e3,In=4500,An=(e,t)=>t?Ct.drop(t.duration):e?Ct.snap:Ct.fluid,Rn=(e,t)=>{if(e)return t?St:_t};var xn=o().createContext(null);function Nn(e){const t=(0,n.useContext)(e);return t||D(),t}function Dn(e){e.preventDefault()}var Ln=(e,t)=>e===t,jn=e=>{const{combine:t,destination:r}=e;return r?r.droppableId:t?t.droppableId:null};function Mn(e=null){return{isDragging:!1,isDropAnimating:!1,isClone:!1,dropAnimation:null,mode:null,draggingOver:null,combineTargetFor:e,combineWith:null}}const kn={mapped:{type:"SECONDARY",offset:V,combineTargetFor:null,shouldAnimateDisplacement:!0,snapshot:Mn(null)}},Fn={dropAnimationFinished:()=>({type:"DROP_ANIMATION_FINISHED",payload:null})},qn=(0,u.connect)((()=>{const e=function(){const e=w(((e,t)=>({x:e,y:t}))),t=w(((e,t,r=null,n=null,o=null)=>({isDragging:!0,isClone:t,isDropAnimating:Boolean(o),dropAnimation:o,mode:e,draggingOver:r,combineWith:n,combineTargetFor:null}))),r=w(((e,r,n,o,i=null,a=null,l=null)=>({mapped:{type:"DRAGGING",dropping:null,draggingOver:i,combineWith:a,mode:r,offset:e,dimension:n,forceShouldAnimate:l,snapshot:t(r,o,i,a,null)}})));return(n,o)=>{if(Mr(n)){if(n.critical.draggable.id!==o.draggableId)return null;const t=n.current.client.offset,a=n.dimensions.draggables[o.draggableId],l=Ue(n.impact),u=(i=n.impact).at&&"COMBINE"===i.at.type?i.at.combine.draggableId:null,s=n.forceShouldAnimate;return r(e(t.x,t.y),n.movementMode,a,o.isClone,l,u,s)}var i;if("DROP_ANIMATING"===n.phase){const e=n.completed;if(e.result.draggableId!==o.draggableId)return null;const r=o.isClone,i=n.dimensions.draggables[o.draggableId],a=e.result,l=a.mode,u=jn(a),s=(e=>e.combine?e.combine.draggableId:null)(a),c={duration:n.dropDuration,curve:Ot,moveTo:n.newHomeClientOffset,opacity:s?St:null,scale:s?wt:null};return{mapped:{type:"DRAGGING",offset:n.newHomeClientOffset,dimension:i,dropping:c,draggingOver:u,combineWith:s,mode:l,forceShouldAnimate:null,snapshot:t(l,r,u,s,c)}}}return null}}(),t=function(){const e=w(((e,t)=>({x:e,y:t}))),t=w(Mn),r=w(((e,r=null,n)=>({mapped:{type:"SECONDARY",offset:e,combineTargetFor:r,shouldAnimateDisplacement:n,snapshot:t(r)}}))),n=e=>e?r(V,e,!0):null,o=(t,o,i,a)=>{const l=i.displaced.visible[t],u=Boolean(a.inVirtualList&&a.effected[t]),s=ae(i),c=s&&s.draggableId===t?o:null;if(!l){if(!u)return n(c);if(i.displaced.invisible[t])return null;const o=G(a.displacedBy.point),l=e(o.x,o.y);return r(l,c,!0)}if(u)return n(c);const d=i.displacedBy.point,f=e(d.x,d.y);return r(f,c,l.shouldAnimate)};return(e,t)=>{if(Mr(e))return e.critical.draggable.id===t.draggableId?null:o(t.draggableId,e.critical.draggable.id,e.impact,e.afterCritical);if("DROP_ANIMATING"===e.phase){const r=e.completed;return r.result.draggableId===t.draggableId?null:o(t.draggableId,r.result.draggableId,r.impact,r.afterCritical)}return null}}();return(r,n)=>e(r,n)||t(r,n)||kn}),Fn,null,{context:Ir,areStatePropsEqual:Ln})((e=>{const t=(0,n.useRef)(null),r=d(((e=null)=>{t.current=e}),[]),a=d((()=>t.current),[]),{contextId:l,dragHandleUsageInstructionsId:u,registry:s}=Nn(Lr),{type:f,droppableId:p}=Nn(xn),g=c((()=>({id:e.draggableId,index:e.index,type:f,droppableId:p})),[e.draggableId,e.index,f,p]),{children:v,draggableId:h,isEnabled:m,shouldRespectForcePress:y,canDragInteractiveElements:O,isClone:S,mapped:_,dropAnimationFinished:w}=e;S||function(e){const t=Dr("draggable"),{descriptor:r,registry:o,getDraggableRef:i,canDragInteractiveElements:a,shouldRespectForcePress:l,isEnabled:u}=e,s=c((()=>({canDragInteractiveElements:a,shouldRespectForcePress:l,isEnabled:u})),[a,u,l]),f=d((e=>{const t=i();return t||D(),function(e,t,r=V){const n=window.getComputedStyle(t),o=t.getBoundingClientRect(),i=E(o,n),a=b(i,r);return{descriptor:e,placeholder:{client:i,tagName:t.tagName.toLowerCase(),display:n.display},displaceBy:{x:i.marginBox.width,y:i.marginBox.height},client:i,page:a}}(r,t,e)}),[r,i]),p=c((()=>({uniqueId:t,descriptor:r,options:s,getDimension:f})),[r,f,s,t]),g=(0,n.useRef)(p),v=(0,n.useRef)(!0);Or((()=>(o.draggable.register(g.current),()=>o.draggable.unregister(g.current))),[o.draggable]),Or((()=>{if(v.current)return void(v.current=!1);const e=g.current;g.current=p,o.draggable.update(p,e)}),[p,o.draggable])}(c((()=>({descriptor:g,registry:s,getDraggableRef:a,canDragInteractiveElements:O,shouldRespectForcePress:y,isEnabled:m})),[g,s,a,O,y,m]));const T=c((()=>m?{tabIndex:0,role:"button","aria-describedby":u,"data-rfd-drag-handle-draggable-id":h,"data-rfd-drag-handle-context-id":l,draggable:!1,onDragStart:Dn}:null),[l,u,h,m]),P=d((e=>{"DRAGGING"===_.type&&_.dropping&&"transform"===e.propertyName&&(0,i.flushSync)(w)}),[w,_]),C=c((()=>{const e=function(e){return"DRAGGING"===e.type?function(e){const t=e.dimension.client,{offset:r,combineWith:n,dropping:o}=e,i=Boolean(n),a=(e=>null!=e.forceShouldAnimate?e.forceShouldAnimate:"SNAP"===e.mode)(e),l=Boolean(o),u=l?Rt(r,i):At(r);return{position:"fixed",top:t.marginBox.top,left:t.marginBox.left,boxSizing:"border-box",width:t.borderBox.width,height:t.borderBox.height,transition:An(a,o),transform:u,opacity:Rn(i,l),zIndex:l?In:Cn,pointerEvents:"none"}}(e):{transform:At((t=e).offset),transition:t.shouldAnimateDisplacement?void 0:"none"};var t}(_),t="DRAGGING"===_.type&&_.dropping?P:void 0;return{innerRef:r,draggableProps:{"data-rfd-draggable-context-id":l,"data-rfd-draggable-id":h,style:e,onTransitionEnd:t},dragHandleProps:T}}),[l,T,h,_,P,r]),I=c((()=>({draggableId:g.id,type:g.type,source:{index:g.index,droppableId:g.droppableId}})),[g.droppableId,g.id,g.index,g.type]);return o().createElement(o().Fragment,null,v(C,_.snapshot,I))}));function Vn(e){return Nn(xn).isUsingCloneFor!==e.draggableId||e.isClone?o().createElement(qn,e):null}function Bn(e){const t="boolean"!=typeof e.isDragDisabled||!e.isDragDisabled,r=Boolean(e.disableInteractiveElementBlocking),n=Boolean(e.shouldRespectForcePress);return o().createElement(Vn,P({},e,{isClone:!1,isEnabled:t,canDragInteractiveElements:r,shouldRespectForcePress:n}))}const Un=e=>t=>e===t,Wn=Un("scroll"),Gn=Un("auto"),Hn=(Un("visible"),(e,t)=>t(e.overflowX)||t(e.overflowY)),Kn=e=>null==e||e===document.body||e===document.documentElement?null:(e=>{const t=window.getComputedStyle(e),r={overflowX:t.overflowX,overflowY:t.overflowY};return Hn(r,Wn)||Hn(r,Gn)})(e)?e:Kn(e.parentElement);var $n=e=>({x:e.scrollLeft,y:e.scrollTop});const zn=e=>!!e&&("fixed"===window.getComputedStyle(e).position||zn(e.parentElement));const Yn={passive:!1},Qn={passive:!0};var Xn=e=>e.shouldPublishImmediately?Yn:Qn;const Jn=e=>e&&e.env.closestScrollable||null;function Zn(e){const t=(0,n.useRef)(null),r=Nn(Lr),o=Dr("droppable"),{registry:i,marshal:a}=r,l=jr(e),u=c((()=>({id:e.droppableId,type:e.type,mode:e.mode})),[e.droppableId,e.mode,e.type]),s=(0,n.useRef)(u),f=c((()=>w(((e,r)=>{t.current||D();const n={x:e,y:r};a.updateDroppableScroll(u.id,n)}))),[u.id,a]),g=d((()=>{const e=t.current;return e&&e.env.closestScrollable?$n(e.env.closestScrollable):V}),[]),v=d((()=>{const e=g();f(e.x,e.y)}),[g,f]),m=c((()=>T(v)),[v]),y=d((()=>{const e=t.current,r=Jn(e);e&&r||D(),e.scrollOptions.shouldPublishImmediately?v():m()}),[m,v]),E=d(((e,n)=>{t.current&&D();const o=l.current,i=o.getDroppableRef();i||D();const a=(e=>({closestScrollable:Kn(e),isFixedOnPage:zn(e)}))(i),s={ref:i,descriptor:u,env:a,scrollOptions:n};t.current=s;const c=(({ref:e,descriptor:t,env:r,windowScroll:n,direction:o,isDropDisabled:i,isCombineEnabled:a,shouldClipSubject:l})=>{const u=r.closestScrollable,s=((e,t)=>{const r=O(e);if(!t)return r;if(e!==t)return r;const n=r.paddingBox.top-t.scrollTop,o=r.paddingBox.left-t.scrollLeft,i=n+t.scrollHeight,a=o+t.scrollWidth,l=p({top:n,right:a,bottom:i,left:o},r.border);return h({borderBox:l,margin:r.margin,border:r.border,padding:r.padding})})(e,u),c=b(s,n),d=(()=>{if(!u)return null;const e=O(u),t={scrollHeight:u.scrollHeight,scrollWidth:u.scrollWidth};return{client:e,page:b(e,n),scroll:$n(u),scrollSize:t,shouldClipSubject:l}})(),f=(({descriptor:e,isEnabled:t,isCombineEnabled:r,isFixedOnPage:n,direction:o,client:i,page:a,closest:l})=>{const u=(()=>{if(!l)return null;const{scrollSize:e,client:t}=l,r=Kt({scrollHeight:e.scrollHeight,scrollWidth:e.scrollWidth,height:t.paddingBox.height,width:t.paddingBox.width});return{pageMarginBox:l.page.marginBox,frameClient:t,scrollSize:e,shouldClipSubject:l.shouldClipSubject,scroll:{initial:l.scroll,current:l.scroll,max:r,diff:{value:V,displacement:V}}}})(),s="vertical"===o?ve:he;return{descriptor:e,isCombineEnabled:r,isFixedOnPage:n,axis:s,isEnabled:t,client:i,page:a,frame:u,subject:J({page:a,withPlaceholder:null,axis:s,frame:u})}})({descriptor:t,isEnabled:!i,isCombineEnabled:a,isFixedOnPage:r.isFixedOnPage,direction:o,client:s,page:c,closest:d});return f})({ref:i,descriptor:u,env:a,windowScroll:e,direction:o.direction,isDropDisabled:o.isDropDisabled,isCombineEnabled:o.isCombineEnabled,shouldClipSubject:!o.ignoreContainerClipping}),d=a.closestScrollable;return d&&(d.setAttribute(yr.contextId,r.contextId),d.addEventListener("scroll",y,Xn(s.scrollOptions))),c}),[r.contextId,u,y,l]),S=d((()=>{const e=t.current,r=Jn(e);return e&&r||D(),$n(r)}),[]),_=d((()=>{const e=t.current;e||D();const r=Jn(e);t.current=null,r&&(m.cancel(),r.removeAttribute(yr.contextId),r.removeEventListener("scroll",y,Xn(e.scrollOptions)))}),[y,m]),P=d((e=>{const r=t.current;r||D();const n=Jn(r);n||D(),n.scrollTop+=e.y,n.scrollLeft+=e.x}),[]),C=c((()=>({getDimensionAndWatchScroll:E,getScrollWhileDragging:S,dragStopped:_,scroll:P})),[_,E,S,P]),I=c((()=>({uniqueId:o,descriptor:u,callbacks:C})),[C,u,o]);Or((()=>(s.current=I.descriptor,i.droppable.register(I),()=>{t.current&&_(),i.droppable.unregister(I)})),[C,u,_,I,a,i.droppable]),Or((()=>{t.current&&a.updateDroppableIsEnabled(s.current.id,!e.isDropDisabled)}),[e.isDropDisabled,a]),Or((()=>{t.current&&a.updateDroppableIsCombineEnabled(s.current.id,e.isCombineEnabled)}),[e.isCombineEnabled,a])}function eo(){}const to={width:0,height:0,margin:{top:0,right:0,bottom:0,left:0}};var ro=o().memo((e=>{const t=(0,n.useRef)(null),r=d((()=>{t.current&&(clearTimeout(t.current),t.current=null)}),[]),{animate:i,onTransitionEnd:a,onClose:l,contextId:u}=e,[s,c]=(0,n.useState)("open"===e.animate);(0,n.useEffect)((()=>s?"open"!==i?(r(),c(!1),eo):t.current?eo:(t.current=setTimeout((()=>{t.current=null,c(!1)})),r):eo),[i,s,r]);const f=d((e=>{"height"===e.propertyName&&(a(),"close"===i&&l())}),[i,l,a]),p=(({isAnimatingOpenOnMount:e,placeholder:t,animate:r})=>{const n=(({isAnimatingOpenOnMount:e,placeholder:t,animate:r})=>e||"close"===r?to:{height:t.client.borderBox.height,width:t.client.borderBox.width,margin:t.client.margin})({isAnimatingOpenOnMount:e,placeholder:t,animate:r});return{display:t.display,boxSizing:"border-box",width:n.width,height:n.height,marginTop:n.margin.top,marginRight:n.margin.right,marginBottom:n.margin.bottom,marginLeft:n.margin.left,flexShrink:"0",flexGrow:"0",pointerEvents:"none",transition:"none"!==r?Ct.placeholder:null}})({isAnimatingOpenOnMount:s,animate:e.animate,placeholder:e.placeholder});return o().createElement(e.placeholder.tagName,{style:p,"data-rfd-placeholder-context-id":u,onTransitionEnd:f,ref:e.innerRef})}));class no extends o().PureComponent{constructor(...e){super(...e),this.state={isVisible:Boolean(this.props.on),data:this.props.on,animate:this.props.shouldAnimate&&this.props.on?"open":"none"},this.onClose=()=>{"close"===this.state.animate&&this.setState({isVisible:!1})}}static getDerivedStateFromProps(e,t){return e.shouldAnimate?e.on?{isVisible:!0,data:e.on,animate:"open"}:t.isVisible?{isVisible:!0,data:t.data,animate:"close"}:{isVisible:!1,animate:"close",data:null}:{isVisible:Boolean(e.on),data:e.on,animate:"none"}}render(){if(!this.state.isVisible)return null;const e={onClose:this.onClose,data:this.state.data,animate:this.state.animate};return this.props.children(e)}}const oo={mode:"standard",type:"DEFAULT",direction:"vertical",isDropDisabled:!1,isCombineEnabled:!1,ignoreContainerClipping:!1,renderClone:null,getContainerForClone:function(){return document.body||D(),document.body}},io=e=>{let t,r={...e};for(t in oo)void 0===e[t]&&(r={...r,[t]:oo[t]});return r},ao=(e,t)=>e===t.droppable.type,lo=(e,t)=>t.draggables[e.draggable.id],uo=(0,u.connect)((()=>{const e={placeholder:null,shouldAnimatePlaceholder:!0,snapshot:{isDraggingOver:!1,draggingOverWith:null,draggingFromThisWith:null,isUsingPlaceholder:!1},useClone:null},t={...e,shouldAnimatePlaceholder:!1},r=w((e=>({draggableId:e.id,type:e.type,source:{index:e.index,droppableId:e.droppableId}}))),n=w(((n,o,i,a,l,u)=>{const s=l.descriptor.id;if(l.descriptor.droppableId===n){const e=u?{render:u,dragging:r(l.descriptor)}:null,t={isDraggingOver:i,draggingOverWith:i?s:null,draggingFromThisWith:s,isUsingPlaceholder:!0};return{placeholder:l.placeholder,shouldAnimatePlaceholder:!1,snapshot:t,useClone:e}}if(!o)return t;if(!a)return e;const c={isDraggingOver:i,draggingOverWith:s,draggingFromThisWith:null,isUsingPlaceholder:!0};return{placeholder:l.placeholder,shouldAnimatePlaceholder:!0,snapshot:c,useClone:null}}));return(r,o)=>{const i=io(o),a=i.droppableId,l=i.type,u=!i.isDropDisabled,s=i.renderClone;if(Mr(r)){const e=r.critical;if(!ao(l,e))return t;const o=lo(e,r.dimensions),i=Ue(r.impact)===a;return n(a,u,i,i,o,s)}if("DROP_ANIMATING"===r.phase){const e=r.completed;if(!ao(l,e.critical))return t;const o=lo(e.critical,r.dimensions);return n(a,u,jn(e.result)===a,Ue(e.impact)===a,o,s)}if("IDLE"===r.phase&&r.completed&&!r.shouldFlush){const n=r.completed;if(!ao(l,n.critical))return t;const o=Ue(n.impact)===a,i=Boolean(n.impact.at&&"COMBINE"===n.impact.at.type),u=n.critical.droppable.id===a;return o?i?e:t:u?e:t}return t}}),{updateViewportMaxScroll:e=>({type:"UPDATE_VIEWPORT_MAX_SCROLL",payload:e})},((e,t,r)=>({...io(r),...e,...t})),{context:Ir,areStatePropsEqual:Ln})((e=>{const t=(0,n.useContext)(Lr);t||D();const{contextId:r,isMovementAllowed:i}=t,l=(0,n.useRef)(null),u=(0,n.useRef)(null),{children:s,droppableId:f,type:p,mode:g,direction:v,ignoreContainerClipping:h,isDropDisabled:m,isCombineEnabled:y,snapshot:b,useClone:E,updateViewportMaxScroll:O,getContainerForClone:S}=e,_=d((()=>l.current),[]),w=d(((e=null)=>{l.current=e}),[]),T=(d((()=>u.current),[]),d(((e=null)=>{u.current=e}),[])),P=d((()=>{i()&&O({maxScroll:zt()})}),[i,O]);Zn({droppableId:f,type:p,mode:g,direction:v,isDropDisabled:m,isCombineEnabled:y,ignoreContainerClipping:h,getDroppableRef:_});const C=c((()=>o().createElement(no,{on:e.placeholder,shouldAnimate:e.shouldAnimatePlaceholder},(({onClose:e,data:t,animate:n})=>o().createElement(ro,{placeholder:t,onClose:e,innerRef:T,animate:n,contextId:r,onTransitionEnd:P})))),[r,P,e.placeholder,e.shouldAnimatePlaceholder,T]),I=c((()=>({innerRef:w,placeholder:C,droppableProps:{"data-rfd-droppable-id":f,"data-rfd-droppable-context-id":r}})),[r,f,C,w]),A=E?E.dragging.draggableId:null,R=c((()=>({droppableId:f,type:p,isUsingCloneFor:A})),[f,A,p]);return o().createElement(xn.Provider,{value:R},s(I,b),function(){if(!E)return null;const{dragging:e,render:t}=E,r=o().createElement(Vn,{draggableId:e.draggableId,index:e.source.index,isClone:!0,isEnabled:!0,shouldRespectForcePress:!1,canDragInteractiveElements:!0},((r,n)=>t(r,n,e)));return a().createPortal(r,S())}())}));var so=uo},442:function(e){e.exports=function(){"use strict";return function(e,t,r){(r=r||{}).childrenKeyName=r.childrenKeyName||"children";var n=e||[],o=[],i=0;do{var a=n.filter((function(e){return t(e,i)}))[0];if(!a)break;o.push(a),n=a[r.childrenKeyName]||[],i+=1}while(n.length>0);return o}}()},71633:(e,t)=>{var r;!function(){"use strict";var n={}.hasOwnProperty;function o(){for(var e=[],t=0;t<arguments.length;t++){var r=arguments[t];if(r){var i=typeof r;if("string"===i||"number"===i)e.push(r);else if(Array.isArray(r)){if(r.length){var a=o.apply(null,r);a&&e.push(a)}}else if("object"===i){if(r.toString!==Object.prototype.toString&&!r.toString.toString().includes("[native code]")){e.push(r.toString());continue}for(var l in r)n.call(r,l)&&r[l]&&e.push(l)}}}return e.join(" ")}e.exports?(o.default=o,e.exports=o):void 0===(r=function(){return o}.apply(t,[]))||(e.exports=r)}()},19999:e=>{var t=function(){"use strict";function e(e,t){return null!=t&&e instanceof t}var t,r,n;try{t=Map}catch(e){t=function(){}}try{r=Set}catch(e){r=function(){}}try{n=Promise}catch(e){n=function(){}}function o(i,l,u,s,c){"object"==typeof l&&(u=l.depth,s=l.prototype,c=l.includeNonEnumerable,l=l.circular);var d=[],f=[],p="undefined"!=typeof Buffer;return void 0===l&&(l=!0),void 0===u&&(u=1/0),function i(u,g){if(null===u)return null;if(0===g)return u;var v,h;if("object"!=typeof u)return u;if(e(u,t))v=new t;else if(e(u,r))v=new r;else if(e(u,n))v=new n((function(e,t){u.then((function(t){e(i(t,g-1))}),(function(e){t(i(e,g-1))}))}));else if(o.__isArray(u))v=[];else if(o.__isRegExp(u))v=new RegExp(u.source,a(u)),u.lastIndex&&(v.lastIndex=u.lastIndex);else if(o.__isDate(u))v=new Date(u.getTime());else{if(p&&Buffer.isBuffer(u))return v=Buffer.allocUnsafe?Buffer.allocUnsafe(u.length):new Buffer(u.length),u.copy(v),v;e(u,Error)?v=Object.create(u):void 0===s?(h=Object.getPrototypeOf(u),v=Object.create(h)):(v=Object.create(s),h=s)}if(l){var m=d.indexOf(u);if(-1!=m)return f[m];d.push(u),f.push(v)}for(var y in e(u,t)&&u.forEach((function(e,t){var r=i(t,g-1),n=i(e,g-1);v.set(r,n)})),e(u,r)&&u.forEach((function(e){var t=i(e,g-1);v.add(t)})),u){var b;h&&(b=Object.getOwnPropertyDescriptor(h,y)),b&&null==b.set||(v[y]=i(u[y],g-1))}if(Object.getOwnPropertySymbols){var E=Object.getOwnPropertySymbols(u);for(y=0;y<E.length;y++){var O=E[y];(!(_=Object.getOwnPropertyDescriptor(u,O))||_.enumerable||c)&&(v[O]=i(u[O],g-1),_.enumerable||Object.defineProperty(v,O,{enumerable:!1}))}}if(c){var S=Object.getOwnPropertyNames(u);for(y=0;y<S.length;y++){var _,w=S[y];(_=Object.getOwnPropertyDescriptor(u,w))&&_.enumerable||(v[w]=i(u[w],g-1),Object.defineProperty(v,w,{enumerable:!1}))}}return v}(i,u)}function i(e){return Object.prototype.toString.call(e)}function a(e){var t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),t}return o.clonePrototype=function(e){if(null===e)return null;var t=function(){};return t.prototype=e,new t},o.__objToStr=i,o.__isDate=function(e){return"object"==typeof e&&"[object Date]"===i(e)},o.__isArray=function(e){return"object"==typeof e&&"[object Array]"===i(e)},o.__isRegExp=function(e){return"object"==typeof e&&"[object RegExp]"===i(e)},o.__getRegExpFlags=a,o}();e.exports&&(e.exports=t)},78784:e=>{function t(e){var r,n,o="";if("string"==typeof e||"number"==typeof e)o+=e;else if("object"==typeof e)if(Array.isArray(e)){var i=e.length;for(r=0;r<i;r++)e[r]&&(n=t(e[r]))&&(o&&(o+=" "),o+=n)}else for(n in e)e[n]&&(o&&(o+=" "),o+=n);return o}function r(){for(var e,r,n=0,o="",i=arguments.length;n<i;n++)(e=arguments[n])&&(r=t(e))&&(o&&(o+=" "),o+=r);return o}e.exports=r,e.exports.clsx=r},35489:(e,t,r)=>{"use strict";var n=r(60062),o={"text/plain":"Text","text/html":"Url",default:"Text"};e.exports=function(e,t){var r,i,a,l,u,s,c=!1;t||(t={}),r=t.debug||!1;try{if(a=n(),l=document.createRange(),u=document.getSelection(),(s=document.createElement("span")).textContent=e,s.ariaHidden="true",s.style.all="unset",s.style.position="fixed",s.style.top=0,s.style.clip="rect(0, 0, 0, 0)",s.style.whiteSpace="pre",s.style.webkitUserSelect="text",s.style.MozUserSelect="text",s.style.msUserSelect="text",s.style.userSelect="text",s.addEventListener("copy",(function(n){if(n.stopPropagation(),t.format)if(n.preventDefault(),void 0===n.clipboardData){r&&console.warn("unable to use e.clipboardData"),r&&console.warn("trying IE specific stuff"),window.clipboardData.clearData();var i=o[t.format]||o.default;window.clipboardData.setData(i,e)}else n.clipboardData.clearData(),n.clipboardData.setData(t.format,e);t.onCopy&&(n.preventDefault(),t.onCopy(n.clipboardData))})),document.body.appendChild(s),l.selectNodeContents(s),u.addRange(l),!document.execCommand("copy"))throw new Error("copy command was unsuccessful");c=!0}catch(n){r&&console.error("unable to copy using execCommand: ",n),r&&console.warn("trying IE specific stuff");try{window.clipboardData.setData(t.format||"text",e),t.onCopy&&t.onCopy(window.clipboardData),c=!0}catch(n){r&&console.error("unable to copy using clipboardData: ",n),r&&console.error("falling back to prompt"),i=function(e){var t=(/mac os x/i.test(navigator.userAgent)?"⌘":"Ctrl")+"+C";return e.replace(/#{\s*key\s*}/g,t)}("message"in t?t.message:"Copy to clipboard: #{key}, Enter"),window.prompt(i,e)}}finally{u&&("function"==typeof u.removeRange?u.removeRange(l):u.removeAllRanges()),s&&document.body.removeChild(s),a()}return c}},78701:(e,t,r)=>{"use strict";r.d(t,{A:()=>l});var n=r(34942),o=r.n(n),i=r(60278),a=r.n(i)()(o());a.push([e.id,"/* hides the native Calendar picker icon given when using type=date */\n.grafana-plugin-ui-date-input input[type='date']::-webkit-inner-spin-button,\n.grafana-plugin-ui-date-input input[type='date']::-webkit-calendar-picker-indicator,\ninput.grafana-plugin-ui-date-input[type='date']::-webkit-inner-spin-button,\ninput.grafana-plugin-ui-date-input[type='date']::-webkit-calendar-picker-indicator {\n  display: none;\n  -webkit-appearance: none;\n}\n","",{version:3,sources:["webpack://./../node_modules/@grafana/plugin-ui/dist/components/DatePickerWithInput/style.css"],names:[],mappings:"AAAA,qEAAqE;AACrE;;;;EAIE,aAAa;EACb,wBAAwB;AAC1B",sourcesContent:["/* hides the native Calendar picker icon given when using type=date */\n.grafana-plugin-ui-date-input input[type='date']::-webkit-inner-spin-button,\n.grafana-plugin-ui-date-input input[type='date']::-webkit-calendar-picker-indicator,\ninput.grafana-plugin-ui-date-input[type='date']::-webkit-inner-spin-button,\ninput.grafana-plugin-ui-date-input[type='date']::-webkit-calendar-picker-indicator {\n  display: none;\n  -webkit-appearance: none;\n}\n"],sourceRoot:""}]);const l=a},60278:e=>{"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var r="",n=void 0!==t[5];return t[4]&&(r+="@supports (".concat(t[4],") {")),t[2]&&(r+="@media ".concat(t[2]," {")),n&&(r+="@layer".concat(t[5].length>0?" ".concat(t[5]):""," {")),r+=e(t),n&&(r+="}"),t[2]&&(r+="}"),t[4]&&(r+="}"),r})).join("")},t.i=function(e,r,n,o,i){"string"==typeof e&&(e=[[null,e,void 0]]);var a={};if(n)for(var l=0;l<this.length;l++){var u=this[l][0];null!=u&&(a[u]=!0)}for(var s=0;s<e.length;s++){var c=[].concat(e[s]);n&&a[c[0]]||(void 0!==i&&(void 0===c[5]||(c[1]="@layer".concat(c[5].length>0?" ".concat(c[5]):""," {").concat(c[1],"}")),c[5]=i),r&&(c[2]?(c[1]="@media ".concat(c[2]," {").concat(c[1],"}"),c[2]=r):c[2]=r),o&&(c[4]?(c[1]="@supports (".concat(c[4],") {").concat(c[1],"}"),c[4]=o):c[4]="".concat(o)),t.push(c))}},t}},34942:e=>{"use strict";e.exports=function(e){var t=e[1],r=e[3];if(!r)return t;if("function"==typeof btoa){var n=btoa(unescape(encodeURIComponent(JSON.stringify(r)))),o="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(n),i="/*# ".concat(o," */");return[t].concat([i]).join("\n")}return[t].join("\n")}},92194:e=>{"use strict";e.exports=function e(t,r){if(t===r)return!0;if(t&&r&&"object"==typeof t&&"object"==typeof r){if(t.constructor!==r.constructor)return!1;var n,o,i;if(Array.isArray(t)){if((n=t.length)!=r.length)return!1;for(o=n;0!=o--;)if(!e(t[o],r[o]))return!1;return!0}if(t.constructor===RegExp)return t.source===r.source&&t.flags===r.flags;if(t.valueOf!==Object.prototype.valueOf)return t.valueOf()===r.valueOf();if(t.toString!==Object.prototype.toString)return t.toString()===r.toString();if((n=(i=Object.keys(t)).length)!==Object.keys(r).length)return!1;for(o=n;0!=o--;)if(!Object.prototype.hasOwnProperty.call(r,i[o]))return!1;for(o=n;0!=o--;){var a=i[o];if(!("_owner"===a&&t.$$typeof||e(t[a],r[a])))return!1}return!0}return t!=t&&r!=r}},76511:(e,t)=>{var r=Object.keys;t.L=function(e,t){if(e===t)return!0;if(!(e instanceof Object&&t instanceof Object))return!1;for(var n=r(e),o=n.length,i=0;i<o;i++)if(!(n[i]in t))return!1;for(i=0;i<o;i++)if(e[n[i]]!==t[n[i]])return!1;return o===r(t).length}},92299:(e,t,r)=>{var n,o,i;void 0===(o="function"==typeof(n=i=function(){function e(){for(var e=0,t={};e<arguments.length;e++){var r=arguments[e];for(var n in r)t[n]=r[n]}return t}function t(e){return e.replace(/(%[0-9A-Z]{2})+/g,decodeURIComponent)}return function r(n){function o(){}function i(t,r,i){if("undefined"!=typeof document){"number"==typeof(i=e({path:"/"},o.defaults,i)).expires&&(i.expires=new Date(1*new Date+864e5*i.expires)),i.expires=i.expires?i.expires.toUTCString():"";try{var a=JSON.stringify(r);/^[\{\[]/.test(a)&&(r=a)}catch(e){}r=n.write?n.write(r,t):encodeURIComponent(String(r)).replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g,decodeURIComponent),t=encodeURIComponent(String(t)).replace(/%(23|24|26|2B|5E|60|7C)/g,decodeURIComponent).replace(/[\(\)]/g,escape);var l="";for(var u in i)i[u]&&(l+="; "+u,!0!==i[u]&&(l+="="+i[u].split(";")[0]));return document.cookie=t+"="+r+l}}function a(e,r){if("undefined"!=typeof document){for(var o={},i=document.cookie?document.cookie.split("; "):[],a=0;a<i.length;a++){var l=i[a].split("="),u=l.slice(1).join("=");r||'"'!==u.charAt(0)||(u=u.slice(1,-1));try{var s=t(l[0]);if(u=(n.read||n)(u,s)||t(u),r)try{u=JSON.parse(u)}catch(e){}if(o[s]=u,e===s)break}catch(e){}}return e?o[e]:o}}return o.set=i,o.get=function(e){return a(e,!1)},o.getJSON=function(e){return a(e,!0)},o.remove=function(t,r){i(t,"",e(r,{expires:-1}))},o.defaults={},o.withConverter=r,o}((function(){}))})?n.call(t,r,t,e):n)||(e.exports=o),e.exports=i()},36682:(e,t,r)=>{var n,o="__lodash_hash_undefined__",i="[object Function]",a="[object GeneratorFunction]",l=/^\[object .+?Constructor\]$/,u="object"==typeof r.g&&r.g&&r.g.Object===Object&&r.g,s="object"==typeof self&&self&&self.Object===Object&&self,c=u||s||Function("return this")(),d=Array.prototype,f=Function.prototype,p=Object.prototype,g=c["__core-js_shared__"],v=(n=/[^.]+$/.exec(g&&g.keys&&g.keys.IE_PROTO||""))?"Symbol(src)_1."+n:"",h=f.toString,m=p.hasOwnProperty,y=p.toString,b=RegExp("^"+h.call(m).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),E=d.splice,O=I(c,"Map"),S=I(Object,"create");function _(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function w(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function T(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function P(e,t){for(var r,n,o=e.length;o--;)if((r=e[o][0])===(n=t)||r!=r&&n!=n)return o;return-1}function C(e,t){var r,n,o=e.__data__;return("string"==(n=typeof(r=t))||"number"==n||"symbol"==n||"boolean"==n?"__proto__"!==r:null===r)?o["string"==typeof t?"string":"hash"]:o.map}function I(e,t){var r=function(e,t){return null==e?void 0:e[t]}(e,t);return function(e){if(!R(e)||v&&v in e)return!1;var t=function(e){var t=R(e)?y.call(e):"";return t==i||t==a}(e)||function(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(e){}return t}(e)?b:l;return t.test(function(e){if(null!=e){try{return h.call(e)}catch(e){}try{return e+""}catch(e){}}return""}(e))}(r)?r:void 0}function A(e,t){if("function"!=typeof e||t&&"function"!=typeof t)throw new TypeError("Expected a function");var r=function(){var n=arguments,o=t?t.apply(this,n):n[0],i=r.cache;if(i.has(o))return i.get(o);var a=e.apply(this,n);return r.cache=i.set(o,a),a};return r.cache=new(A.Cache||T),r}function R(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}_.prototype.clear=function(){this.__data__=S?S(null):{}},_.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},_.prototype.get=function(e){var t=this.__data__;if(S){var r=t[e];return r===o?void 0:r}return m.call(t,e)?t[e]:void 0},_.prototype.has=function(e){var t=this.__data__;return S?void 0!==t[e]:m.call(t,e)},_.prototype.set=function(e,t){return this.__data__[e]=S&&void 0===t?o:t,this},w.prototype.clear=function(){this.__data__=[]},w.prototype.delete=function(e){var t=this.__data__,r=P(t,e);return!(r<0||(r==t.length-1?t.pop():E.call(t,r,1),0))},w.prototype.get=function(e){var t=this.__data__,r=P(t,e);return r<0?void 0:t[r][1]},w.prototype.has=function(e){return P(this.__data__,e)>-1},w.prototype.set=function(e,t){var r=this.__data__,n=P(r,e);return n<0?r.push([e,t]):r[n][1]=t,this},T.prototype.clear=function(){this.__data__={hash:new _,map:new(O||w),string:new _}},T.prototype.delete=function(e){return C(this,e).delete(e)},T.prototype.get=function(e){return C(this,e).get(e)},T.prototype.has=function(e){return C(this,e).has(e)},T.prototype.set=function(e,t){return C(this,e).set(e,t),this},A.Cache=T,e.exports=A},1416:(e,t,r)=>{var n=r(99138)(r(41433),"DataView");e.exports=n},9073:(e,t,r)=>{var n=r(82316),o=r(76458),i=r(2149),a=r(44297),l=r(33121);function u(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}u.prototype.clear=n,u.prototype.delete=o,u.prototype.get=i,u.prototype.has=a,u.prototype.set=l,e.exports=u},72707:(e,t,r)=>{var n=r(39714),o=r(33812),i=r(14727),a=r(8379),l=r(8291);function u(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}u.prototype.clear=n,u.prototype.delete=o,u.prototype.get=i,u.prototype.has=a,u.prototype.set=l,e.exports=u},91955:(e,t,r)=>{var n=r(99138)(r(41433),"Map");e.exports=n},90369:(e,t,r)=>{var n=r(72092),o=r(49626),i=r(79925),a=r(26809),l=r(94385);function u(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}u.prototype.clear=n,u.prototype.delete=o,u.prototype.get=i,u.prototype.has=a,u.prototype.set=l,e.exports=u},42616:(e,t,r)=>{var n=r(99138)(r(41433),"Promise");e.exports=n},60157:(e,t,r)=>{var n=r(99138)(r(41433),"Set");e.exports=n},61527:(e,t,r)=>{var n=r(90369),o=r(79912),i=r(23767);function a(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new n;++t<r;)this.add(e[t])}a.prototype.add=a.prototype.push=o,a.prototype.has=i,e.exports=a},86469:(e,t,r)=>{var n=r(72707),o=r(71848),i=r(17406),a=r(58569),l=r(43109),u=r(73389);function s(e){var t=this.__data__=new n(e);this.size=t.size}s.prototype.clear=o,s.prototype.delete=i,s.prototype.get=a,s.prototype.has=l,s.prototype.set=u,e.exports=s},32781:(e,t,r)=>{var n=r(41433).Symbol;e.exports=n},28944:(e,t,r)=>{var n=r(41433).Uint8Array;e.exports=n},78499:(e,t,r)=>{var n=r(99138)(r(41433),"WeakMap");e.exports=n},96701:e=>{e.exports=function(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}},10149:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n&&!1!==t(e[r],r,e););return e}},61414:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=0,i=[];++r<n;){var a=e[r];t(a,r,e)&&(i[o++]=a)}return i}},31163:(e,t,r)=>{var n=r(36204),o=r(21256),i=r(6397),a=r(30492),l=r(42845),u=r(47995),s=Object.prototype.hasOwnProperty;e.exports=function(e,t){var r=i(e),c=!r&&o(e),d=!r&&!c&&a(e),f=!r&&!c&&!d&&u(e),p=r||c||d||f,g=p?n(e.length,String):[],v=g.length;for(var h in e)!t&&!s.call(e,h)||p&&("length"==h||d&&("offset"==h||"parent"==h)||f&&("buffer"==h||"byteLength"==h||"byteOffset"==h)||l(h,v))||g.push(h);return g}},44272:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}},78740:e=>{e.exports=function(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}},57260:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}},61617:(e,t,r)=>{var n=r(14772),o=r(39316);e.exports=function(e,t,r){(void 0!==r&&!o(e[t],r)||void 0===r&&!(t in e))&&n(e,t,r)}},82863:(e,t,r)=>{var n=r(14772),o=r(39316),i=Object.prototype.hasOwnProperty;e.exports=function(e,t,r){var a=e[t];i.call(e,t)&&o(a,r)&&(void 0!==r||t in e)||n(e,t,r)}},58301:(e,t,r)=>{var n=r(39316);e.exports=function(e,t){for(var r=e.length;r--;)if(n(e[r][0],t))return r;return-1}},61145:(e,t,r)=>{var n=r(42083),o=r(31178);e.exports=function(e,t){return e&&n(t,o(t),e)}},14306:(e,t,r)=>{var n=r(42083),o=r(15405);e.exports=function(e,t){return e&&n(t,o(t),e)}},14772:(e,t,r)=>{var n=r(18559);e.exports=function(e,t,r){"__proto__"==t&&n?n(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}},53025:e=>{e.exports=function(e,t,r){return e==e&&(void 0!==r&&(e=e<=r?e:r),void 0!==t&&(e=e>=t?e:t)),e}},2931:(e,t,r)=>{var n=r(86469),o=r(10149),i=r(82863),a=r(61145),l=r(14306),u=r(87030),s=r(68835),c=r(90859),d=r(96728),f=r(90966),p=r(29697),g=r(31201),v=r(96785),h=r(43283),m=r(19181),y=r(6397),b=r(30492),E=r(50422),O=r(58953),S=r(53764),_=r(31178),w=r(15405),T="[object Arguments]",P="[object Function]",C="[object Object]",I={};I[T]=I["[object Array]"]=I["[object ArrayBuffer]"]=I["[object DataView]"]=I["[object Boolean]"]=I["[object Date]"]=I["[object Float32Array]"]=I["[object Float64Array]"]=I["[object Int8Array]"]=I["[object Int16Array]"]=I["[object Int32Array]"]=I["[object Map]"]=I["[object Number]"]=I[C]=I["[object RegExp]"]=I["[object Set]"]=I["[object String]"]=I["[object Symbol]"]=I["[object Uint8Array]"]=I["[object Uint8ClampedArray]"]=I["[object Uint16Array]"]=I["[object Uint32Array]"]=!0,I["[object Error]"]=I[P]=I["[object WeakMap]"]=!1,e.exports=function e(t,r,A,R,x,N){var D,L=1&r,j=2&r,M=4&r;if(A&&(D=x?A(t,R,x,N):A(t)),void 0!==D)return D;if(!O(t))return t;var k=y(t);if(k){if(D=v(t),!L)return s(t,D)}else{var F=g(t),q=F==P||"[object GeneratorFunction]"==F;if(b(t))return u(t,L);if(F==C||F==T||q&&!x){if(D=j||q?{}:m(t),!L)return j?d(t,l(D,t)):c(t,a(D,t))}else{if(!I[F])return x?t:{};D=h(t,F,L)}}N||(N=new n);var V=N.get(t);if(V)return V;N.set(t,D),S(t)?t.forEach((function(n){D.add(e(n,r,A,n,t,N))})):E(t)&&t.forEach((function(n,o){D.set(o,e(n,r,A,o,t,N))}));var B=k?void 0:(M?j?p:f:j?w:_)(t);return o(B||t,(function(n,o){B&&(n=t[o=n]),i(D,o,e(n,r,A,o,t,N))})),D}},23508:(e,t,r)=>{var n=r(58953),o=Object.create,i=function(){function e(){}return function(t){if(!n(t))return{};if(o)return o(t);e.prototype=t;var r=new e;return e.prototype=void 0,r}}();e.exports=i},15663:e=>{e.exports=function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}},61044:(e,t,r)=>{var n=r(78740),o=r(18031);e.exports=function e(t,r,i,a,l){var u=-1,s=t.length;for(i||(i=o),l||(l=[]);++u<s;){var c=t[u];r>0&&i(c)?r>1?e(c,r-1,i,a,l):n(l,c):a||(l[l.length]=c)}return l}},61469:(e,t,r)=>{var n=r(15409)();e.exports=n},61701:(e,t,r)=>{var n=r(61469),o=r(31178);e.exports=function(e,t){return e&&n(e,t,o)}},17722:(e,t,r)=>{var n=r(87181),o=r(86729);e.exports=function(e,t){for(var r=0,i=(t=n(t,e)).length;null!=e&&r<i;)e=e[o(t[r++])];return r&&r==i?e:void 0}},74403:(e,t,r)=>{var n=r(78740),o=r(6397);e.exports=function(e,t,r){var i=t(e);return o(e)?i:n(i,r(e))}},87148:(e,t,r)=>{var n=r(32781),o=r(17903),i=r(71738),a=n?n.toStringTag:void 0;e.exports=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":a&&a in Object(e)?o(e):i(e)}},809:e=>{e.exports=function(e,t){return null!=e&&t in Object(e)}},4575:(e,t,r)=>{var n=r(15663),o=r(12827),i=r(16547);e.exports=function(e,t,r){return t==t?i(e,t,r):n(e,o,r)}},79250:(e,t,r)=>{var n=r(87148),o=r(22934);e.exports=function(e){return o(e)&&"[object Arguments]"==n(e)}},22122:(e,t,r)=>{var n=r(42032),o=r(22934);e.exports=function e(t,r,i,a,l){return t===r||(null==t||null==r||!o(t)&&!o(r)?t!=t&&r!=r:n(t,r,i,a,e,l))}},42032:(e,t,r)=>{var n=r(86469),o=r(44075),i=r(64622),a=r(62677),l=r(31201),u=r(6397),s=r(30492),c=r(47995),d="[object Arguments]",f="[object Array]",p="[object Object]",g=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,v,h,m){var y=u(e),b=u(t),E=y?f:l(e),O=b?f:l(t),S=(E=E==d?p:E)==p,_=(O=O==d?p:O)==p,w=E==O;if(w&&s(e)){if(!s(t))return!1;y=!0,S=!1}if(w&&!S)return m||(m=new n),y||c(e)?o(e,t,r,v,h,m):i(e,t,E,r,v,h,m);if(!(1&r)){var T=S&&g.call(e,"__wrapped__"),P=_&&g.call(t,"__wrapped__");if(T||P){var C=T?e.value():e,I=P?t.value():t;return m||(m=new n),h(C,I,r,v,m)}}return!!w&&(m||(m=new n),a(e,t,r,v,h,m))}},4800:(e,t,r)=>{var n=r(31201),o=r(22934);e.exports=function(e){return o(e)&&"[object Map]"==n(e)}},72491:(e,t,r)=>{var n=r(86469),o=r(22122);e.exports=function(e,t,r,i){var a=r.length,l=a,u=!i;if(null==e)return!l;for(e=Object(e);a--;){var s=r[a];if(u&&s[2]?s[1]!==e[s[0]]:!(s[0]in e))return!1}for(;++a<l;){var c=(s=r[a])[0],d=e[c],f=s[1];if(u&&s[2]){if(void 0===d&&!(c in e))return!1}else{var p=new n;if(i)var g=i(d,f,c,e,t,p);if(!(void 0===g?o(f,d,3,i,p):g))return!1}}return!0}},12827:e=>{e.exports=function(e){return e!=e}},16567:(e,t,r)=>{var n=r(18446),o=r(18092),i=r(58953),a=r(81485),l=/^\[object .+?Constructor\]$/,u=Function.prototype,s=Object.prototype,c=u.toString,d=s.hasOwnProperty,f=RegExp("^"+c.call(d).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=function(e){return!(!i(e)||o(e))&&(n(e)?f:l).test(a(e))}},7866:(e,t,r)=>{var n=r(31201),o=r(22934);e.exports=function(e){return o(e)&&"[object Set]"==n(e)}},97129:(e,t,r)=>{var n=r(87148),o=r(3330),i=r(22934),a={};a["[object Float32Array]"]=a["[object Float64Array]"]=a["[object Int8Array]"]=a["[object Int16Array]"]=a["[object Int32Array]"]=a["[object Uint8Array]"]=a["[object Uint8ClampedArray]"]=a["[object Uint16Array]"]=a["[object Uint32Array]"]=!0,a["[object Arguments]"]=a["[object Array]"]=a["[object ArrayBuffer]"]=a["[object Boolean]"]=a["[object DataView]"]=a["[object Date]"]=a["[object Error]"]=a["[object Function]"]=a["[object Map]"]=a["[object Number]"]=a["[object Object]"]=a["[object RegExp]"]=a["[object Set]"]=a["[object String]"]=a["[object WeakMap]"]=!1,e.exports=function(e){return i(e)&&o(e.length)&&!!a[n(e)]}},31454:(e,t,r)=>{var n=r(68171),o=r(37182),i=r(74796),a=r(6397),l=r(75795);e.exports=function(e){return"function"==typeof e?e:null==e?i:"object"==typeof e?a(e)?o(e[0],e[1]):n(e):l(e)}},81452:(e,t,r)=>{var n=r(67499),o=r(9566),i=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return o(e);var t=[];for(var r in Object(e))i.call(e,r)&&"constructor"!=r&&t.push(r);return t}},41491:(e,t,r)=>{var n=r(58953),o=r(67499),i=r(68201),a=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return i(e);var t=o(e),r=[];for(var l in e)("constructor"!=l||!t&&a.call(e,l))&&r.push(l);return r}},68171:(e,t,r)=>{var n=r(72491),o=r(77924),i=r(43729);e.exports=function(e){var t=o(e);return 1==t.length&&t[0][2]?i(t[0][0],t[0][1]):function(r){return r===e||n(r,e,t)}}},37182:(e,t,r)=>{var n=r(22122),o=r(62832),i=r(98235),a=r(13726),l=r(23048),u=r(43729),s=r(86729);e.exports=function(e,t){return a(e)&&l(t)?u(s(e),t):function(r){var a=o(r,e);return void 0===a&&a===t?i(r,e):n(t,a,3)}}},99702:(e,t,r)=>{var n=r(86469),o=r(61617),i=r(61469),a=r(80708),l=r(58953),u=r(15405),s=r(29874);e.exports=function e(t,r,c,d,f){t!==r&&i(r,(function(i,u){if(f||(f=new n),l(i))a(t,r,u,c,e,d,f);else{var p=d?d(s(t,u),i,u+"",t,r,f):void 0;void 0===p&&(p=i),o(t,u,p)}}),u)}},80708:(e,t,r)=>{var n=r(61617),o=r(87030),i=r(76733),a=r(68835),l=r(19181),u=r(21256),s=r(6397),c=r(75569),d=r(30492),f=r(18446),p=r(58953),g=r(54679),v=r(47995),h=r(29874),m=r(47264);e.exports=function(e,t,r,y,b,E,O){var S=h(e,r),_=h(t,r),w=O.get(_);if(w)n(e,r,w);else{var T=E?E(S,_,r+"",e,t,O):void 0,P=void 0===T;if(P){var C=s(_),I=!C&&d(_),A=!C&&!I&&v(_);T=_,C||I||A?s(S)?T=S:c(S)?T=a(S):I?(P=!1,T=o(_,!0)):A?(P=!1,T=i(_,!0)):T=[]:g(_)||u(_)?(T=S,u(S)?T=m(S):p(S)&&!f(S)||(T=l(_))):P=!1}P&&(O.set(_,T),b(T,_,y,E,O),O.delete(_)),n(e,r,T)}}},26733:(e,t,r)=>{var n=r(5576),o=r(98235);e.exports=function(e,t){return n(e,t,(function(t,r){return o(e,r)}))}},5576:(e,t,r)=>{var n=r(17722),o=r(68230),i=r(87181);e.exports=function(e,t,r){for(var a=-1,l=t.length,u={};++a<l;){var s=t[a],c=n(e,s);r(c,s)&&o(u,i(s,e),c)}return u}},93305:e=>{e.exports=function(e){return function(t){return null==t?void 0:t[e]}}},75267:(e,t,r)=>{var n=r(17722);e.exports=function(e){return function(t){return n(t,e)}}},19955:e=>{var t=Math.ceil,r=Math.max;e.exports=function(e,n,o,i){for(var a=-1,l=r(t((n-e)/(o||1)),0),u=Array(l);l--;)u[i?l:++a]=e,e+=o;return u}},82855:e=>{var t=Math.floor;e.exports=function(e,r){var n="";if(!e||r<1||r>9007199254740991)return n;do{r%2&&(n+=e),(r=t(r/2))&&(e+=e)}while(r);return n}},71506:(e,t,r)=>{var n=r(74796),o=r(25265),i=r(26805);e.exports=function(e,t){return i(o(e,t,n),e+"")}},68230:(e,t,r)=>{var n=r(82863),o=r(87181),i=r(42845),a=r(58953),l=r(86729);e.exports=function(e,t,r,u){if(!a(e))return e;for(var s=-1,c=(t=o(t,e)).length,d=c-1,f=e;null!=f&&++s<c;){var p=l(t[s]),g=r;if("__proto__"===p||"constructor"===p||"prototype"===p)return e;if(s!=d){var v=f[p];void 0===(g=u?u(v,p,f):void 0)&&(g=a(v)?v:i(t[s+1])?[]:{})}n(f,p,g),f=f[p]}return e}},7310:(e,t,r)=>{var n=r(53122),o=r(18559),i=r(74796),a=o?function(e,t){return o(e,"toString",{configurable:!0,enumerable:!1,value:n(t),writable:!0})}:i;e.exports=a},49772:e=>{e.exports=function(e,t,r){var n=-1,o=e.length;t<0&&(t=-t>o?0:o+t),(r=r>o?o:r)<0&&(r+=o),o=t>r?0:r-t>>>0,t>>>=0;for(var i=Array(o);++n<o;)i[n]=e[n+t];return i}},36204:e=>{e.exports=function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}},36584:(e,t,r)=>{var n=r(32781),o=r(44272),i=r(6397),a=r(75414),l=n?n.prototype:void 0,u=l?l.toString:void 0;e.exports=function e(t){if("string"==typeof t)return t;if(i(t))return o(t,e)+"";if(a(t))return u?u.call(t):"";var r=t+"";return"0"==r&&1/t==-1/0?"-0":r}},68812:(e,t,r)=>{var n=r(62140),o=/^\s+/;e.exports=function(e){return e?e.slice(0,n(e)+1).replace(o,""):e}},30041:e=>{e.exports=function(e){return function(t){return e(t)}}},35263:(e,t,r)=>{var n=r(87181),o=r(75342),i=r(48549),a=r(86729);e.exports=function(e,t){return t=n(t,e),null==(e=i(e,t))||delete e[a(o(t))]}},57838:(e,t,r)=>{var n=r(44272);e.exports=function(e,t){return n(t,(function(t){return e[t]}))}},79151:e=>{e.exports=function(e,t){return e.has(t)}},87181:(e,t,r)=>{var n=r(6397),o=r(13726),i=r(43614),a=r(53506);e.exports=function(e,t){return n(e)?e:o(e,t)?[e]:i(a(e))}},57177:(e,t,r)=>{var n=r(28944);e.exports=function(e){var t=new e.constructor(e.byteLength);return new n(t).set(new n(e)),t}},87030:(e,t,r)=>{e=r.nmd(e);var n=r(41433),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o?n.Buffer:void 0,l=a?a.allocUnsafe:void 0;e.exports=function(e,t){if(t)return e.slice();var r=e.length,n=l?l(r):new e.constructor(r);return e.copy(n),n}},24893:(e,t,r)=>{var n=r(57177);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}},94021:e=>{var t=/\w*$/;e.exports=function(e){var r=new e.constructor(e.source,t.exec(e));return r.lastIndex=e.lastIndex,r}},61548:(e,t,r)=>{var n=r(32781),o=n?n.prototype:void 0,i=o?o.valueOf:void 0;e.exports=function(e){return i?Object(i.call(e)):{}}},76733:(e,t,r)=>{var n=r(57177);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}},68835:e=>{e.exports=function(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}},42083:(e,t,r)=>{var n=r(82863),o=r(14772);e.exports=function(e,t,r,i){var a=!r;r||(r={});for(var l=-1,u=t.length;++l<u;){var s=t[l],c=i?i(r[s],e[s],s,r,e):void 0;void 0===c&&(c=e[s]),a?o(r,s,c):n(r,s,c)}return r}},90859:(e,t,r)=>{var n=r(42083),o=r(88876);e.exports=function(e,t){return n(e,o(e),t)}},96728:(e,t,r)=>{var n=r(42083),o=r(58355);e.exports=function(e,t){return n(e,o(e),t)}},38109:(e,t,r)=>{var n=r(41433)["__core-js_shared__"];e.exports=n},54171:(e,t,r)=>{var n=r(71506),o=r(66220);e.exports=function(e){return n((function(t,r){var n=-1,i=r.length,a=i>1?r[i-1]:void 0,l=i>2?r[2]:void 0;for(a=e.length>3&&"function"==typeof a?(i--,a):void 0,l&&o(r[0],r[1],l)&&(a=i<3?void 0:a,i=1),t=Object(t);++n<i;){var u=r[n];u&&e(t,u,n,a)}return t}))}},15409:e=>{e.exports=function(e){return function(t,r,n){for(var o=-1,i=Object(t),a=n(t),l=a.length;l--;){var u=a[e?l:++o];if(!1===r(i[u],u,i))break}return t}}},9648:(e,t,r)=>{var n=r(19955),o=r(66220),i=r(14764);e.exports=function(e){return function(t,r,a){return a&&"number"!=typeof a&&o(t,r,a)&&(r=a=void 0),t=i(t),void 0===r?(r=t,t=0):r=i(r),a=void 0===a?t<r?1:-1:i(a),n(t,r,a,e)}}},77222:(e,t,r)=>{var n=r(54679);e.exports=function(e){return n(e)?void 0:e}},18559:(e,t,r)=>{var n=r(99138),o=function(){try{var e=n(Object,"defineProperty");return e({},"",{}),e}catch(e){}}();e.exports=o},44075:(e,t,r)=>{var n=r(61527),o=r(57260),i=r(79151);e.exports=function(e,t,r,a,l,u){var s=1&r,c=e.length,d=t.length;if(c!=d&&!(s&&d>c))return!1;var f=u.get(e),p=u.get(t);if(f&&p)return f==t&&p==e;var g=-1,v=!0,h=2&r?new n:void 0;for(u.set(e,t),u.set(t,e);++g<c;){var m=e[g],y=t[g];if(a)var b=s?a(y,m,g,t,e,u):a(m,y,g,e,t,u);if(void 0!==b){if(b)continue;v=!1;break}if(h){if(!o(t,(function(e,t){if(!i(h,t)&&(m===e||l(m,e,r,a,u)))return h.push(t)}))){v=!1;break}}else if(m!==y&&!l(m,y,r,a,u)){v=!1;break}}return u.delete(e),u.delete(t),v}},64622:(e,t,r)=>{var n=r(32781),o=r(28944),i=r(39316),a=r(44075),l=r(90953),u=r(15851),s=n?n.prototype:void 0,c=s?s.valueOf:void 0;e.exports=function(e,t,r,n,s,d,f){switch(r){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return!(e.byteLength!=t.byteLength||!d(new o(e),new o(t)));case"[object Boolean]":case"[object Date]":case"[object Number]":return i(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var p=l;case"[object Set]":var g=1&n;if(p||(p=u),e.size!=t.size&&!g)return!1;var v=f.get(e);if(v)return v==t;n|=2,f.set(e,t);var h=a(p(e),p(t),n,s,d,f);return f.delete(e),h;case"[object Symbol]":if(c)return c.call(e)==c.call(t)}return!1}},62677:(e,t,r)=>{var n=r(90966),o=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,i,a,l){var u=1&r,s=n(e),c=s.length;if(c!=n(t).length&&!u)return!1;for(var d=c;d--;){var f=s[d];if(!(u?f in t:o.call(t,f)))return!1}var p=l.get(e),g=l.get(t);if(p&&g)return p==t&&g==e;var v=!0;l.set(e,t),l.set(t,e);for(var h=u;++d<c;){var m=e[f=s[d]],y=t[f];if(i)var b=u?i(y,m,f,t,e,l):i(m,y,f,e,t,l);if(!(void 0===b?m===y||a(m,y,r,i,l):b)){v=!1;break}h||(h="constructor"==f)}if(v&&!h){var E=e.constructor,O=t.constructor;E==O||!("constructor"in e)||!("constructor"in t)||"function"==typeof E&&E instanceof E&&"function"==typeof O&&O instanceof O||(v=!1)}return l.delete(e),l.delete(t),v}},59820:(e,t,r)=>{var n=r(73406),o=r(25265),i=r(26805);e.exports=function(e){return i(o(e,void 0,n),e+"")}},75380:(e,t,r)=>{var n="object"==typeof r.g&&r.g&&r.g.Object===Object&&r.g;e.exports=n},90966:(e,t,r)=>{var n=r(74403),o=r(88876),i=r(31178);e.exports=function(e){return n(e,i,o)}},29697:(e,t,r)=>{var n=r(74403),o=r(58355),i=r(15405);e.exports=function(e){return n(e,i,o)}},15535:(e,t,r)=>{var n=r(95662);e.exports=function(e,t){var r=e.__data__;return n(t)?r["string"==typeof t?"string":"hash"]:r.map}},77924:(e,t,r)=>{var n=r(23048),o=r(31178);e.exports=function(e){for(var t=o(e),r=t.length;r--;){var i=t[r],a=e[i];t[r]=[i,a,n(a)]}return t}},99138:(e,t,r)=>{var n=r(16567),o=r(6772);e.exports=function(e,t){var r=o(e,t);return n(r)?r:void 0}},13347:(e,t,r)=>{var n=r(51019)(Object.getPrototypeOf,Object);e.exports=n},17903:(e,t,r)=>{var n=r(32781),o=Object.prototype,i=o.hasOwnProperty,a=o.toString,l=n?n.toStringTag:void 0;e.exports=function(e){var t=i.call(e,l),r=e[l];try{e[l]=void 0;var n=!0}catch(e){}var o=a.call(e);return n&&(t?e[l]=r:delete e[l]),o}},88876:(e,t,r)=>{var n=r(61414),o=r(53629),i=Object.prototype.propertyIsEnumerable,a=Object.getOwnPropertySymbols,l=a?function(e){return null==e?[]:(e=Object(e),n(a(e),(function(t){return i.call(e,t)})))}:o;e.exports=l},58355:(e,t,r)=>{var n=r(78740),o=r(13347),i=r(88876),a=r(53629),l=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)n(t,i(e)),e=o(e);return t}:a;e.exports=l},31201:(e,t,r)=>{var n=r(1416),o=r(91955),i=r(42616),a=r(60157),l=r(78499),u=r(87148),s=r(81485),c="[object Map]",d="[object Promise]",f="[object Set]",p="[object WeakMap]",g="[object DataView]",v=s(n),h=s(o),m=s(i),y=s(a),b=s(l),E=u;(n&&E(new n(new ArrayBuffer(1)))!=g||o&&E(new o)!=c||i&&E(i.resolve())!=d||a&&E(new a)!=f||l&&E(new l)!=p)&&(E=function(e){var t=u(e),r="[object Object]"==t?e.constructor:void 0,n=r?s(r):"";if(n)switch(n){case v:return g;case h:return c;case m:return d;case y:return f;case b:return p}return t}),e.exports=E},6772:e=>{e.exports=function(e,t){return null==e?void 0:e[t]}},16866:(e,t,r)=>{var n=r(87181),o=r(21256),i=r(6397),a=r(42845),l=r(3330),u=r(86729);e.exports=function(e,t,r){for(var s=-1,c=(t=n(t,e)).length,d=!1;++s<c;){var f=u(t[s]);if(!(d=null!=e&&r(e,f)))break;e=e[f]}return d||++s!=c?d:!!(c=null==e?0:e.length)&&l(c)&&a(f,c)&&(i(e)||o(e))}},82316:(e,t,r)=>{var n=r(4558);e.exports=function(){this.__data__=n?n(null):{},this.size=0}},76458:e=>{e.exports=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}},2149:(e,t,r)=>{var n=r(4558),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;if(n){var r=t[e];return"__lodash_hash_undefined__"===r?void 0:r}return o.call(t,e)?t[e]:void 0}},44297:(e,t,r)=>{var n=r(4558),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;return n?void 0!==t[e]:o.call(t,e)}},33121:(e,t,r)=>{var n=r(4558);e.exports=function(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=n&&void 0===t?"__lodash_hash_undefined__":t,this}},96785:e=>{var t=Object.prototype.hasOwnProperty;e.exports=function(e){var r=e.length,n=new e.constructor(r);return r&&"string"==typeof e[0]&&t.call(e,"index")&&(n.index=e.index,n.input=e.input),n}},43283:(e,t,r)=>{var n=r(57177),o=r(24893),i=r(94021),a=r(61548),l=r(76733);e.exports=function(e,t,r){var u=e.constructor;switch(t){case"[object ArrayBuffer]":return n(e);case"[object Boolean]":case"[object Date]":return new u(+e);case"[object DataView]":return o(e,r);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return l(e,r);case"[object Map]":case"[object Set]":return new u;case"[object Number]":case"[object String]":return new u(e);case"[object RegExp]":return i(e);case"[object Symbol]":return a(e)}}},19181:(e,t,r)=>{var n=r(23508),o=r(13347),i=r(67499);e.exports=function(e){return"function"!=typeof e.constructor||i(e)?{}:n(o(e))}},18031:(e,t,r)=>{var n=r(32781),o=r(21256),i=r(6397),a=n?n.isConcatSpreadable:void 0;e.exports=function(e){return i(e)||o(e)||!!(a&&e&&e[a])}},42845:e=>{var t=/^(?:0|[1-9]\d*)$/;e.exports=function(e,r){var n=typeof e;return!!(r=null==r?9007199254740991:r)&&("number"==n||"symbol"!=n&&t.test(e))&&e>-1&&e%1==0&&e<r}},66220:(e,t,r)=>{var n=r(39316),o=r(18330),i=r(42845),a=r(58953);e.exports=function(e,t,r){if(!a(r))return!1;var l=typeof t;return!!("number"==l?o(r)&&i(t,r.length):"string"==l&&t in r)&&n(r[t],e)}},13726:(e,t,r)=>{var n=r(6397),o=r(75414),i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,a=/^\w*$/;e.exports=function(e,t){if(n(e))return!1;var r=typeof e;return!("number"!=r&&"symbol"!=r&&"boolean"!=r&&null!=e&&!o(e))||a.test(e)||!i.test(e)||null!=t&&e in Object(t)}},95662:e=>{e.exports=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}},18092:(e,t,r)=>{var n,o=r(38109),i=(n=/[^.]+$/.exec(o&&o.keys&&o.keys.IE_PROTO||""))?"Symbol(src)_1."+n:"";e.exports=function(e){return!!i&&i in e}},67499:e=>{var t=Object.prototype;e.exports=function(e){var r=e&&e.constructor;return e===("function"==typeof r&&r.prototype||t)}},23048:(e,t,r)=>{var n=r(58953);e.exports=function(e){return e==e&&!n(e)}},39714:e=>{e.exports=function(){this.__data__=[],this.size=0}},33812:(e,t,r)=>{var n=r(58301),o=Array.prototype.splice;e.exports=function(e){var t=this.__data__,r=n(t,e);return!(r<0||(r==t.length-1?t.pop():o.call(t,r,1),--this.size,0))}},14727:(e,t,r)=>{var n=r(58301);e.exports=function(e){var t=this.__data__,r=n(t,e);return r<0?void 0:t[r][1]}},8379:(e,t,r)=>{var n=r(58301);e.exports=function(e){return n(this.__data__,e)>-1}},8291:(e,t,r)=>{var n=r(58301);e.exports=function(e,t){var r=this.__data__,o=n(r,e);return o<0?(++this.size,r.push([e,t])):r[o][1]=t,this}},72092:(e,t,r)=>{var n=r(9073),o=r(72707),i=r(91955);e.exports=function(){this.size=0,this.__data__={hash:new n,map:new(i||o),string:new n}}},49626:(e,t,r)=>{var n=r(15535);e.exports=function(e){var t=n(this,e).delete(e);return this.size-=t?1:0,t}},79925:(e,t,r)=>{var n=r(15535);e.exports=function(e){return n(this,e).get(e)}},26809:(e,t,r)=>{var n=r(15535);e.exports=function(e){return n(this,e).has(e)}},94385:(e,t,r)=>{var n=r(15535);e.exports=function(e,t){var r=n(this,e),o=r.size;return r.set(e,t),this.size+=r.size==o?0:1,this}},90953:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}},43729:e=>{e.exports=function(e,t){return function(r){return null!=r&&r[e]===t&&(void 0!==t||e in Object(r))}}},79268:(e,t,r)=>{var n=r(14556);e.exports=function(e){var t=n(e,(function(e){return 500===r.size&&r.clear(),e})),r=t.cache;return t}},4558:(e,t,r)=>{var n=r(99138)(Object,"create");e.exports=n},9566:(e,t,r)=>{var n=r(51019)(Object.keys,Object);e.exports=n},68201:e=>{e.exports=function(e){var t=[];if(null!=e)for(var r in Object(e))t.push(r);return t}},23685:(e,t,r)=>{e=r.nmd(e);var n=r(75380),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o&&n.process,l=function(){try{return i&&i.require&&i.require("util").types||a&&a.binding&&a.binding("util")}catch(e){}}();e.exports=l},71738:e=>{var t=Object.prototype.toString;e.exports=function(e){return t.call(e)}},51019:e=>{e.exports=function(e,t){return function(r){return e(t(r))}}},25265:(e,t,r)=>{var n=r(96701),o=Math.max;e.exports=function(e,t,r){return t=o(void 0===t?e.length-1:t,0),function(){for(var i=arguments,a=-1,l=o(i.length-t,0),u=Array(l);++a<l;)u[a]=i[t+a];a=-1;for(var s=Array(t+1);++a<t;)s[a]=i[a];return s[t]=r(u),n(e,this,s)}}},48549:(e,t,r)=>{var n=r(17722),o=r(49772);e.exports=function(e,t){return t.length<2?e:n(e,o(t,0,-1))}},41433:(e,t,r)=>{var n=r(75380),o="object"==typeof self&&self&&self.Object===Object&&self,i=n||o||Function("return this")();e.exports=i},29874:e=>{e.exports=function(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}},79912:e=>{e.exports=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this}},23767:e=>{e.exports=function(e){return this.__data__.has(e)}},15851:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}},26805:(e,t,r)=>{var n=r(7310),o=r(23983)(n);e.exports=o},23983:e=>{var t=Date.now;e.exports=function(e){var r=0,n=0;return function(){var o=t(),i=16-(o-n);if(n=o,i>0){if(++r>=800)return arguments[0]}else r=0;return e.apply(void 0,arguments)}}},71848:(e,t,r)=>{var n=r(72707);e.exports=function(){this.__data__=new n,this.size=0}},17406:e=>{e.exports=function(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r}},58569:e=>{e.exports=function(e){return this.__data__.get(e)}},43109:e=>{e.exports=function(e){return this.__data__.has(e)}},73389:(e,t,r)=>{var n=r(72707),o=r(91955),i=r(90369);e.exports=function(e,t){var r=this.__data__;if(r instanceof n){var a=r.__data__;if(!o||a.length<199)return a.push([e,t]),this.size=++r.size,this;r=this.__data__=new i(a)}return r.set(e,t),this.size=r.size,this}},16547:e=>{e.exports=function(e,t,r){for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}},43614:(e,t,r)=>{var n=r(79268),o=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,i=/\\(\\)?/g,a=n((function(e){var t=[];return 46===e.charCodeAt(0)&&t.push(""),e.replace(o,(function(e,r,n,o){t.push(n?o.replace(i,"$1"):r||e)})),t}));e.exports=a},86729:(e,t,r)=>{var n=r(75414);e.exports=function(e){if("string"==typeof e||n(e))return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}},81485:e=>{var t=Function.prototype.toString;e.exports=function(e){if(null!=e){try{return t.call(e)}catch(e){}try{return e+""}catch(e){}}return""}},62140:e=>{var t=/\s/;e.exports=function(e){for(var r=e.length;r--&&t.test(e.charAt(r)););return r}},53122:e=>{e.exports=function(e){return function(){return e}}},39316:e=>{e.exports=function(e,t){return e===t||e!=e&&t!=t}},27572:(e,t,r)=>{var n=r(53506),o=/[\\^$.*+?()[\]{}|]/g,i=RegExp(o.source);e.exports=function(e){return(e=n(e))&&i.test(e)?e.replace(o,"\\$&"):e}},73406:(e,t,r)=>{var n=r(61044);e.exports=function(e){return null!=e&&e.length?n(e,1):[]}},62832:(e,t,r)=>{var n=r(17722);e.exports=function(e,t,r){var o=null==e?void 0:n(e,t);return void 0===o?r:o}},98235:(e,t,r)=>{var n=r(809),o=r(16866);e.exports=function(e,t){return null!=e&&o(e,t,n)}},74796:e=>{e.exports=function(e){return e}},39007:(e,t,r)=>{var n=r(4575),o=r(18330),i=r(7571),a=r(79445),l=r(23308),u=Math.max;e.exports=function(e,t,r,s){e=o(e)?e:l(e),r=r&&!s?a(r):0;var c=e.length;return r<0&&(r=u(c+r,0)),i(e)?r<=c&&e.indexOf(t,r)>-1:!!c&&n(e,t,r)>-1}},21256:(e,t,r)=>{var n=r(79250),o=r(22934),i=Object.prototype,a=i.hasOwnProperty,l=i.propertyIsEnumerable,u=n(function(){return arguments}())?n:function(e){return o(e)&&a.call(e,"callee")&&!l.call(e,"callee")};e.exports=u},6397:e=>{var t=Array.isArray;e.exports=t},18330:(e,t,r)=>{var n=r(18446),o=r(3330);e.exports=function(e){return null!=e&&o(e.length)&&!n(e)}},75569:(e,t,r)=>{var n=r(18330),o=r(22934);e.exports=function(e){return o(e)&&n(e)}},30492:(e,t,r)=>{e=r.nmd(e);var n=r(41433),o=r(80659),i=t&&!t.nodeType&&t,a=i&&e&&!e.nodeType&&e,l=a&&a.exports===i?n.Buffer:void 0,u=(l?l.isBuffer:void 0)||o;e.exports=u},95685:(e,t,r)=>{var n=r(81452),o=r(31201),i=r(21256),a=r(6397),l=r(18330),u=r(30492),s=r(67499),c=r(47995),d=Object.prototype.hasOwnProperty;e.exports=function(e){if(null==e)return!0;if(l(e)&&(a(e)||"string"==typeof e||"function"==typeof e.splice||u(e)||c(e)||i(e)))return!e.length;var t=o(e);if("[object Map]"==t||"[object Set]"==t)return!e.size;if(s(e))return!n(e).length;for(var r in e)if(d.call(e,r))return!1;return!0}},18446:(e,t,r)=>{var n=r(87148),o=r(58953);e.exports=function(e){if(!o(e))return!1;var t=n(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}},3330:e=>{e.exports=function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=9007199254740991}},50422:(e,t,r)=>{var n=r(4800),o=r(30041),i=r(23685),a=i&&i.isMap,l=a?o(a):n;e.exports=l},58953:e=>{e.exports=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}},22934:e=>{e.exports=function(e){return null!=e&&"object"==typeof e}},54679:(e,t,r)=>{var n=r(87148),o=r(13347),i=r(22934),a=Function.prototype,l=Object.prototype,u=a.toString,s=l.hasOwnProperty,c=u.call(Object);e.exports=function(e){if(!i(e)||"[object Object]"!=n(e))return!1;var t=o(e);if(null===t)return!0;var r=s.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&u.call(r)==c}},53764:(e,t,r)=>{var n=r(7866),o=r(30041),i=r(23685),a=i&&i.isSet,l=a?o(a):n;e.exports=l},7571:(e,t,r)=>{var n=r(87148),o=r(6397),i=r(22934);e.exports=function(e){return"string"==typeof e||!o(e)&&i(e)&&"[object String]"==n(e)}},75414:(e,t,r)=>{var n=r(87148),o=r(22934);e.exports=function(e){return"symbol"==typeof e||o(e)&&"[object Symbol]"==n(e)}},47995:(e,t,r)=>{var n=r(97129),o=r(30041),i=r(23685),a=i&&i.isTypedArray,l=a?o(a):n;e.exports=l},31178:(e,t,r)=>{var n=r(31163),o=r(81452),i=r(18330);e.exports=function(e){return i(e)?n(e):o(e)}},15405:(e,t,r)=>{var n=r(31163),o=r(41491),i=r(18330);e.exports=function(e){return i(e)?n(e,!0):o(e)}},75342:e=>{e.exports=function(e){var t=null==e?0:e.length;return t?e[t-1]:void 0}},9680:(e,t,r)=>{var n=r(14772),o=r(61701),i=r(31454);e.exports=function(e,t){var r={};return t=i(t,3),o(e,(function(e,o,i){n(r,o,t(e,o,i))})),r}},14556:(e,t,r)=>{var n=r(90369);function o(e,t){if("function"!=typeof e||null!=t&&"function"!=typeof t)throw new TypeError("Expected a function");var r=function(){var n=arguments,o=t?t.apply(this,n):n[0],i=r.cache;if(i.has(o))return i.get(o);var a=e.apply(this,n);return r.cache=i.set(o,a)||i,a};return r.cache=new(o.Cache||n),r}o.Cache=n,e.exports=o},25632:(e,t,r)=>{var n=r(99702),o=r(54171)((function(e,t,r){n(e,t,r)}));e.exports=o},89032:(e,t,r)=>{var n=r(99702),o=r(54171)((function(e,t,r,o){n(e,t,r,o)}));e.exports=o},24319:(e,t,r)=>{var n=r(44272),o=r(2931),i=r(35263),a=r(87181),l=r(42083),u=r(77222),s=r(59820),c=r(29697),d=s((function(e,t){var r={};if(null==e)return r;var s=!1;t=n(t,(function(t){return t=a(t,e),s||(s=t.length>1),t})),l(e,c(e),r),s&&(r=o(r,7,u));for(var d=t.length;d--;)i(r,t[d]);return r}));e.exports=d},67171:(e,t,r)=>{var n=r(26733),o=r(59820)((function(e,t){return null==e?{}:n(e,t)}));e.exports=o},55026:(e,t,r)=>{var n=r(44272),o=r(31454),i=r(5576),a=r(29697);e.exports=function(e,t){if(null==e)return{};var r=n(a(e),(function(e){return[e]}));return t=o(t),i(e,r,(function(e,r){return t(e,r[0])}))}},75795:(e,t,r)=>{var n=r(93305),o=r(75267),i=r(13726),a=r(86729);e.exports=function(e){return i(e)?n(a(e)):o(e)}},53649:(e,t,r)=>{var n=r(9648)();e.exports=n},54249:(e,t,r)=>{var n=r(82855),o=r(66220),i=r(79445),a=r(53506);e.exports=function(e,t,r){return t=(r?o(e,t,r):void 0===t)?1:i(t),n(a(e),t)}},83391:(e,t,r)=>{var n=r(53025),o=r(36584),i=r(79445),a=r(53506);e.exports=function(e,t,r){return e=a(e),r=null==r?0:n(i(r),0,e.length),t=o(t),e.slice(r,r+t.length)==t}},53629:e=>{e.exports=function(){return[]}},80659:e=>{e.exports=function(){return!1}},14764:(e,t,r)=>{var n=r(95378),o=1/0;e.exports=function(e){return e?(e=n(e))===o||e===-1/0?17976931348623157e292*(e<0?-1:1):e==e?e:0:0===e?e:0}},79445:(e,t,r)=>{var n=r(14764);e.exports=function(e){var t=n(e),r=t%1;return t==t?r?t-r:t:0}},95378:(e,t,r)=>{var n=r(68812),o=r(58953),i=r(75414),a=/^[-+]0x[0-9a-f]+$/i,l=/^0b[01]+$/i,u=/^0o[0-7]+$/i,s=parseInt;e.exports=function(e){if("number"==typeof e)return e;if(i(e))return NaN;if(o(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=o(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=n(e);var r=l.test(e);return r||u.test(e)?s(e.slice(2),r?2:8):a.test(e)?NaN:+e}},47264:(e,t,r)=>{var n=r(42083),o=r(15405);e.exports=function(e){return n(e,o(e))}},53506:(e,t,r)=>{var n=r(36584);e.exports=function(e){return null==e?"":n(e)}},23308:(e,t,r)=>{var n=r(57838),o=r(31178);e.exports=function(e){return null==e?[]:n(e,o(e))}},95689:(e,t,r)=>{"use strict";const n=r(29691),o=Symbol("max"),i=Symbol("length"),a=Symbol("lengthCalculator"),l=Symbol("allowStale"),u=Symbol("maxAge"),s=Symbol("dispose"),c=Symbol("noDisposeOnSet"),d=Symbol("lruList"),f=Symbol("cache"),p=Symbol("updateAgeOnGet"),g=()=>1,v=(e,t,r)=>{const n=e[f].get(t);if(n){const t=n.value;if(h(e,t)){if(y(e,n),!e[l])return}else r&&(e[p]&&(n.value.now=Date.now()),e[d].unshiftNode(n));return t.value}},h=(e,t)=>{if(!t||!t.maxAge&&!e[u])return!1;const r=Date.now()-t.now;return t.maxAge?r>t.maxAge:e[u]&&r>e[u]},m=e=>{if(e[i]>e[o])for(let t=e[d].tail;e[i]>e[o]&&null!==t;){const r=t.prev;y(e,t),t=r}},y=(e,t)=>{if(t){const r=t.value;e[s]&&e[s](r.key,r.value),e[i]-=r.length,e[f].delete(r.key),e[d].removeNode(t)}};class b{constructor(e,t,r,n,o){this.key=e,this.value=t,this.length=r,this.now=n,this.maxAge=o||0}}const E=(e,t,r,n)=>{let o=r.value;h(e,o)&&(y(e,r),e[l]||(o=void 0)),o&&t.call(n,o.value,o.key,e)};e.exports=class{constructor(e){if("number"==typeof e&&(e={max:e}),e||(e={}),e.max&&("number"!=typeof e.max||e.max<0))throw new TypeError("max must be a non-negative number");this[o]=e.max||1/0;const t=e.length||g;if(this[a]="function"!=typeof t?g:t,this[l]=e.stale||!1,e.maxAge&&"number"!=typeof e.maxAge)throw new TypeError("maxAge must be a number");this[u]=e.maxAge||0,this[s]=e.dispose,this[c]=e.noDisposeOnSet||!1,this[p]=e.updateAgeOnGet||!1,this.reset()}set max(e){if("number"!=typeof e||e<0)throw new TypeError("max must be a non-negative number");this[o]=e||1/0,m(this)}get max(){return this[o]}set allowStale(e){this[l]=!!e}get allowStale(){return this[l]}set maxAge(e){if("number"!=typeof e)throw new TypeError("maxAge must be a non-negative number");this[u]=e,m(this)}get maxAge(){return this[u]}set lengthCalculator(e){"function"!=typeof e&&(e=g),e!==this[a]&&(this[a]=e,this[i]=0,this[d].forEach((e=>{e.length=this[a](e.value,e.key),this[i]+=e.length}))),m(this)}get lengthCalculator(){return this[a]}get length(){return this[i]}get itemCount(){return this[d].length}rforEach(e,t){t=t||this;for(let r=this[d].tail;null!==r;){const n=r.prev;E(this,e,r,t),r=n}}forEach(e,t){t=t||this;for(let r=this[d].head;null!==r;){const n=r.next;E(this,e,r,t),r=n}}keys(){return this[d].toArray().map((e=>e.key))}values(){return this[d].toArray().map((e=>e.value))}reset(){this[s]&&this[d]&&this[d].length&&this[d].forEach((e=>this[s](e.key,e.value))),this[f]=new Map,this[d]=new n,this[i]=0}dump(){return this[d].map((e=>!h(this,e)&&{k:e.key,v:e.value,e:e.now+(e.maxAge||0)})).toArray().filter((e=>e))}dumpLru(){return this[d]}set(e,t,r){if((r=r||this[u])&&"number"!=typeof r)throw new TypeError("maxAge must be a number");const n=r?Date.now():0,l=this[a](t,e);if(this[f].has(e)){if(l>this[o])return y(this,this[f].get(e)),!1;const a=this[f].get(e).value;return this[s]&&(this[c]||this[s](e,a.value)),a.now=n,a.maxAge=r,a.value=t,this[i]+=l-a.length,a.length=l,this.get(e),m(this),!0}const p=new b(e,t,l,n,r);return p.length>this[o]?(this[s]&&this[s](e,t),!1):(this[i]+=p.length,this[d].unshift(p),this[f].set(e,this[d].head),m(this),!0)}has(e){if(!this[f].has(e))return!1;const t=this[f].get(e).value;return!h(this,t)}get(e){return v(this,e,!0)}peek(e){return v(this,e,!1)}pop(){const e=this[d].tail;return e?(y(this,e),e.value):null}del(e){y(this,this[f].get(e))}load(e){this.reset();const t=Date.now();for(let r=e.length-1;r>=0;r--){const n=e[r],o=n.e||0;if(0===o)this.set(n.k,n.v);else{const e=o-t;e>0&&this.set(n.k,n.v,e)}}}prune(){this[f].forEach(((e,t)=>v(this,t,!1)))}}},80499:(e,t)=>{"use strict";t.v=function(e){e.client&&(document.head.appendChild(e.msh=document.createElement("style")),e.createRule=function(t,r){var n=t+"{}";r&&(n=r+"{"+n+"}");var o=r?e.msh.sheet:e.sh.sheet,i=o.insertRule(n,o.cssRules.length),a=(o.cssRules||o.rules)[i];if(a.index=i,r){var l=(a.cssRules||a.rules)[0];a.style=l.style,a.styleMap=l.styleMap}return a})}},55463:(e,t,r)=>{"use strict";var n=r(33776).t;t.v=function(e){if(e.client){var t=e.kebab;r.prototype.diff=function(e){var r,n=this.decl,o=this.rule.style;for(r in n)void 0===e[r]&&o.removeProperty(r);for(r in e)e[r]!==n[r]&&o.setProperty(t(r),e[r]);this.decl=e},r.prototype.del=function(){n(this.rule)},o.prototype.diff=function(e){var t=this.tree;for(var n in t)if(void 0===e[n]){var o=t[n];for(var i in o)o[i].del()}for(var n in e)if(void 0===t[n])for(var i in e[n])(u=new r(i,n)).diff(e[n][i]),e[n][i]=u;else{var a=t[n],l=e[n];for(var i in a)l[i]||a[i].del();for(var i in l){var u;(u=a[i])?(u.diff(l[i]),l[i]=u):((u=new r(i,n)).diff(l[i]),l[i]=u)}}this.tree=e},e.VRule=r,e.VSheet=o}function r(t,r){this.rule=e.createRule(t,r),this.decl={}}function o(){this.tree={}}}},46330:(e,t)=>{t.J=function e(t,r,n,o){var i,a,l={},u=!1;for(i in r)"object"!=typeof(a=r[i])&&(u=!0,l[i]=a);for(i in u&&(t[o]||(t[o]={}),t[o][n]=l),r)if("object"==typeof(a=r[i]))if("@"===i[0])e(t,a,n,i);else{var s=i.indexOf("&")>-1,c=n.split(",");if(s)for(var d=0;d<c.length;d++)c[d]=i.replace(/&/g,c[d]);else for(d=0;d<c.length;d++)c[d]=c[d]+" "+i;e(t,a,c.join(","),o)}}},33776:(e,t)=>{t.t=function(e){var t=e.index,r=e.parentStyleSheet,n=r.cssRules||r.rules;for(t=Math.max(t,n.length-1);t>=0;){if(n[t]===e){r.deleteRule(t);break}t--}}},21433:(e,t)=>{"use strict";var r=/[A-Z]/g;t.v=function(e){var t=(e=e||{}).assign||Object.assign,n=t({raw:"",pfx:"_",client:"object"==typeof window,assign:t,stringify:JSON.stringify,kebab:function(e){return e.replace(r,"-$&").toLowerCase()},decl:function(e,t){return(e=n.kebab(e))+":"+t+";"},hash:function(e){return function(e){for(var t=5381,r=e.length;r;)t=33*t^e.charCodeAt(--r);return"_"+(t>>>0).toString(36)}(n.stringify(e))},selector:function(e,t){return e+(":"===t[0]?"":" ")+t},putRaw:function(e){n.raw+=e}},e);return n.client&&(n.sh||document.head.appendChild(n.sh=document.createElement("style")),n.putRaw=function(e){var t=n.sh.sheet;try{t.insertRule(e,t.cssRules.length)}catch(e){}}),n.put=function(e,t,r){var o,i,a="",l=[];for(o in t)(i=t[o])instanceof Object&&!(i instanceof Array)?l.push(o):a+=n.decl(o,i,e,r);a&&(a=e+"{"+a+"}",n.putRaw(r?r+"{"+a+"}":a));for(var u=0;u<l.length;u++)"@"===(o=l[u])[0]&&"@font-face"!==o?n.putAt(e,t[o],o):n.put(n.selector(e,o),t[o],r)},n.putAt=n.put,n}},96495:function(e){(function(){var t,r,n,o,i,a;"undefined"!=typeof performance&&null!==performance&&performance.now?e.exports=function(){return performance.now()}:"undefined"!=typeof process&&null!==process&&process.hrtime?(e.exports=function(){return(t()-i)/1e6},r=process.hrtime,o=(t=function(){var e;return 1e9*(e=r())[0]+e[1]})(),a=1e9*process.uptime(),i=o-a):Date.now?(e.exports=function(){return Date.now()-n},n=Date.now()):(e.exports=function(){return(new Date).getTime()-n},n=(new Date).getTime())}).call(this)},56182:(e,t,r)=>{for(var n=r(96495),o="undefined"==typeof window?r.g:window,i=["moz","webkit"],a="AnimationFrame",l=o["request"+a],u=o["cancel"+a]||o["cancelRequest"+a],s=0;!l&&s<i.length;s++)l=o[i[s]+"Request"+a],u=o[i[s]+"Cancel"+a]||o[i[s]+"CancelRequest"+a];if(!l||!u){var c=0,d=0,f=[],p=1e3/60;l=function(e){if(0===f.length){var t=n(),r=Math.max(0,p-(t-c));c=r+t,setTimeout((function(){var e=f.slice(0);f.length=0;for(var t=0;t<e.length;t++)if(!e[t].cancelled)try{e[t].callback(c)}catch(e){setTimeout((function(){throw e}),0)}}),Math.round(r))}return f.push({handle:++d,callback:e,cancelled:!1}),d},u=function(e){for(var t=0;t<f.length;t++)f[t].handle===e&&(f[t].cancelled=!0)}}e.exports=function(e){return l.call(o,e)},e.exports.cancel=function(){u.apply(o,arguments)},e.exports.polyfill=function(e){e||(e=o),e.requestAnimationFrame=l,e.cancelAnimationFrame=u}},62611:(e,t,r)=>{"use strict";var n=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.setDragStart=t.setDragProgress=t.setDragEnd=void 0;var o=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==n(e)&&"function"!=typeof e)return{default:e};var r=i(t);if(r&&r.has(e))return r.get(e);var o={},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var l in e)if("default"!==l&&Object.prototype.hasOwnProperty.call(e,l)){var u=a?Object.getOwnPropertyDescriptor(e,l):null;u&&(u.get||u.set)?Object.defineProperty(o,l,u):o[l]=e[l]}return o.default=e,r&&r.set(e,o),o}(r(55256));function i(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(i=function(e){return e?r:t})(e)}t.setDragProgress=function(e,t){return{type:o.SET_DRAG_PROGRESS,mousePos:e,dragging:t}},t.setDragStart=function(e,t,r){return{type:o.SET_DRAG_START,dragStart:e,dragging:t,mousePos:r}},t.setDragEnd=function(){return{type:o.SET_DRAG_END}}},44150:(e,t,r)=>{"use strict";var n=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.setNot=t.setLock=t.setConjunction=void 0;var o=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==n(e)&&"function"!=typeof e)return{default:e};var r=a(t);if(r&&r.has(e))return r.get(e);var o={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var l in e)if("default"!==l&&Object.prototype.hasOwnProperty.call(e,l)){var u=i?Object.getOwnPropertyDescriptor(e,l):null;u&&(u.get||u.set)?Object.defineProperty(o,l,u):o[l]=e[l]}return o.default=e,r&&r.set(e,o),o}(r(55256)),i=r(98477);function a(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(a=function(e){return e?r:t})(e)}t.setConjunction=function(e,t,r){return{type:o.SET_CONJUNCTION,path:(0,i.toImmutableList)(t),conjunction:r}},t.setNot=function(e,t,r){return{type:o.SET_NOT,path:(0,i.toImmutableList)(t),not:r}},t.setLock=function(e,t,r){return{type:o.SET_LOCK,path:(0,i.toImmutableList)(t),lock:r}}},74417:(e,t,r)=>{"use strict";var n=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.tree=t.rule=t.group=t.drag=void 0;var o=s(r(34257));t.tree=o;var i=s(r(44150));t.group=i;var a=s(r(16099));t.rule=a;var l=s(r(62611));function u(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(u=function(e){return e?r:t})(e)}function s(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==n(e)&&"function"!=typeof e)return{default:e};var r=u(t);if(r&&r.has(e))return r.get(e);var o={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(o,a,l):o[a]=e[a]}return o.default=e,r&&r.set(e,o),o}t.drag=l},16099:(e,t,r)=>{"use strict";var n=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.setValueSrc=t.setValue=t.setOperatorOption=t.setOperator=t.setField=void 0;var o=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==n(e)&&"function"!=typeof e)return{default:e};var r=a(t);if(r&&r.has(e))return r.get(e);var o={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var l in e)if("default"!==l&&Object.prototype.hasOwnProperty.call(e,l)){var u=i?Object.getOwnPropertyDescriptor(e,l):null;u&&(u.get||u.set)?Object.defineProperty(o,l,u):o[l]=e[l]}return o.default=e,r&&r.set(e,o),o}(r(55256)),i=r(98477);function a(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(a=function(e){return e?r:t})(e)}t.setField=function(e,t,r){return{type:o.SET_FIELD,path:(0,i.toImmutableList)(t),field:r,config:e}},t.setOperator=function(e,t,r){return{type:o.SET_OPERATOR,path:(0,i.toImmutableList)(t),operator:r,config:e}},t.setValue=function(e,t,r,n,a,l,u){return{type:o.SET_VALUE,path:(0,i.toImmutableList)(t),delta:r,value:n,valueType:a,asyncListValues:l,config:e,__isInternal:u}},t.setValueSrc=function(e,t,r,n){return{type:o.SET_VALUE_SRC,path:(0,i.toImmutableList)(t),delta:r,srcKey:n,config:e}},t.setOperatorOption=function(e,t,r,n){return{type:o.SET_OPERATOR_OPTION,path:(0,i.toImmutableList)(t),name:r,value:n,config:e}}},34257:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.setTree=t.removeRule=t.removeGroup=t.moveItem=t.addRule=t.addGroup=t.addDefaultCaseGroup=t.addCaseGroup=void 0;var i=n(r(58048)),a=r(98477),l=r(18313),u=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=s(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(55256));function s(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(s=function(e){return e?r:t})(e)}n(r(37512)),t.setTree=function(e,t){return{type:u.SET_TREE,tree:t,config:e}},t.addRule=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"rule",o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;return{type:u.ADD_RULE,ruleType:n,children:o,path:(0,a.toImmutableList)(t),id:(0,i.default)(),properties:(0,l.defaultRuleProperties)(e).merge(r||{}),config:e}},t.removeRule=function(e,t){return{type:u.REMOVE_RULE,path:(0,a.toImmutableList)(t),config:e}},t.addDefaultCaseGroup=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:u.ADD_CASE_GROUP,path:(0,a.toImmutableList)(t),children:n,id:(0,i.default)(),properties:(0,l.defaultGroupProperties)(e).merge(r||{}),config:e,meta:{isDefaultCase:!0}}},t.addCaseGroup=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:u.ADD_CASE_GROUP,path:(0,a.toImmutableList)(t),children:n,id:(0,i.default)(),properties:(0,l.defaultGroupProperties)(e).merge(r||{}),config:e}},t.addGroup=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:u.ADD_GROUP,path:(0,a.toImmutableList)(t),children:n,id:(0,i.default)(),properties:(0,l.defaultGroupProperties)(e).merge(r||{}),config:e}},t.removeGroup=function(e,t){return{type:u.REMOVE_GROUP,path:(0,a.toImmutableList)(t),config:e}},t.moveItem=function(e,t,r,n){return{type:u.MOVE_ITEM,fromPath:(0,a.toImmutableList)(t),toPath:(0,a.toImmutableList)(r),placement:n,config:e}}},86893:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i,a,l=n(r(39805)),u=n(r(40989)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=E(r(85959)),p=n(r(91504)),g=E(r(37512)),v=r(22173),h=n(r(85808)),m=r(53502),y=(n(r(58048)),r(92895));function b(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(b=function(e){return e?r:t})(e)}function E(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=b(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}var O=(0,h.default)((a=function(e){(0,s.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,d.default)(t);if(r){var o=(0,d.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,c.default)(this,e)});function o(e){var t;return(0,l.default)(this,o),(t=n.call(this,e))._updPath(e),t}return(0,u.default)(o,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=(0,y.pureShouldComponentUpdate)(this)(e,t);if(n){var o=[];for(var i in e)e[i]!==r[i]&&"__isInternalValueChange"!=i&&o.push(i);o.length||(n=!1),1==o.length&&"tree"==o[0]&&e.__isInternalValueChange&&(n=!1)}return n}},{key:"_updPath",value:function(e){var t=e.tree.get("id");this.path=g.default.List.of(t)}},{key:"render",value:function(){var e=this.props.tree,t=e.get("type"),r="switch_group"==t,n=r?null:(0,m.getTotalReordableNodesCountInTree)(e),o=r?null:(0,m.getTotalRulesCountInTree)(e),i=e.get("id");return f.default.createElement(v.Item,{key:i,id:i,path:this.path,type:t,properties:e.get("properties")||new g.Map,config:this.props.config,actions:this.props.actions,children1:e.get("children1")||new g.Map,reordableNodesCnt:n,totalRulesCnt:o,parentReordableNodesCnt:0,onDragStart:this.props.onDragStart})}}]),o}(f.Component),a.propTypes={tree:p.default.any.isRequired,config:p.default.object.isRequired,actions:p.default.object.isRequired,onDragStart:p.default.func},i=a))||i;t.default=O},39842:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(85707)),a=n(r(39805)),l=n(r(40989)),u=n(r(36417)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=E(r(85959)),p=r(30200),g=n(r(98275)),v=n(r(91504)),h=E(r(74417)),m=r(98477),y=r(92895);function b(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(b=function(e){return e?r:t})(e)}function E(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=b(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}function O(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function S(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?O(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):O(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var _=function(e){(0,s.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,d.default)(t);if(r){var o=(0,d.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,c.default)(this,e)});function o(e){var t;return(0,a.default)(this,o),(t=n.call(this,e)).shouldComponentUpdate=(0,y.liteShouldComponentUpdate)((0,u.default)(t),{tree:function(e){return e!==t.oldValidatedTree||t.oldValidatedTree!==t.validatedTree}}),(0,y.useOnPropsChanged)((0,u.default)(t)),t._updateActions(e),t.validatedTree=e.getMemoizedTree(e.config,e.tree),t.oldValidatedTree=t.validatedTree,t}return(0,l.default)(o,[{key:"_updateActions",value:function(e){var t=e.config,r=e.dispatch;this.actions=(0,y.bindActionCreators)(S(S(S({},h.tree),h.group),h.rule),t,r)}},{key:"onPropsChanged",value:function(e){var t=e.onChange,r=this.props.config,n=e.tree,o=(this.props.tree,e.config);this.oldValidatedTree=this.validatedTree,this.validatedTree=n,r!==o&&(this._updateActions(e),this.validatedTree=e.getMemoizedTree(o,n,r)),!(0,m.immutableEqual)(this.validatedTree,this.oldValidatedTree)&&t&&t(this.validatedTree,o,e.__lastAction)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.renderBuilder,n=e.dispatch,o=e.__isInternalValueChange;return r({tree:this.validatedTree,actions:this.actions,config:t,dispatch:n,__isInternalValueChange:o})}}]),o}(f.Component);_.propTypes={config:v.default.object.isRequired,onChange:v.default.func,renderBuilder:v.default.func,tree:v.default.any};var w=(0,p.connect)((function(e){return{tree:e.tree,__isInternalValueChange:e.__isInternalValueChange,__lastAction:e.__lastAction}}),null,null,{context:g.default})(_);w.displayName="ConnectedQuery";var T=w;t.default=T},52835:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(36417)),u=n(r(87861)),s=n(r(15118)),c=n(r(29402)),d=T(r(85959)),f=n(r(91504)),p=n(r(53438)),g=n(r(98275)),v=r(7694),h=r(30200),m=T(r(74417)),y=r(40112),b=r(98477),E=r(18313),O=r(40056),S=r(92895),_=n(r(39842));function w(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(w=function(e){return e?r:t})(e)}function T(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=w(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}var P=function(e){(0,u.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,c.default)(t);if(r){var o=(0,c.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,s.default)(this,e)});function o(e,t){var r;(0,i.default)(this,o),(r=n.call(this,e,t)).shouldComponentUpdate=(0,S.liteShouldComponentUpdate)((0,l.default)(r),{value:function(e,t,r){return!1}}),(0,S.useOnPropsChanged)((0,l.default)(r)),r.getMemoizedConfig=(0,y.createConfigMemo)(),r.getMemoizedTree=(0,O.createValidationMemo)();var a=r.getMemoizedConfig(e),u=e.value,s=r.getMemoizedTree(a,u),c=(0,p.default)(a,s,r.getMemoizedTree),d=(0,v.createStore)(c);return r.state={store:d,config:a},r}return(0,a.default)(o,[{key:"onPropsChanged",value:function(e){var t=this,r=this.state.config,n=this.getMemoizedConfig(e),o=r!==n,i=this.state.store.getState().tree,a=!(0,b.immutableEqual)(e.value,this.props.value)&&!(0,b.immutableEqual)(e.value,i),l=a?e.value||(0,E.defaultRoot)(e):i;if(o&&this.setState({config:n}),a||o){var u=this.getMemoizedTree(n,l,r);return Promise.resolve().then((function(){t.state.store.dispatch(m.tree.setTree(n,u))}))}}},{key:"render",value:function(){var e=this.props,t=e.renderBuilder,r=e.get_children,n=e.onChange,o=e.settings,i=this.state,a=i.config,l=i.store,u=o.renderProvider;return d.default.createElement(u,{config:a},d.default.createElement(h.Provider,{store:l,context:g.default},d.default.createElement(_.default,{config:a,getMemoizedTree:this.getMemoizedTree,onChange:n,renderBuilder:t||r})))}}]),o}(d.Component);t.default=P,P.propTypes={conjunctions:f.default.object.isRequired,fields:f.default.object.isRequired,types:f.default.object.isRequired,operators:f.default.object.isRequired,widgets:f.default.object.isRequired,settings:f.default.object.isRequired,onChange:f.default.func,renderBuilder:f.default.func,value:f.default.any}},76736:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(78304)),a=n(r(40453)),l=n(r(39805)),u=n(r(40989)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=h(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),p=n(r(91504)),g=r(85808),v=["isDraggingTempo","isDraggingMe","dragging"];function h(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(h=function(e){return e?r:t})(e)}var m=r(71633);t.default=function(e){return function(t){var r;return(r=function(r){(0,s.default)(h,r);var n,o,p=(n=h,o=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,t=(0,d.default)(n);if(o){var r=(0,d.default)(this).constructor;e=Reflect.construct(t,arguments,r)}else e=t.apply(this,arguments);return(0,c.default)(this,e)});function h(e){var t;return(0,l.default)(this,h),(t=p.call(this,e)).handleDraggerMouseDown=function(e){var r=t.props.id,n=t.wrapper.current;t.props.onDragStart&&t.props.onDragStart(r,n,e)},t.wrapper=f.default.createRef(),t}return(0,u.default)(h,[{key:"render",value:function(){var r=this.props,n=r.isDraggingTempo,o=r.isDraggingMe,l=r.dragging,u=(0,a.default)(r,v),s=u.isTrueLocked,c={};o&&n&&(g._isReorderingTree||(c={top:l.y,left:l.x,width:l.w}));var d=m(e,"group-or-rule",o&&n?"qb-draggable":null,o&&!n?"qb-placeholder":null,s?"locked":null);return f.default.createElement("div",{className:d,style:c,ref:this.wrapper,"data-id":this.props.id},f.default.createElement(t,(0,i.default)({handleDraggerMouseDown:this.handleDraggerMouseDown,isDraggingMe:o,isDraggingTempo:n},u)))}}]),h}(f.PureComponent)).propTypes={isDraggingTempo:p.default.bool,isDraggingMe:p.default.bool,onDragStart:p.default.func,dragging:p.default.object,isLocked:p.default.bool,isTrueLocked:p.default.bool},r}}},44281:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(36417)),u=n(r(87861)),s=n(r(15118)),c=n(r(29402)),d=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=y(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),f=n(r(91504)),p=n(r(9680)),g=n(r(98275)),v=r(92895),h=r(30200),m=r(18313);function y(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(y=function(e){return e?r:t})(e)}t.default=function(e){var t=(0,h.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:g.default})(function(e){var t;return t=function(t){(0,u.default)(f,t);var r,n,o=(r=f,n=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,t=(0,c.default)(r);if(n){var o=(0,c.default)(this).constructor;e=Reflect.construct(t,arguments,o)}else e=t.apply(this,arguments);return(0,s.default)(this,e)});function f(e){var t;return(0,i.default)(this,f),(t=o.call(this,e))._selectedConjunction=function(e){return(e=e||t.props).conjunction||(0,m.defaultGroupConjunction)(e.config,e.field)},t.setConjunction=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setConjunction(t.props.path,e)},t.setNot=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setNot(t.props.path,e)},t.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setLock(t.props.path,e)},t.dummyFn=function(){},t.removeSelf=function(){t.props.actions.removeGroup(t.props.path)},t.addGroup=function(){t.props.actions.addGroup(t.props.path)},t.addCaseGroup=function(){t.props.actions.addCaseGroup(t.props.path)},t.addDefaultCaseGroup=function(){t.props.actions.addDefaultCaseGroup(t.props.path)},t.addRule=function(){t.props.actions.addRule(t.props.path)},t.setField=function(e){t.props.actions.setField(t.props.path,e)},t.setOperator=function(e){t.props.actions.setOperator(t.props.path,e)},t.setValue=function(e,r,n){t.props.actions.setValue(t.props.path,e,r,n)},(0,v.useOnPropsChanged)((0,l.default)(t)),t.selectedConjunction=t._selectedConjunction(e),t.conjunctionOptions=t._getConjunctionOptions(e),t.dummyFn.isDummyFn=!0,t}return(0,a.default)(f,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=(0,v.pureShouldComponentUpdate)(this)(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var l in e){var u=e[l]!=r[l];"dragging"!=l||i||(u=!1),u&&a.push(l)}a.length||(o=!1)}return o}},{key:"onPropsChanged",value:function(e){var t=e.config,r=(e.id,e.conjunction),n=this.props.config,o=this.props.conjunction;n==t&&o==r||(this.selectedConjunction=this._selectedConjunction(e),this.conjunctionOptions=this._getConjunctionOptions(e))}},{key:"_getConjunctionOptions",value:function(e){var t=this;return(0,p.default)(e.config.conjunctions,(function(r,n){return{id:"conjunction-".concat(e.id,"-").concat(n),name:"conjunction[".concat(e.id,"]"),key:n,label:r.label,checked:n===t._selectedConjunction(e)}}))}},{key:"render",value:function(){var t=this.props.dragging.id==this.props.id,r=this.props.path.size,n=this.props.config.settings.maxNesting,o=!t&&this.props.isDraggingTempo,i=void 0===n||r<n,a=1==r;return d.default.createElement("div",{className:"group-or-rule-container group-container","data-id":this.props.id},[t?d.default.createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,isRoot:a,allowFurtherNesting:i,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:this.dummyFn,setNot:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,addGroup:this.dummyFn,addCaseGroup:this.dummyFn,addDefaultCaseGroup:this.dummyFn,addRule:this.dummyFn,setField:this.dummyFn,setOperator:this.dummyFn,setValue:this.dummyFn,value:this.props.value||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,d.default.createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:t,isDraggingTempo:o,onDragStart:this.props.onDragStart,isRoot:a,allowFurtherNesting:i,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:o?this.dummyFn:this.setConjunction,setNot:o?this.dummyFn:this.setNot,setLock:o?this.dummyFn:this.setLock,removeSelf:o?this.dummyFn:this.removeSelf,addGroup:o?this.dummyFn:this.addGroup,addCaseGroup:o?this.dummyFn:this.addCaseGroup,addDefaultCaseGroup:o?this.dummyFn:this.addDefaultCaseGroup,addRule:o?this.dummyFn:this.addRule,setField:o?this.dummyFn:this.setField,setOperator:o?this.dummyFn:this.setOperator,setValue:o?this.dummyFn:this.setValue,value:this.props.value||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}]),f}(d.Component),t.propTypes={config:f.default.object.isRequired,actions:f.default.object.isRequired,path:f.default.any.isRequired,id:f.default.string.isRequired,groupId:f.default.string,not:f.default.bool,conjunction:f.default.string,children1:f.default.any,onDragStart:f.default.func,reordableNodesCnt:f.default.number,field:f.default.string,parentField:f.default.string,isLocked:f.default.bool,isTrueLocked:f.default.bool,dragging:f.default.object,isDraggingTempo:f.default.bool},t}(e));return t.displayName="ConnectedGroupContainer",t}},72294:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=h(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),d=n(r(91504)),f=n(r(98275)),p=r(40112),g=r(92895),v=r(30200);function h(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(h=function(e){return e?r:t})(e)}var m=r(71633);t.default=function(e){var t=(0,v.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:f.default})(function(e){var t;return t=function(t){(0,l.default)(d,t);var r,n,o=(r=d,n=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,t=(0,s.default)(r);if(n){var o=(0,s.default)(this).constructor;e=Reflect.construct(t,arguments,o)}else e=t.apply(this,arguments);return(0,u.default)(this,e)});function d(e){var t;return(0,i.default)(this,d),(t=o.call(this,e)).dummyFn=function(){},t.removeSelf=function(){t.props.actions.removeRule(t.props.path)},t.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setLock(t.props.path,e)},t.setField=function(e){t.props.actions.setField(t.props.path,e)},t.setOperator=function(e){t.props.actions.setOperator(t.props.path,e)},t.setOperatorOption=function(e,r){t.props.actions.setOperatorOption(t.props.path,e,r)},t.setValue=function(e,r,n,o,i){t.props.actions.setValue(t.props.path,e,r,n,o,i)},t.setValueSrc=function(e,r){t.props.actions.setValueSrc(t.props.path,e,r)},t.dummyFn.isDummyFn=!0,t}return(0,a.default)(d,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=(0,g.pureShouldComponentUpdate)(this)(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var l in e){var u=e[l]!=r[l];"dragging"!=l||i||(u=!1),u&&a.push(l)}a.length||(o=!1)}return o}},{key:"render",value:function(){var t=this.props.dragging.id==this.props.id,r=(0,p.getFieldConfig)(this.props.config,this.props.field),n=this.props.config.settings.showErrorMessage,o=(r&&r.type,!t&&this.props.isDraggingTempo),i=this.props.valueError,a=null!=(i&&i.toArray().filter((function(e){return!!e})).shift()||null)&&n;return c.default.createElement("div",{className:m("group-or-rule-container","rule-container",a?"rule-with-error":null),"data-id":this.props.id},[t?c.default.createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,setField:this.dummyFn,setOperator:this.dummyFn,setOperatorOption:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,selectedField:this.props.field||null,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueError:this.props.valueError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,c.default.createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:t,isDraggingTempo:o,onDragStart:this.props.onDragStart,setLock:o?this.dummyFn:this.setLock,removeSelf:o?this.dummyFn:this.removeSelf,setField:o?this.dummyFn:this.setField,setOperator:o?this.dummyFn:this.setOperator,setOperatorOption:o?this.dummyFn:this.setOperatorOption,setValue:o?this.dummyFn:this.setValue,setValueSrc:o?this.dummyFn:this.setValueSrc,selectedField:this.props.field||null,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueError:this.props.valueError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}]),d}(c.Component),t.propTypes={id:d.default.string.isRequired,groupId:d.default.string,config:d.default.object.isRequired,path:d.default.any.isRequired,operator:d.default.string,field:d.default.string,actions:d.default.object.isRequired,onDragStart:d.default.func,value:d.default.any,valueSrc:d.default.any,asyncListValues:d.default.array,valueError:d.default.any,operatorOptions:d.default.object,reordableNodesCnt:d.default.number,parentField:d.default.string,isLocked:d.default.bool,isTrueLocked:d.default.bool,dragging:d.default.object,isDraggingTempo:d.default.bool},t}(e));return t.displayName="ConnectedRuleContainer",t}},85808:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=t._isReorderingTree=void 0;var i=n(r(78304)),a=n(r(10906)),l=n(r(39805)),u=n(r(40989)),s=n(r(36417)),c=n(r(87861)),d=n(r(15118)),f=n(r(29402)),p=w(r(85959)),g=r(30200),v=r(53502),h=r(98477),m=n(r(98275)),y=w(r(55256)),b=n(r(19999)),E=n(r(91504)),O=w(r(74417)),S=r(92895);function _(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(_=function(e){return e?r:t})(e)}function w(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=_(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}var T=!1;t._isReorderingTree=T,t.default=function(e){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,n=(0,g.connect)((function(e){return{dragging:e.dragging,dragStart:e.dragStart,mousePos:e.mousePos}}),{setDragStart:O.drag.setDragStart,setDragProgress:O.drag.setDragProgress,setDragEnd:O.drag.setDragEnd},null,{context:m.default})(function(e){var r,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return r=function(r){(0,c.default)(E,r);var o,g,m=(o=E,g=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,t=(0,f.default)(o);if(g){var r=(0,f.default)(this).constructor;e=Reflect.construct(t,arguments,r)}else e=t.apply(this,arguments);return(0,d.default)(this,e)});function E(e){var t;return(0,l.default)(this,E),(t=m.call(this,e))._getEventTarget=function(e,t){return e&&e.__mocked_window||document.body||window},t.onDragStart=function(e,r,n){var o=r.closest(".query-builder");void 0===t._isUsingLegacyReactDomRender&&(t._isUsingLegacyReactDomRender=(0,S.isUsingLegacyReactDomRender)(o)),document.body.classList.add("qb-dragging"),o.classList.add("qb-dragging");var i,a=o.closest(".query-builder-container")||o,l=(a=t._getScrollParent(a)||document.body).scrollTop,u=(t._getDraggableNodeEl(o),t._getPlaceholderNodeEl(o),o.querySelectorAll(".group--children")),s=u.length?u[0]:null;s&&(i=window.getComputedStyle(s,null).getPropertyValue("padding-left"),i=parseInt(i));var c={id:e,x:r.offsetLeft,y:r.offsetTop,w:r.offsetWidth,h:r.offsetHeight,itemInfo:t.tree.items[e],paddingLeft:i},d={id:e,x:r.offsetLeft,y:r.offsetTop,scrollTop:l,clientX:n.clientX,clientY:n.clientY,itemInfo:(0,b.default)(t.tree.items[e]),treeEl:o,treeElContainer:a},f={clientX:n.clientX,clientY:n.clientY},p=t._getEventTarget(n,d);t.eventTarget=p,p.addEventListener("mousemove",t.onDrag),p.addEventListener("mouseup",t.onDragEnd),t.props.setDragStart(d,c,f)},t.onDrag=function(e){var r=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=Object.assign({},t.props.dragging),i=t.props.dragStart,a=o.paddingLeft,l=i.treeElContainer.scrollTop;if(o.itemInfo=t.tree.items[o.id],o.itemInfo){var u={clientX:e.clientX,clientY:e.clientY},s={clientX:i.clientX,clientY:i.clientY};if(e.__mock_dom){var c=i.treeEl,d=t._getDraggableNodeEl(c),f=t._getPlaceholderNodeEl(c);e.__mock_dom({treeEl:c,dragEl:d,plhEl:f})}if(!i.plX){var p=i.treeEl,g=t._getPlaceholderNodeEl(p);g&&(i.plX=g.getBoundingClientRect().left+window.scrollX,i.plY=g.getBoundingClientRect().top+window.scrollY)}var v=i.x,h=i.y,m=i.clientX,y=i.clientY,b=i.scrollTop,E={x:v+(e.clientX-m),y:h+(e.clientY-y)+(l-b)};o.x=E.x,o.y=E.y,o.paddingLeft=a,o.mousePos=u,o.startMousePos=s,t.props.setDragProgress(u,o),r&&t.handleDrag(o,e,n)||e.preventDefault&&e.preventDefault()}},t.onDragEnd=function(){var e=t.props.dragStart.treeEl;t.props.setDragEnd(),e.classList.remove("qb-dragging"),document.body.classList.remove("qb-dragging"),t._cacheEls={};var r=t.eventTarget||t._getEventTarget();r.removeEventListener("mousemove",t.onDrag),r.removeEventListener("mouseup",t.onDragEnd)},(0,S.useOnPropsChanged)((0,s.default)(t)),t.onPropsChanged(e),t}return(0,u.default)(E,[{key:"onPropsChanged",value:function(e){this.tree=(0,v.getFlatTree)(e.tree)}},{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=(0,S.pureShouldComponentUpdate)(this)(e,t);if(o&&n==t&&r!=e){var i=[];for(var a in e)e[a]!=r[a]&&"dragging"!=a&&"mousePos"!=a&&i.push(a);i.length||(o=!1)}return o}},{key:"componentDidUpdate",value:function(e,r){var n=this.props.dragging,o=this.props.dragStart;if(t._isReorderingTree=T=!1,o&&o.id&&(n.itemInfo=this.tree.items[n.id],n.itemInfo&&(n.itemInfo.index!=o.itemInfo.index||n.itemInfo.parent!=o.itemInfo.parent))){var i=o.treeEl,a=o.treeElContainer,l=this._getPlaceholderNodeEl(i,!0);if(l){var u=l.getBoundingClientRect().left+window.scrollX,s=l.getBoundingClientRect().top+window.scrollY,c=o.plX,d=o.plY,f=a.scrollTop;o.plX=u,o.plY=s,o.itemInfo=(0,b.default)(n.itemInfo),o.y=l.offsetTop,o.x=l.offsetLeft,o.clientY+=s-d,o.clientX+=u-c,a!=document.body&&(o.scrollTop=f),this.onDrag(this.props.mousePos,!1)}}}},{key:"_getNodeElById",value:function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==t)return null;this._cacheEls||(this._cacheEls={});var n=this._cacheEls[t];return n&&document.contains(n)&&!r||(n=e.querySelector('.group-or-rule-container[data-id="'+t+'"]'),this._cacheEls[t]=n),n}},{key:"_getDraggableNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.draggable;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-draggable");return r=n.length?n[0]:null,this._cacheEls.draggable=r,r}},{key:"_getPlaceholderNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.placeholder;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-placeholder");return r=n.length?n[0]:null,this._cacheEls.placeholder=r,r}},{key:"_isScrollable",value:function(e){var t=window.getComputedStyle(e)["overflow-y"];return("scroll"===t||"auto"===t)&&e.scrollHeight>e.offsetHeight}},{key:"_getScrollParent",value:function(e){return null==e?null:e===document.body||this._isScrollable(e)?e:this._getScrollParent(e.parentNode)}},{key:"handleDrag",value:function(e,t,r){var n,o,i,l,u=this,s=e.itemInfo,c=e.paddingLeft,d=null,f=this.props.dragStart.treeEl,p=e.id,g=this._getDraggableNodeEl(f),v=this._getPlaceholderNodeEl(f);if(g&&v){if(n=g.getBoundingClientRect(),!(o=v.getBoundingClientRect()).width)return;var m={hrz:0,vrt:0};n.top<o.top?m.vrt=-1:n.bottom>o.bottom&&(m.vrt=1),n.left>o.left?m.hrz=1:n.left<o.left&&(m.hrz=-1);var b,E={x:(l=f.getBoundingClientRect()).left+(l.right-l.left)/2,y:m.vrt>=0?n.bottom:n.top};if(t.__mocked_hov_container)b=t.__mocked_hov_container;else{var O=document.elementFromPoint(E.x,E.y-1);if(!(b=O?O.closest(".group-or-rule-container"):null)&&O&&O.classList.contains("query-builder-container")){var S,_=null==O||null===(S=O.firstChild)||void 0===S?void 0:S.firstChild;_&&_.classList.contains("group-or-rule-container")&&(b=_)}}if(b){var w=b.classList.contains("group-container"),T=b.getAttribute("data-id"),P=b,C=!1,I=!1;if(P){var A=(i=P.getBoundingClientRect()).bottom-i.top,R=this.tree.items[T],x=null,N=null,D=null,L=null;if(0==m.vrt)D=s,(N=v)&&(x=N.getBoundingClientRect());else if(w){if(m.vrt>0){var j=b.getElementsByClassName("group--header"),M=j.length?j[0]:null;if(M){var k=M.getBoundingClientRect(),F=k.bottom-k.top;n.bottom-k.top>3*F/4&&R.top>e.itemInfo.top&&(D=R,x=k,N=M,I=!0)}}else m.vrt<0&&R.lev>=s.lev&&i.bottom-n.top>=2&&R.top<e.itemInfo.top&&(D=R,x=i,N=P,C=!0);(m.vrt<0?i.bottom-n.top>A-5:n.bottom-i.top>A-5)&&(I||C||(D=R,x=i,N=P),L=R)}else(m.vrt<0?i.bottom-n.top>A/2:n.bottom-i.top>A/2)&&(D=R,x=i,N=P);var q=D&&D.id==p;if(x){var V=n.left-l.left,B=(x.left,l.left,Math.max(0,Math.round(V/c))),U=[],W=[];if(q);else{if(w&&(C?U.push([y.PLACEMENT_APPEND,D,D.lev+1]):I&&U.push([y.PLACEMENT_PREPEND,D,D.lev+1]),L)){var G=0==L.lev,H="case_group"==L.type&&"case_group"!=s.type,K=L.prev&&this.tree.items[L.prev].caseId,$=L.next&&this.tree.items[L.next].caseId;s.caseId==K&&(K=null),s.caseId==$&&($=null);var z=K&&this.tree.items[K],Y=$&&this.tree.items[$];m.vrt>0?G?W.push([y.PLACEMENT_APPEND,L,L.lev+1]):H&&Y?W.push([y.PLACEMENT_PREPEND,Y,Y.lev+1]):W.push([y.PLACEMENT_AFTER,L,L.lev]):m.vrt<0&&(G?W.push([y.PLACEMENT_PREPEND,L,L.lev+1]):H&&z?W.push([y.PLACEMENT_APPEND,z,z.lev+1]):W.push([y.PLACEMENT_BEFORE,L,L.lev]))}C||I||(m.vrt<0?U.push([y.PLACEMENT_BEFORE,D,D.lev]):m.vrt>0&&U.push([y.PLACEMENT_AFTER,D,D.lev]))}var Q=function(e){var t=e[1],r=s.caseId?u.tree.items[s.caseId]:null,n=t.caseId?u.tree.items[t.caseId]:null;return[].concat((0,a.default)(e),[r,n])};U=U.map(Q),W=W.map(Q);var X=null,J=(U=U.filter((function(e){var t=e[0],r=e[1];if((t==y.PLACEMENT_BEFORE||t==y.PLACEMENT_AFTER)&&null==r.parent)return!1;if(r.collapsed&&(t==y.PLACEMENT_APPEND||t==y.PLACEMENT_PREPEND))return!1;var n=r.id==s.id;if(!n)for(var o=r;o.parent;)if((o=u.tree.items[o.parent]).id==s.id){n=!0;break}return!n})).map((function(e){var t=e[0],r=e[1],n=(e[2],e[3],e[4],null);return(n=t==y.PLACEMENT_APPEND||t==y.PLACEMENT_PREPEND?r:u.tree.items[r.parent])&&null==n.parent&&(n=null),e[5]=n,e}))).filter((function(e){return u.canMove(s,e[1],e[0],e[3],e[4],e[5],r)}));0==J.length&&W.length>0&&(J=W.filter((function(e){return u.canMove(s,e[1],e[0],e[3],e[4],e[5],r)})));var Z=J.map((function(e){return e[2]})),ee=s.lev,te=Z.concat(ee),re=null;-1!=te.indexOf(B)?re=B:B>Math.max.apply(Math,(0,a.default)(te))?re=Math.max.apply(Math,(0,a.default)(te)):B<Math.min.apply(Math,(0,a.default)(te))&&(re=Math.min.apply(Math,(0,a.default)(te))),X=J.find((function(e){return e[2]==re})),q||X||!J.length||(X=J[0]),d=X}}}else h.logger.log("out of tree bounds!")}return!!d&&(this.move(s,d[1],d[0],d[3]),!0)}},{key:"canMove",value:function(e,t,r,n,o,i,a){if(!e||!t)return!1;if(e.id===t.id)return!1;var l=this.props.config.settings,u=l.canRegroup,s=l.canRegroupCases,c=l.maxNesting,d=l.maxNumberOfRules,f=l.canLeaveEmptyCase,p=i?i.lev+1:t.lev,g=r==y.PLACEMENT_BEFORE||r==y.PLACEMENT_AFTER,v=r==y.PLACEMENT_PREPEND||r==y.PLACEMENT_APPEND,h=g&&1==t.lev||v&&0==t.lev,m=e.parent!=t.parent,b=v||m,E="case_group"==e.type&&!h||"rule_group"==e.parentType||"rule_group"==t.type||"rule_group"==t.parentType||"case_group"!=e.type&&"case_group"==t.type&&g||"case_group"!=e.type&&"switch_group"==t.type||!s&&e.caseId!=t.caseId,O=t.isLocked||e.isLocked||i&&i.isLocked;if(c&&p>c)return!1;if(b&&(!u||E||O))return!1;if("case_group"!=e.type&&e.caseId!=t.caseId){var S=!!n&&2==n._height,_=o?o.leafsCount+1:0;if(d&&_>d)return!1;if(S&&!f)return!1}if("case_group"==e.type&&(e.isDefaultCase||t.isDefaultCase||"switch_group"==t.type&&r==y.PLACEMENT_APPEND))return!1;var w=!0;return a&&(w=a(e.node.toJS(),t.node.toJS(),r,i?i.node.toJS():null)),w}},{key:"move",value:function(e,r,n,o){this._isUsingLegacyReactDomRender||(t._isReorderingTree=T=!0),this.props.actions.moveItem(e.path,r.path,n)}},{key:"render",value:function(){return p.default.createElement(e,(0,i.default)({},this.props,{onDragStart:this.onDragStart}))}}]),E}(p.Component),r.propTypes={tree:E.default.any.isRequired,actions:E.default.object.isRequired},r}(e,r));return n.displayName="ConnectedSortableContainer",n}},58403:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o,i,a,l=n(r(85707)),u=n(r(39805)),s=n(r(40989)),c=n(r(36417)),d=n(r(41621)),f=n(r(87861)),p=n(r(15118)),g=n(r(29402)),v=n(r(85959)),h=n(r(91504)),m=n(r(44281)),y=n(r(76736)),b=r(17919),E=r(6176),O=r(92895),S=r(35939),_=n(r(54381));function w(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function T(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?w(Object(r),!0).forEach((function(t){(0,l.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):w(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var P=r(71633),C=(o=(0,y.default)("group case_group"),(0,m.default)(i=o(i=(0,S.ConfirmFn)(((a=function(e){(0,f.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,g.default)(t);if(r){var o=(0,g.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,p.default)(this,e)});function o(e){var t;return(0,u.default)(this,o),(t=n.call(this,e)).childrenClassName=function(){return"case_group--children"},t.renderFooterWrapper=function(){return null},(0,O.useOnPropsChanged)((0,c.default)(t)),t.onPropsChanged(e),t}return(0,s.default)(o,[{key:"onPropsChanged",value:function(e){}},{key:"isDefaultCase",value:function(){return null==this.props.children1}},{key:"reordableNodesCnt",value:function(){return this.props.parentReordableNodesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"showDragIcon",value:function(){return!this.isDefaultCase()&&(0,d.default)((0,g.default)(o.prototype),"showDragIcon",this).call(this)}},{key:"renderHeaderWrapper",value:function(){return v.default.createElement("div",{key:"group-header",className:P("group--header",this.isOneChild()?"one--child":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeaderLeft(),this.renderHeaderCenter(),this.renderActions())}},{key:"renderChildrenWrapper",value:function(){return this.isDefaultCase()?null:v.default.createElement("div",{className:"case_group--body"},this.renderCondition(),this.renderValue())}},{key:"renderHeaderLeft",value:function(){return this.isDefaultCase()?this.props.config.settings.defaultCaseLabel||"":v.default.createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderCondition",value:function(){return this.isDefaultCase()?null:(0,d.default)((0,g.default)(o.prototype),"renderChildrenWrapper",this).call(this)}},{key:"renderHeaderCenter",value:function(){return this.isDefaultCase()?this.renderValue():null}},{key:"canAddGroup",value:function(){return!this.isDefaultCase()&&(0,d.default)((0,g.default)(o.prototype),"canAddGroup",this).call(this)}},{key:"canAddRule",value:function(){return!this.isDefaultCase()&&(0,d.default)((0,g.default)(o.prototype),"canAddRule",this).call(this)}},{key:"renderValue",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.value,o=e.setValue,i=e.id,a=t.settings.immutableValuesMode,l=v.default.createElement(_.default,{key:"values",isCaseValue:!0,field:"!case_value",operator:null,value:n,valueSrc:"value",valueError:null,config:t,setValue:a?S.dummyFn:o,setValueSrc:S.dummyFn,readonly:a||r,id:i,groupId:null});return v.default.createElement(S.Col,{className:"case_group--value"},l)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addGroup,n=e.addRule,o=e.isLocked,i=e.isTrueLocked,a=e.id;return v.default.createElement(E.GroupActions,{config:t,addGroup:r,addRule:n,canAddRule:this.canAddRule(),canAddGroup:this.canAddGroup(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props.value,t=e&&e.size?e.get(0):null,r=null!=t&&(!Array.isArray(t)||t.length>0);return(0,d.default)((0,g.default)(o.prototype),"isEmptyCurrentGroup",this).call(this)&&!r}}]),o}(b.BasicGroup)).propTypes=T(T({},b.BasicGroup.propTypes),{},{parentReordableNodesCnt:h.default.number,value:h.default.any,setValue:h.default.func}),i=a))||i)||i)||i);t.default=C},17919:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=t.BasicGroup=void 0;var i=n(r(78304)),a=n(r(85707)),l=n(r(39805)),u=n(r(40989)),s=n(r(36417)),c=n(r(87861)),d=n(r(15118)),f=n(r(29402)),p=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=O(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),g=n(r(91504)),v=n(r(83391)),h=n(r(44281)),m=n(r(76736)),y=r(22173),b=r(6176),E=r(35939);function O(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(O=function(e){return e?r:t})(e)}function S(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function _(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?S(Object(r),!0).forEach((function(t){(0,a.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):S(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var w=r(71633),T=function(e){(0,c.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,f.default)(t);if(r){var o=(0,f.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,d.default)(this,e)});function o(e){var t;return(0,l.default)(this,o),(t=n.call(this,e)).childrenClassName=function(){return""},t.renderBeforeActions=function(){var e=t.props.config.settings.renderBeforeActions;return null==e?null:"function"==typeof e?p.default.createElement(e,t.props):e},t.renderAfterActions=function(){var e=t.props.config.settings.renderAfterActions;return null==e?null:"function"==typeof e?p.default.createElement(e,t.props):e},t.removeSelf=t.removeSelf.bind((0,s.default)(t)),t.setLock=t.setLock.bind((0,s.default)(t)),t.renderItem=t.renderItem.bind((0,s.default)(t)),t}return(0,u.default)(o,[{key:"isGroupTopPosition",value:function(){return(0,v.default)(this.props.config.settings.groupActionsPosition||"topRight","top")}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this,t=this.props.confirmFn,r=this.props.config.settings,n=r.renderConfirm,o=r.removeGroupConfirmOptions,i=function(){e.props.removeSelf()};o&&!this.isEmptyCurrentGroup()?n(_(_({},o),{},{onOk:i,onCancel:null,confirmFn:t})):i()}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props.children1;return!e||0==e.size||1==e.size&&this.isEmpty(e.first())}},{key:"isEmpty",value:function(e){return"group"==e.get("type")||"rule_group"==e.get("type")?this.isEmptyGroup(e):this.isEmptyRule(e)}},{key:"isEmptyGroup",value:function(e){var t=e.get("children1");return!t||0==t.size||1==t.size&&this.isEmpty(t.first())}},{key:"isEmptyRule",value:function(e){var t=e.get("properties");return!(null!==t.get("field")&&null!==t.get("operator")&&t.get("value").filter((function(e){return void 0!==e})).size>0)}},{key:"render",value:function(){return p.default.createElement(p.default.Fragment,null,this.renderHeaderWrapper(),this.renderChildrenWrapper(),this.renderFooterWrapper())}},{key:"showNot",value:function(){return this.props.config.settings.showNot}},{key:"showConjs",value:function(){var e=this.props,t=e.conjunctionOptions;return e.children1,e.config,Object.keys(t).length>1||this.showNot()}},{key:"isOneChild",value:function(){var e=this.props.children1;return!e||e.size<2}},{key:"renderChildrenWrapper",value:function(){return this.props.children1&&p.default.createElement("div",{key:"group-children",className:w("group--children",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isOneChild()?"one--child":"",this.childrenClassName())},this.renderChildren())}},{key:"renderHeaderWrapper",value:function(){var e=this.isGroupTopPosition();return p.default.createElement("div",{key:"group-header",className:w("group--header",this.isOneChild()?"one--child":"")},this.renderHeader(),e&&this.renderBeforeActions(),e&&this.renderActions(),e&&this.renderAfterActions())}},{key:"renderFooterWrapper",value:function(){return!this.isGroupTopPosition()&&p.default.createElement("div",{key:"group-footer",className:"group--footer"},this.renderBeforeActions(),this.renderActions(),this.renderAfterActions())}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return p.default.createElement(b.GroupActions,{config:t,addRule:r,addGroup:n,canAddGroup:this.canAddGroup(),canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"canAddGroup",value:function(){return this.props.allowFurtherNesting}},{key:"canAddRule",value:function(){var e=this.props.config.settings.maxNumberOfRules,t=this.props.totalRulesCnt;return!e||t<e}},{key:"canDeleteGroup",value:function(){return!this.props.isRoot}},{key:"renderChildren",value:function(){var e=this.props.children1;return e?e.map(this.renderItem).toList():null}},{key:"renderItem",value:function(e){var t=this.props,r=t.config,n=t.actions,o=t.onDragStart,a=t.isLocked,l="group"==e.get("type")&&null!=e.getIn(["properties","field"])?"rule_group":e.get("type");return p.default.createElement(y.Item,(0,i.default)({},this.extraPropsForItem(e),{key:e.get("id"),id:e.get("id"),groupId:t.id,path:e.get("path"),type:l,properties:e.get("properties"),config:r,actions:n,children1:e.get("children1"),reordableNodesCnt:this.reordableNodesCntForItem(e),totalRulesCnt:this.totalRulesCntForItem(e),parentReordableNodesCnt:this.reordableNodesCnt(),onDragStart:o,isDraggingTempo:this.props.isDraggingTempo,isParentLocked:a}))}},{key:"extraPropsForItem",value:function(e){return{}}},{key:"reordableNodesCnt",value:function(){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.reordableNodesCnt()}},{key:"showDragIcon",value:function(){var e=this.props,t=e.config,r=e.isRoot,n=e.isLocked,o=this.reordableNodesCnt();return t.settings.canReorder&&!r&&o>1&&!n}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown;return this.showDragIcon()&&p.default.createElement("span",{key:"group-drag-icon",className:"qb-drag-handler group--drag-handler",onMouseDown:e},p.default.createElement(E.DragIcon,null)," ")}},{key:"conjunctionOptions",value:function(){return this.props.conjunctionOptions}},{key:"renderConjs",value:function(){var e=this.props,t=e.config,r=e.children1,n=e.id,o=e.selectedConjunction,i=e.setConjunction,a=e.not,l=e.setNot,u=e.isLocked,s=t.settings,c=s.immutableGroupsMode,d=s.renderConjs,f=(s.showNot,s.notLabel),g=this.conjunctionOptions();if(!this.showConjs())return null;if(!r||!r.size)return null;var v={disabled:this.isOneChild(),readonly:c||u,selectedConjunction:o,setConjunction:c?E.dummyFn:i,conjunctionOptions:g,config:t,not:a||!1,id:n,setNot:c?E.dummyFn:l,notLabel:f,showNot:this.showNot(),isLocked:u};return p.default.createElement(d,v)}},{key:"renderHeader",value:function(){return p.default.createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}}]),o}(p.PureComponent);t.BasicGroup=T,T.propTypes={reordableNodesCnt:g.default.number,conjunctionOptions:g.default.object.isRequired,allowFurtherNesting:g.default.bool.isRequired,isRoot:g.default.bool.isRequired,not:g.default.bool,selectedConjunction:g.default.string,config:g.default.object.isRequired,id:g.default.string.isRequired,groupId:g.default.string,path:g.default.any,children1:g.default.any,isDraggingMe:g.default.bool,isDraggingTempo:g.default.bool,isLocked:g.default.bool,isTrueLocked:g.default.bool,handleDraggerMouseDown:g.default.func,onDragStart:g.default.func,addRule:g.default.func.isRequired,addGroup:g.default.func.isRequired,removeSelf:g.default.func.isRequired,setConjunction:g.default.func.isRequired,setNot:g.default.func.isRequired,setLock:g.default.func.isRequired,actions:g.default.object.isRequired};var P=(0,h.default)((0,m.default)("group")((0,E.ConfirmFn)(T)));t.default=P},6176:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.GroupActions=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=d(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959));function d(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(d=function(e){return e?r:t})(e)}var f={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},p=function(e){(0,l.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,s.default)(t);if(r){var o=(0,s.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,u.default)(this,e)});function o(){return(0,i.default)(this,o),n.apply(this,arguments)}return(0,a.default)(o,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.removeSelf,i=e.setLock,a=e.isLocked,l=e.isTrueLocked,u=e.id,s=e.canAddGroup,d=e.canAddRule,p=e.canDeleteGroup,g=t.settings,v=g.immutableGroupsMode,h=g.addRuleLabel,m=g.addGroupLabel,y=g.delGroupLabel,b=g.groupActionsPosition,E=g.renderButton,O=g.renderSwitch,S=g.renderButtonGroup,_=g.lockLabel,w=g.lockedLabel,T=g.showLock,P=g.canDeleteLocked,C=f[b||"topRight"],I=T&&!(a&&!l)&&c.default.createElement(O,{type:"lock",id:u,value:a,setValue:i,label:_,checkedLabel:w,config:t}),A=!v&&d&&!a&&c.default.createElement(E,{type:"addRule",onClick:r,label:h,readonly:a,config:t}),R=!v&&s&&!a&&c.default.createElement(E,{type:"addGroup",onClick:n,label:m,readonly:a,config:t}),x=!v&&p&&(!a||a&&P)&&c.default.createElement(E,{type:"delGroup",onClick:o,label:y,config:t});return c.default.createElement("div",{className:"group--actions ".concat(C)},c.default.createElement(S,{config:t},I,A,R,x))}}]),o}(c.PureComponent);t.GroupActions=p},22173:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.Item=void 0;var i=n(r(40453)),a=n(r(39805)),l=n(r(40989)),u=n(r(87861)),s=n(r(15118)),c=n(r(29402)),d=n(r(78304)),f=n(r(85707)),p=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=S(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),g=n(r(91504)),v=n(r(21716)),h=n(r(17919)),m=n(r(64121)),y=n(r(66582)),b=n(r(70563)),E=n(r(58403)),O=["type"];function S(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(S=function(e){return e?r:t})(e)}function _(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function w(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_(Object(r),!0).forEach((function(t){(0,f.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var T=function(e){var t=e.properties.toObject(),r=w({},t);return e.isParentLocked&&(r.isLocked=!0),t.isLocked&&(r.isTrueLocked=!0),r},P={rule:function(e){return p.default.createElement(v.default,(0,d.default)({},T(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,config:e.config,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},group:function(e){return p.default.createElement(h.default,(0,d.default)({},T(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group:function(e){return p.default.createElement(m.default,(0,d.default)({},T(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group_ext:function(e){return p.default.createElement(y.default,(0,d.default)({},T(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},switch_group:function(e){return p.default.createElement(b.default,(0,d.default)({},T(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},case_group:function(e){return p.default.createElement(E.default,(0,d.default)({},T(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))}},C=function(e){(0,u.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,c.default)(t);if(r){var o=(0,c.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,s.default)(this,e)});function o(){return(0,a.default)(this,o),n.apply(this,arguments)}return(0,l.default)(o,[{key:"render",value:function(){var e=this.props,t=e.type,r=(0,i.default)(e,O),n="array"==r.properties.get("mode")?"_ext":"",o=r.config.settings.renderItem,a=P[t+n];return o?o(w(w({},r),{},{type:t,itemComponent:a})):a?a(r):null}}]),o}(p.PureComponent);t.Item=C,C.propTypes={config:g.default.object.isRequired,id:g.default.string.isRequired,groupId:g.default.string,type:g.default.oneOf(["rule","group","rule_group","switch_group","case_group"]).isRequired,path:g.default.any.isRequired,properties:g.default.any.isRequired,children1:g.default.any,actions:g.default.object.isRequired,reordableNodesCnt:g.default.number,onDragStart:g.default.func,parentField:g.default.string,isDraggingTempo:g.default.bool,isParentLocked:g.default.bool}},21716:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i,a,l,u=n(r(85707)),s=n(r(39805)),c=n(r(40989)),d=n(r(36417)),f=n(r(87861)),p=n(r(15118)),g=n(r(29402)),v=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=C(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),h=n(r(91504)),m=n(r(72294)),y=n(r(76736)),b=n(r(762)),E=n(r(29790)),O=n(r(54381)),S=n(r(46487)),_=r(40112),w=r(89112),T=r(92895),P=r(35939);function C(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(C=function(e){return e?r:t})(e)}function I(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function A(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?I(Object(r),!0).forEach((function(t){(0,u.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):I(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var R=r(71633),x=(i=(0,y.default)("rule"),(0,m.default)(a=i(a=(0,P.ConfirmFn)(((l=function(e){(0,f.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,g.default)(t);if(r){var o=(0,g.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,p.default)(this,e)});function o(e){var t;return(0,s.default)(this,o),t=n.call(this,e),(0,T.useOnPropsChanged)((0,d.default)(t)),t.removeSelf=t.removeSelf.bind((0,d.default)(t)),t.setLock=t.setLock.bind((0,d.default)(t)),t.onPropsChanged(e),t}return(0,c.default)(o,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["selectedField","selectedOperator","config","reordableNodesCnt","isLocked"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedOperator,n=e.config,o=e.reordableNodesCnt,i=e.isLocked,a=(0,w.getFieldPathLabels)(t,n),l=(0,_.getFieldConfig)(n,t),u=l&&"!struct"==l.type,s=t&&r&&!u,c=(0,_.getOperatorConfig)(n,r,t),d=c&&null!=c.options,f=(0,_.getFieldWidgetConfig)(n,t,r)||{},p=f.hideOperator;return{selectedFieldPartsLabels:a,selectedFieldWidgetConfig:f,showDragIcon:n.settings.canReorder&&o>1&&!i,showOperator:t&&!p,showOperatorLabel:t&&p&&f.operatorInlineLabel,showWidget:s,showOperatorOptions:s&&d}}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this,t=this.props.confirmFn,r=this.props.config.settings,n=r.renderConfirm,o=r.removeRuleConfirmOptions,i=function(){e.props.removeSelf()};o&&!this.isEmptyCurrentRule()?n(A(A({},o),{},{onOk:i,onCancel:null,confirmFn:t})):i()}},{key:"isEmptyCurrentRule",value:function(){return!(null!==this.props.selectedField&&null!==this.props.selectedOperator&&this.props.value.filter((function(e){return void 0!==e})).size>0)}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=t.settings.immutableFieldsMode;return v.default.createElement(E.default,{key:"field",classname:"rule--field",config:t,selectedField:this.props.selectedField,setField:n?P.dummyFn:this.props.setField,parentField:this.props.parentField,readonly:n||r,id:this.props.id,groupId:this.props.groupId})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta,o=n.selectedFieldPartsLabels,i=n.selectedFieldWidgetConfig,a=n.showOperator,l=n.showOperatorLabel,u=t.settings.immutableOpsMode;return v.default.createElement(b.default,{key:"operator",config:t,selectedField:this.props.selectedField,selectedOperator:this.props.selectedOperator,setOperator:u?P.dummyFn:this.props.setOperator,selectedFieldPartsLabels:o,showOperator:a,showOperatorLabel:l,selectedFieldWidgetConfig:i,readonly:u||r,id:this.props.id,groupId:this.props.groupId})}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.valueError,n=e.isLocked,o=this.meta.showWidget,i=t.settings.immutableValuesMode;if(!o)return null;var a=v.default.createElement(O.default,{key:"values",field:this.props.selectedField,parentField:this.props.parentField,operator:this.props.selectedOperator,value:this.props.value,valueSrc:this.props.valueSrc,asyncListValues:this.props.asyncListValues,valueError:r,config:t,setValue:i?P.dummyFn:this.props.setValue,setValueSrc:i?P.dummyFn:this.props.setValueSrc,readonly:i||n,id:this.props.id,groupId:this.props.groupId});return v.default.createElement(P.Col,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},a)}},{key:"renderOperatorOptions",value:function(){var e=this.props.config,t=this.meta.showOperatorOptions,r=e.settings,n=r.immutableOpsMode,o=r.immutableValuesMode;if(!t)return null;var i=v.default.createElement(S.default,{key:"operatorOptions",selectedField:this.props.selectedField,selectedOperator:this.props.selectedOperator,operatorOptions:this.props.operatorOptions,setOperatorOption:n?P.dummyFn:this.props.setOperatorOption,config:e,readonly:o});return v.default.createElement(P.Col,{key:"op-options-for-"+this.props.selectedOperator,className:"rule--operator-options"},i)}},{key:"renderBeforeWidget",value:function(){var e=this.props.config.settings.renderBeforeWidget;return e&&v.default.createElement(P.Col,{key:"before-widget-for-"+this.props.selectedOperator,className:"rule--before-widget"},"function"==typeof e?e(this.props):e)}},{key:"renderAfterWidget",value:function(){var e=this.props.config.settings.renderAfterWidget;return e&&v.default.createElement(P.Col,{key:"after-widget-for-"+this.props.selectedOperator,className:"rule--after-widget"},"function"==typeof e?e(this.props):e)}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings,o=n.renderRuleError,i=n.showErrorMessage,a=r&&r.toArray().filter((function(e){return!!e})).shift()||null;return i&&a&&v.default.createElement("div",{className:"rule--error"},o?o({error:a}):a)}},{key:"renderDrag",value:function(){return this.meta.showDragIcon&&v.default.createElement("span",{key:"rule-drag-icon",className:"qb-drag-handler rule--drag-handler",onMouseDown:this.props.handleDraggerMouseDown},v.default.createElement(P.DragIcon,null)," ")}},{key:"renderDel",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=t.settings,o=n.deleteLabel,i=n.immutableGroupsMode,a=n.renderButton,l=n.canDeleteLocked;return!i&&(!r||r&&l)&&v.default.createElement(a,{type:"delRule",onClick:this.removeSelf,label:o,config:t})}},{key:"renderLock",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.isTrueLocked,o=e.id,i=t.settings,a=i.lockLabel,l=i.lockedLabel,u=i.showLock,s=i.renderSwitch;return u&&!(r&&!n)&&v.default.createElement(s,{type:"lock",id:o,value:r,setValue:this.setLock,label:a,checkedLabel:l,hideLabel:!0,config:t})}},{key:"render",value:function(){var e=this.meta,t=e.showOperatorOptions,r=e.selectedFieldWidgetConfig,n=this.props,o=n.valueSrc,i=n.value,a=n.config,l="value"==o.first()&&!t&&1==i.size&&r.fullWidth,u=a.settings.renderButtonGroup,s=[this.renderField(),this.renderOperator(),this.renderBeforeWidget(),this.renderWidget(),this.renderAfterWidget(),this.renderOperatorOptions()],c=v.default.createElement("div",{key:"rule-body",className:R("rule--body",l&&"can--shrink--value")},s),d=this.renderError(),f=this.renderDrag(),p=this.renderLock(),g=this.renderDel();return v.default.createElement(v.default.Fragment,null,f,v.default.createElement("div",{className:"rule--body--wrapper"},c,d),v.default.createElement("div",{className:"rule--header"},v.default.createElement(u,{config:a},p,g)))}}]),o}(v.PureComponent)).propTypes={id:h.default.string.isRequired,groupId:h.default.string,selectedField:h.default.string,selectedOperator:h.default.string,operatorOptions:h.default.object,config:h.default.object.isRequired,value:h.default.any,valueSrc:h.default.any,asyncListValues:h.default.array,isDraggingMe:h.default.bool,isDraggingTempo:h.default.bool,parentField:h.default.string,valueError:h.default.any,isLocked:h.default.bool,isTrueLocked:h.default.bool,handleDraggerMouseDown:h.default.func,setField:h.default.func,setOperator:h.default.func,setOperatorOption:h.default.func,setLock:h.default.func,removeSelf:h.default.func,setValue:h.default.func,setValueSrc:h.default.func,reordableNodesCnt:h.default.number},a=l))||a)||a)||a);t.default=x},64121:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o,i,a,l=n(r(85707)),u=n(r(39805)),s=n(r(40989)),c=n(r(36417)),d=n(r(41621)),f=n(r(87861)),p=n(r(15118)),g=n(r(29402)),v=n(r(85959)),h=n(r(91504)),m=n(r(44281)),y=n(r(76736)),b=r(17919),E=r(16966),O=n(r(29790)),S=r(92895),_=r(35939);function w(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function T(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?w(Object(r),!0).forEach((function(t){(0,l.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):w(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var P=(o=(0,y.default)("group rule_group"),(0,m.default)(i=o(i=(0,_.ConfirmFn)(((a=function(e){(0,f.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,g.default)(t);if(r){var o=(0,g.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,p.default)(this,e)});function o(e){var t;return(0,u.default)(this,o),(t=n.call(this,e)).childrenClassName=function(){return"rule_group--children"},t.renderHeaderWrapper=function(){return null},t.renderFooterWrapper=function(){return null},t.renderConjs=function(){return null},t.canAddGroup=function(){return!1},t.canAddRule=function(){return!0},t.canDeleteGroup=function(){return!1},(0,S.useOnPropsChanged)((0,c.default)(t)),t.onPropsChanged(e),t}return(0,s.default)(o,[{key:"onPropsChanged",value:function(e){}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.children1.size}},{key:"renderChildrenWrapper",value:function(){return v.default.createElement(v.default.Fragment,null,this.renderDrag(),this.renderField(),this.renderActions(),(0,d.default)((0,g.default)(o.prototype),"renderChildrenWrapper",this).call(this))}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.setField,o=e.parentField,i=e.id,a=e.groupId,l=e.isLocked,u=t.settings.immutableFieldsMode;return v.default.createElement(O.default,{key:"field",classname:"group--field",config:t,selectedField:r,setField:n,parentField:o,readonly:u||l,id:i,groupId:a})}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return v.default.createElement(E.RuleGroupActions,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}]),o}(b.BasicGroup)).propTypes=T(T({},b.BasicGroup.propTypes),{},{selectedField:h.default.string,parentField:h.default.string,setField:h.default.func}),i=a))||i)||i)||i);t.default=P},16966:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.RuleGroupActions=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=d(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959));function d(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(d=function(e){return e?r:t})(e)}var f=function(e){(0,l.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,s.default)(t);if(r){var o=(0,s.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,u.default)(this,e)});function o(){return(0,i.default)(this,o),n.apply(this,arguments)}return(0,a.default)(o,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,l=e.isLocked,u=e.isTrueLocked,s=e.id,d=t.settings,f=d.immutableGroupsMode,p=d.addRuleLabel,g=d.delGroupLabel,v=d.renderButton,h=d.renderSwitch,m=d.renderButtonGroup,y=d.lockLabel,b=d.lockedLabel,E=d.showLock,O=d.canDeleteLocked,S=E&&!(l&&!u)&&c.default.createElement(h,{type:"lock",id:s,value:l,setValue:a,label:y,checkedLabel:b,hideLabel:!0,config:t}),_=!f&&n&&!l&&c.default.createElement(v,{type:"addRuleGroup",onClick:r,label:p,readonly:l,config:t}),w=!f&&o&&(!l||l&&O)&&c.default.createElement(v,{type:"delRuleGroup",onClick:i,label:g,config:t});return c.default.createElement("div",{className:"group--actions"},c.default.createElement(m,{config:t},S,_,w))}}]),o}(c.PureComponent);t.RuleGroupActions=f},66582:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o,i,a,l=n(r(85707)),u=n(r(39805)),s=n(r(40989)),c=n(r(36417)),d=n(r(41621)),f=n(r(87861)),p=n(r(15118)),g=n(r(29402)),v=n(r(85959)),h=n(r(91504)),m=n(r(44281)),y=n(r(76736)),b=r(17919),E=r(48619),O=n(r(29790)),S=n(r(762)),_=r(92895),w=r(35939),T=r(40112),P=n(r(54381));function C(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function I(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?C(Object(r),!0).forEach((function(t){(0,l.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):C(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function A(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var R=r(71633),x=(o=(0,y.default)("group rule_group_ext"),(0,m.default)(i=o(i=(0,w.ConfirmFn)(((a=function(e){(0,f.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,g.default)(t);if(r){var o=(0,g.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,p.default)(this,e)});function o(e){var t;return(0,u.default)(this,o),(t=n.call(this,e)).childrenClassName=function(){return"rule_group_ext--children"},t.renderFooterWrapper=function(){return null},t.canAddGroup=function(){return!1},t.canAddRule=function(){return!0},t.canDeleteGroup=function(){return!0},(0,_.useOnPropsChanged)((0,c.default)(t)),t.onPropsChanged(e),t}return(0,s.default)(o,[{key:"onPropsChanged",value:function(e){}},{key:"renderHeaderWrapper",value:function(){return v.default.createElement("div",{key:"group-header",className:R("group--header",this.isOneChild()?"one--child":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeader(),this.renderGroupField(),this.renderActions())}},{key:"renderHeader",value:function(){return v.default.createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderGroupField",value:function(){return v.default.createElement("div",{className:"group--field--count--rule"},this.renderField(),this.renderOperator(),this.renderWidget())}},{key:"showNot",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=(e.selectedOperator,(0,T.getFieldConfig)(t,r)||{});return null!=n.showNot?n.showNot:t.settings.showNot}},{key:"conjunctionOptions",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=(e.selectedOperator,(0,T.getFieldConfig)(t,r)||{}),i=(0,d.default)((0,g.default)(o.prototype),"conjunctionOptions",this).call(this);if(n.conjunctions){var a,l={},u=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return A(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?A(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(n.conjunctions);try{for(u.s();!(a=u.n()).done;){var s=a.value;l[s]=i[s]}}catch(e){u.e(e)}finally{u.f()}i=l}return i}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.setField,o=e.parentField,i=e.id,a=e.groupId,l=e.isLocked,u=t.settings.immutableFieldsMode;return v.default.createElement(O.default,{key:"field",classname:"rule--field",config:t,selectedField:r,setField:n,parentField:o,readonly:u||l,id:i,groupId:a})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.setField,i=e.setOperator,a=e.isLocked,l=t.settings.immutableFieldsMode,u=(0,T.getFieldWidgetConfig)(t,r,n)||{},s=u.hideOperator,c=r&&s&&u.operatorInlineLabel,d=r&&!s;return v.default.createElement(S.default,{key:"operator",classname:"group--operator",config:t,selectedField:r,selectedOperator:n,setField:o,setOperator:i,selectedFieldPartsLabels:["group"],showOperator:d,showOperatorLabel:c,selectedFieldWidgetConfig:u,readonly:l||a,id:this.props.id,groupId:this.props.groupId})}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.isLocked,i=t.settings.immutableValuesMode;if(!r||!n)return null;var a=v.default.createElement(P.default,{key:"values",isForRuleGruop:!0,field:this.props.selectedField,operator:this.props.selectedOperator,value:this.props.value,valueSrc:"value",valueError:null,config:t,setValue:i?w.dummyFn:this.props.setValue,setValueSrc:w.dummyFn,readonly:i||o,id:this.props.id,groupId:this.props.groupId});return v.default.createElement(w.Col,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},a)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return v.default.createElement(E.RuleGroupExtActions,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.children1.size}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}]),o}(b.BasicGroup)).propTypes=I(I({},b.BasicGroup.propTypes),{},{selectedField:h.default.string,selectedOperator:h.default.string,value:h.default.any,parentField:h.default.string,setField:h.default.func,setOperator:h.default.func,setValue:h.default.func}),i=a))||i)||i)||i);t.default=x},48619:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.RuleGroupExtActions=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=d(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959));function d(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(d=function(e){return e?r:t})(e)}var f=function(e){(0,l.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,s.default)(t);if(r){var o=(0,s.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,u.default)(this,e)});function o(){return(0,i.default)(this,o),n.apply(this,arguments)}return(0,a.default)(o,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,l=e.isLocked,u=e.isTrueLocked,s=e.id,d=t.settings,f=d.immutableGroupsMode,p=d.addSubRuleLabel,g=d.delGroupLabel,v=d.renderButton,h=d.renderSwitch,m=d.renderButtonGroup,y=d.lockLabel,b=d.lockedLabel,E=d.showLock,O=d.canDeleteLocked,S=E&&!(l&&!u)&&c.default.createElement(h,{type:"lock",id:s,value:l,setValue:a,label:y,checkedLabel:b,config:t}),_=!f&&n&&!l&&c.default.createElement(v,{type:"addRuleGroupExt",onClick:r,label:p,readonly:l,config:t}),w=!f&&o&&(!l||l&&O)&&c.default.createElement(v,{type:"delRuleGroup",onClick:i,label:g,config:t});return c.default.createElement("div",{className:"group--actions group--actions--tr"},c.default.createElement(m,{config:t},S,_,w))}}]),o}(c.PureComponent);t.RuleGroupExtActions=f},70563:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o,i,a,l=n(r(85707)),u=n(r(39805)),s=n(r(40989)),c=n(r(36417)),d=n(r(87861)),f=n(r(15118)),p=n(r(29402)),g=n(r(85959)),v=(n(r(91504)),n(r(44281))),h=n(r(76736)),m=r(17919),y=r(22292),b=r(92895),E=r(35939),O=r(53502);function S(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var _=r(71633),w=(o=(0,h.default)("group switch_group"),(0,v.default)(i=o(i=(0,E.ConfirmFn)(((a=function(e){(0,d.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,p.default)(t);if(r){var o=(0,p.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,f.default)(this,e)});function o(e){var t;return(0,u.default)(this,o),(t=n.call(this,e)).childrenClassName=function(){return"switch_group--children"},t.renderFooterWrapper=function(){return null},t.hasDefaultCase=function(){return t.props.children1.size&&t.props.children1.filter((function(e){return null==e.get("children1")})).size>0},(0,b.useOnPropsChanged)((0,c.default)(t)),t.onPropsChanged(e),t}return(0,s.default)(o,[{key:"onPropsChanged",value:function(e){}},{key:"canAddGroup",value:function(){var e=this.props.config.settings.maxNumberOfCases,t=this.props.children1.size;return!e||t<e}},{key:"canAddRule",value:function(){return!1}},{key:"reordableNodesCnt",value:function(){var e=this.props.children1.size;return this.hasDefaultCase()&&e--,e}},{key:"totalRulesCntForItem",value:function(e){return(0,O.getTotalRulesCountInTree)(e)}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.config.settings,r=t.canLeaveEmptyCase,n=t.canRegroupCases,o=this.props.children1.size;this.hasDefaultCase()&&o--;var i=(0,O.getTotalReordableNodesCountInTree)(e);return 1==i&&n&&r&&o>1&&(i=111),i}},{key:"renderHeaderWrapper",value:function(){return g.default.createElement("div",{key:"group-header",className:_("group--header",this.isOneChild()?"one--child":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeader(),this.renderActions())}},{key:"renderHeader",value:function(){return g.default.createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderConjs",value:function(){var e=this.props.config.settings.renderSwitchPrefix;return e?e():null}},{key:"showNot",value:function(){return!1}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return g.default.createElement(y.SwitchGroupActions,{config:t,addCaseGroup:r,addDefaultCaseGroup:n,canAddDefault:!this.hasDefaultCase(),canAddGroup:this.canAddGroup(),setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}}]),o}(m.BasicGroup)).propTypes=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?S(Object(r),!0).forEach((function(t){(0,l.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):S(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},m.BasicGroup.propTypes),i=a))||i)||i)||i);t.default=w},22292:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.SwitchGroupActions=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=d(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959));function d(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(d=function(e){return e?r:t})(e)}var f={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},p=function(e){(0,l.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,s.default)(t);if(r){var o=(0,s.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,u.default)(this,e)});function o(){return(0,i.default)(this,o),n.apply(this,arguments)}return(0,a.default)(o,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.setLock,i=e.isLocked,a=e.isTrueLocked,l=e.id,u=e.canAddGroup,s=e.canAddDefault,d=t.settings,p=d.immutableGroupsMode,g=d.addCaseLabel,v=d.addDefaultCaseLabel,h=d.groupActionsPosition,m=d.renderButton,y=d.renderSwitch,b=d.renderButtonGroup,E=d.lockLabel,O=d.lockedLabel,S=d.showLock,_=f[h||"topRight"],w=S&&!(i&&!a)&&c.default.createElement(y,{type:"lock",id:l,value:i,setValue:o,label:E,checkedLabel:O,config:t}),T=!p&&u&&!i&&c.default.createElement(m,{type:"addCaseGroup",onClick:r,label:g,readonly:i,config:t}),P=!p&&s&&!i&&c.default.createElement(m,{type:"addDefaultCaseGroup",onClick:n,label:v,readonly:i,config:t});return c.default.createElement("div",{className:"group--actions ".concat(_)},c.default.createElement(b,{config:t},w,T,P))}}]),o}(c.PureComponent);t.SwitchGroupActions=p},88949:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(78304)),a=n(r(39805)),l=n(r(40989)),u=n(r(87861)),s=n(r(15118)),c=n(r(29402)),d=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=g(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),f=n(r(91504)),p=n(r(53649));function g(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(g=function(e){return e?r:t})(e)}var v=function(e){(0,u.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,c.default)(t);if(r){var o=(0,c.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,s.default)(this,e)});function o(){var e;(0,a.default)(this,o);for(var t=arguments.length,r=new Array(t),i=0;i<t;i++)r[i]=arguments[i];return(e=n.call.apply(n,[this].concat(r))).handleChange=function(t){e.props.setOption("proximity",parseInt(t))},e}return(0,l.default)(o,[{key:"render",value:function(){var e=this.props,t=e.defaults,r=e.options,n=e.config,o=e.optionLabel,a=e.optionPlaceholder,l=e.customProps,u=e.minProximity,s=e.maxProximity,c=e.optionTextBefore,f=e.readonly,g=n.settings,v=n.widgets,h=t?t.proximity:void 0,m=g.showLabels,y=r.get("proximity",h),b=(0,p.default)(u,s+1).map((function(e){return{title:e,value:e}})),E=v.select.factory;return d.default.createElement("div",{className:"operator--PROXIMITY"},d.default.createElement("div",{className:"operator--options"},m&&d.default.createElement("label",{className:"rule--label"},o),!m&&c&&d.default.createElement("div",{className:"operator--options--sep"},d.default.createElement("span",null,c)),d.default.createElement(E,(0,i.default)({config:n,value:y,listValues:b,setValue:this.handleChange,readonly:f,placeholder:a},l))),d.default.createElement("div",{className:"operator--widgets"},this.props.children))}}]),o}(d.PureComponent);t.default=v,v.propTypes={config:f.default.object.isRequired,setOption:f.default.func.isRequired,options:f.default.any.isRequired,minProximity:f.default.number,maxProximity:f.default.number,optionPlaceholder:f.default.string,optionTextBefore:f.default.string,optionLabel:f.default.string,customProps:f.default.object,readonly:f.default.bool},v.defaultProps={customProps:{},minProximity:2,maxProximity:10,optionPlaceholder:"Select words between",optionLabel:"Words between",optionTextBefore:null}},91680:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),Object.defineProperty(t,"ProximityOperator",{enumerable:!0,get:function(){return o.default}});var o=n(r(88949))},67301:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(85707)),a=n(r(39805)),l=n(r(40989)),u=n(r(36417)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=E(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),p=n(r(91504)),g=r(40112),v=r(89112),h=r(98477),m=r(92895),y=n(r(75342)),b=n(r(31178));function E(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(E=function(e){return e?r:t})(e)}function O(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var S=function(e){(0,s.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,d.default)(t);if(r){var o=(0,d.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,c.default)(this,e)});function o(e){var t;return(0,a.default)(this,o),t=n.call(this,e),(0,m.useOnPropsChanged)((0,u.default)(t)),t.onPropsChanged(e),t}return(0,l.default)(o,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["selectedField","config","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.config,n=e.parentField,o=t,i=r.settings,a=i.maxLabelsLength,l=i.fieldSeparatorDisplay,u=i.fieldPlaceholder,s=i.fieldSeparator,c=!!t,d=c?null:(0,h.truncateString)(u,a),f=c?(0,g.getFieldConfig)(r,o):null,p=f||{},m=(0,v.getFieldPath)(o,r),y=(0,v.getFieldPath)(o,r,!0),b=this.getFieldLabel(f,o,r),E=(0,v.getFieldPathLabels)(o,r),O=E?E.join(l):null;(O==b||n)&&(O=null);var S=p.label2,_="string"==typeof n?n.split(s):n,w=n?(0,g.getFieldConfig)(r,n):null,T=n?w&&w.subfields:r.fields;return{placeholder:d,items:this.buildOptions(_,r,T,_),parentField:n,selectedKey:o,selectedKeys:m,selectedPath:y,selectedLabel:b,selectedOpts:p,selectedAltLabel:S,selectedFullLabel:O}}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.fieldSeparator,o=r.settings.maxLabelsLength,i=Array.isArray(t)?t:t.split(n),a=e&&e.label||(0,y.default)(i);return(0,h.truncateString)(a,o)}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!r)return null;var a=t.settings,l=a.fieldSeparator,u=a.fieldSeparatorDisplay,s=o?o.join(l)+l:"";return(0,b.default)(r).map((function(a){var l=r[a],c=n.getFieldLabel(l,a,t),d=(0,v.getFieldPathLabels)(s+a,t).join(u);(d==c||e)&&(d=null);var f=l.label2,p=l.tooltip,g=(o||[]).concat(a),h=l.disabled;if(!l.hideForSelect)return"!struct"==l.type?{disabled:h,key:a,path:s+a,label:c,fullLabel:d,altLabel:f,tooltip:p,items:n.buildOptions(e,t,l.subfields,g,c)}:{disabled:h,key:a,path:s+a,label:c,fullLabel:d,altLabel:f,tooltip:p,grouplabel:i}})).filter((function(e){return!!e}))}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setField,o=e.readonly,a=e.id,l=e.groupId,u=t.settings.renderField,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?O(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):O(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:a,groupId:l,config:t,customProps:r,readonly:o,setField:n},this.meta);return u(s)}}]),o}(f.PureComponent);t.default=S,S.propTypes={id:p.default.string,groupId:p.default.string,config:p.default.object.isRequired,selectedField:p.default.string,parentField:p.default.string,customProps:p.default.object,readonly:p.default.bool,setField:p.default.func.isRequired}},29790:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=p(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),d=n(r(67301)),f=r(35939);function p(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(p=function(e){return e?r:t})(e)}var g=function(e){(0,l.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,s.default)(t);if(r){var o=(0,s.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,u.default)(this,e)});function o(){return(0,i.default)(this,o),n.apply(this,arguments)}return(0,a.default)(o,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.setField,o=e.parentField,i=e.classname,a=e.readonly,l=e.id,u=e.groupId;return c.default.createElement(f.Col,{className:i},t.settings.showLabels&&c.default.createElement("label",{className:"rule--label"},t.settings.fieldLabel),c.default.createElement(d.default,{config:t,selectedField:r,parentField:o,setField:n,customProps:t.settings.customFieldSelectProps,readonly:a,id:l,groupId:u}))}}]),o}(c.PureComponent);t.default=g},3463:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(85707)),a=n(r(18821)),l=n(r(39805)),u=n(r(40989)),s=n(r(36417)),c=n(r(87861)),d=n(r(15118)),f=n(r(29402)),p=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=S(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),g=n(r(91504)),v=r(40112),h=r(89112),m=r(98477),y=r(92895),b=n(r(75342)),E=n(r(31178)),O=n(r(19999));function S(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(S=function(e){return e?r:t})(e)}function _(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var w=function(e){(0,c.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,f.default)(t);if(r){var o=(0,f.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,d.default)(this,e)});function o(e){var t;return(0,l.default)(this,o),t=n.call(this,e),(0,y.useOnPropsChanged)((0,s.default)(t)),t.onPropsChanged(e),t}return(0,u.default)(o,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","operator","isFuncArg"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0;(!this.meta||["config","field","value"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r&&(this.items=this.getItems(e))}},{key:"getItems",value:function(e){var t=e.config,r=e.field,n=e.operator,o=e.parentFuncs,i=e.fieldDefinition,a=e.isFuncArg,l=t.settings.canUseFuncForField,u=this.filterFuncs(t,t.funcs,r,n,l,o,a,i);return this.buildOptions(t,u)}},{key:"getMeta",value:function(e){var t=e.config,r=e.field,n=e.value,o=t.settings,i=o.funcPlaceholder,a=o.fieldSeparatorDisplay,l=n,u=!!n,s=(0,v.getFieldConfig)(t,r).widgets.field,c=(s&&s.widgetProps,u?null:i),d=u?(0,v.getFuncConfig)(t,l):null,f=d||{},p=(0,h.getFieldPath)(l,t),g=(0,h.getFieldPath)(l,t,!0),m=this.getFuncLabel(d,l,t),y=(0,h.getFuncPathLabels)(l,t),b=y?y.join(a):null;return b==m&&(b=null),{placeholder:c,selectedKey:l,selectedKeys:p,selectedPath:g,selectedLabel:m,selectedOpts:f,selectedFullLabel:b}}},{key:"filterFuncs",value:function(e,t,r,n,o,i,l,u){t=(0,O.default)(t);var s,c=e.settings.fieldSeparator,d=(0,v.getFieldConfig)(e,r),f=d,p=(0,h.getWidgetForFieldOp)(e,r,n,"value");if(l&&u)f=u,s=u.type;else if(p){var g=e.widgets[p].type;s=g}else s=d.type;return function t(l,u){for(var p in l){var g=l[p].subfields,h=(u||[]).concat(p),m=h.join(c),y=(0,v.getFuncConfig)(e,m);if("!struct"==y.type)0==t(g,h)&&delete l[p];else{var b=y.returnType==s;f.funcs&&(b=b&&f.funcs.includes(m)),o&&(b=b&&o(r,d,m,y,n)),!y.allowSelfNesting&&i&&i.map((function(e){var t=(0,a.default)(e,2),r=t[0];return t[1],r})).includes(m)&&(b=!1),b||delete l[p]}}return(0,E.default)(l).length}(t,[]),t}},{key:"buildOptions",value:function(e,t){var r=this,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(!t)return null;var i=e.settings,a=i.fieldSeparator,l=i.fieldSeparatorDisplay,u=n?n.join(a)+a:"";return(0,E.default)(t).map((function(i){var a=t[i],s=r.getFuncLabel(a,i,e),c=(0,h.getFuncPathLabels)(i,e).join(l);c==s&&(c=null);var d=a.tooltip,f=(n||[]).concat(i);return"!struct"==a.type?{key:i,path:u+i,label:s,fullLabel:c,tooltip:d,items:r.buildOptions(e,a.subfields,f,s)}:{key:i,path:u+i,label:s,fullLabel:c,tooltip:d,grouplabel:o}}))}},{key:"getFuncLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.fieldSeparator,o=r.settings.maxLabelsLength,i=Array.isArray(t)?t:t.split(n),a=e.label||(0,b.default)(i);return(0,m.truncateString)(a,o)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,a=e.id,l=e.groupId,u=t.settings.renderFunc,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({config:t,customProps:r,readonly:o,setField:n,items:this.items,id:a,groupId:l},this.meta);return u(s)}}]),o}(p.PureComponent);t.default=w,w.propTypes={id:g.default.string,groupId:g.default.string,config:g.default.object.isRequired,field:g.default.string.isRequired,operator:g.default.string,customProps:g.default.object,value:g.default.string,setValue:g.default.func.isRequired,readonly:g.default.bool,parentFuncs:g.default.array,fieldDefinition:g.default.object,isFuncArg:g.default.bool}},68139:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(78304)),a=n(r(10906)),l=n(r(39805)),u=n(r(40989)),s=n(r(36417)),c=n(r(87861)),d=n(r(15118)),f=n(r(29402)),p=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=O(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),g=n(r(91504)),v=n(r(3463)),h=r(40112),m=n(r(54381)),y=r(35939),b=r(63968),E=r(92895);function O(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(O=function(e){return e?r:t})(e)}function S(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var r,n=(0,f.default)(e);if(t){var o=(0,f.default)(this).constructor;r=Reflect.construct(n,arguments,o)}else r=n.apply(this,arguments);return(0,d.default)(this,r)}}var _=function(e){(0,c.default)(r,e);var t=S(r);function r(e){var n;return(0,l.default)(this,r),(n=t.call(this,e)).setFunc=function(e){n.props.setValue((0,b.setFunc)(n.props.value,e,n.props.config))},n.setArgValue=function(e,t){var r=n.props.config,o=n.meta.funcDefinition.args[e];n.props.setValue((0,b.setArgValue)(n.props.value,e,t,o,r))},n.setArgValueSrc=function(e,t){var r=n.props.config,o=n.meta.funcDefinition.args[e];n.props.setValue((0,b.setArgValueSrc)(n.props.value,e,t,o,r))},n.renderFuncSelect=function(){var e=n.props,t=e.config,r=e.field,o=e.operator,i=e.customProps,a=e.value,l=e.readonly,u=e.parentFuncs,s=e.id,c=e.groupId,d=e.isFuncArg,f=e.fieldDefinition,g={value:a?a.get("func"):null,setValue:n.setFunc,config:t,field:r,operator:o,customProps:i,readonly:l,parentFuncs:u,isFuncArg:d,fieldDefinition:f,id:s,groupId:c},h=t.settings,m=h.showLabels,b=h.funcLabel,E=m?p.default.createElement("label",{className:"rule--label"},b):null;return p.default.createElement(y.Col,{key:"func",className:"rule--func"},E,p.default.createElement(v.default,g))},n.renderArgLabel=function(e,t){var r=t.valueSources,o=t.type,i=t.showPrefix,a=t.label,l=n.props.config,u=r&&1==r.length&&"const"==r[0];return l.settings.showLabels||"boolean"!=o&&!u||!i?null:p.default.createElement(y.Col,{className:"rule--func--arg-label"},a||e)},n.renderArgLabelSep=function(e,t){var r=t.valueSources,o=t.type,i=t.showPrefix,a=n.props.config,l=r&&1==r.length&&"const"==r[0];return a.settings.showLabels||"boolean"!=o&&!l||!i?null:p.default.createElement(y.Col,{className:"rule--func--arg-label-sep"},":")},n.renderArgVal=function(e,t,r){var o=n.props,i=o.config,a=o.field,l=(o.operator,o.value),u=o.readonly,s=o.parentFuncs,c=o.id,d=o.groupId,f=l?l.getIn(["args",t]):null,g=f?f.get("value"):void 0,v=1==r.valueSources.length?r.valueSources[0]:void 0,h={config:i,fieldFunc:e,fieldArg:t,leftField:a,operator:null,value:g,valueSrc:f?f.get("valueSrc")||v||"value":v,setValue:n.setArgValue,setValueSrc:n.setArgValueSrc,funcKey:e,argKey:t,argDefinition:r,readonly:u,parentFuncs:s,id:c,groupId:d};return p.default.createElement(y.Col,{className:"rule--func--arg-value"},p.default.createElement(w,h))},n.renderArgSep=function(e,t,r,n){var o=n.renderSeps;return r?p.default.createElement(y.Col,{className:"rule--func--arg-sep"},o?o[r-1]:", "):null},n.renderBracketBefore=function(e){var t=e.renderBrackets;return p.default.createElement(y.Col,{key:"before_args",className:"rule--func--bracket-before"},t?t[0]:"(")},n.renderBracketAfter=function(e){var t=e.renderBrackets;return p.default.createElement(y.Col,{key:"after_args",className:"rule--func--bracket-after"},t?t[1]:")")},n.renderFuncArgs=function(){var e=n.meta,t=e.funcDefinition,r=e.funcKey;if(!r)return null;var o=t.args;return o?p.default.createElement(p.default.Fragment,null,n.renderBracketBefore(t),p.default.createElement(y.Col,{key:"args",className:"rule--func--args"},Object.keys(o).map((function(e,i){return p.default.createElement(y.Col,{key:"arg-".concat(e,"-").concat(i),className:"rule--func--arg"},n.renderArgSep(e,o[e],i,t),n.renderArgLabel(e,o[e]),n.renderArgLabelSep(e,o[e]),n.renderArgVal(r,e,o[e]))}))),n.renderBracketAfter(t)):null},(0,E.useOnPropsChanged)((0,s.default)(n)),n.onPropsChanged(e),n}return(0,u.default)(r,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","field","operator","value"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.config,r=(e.field,e.operator,e.value),n=r?r.get("func"):null;return{funcDefinition:n?(0,h.getFuncConfig)(t,n):null,funcKey:n}}},{key:"render",value:function(){return p.default.createElement(y.Col,{className:"rule--func--wrapper"},this.renderFuncSelect(),this.renderFuncArgs())}}]),r}(p.PureComponent);t.default=_,_.propTypes={id:g.default.string,groupId:g.default.string,config:g.default.object.isRequired,field:g.default.string.isRequired,operator:g.default.string,customProps:g.default.object,value:g.default.object,setValue:g.default.func.isRequired,readonly:g.default.bool,parentFuncs:g.default.array,fieldDefinition:g.default.object,isFuncArg:g.default.bool};var w=function(e){(0,c.default)(r,e);var t=S(r);function r(){var e;(0,l.default)(this,r);for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];return(e=t.call.apply(t,[this].concat(o))).setValue=function(t,r,n){var o=e.props;(0,o.setValue)(o.argKey,r)},e.setValueSrc=function(t,r,n){var o=e.props;(0,o.setValueSrc)(o.argKey,r)},e}return(0,u.default)(r,[{key:"render",value:function(){var e=this.props,t=e.funcKey,r=e.argKey,n=e.parentFuncs;return p.default.createElement(m.default,(0,i.default)({},this.props,{setValue:this.setValue,setValueSrc:this.setValueSrc,isFuncArg:!0,parentFuncs:[].concat((0,a.default)(n||[]),[[t,r]])}))}}]),r}(p.PureComponent);w.propTypes={funcKey:g.default.string.isRequired,argKey:g.default.string.isRequired,setValue:g.default.func.isRequired,setValueSrc:g.default.func.isRequired,readonly:g.default.bool,parentFuncs:g.default.array,id:g.default.string,groupId:g.default.string}},6137:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(85707)),a=n(r(39805)),l=n(r(40989)),u=n(r(36417)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=b(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),p=n(r(91504)),g=r(40112),v=n(r(31178)),h=n(r(55026)),m=n(r(9680)),y=r(92895);function b(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(b=function(e){return e?r:t})(e)}function E(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var O=function(e){(0,s.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,d.default)(t);if(r){var o=(0,d.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,c.default)(this,e)});function o(e){var t;return(0,a.default)(this,o),t=n.call(this,e),(0,y.useOnPropsChanged)((0,u.default)(t)),t.onPropsChanged(e),t}return(0,l.default)(o,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","selectedField","selectedOperator"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.config,r=e.selectedField,n=e.selectedOperator,o=(0,g.getFieldConfig)(t,r),i=null==o?void 0:o.operators,a=(0,m.default)((0,h.default)(t.operators,(function(e,t){return-1!==(null==i?void 0:i.indexOf(t))})),(function(e,n){return(0,g.getOperatorConfig)(t,n,r)})),l=this.buildOptions(t,a,i),u=!!n,s=(u?a[n]:null)||{},c=u?[n]:null;return{placeholder:this.props.config.settings.operatorPlaceholder,items:l,selectedKey:n,selectedKeys:c,selectedPath:c,selectedLabel:s.label,selectedOpts:s,fieldConfig:o}}},{key:"buildOptions",value:function(e,t,r){return t&&r?(0,v.default)(t).sort((function(e,t){return r.indexOf(e)-r.indexOf(t)})).map((function(e){return{key:e,path:e,label:t[e].label}})):null}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setOperator,o=e.readonly,a=e.id,l=e.groupId,u=t.settings.renderOperator,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?E(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):E(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:a,groupId:l,config:t,customProps:r,readonly:o,setField:n},this.meta);return s.items?u(s):null}}]),o}(f.PureComponent);t.default=O,O.propTypes={id:p.default.string,groupId:p.default.string,config:p.default.object.isRequired,selectedField:p.default.string,selectedOperator:p.default.string,readonly:p.default.bool,setOperator:p.default.func.isRequired}},46487:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(40453)),a=n(r(39805)),l=n(r(40989)),u=n(r(87861)),s=n(r(15118)),c=n(r(29402)),d=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=v(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),f=n(r(91504)),p=r(40112),g=["factory"];function v(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(v=function(e){return e?r:t})(e)}var h=function(e){(0,u.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,c.default)(t);if(r){var o=(0,c.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,s.default)(this,e)});function o(){return(0,a.default)(this,o),n.apply(this,arguments)}return(0,l.default)(o,[{key:"render",value:function(){if(!this.props.selectedOperator)return null;var e=(0,p.getOperatorConfig)(this.props.config,this.props.selectedOperator,this.props.selectedField);if(void 0===e.options)return null;var t=e.options,r=t.factory,n=(0,i.default)(t,g),o=r(Object.assign({},n,{config:this.props.config,field:this.props.selectedField,operator:this.props.selectedOperator,options:this.props.operatorOptions,setOption:this.props.setOperatorOption,readonly:this.props.readonly})),a=this.props.selectedOperator;return d.default.createElement("div",{className:"rule--operator rule--operator--".concat(a.toUpperCase())},o)}}]),o}(d.PureComponent);t.default=h,h.propTypes={config:f.default.object.isRequired,operatorOptions:f.default.any.isRequired,selectedField:f.default.string.isRequired,selectedOperator:f.default.string.isRequired,readonly:f.default.bool,setOperatorOption:f.default.func.isRequired}},762:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(39805)),a=n(r(40989)),l=n(r(87861)),u=n(r(15118)),s=n(r(29402)),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=p(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),d=n(r(6137)),f=r(35939);function p(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(p=function(e){return e?r:t})(e)}var g=function(e){(0,l.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,s.default)(t);if(r){var o=(0,s.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,u.default)(this,e)});function o(){return(0,i.default)(this,o),n.apply(this,arguments)}return(0,a.default)(o,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.setOperator,i=e.selectedFieldPartsLabels,a=e.showOperator,l=e.showOperatorLabel,u=e.selectedFieldWidgetConfig,s=e.readonly,p=e.id,g=e.groupId;return[a&&c.default.createElement(f.Col,{key:"operators-for-"+(i||[]).join("_"),className:"rule--operator"},t.settings.showLabels&&c.default.createElement("label",{className:"rule--label"},t.settings.operatorLabel),c.default.createElement(d.default,{key:"operator",config:t,selectedField:r,selectedOperator:n,setOperator:o,readonly:s,id:p,groupId:g})),l&&c.default.createElement(f.Col,{key:"operators-for-"+(i||[]).join("_"),className:"rule--operator"},c.default.createElement("div",{className:"rule--operator"},t.settings.showLabels?c.default.createElement("label",{className:"rule--label"}," "):null,c.default.createElement("span",null,u.operatorInlineLabel)))]}}]),o}(c.PureComponent);t.default=g},83914:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(85707)),a=n(r(39805)),l=n(r(40989)),u=n(r(36417)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=O(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),p=n(r(91504)),g=r(40112),v=r(89112),h=r(98477),m=r(92895),y=n(r(75342)),b=n(r(31178)),E=n(r(19999));function O(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(O=function(e){return e?r:t})(e)}function S(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var _=function(e){(0,s.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,d.default)(t);if(r){var o=(0,d.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,c.default)(this,e)});function o(e){var t;return(0,a.default)(this,o),t=n.call(this,e),(0,m.useOnPropsChanged)((0,u.default)(t)),t.onPropsChanged(e),t}return(0,l.default)(o,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","operator","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0,n=!this.meta||["config","field","operator","value","placeholder","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0;r&&(this.items=this.getItems(e)),n&&(this.meta=this.getMeta(e))}},{key:"getItems",value:function(e){var t=e.config,r=e.field,n=e.operator,o=e.parentField,i=e.isFuncArg,a=e.fieldDefinition,l=t.settings.canCompareFieldWithField,u=t.settings.fieldSeparator,s="string"==typeof o?o.split(u):o,c=o?(0,g.getFieldConfig)(t,o):null,d=o?c&&c.subfields:t.fields,f=this.filterFields(t,d,r,o,s,n,l,i,a);return this.buildOptions(s,t,f,s)}},{key:"getMeta",value:function(e){var t=e.config,r=e.field,n=(e.operator,e.value),o=e.placeholder,i=e.isFuncArg,a=e.parentField,l=t.settings,u=l.fieldPlaceholder,s=l.fieldSeparatorDisplay,c=n,d=!!n,f=(0,g.getFieldConfig)(t,r).widgets.field,p=f&&f.widgetProps||{},h=d?null:i&&o||p.valuePlaceholder||u,m=d?(0,g.getFieldConfig)(t,c):null,y=m||{},b=(0,v.getFieldPath)(c,t),E=(0,v.getFieldPath)(c,t,!0),O=this.getFieldLabel(m,c,t),S=(0,v.getFieldPathLabels)(c,t),_=S?S.join(s):null;return(_==O||a)&&(_=null),{placeholder:h,selectedKey:c,selectedKeys:b,selectedPath:E,selectedLabel:O,selectedOpts:y,selectedAltLabel:y.label2,selectedFullLabel:_}}},{key:"filterFields",value:function(e,t,r,n,o,i,a,l,u){t=(0,E.default)(t);var s,c=e.settings.fieldSeparator,d=(0,g.getFieldConfig)(e,r),f=(0,v.getWidgetForFieldOp)(e,r,i,"value");if(l&&u)s=u.type;else if(f){var p=e.widgets[f].type;s=p}else s=d.type;return function t(n,o){for(var u in n){var f=n[u].subfields,p=(o||[]).concat(u),v=p.join(c),h=(0,g.getFieldConfig)(e,v);if(h)if("!struct"==h.type||"!group"==h.type)0==t(f,p)&&delete n[u];else{var m=h.type==s&&(!!l||v!=r),y=a||e.settings.canCompareFieldWithField;y&&(m=m&&y(r,d,v,h,i)),m||delete n[u]}else delete n[u]}return(0,b.default)(n).length}(t,o||[]),t}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!r)return null;var a=t.settings,l=a.fieldSeparator,u=a.fieldSeparatorDisplay,s=o?o.join(l)+l:"";return(0,b.default)(r).map((function(a){var l=r[a],c=n.getFieldLabel(l,a,t),d=(0,v.getFieldPathLabels)(a,t).join(u);(d==c||e)&&(d=null);var f=l.label2,p=l.tooltip,g=(o||[]).concat(a);if(!l.hideForCompare)return"!struct"==l.type||"!group"==l.type?{key:a,path:s+a,label:c,fullLabel:d,altLabel:f,tooltip:p,items:n.buildOptions(e,t,l.subfields,g,c)}:{key:a,path:s+a,label:c,fullLabel:d,altLabel:f,tooltip:p,grouplabel:i}})).filter((function(e){return!!e}))}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.fieldSeparator,o=r.settings.maxLabelsLength,i=Array.isArray(t)?t:t.split(n),a=e.label||(0,y.default)(i);return(0,h.truncateString)(a,o)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,a=e.id,l=e.groupId,u=t.settings.renderField,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?S(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):S(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({config:t,customProps:r,setField:n,readonly:o,items:this.items,id:a,groupId:l},this.meta);return u(s)}}]),o}(f.PureComponent);t.default=_,_.propTypes={id:p.default.string,groupId:p.default.string,setValue:p.default.func.isRequired,config:p.default.object.isRequired,field:p.default.string.isRequired,value:p.default.string,operator:p.default.string,customProps:p.default.object,readonly:p.default.bool,parentField:p.default.string,fieldDefinition:p.default.object,isFuncArg:p.default.bool}},54381:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(78304)),a=n(r(39805)),l=n(r(40989)),u=n(r(36417)),s=n(r(87861)),c=n(r(15118)),d=n(r(29402)),f=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=_(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(85959)),p=n(r(91504)),g=n(r(53649)),v=r(40112),h=r(89112),m=r(98477),y=r(92895),b=n(r(67171)),E=n(r(37512)),O=n(r(82499)),S=r(35939);function _(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(_=function(e){return e?r:t})(e)}var w={cardinality:1},T=function(e){(0,s.default)(o,e);var t,r,n=(t=o,r=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}(),function(){var e,n=(0,d.default)(t);if(r){var o=(0,d.default)(this).constructor;e=Reflect.construct(n,arguments,o)}else e=n.apply(this,arguments);return(0,c.default)(this,e)});function o(e){var t;return(0,a.default)(this,o),(t=n.call(this,e))._setValue=function(e,r,n,o,i,a){if(e&&Array.isArray(o)){var l=[t.props.value.get(0),t.props.value.get(1)];l[0]!=o[0]&&t.props.setValue(0,o[0],n,i,a),l[1]!=o[1]&&t.props.setValue(1,o[1],n,i,a)}else t.props.setValue(r,o,n,i,a)},t._onChangeValueSrc=function(e,r){t.props.setValueSrc(e,r)},t.renderWidget=function(e,t,r){var n=r.config,o=r.isFuncArg,a=r.leftField,l=r.operator,u=r.value,s=r.valueError,c=r.readonly,d=r.parentField,p=r.parentFuncs,g=r.id,v=r.groupId,h=n.settings,m=t.widgets,y=t.iValues,E=t.aField,S=o?y:u,_=o?a:E,w=m[e],T=w.valueSrc,P=w.valueLabel,C=h.showLabels?f.default.createElement("label",{className:"rule--label"},P.label):null;return f.default.createElement("div",{key:"widget-"+_+"-"+e,className:"widget--widget"},"func"==T?null:C,f.default.createElement(O.default,(0,i.default)({id:g,groupId:v,valueSrc:T,delta:e,value:S,valueError:s,isFuncArg:o},(0,b.default)(t,["isSpecialRange","fieldDefinition","asyncListValues"]),(0,b.default)(m[e],["widget","widgetDefinition","widgetValueLabel","valueLabels","textSeparators","setValueHandler"]),{config:n,field:_,parentField:d,parentFuncs:p,operator:l,readonly:c})))},t.renderValueSources=function(e,t,r){var n=r.config,o=r.isFuncArg,i=r.leftField,a=r.operator,l=r.readonly,u=n.settings,s=t.valueSources,c=t.widgets,d=t.aField,p=o?i:d,g=c[e],v=g.valueSrc,h=g.setValueSrcHandler,m=u.valueSourcesInfo,y=u.renderValueSources,b=s.map((function(e){return[e,{label:m[e].label}]})),E=u.showLabels?f.default.createElement("label",{className:"rule--label"}," "):null;return s.length>1&&!l&&f.default.createElement("div",{key:"valuesrc-"+p+"-"+e,className:"widget--valuesrc"},E,f.default.createElement(y,{key:"valuesrc-"+e,delta:e,valueSources:b,valueSrc:v,config:n,field:p,operator:a,setValueSrc:h,readonly:l,title:u.valueSourcesPopupTitle}))},t.renderSep=function(e,t,r){var n=r.config,o=t.widgets,i=n.settings,a=o[e].sepText,l=i.showLabels?f.default.createElement("label",{className:"rule--label"}," "):null;return a&&f.default.createElement("div",{key:"widget-separators-"+e,className:"widget--sep"},l,f.default.createElement("span",null,a))},t.renderWidgetDelta=function(e){return[t.renderSep(e,t.meta,t.props),t.renderValueSources(e,t.meta,t.props),t.renderWidget(e,t.meta,t.props)]},(0,y.useOnPropsChanged)((0,u.default)(t)),t.onPropsChanged(e),t}return(0,l.default)(o,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","field","fieldFunc","fieldArg","leftField","operator","valueSrc","isFuncArg","asyncListValues"].map((function(r){return e[r]!==t[r]||"isFuncArg"==r&&e.isFuncArg&&e.value!==t.value})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=this,r=e.config,n=e.field,o=e.fieldFunc,i=e.fieldArg,a=e.operator,l=e.valueSrc,u=e.value,s=e.isForRuleGruop,c=e.isCaseValue,d=e.isFuncArg,f=e.leftField,p=e.asyncListValues,y=d?{func:o,arg:i}:n,b=l,O=u;(d||s||c)&&(b=E.default.List([l]),O=E.default.List([u]));var S=(0,v.getFieldConfig)(r,y),_=(0,h.getWidgetForFieldOp)(r,y,a),T=((0,h.getWidgetsForFieldOp)(r,y,a),d?w:(0,v.getOperatorConfig)(r,a,y));if((null==S||null==T)&&!c)return null;var P=null==T?void 0:T.isSpecialRange,C=P&&("field"==b.get(0)||"field"==b.get(1)),I=P&&!C,A=I?1:(0,m.defaultValue)(null==T?void 0:T.cardinality,1);if(0===A)return null;var R=(0,h.getValueSourcesForFieldOp)(r,y,a,S,d?f:null),x=(0,g.default)(0,A).map((function(e){var n,o=b.get(e)||null,i=(0,h.getWidgetForFieldOp)(r,y,a,o),l=(0,v.getFieldWidgetConfig)(r,y,a,i,o);C&&(i=l.singleWidget,l=(0,v.getFieldWidgetConfig)(r,y,a,i,o));var u=null===(n=l)||void 0===n?void 0:n.type,s=(0,h.getValueLabel)(r,y,a,e,o,I),c=(0,h.getValueLabel)(r,y,a,e,null,I),d=null!=T&&T.textSeparators?null==T?void 0:T.textSeparators[e]:null,f=t._onChangeValueSrc.bind(t,e),p=null,g=null;return P&&(p={placeholder:[(p=[(0,h.getValueLabel)(r,y,a,0),(0,h.getValueLabel)(r,y,a,1)])[0].placeholder,p[1].placeholder],label:[p[0].label,p[1].label]},g=null==T?void 0:T.textSeparators),{valueSrc:o,valueLabel:s,widget:i,sepText:d,setValueSrcHandler:f,widgetDefinition:l,widgetValueLabel:c,valueLabels:p,textSeparators:g,setValueHandler:t._setValue.bind(t,P,e,u)}}));return{defaultWidget:_,fieldDefinition:S,operatorDefinition:T,isSpecialRange:I,cardinality:A,valueSources:R,widgets:x,iValues:O,aField:y,asyncListValues:p}}},{key:"render",value:function(){if(!this.meta)return null;var e=this.meta,t=e.defaultWidget,r=e.cardinality;if(!t)return null;var n=t;return f.default.createElement(S.Col,{className:"rule--widget rule--widget--".concat(n.toUpperCase()),key:"widget-col-"+n},(0,g.default)(0,r).map(this.renderWidgetDelta))}}]),o}(f.PureComponent);t.default=T,T.propTypes={config:p.default.object.isRequired,value:p.default.any,valueSrc:p.default.any,valueError:p.default.any,field:p.default.string,operator:p.default.string,readonly:p.default.bool,asyncListValues:p.default.array,id:p.default.string,groupId:p.default.string,setValue:p.default.func,setValueSrc:p.default.func,isFuncArg:p.default.bool,fieldFunc:p.default.string,fieldArg:p.default.string,leftField:p.default.string,isForRuleGruop:p.default.bool,parentField:p.default.string,parentFuncs:p.default.array,isCaseValue:p.default.bool}},82499:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(40453)),i=(n(r(85959)),r(98477)),a=["factory"];t.default=function(e){var t=e.delta,r=e.isFuncArg,n=(e.valueSrc,e.value),l=e.valueError,u=e.asyncListValues,s=e.isSpecialRange,c=e.fieldDefinition,d=(e.widget,e.widgetDefinition),f=e.widgetValueLabel,p=e.valueLabels,g=e.textSeparators,v=e.setValueHandler,h=e.config,m=e.field,y=e.operator,b=e.readonly,E=e.parentField,O=e.parentFuncs,S=e.id,_=e.groupId,w=d.factory,T=(0,o.default)(d,a),P=r&&c.valueSources&&1==c.valueSources.length&&"const"==c.valueSources[0],C=c.defaultValue;if(!w)return"?";var I=s?[n.get(0),n.get(1)]:n?n.get(t):void 0,A=l&&(s?[l.get(0),l.get(1)]:l.get(t))||null;s&&void 0===I[0]&&void 0===I[1]&&(I=void 0);var R=(c||{}).fieldSettings,x=Object.assign({},T,R,{config:h,field:m,parentField:E,parentFuncs:O,fieldDefinition:c,operator:y,delta:t,isSpecialRange:s,isFuncArg:r,value:I,valueError:A,label:f.label,placeholder:f.placeholder,placeholders:p?p.placeholder:null,textSeparators:g,setValue:v,readonly:b,asyncListValues:u,id:S,groupId:_});return P&&C?"boolean"==typeof C?C?x.labelYes||"YES":x.labelNo||"NO":R.listValues?Array.isArray(C)?C.map((function(e){return(0,i.getTitleInListValues)(R.listValues,e)||e})).join(", "):(0,i.getTitleInListValues)(R.listValues,C)||C:""+C:w(x)}},35939:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.dummyFn=t.DragIcon=t.ConfirmFn=t.Col=void 0;var o=n(r(78304)),i=n(r(40453)),a=n(r(85959)),l=["children"];t.Col=function(e){var t=e.children,r=(0,i.default)(e,l);return a.default.createElement("div",r,t)},t.dummyFn=function(){},t.DragIcon=function(){return a.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",width:"18px",height:"18px"},a.default.createElement("path",{d:"M0 0h24v24H0V0z",fill:"none"}),a.default.createElement("path",{d:"M3 18h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z"}))},t.ConfirmFn=function(e){return function(t){var r=t.config.settings.useConfirm,n=r?r():null;return a.default.createElement(e,(0,o.default)({},t,{confirmFn:n}))}}},64072:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0});var o={ValueFieldWidget:!0,FuncWidget:!0};Object.defineProperty(t,"FuncWidget",{enumerable:!0,get:function(){return a.default}}),Object.defineProperty(t,"ValueFieldWidget",{enumerable:!0,get:function(){return i.default}});var i=n(r(83914)),a=n(r(68139)),l=r(79176);Object.keys(l).forEach((function(e){"default"!==e&&"__esModule"!==e&&(Object.prototype.hasOwnProperty.call(o,e)||e in t&&t[e]===l[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return l[e]}}))}))},23133:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(85959));t.default=function(e){var t=e.type,r=e.label,n=e.onClick,i=e.readonly,a=(e.config,r||{addRuleGroup:"+",addRuleGroupExt:"+",delGroup:"x",delRuleGroup:"x",delRule:"x"}[t]);return o.default.createElement("button",{onClick:n,type:"button",disabled:i},a)}},88414:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(85959));t.default=function(e){var t=e.children;return e.config,o.default.createElement(o.default.Fragment,null,t)}},40862:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(85959));t.default=function(e){var t,r=e.id,n=e.not,i=e.setNot,a=e.conjunctionOptions,l=e.setConjunction,u=e.disabled,s=e.readonly,c=e.config,d=e.showNot,f=e.notLabel,p=Object.keys(a).length,g=u,v=c.settings.forceShowConj||p>1&&!g,h=function(e){return l(e.target.value)};return[d&&(t="not",[o.default.createElement("input",{key:r+t,type:"checkbox",id:r+t,checked:n,disabled:s,onChange:function(e){return i(e.target.checked)}}),o.default.createElement("label",{key:r+t+"label",htmlFor:r+t},f||"NOT")]),v&&Object.keys(a).map((function(e){var t=a[e],r=t.id,n=t.name,i=t.label,c=t.checked,d=l.isDummyFn?"__dummy":"";return!s&&!u||c?[o.default.createElement("input",{key:r+d,type:"radio",id:r+d,name:n+d,checked:c,disabled:s||u,value:e,onChange:h}),o.default.createElement("label",{key:r+d+"label",htmlFor:r+d},i)]:null}))]}},61609:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(85959));t.default=function(e){var t=e.items,r=e.setField,n=e.selectedKey,i=e.readonly,a=null!=n;return o.default.createElement("select",{onChange:function(e){return r(e.target.value)},value:a?n:"",disabled:i},!a&&o.default.createElement("option",{disabled:!0,value:""}),function e(t){return t.map((function(t){var r=t.items,n=t.path,i=t.label,a=t.disabled;return r?o.default.createElement("optgroup",{disabled:a,key:n,label:i},e(r)):o.default.createElement("option",{disabled:a,key:n,value:n},i)}))}(t))}},85861:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(85959));t.default=function(e){var t=e.value,r=e.setValue,n=e.label,i=e.id,a=(e.config,e.type);return[o.default.createElement("input",{key:i+a,type:"checkbox",id:i+a,checked:!!t,onChange:function(e){return r(e.target.checked)}}),o.default.createElement("label",{key:i+a+"label",htmlFor:i+a},n)]}},73780:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(18821)),i=n(r(85959));t.default=function(e){e.config;var t=e.valueSources,r=e.valueSrc,n=(e.title,e.setValueSrc),a=e.readonly;return i.default.createElement("select",{onChange:function(e){return n(e.target.value)},value:r,disabled:a},function(e){return e.map((function(e){var t=(0,o.default)(e,2),r=t[0],n=t[1];return i.default.createElement("option",{key:r,value:r},n.label)}))}(t))}},28157:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,t.default=function(e){var t=e.onOk,r=(e.okText,e.cancelText,e.title);confirm(r)&&t()}},79176:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),Object.defineProperty(t,"VanillaBooleanWidget",{enumerable:!0,get:function(){return o.default}}),Object.defineProperty(t,"VanillaButton",{enumerable:!0,get:function(){return h.default}}),Object.defineProperty(t,"VanillaButtonGroup",{enumerable:!0,get:function(){return m.default}}),Object.defineProperty(t,"VanillaConjs",{enumerable:!0,get:function(){return v.default}}),Object.defineProperty(t,"VanillaDateTimeWidget",{enumerable:!0,get:function(){return s.default}}),Object.defineProperty(t,"VanillaDateWidget",{enumerable:!0,get:function(){return l.default}}),Object.defineProperty(t,"VanillaFieldSelect",{enumerable:!0,get:function(){return g.default}}),Object.defineProperty(t,"VanillaMultiSelectWidget",{enumerable:!0,get:function(){return c.default}}),Object.defineProperty(t,"VanillaNumberWidget",{enumerable:!0,get:function(){return f.default}}),t.VanillaProvider=void 0,Object.defineProperty(t,"VanillaSelectWidget",{enumerable:!0,get:function(){return d.default}}),Object.defineProperty(t,"VanillaSliderWidget",{enumerable:!0,get:function(){return p.default}}),Object.defineProperty(t,"VanillaSwitch",{enumerable:!0,get:function(){return b.default}}),Object.defineProperty(t,"VanillaTextAreaWidget",{enumerable:!0,get:function(){return a.default}}),Object.defineProperty(t,"VanillaTextWidget",{enumerable:!0,get:function(){return i.default}}),Object.defineProperty(t,"VanillaTimeWidget",{enumerable:!0,get:function(){return u.default}}),Object.defineProperty(t,"VanillaValueSources",{enumerable:!0,get:function(){return y.default}}),Object.defineProperty(t,"vanillaConfirm",{enumerable:!0,get:function(){return E.default}}),n(r(85959));var o=n(r(58377)),i=n(r(71726)),a=n(r(731)),l=n(r(65949)),u=n(r(40676)),s=n(r(98875)),c=n(r(11956)),d=n(r(13353)),f=n(r(65560)),p=n(r(7784)),g=n(r(61609)),v=n(r(40862)),h=n(r(23133)),m=n(r(88414)),y=n(r(73780)),b=n(r(85861)),E=n(r(28157));t.VanillaProvider=function(e){return e.config,e.children}},58377:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959)),a=n(r(58048));t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.labelYes),l=e.labelNo,u=e.readonly,s=e.customProps,c=void 0===s?{}:s,d=c.radioYes||{},f=c.radioNo||{},p=function(e){return r("true"==e.target.value)},g=(0,a.default)(),v=(0,a.default)();return i.default.createElement(i.default.Fragment,null,i.default.createElement("input",(0,o.default)({key:g,type:"radio",id:g,value:!0,checked:!!t,disabled:u,onChange:p},d)),i.default.createElement("label",{style:{display:"inline"},key:g+"label",htmlFor:g},n),i.default.createElement("input",(0,o.default)({key:v,type:"radio",id:v,value:!1,checked:!t,disabled:u,onChange:p},f)),i.default.createElement("label",{style:{display:"inline"},key:v+"label",htmlFor:v},l))}},65949:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959));n(r(92468)),t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.readonly),a=e.customProps;return i.default.createElement("input",(0,o.default)({type:"date",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},a))}},98875:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959)),a=n(r(92468));t.default=function(e){var t,r=e.value,n=e.setValue,l=(e.config,e.valueFormat),u=(e.use12Hours,e.readonly),s=e.customProps;return t=r?(0,a.default)(r).format("YYYY-MM-DDTHH:mm"):"",i.default.createElement("input",(0,o.default)({type:"datetime-local",value:t,disabled:u,onChange:function(e){var t=e.target.value;t=""==t?void 0:(0,a.default)(new Date(t)).format(l),n(t)}},s))}},11956:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959)),a=r(98477),l=n(r(24319));t.default=function(e){var t=e.listValues,r=e.value,n=e.setValue,u=(e.allowCustomValues,e.readonly),s=e.customProps;return i.default.createElement("select",(0,o.default)({multiple:!0,onChange:function(e){return n(function(e){for(var t=[],r=e.options,n=0;n<r.length;n++){var o=r[n];o.selected&&t.push(o.value)}return t.length||(t=void 0),t}(e.target))},value:r,disabled:u},(0,l.default)(s,["showSearch","input","showCheckboxes"])),(0,a.mapListValues)(t,(function(e){var t=e.title,r=e.value;return i.default.createElement("option",{key:r,value:r},t)})))}},65560:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959));t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),a=e.min,l=e.max,u=e.step,s=e.placeholder,c=e.customProps,d=null==t?"":t;return i.default.createElement("input",(0,o.default)({type:"number",value:d,placeholder:s,disabled:n,min:a,max:l,step:u,onChange:function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)}},c))}},13353:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959)),a=r(98477),l=n(r(24319));t.default=function(e){var t=e.listValues,r=e.value,n=e.setValue,u=(e.allowCustomValues,e.readonly),s=e.customProps,c=null!=r;return i.default.createElement("select",(0,o.default)({onChange:function(e){return n(e.target.value)},value:c?r:"",disabled:u},(0,l.default)(s,["showSearch","input"])),!c&&i.default.createElement("option",{disabled:!0,value:""}),(0,a.mapListValues)(t,(function(e){var t=e.title,r=e.value;return i.default.createElement("option",{key:r,value:r},t)})))}},7784:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959));t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),a=e.min,l=e.max,u=e.step,s=e.placeholder,c=e.customProps,d=void 0===c?{}:c,f=d.input||{},p=d.slider||d,g=function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)},v=null==t?"":t;return[i.default.createElement("input",(0,o.default)({key:"number",type:"number",value:v,placeholder:s,disabled:n,min:a,max:l,step:u,onChange:g},f)),i.default.createElement("input",(0,o.default)({key:"range",type:"range",value:v,disabled:n,min:a,max:l,step:u,onChange:g},p))]}},71726:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959));t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),a=e.placeholder,l=e.maxLength,u=e.customProps,s=t||"";return i.default.createElement("input",(0,o.default)({type:"text",value:s,placeholder:a,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:l},u))}},731:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959));t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),a=e.placeholder,l=e.maxLength,u=(e.maxRows,e.fullWidth),s=e.customProps,c=t||"";return i.default.createElement("textarea",(0,o.default)({value:c,placeholder:a,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:l,style:{width:u?"100%":void 0}},s))}},40676:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(78304)),i=n(r(85959));t.default=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.use12Hours,e.readonly),a=e.customProps;return i.default.createElement("input",(0,o.default)({type:"time",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},a))}},26314:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.stringifyForDisplay=t.mongoFormatOp2=t.mongoFormatOp1=t.default=void 0;var i=n(r(85707)),a=n(r(85959)),l=g(r(64072)),u=g(r(91680)),s=r(22777),c=r(98477),d=n(r(92468)),f=r(74837);function p(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(p=function(e){return e?r:t})(e)}function g(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=p(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}function v(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function h(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?v(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):v(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var m=l.VanillaBooleanWidget,y=l.VanillaTextWidget,b=l.VanillaTextAreaWidget,E=l.VanillaDateWidget,O=l.VanillaTimeWidget,S=l.VanillaDateTimeWidget,_=l.VanillaMultiSelectWidget,w=l.VanillaSelectWidget,T=l.VanillaNumberWidget,P=l.VanillaSliderWidget,C=l.ValueFieldWidget,I=l.FuncWidget,A=u.ProximityOperator,R=function(e,t,r,n,o,a,l,u,s,c,d,f){var p="string"!=typeof n||n.startsWith("$")?n:"$"+n,g=t(a,f);if(void 0!==g)return r?l||e&&"$eq"!=e?l?{$not:(0,i.default)({},e,[p,g])}:(0,i.default)({},n,{$not:(0,i.default)({},e,g)}):(0,i.default)({},n,{$ne:g}):l||e&&"$eq"!=e?l?(0,i.default)({},e,[p,g]):(0,i.default)({},n,(0,i.default)({},e,g)):(0,i.default)({},n,g)};t.mongoFormatOp1=R;var x=function(e,t,r,n,o,a,l,u,s,c,d){var f,p,g="string"!=typeof r||r.startsWith("$")?r:"$"+r;return t?a?{$not:{$and:[(0,i.default)({},e[0],[g,o[0]]),(0,i.default)({},e[1],[g,o[1]])]}}:(0,i.default)({},r,{$not:(f={},(0,i.default)(f,e[0],o[0]),(0,i.default)(f,e[1],o[1]),f)}):a?{$and:[(0,i.default)({},e[0],[g,o[0]]),(0,i.default)({},e[1],[g,o[1]])]}:(0,i.default)({},r,(p={},(0,i.default)(p,e[0],o[0]),(0,i.default)(p,e[1],o[1]),p))};t.mongoFormatOp2=x;var N={equal:{label:"==",labelForFormat:"==",sqlOp:"=",spelOp:"==",spelOps:["==","eq"],reversedOp:"not_equal",formatOp:function(e,t,r,n,o,i,a,l,u){var s=l?"=":i.label;return"boolean"==o&&l?"No"==r?"NOT ".concat(e):"".concat(e):"".concat(e," ").concat(s," ").concat(r)},mongoFormatOp:R.bind(null,"$eq",(function(e){return e}),!1),jsonLogic:"==",elasticSearchQueryType:"term"},not_equal:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",spelOp:"!=",spelOps:["!=","ne"],reversedOp:"equal",formatOp:function(e,t,r,n,o,i,a,l,u){return"boolean"==o&&l?"No"==r?"".concat(e):"NOT ".concat(e):"".concat(e," ").concat(i.label," ").concat(r)},mongoFormatOp:R.bind(null,"$ne",(function(e){return e}),!1),jsonLogic:"!="},less:{label:"<",labelForFormat:"<",sqlOp:"<",spelOp:"<",spelOps:["<","lt"],reversedOp:"greater_or_equal",mongoFormatOp:R.bind(null,"$lt",(function(e){return e}),!1),jsonLogic:"<",elasticSearchQueryType:"range"},less_or_equal:{label:"<=",labelForFormat:"<=",sqlOp:"<=",spelOp:"<=",spelOps:["<=","le"],reversedOp:"greater",mongoFormatOp:R.bind(null,"$lte",(function(e){return e}),!1),jsonLogic:"<=",elasticSearchQueryType:"range"},greater:{label:">",labelForFormat:">",sqlOp:">",spelOp:">",spelOps:[">","gt"],reversedOp:"less_or_equal",mongoFormatOp:R.bind(null,"$gt",(function(e){return e}),!1),jsonLogic:">",elasticSearchQueryType:"range"},greater_or_equal:{label:">=",labelForFormat:">=",sqlOp:">=",spelOp:">=",spelOps:[">=","ge"],reversedOp:"less",mongoFormatOp:R.bind(null,"$gte",(function(e){return e}),!1),jsonLogic:">=",elasticSearchQueryType:"range"},like:{label:"Contains",labelForFormat:"Contains",reversedOp:"not_like",sqlOp:"LIKE",spelOp:".contains",spelOps:["matches",".contains"],mongoFormatOp:R.bind(null,"$regex",(function(e){return"string"==typeof e?(0,c.escapeRegExp)(e):void 0}),!1),jsonLogic:"in",_jsonLogicIsRevArgs:!0,valueSources:["value"],elasticSearchQueryType:"regexp"},not_like:{isNotOp:!0,label:"Not contains",reversedOp:"like",labelForFormat:"Not Contains",sqlOp:"NOT LIKE",mongoFormatOp:R.bind(null,"$regex",(function(e){return"string"==typeof e?(0,c.escapeRegExp)(e):void 0}),!0),valueSources:["value"]},starts_with:{label:"Starts with",labelForFormat:"Starts with",sqlOp:"LIKE",spelOp:".startsWith",spelOps:["matches",".startsWith"],mongoFormatOp:R.bind(null,"$regex",(function(e){return"string"==typeof e?"^"+(0,c.escapeRegExp)(e):void 0}),!1),jsonLogic:void 0,valueSources:["value"]},ends_with:{label:"Ends with",labelForFormat:"Ends with",sqlOp:"LIKE",spelOp:".endsWith",spelOps:["matches",".endsWith"],mongoFormatOp:R.bind(null,"$regex",(function(e){return"string"==typeof e?(0,c.escapeRegExp)(e)+"$":void 0}),!1),jsonLogic:void 0,valueSources:["value"]},between:{label:"Between",labelForFormat:"BETWEEN",sqlOp:"BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,l){var u=r.first(),s=r.get(1);return l?"".concat(e," BETWEEN ").concat(u," AND ").concat(s):"".concat(e," >= ").concat(u," && ").concat(e," <= ").concat(s)},spelFormatOp:function(e,t,r,n,o,i,a,l){var u=r[0],s=r[1];return"".concat(e," >= ").concat(u," && ").concat(e," <= ").concat(s)},mongoFormatOp:x.bind(null,["$gte","$lte"],!1),valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"not_between",jsonLogic:"<=",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]?null:"Invalid range":null},elasticSearchQueryType:function(e){return"time"===e?"filter":"range"}},not_between:{isNotOp:!0,label:"Not between",labelForFormat:"NOT BETWEEN",sqlOp:"NOT BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,l){var u=r.first(),s=r.get(1);return l?"".concat(e," NOT BETWEEN ").concat(u," AND ").concat(s):"(".concat(e," < ").concat(u," || ").concat(e," > ").concat(s,")")},spelFormatOp:function(e,t,r,n,o,i,a,l){var u=r[0],s=r[1];return"(".concat(e," < ").concat(u," || ").concat(e," > ").concat(s,")")},mongoFormatOp:x.bind(null,["$gte","$lte"],!0),valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"between",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]?null:"Invalid range":null}},is_empty:{label:"Is empty",labelForFormat:"IS EMPTY",cardinality:0,reversedOp:"is_not_empty",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS EMPTY"):"!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var u=(0,s.sqlEmptyValue)(l);return"COALESCE(".concat(e,", ").concat(u,") = ").concat(u)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," <= ''")},mongoFormatOp:R.bind(null,"$in",(function(e,t){return[(0,s.mongoEmptyValue)(t),null]}),!1),jsonLogic:"!"},is_not_empty:{isNotOp:!0,label:"Is not empty",labelForFormat:"IS NOT EMPTY",cardinality:0,reversedOp:"is_empty",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS NOT EMPTY"):"!!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var u=(0,s.sqlEmptyValue)(l);return"COALESCE(".concat(e,", ").concat(u,") <> ").concat(u)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," > ''")},mongoFormatOp:R.bind(null,"$nin",(function(e,t){return[(0,s.mongoEmptyValue)(t),null]}),!1),jsonLogic:"!!",elasticSearchQueryType:"exists"},is_null:{label:"Is null",labelForFormat:"IS NULL",sqlOp:"IS NULL",cardinality:0,reversedOp:"is_not_null",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS NULL"):"!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," == null")},mongoFormatOp:R.bind(null,"$eq",(function(e){return null}),!1),jsonLogic:"=="},is_not_null:{label:"Is not null",labelForFormat:"IS NOT NULL",sqlOp:"IS NOT NULL",cardinality:0,reversedOp:"is_null",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS NOT NULL"):"!!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," != null")},mongoFormatOp:R.bind(null,"$ne",(function(e){return null}),!1),jsonLogic:"!=",elasticSearchQueryType:"exists"},select_equals:{label:"==",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,l){var u=l?"=":"==";return"".concat(e," ").concat(u," ").concat(r)},spelOp:"==",spelOps:["==","eq"],mongoFormatOp:R.bind(null,"$eq",(function(e){return e}),!1),reversedOp:"select_not_equals",jsonLogic:"==",elasticSearchQueryType:"term"},select_not_equals:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," != ").concat(r)},spelOp:"!=",spelOps:["!=","ne"],mongoFormatOp:R.bind(null,"$ne",(function(e){return e}),!1),reversedOp:"select_equals",jsonLogic:"!="},select_any_in:{label:"Any in",labelForFormat:"IN",sqlOp:"IN",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):"".concat(e," IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):void 0},spelOp:"$contains",mongoFormatOp:R.bind(null,"$in",(function(e){return e}),!1),reversedOp:"select_not_any_in",jsonLogic:"in",elasticSearchQueryType:"term"},select_not_any_in:{isNotOp:!0,label:"Not in",labelForFormat:"NOT IN",sqlOp:"NOT IN",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):"".concat(e," NOT IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):void 0},mongoFormatOp:R.bind(null,"$nin",(function(e){return e}),!1),reversedOp:"select_any_in"},multiselect_contains:{label:"Contains",labelForFormat:"CONTAINS",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," CONTAINS [").concat(r.join(", "),"]"):"".concat(e," CONTAINS ").concat(r)},reversedOp:"multiselect_not_contains",jsonLogic2:"some-in",jsonLogic:function(e,t,r){return{some:[e,{in:[{var:""},r]}]}},spelOp:"CollectionUtils.containsAny()",elasticSearchQueryType:"term",mongoFormatOp:R.bind(null,"$in",(function(e){return e}),!1)},multiselect_not_contains:{isNotOp:!0,label:"Not contains",labelForFormat:"NOT CONTAINS",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," NOT CONTAINS [").concat(r.join(", "),"]"):"".concat(e," NOT CONTAINS ").concat(r)},reversedOp:"multiselect_contains"},multiselect_equals:{label:"Equals",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,l){var u=l?"=":"==";return"value"==n?"".concat(e," ").concat(u," [").concat(r.join(", "),"]"):"".concat(e," ").concat(u," ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," = '").concat(r.map((function(e){return s.SqlString.trim(e)})).join(","),"'"):void 0},spelOp:".equals",mongoFormatOp:R.bind(null,"$eq",(function(e){return e}),!1),reversedOp:"multiselect_not_equals",jsonLogic2:"all-in",jsonLogic:function(e,t,r){return{all:[e,{in:[{var:""},r]}]}},elasticSearchQueryType:"term"},multiselect_not_equals:{isNotOp:!0,label:"Not equals",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," != [").concat(r.join(", "),"]"):"".concat(e," != ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," != '").concat(r.map((function(e){return s.SqlString.trim(e)})).join(","),"'"):void 0},mongoFormatOp:R.bind(null,"$ne",(function(e){return e}),!1),reversedOp:"multiselect_equals"},proximity:{label:"Proximity search",cardinality:2,valueLabels:[{label:"Word 1",placeholder:"Enter first word"},{label:"Word 2",placeholder:"Enter second word"}],textSeparators:[],formatOp:function(e,t,r,n,o,i,a,l){var u=r.first(),s=r.get(1),c=a.get("proximity");return"".concat(e," ").concat(u," NEAR/").concat(c," ").concat(s)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var u=r.first(),c=r.get(1),d=s.SqlString.trim(u),f=s.SqlString.trim(c),p=a.get("proximity");return"CONTAINS(".concat(e,", 'NEAR((").concat(d,", ").concat(f,"), ").concat(p,")')")},mongoFormatOp:void 0,jsonLogic:void 0,options:{optionLabel:"Near",optionTextBefore:"Near",optionPlaceholder:"Select words between",factory:function(e){return a.default.createElement(A,e)},minProximity:2,maxProximity:10,defaults:{proximity:2}}},some:{label:"Some",labelForFormat:"SOME",cardinality:0,jsonLogic:"some",spelFormatOp:function(e){return"".concat(e," > 0")},mongoFormatOp:R.bind(null,"$gt",(function(e){return 0}),!1)},all:{label:"All",labelForFormat:"ALL",cardinality:0,jsonLogic:"all",spelFormatOp:function(e,t,r){return"".concat(e," == ").concat(r)},mongoFormatOp:R.bind(null,"$eq",(function(e){return e}),!1)},none:{label:"None",labelForFormat:"NONE",cardinality:0,jsonLogic:"none",spelFormatOp:function(e){return"".concat(e," == 0")},mongoFormatOp:R.bind(null,"$eq",(function(e){return 0}),!1)}},D=function(e){return null==e?"NULL":e.toString()};t.stringifyForDisplay=D;var L={conjunctions:{AND:{label:"And",mongoConj:"$and",jsonLogicConj:"and",sqlConj:"AND",spelConj:"and",spelConjs:["and","&&"],reversedConj:"OR",formatConj:function(e,t,r,n){return e.size>1?(r?"NOT ":"")+"("+e.join(" "+(n?"AND":"&&")+" ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},sqlFormatConj:function(e,t,r){return e.size>1?(r?"NOT ":"")+"("+e.join(" AND ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},spelFormatConj:function(e,t,r,n){return r&&(n=!1),e.size>1?(r?"!":"")+(n?"":"(")+e.join(" && ")+(n?"":")"):(r?"!(":"")+e.first()+(r?")":"")}},OR:{label:"Or",mongoConj:"$or",jsonLogicConj:"or",sqlConj:"OR",spelConj:"or",spelConjs:["or","||"],reversedConj:"AND",formatConj:function(e,t,r,n){return e.size>1?(r?"NOT ":"")+"("+e.join(" "+(n?"OR":"||")+" ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},sqlFormatConj:function(e,t,r){return e.size>1?(r?"NOT ":"")+"("+e.join(" OR ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},spelFormatConj:function(e,t,r,n){return r&&(n=!1),e.size>1?(r?"!":"")+(n?"":"(")+e.join(" || ")+(n?"":")"):(r?"!(":"")+e.first()+(r?")":"")}}},operators:N,widgets:{text:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"String",valuePlaceholder:"Enter string",factory:function(e){return a.default.createElement(y,e)},formatValue:function(e,t,r,n){return n?D(e):JSON.stringify(e)},spelFormatValue:function(e,t,r,n,o){var i;return"matches"==o.spelOp&&"regex"!=n?(i="starts_with"==n?"(?s)^".concat((0,c.escapeRegExp)(e),".*"):"(?s).*".concat((0,c.escapeRegExp)(e),"ends_with"==n?"$":".*"),(0,s.spelEscape)(i)):(0,s.spelEscape)(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?s.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):s.SqlString.escape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},textarea:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"Text",valuePlaceholder:"Enter text",factory:function(e){return a.default.createElement(b,e)},formatValue:function(e,t,r,n){return n?D(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?s.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):s.SqlString.escape(e)},spelFormatValue:function(e){return(0,s.spelEscape)(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e},fullWidth:!0},number:{type:"number",jsType:"number",valueSrc:"value",factory:function(e){return a.default.createElement(T,e)},valueLabel:"Number",valuePlaceholder:"Enter number",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?D(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return s.SqlString.escape(e)},spelFormatValue:function(e,t,r){var n=r.step&&!Number.isInteger(r.step);return(0,s.spelEscape)(e,n)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},slider:{type:"number",jsType:"number",valueSrc:"value",factory:function(e){return a.default.createElement(P,e)},valueLabel:"Number",valuePlaceholder:"Enter number or move slider",formatValue:function(e,t,r,n){return n?D(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return s.SqlString.escape(e)},spelFormatValue:function(e){return(0,s.spelEscape)(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},select:{type:"select",jsType:"string",valueSrc:"value",factory:function(e){return a.default.createElement(w,e)},valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=(0,c.getTitleInListValues)(t.fieldSettings.listValues||t.asyncListValues,e);return n?D(o):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return s.SqlString.escape(e)},spelFormatValue:function(e){return(0,s.spelEscape)(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},multiselect:{type:"multiselect",jsType:"array",valueSrc:"value",factory:function(e){return a.default.createElement(_,e)},valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=e.map((function(e){return(0,c.getTitleInListValues)(t.fieldSettings.listValues||t.asyncListValues,e)}));return n?o.map(D):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){return e.map((function(e){return s.SqlString.escape(e)}))},spelFormatValue:function(e,t,r,n,o){var i=o.spelOp&&"$"==o.spelOp[0],a=(0,s.spelEscape)(e);return i&&(a=(0,s.spelFixList)(a)),a},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},date:{type:"date",jsType:"string",valueSrc:"value",factory:function(e){return a.default.createElement(E,e)},dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD",useKeyboard:!0,valueLabel:"Date",valuePlaceholder:"Enter date",valueLabels:[{label:"Date from",placeholder:"Enter date from"},{label:"Date to",placeholder:"Enter date to"}],formatValue:function(e,t,r,n){var o=(0,d.default)(e,r.valueFormat);return n?o.format(r.dateFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=(0,d.default)(e,r.valueFormat);return s.SqlString.escape(i.format("YYYY-MM-DD"))},spelFormatValue:function(e,t,r,n,o){var i=(0,d.default)(e,r.valueFormat);return"new java.text.SimpleDateFormat('yyyy-MM-dd').parse('".concat(i.format("YYYY-MM-DD"),"')")},jsonLogic:function(e,t,r){return(0,d.default)(e,r.valueFormat).toDate()},toJS:function(e,t){var r=(0,d.default)(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=(0,d.default)(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},time:{type:"time",jsType:"string",valueSrc:"value",factory:function(e){return a.default.createElement(O,e)},timeFormat:"HH:mm",valueFormat:"HH:mm:ss",use12Hours:!1,useKeyboard:!0,valueLabel:"Time",valuePlaceholder:"Enter time",valueLabels:[{label:"Time from",placeholder:"Enter time from"},{label:"Time to",placeholder:"Enter time to"}],formatValue:function(e,t,r,n){var o=(0,d.default)(e,r.valueFormat);return n?o.format(r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=(0,d.default)(e,r.valueFormat);return s.SqlString.escape(i.format("HH:mm:ss"))},spelFormatValue:function(e,t,r,n,o){var i=(0,d.default)(e,r.valueFormat);return"T(java.time.LocalTime).parse('".concat(i.format("HH:mm:ss"),"')")},jsonLogic:function(e,t,r){var n=(0,d.default)(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},toJS:function(e,t){var r=(0,d.default)(e,t.valueFormat);return r.isValid()?60*r.get("hour")*60+60*r.get("minute")+r.get("second"):void 0},mongoFormatValue:function(e,t,r){var n=(0,d.default)(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},elasticSearchFormatValue:function(e,t,r,n){return{script:{script:{source:"doc[".concat(n,"][0].getHour() >== params.min && doc[").concat(n,"][0].getHour() <== params.max"),params:{min:t[0],max:t[1]}}}}}},datetime:{type:"datetime",jsType:"string",valueSrc:"value",factory:function(e){return a.default.createElement(S,e)},timeFormat:"HH:mm",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD HH:mm:ss",use12Hours:!1,useKeyboard:!0,valueLabel:"Datetime",valuePlaceholder:"Enter datetime",valueLabels:[{label:"Datetime from",placeholder:"Enter datetime from"},{label:"Datetime to",placeholder:"Enter datetime to"}],formatValue:function(e,t,r,n){var o=(0,d.default)(e,r.valueFormat);return n?o.format(r.dateFormat+" "+r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=(0,d.default)(e,r.valueFormat);return s.SqlString.escape(i.toDate())},spelFormatValue:function(e,t,r,n,o){var i=(0,d.default)(e,r.valueFormat);return"new java.text.SimpleDateFormat('yyyy-MM-dd HH:mm:ss').parse('".concat(i.format("YYYY-MM-DD HH:mm:ss"),"')")},jsonLogic:function(e,t,r){return(0,d.default)(e,r.valueFormat).toDate()},toJS:function(e,t){var r=(0,d.default)(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=(0,d.default)(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},boolean:{type:"boolean",jsType:"boolean",valueSrc:"value",factory:function(e){return a.default.createElement(m,e)},labelYes:"Yes",labelNo:"No",formatValue:function(e,t,r,n){return n?e?"Yes":"No":JSON.stringify(!!e)},sqlFormatValue:function(e,t,r,n,o){return s.SqlString.escape(e)},spelFormatValue:function(e,t,r,n,o){return(0,s.spelEscape)(e)},defaultValue:!1,toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},field:{valueSrc:"field",factory:function(e){return a.default.createElement(C,e)},formatValue:function(e,t,r,n,o,i,a){return n&&a.label||e},sqlFormatValue:function(e,t,r,n,o,i){return e},spelFormatValue:function(e,t,r,n,o){return e},valueLabel:"Field to compare",valuePlaceholder:"Select field to compare",customProps:{showSearch:!0}},func:{valueSrc:"func",factory:function(e){return a.default.createElement(I,e)},valueLabel:"Function",valuePlaceholder:"Select function",customProps:{}},case_value:{valueSrc:"value",type:"case_value",spelFormatValue:function(e){return(0,s.spelEscape)(""===e?null:e)},spelImportValue:function(e){return[e.value,[]]},factory:function(e){var t=e.value,r=e.setValue;return a.default.createElement("input",{type:"text",value:t||"",onChange:function(e){return r(e.target.value)}})}}},types:{text:{defaultOperator:"equal",mainWidget:"text",widgets:{text:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","proximity","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},textarea:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},field:{operators:["equal","not_equal","proximity"]}}},number:{defaultOperator:"equal",mainWidget:"number",widgets:{number:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]},slider:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","is_null","is_not_null"]}}},date:{defaultOperator:"equal",widgets:{date:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},time:{defaultOperator:"equal",widgets:{time:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},datetime:{defaultOperator:"equal",widgets:{datetime:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},select:{mainWidget:"select",defaultOperator:"select_equals",widgets:{select:{operators:["select_equals","select_not_equals","is_null","is_not_null"],widgetProps:{customProps:{showSearch:!0}}},multiselect:{operators:["select_any_in","select_not_any_in","is_null","is_not_null"]}}},multiselect:{defaultOperator:"multiselect_equals",widgets:{multiselect:{operators:["multiselect_contains","multiselect_not_contains","multiselect_equals","multiselect_not_equals","is_null","is_not_null"]}}},boolean:{defaultOperator:"equal",widgets:{boolean:{operators:["equal","not_equal","is_null","is_not_null"],widgetProps:{}},field:{operators:["equal","not_equal"]}}},"!group":{defaultOperator:"some",mainWidget:"number",widgets:{number:{widgetProps:{min:0},operators:["some","all","none","equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between"],opProps:{equal:{label:"Count =="},not_equal:{label:"Count !="},less:{label:"Count <"},less_or_equal:{label:"Count <="},greater:{label:"Count >"},greater_or_equal:{label:"Count >="},between:{label:"Count between"},not_between:{label:"Count not between"}}}}},case_value:{mainWidget:"case_value",widgets:{case_value:{}}}},settings:h(h({},f.settings),{},{formatField:function(e,t,r,n,o,i){return i?r:e},formatSpelField:function(e,t,r,n,o,i){var a=n.map((function(e,t){var r=e.key,n=e.parent;return 0==t?"[map]"==n?"#this[".concat((0,s.spelEscape)(r),"]"):r:"map"==n||"[map]"==n?"[".concat((0,s.spelEscape)(r),"]"):".".concat(r)})).join("");return o.isSpelVariable&&(a="#"+a),a},sqlFormatReverse:function(e){if(null!=e)return"NOT("+e+")"},spelFormatReverse:function(e){if(null!=e)return"!("+e+")"},formatReverse:function(e,t,r,n,o,i){if(null!=e)return i?"NOT ("+e+")":"!("+e+")"},formatAggr:function(e,t,r,n,o,i,a,l,u,s){var c=a.labelForFormat,d=a.cardinality;if(0==d){var f=e?" HAVE ".concat(e):"";return"".concat(c," OF ").concat(t).concat(f)}if(null==d||1==d){var p=e?" WHERE ".concat(e):"";return"COUNT OF ".concat(t).concat(p," ").concat(c," ").concat(n)}if(2==d){var g=e?" WHERE ".concat(e):"",v=n.first(),h=n.get(1);return"COUNT OF ".concat(t).concat(g," ").concat(c," ").concat(v," AND ").concat(h)}},canCompareFieldWithField:function(e,t,r,n){return!0},valueSourcesInfo:{value:{label:"Value"},field:{label:"Field",widget:"field"},func:{label:"Function",widget:"func"}},customFieldSelectProps:{showSearch:!0},defaultSliderWidth:"200px",defaultSelectWidth:"200px",defaultSearchWidth:"100px",defaultMaxRows:5})};t.default=L},74837:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.settings=void 0;var i=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=l(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var u=i?Object.getOwnPropertyDescriptor(e,a):null;u&&(u.get||u.set)?Object.defineProperty(n,a,u):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(64072)),a=n(r(85959));function l(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(l=function(e){return e?r:t})(e)}var u=i.VanillaFieldSelect,s=i.VanillaConjs,c=i.VanillaButton,d=i.VanillaButtonGroup,f=i.VanillaProvider,p=i.VanillaValueSources,g=i.vanillaConfirm,v=i.VanillaSwitch,h={formatField:function(e,t,r,n,o,i){return i?r:e},renderField:function(e){return a.default.createElement(u,e)},renderOperator:function(e){return a.default.createElement(u,e)},renderFunc:function(e){return a.default.createElement(u,e)},renderConjs:function(e){return a.default.createElement(s,e)},renderSwitch:function(e){return a.default.createElement(v,e)},renderButton:function(e){return a.default.createElement(c,e)},renderButtonGroup:function(e){return a.default.createElement(d,e)},renderProvider:function(e){return a.default.createElement(f,e)},renderValueSources:function(e){return a.default.createElement(p,e)},renderConfirm:g,renderSwitchPrefix:function(){return a.default.createElement(a.default.Fragment,null,"Conditions")},valueSourcesInfo:{value:{}},fieldSeparator:".",fieldSeparatorDisplay:".",renderSize:"small",maxLabelsLength:100,canReorder:!0,canRegroup:!0,showLock:!1,canDeleteLocked:!1,showNot:!0,canLeaveEmptyGroup:!0,shouldCreateEmptyGroup:!1,forceShowConj:!1,canShortMongoQuery:!0,removeEmptyGroupsOnLoad:!0,removeIncompleteRulesOnLoad:!0,removeInvalidMultiSelectValuesOnLoad:!0,groupActionsPosition:"topRight",setOpOnChangeField:["keep","default"],groupOperators:["some","all","none"],convertableWidgets:{number:["slider","rangeslider"],slider:["number","rangeslider"],rangeslider:["number","slider"],text:["textarea"],textarea:["text"]},locale:{moment:"en"},valueLabel:"Value",valuePlaceholder:"Value",fieldLabel:"Field",operatorLabel:"Operator",funcLabel:"Function",fieldPlaceholder:"Select field",funcPlaceholder:"Select function",operatorPlaceholder:"Select operator",lockLabel:"Lock",lockedLabel:"Locked",deleteLabel:null,addGroupLabel:"Add group",addCaseLabel:"Add condition",addDefaultCaseLabel:"Add default condition",defaultCaseLabel:"Default:",addRuleLabel:"Add rule",addSubRuleLabel:"Add sub rule",delGroupLabel:"",notLabel:"Not",valueSourcesPopupTitle:"Select value source",removeRuleConfirmOptions:null,removeGroupConfirmOptions:null,defaultGroupConjunction:"AND",jsonLogic:{groupVarKey:"var",altVarKey:"var",lockedOp:"locked"}};t.settings=h},63279:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.UPPER=t.RELATIVE_DATETIME=t.NOW=t.LOWER=t.LINEAR_REGRESSION=void 0;var o=n(r(92468)),i={label:"Now",returnType:"datetime",jsonLogic:"now",jsonLogicCustomOps:{now:function(){return new Date}},spelFunc:"new java.util.Date()",sqlFormatFunc:function(){return"NOW()"},mongoFormatFunc:function(){return new Date},formatFunc:function(){return"NOW"}};t.NOW=i;var a={label:"Relative",returnType:"datetime",renderBrackets:["",""],renderSeps:["","",""],jsonLogic:function(e){var t=e.date,r=e.op;return{date_add:[t,e.val*("minus"==r?-1:1),e.dim]}},jsonLogicImport:function(e){var t=e.date_add[0],r=Math.abs(e.date_add[1]);return[t,e.date_add[1]>=0?"plus":"minus",r,e.date_add[2]]},jsonLogicCustomOps:{date_add:function(e,t,r){return(0,o.default)(e).add(t,r).toDate()}},sqlFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return"DATE_ADD(".concat(t,", INTERVAL ").concat(parseInt(n)*("minus"==r?-1:1)," ").concat(o.replace(/^'|'$/g,""),")")},mongoFormatFunc:null,formatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return n?"".concat(t," ").concat("minus"==r?"-":"+"," ").concat(n," ").concat(o):t},args:{date:{label:"Date",type:"datetime",defaultValue:{func:"NOW",args:[]},valueSources:["func","field"]},op:{label:"Op",type:"select",defaultValue:"plus",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{plus:"+",minus:"-"}}},val:{label:"Value",type:"number",fieldSettings:{min:0},defaultValue:0,valueSources:["value"]},dim:{label:"Dimension",type:"select",defaultValue:"day",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{day:"day",week:"week",month:"month",year:"year"}}}}};t.RELATIVE_DATETIME=a,t.LOWER={label:"Lowercase",mongoFunc:"$toLower",jsonLogic:"toLowerCase",spelFunc:".toLowerCase",jsonLogicCustomOps:{toLowerCase:function(e){return e.toLowerCase()}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field"]}}},t.UPPER={label:"Uppercase",mongoFunc:"$toUpper",jsonLogic:"toUpperCase",spelFunc:".toUpperCase",jsonLogicCustomOps:{toUpperCase:function(e){return e.toUpperCase()}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field"]}}},t.LINEAR_REGRESSION={label:"Linear regression",returnType:"number",formatFunc:function(e,t){var r=e.coef,n=e.bias,o=e.val;return"(".concat(r," * ").concat(o," + ").concat(n,")")},sqlFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},mongoFormatFunc:function(e){var t=e.coef,r=e.bias;return{$sum:[{$multiply:[t,e.val]},r]}},jsonLogic:function(e){var t=e.coef,r=e.bias;return{"+":[{"*":[t,e.val]},r]}},jsonLogicImport:function(e){return[e["+"][0]["*"][0],e["+"][0]["*"][1],e["+"][1]]},renderBrackets:["",""],renderSeps:[" * "," + "],args:{coef:{label:"Coef",type:"number",defaultValue:1,valueSources:["value"]},val:{label:"Value",type:"number",valueSources:["value","field"]},bias:{label:"Bias",type:"number",defaultValue:0,valueSources:["value"]}}}},55256:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SET_VALUE_SRC=t.SET_VALUE=t.SET_TREE=t.SET_OPERATOR_OPTION=t.SET_OPERATOR=t.SET_NOT=t.SET_LOCK=t.SET_FIELD=t.SET_DRAG_START=t.SET_DRAG_PROGRESS=t.SET_DRAG_END=t.SET_CONJUNCTION=t.REMOVE_RULE=t.REMOVE_GROUP=t.PLACEMENT_PREPEND=t.PLACEMENT_BEFORE=t.PLACEMENT_APPEND=t.PLACEMENT_AFTER=t.MOVE_ITEM=t.ADD_RULE=t.ADD_GROUP=t.ADD_CASE_GROUP=void 0,t.ADD_GROUP="ADD_GROUP",t.ADD_CASE_GROUP="ADD_CASE_GROUP",t.REMOVE_GROUP="REMOVE_GROUP",t.SET_CONJUNCTION="SET_CONJUNCTION",t.SET_NOT="SET_NOT",t.ADD_RULE="ADD_RULE",t.REMOVE_RULE="REMOVE_RULE",t.SET_FIELD="SET_FIELD",t.SET_OPERATOR="SET_OPERATOR",t.SET_VALUE="SET_VALUE",t.SET_VALUE_SRC="SET_VALUE_SRC",t.SET_OPERATOR_OPTION="SET_OPERATOR_OPTION",t.SET_LOCK="SET_LOCK",t.SET_TREE="SET_TREE",t.MOVE_ITEM="MOVE_ITEM",t.PLACEMENT_AFTER="after",t.PLACEMENT_BEFORE="before",t.PLACEMENT_APPEND="append",t.PLACEMENT_PREPEND="prepend",t.SET_DRAG_PROGRESS="SET_DRAG_PROGRESS",t.SET_DRAG_START="SET_DRAG_START",t.SET_DRAG_END="SET_DRAG_END"},30915:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.elasticSearchFormat=function e(t,r){if(t){var n=t.get("type"),i=t.get("properties")||new Map;if("rule"===n&&i.get("field")){var l,u,c=i.get("operator"),d=i.get("field"),f=i.get("value").toJS(),p=(null===(l=i.get("valueType"))||void 0===l||l.get(0),null===(u=i.get("valueSrc"))||void 0===u?void 0:u.get(0));if("func"===p)return;return f&&Array.isArray(f[0])?f[0].map((function(e){return s(d,[e],c,r,p)})):s(d,f,c,r,p)}if("group"===n||"rule_group"===n){var g=i.get("not"),v=i.get("conjunction");return v||(v=(0,a.defaultConjunction)(r)),function(e,t,r,n,i){if(e&&e.size){var a=e.valueSeq().toArray(),l=function(e,t){switch(e){case"AND":return t?"must_not":"must";case"OR":return t?"should_not":"should";case"NOT":return t?"must":"must_not";default:return}}(t,r),u=a.map((function(e){return n(e,i)})).filter((function(e){return void 0!==e}));if(u.length){var s=u.flat(1/0);return{bool:(0,o.default)({},l,s)}}}}(t.get("children1"),v,g,e,r)}}};var o=n(r(85707)),i=r(89112),a=r(18313);function l(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function u(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?l(Object(r),!0).forEach((function(t){(0,o.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):l(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function s(e,t,r,n,a){if(e&&r&&null!=t){var l=r,s=n.operators[l];if(s){var c=s.elasticSearchQueryType,d=!1;!c&&s.reversedOp&&(d=!0,l=s.reversedOp,c=(s=n.operators[l]).elasticSearchQueryType);var f=(0,i.getWidgetForFieldOp)(n,e,l,a),p=n.widgets[f];if(p){var g,v,h=p.elasticSearchFormatValue;if(g="function"==typeof c?c(f):c)return v="function"==typeof h?h(g,t,l,e,n):function(e,t,r,n,i){var a=n;switch(e){case"filter":return{script:i.operators[r].elasticSearchScript(n,t)};case"exists":return{field:n};case"match":return(0,o.default)({},a,t[0]);case"term":return(0,o.default)({},n,t[0]);case"geo_bounding_box":return(0,o.default)({},n,function(e){if(null==e)return null;var t=e.split(",").map(Number);return{top_left:{lat:t[0],lon:t[1]},bottom_right:{lat:t[2],lon:t[3]}}}(t[0]));case"range":return(0,o.default)({},n,function(e,t){if(e.length>1)return{gte:"".concat(e[0]),lte:"".concat(e[1])};var r=e[0];switch(t){case"on_date":case"not_on_date":case"equal":case"select_equals":case"not_equal":return{gte:"".concat(r,"||/d"),lte:"".concat(r,"||+1d")};case"less_or_equal":return{lte:"".concat(r)};case"greater_or_equal":return{gte:"".concat(r)};case"less":return{lt:"".concat(r)};case"greater":return{gt:"".concat(r)};default:return}}(t,r));case"wildcard":return(0,o.default)({},n,function(e){return{value:"*"+e+"*"}}(t[0]));case"regexp":return(0,o.default)({},n,function(e){return{value:e}}(t[0]));default:return}}(g,t,l,e,n),d?{bool:{must_not:(0,o.default)({},g,u({},v))}}:(0,o.default)({},g,u({},v))}}}}},13040:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(63509);Object.keys(n).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===n[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return n[e]}}))}));var o=r(18804);Object.keys(o).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===o[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return o[e]}}))}));var i=r(53890);Object.keys(i).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===i[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return i[e]}}))}));var a=r(82204);Object.keys(a).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===a[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return a[e]}}))}));var l=r(40844);Object.keys(l).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===l[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return l[e]}}))}));var u=r(93089);Object.keys(u).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===u[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return u[e]}}))}));var s=r(30915);Object.keys(s).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===s[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return s[e]}}))}))},18804:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.jsonLogicFormat=void 0;var o=n(r(10906)),i=n(r(85707)),a=r(98477),l=r(40112),u=r(89112),s=r(18313),c=r(63968),d=r(37512),f=n(r(24319)),p=n(r(67171));function g(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function v(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?g(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):g(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function h(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}t.jsonLogicFormat=function(e,t){var r,n={usedFields:[],errors:[]},o=m(e,t,n,!0),i=n.errors,a=n.usedFields,u=t.settings.fieldSeparator,s={},c=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return h(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?h(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(a);try{for(c.s();!(r=c.n()).done;)for(var d=r.value,f=((0,l.getFieldConfig)(t,d),d.split(u)),p=s,g=0;g<f.length;g++){var v=f[g],y=(0,l.getFieldConfig)(t,f.slice(0,g+1))||{};g!=f.length-1?"!group"==y.type&&"struct"!=y.mode?(p[v]||(p[v]=[{}]),p=p[v][0]):(p[v]||(p[v]={}),p=p[v]):p[v]||(p[v]=null)}}catch(e){c.e(e)}finally{c.f()}return{errors:i,logic:o,data:s}};var m=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(e){var a,l=e.get("type"),u=(e.get("properties")||new d.Map).get("isLocked"),s=t.settings.jsonLogic.lockedOp;return"group"===l||"rule_group"===l?a=y(e,t,r,n,o):"rule"===l&&(a=b(e,t,r,o)),u&&a&&s&&(a=(0,i.default)({},s,a)),a}},y=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=e.get("type"),u=e.get("properties")||new d.Map,c=u.get("mode"),f=e.get("children1"),p=u.get("field");if(f){var g=u.get("conjunction");g||(g=(0,s.defaultConjunction)(t));var v=t.conjunctions[g].jsonLogicConj||g.toLowerCase(),h=u.get("not");if("and"==v||"or"==v){var y="rule_group"===a&&!n,b=y&&"struct"!=c?p:o,O=u.get("operator"),S=O&&(0,l.getOperatorConfig)(t,O,p)||null,T=E(t,u,r,O,o),P=y&&(!O||0==S.cardinality),C=f.map((function(e){return m(e,t,r,!1,b)})).filter((function(e){return void 0!==e}));if(y&&"struct"!=c&&!P){if(null==T)return}else if(!C.size)return;var I={};if(1!=C.size||n?I[v]=C.toList().toJS():I=C.first(),h&&(I={"!":I}),y&&"struct"!=c){var A=_(r,t,p,o);if(P){var R=O||"some";I=(0,i.default)({},R,[A,I])}else{var x=C.size?{filter:[A,I]}:A;I=w(t,u,{reduce:[x,{"+":[1,{var:"accumulator"}]},0]},T,O)}}return I}r.errors.push("Conjunction ".concat(v," is not supported"))}},b=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("properties")||new d.Map,i=o.get("field"),a=o.get("operator"),u=o.get("operatorOptions");if((u=u?u.toJS():null)&&!Object.keys(u).length&&(u=null),null!=i&&null!=a){var s=(0,l.getFieldConfig)(t,i)||{},c=(0,l.getOperatorConfig)(t,a,i)||{},f=c.reversedOp,p=(0,l.getOperatorConfig)(t,f,i)||{},g=!1;if(c.jsonLogic||p.jsonLogic){if(!c.jsonLogic&&p.jsonLogic){g=!0;var v=[f,a];a=v[0],f=v[1];var h=[p,c];c=h[0],p=h[1]}var m=E(t,o,r,a,n);if(void 0!==m){var y=_(r,t,i,n);return w(t,o,y,m,a,u,s,g)}}else r.errors.push("Operator ".concat(a," is not supported"))}},E=function(e,t,r,n,o){var i=t.get("field"),s=t.get("valueSrc"),d=t.get("valueType"),p=(0,l.getFieldConfig)(e,i)||{},g=(0,l.getOperatorConfig)(e,n,i)||{},v=(0,a.defaultValue)(g.cardinality,1),h=t.get("value"),m=t.get("asyncListValues");if(null!=h){var y=[],b=[],E=r.usedFields,S=h.map((function(t,a){var v=s?s.get(a):null,h=d?d.get(a):null,E=(0,c.completeValue)(t,v,e),S=(0,u.getWidgetForFieldOp)(e,i,n,v),_=(0,f.default)((0,l.getFieldWidgetConfig)(e,i,n,S,v),["factory"]),w=O(r,e,E,v,h,_,p,n,g,o,m);return void 0!==w&&(y.push(v),b.push(h)),w})),_=S.filter((function(e){return void 0===e})).size>0;if(!(S.size<v||_))return v>1?S.toArray():1==v?S.first():null;r.usedFields=E}},O=function(e,t,r,n,o,i,a,l,u){var s=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"==n)d=_(e,t,r,s);else if("func"==n)d=S(e,t,r,s);else if("function"==typeof i.jsonLogic){var g=i.jsonLogic,h=[r,v(v({},(0,p.default)(a,["fieldSettings","listValues"])),{},{asyncListValues:c}),(0,f.default)(i,["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue"])];l&&(h.push(l),h.push(u)),d=g.apply(void 0,h)}else d=r;return d}},S=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=r.get("func"),a=r.get("args"),u=(0,l.getFuncConfig)(t,o);if(u.jsonLogic){var s={};for(var c in u.args){var d=u.args[c],f=(0,l.getFieldConfig)(t,d),p=a?a.get(c):void 0,g=p?p.get("value"):void 0,v=p?p.get("valueSrc"):void 0,h=O(e,t,g,v,d.type,f,d,null,null,n);if(null!=g&&void 0===h)return void e.errors.push("Can't format value of arg ".concat(c," for func ").concat(o));void 0!==h&&(s[c]=h)}var m,y=Object.values(s);if("function"==typeof u.jsonLogic){var b=[s];m=u.jsonLogic.apply(void 0,b)}else{var E=u.jsonLogic||o;if(u.jsonLogicIsMethod){var S=y[0],_=y.slice(1);m=_.length?{method:[S,E,_]}:{method:[S,E]}}else m=(0,i.default)({},E,y)}return m}e.errors.push("Func ".concat(o," is not supported"))},_=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=t.settings,u=a.fieldSeparator,s=a.jsonLogic;if(r){Array.isArray(r)&&(r=r.join(u));var c=(0,l.getFieldConfig)(t,r)||{},d=r;if(c.fieldName&&(d=c.fieldName),o){var f=(0,l.getFieldConfig)(t,o)||{},p=o;f.fieldName&&(p=f.fieldName),0==d.indexOf(p+u)?d=d.slice((p+u).length):e.errors.push("Can't cut group ".concat(p," from field ").concat(d))}var g=c.jsonLogicVar||("!group"==c.type?s.groupVarKey:"var");n=(0,i.default)({},g,d),-1==e.usedFields.indexOf(r)&&e.usedFields.push(r)}return n},w=function(e,t,r,n,u){var s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,d=arguments.length>7&&void 0!==arguments[7]&&arguments[7],p=t.get("field"),g=(0,l.getOperatorConfig)(e,u,p)||{},v="function"==typeof g.jsonLogic?g.jsonLogic:function(e,t,r,n){var l=e,u=(0,a.defaultValue)(t.cardinality,1),s=(0,a.defaultValue)(t._jsonLogicIsRevArgs,!1);"string"==typeof t.jsonLogic&&(l=t.jsonLogic);var c=["<","<=",">",">="],d=["==","!="];return function(e,t,a,f,p){return 0==u&&d.includes(l)?(0,i.default)({},l,[r,null]):0==u?(0,i.default)({},l,r):1==u&&s?(0,i.default)({},l,[n,r]):1==u?(0,i.default)({},l,[r,n]):2==u&&c.includes(l)?(0,i.default)({},l,[n[0],r,n[1]]):(0,i.default)({},l,[r].concat((0,o.default)(n)))}}(u,g,r,n),h=[r,u,n,(0,f.default)(g,["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"]),s,c],m=v.apply(void 0,h);return d&&(m={"!":m}),m}},53890:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.mongodbFormat=t._mongodbFormat=void 0;var o=n(r(18821)),i=n(r(85707)),a=n(r(10906)),l=n(r(10564)),u=r(98477),s=r(40112),c=r(89112),d=r(18313),f=r(63968),p=n(r(24319)),g=n(r(67171)),v=r(37512),h=r(74837);function m(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function y(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?m(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):m(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var b=function(e){return"object"==(0,l.default)(e)&&null!==e&&!Array.isArray(e)};t.mongodbFormat=function(e,t){return E(e,t,!1)};var E=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=O([],e,t,n);return r?[o,n.errors]:(n.errors.length&&console.warn("Errors while exporting to MongoDb:",n.errors),o)};t._mongodbFormat=E;var O=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0;if(t){var u=t.get("type");return"group"===u||"rule_group"===u?S(e,t,r,n,o,i,a,l):"rule"===u?_(e,t,r,n,o,i,a,l):void 0}},S=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],l=t.get("type"),u=t.get("properties")||new v.Map,c=t.get("children1"),f=r.settings.canShortMongoQuery;if(c){var p=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,g=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),h=p&&g,m="rule_group"===l?u.get("field"):null,y=T(m,r,n,h),E=((0,s.getFieldConfig)(r,m)||{}).mode,S=m&&"array"==E,_=o?!u.get("not"):u.get("not"),w=c.map((function(o){return O([].concat((0,a.default)(e),[t]),o,r,n,_,!0,"array"==E?function(e){return"$$el.".concat(e)}:void 0)})).filter((function(e){return void 0!==e}));if(S||w.size){var P=u.get("conjunction");P||(P=(0,d.defaultConjunction)(r));var C=r.conjunctions[P],I=C.reversedConj;_&&I&&(P=I,C=r.conjunctions[P]);var A,R=C.mongoConj;if(1==w.size)A=w.first();else if(w.size>1){var x=w.toList().toJS();f&&"$and"==R&&(A=x.reduce((function(e,t){if(e){for(var r in t){if("$"==r[0]){e=void 0;break}if(null==e[r])e[r]=t[r];else{var n=e[r],o=t[r];if(b(n)||(n={$eq:n}),b(o)||(o={$eq:o}),Object.keys(n)[0]==Object.keys(o)[0]){e=void 0;break}e[r]=Object.assign({},n,o)}}return e}}),{})),A||(A=(0,i.default)({},R,x))}if(m)if("array"==E){var N={$size:y},D=A?{$size:{$filter:{input:"$"+y,as:"el",cond:A}}}:N;A={$expr:A=O(e,t.set("type","rule"),r,n,!1,!1,(function(e){return D}),N)}}else A=(0,i.default)({},y,{$elemMatch:A});return A}}},_=function(e,t,r,n){var i=arguments.length>4&&void 0!==arguments[4]&&arguments[4],a=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,d=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0,g=t.get("properties")||new v.Map,h=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,m=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),y=h&&m,b=g.get("operator"),E=g.get("operatorOptions"),O=g.get("field"),S=g.get("value"),_=g.get("valueSrc"),P=g.get("valueType"),C=g.get("asyncListValues");if(null!=O&&null!=b&&void 0!==S){var I=(0,s.getFieldConfig)(r,O)||{},A=(0,s.getOperatorConfig)(r,b,O)||{},R=A.reversedOp,x=(0,s.getOperatorConfig)(r,R,O)||{},N=(0,u.defaultValue)(A.cardinality,1),D=i;if(D&&R){var L=[R,b];b=L[0],R=L[1];var j=[x,A];A=j[0],x=j[1],D=!1}var M=T(O,r,n,y),k=[],F=[],q=!1,V=S.map((function(e,t){var i=_?_.get(t):null,a=P?P.get(t):null,l=(0,f.completeValue)(e,i,r),u=(0,c.getWidgetForFieldOp)(r,O,b,i),d=(0,p.default)((0,s.getFieldWidgetConfig)(r,O,b,u,i),["factory"]),g=w(n,r,l,i,a,d,I,y,b,A,C),v=(0,o.default)(g,2),h=v[0],m=v[1];return void 0!==h&&(q=q||m,k.push(i),F.push(a)),h}));l&&(q=!0);var B=q&&a,U=V.filter((function(e){return void 0===e})).size>0;if(!(V.size<N||U)){var W=N>1?V.toArray():1==N?V.first():null,G=A.mongoFormatOp;if(G){var H=[l?l(M):M,b,void 0!==d&&null==W?d:W,q,k.length>1?k:k[0],F.length>1?F:F[0],(0,p.default)(A,["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"]),E,I],K=G.apply(void 0,H);return B&&(K={$expr:K}),D&&(K={$not:K}),K}n.errors.push("Operator ".concat(b," is not supported"))}}},w=function(e,t,r,n,i,a,l,u,s,c,d){if(void 0===r)return[void 0,!1];var f,v=!1;if("field"==n){var h=P(e,t,r,u),m=(0,o.default)(h,2);f=m[0],v=m[1]}else if("func"==n){var b=C(e,t,r,u),E=(0,o.default)(b,2);f=E[0],v=E[1]}else if("function"==typeof a.mongoFormatValue){var O=a.mongoFormatValue,S=[r,y(y({},(0,g.default)(l,["fieldSettings","listValues"])),{},{asyncListValues:d}),(0,p.default)(a,["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue"])];s&&(S.push(s),S.push(c)),f=O.apply(void 0,S)}else f=r;return[f,v]},T=function(e,t,r,n){if(e){var o=(0,s.getFieldConfig)(t,e)||{},i=t.settings.fieldSeparator,a=(Array.isArray(e)||e.split(i),Array.isArray(e)?e.join(i):e);if(o.fieldName&&(a=o.fieldName),n){var l=(0,s.getFieldConfig)(t,n)||{},u=n;l.fieldName&&(u=l.fieldName),0==a.indexOf(u+".")?a=a.slice((u+".").length):r.errors.push("Can't cut group ".concat(u," from field ").concat(a))}return a}},P=function(e,t,r,n){var o,i=t.settings.fieldSeparator;if(r){var a=(0,s.getFieldConfig)(t,r)||{},l=Array.isArray(r)?r:r.split(i),u=((0,c.getFieldPath)(r,t),(0,c.getFieldPathLabels)(r,t)),d=u?u.join(i):null;o="$"+(t.settings.formatField||h.settings.formatField)(T(r,t,e,n),l,d,a,t,!1)}return[o,!0]},C=function(e,t,r,n){var a,l=r.get("func"),u=r.get("args"),d=(0,s.getFuncConfig)(t,l),f=d.mongoFunc||l,g=d.mongoArgsAsObject,v={},h=0,m=void 0;for(var y in d.args){var b=d.args[y],E=(0,s.getFieldConfig)(t,b),O=u?u.get(y):void 0,S=O?O.get("value"):void 0,_=O?O.get("valueSrc"):void 0,T=O?O.get("asyncListValues"):void 0,P=(0,c.getWidgetForFieldOp)(t,E,null,_),C=(0,p.default)((0,s.getFieldWidgetConfig)(t,E,null,P,_),["factory"]),I=w(e,t,S,_,b.type,C,E,n,null,null,T),A=(0,o.default)(I,2),R=A[0];if(A[1],null!=S&&void 0===R)return e.errors.push("Can't format value of arg ".concat(y," for func ").concat(l)),[void 0,!1];h++,void 0!==R&&(v[y]=R,m=R)}if("function"==typeof d.mongoFormatFunc){var x=[v];a=d.mongoFormatFunc.apply(void 0,x)}else{if(null===d.mongoFormatFunc)return e.errors.push("Functon ".concat(f," is not supported")),[void 0,!1];a=g?(0,i.default)({},f,v):1==h&&void 0!==m?(0,i.default)({},f,m):(0,i.default)({},f,Object.values(v))}return[a,!0]}},63509:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.queryBuilderFormat=void 0;var o=n(r(85707)),i=r(98477),a=r(40112),l=r(18313),u=r(89112),s=(r(63968),r(37512));function c(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function d(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?c(Object(r),!0).forEach((function(t){(0,o.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):c(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}t.queryBuilderFormat=function(e,t){var r={usedFields:[]},n=f(e,t,r);if(n)return d(d({},n),r)};var f=function(e,t,r){if(e){var n=e.get("type"),o=e.get("children1");return("group"===n||"rule_group"===n)&&o&&o.size?p(e,t,r):"rule"===n?g(e,t,r):void 0}},p=function(e,t,r){var n=e.get("properties")||new s.Map,o=e.get("children1"),i=e.get("id"),a=o.map((function(e){return f(e,t,r)})).filter((function(e){return void 0!==e}));if(a.size){var u=n.get("conjunction");u||(u=(0,l.defaultConjunction)(t));var c=n.get("not");return{id:i,rules:a.toList(),condition:u.toUpperCase(),not:c}}},g=function(e,t,r){var n=e.get("properties")||new s.Map,o=e.get("id"),l=n.get("operator"),c=n.get("operatorOptions"),d=n.get("field"),f=n.get("value"),p=n.get("valueSrc"),g=n.get("valueType"),v=f.filter((function(e){return void 0===e})).size>0;if(null!=d&&null!=l&&!v){var h=(0,a.getFieldConfig)(t,d)||{},m=(0,a.getOperatorConfig)(t,l,d)||{},y=h.type||"undefined",b=(0,i.defaultValue)(m.cardinality,1),E=t.types[h.type]||{},O=(0,u.formatFieldName)(d,t,r);if(!(f.size<b)){-1==r.usedFields.indexOf(d)&&r.usedFields.push(d),f=f.toArray(),p=p.toArray(),g=g.toArray();for(var S=[],_=0;_<f.length;_++){var w={type:g[_],value:f[_]};if(S.push(w),"field"==p[_]){var T=f[_];-1==r.usedFields.indexOf(T)&&r.usedFields.push(T)}}var P=c?c.toJS():null;P&&!Object.keys(P).length&&(P=null);var C={id:o,fieldName:O,type:y,input:E.mainWidget,operator:l};return P&&(C.operatorOptions=P),C.values=S,C}}}},93089:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.queryString=void 0;var o=n(r(85707)),i=n(r(18821)),a=n(r(10906)),l=r(40112),u=r(89112),s=n(r(24319)),c=n(r(67171)),d=r(98477),f=r(18313),p=r(74837),g=r(63968),v=r(37512);function h(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function m(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?h(Object(r),!0).forEach((function(t){(0,o.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}t.queryString=function(e,t){var r={errors:[]},n=y(e,t,r,arguments.length>2&&void 0!==arguments[2]&&arguments[2],null);return r.errors.length&&console.warn("Errors while exporting to string:",r.errors),n};var y=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(e){var i=e.get("type");return e.get("children1"),"group"===i||"rule_group"===i?b(e,t,r,n,o):"rule"===i?E(e,t,r,n,o):void 0}},b=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,i=e.get("type"),l=e.get("properties")||new v.Map,u=l.get("mode"),s=e.get("children1");if(s){var c="rule_group"===i,d=c&&"array"==u?l.get("field"):null,p=c&&"array"==u,g=l.get("not"),h=s.map((function(e){return y(e,t,r,n,d)})).filter((function(e){return void 0!==e}));if(p||h.size){var m=l.get("conjunction");m||(m=(0,f.defaultConjunction)(t));var b,O=t.conjunctions[m],S=h.size?O.formatConj(h,m,g,n):null;if(d){var _=E(e,t,r,n,o,!0);if(_){var w,T=_.pop(),P=[S].concat((0,a.default)(_));b=(w=t.settings).formatAggr.apply(w,(0,a.default)(P)),T&&(b=t.settings.formatReverse(b,null,null,null,null,n))}}else b=S;return b}}},E=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]&&arguments[5],c=e.get("properties")||new v.Map,f=c.get("field"),p=c.get("operator"),h=c.get("operatorOptions");if(null!=f&&null!=p){var m=(0,l.getFieldConfig)(t,f)||{},y=(0,l.getOperatorConfig)(t,p,f)||{},b=y.reversedOp,E=(0,l.getOperatorConfig)(t,b,f)||{},_=!1,w=y.formatOp;if(!w&&b&&(w=E.formatOp)){_=!0;var T=[b,p];p=T[0],b=T[1];var P=[E,y];y=P[0],E=P[1]}if(w||(w=function(e,t){var r,n=t.labelForFormat||e,o=(0,d.defaultValue)(t.cardinality,1);return 0==o?r=function(e,t,r,o,i,a,l,u){return"".concat(e," ").concat(n)}:1==o?r=function(e,t,r,o,i,a,l,u){return"".concat(e," ").concat(n," ").concat(r)}:2==o&&(r=function(e,t,r,o,i,a,l,u){var s=r.first(),c=r.get(1);return"".concat(e," ").concat(n," ").concat(s," AND ").concat(c)}),r}(p,y)),w){var C=S(t,r,f,n,o),I=function(e,t,r,n,o,i){var a,c=t.get("field"),f=t.get("valueSrc"),p=t.get("valueType"),v=(0,l.getFieldConfig)(e,c)||{},h=n||t.get("operator"),m=(0,l.getOperatorConfig)(e,h,c)||{},y=(0,d.defaultValue)(m.cardinality,1),b=t.get("value"),E=t.get("asyncListValues"),S=[],_=[];if(null!=b){var w=b.map((function(t,n){var a=f?f.get(n):null,d=p?p.get(n):null,y=(0,g.completeValue)(t,a,e),b=(0,u.getWidgetForFieldOp)(e,c,h,a),w=(0,s.default)((0,l.getFieldWidgetConfig)(e,c,h,b,a),["factory"]),T=O(e,r,y,a,d,w,v,h,m,o,i,E);return void 0!==T&&(S.push(a),_.push(d)),T}));w.filter((function(e){return void 0===e})).size>0||w.size<y||(a=1==y?w.first():w)}return[a,S.length>1?S:S[0],_.length>1?_:_[0]]}(t,c,r,p,n,o),A=(0,i.default)(I,3),R=A[0],x=A[1],N=A[2];if(void 0!==R){var D=[C,p,R,x,N,(0,s.default)(y,["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"]),h,n,m,_];if(a)return D;var L=w.apply(void 0,D);return _&&(L=t.settings.formatReverse(L,p,b,y,E,n)),L}}}},O=function(e,t,r,n,o,i,a,u,d,f){var p=arguments.length>10&&void 0!==arguments[10]?arguments[10]:null,g=arguments.length>11?arguments[11]:void 0;if(void 0!==r){var v;if("field"==n)v=S(e,t,r,f,p);else if("func"==n)v=_(e,t,r,f,p);else if("function"==typeof i.formatValue){var h=i.formatValue,y=[r,m(m({},(0,c.default)(a,["fieldSettings","listValues"])),{},{asyncListValues:g}),(0,s.default)(i,["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue"]),f];if(u&&(y.push(u),y.push(d)),"field"==n){var b=(0,l.getFieldConfig)(e,r)||{};y.push(b)}v=h.apply(void 0,y)}else v=r;return v}},S=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=e.settings,s=a.fieldSeparator,c=a.fieldSeparatorDisplay,d=null;if(r){var f=(0,l.getFieldConfig)(e,r)||{},g=Array.isArray(r)?r:r.split(s),v=((0,u.getFieldPath)(r,e),(0,u.getFieldPathLabels)(r,e,i?o:null)),h=v?v.join(c):null,m=f.label2||h;d=(e.settings.formatField||p.settings.formatField)((0,u.formatFieldName)(r,e,t,i?o:null),g,m,f,e,n)}return d},_=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=r.get("func"),u=r.get("args"),s=(0,l.getFuncConfig)(e,a),c=n&&s.label||a,d={},f={};for(var p in s.args){var g=s.args[p],v=(0,l.getFieldConfig)(e,g),h=u?u.get(p):void 0,m=h?h.get("value"):void 0,y=h?h.get("valueSrc"):void 0,b=h?h.get("asyncListValues"):void 0,E=O(e,t,m,y,g.type,v,g,null,null,n,o,b),S=n&&g.label||p;void 0!==E&&(d[p]=E,f[S]=E)}var _=null;if("function"==typeof s.formatFunc){var w=s.formatFunc,T=[d,n];_=w.apply(void 0,T)}else{var P=Object.entries(f).map((function(e){var t=(0,i.default)(e,2),r=t[0],o=t[1];return n?"".concat(r,": ").concat(o):"".concat(o)})).join(", ");_="".concat(c,"(").concat(P,")")}return _}},40844:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.spelFormat=t._spelFormat=void 0;var o=n(r(81719)),i=n(r(85707)),a=n(r(18821)),l=r(40112),u=r(89112),s=n(r(24319)),c=n(r(67171)),d=r(98477),f=r(18313),p=(r(74837),r(63968)),g=r(37512),v=r(22777);function h(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function m(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?h(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}t.spelFormat=function(e,t){return y(e,t,!1)};var y=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=b(e,t,n,null);return r?[o,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SpEL:",n.errors),o)};t._spelFormat=y;var b=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return"group"===o||"rule_group"===o?S(e,t,r,n):"rule"===o?T(e,t,r,n):"switch_group"==o?O(e,t,r,n):"case_group"==o?E(e,t,r,n):void 0}},E=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type");if("case_group"==o){var i=e.get("properties")||new g.Map,l=P(t,i,r,null,n,"!case_value"),u=(0,a.default)(l,3),s=u[0];return u[1],u[2],[S(e,t,r,n),s]}r.errors.push("Unexpected child of type ".concat(o," inside switch"))},O=function(e,t,r){e.get("properties")||new g.Map;var n=e.get("children1");if(n){var o=n.map((function(e){return E(e,t,r,null)})).filter((function(e){return void 0!==e})).toArray();if(o.length){if(1==o.length&&!o[0][0])return o[0][1];for(var i=[],l=0;l<o.length;l++)l==o.length-1||o[l][0]?(i.push(o[l]),l==o.length-1&&o[l][0]&&i.push([void 0,null])):r.errors.push("No condition for case ".concat(l));for(var u="",s="",c=0;c<i.length;c++){var d=(0,a.default)(i[c],2),f=d[0],p=d[1];null==p&&(p="null"),null==f&&(f="true"),c!=i.length-1?(u+="(".concat(f," ? ").concat(p," : "),s+=")"):u+="".concat(p)}return u+s}}},S=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type"),i=e.get("properties")||new g.Map,u=i.get("mode"),s=e.get("children1"),c=i.get("field");if(s){var d=i.get("conjunction");d||(d=(0,f.defaultConjunction)(t));var p=t.conjunctions[d],v=i.get("not"),h="rule_group"===o,m=h&&"struct"!=u,y=m?c:n,E=((0,l.getFieldConfig)(t,y)||{}).isSpelArray,O=i.get("operator");O||u&&"some"!=u||(O="some");var S=w(t,O,c),T=S!=O,C=O&&(0,l.getOperatorConfig)(t,S,c)||null,A=h&&(!S||0==C.cardinality),R=P(t,i,r,S,n,null),x=(0,a.default)(R,3),N=x[0],D=x[1],L=x[2],j=s.map((function(e){return b(e,t,r,y)})).filter((function(e){return void 0!==e}));if(m&&!A){if(null==N)return}else if(!j.size)return;var M,k=h,F=j.size?p.spelFormatConj(j,d,v,k):null;if(m){var q=I(r,t,c,n),V=E?".length":".size()",B="".concat(q).concat(V),U=F?"".concat(q,".?[").concat(F,"]").concat(V):B;M=_(r,t,i,U,A?B:N,S,D,L,T)}else M=F;return M}},_=function(e,t,r,n,o,i,a,u){var c=arguments.length>8&&void 0!==arguments[8]&&arguments[8],f=r.get("field"),p=(0,l.getOperatorConfig)(t,i,f)||{},g=(0,l.getFieldConfig)(t,f)||{},v=r.get("operatorOptions"),h=p.spelFormatOp||function(e,t){var r=t.spelOp;if(r){var n,o="$"==r[0],i="."==r[0]||o,a="()"==r.substring(r.length-2),l=i?r.slice(1):a?r.substring(0,r.length-2):r,u=(0,d.defaultValue)(t.cardinality,1);return 0==u?n=function(e,t,r,n,o,a,u,s){return i?"".concat(e,".").concat(l,"()"):"".concat(e," ").concat(l)}:1==u&&(n=function(e,t,r,n,u,s,c,d){return o?"".concat(r,".").concat(l,"(").concat(e,")"):a?"".concat(l,"(").concat(e,", ").concat(r,")"):i?"".concat(e,".").concat(l,"(").concat(r,")"):"".concat(e," ").concat(l," ").concat(r)}),n}}(0,p);if(h){var m,y=[n,i,o,a,u,(0,s.default)(p,["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"]),v,g];return m=h.apply(void 0,y),c&&(m=t.settings.spelFormatReverse(m)),void 0===m&&e.errors.push("Operator ".concat(i," is not supported for value source ").concat(a)),m}e.errors.push("Operator ".concat(i," is not supported"))},w=function(e,t,r){if(t){var n=(0,l.getOperatorConfig)(e,t,r)||{},o=n.reversedOp,i=(0,l.getOperatorConfig)(e,o,r)||{},a=n.spelOp||n.spelFormatOp,u=i.spelOp||i.spelFormatOp;if(a||u){if(!a&&u){var s=[o,t];t=s[0],o=s[1];var c=[i,n];n=c[0],i=c[1]}return t}}},T=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("properties")||new g.Map,i=o.get("field"),l=o.get("operator");if(null!=i&&null!=l){var u=w(t,l,i);if(u){var s=u!=l,c=P(t,o,r,u,n,null),d=(0,a.default)(c,3),f=d[0],p=d[1],v=d[2];if(void 0!==f){var h=I(r,t,i,n);return _(r,t,o,h,f,u,p,v,s)}}else r.errors.push("Operator ".concat(l," is not supported"))}},P=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),c=t.get("valueSrc"),f=t.get("valueType");("!case_value"==i||f&&"case_value"==f.get(0))&&(a="!case_value");var g,v=(0,l.getFieldConfig)(e,a)||{},h=(0,l.getOperatorConfig)(e,n,a)||{},m=(0,d.defaultValue)(h.cardinality,1),y=t.get("value"),b=t.get("asyncListValues"),E=[],O=[];if(null!=y){var S=y.map((function(t,i){var d=c?c.get(i):null,g=f?f.get(i):null,m=(0,p.completeValue)(t,d,e),y=(0,u.getWidgetForFieldOp)(e,a,n,d),S=(0,s.default)((0,l.getFieldWidgetConfig)(e,a,n,y,d),["factory"]),_=C(r,e,m,d,g,S,v,n,h,o,b);return void 0!==_&&(E.push(d),O.push(g)),_})),_=S.filter((function(e){return void 0===e})).size>0;S.size<m||_||(g=m>1?S.toArray():1==m?S.first():null)}return[g,E.length>1?E:E[0],O.length>1?O:O[0]]},C=function(e,t,r,n,o,i,a,u,d){var f=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,p=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var g;if("field"==n)g=I(e,t,r,f);else if("func"==n)g=A(e,t,r,f);else if("function"==typeof i.spelFormatValue){var h=i.spelFormatValue,y=[r,m(m({},(0,c.default)(a,["fieldSettings","listValues"])),{},{asyncListValues:p}),(0,s.default)(i,["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue"])];if(u&&(y.push(u),y.push(d)),"field"==n){var b=(0,l.getFieldConfig)(t,r)||{};y.push(b)}g=h.apply(void 0,y)}else g=(0,v.spelEscape)(r);return g}},I=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(r){var o=t.settings.fieldSeparator,i=(0,l.getFieldConfig)(t,r)||{},s=Array.isArray(r)?r:r.split(o),c=((0,u.getFieldPath)(r,t,n),(0,u.getFieldPartsConfigs)(r,t,n)),d=t.settings.formatSpelField,f=(0,u.formatFieldName)(r,t,e);if(n){var p=(0,l.getFieldConfig)(t,n)||{},g=n;p.fieldName&&(g=p.fieldName),0==f.indexOf(g+o)?f=f.slice((g+o).length):e.errors.push("Can't cut group ".concat(g," from field ").concat(f))}return d(f,n,s,c.map((function(e){var t,r=(0,a.default)(e,3),n=r[0],o=r[1],i=r[2];return i&&(t="!struct"==i.type||"!group"==i.type&&"struct"==i.mode?o.isSpelMap?"map":"class":"!group"==i.type?o.isSpelItemMap?"[map]":"[class]":"class"),{key:n,parent:t,isSpelVariable:null==o?void 0:o.isSpelVariable}})),i,t)}},A=function(e,t,r){var n,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,u=r.get("func"),s=r.get("args"),c=(0,l.getFuncConfig)(t,u),d=c.spelFunc||u,f={};for(var p in c.args){var g=c.args[p],v=(0,l.getFieldConfig)(t,g),h=s?s.get(p):void 0,m=h?h.get("value"):void 0,y=h?h.get("valueSrc"):void 0,b=h?h.get("asyncListValues"):void 0,E=C(e,t,m,y,g.type,v,g,null,null,i,b);if(null!=m&&void 0===E)return void e.errors.push("Can't format value of arg ".concat(p," for func ").concat(u));void 0!==E&&(f[p]=E)}if("function"==typeof c.spelFormatFunc){var O=[f];n=c.spelFormatFunc.apply(void 0,O)}else{var S=Object.entries(f).map((function(e){var t=(0,a.default)(e,2);return t[0],t[1]}));if("."==d[0]&&S.length){var _=(0,o.default)(S),w=_[0],T=_.slice(1);n="".concat(w).concat(d,"(").concat(T.join(", "),")")}else n="".concat(d,"(").concat(S.join(", "),")")}return n}},82204:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.sqlFormat=t._sqlFormat=void 0;var o=n(r(18821)),i=n(r(85707)),a=r(40112),l=r(89112),u=n(r(24319)),s=n(r(67171)),c=r(98477),d=r(18313),f=r(74837),p=r(63968),g=r(37512),v=r(22777);function h(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function m(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?h(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}t.sqlFormat=function(e,t){return y(e,t,!1)};var y=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=b(e,t,n);return r?[o,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SQL:",n.errors),o)};t._sqlFormat=y;var b=function(e,t,r){if(e){var n=e.get("type"),o=e.get("children1");return("group"===n||"rule_group"===n)&&o&&o.size?E(e,t,r):"rule"===n?O(e,t,r):void 0}},E=function(e,t,r){var n=e.get("type"),o=e.get("properties")||new g.Map,i=e.get("children1"),l="rule_group"===n?o.get("field"):null;"array"==((0,a.getFieldConfig)(t,l)||{}).mode&&r.errors.push("Aggregation is not supported for ".concat(l));var u=o.get("not"),s=i.map((function(e){return b(e,t,r)})).filter((function(e){return void 0!==e}));if(s.size){var c=o.get("conjunction");return c||(c=(0,d.defaultConjunction)(t)),t.conjunctions[c].sqlFormatConj(s,c,u)}},O=function(e,t,r){var n=e.get("properties")||new g.Map,o=n.get("field"),i=n.get("operator"),s=n.get("operatorOptions"),d=n.get("valueSrc"),f=n.get("valueType"),v=n.get("value"),h=n.get("asyncListValues");if(null!=o&&null!=i){var m=(0,a.getFieldConfig)(t,o)||{},y=(0,a.getOperatorConfig)(t,i,o)||{},b=y.reversedOp,E=(0,a.getOperatorConfig)(t,b,o)||{},O=(0,c.defaultValue)(y.cardinality,1),w=!1,T=y.sqlOp||y.sqlFormatOp,P=E.sqlOp||E.sqlFormatOp;if(T||P){if(!P&&P){w=!0;var C=[b,i];i=C[0],b=C[1];var I=[E,y];y=I[0],E=I[1]}var A=[],R=[],x=v.map((function(e,n){var s=d?d.get(n):null,c=f?f.get(n):null,g=(0,p.completeValue)(e,s,t),v=(0,l.getWidgetForFieldOp)(t,o,i,s),b=(0,u.default)((0,a.getFieldWidgetConfig)(t,o,i,v,s),["factory"]),E=S(r,t,g,s,c,b,m,i,y,h);return void 0!==E&&(A.push(s),R.push(c)),E}));if(!(x.filter((function(e){return void 0===e})).size>0||x.size<O)){var N=1==O?x.first():x,D=y.sqlFormatOp||function(e,t){var r,n=t.sqlOp||e,o=(0,c.defaultValue)(t.cardinality,1);return 0==o?r=function(e,t,r,o,i,a,l,u){return"".concat(e," ").concat(n)}:1==o?r=function(e,t,r,o,i,a,l,u){return"".concat(e," ").concat(n," ").concat(r)}:2==o&&(r=function(e,t,r,o,i,a,l,u){var s=r.first(),c=r.get(1);return"".concat(e," ").concat(n," ").concat(s," AND ").concat(c)}),r}(i,y);if(D){var L,j=[_(r,t,o),i,N,A.length>1?A:A[0],R.length>1?R:R[0],(0,u.default)(y,["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"]),s,m];if(L=D.apply(void 0,j),w&&(L=t.settings.sqlFormatReverse(L)),void 0!==L)return L;r.errors.push("Operator ".concat(i," is not supported for value source ").concat(A.join(", ")))}else r.errors.push("Operator ".concat(i," is not supported"))}}else r.errors.push("Operator ".concat(i," is not supported"))}},S=function(e,t,r,n,o,i,l,c,d,f){if(void 0!==r){var p;if("field"==n)p=_(e,t,r);else if("func"==n)p=w(e,t,r);else if("function"==typeof i.sqlFormatValue){var g=i.sqlFormatValue,h=[r,m(m({},(0,s.default)(l,["fieldSettings","listValues"])),{},{asyncListValues:f}),(0,u.default)(i,["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue"])];if(c&&(h.push(c),h.push(d)),"field"==n){var y=(0,a.getFieldConfig)(t,r)||{};h.push(y)}p=g.apply(void 0,h)}else p=Array.isArray(r)?r.map((function(e){return v.SqlString.escape(e)})):v.SqlString.escape(r);return p}},_=function(e,t,r){if(r){var n=t.settings.fieldSeparator,o=(0,a.getFieldConfig)(t,r)||{},i=Array.isArray(r)?r:r.split(n),u=((0,l.getFieldPath)(r,t),(0,l.getFieldPathLabels)(r,t)),s=u?u.join(n):null;return(t.settings.formatField||f.settings.formatField)((0,l.formatFieldName)(r,t,e),i,s,o,t)}},w=function(e,t,r){var n,i=r.get("func"),l=r.get("args"),u=(0,a.getFuncConfig)(t,i),s=u.sqlFunc||i,c={};for(var d in u.args){var f=u.args[d],p=(0,a.getFieldConfig)(t,f),g=l?l.get(d):void 0,v=g?g.get("value"):void 0,h=g?g.get("valueSrc"):void 0,m=g?g.get("asyncListValues"):void 0,y=S(e,t,v,h,f.type,p,f,null,null,m);if(null!=v&&void 0===y)return void e.errors.push("Can't format value of arg ".concat(d," for func ").concat(i));void 0!==y&&(c[d]=y)}if("function"==typeof u.sqlFormatFunc){var b=[c];n=u.sqlFormatFunc.apply(void 0,b)}else{var E=Object.entries(c).map((function(e){var t=(0,o.default)(e,2);return t[0],t[1]})).join(", ");n="".concat(s,"(").concat(E,")")}return n}},30539:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(55511);Object.keys(n).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===n[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return n[e]}}))}));var o=r(4583);Object.keys(o).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===o[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return o[e]}}))}));var i=r(38637);Object.keys(i).forEach((function(e){"default"!==e&&"__esModule"!==e&&(e in t&&t[e]===i[e]||Object.defineProperty(t,e,{enumerable:!0,get:function(){return i[e]}}))}))},4583:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.loadFromJsonLogic=t._loadFromJsonLogic=void 0;var o=n(r(10906)),i=n(r(81719)),a=n(r(85707)),l=n(r(18821)),u=n(r(58048)),s=r(98477),c=r(40112),d=r(89112),f=r(55511),p=r(18313),g=n(r(92468));function v(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function h(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?v(Object(r),!0).forEach((function(t){(0,a.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):v(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var m=function(e){return Array.from(new Set(e))};t.loadFromJsonLogic=function(e,t){return y(e,t,!1)};var y=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=(0,c.extendConfig)(t),i=b(o),a=e?E(e,i,o,"rule",n):void 0;a&&"group"!=a.type&&(a=P(a,o));var l=a?(0,f.loadTree)(a):void 0;return r?[l,n.errors]:(n.errors.length&&console.warn("Errors while importing from JsonLogic:",n.errors),l)};t._loadFromJsonLogic=y;var b=function(e){var t={};for(var r in e.operators){var n=e.operators[r];if("string"==typeof n.jsonLogic){var o=(n._jsonLogicIsRevArgs?"#":"")+n.jsonLogic+"/"+(0,s.defaultValue)(n.cardinality,1);t[o]||(t[o]=[]),t[o].push(r)}else if("string"==typeof n.jsonLogic2){var i=n.jsonLogic2+"/"+(0,s.defaultValue)(n.cardinality,1);t[i]||(t[i]=[]),t[i].push(r)}}var a={};for(var l in e.conjunctions)a[e.conjunctions[l].jsonLogicConj||l.toLowerCase()]=l;var u={};for(var c in e.funcs){var d=e.funcs[c],f=void 0;d.jsonLogicIsMethod?f="#"+d.jsonLogic:"string"==typeof d.jsonLogic&&(f=d.jsonLogic),f&&(u[f]||(u[f]=[]),u[f].push(c))}var p=e.settings.jsonLogic;return{operators:t,conjunctions:a,funcs:u,varKeys:["var",p.groupVarKey,p.altVarKey]}},E=function e(t,r,n,o,i){var a,l,u,c=arguments.length>5&&void 0!==arguments[5]&&arguments[5],d=arguments.length>6?arguments[6]:void 0,f=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;(0,s.isJsonLogic)(t)&&(l=t[a=Object.keys(t)[0]],Array.isArray(l)||(l=[l]));var g=i.errors.length,v=n.settings.jsonLogic.lockedOp,h="!"==a&&1==l.length&&l[0]&&(0,s.isJsonLogic)(l[0])&&r.varKeys.includes(Object.keys(l[0])[0]),m="!"==a&&!h,y=v&&a==v;y?u=e(l[0],r,n,o,i,c,d,f,p,!0):m?u=e(l[0],r,n,o,i,!c,d,f,p):"val"==o?u=S(a,l,r,n,c,i,p)||_(a,l,r,n,c,d,i,p)||O(t,d,f,n,i):"rule"==o&&(u=w(a,l,r,n,c,i,p,!1)||I(a,l,r,n,c,i,p));var b=i.errors.length;return"!"!=a&&void 0===u&&b==g&&i.errors.push("Can't parse logic ".concat(JSON.stringify(t))),y&&(u.properties.isLocked=!0),u},O=function(e,t,r,n,o){if(void 0!==e){var i=n.widgets[r||t.mainWidget];if(i){if(!(0,s.isJsonLogic)(e)){if(t&&"time"==t.type&&"number"==typeof e){var a=Math.floor(e/60/60)%24,l=Math.floor(e/60)%60,u=e%60,c=i.valueFormat;if(c){var d=new Date(e);d.setMilliseconds(0),d.setHours(a),d.setMinutes(l),d.setSeconds(u),e=(0,g.default)(d).format(c)}else e="".concat(a,":").concat(l,":").concat(u)}if(t&&["date","datetime"].includes(t.type)&&e&&!(e instanceof Date))try{var f=new Date(e);f instanceof Date&&f.toISOString()===e&&(e=f)}catch(t){o.errors.push("Can't convert value ".concat(e," as Date")),e=void 0}if(e instanceof Date&&t){var p=i.valueFormat;p&&(e=(0,g.default)(e).format(p))}var v;return e&&t.fieldSettings&&t.fieldSettings.asyncFetch&&(v=Array.isArray(e)?e:[e]),{valueSrc:"value",value:e,valueType:i.type,asyncListValues:v}}o.errors.push("Unexpected logic in value: ".concat(JSON.stringify(e)))}else o.errors.push("No widget for type ".concat(t.type))}},S=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=n.settings.fieldSeparator;if(r.varKeys.includes(e)&&"string"==typeof t[0]){var u=t[0];a&&(u=[a,u].join(l)),u=(0,c.normalizeField)(n,u);var s=(0,c.getFieldConfig)(n,u);return s?{valueSrc:"field",value:u,valueType:s.type}:void i.errors.push("No config for field ".concat(u))}},_=function(e,t,r,n,u,s,c){var d=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null;if(e){var f,p,g,v="method"==e;if(v){var m,y,b=(0,i.default)(t);m=b[0],f=b[1],y=b.slice(2),p=[m].concat((0,o.default)(y))}else f=e,p=t;var O=(v?"#":"")+f,S=(r.funcs[O]||[]).filter((function(e){return!s||n.funcs[e].returnType==s.type}));if(S.length)g=S[0];else for(var _=(0,a.default)({},e,t),w=0,T=Object.entries(n.funcs||{});w<T.length;w++){var P=(0,l.default)(T[w],2),C=P[0],I=P[1];if(I.jsonLogicImport&&I.returnType==s.type){var A=void 0;try{A=I.jsonLogicImport(_)}catch(e){}A&&(g=C,p=A)}}if(g&&g){var R=n.funcs[g],x=Object.keys(R.args||{}),N=p.reduce((function(e,t,o){var i=x[o],l=R.args[i],u=E(t,r,n,"val",c,!1,l,null,d);if(void 0!==u||void 0!==(u=l.defaultValue))return h(h({},e),{},(0,a.default)({},i,u));c.errors.push("No value for arg ".concat(i," of func ").concat(g))}),{});return{valueSrc:"func",value:{func:g,args:N},valueType:R.returnType}}}},w=function(e,t,r,n,i,d){var f=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,p=r.conjunctions[e],g=n.settings.fieldSeparator,v=f?(0,c.getFieldConfig)(n,f):null;if(null==v||v.type,p){var y=t.map((function(e){return E(e,r,n,"rule",d,!1,null,null,f)})).filter((function(e){return void 0!==e})).reduce((function(e,t){return h(h({},e),{},(0,a.default)({},t.id,t))}),{}),b=Object.values(y).map((function(e){var t;return null==e||null===(t=e.properties)||void 0===t?void 0:t.field})).filter((function(e){return e&&e.includes(g)})),O=Object.fromEntries(m(b).map((function(e){var t=e.split(g),r=Object.fromEntries(t.slice(0,-1).map((function(e,t,r){return[].concat((0,o.default)(r.slice(0,t)),[e])})).map((function(e){return[e.join(g),(0,c.getFieldConfig)(n,e)]})).filter((function(e){var t=(0,l.default)(e,2);return t[0],"!group"==t[1].type})));return[e,Object.keys(r)]}))),S=(Object.values(y).map((function(e){var t;return null==e||null===(t=e.properties)||void 0===t?void 0:t.field})).map((function(e){return O[e]})).filter((function(e){return e&&e.length})),m(Object.values(O).flat())),_=(T(S),{conjunction:p,not:i}),w=(0,u.default)(),P={},C={};return Object.entries(y).map((function(e){var t=(0,l.default)(e,2),r=t[0],i=t[1];if("group"==i.type||"rule_group"==i.type)P[r]=i;else{var a,d=null==i||null===(a=i.properties)||void 0===a?void 0:a.field,v=O[d],h=null==v?void 0:v.at(-1);if(h){var m=P,y=f?f.split(g):[];(0,s.shallowEqual)(y,h.split(g).slice(0,y.length))||(y=[]),h.split(g).slice(y.length).map((function(e,t,r){return[].concat((0,o.default)(y),(0,o.default)(r.slice(0,t)),[e]).join(g)})).map((function(e){return(0,c.normalizeField)(n,e)})).map((function(e){return{f:e,fc:(0,c.getFieldConfig)(n,e)||{}}})).filter((function(e){return"!struct"!=e.fc.type})).map((function(e,t){var r=e.f,n=e.fc,o=C[r];o||(o=(0,u.default)(),C[r]=o,m[o]={type:"rule_group",id:o,children1:{},properties:{conjunction:p,not:!1,field:r,mode:n.mode}}),m=m[o].children1})),m[r]=i}else P[r]=i}})),{type:"group",id:w,children1:P,properties:_}}},T=function(e){for(var t=(0,o.default)(e).sort((function(e,t){return e.length-t.length})),r=0;r<t.length;r++)for(var n=r+1;n<t.length;n++)0==t[n].indexOf(t[r])&&(t.splice(n,1),n--);return t},P=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:(0,u.default)(),children1:(0,a.default)({},e.id,e),properties:{conjunction:(0,p.defaultConjunction)(t),not:r}}},C=function(e,t,r,n,o,a,u,d){var f=!(("all"==e||"some"==e)&&(0,s.isJsonLogic)(r[1])&&"in"==Object.keys(r[1])[0])&&a.settings.groupOperators.includes(e),p=f?0:t-1;f?p=0:["==","!="].includes(e)&&1==p&&null===r[1]&&(t=1,p=0,r=[r[0]]);var g=e+"/"+p,v=a.settings.fieldSeparator,h=o.operators[(d?"#":"")+g];if(h){var m,y=[];if(["<","<=",">",">="].includes(e)&&3==t)m=r[1],y=[r[0],r[2]];else if(d)m=r[1],y=[r[0]];else{var b=r,E=(0,i.default)(b);m=E[0],y=E.slice(1)}if((0,s.isJsonLogic)(m)){var O,S,_=Object.keys(m)[0],w=Object.values(m)[0];if(o.varKeys.includes(_)&&"string"==typeof w&&(O=w),f&&(S=y[0],y=[]),"reduce"==_&&Array.isArray(w)&&3==w.length){var T=w,P=(0,l.default)(T,3),C=P[0],I=P[1],A=P[2];if((0,s.isJsonLogic)(C)&&0==A&&(0,s.isJsonLogic)(I)&&Array.isArray(I["+"])&&1==I["+"][0]&&(0,s.isJsonLogic)(I["+"][1])&&"accumulator"==I["+"][1].var)if(_=Object.keys(C)[0],w=Object.values(C)[0],"filter"==_){var R=w,x=(0,l.default)(R,2),N=x[0],D=x[1];(0,s.isJsonLogic)(N)&&(_=Object.keys(N)[0],w=Object.values(N)[0],o.varKeys.includes(_)&&"string"==typeof w&&(O=w,S=D))}else o.varKeys.includes(_)&&"string"==typeof w&&(O=w)}if(O){n&&(O=[n,O].join(v)),O=(0,c.normalizeField)(a,O);var L=(0,c.getFieldConfig)(a,O);if(L){var j=h[0];if(h.length>1&&L&&L.operators){if(h=h.filter((function(e){return L.operators.includes(e)})),0==h.length)return void u.push("No corresponding ops for field ".concat(O));j=h[0]}return{field:O,fieldConfig:L,opKey:j,args:y,having:S}}u.push("No config for field ".concat(O))}else u.push("Unknown field ".concat(JSON.stringify(m)))}else u.push("Incorrect operands for ".concat(e,": ").concat(JSON.stringify(r)))}},I=function e(t,r,n,o,i,l){var c=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if(t){var f=r.length;if(("all"==t||"some"==t)&&(0,s.isJsonLogic)(r[1])){var g=Object.keys(r[1])[0];"in"==g&&(r=[r[0],r[1][g][1]],t=t+"-"+g)}var v=function(e,t,r,n,o,i,a){var l=[],u=C(e,t,r,n,o,i,l,!1)||C(e,t,r,n,o,i,l,!0);if(u)return u;a.errors.push(l.join("; ")||"Unknown op ".concat(e,"/").concat(t))}(t,f,r,c,n,o,l);if(v){var h,m,y=v.field,b=v.fieldConfig,O=v.opKey,S=v.args,_=v.having,T=o.operators[O],I=(void 0!==b.showNot?b.showNot:o.settings.showNot,!0);if("!group"==b.type&&_){m=_[h=Object.keys(_)[0]],Array.isArray(m)||(m=[m]);var A="!"==h&&1==m.length&&m[0]&&(0,s.isJsonLogic)(m[0])&&n.varKeys.includes(Object.keys(m[0])[0]);"!"!=h||A||(i=!i,m=(_=_["!"])[h=Object.keys(_)[0]],Array.isArray(m)||(m=[m]))}i&&T.reversedOp&&(i=!1,O=T.reversedOp,T=o.operators[O]);var R=(0,d.getWidgetForFieldOp)(o,y,O),x=S.map((function(e){return E(e,n,o,"val",l,!1,b,R,c)}));if(!x.filter((function(e){return void 0===e})).length){var N;if("!group"==b.type&&_){if(void 0!==n.conjunctions[h])N=w(h,m,n,o,i,l,y,!0),i=!1;else{var D,L=e(h,m,n,o,i&&I,l,y);!i||null!=L&&null!==(D=L.properties)&&void 0!==D&&D.not||(i=!1),N=function(e,t,r,n,o){if(e)return{type:"rule_group",id:(0,u.default)(),children1:(0,a.default)({},e.id,e),properties:{conjunction:o||(0,p.defaultGroupConjunction)(n,r),not:!1,field:t}}}(L,y,b,o,n.conjunctions.and)}if(!N)return;N.type="rule_group",i&&Object.assign(N.properties,{not:i}),Object.assign(N.properties,{field:y,mode:b.mode,operator:O}),"array"==b.mode&&Object.assign(N.properties,{value:x.map((function(e){return e.value})),valueSrc:x.map((function(e){return e.valueSrc})),valueType:x.map((function(e){return e.valueType}))})}else if("!group"!=b.type||_){var j=x.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),M=j.length?j[0]:void 0;N={type:"rule",id:(0,u.default)(),properties:{field:y,operator:O,value:x.map((function(e){return e.value})),valueSrc:x.map((function(e){return e.valueSrc})),valueType:x.map((function(e){return e.valueType})),asyncListValues:M}},i&&(N=P(N,o,i))}else N={type:"rule_group",id:(0,u.default)(),children1:{},properties:{conjunction:(0,p.defaultGroupConjunction)(o,b),not:i,mode:b.mode,field:y,operator:O}},"array"==b.mode&&Object.assign(N.properties,{value:x.map((function(e){return e.value})),valueSrc:x.map((function(e){return e.valueSrc})),valueType:x.map((function(e){return e.valueType}))});return N}}}}},38637:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.loadFromSpel=t._loadFromSpel=void 0;var o=n(r(18821)),i=n(r(10564)),a=n(r(85707)),l=n(r(10906)),u=r(22262),s=n(r(58048)),c=r(40112),d=r(89112),f=r(55511),p=r(18313),g=r(98477),v=n(r(92468));function h(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function m(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?h(Object(r),!0).forEach((function(t){(0,a.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}t.loadFromSpel=function(e,t){return y(e,t,!0)};var y=function(e,t){var r,n,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i={errors:[]},a=(0,c.extendConfig)(t),l=O(a),s=void 0;try{r=u.SpelExpressionEvaluator.compile(e)._compiledExpression}catch(e){i.errors.push(e)}r&&(g.logger.debug("compiledExpression:",r),n=b(r,i),g.logger.debug("convertedObj:",n,i),(s=T(n,l,a,i))&&"group"!=s.type&&"switch_group"!=s.type&&(s=R(s,a,n.not)),g.logger.debug("jsTree:",s));var d=s?(0,f.loadTree)(s):void 0;return o?[d,i.errors]:(i.errors.length&&console.warn("Errors while importing from SpEL:",i.errors),d)};t._loadFromSpel=y;var b=function e(t,r){var n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,a=t.getType(),u=t.getChildren().map((function(n){return e(n,r,t)}));if("op-or"!=a&&"op-and"!=a||(u=u.reduce((function(e,t){var r=t.type!=a||t.not?[t]:t.children;return[].concat((0,l.default)(e),(0,l.default)(r))}),[])),"op-not"==a)return 1!=u.length&&r.errors.push("Operator NOT should have 1 child, but got ".concat(u.length,"}")),m(m({},u[0]),{},{not:!u[0].not});if("compound"==a){var s=(u=u.filter((function(e){return!("selection"==e.type&&1==e.children.length&&"boolean"==e.children[0].type&&1==e.children[0].val)}))).find((function(e){return"selection"==e.type}));s&&1!=s.children.length&&r.errors.push("Selection should have 1 child, but got ".concat(s.children.length));var c=s?s.children[0]:null,d=u[u.length-1],f="method"==d.type&&"size"==d.val.methodName||"!func"==d.type&&"size"==d.methodName,p="property"==d.type&&"length"==d.val,v=u.filter((function(e){return e!==s&&e!==d}));if(f||p)return{type:"!aggr",filter:c,source:{type:"compound",children:v}};if(u=(u=u.filter((function(e){var t="variable"==e.type&&"this"==e.val,r="variable"==e.type&&"root"==e.val;return!(t||r)}))).map((function(e){return"indexer"==e.type&&1==e.children.length?{type:"indexer",val:e.children[0].val,itype:e.children[0].type}:e})),"method"==d.type)return{type:"!func",obj:u.filter((function(e){return e!==d})),methodName:d.val.methodName,args:d.val.args};if("!func"==d.type){var h=u.filter((function(e){return e!==d}));return m(m({},d),{},{obj:h})}}try{t.getRaw?n=t.getRaw():0==t.getValue.length&&(n=t.getValue())}catch(e){g.logger.error("[spel2js] Error in getValue()",e)}if("ternary"==a&&(n=E(u)),"object"===(0,i.default)(n)&&null!==n&&(n.methodName||n.functionName)&&(n.args=n.args.map((function(n){return e(n,r,t)}))),"list"==a&&(n=n.map((function(n){return e(n,r,t)})),!o&&1==n.length))return n[0];if("constructorref"==a){var y=u.find((function(e){return"qualifiedidentifier"==e.type})),b=null==y?void 0:y.val;return b?{type:"!new",cls:b,args:u.filter((function(e){return"qualifiedidentifier"!=e.type}))}:void r.errors.push("Can't find qualifiedidentifier in constructorref children: ".concat(JSON.stringify(u)))}if("typeref"==a){var O=u.find((function(e){return"qualifiedidentifier"==e.type})),S=null==O?void 0:O.val;return S?(u.filter((function(e){return"qualifiedidentifier"!=e.type})),{type:"!type",cls:S}):void r.errors.push("Can't find qualifiedidentifier in typeref children: ".concat(JSON.stringify(u)))}if("function"==a||"method"==a){var _=n,w=_.functionName,T=_.methodName,P=_.args;return{type:"!func",methodName:w||T,isVar:"function"==a,args:P}}return{type:a,children:u,val:n}},E=function(e){var t=[];return function e(r){var n=(0,o.default)(r,3),i=n[0],a=n[1],l=n[2];t.push([i,a]),"ternary"==(null==l?void 0:l.type)?e(l.children):t.push([void 0,l])}(e),t},O=function(e){var t={},r=function(r){var n=e.operators[r];if(n.spelOps)n.spelOps.forEach((function(e){var n=e;t[n]||(t[n]=[]),t[n].push(r)}));else if(n.spelOp){var o=n.spelOp;t[o]||(t[o]=[]),t[o].push(r)}else g.logger.log("[spel] No spelOp for operator ".concat(r))};for(var n in e.operators)r(n);var o={};for(var i in e.conjunctions)o[e.conjunctions[i].spelConj||i.toLowerCase()]=i;var a={};for(var l in e.funcs){var u=e.funcs[l],s=void 0;"string"==typeof u.spelFunc&&(s=u.spelFunc),s&&(a[s]||(a[s]=[]),a[s].push(l))}return{operators:t,conjunctions:o,funcs:a}},S=function(e,t){var r=!1,n=e.map((function(e){if("variable"==e.type||"property"==e.type||"indexer"==e.type&&"string"==e.itype)return e.val;r=!0,t.errors.push("Unexpected item in compound: ".concat(JSON.stringify(e)))}));return r?void 0:n},_=function e(t,r,n,o,i){if(null!=t){var u=n.settings.fieldSeparator,s={number:"number",string:"text",boolean:"boolean",null:"null"},d=null!=i&&i._groupField?[null==i?void 0:i._groupField]:[];if("compound"==t.type){var f,p,g=S(t.children,o);if(!g)return;var h=[].concat(d,(0,l.default)(g));return{valueSrc:"field",isVariable:"variable"==(null===(f=t.children)||void 0===f||null===(p=f[0])||void 0===p?void 0:p.type),value:h.join(u)}}if("variable"==t.type||"property"==t.type){var y=[].concat(d,[t.val]);return{valueSrc:"field",isVariable:"variable"==t.type,value:y.join(u)}}if(s[t.type]){var b=t.val,E=s[t.type];return null!=i&&i.isUnary&&(b=-b),{valueSrc:"value",valueType:E,value:b}}if("list"==t.type){var O,_=t.val.map((function(i){return e(i,r,n,o,t)}));return _.length&&(null===(O=_[0])||void 0===O||O.valueType),{valueSrc:"value",valueType:"multiselect",value:_.map((function(e){return null==e?void 0:e.value}))}}if("!func"==t.type){var T,P=t.obj,C=t.methodName,A=t.args,R=(t.isVar,T={},(0,a.default)(T,".contains","like"),(0,a.default)(T,".startsWith","starts_with"),(0,a.default)(T,".endsWith","ends_with"),(0,a.default)(T,"$contains","select_any_in"),(0,a.default)(T,".equals","multiselect_equals"),(0,a.default)(T,"CollectionUtils.containsAny()","multiselect_contains"),T),x=A.map((function(a){return e(a,r,n,o,m(m({},t),{},{_groupField:null==i?void 0:i._groupField}))}));if("contains"==C&&P&&"list"==P[0].type){var N=P.map((function(i){return e(i,r,n,o,t)}));if(1!=x.length||"field"!=x[0].valueSrc)return void o.errors.push("Expected arg to method ".concat(C," to be field but got: ").concat(JSON.stringify(x)));var D=x[0].value;if(1!=N.length||"multiselect"!=N[0].valueType)return void o.errors.push("Expected object of method ".concat(C," to be inline list but got: ").concat(JSON.stringify(N)));var L=R["$"+C],j=N[0];return w(n,o,D,L,[j])}if(P&&"property"==P[0].type&&R[P[0].val+"."+C+"()"]){var M=R[P[0].val+"."+C+"()"],k=x[0].value,F=x.slice(1);return w(n,o,k,M,F)}if(R["."+C]){var q=R["."+C],V=S(P,o);if(V&&1==x.length){var B=[].concat(d,(0,l.default)(V)).join(u);return w(n,o,B,q,x)}}else{if("parse"==C&&P&&"!new"==P[0].type&&"SimpleDateFormat"==P[0].cls.at(-1)){var U=P[0].args.map((function(a){return e(a,r,n,o,m(m({},t),{},{_groupField:null==i?void 0:i._groupField}))}));if(1!=U.length||"text"!=U[0].valueType)return void o.errors.push("Expected args of ".concat(P[0].cls.join("."),".").concat(C," to be 1 string but got: ").concat(JSON.stringify(U)));if(1!=x.length||"text"!=x[0].valueType)return void o.errors.push("Expected args of ".concat(P[0].cls.join(".")," to be 1 string but got: ").concat(JSON.stringify(x)));var W=U[0].value,G=x[0].value,H=W.includes(" ")?"datetime":"date",K=H,$=(0,c.getFieldConfig)(n,null),z=n.widgets[K||(null==$?void 0:$.mainWidget)].valueFormat,Y=(0,v.default)(G,v.default.ISO_8601);return{valueSrc:"value",valueType:H,value:Y.isValid()?Y.format(z):void 0}}if("parse"==C&&P&&"!type"==P[0].type&&"LocalTime"==P[0].cls.at(-1)){if(1!=x.length||"text"!=x[0].valueType)return void o.errors.push("Expected args of ".concat(P[0].cls.join(".")," to be 1 string but got: ").concat(JSON.stringify(x)));var Q=x[0].value,X="time",J=X,Z=(0,c.getFieldConfig)(n,null),ee=n.widgets[J||(null==Z?void 0:Z.mainWidget)].valueFormat,te=(0,v.default)(Q,"HH:mm:ss");return{valueSrc:"value",valueType:X,value:te.isValid()?te.format(ee):void 0}}o.errors.push("Unsupported method ".concat(C))}}else{if("op-plus"==t.type&&"ternary"==(null==i?void 0:i.type))return I(t,r,n,o);o.errors.push("Can't convert arg of type ".concat(t.type))}}},w=function(e,t,r,n,o){if(!o.filter((function(e){return void 0===e})).length){var i=(0,c.getFieldConfig)(e,r);if(i){var a=(0,d.getWidgetForFieldOp)(e,r,n),l=e.widgets[a||i.mainWidget],u=o.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),f=u.length?u[0]:void 0;return{type:"rule",id:(0,s.default)(),properties:{field:r,operator:n,value:o.map((function(e){return e.value})),valueSrc:o.map((function(e){return e.valueSrc})),valueType:o.map((function(e){return"value"==e.valueSrc&&((null==l?void 0:l.type)||(null==i?void 0:i.type))||e.valueType})),asyncListValues:f}}}t.errors.push("No config for field ".concat(r))}},T=function e(t,r,n,i){var a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(t){var l;if(0==t.type.indexOf("op-")){var u=t.type.slice(3);if(("minus"==u||"plus"==u)&&1==t.children.length)return t.isUnary=!0,e(t.children[0],r,n,i,t);var f="and"==u&&2==t.children.length&&"op-ge"==t.children[0].type&&"op-le"==t.children[1].type,p="or"==u&&2==t.children.length&&"op-lt"==t.children[0].type&&"op-gt"==t.children[1].type;if(f||p){var v=(0,o.default)(t.children[0].children,2),h=v[0],y=v[1],b=(0,o.default)(t.children[1].children,2),E=b[0],O=b[1],S="number"==y.type&&"number"==O.type,T=function(e,t,r,n,i,a){var l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if(e.type==t.type){if("!aggr"==e.type){var u=[e.source,t.source].map((function(e){return _(e,n,i,a,m(m({},r),{},{_groupField:null==l?void 0:l._groupField}))})),s=(0,o.default)(u,2),c=s[0],d=s[1];return c.value==d.value}var f=[e,t].map((function(e){return _(e,n,i,a,m(m({},r),{},{_groupField:null==l?void 0:l._groupField}))})),p=(0,o.default)(f,2),g=p[0],v=p[1];return g.value==v.value}return!1}(h,E,t,r,n,i,a);if(S&&T)return y.val,O.val,e({type:"op-between",children:[h,y,O]},r,n,i,a)}var I,A=r.operators[u];"eq"==u&&"null"==t.children[1].type?I="is_null":"ne"==u&&"null"==t.children[1].type?I="is_not_null":"le"==u&&"string"==t.children[1].type&&""==t.children[1].val?(I="is_empty",A=["is_empty"]):"gt"==u&&"string"==t.children[1].type&&""==t.children[1].val?(I="is_not_empty",A=["is_not_empty"]):"between"==u&&(I="between",A=["between"]);var x=function(){return t.children.map((function(o){return e(o,r,n,i,m(m({},t),{},{_groupField:null==a?void 0:a._groupField}))}))};if("and"==u||"or"==u){var N={};x().forEach((function(e){if(e){var t=(0,s.default)();e.id=t,null!=e.type?N[t]=e:i.errors.push("Bad item in AND/OR: ".concat(JSON.stringify(e)))}})),l={type:"group",id:(0,s.default)(),children1:N,properties:{conjunction:r.conjunctions[u],not:t.not}}}else if(A){var D=x(),L=D[0],j=D.slice(1);if(I=A[0],L)if(L.groupFieldValue){"field"!=L.groupFieldValue.valueSrc&&i.errors.push("Expected group field ".concat(JSON.stringify(L)));var M=L.groupFieldValue.value,k=j[0];k&&k.groupFieldValue&&"field"==k.groupFieldValue.valueSrc&&k.groupFieldValue.value==M?(I="all",j=[]):"equal"==I&&"value"==k.valueSrc&&"number"==k.valueType&&0==k.value?(I="none",j=[]):"greater"==I&&"value"==k.valueSrc&&"number"==k.valueType&&0==k.value&&(I="some",j=[]),l=function(e,t,r,n,o){var i=e.groupFilter,a=e.groupFieldValue;if("field"!=a.valueSrc)throw"Bad groupFieldValue: ".concat(JSON.stringify(a));var l=a.value,u=w(n,o,l,t,r);if(u){var d=(0,c.getFieldConfig)(n,l),f=null==d?void 0:d.mode,p=m(m({},i||{}),{},{type:"rule_group",properties:m(m(m({},u.properties),(null==i?void 0:i.properties)||{}),{},{mode:f})});return p.id||(p.id=(0,s.default)()),p}}(L,I,j,n,i)}else{"field"!=L.valueSrc&&i.errors.push("Expected field ".concat(JSON.stringify(L)));var F=L.value;if(A.length>1){g.logger.warn("[spel] Spel operator ".concat(u," can be mapped to ").concat(A));var q=A.map((function(e){return{op:e,widget:(0,d.getWidgetForFieldOp)(n,F,e)}}));"eq"!=u&&"ne"!=u||(I=q.find((function(e){e.op;var t=e.widget;return t&&"field"!=t})).op)}l=w(n,i,F,I,j)}}else a||(l=P(t,r,n,i)),l||i.errors.push("Can't convert op ".concat(u))}else if("!aggr"==t.type){var V,B=e(t.source,r,n,i,m(m({},t),{},{_groupField:null==a?void 0:a._groupField})),U=e(t.filter,r,n,i,m(m({},t),{},{_groupField:null==B?void 0:B.value}));"rule"==(null===(V=U)||void 0===V?void 0:V.type)&&(U=R(U,n)),l={groupFilter:U,groupFieldValue:B},a||(l=void 0,i.errors.push("Unexpected !aggr in root"))}else if("ternary"==t.type){var W={};t.val.forEach((function(e){var a=(0,o.default)(e,2),l=a[0],u=a[1],s=C(l,u,r,n,i,t);s&&(W[s.id]=s)})),l={type:"switch_group",id:(0,s.default)(),children1:W,properties:{}}}else if((l=_(t,r,n,i,a))&&!l.type&&!a){var G=P(t,r,n,i);G?l=G:(l=void 0,i.errors.push("Can't convert rule of type ".concat(t.type,", it looks like var/literal")))}return l}},P=function(e,t,r,n){var o={},i=C(null,e,t,r,n);return i&&(o[i.id]=i),{type:"switch_group",id:(0,s.default)(),children1:o,properties:{}}},C=function(e,t,r,n,o){var i,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,l=A(n,o,r,t,a);return e?(i=T(e,r,n,o,a))&&i.type?("group"!=i.type&&(i=R(i,n)),i.type="case_group"):(o.errors.push("Unexpected case: ".concat(JSON.stringify(i))),i=void 0):i={id:(0,s.default)(),type:"case_group",properties:{}},i&&(i.properties=m(m({},i.properties),l)),i},I=function(e,t,r,n){var o=[];return function i(a){a.map((function(a){if("op-plus"==a.type)i(a.children);else{var l=_(a,t,r,n,e);l?o.push(l):n.errors.push("Can't convert ".concat(a.type," in concatenation"))}}))}(e.children),{valueSrc:"value",valueType:"case_value",value:o}},A=function(e,t,r,n){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,l={};i="op-plus"==(null==n?void 0:n.type)?I(n,r,e,t):_(n,r,e,t,a);var u=e.widgets.case_value,s=null==u?void 0:u.spelImportValue;if(s){var c=s(i),d=(0,o.default)(c,2),f=d[0];d[1].map((function(e){return t.errors.push(e)})),f&&(l={value:[f],valueSrc:["value"],valueType:["case_value"]})}else t.errors.push("No fucntion to import case value");return l},R=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:(0,s.default)(),children1:(0,a.default)({},e.id,e),properties:{conjunction:(0,p.defaultConjunction)(t),not:r||!1}}}},55511:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.isImmutableTree=t.getTree=t.checkTree=void 0,Object.defineProperty(t,"isJsonLogic",{enumerable:!0,get:function(){return c.isJsonLogic}}),t.loadTree=t.isValidTree=t.isTree=void 0;var i=n(r(10564)),a=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=d(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(37512)),l=r(40056),u=r(40112),s=r(53502),c=r(98477);function d(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(d=function(e){return e?r:t})(e)}t.getTree=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(e){var n=e;return n=n.toJS(),t&&(n=(0,s.getLightTree)(n,r)),n}},t.loadTree=function(e){if(f(e))return e;if(p(e))return g(e);if("string"==typeof e&&e.startsWith('["~#iM"'))throw"You are trying to load query in obsolete serialization format (Immutable string) which is not supported in versions starting from 2.1.17";if("string"==typeof e)return g(JSON.parse(e));throw"Can't load tree!"},t.checkTree=function(e,t){if(e){var r=(0,u.extendConfig)(t);return(0,l.validateTree)(e,null,r,r)}},t.isValidTree=function(e){return 0==(0,s.getTreeBadFields)(e).length};var f=function(e){return a.Map.isMap(e)};t.isImmutableTree=f;var p=function(e){return"object"==(0,i.default)(e)&&("group"==e.type||"switch_group"==e.type)};function g(e){return(0,a.fromJS)(e,(function(e,t){var r;if("properties"==e){r=t.toOrderedMap();for(var n=0;n<2;n++){var o;null===(null===(o=r.get("value"))||void 0===o?void 0:o.get(n))&&(r=r.setIn(["value",n],void 0))}}else if("value"==e&&t.get(0)&&void 0!==t.get(0).toJS){var i=t.get(0).toJS();r=i.func?t.toOrderedMap():a.default.List.of(i)}else r="asyncListValues"==e?t.toJS():"children1"==e&&a.default.Iterable.isIndexed(t)?new a.default.OrderedMap(t.map((function(e){return[e.get("id"),e]}))):a.default.Iterable.isIndexed(t)?t.toList():t.toOrderedMap();return r}))}t.isTree=p},82961:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),Object.defineProperty(t,"BasicConfig",{enumerable:!0,get:function(){return g.default}}),t.BasicFuncs=void 0,Object.defineProperty(t,"Builder",{enumerable:!0,get:function(){return l.default}}),t.Operators=t.Import=t.Export=void 0,Object.defineProperty(t,"Query",{enumerable:!0,get:function(){return a.default}}),t.Widgets=t.Utils=void 0;var i=n(r(85707)),a=n(r(52835)),l=n(r(86893)),u=h(r(13040));t.Export=u;var s=h(r(30539));t.Import=s;var c=h(r(64072));t.Widgets=c;var d=h(r(91680));t.Operators=d;var f=h(r(35795)),p=h(r(63279));t.BasicFuncs=p;var g=n(r(26314));function v(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(v=function(e){return e?r:t})(e)}function h(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=v(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}function m(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function y(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?m(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):m(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var b=y(y(y({},f),u),s);t.Utils=b},98275:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var o=n(r(85959)).default.createContext();t.default=o},53438:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=n(r(18821)),a=n(r(85707)),l=n(r(37512)),u=r(53502),s=r(18313),c=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=y(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(55256)),d=n(r(58048)),f=r(40112),p=r(89112),g=r(98477),v=r(40056),h=n(r(24319)),m=n(r(9680));function y(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(y=function(e){return e?r:t})(e)}function b(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return E(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?E(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function E(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function O(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function S(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?O(Object(r),!0).forEach((function(t){(0,a.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):O(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var _=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,c=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{},f=i.settings.shouldCreateEmptyGroup,p=t.push(n),g=!f,v=!(null==c||!c.isDefaultCase),h=e;return(e=T(e,t,r,n,(0,s.defaultGroupProperties)(i).merge(o||{}),i,a))!==h&&(a||v||(e=e.setIn((0,u.expandTreePath)(p,"children1"),new l.default.OrderedMap),g&&(e=T(e,p,"rule",(0,d.default)(),(0,s.defaultRuleProperties)(i),i))),e=(0,u.fixPathsInTree)(e)),e},w=function e(t,r,n){n&&Array.isArray(n)&&(r.children1=new l.default.OrderedMap(n.reduce((function(r,n){var o=(0,d.default)(),i=S(S({},n),{},{properties:(0,s.defaultItemProperties)(t,n).merge(n.properties||{}),id:o});return e(t,i,i.children1),S(S({},r),{},(0,a.default)({},o,new l.default.Map(i)))}),{})))},T=function(e,t,r,n,o,i){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("switch_group"==r)throw new Error("Can't add switch_group programmatically");var c,d,f=i.settings,p=f.maxNumberOfCases,g=f.maxNumberOfRules,v=f.maxNesting,h="switch_group"==e.get("type"),m=e.getIn((0,u.expandTreePath)(t)),y=h?e.getIn((0,u.expandTreePath)(t.take(2))):null,b=(0,u.expandTreePath)(t,"children1"),E=e.getIn(b),O=!!E&&E.size,S=O?E.size:null;"case_group"==r?(c=S,d=p):"group"==r?(c=t.size,d=v):"rule_group"==(null==m?void 0:m.get("type"))||(c=h?(0,u.getTotalRulesCountInTree)(y):(0,u.getTotalRulesCountInTree)(e),d=g);var _=!d||!c||c<d,T={type:r,id:n,properties:o};w(i,T,s);var P="case_group"==r&&O&&null==E.last().get("children1");if(_){var C=new l.default.OrderedMap((0,a.default)({},n,new l.default.Map(T)));if(O)if(P){var I,A=E.last(),R=new l.default.OrderedMap((I={},(0,a.default)(I,n,new l.default.Map(T)),(0,a.default)(I,A.get("id"),A),I));e=(e=e.deleteIn((0,u.expandTreePath)(b,"children1",A.get("id")))).mergeIn(b,R)}else e=e.mergeIn(b,C);else e=e.setIn(b,C);e=(0,u.fixPathsInTree)(e)}return e},P=function(e,t){return e=e.deleteIn((0,u.expandTreePath)(t)),(0,u.fixPathsInTree)(e)},C={dragging:{id:null,x:null,y:null,w:null,h:null},mousePos:{},dragStart:{id:null}};t.default=function(e,t,r){var n=(0,s.defaultRoot)(e),o=S({tree:t||n},C);return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:o,n=arguments.length>1?arguments[1]:void 0,y={},E=function(e,t){var r=[c.SET_TREE,c.SET_DRAG_START,c.SET_DRAG_PROGRESS,c.SET_DRAG_END],n=(0,m.default)((0,h.default)(e,["config","asyncListValues","__isInternal"]),g.applyToJS),o=e.path&&function(e,t){return e.getIn((0,u.expandTreePath)(t,"properties","field"))||null}(t.tree,e.path)||e.field;return o&&(n.affectedField=o),(r.includes(e.type)||0==e.type.indexOf("@@redux"))&&(n=null),n}(n,t);switch(n.type){case c.SET_TREE:var O=r(n.config,n.tree);y.tree=O;break;case c.ADD_CASE_GROUP:y.tree=_(t.tree,n.path,"case_group",n.id,n.properties,n.config,n.children,n.meta);break;case c.ADD_GROUP:y.tree=_(t.tree,n.path,"group",n.id,n.properties,n.config,n.children,n.meta);break;case c.REMOVE_GROUP:y.tree=function(e,t,r){e=P(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.slice(0,-1);return!(0,u.hasChildren)(e,o)&&!n&&(e=(0,u.fixEmptyGroupsInTree)(e),(0,u.isEmptyTree)(e)&&!n&&(e=T(e,new l.default.List,"rule",(0,d.default)(),(0,s.defaultRuleProperties)(r),r))),(0,u.fixPathsInTree)(e)}(t.tree,n.path,n.config);break;case c.ADD_RULE:y.tree=T(t.tree,n.path,n.ruleType,n.id,n.properties,n.config,n.children);break;case c.REMOVE_RULE:y.tree=function(e,t,r){e=P(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.pop(),i=e.getIn((0,u.expandTreePath)(o)),a=i.getIn(["properties","field"]),c=i.getIn(["properties","operator"]),p=(i.getIn(["properties","value",0]),a?(0,f.getFieldConfig)(r,a):null),g=c?(0,f.getOperatorConfig)(r,c,a):null,v=a&&c&&0!=g.cardinality,h="rule_group"==i.get("type"),m=!(0,u.hasChildren)(e,o),y=h?v&&p.initialEmptyWhere:n;return m&&!y&&(h&&(e=e.deleteIn((0,u.expandTreePath)(o))),e=(0,u.fixEmptyGroupsInTree)(e),(0,u.isEmptyTree)(e)&&!n&&(e=T(e,new l.default.List,"rule",(0,d.default)(),(0,s.defaultRuleProperties)(r),r))),(0,u.fixPathsInTree)(e)}(t.tree,n.path,n.config);break;case c.SET_CONJUNCTION:y.tree=function(e,t,r){return e.setIn((0,u.expandTreePath)(t,"properties","conjunction"),r)}(t.tree,n.path,n.conjunction);break;case c.SET_NOT:y.tree=function(e,t,r){return e.setIn((0,u.expandTreePath)(t,"properties","not"),r)}(t.tree,n.path,n.not);break;case c.SET_FIELD:y.tree=function(e,t,r,n){if(!r)return P(e,t);var o=n.settings,i=o.fieldSeparator,a=o.setOpOnChangeField,c=o.showErrorMessage;Array.isArray(r)&&(r=r.join(i));var g=e.getIn((0,u.expandTreePath)(t,"type")),v=e.getIn((0,u.expandTreePath)(t,"properties")),h="rule_group"==g,m=(0,f.getFieldConfig)(n,r),y="!group"==m.type,E=y&&"array"==m.mode,O=h!=y,S=v.get("operator"),_=v.get("operatorOptions"),w=(v.get("field"),v.get("value"),v.get("valueSrc",new l.default.List),v.get("valueType",new l.default.List),m&&-1!==m.operators.indexOf(S)?S:null),C=null,I=(0,p.getOperatorsForField)(n,r);if(I&&1==I.length)C=I[0];else if(I&&I.length>1){var A,R=b(a||[]);try{for(R.s();!(A=R.n()).done;){var x=A.value;if("keep"!=x||O?"default"==x?C=(0,s.defaultOperator)(n,r,!1):"first"==x&&(C=(0,p.getFirstOperator)(n,r)):C=w,C)break}}catch(e){R.e(e)}finally{R.f()}}if(!y&&!m.operators)return console.warn("Type ".concat(m.type," is not supported")),e;if(h&&!y&&(e=(e=(e=e.setIn((0,u.expandTreePath)(t,"type"),"rule")).deleteIn((0,u.expandTreePath)(t,"children1"))).setIn((0,u.expandTreePath)(t,"properties"),new l.default.OrderedMap)),y){e=e.setIn((0,u.expandTreePath)(t,"type"),"rule_group");var N=(0,p.getNewValueForFieldOp)(n,n,v,r,C,"field",!0),D=(N.canReuseValue,N.newValue),L=N.newValueSrc,j=N.newValueType,M=N.operatorCardinality,k=(0,s.defaultGroupProperties)(n,m).merge({field:r,mode:m.mode});return E&&(k=k.merge({operator:C,value:D,valueSrc:L,valueType:j})),e=(e=e.setIn((0,u.expandTreePath)(t,"children1"),new l.default.OrderedMap)).setIn((0,u.expandTreePath)(t,"properties"),k),m.initialEmptyWhere&&1==M||(e=T(e,t,"rule",(0,d.default)(),(0,s.defaultRuleProperties)(n,r),n)),(0,u.fixPathsInTree)(e)}return e.updateIn((0,u.expandTreePath)(t,"properties"),(function(e){return e.withMutations((function(e){var t=(0,p.getNewValueForFieldOp)(n,n,e,r,C,"field",!0),o=t.canReuseValue,i=t.newValue,a=t.newValueSrc,l=t.newValueType,u=t.newValueError;c&&(e=e.set("valueError",u));var d=o?_:(0,s.defaultOperatorOptions)(n,C,r);return e.set("field",r).set("operator",C).set("operatorOptions",d).set("value",i).set("valueSrc",a).set("valueType",l).delete("asyncListValues")}))}))}(t.tree,n.path,n.field,n.config);break;case c.SET_LOCK:y.tree=function(e,t,r){return(0,u.removeIsLockedInTree)(e.setIn((0,u.expandTreePath)(t,"properties","isLocked"),r))}(t.tree,n.path,n.lock);break;case c.SET_OPERATOR:y.tree=function(e,t,r,n){var o=n.settings.showErrorMessage,i=e.getIn((0,u.expandTreePath)(t,"properties")),a=e.getIn((0,u.expandTreePath)(t,"children1")),c=i.get("field"),v="!group"==(0,f.getFieldConfig)(n,c).type,h=(0,f.getOperatorConfig)(n,r,c),m=h?(0,g.defaultValue)(h.cardinality,1):null;return e=e.updateIn((0,u.expandTreePath)(t,"properties"),(function(e){return e.withMutations((function(e){var t=e.get("field"),i=e.get("operatorOptions"),a=(e.get("value",new l.default.List),e.get("valueSrc",new l.default.List),e.get("operator"),(0,p.getNewValueForFieldOp)(n,n,e,t,r,"operator",!0)),u=a.canReuseValue,c=a.newValue,d=a.newValueSrc,f=a.newValueType,g=a.newValueError;o&&(e=e.set("valueError",g));var v=u?i:(0,s.defaultOperatorOptions)(n,r,t);return u||(e=e.delete("asyncListValues")),e.set("operator",r).set("operatorOptions",v).set("value",c).set("valueSrc",d).set("valueType",f)}))})),v&&0==m&&0==a.size&&(e=T(e,t,"rule",(0,d.default)(),(0,s.defaultRuleProperties)(n,c),n)),e}(t.tree,n.path,n.operator,n.config);break;case c.SET_VALUE:var w=function(e,t,r,n,o,a,s,c){var d,h=a.settings,m=h.fieldSeparator,y=h.showErrorMessage,b=e.getIn((0,u.expandTreePath)(t,"properties","valueSrc",r+""))||null;"field"===b&&Array.isArray(n)&&(n=n.join(m));var E=e.getIn((0,u.expandTreePath)(t,"properties","field"))||null,O=e.getIn((0,u.expandTreePath)(t,"properties","operator"))||null,S=(0,f.getOperatorConfig)(a,O,E),_=O?(0,g.defaultValue)(S.cardinality,1):null,w=o||function(e,t,r){var n=null;if(e)if("field"===t){var o=(0,f.getFieldConfig)(r,e);o&&(n=o.type)}else if("func"===t){var i=e.get("func");if(i){var a=(0,f.getFuncConfig)(r,i);a&&(n=a.returnType)}}return n}(n,b,a),T=(0,v.validateValue)(a,E,E,O,n,w,b,s,!1,!1),P=(0,i.default)(T,2),C=P[0],I=P[1],A=!C;if(I!==n&&(n=I),y){var R=(0,p.getWidgetForFieldOp)(a,E,O,b),x=(0,f.getFieldWidgetConfig)(a,E,O,R,b),N=Array.from({length:_},(function(r,n){return e.getIn((0,u.expandTreePath)(t,"properties","valueSrc",n+""))||null}));if(S&&S.validateValues&&N.filter((function(e){return"value"==e||null==e})).length==_){var D=Array.from({length:_},(function(o,i){return i==r?n:e.getIn((0,u.expandTreePath)(t,"properties","value",i+""))||null})),L=x&&x.toJS?D.map((function(e){return x.toJS(e,x)})):D,j=S.validateValues(L);e=e.setIn((0,u.expandTreePath)(t,"properties","valueError",_),j)}}e.getIn((0,u.expandTreePath)(t,"properties","value"))||(e=e.setIn((0,u.expandTreePath)(t,"properties","value"),new l.default.List(new Array(_))).setIn((0,u.expandTreePath)(t,"properties","valueType"),new l.default.List(new Array(_))).setIn((0,u.expandTreePath)(t,"properties","valueError"),new l.default.List(new Array(_))));var M=null==e.getIn((0,u.expandTreePath)(t,"properties","value",r+"")),k=!!e.getIn((0,u.expandTreePath)(t,"properties","valueError",r));return(A||y)&&(e=e.deleteIn((0,u.expandTreePath)(t,"properties","asyncListValues")),void 0===n?e=(e=e.setIn((0,u.expandTreePath)(t,"properties","value",r+""),void 0)).setIn((0,u.expandTreePath)(t,"properties","valueType",r+""),null):(s&&(e=e.setIn((0,u.expandTreePath)(t,"properties","asyncListValues"),s)),e=(e=e.setIn((0,u.expandTreePath)(t,"properties","value",r+""),n)).setIn((0,u.expandTreePath)(t,"properties","valueType",r+""),w),d=c&&!M&&!k)),y&&(e=e.setIn((0,u.expandTreePath)(t,"properties","valueError",r),C)),c&&(A&&k||!A&&!k)&&(e=e.setIn((0,u.expandTreePath)(t,"properties","valueError",r),C),d=!1),{tree:e,isInternalValueChange:d}}(t.tree,n.path,n.delta,n.value,n.valueType,n.config,n.asyncListValues,n.__isInternal),I=w.tree,A=w.isInternalValueChange;y.__isInternalValueChange=A,y.tree=I;break;case c.SET_VALUE_SRC:y.tree=function(e,t,r,n,o){var i=o.settings.showErrorMessage,a=e.getIn((0,u.expandTreePath)(t,"properties","field"))||null,l=e.getIn((0,u.expandTreePath)(t,"properties","operator"))||null;if(e=(e=(e=e.setIn((0,u.expandTreePath)(t,"properties","value",r+""),void 0)).setIn((0,u.expandTreePath)(t,"properties","valueType",r+""),null)).deleteIn((0,u.expandTreePath)(t,"properties","asyncListValues")),i){e=e.setIn((0,u.expandTreePath)(t,"properties","valueError",r),null);var s=(0,f.getOperatorConfig)(o,l,a),c=l?(0,g.defaultValue)(s.cardinality,1):null;s.validateValues&&(e=e.setIn((0,u.expandTreePath)(t,"properties","valueError",c),null))}if(e=void 0===n?e.setIn((0,u.expandTreePath)(t,"properties","valueSrc",r+""),null):e.setIn((0,u.expandTreePath)(t,"properties","valueSrc",r+""),n),n){var d=e.getIn((0,u.expandTreePath)(t,"properties")),v=(0,p.getNewValueForFieldOp)(o,o,d,a,l,"valueSrc",!0),h=v.canReuseValue,m=v.newValue,y=v.newValueSrc,b=v.newValueType;v.newValueError,h||y.get(r)!=n||(e=(e=e.setIn((0,u.expandTreePath)(t,"properties","value",r+""),m.get(r))).setIn((0,u.expandTreePath)(t,"properties","valueType",r+""),b.get(r)))}return e}(t.tree,n.path,n.delta,n.srcKey,n.config);break;case c.SET_OPERATOR_OPTION:y.tree=function(e,t,r,n){return e.setIn((0,u.expandTreePath)(t,"properties","operatorOptions",r),n)}(t.tree,n.path,n.name,n.value);break;case c.MOVE_ITEM:y.tree=function(e,t,r,n){var o=(0,u.getItemByPath)(e,t),s=t.pop(),d=t.size>1?(0,u.getItemByPath)(e,s):null,f=d?d.get("children1"):null,p=(0,u.getItemByPath)(e,r),v=n==c.PLACEMENT_APPEND||n==c.PLACEMENT_PREPEND?r:r.pop(),h=n==c.PLACEMENT_APPEND||n==c.PLACEMENT_PREPEND?p:r.size>1?(0,u.getItemByPath)(e,v):null,m=h?h.get("children1"):null;if(!d||!h||!o)return e;var y=d.get("id")==h.get("id"),E=v.size<s.size&&(0,g.deepEqual)(v.toArray(),s.toArray().slice(0,v.size)),O=v.size>s.size&&(0,g.deepEqual)(s.toArray(),v.toArray().slice(0,s.size)),S=null,_=null;E?S=l.default.List(s.toArray().slice(v.size)):O&&(_=l.default.List(v.toArray().slice(s.size)));var w=m,T=f;return O||(T=T.delete(o.get("id"))),y?w=T:E&&(w=w.updateIn((0,u.expandTreeSubpath)(S,"children1"),(function(e){return T}))),n==c.PLACEMENT_BEFORE||n==c.PLACEMENT_AFTER?w=l.default.OrderedMap().withMutations((function(e){var t,r=b(w.entries());try{for(r.s();!(t=r.n()).done;){var a=(0,i.default)(t.value,2),l=a[0],u=a[1];l==p.get("id")&&n==c.PLACEMENT_BEFORE&&e.set(o.get("id"),o),e.set(l,u),l==p.get("id")&&n==c.PLACEMENT_AFTER&&e.set(o.get("id"),o)}}catch(e){r.e(e)}finally{r.f()}})):n==c.PLACEMENT_APPEND?w=w.merge((0,a.default)({},o.get("id"),o)):n==c.PLACEMENT_PREPEND&&(w=l.default.OrderedMap((0,a.default)({},o.get("id"),o)).merge(w)),O&&(T=(T=T.updateIn((0,u.expandTreeSubpath)(_,"children1"),(function(e){return w}))).delete(o.get("id"))),y||E||(e=e.updateIn((0,u.expandTreePath)(s,"children1"),(function(e){return T}))),O||(e=e.updateIn((0,u.expandTreePath)(v,"children1"),(function(e){return w}))),(0,u.fixPathsInTree)(e)}(t.tree,n.fromPath,n.toPath,n.placement,n.config);break;case c.SET_DRAG_START:y.dragStart=n.dragStart,y.dragging=n.dragging,y.mousePos=n.mousePos;break;case c.SET_DRAG_PROGRESS:y.mousePos=n.mousePos,y.dragging=n.dragging;break;case c.SET_DRAG_END:y.tree=function(e,t){return t.settings.canLeaveEmptyGroup||(e=(0,u.fixEmptyGroupsInTree)(e)),e}(t.tree,e),y=S(S({},y),C)}return E&&(y.__lastAction=E),S(S(S({},t),{__isInternalValueChange:void 0,__lastAction:void 0}),y)}}},13875:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.simulateAsyncFetch=t.mergeListValues=t.listValueToOption=t.getListValue=void 0;var o=n(r(61790)),i=n(r(10906)),a=n(r(58155)),l=r(98477);t.simulateAsyncFetch=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1e3;return function(){var n=(0,a.default)(o.default.mark((function n(i,a,u){var s,c,d,f,p,g;return o.default.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return s=null!=u.pageSize?u.pageSize:t,c=(0,l.listValuesToArray)(e).filter((function(e){var t=e.title;return null==i||-1!=t.toUpperCase().indexOf(i.toUpperCase())})),s&&Math.ceil(c.length/s),d=a||0,s&&Math.ceil(d/s),f=s?c.slice(d,d+s):c,p=s?d+f.length:null,g=!!s&&p<c.length,console.debug("simulateAsyncFetch",{search:i,offset:a,values:f,hasMore:g,filtered:c}),n.next=11,(0,l.sleep)(r);case 11:return n.abrupt("return",{values:f,hasMore:g});case 12:case"end":return n.stop()}}),n)})));return function(e,t,r){return n.apply(this,arguments)}}()},t.mergeListValues=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(!t)return e;var n=e||[],o=t.filter((function(e){return null==n.find((function(t){return t.value==e.value}))}));return r?[].concat((0,i.default)(o),(0,i.default)(n)):[].concat((0,i.default)(n),(0,i.default)(o))},t.listValueToOption=function(e){if(null==e)return null;var t=e.title,r=e.value,n=e.disabled,o=e.groupTitle,i=e.renderTitle,a={title:t,value:r};return n&&(a.disabled=n),o&&(a.groupTitle=o),i&&(a.renderTitle=i),a},t.getListValue=function(e,t){return(0,l.mapListValues)(t,(function(t){return t.value===e?t:null})).filter((function(e){return null!==e})).shift()}},40112:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeField=t.getOperatorConfig=t.getFuncConfig=t.getFuncArgConfig=t.getFieldWidgetConfig=t.getFieldRawConfig=t.getFieldConfig=t.extendConfig=t.createConfigMemo=void 0;var o=n(r(10906)),i=n(r(85707)),a=n(r(10564)),l=n(r(25632)),u=n(r(58048)),s=n(r(89032)),c=r(74837),d=n(r(92468)),f=r(98477),p=r(89112),g=n(r(19999)),v=n(r(67171));function h(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function m(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return y(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?y(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function y(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var b=["conjunctions","fields","types","operators","widgets","settings","funcs"];t.createConfigMemo=function(){var e=new Map,t=0;return function(r){return n=function(e){return(0,v.default)(e,b)}(r),function(t){var r,n=m(e.keys());try{var o=function(){var n=r.value;if(0===b.map((function(e){return n[e]===t[e]})).filter((function(e){return!e})).length)return{v:e.get(n)}};for(n.s();!(r=n.n()).done;){var i=o();if("object"===(0,a.default)(i))return i.v}}catch(e){n.e(e)}finally{n.f()}var l,u=m(e.values());try{var s=function(){var e=l.value;if(0===b.map((function(r){return e[r]===t[r]})).filter((function(e){return!e})).length)return{v:e}};for(u.s();!(l=u.n()).done;){var c=s();if("object"===(0,a.default)(c))return c.v}}catch(e){u.e(e)}finally{u.f()}return null}(n)||function(r){var n=E(r,++t);return e.size+1>2&&e.delete(e.keys()[0]),e.set(r,n),n}(n);var n}};var E=function(e,t){return e.__configId||(e=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?h(Object(r),!0).forEach((function(t){(0,i.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},e),e.settings=(0,l.default)({},c.settings,e.settings),e._fieldsCntByType={},e._funcsCntByType={},e.types=(0,g.default)(e.types),function(e,t){for(var r in e)O(0,e[r],t)}(e.types,e),e.fields=(0,g.default)(e.fields),e.__fieldNames={},S(e.fields,e),e.funcs=(0,g.default)(e.funcs),_(e.funcs,e),d.default.locale(e.settings.locale.moment),Object.defineProperty(e,"__configId",{enumerable:!1,writable:!1,value:t||(0,u.default)()})),e};function O(e,t,r){var n=null,o=null;for(var i in t.mainWidget=t.mainWidget||Object.keys(t.widgets).filter((function(e){return"field"!=e&&"func"!=e}))[0],t.widgets){var a=t.widgets[i];if(a.operators){var u=a.operators;t.excludeOperators&&(u=u.filter((function(e){return!t.excludeOperators.includes(e)}))),n=(0,f.mergeArraysSmart)(n,u)}a.defaultOperator&&(o=a.defaultOperator),i==t.mainWidget&&(a=(0,l.default)({},{widgetProps:t.mainWidgetProps||{}},a)),t.widgets[i]=a}t.valueSources||(t.valueSources=Object.keys(r.settings.valueSourcesInfo));var s,c=m(t.valueSources);try{for(c.s();!(s=c.n()).done;){var d=s.value;"value"==d||t.widgets[d]||(t.widgets[d]={})}}catch(e){c.e(e)}finally{c.f()}!t.operators&&n&&(t.operators=Array.from(new Set(n))),!t.defaultOperator&&o&&(t.defaultOperator=o)}function S(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];for(var n in e)w(e[n],t,[].concat((0,o.default)(r),[n])),e[n].subfields&&S(e[n].subfields,t,[].concat((0,o.default)(r),[n]))}function _(e,t){if(e)for(var r in e){var n=e[r];for(var o in n.returnType&&(t._funcsCntByType[n.returnType]||(t._funcsCntByType[n.returnType]=0),t._funcsCntByType[n.returnType]++),n.args)w(n.args[o],t,null,!0);if(n.args){var i,a=!0,l=m(Object.keys(n.args).reverse());try{for(l.s();!(i=l.n()).done;){var u=i.value,s=n.args[u];!a&&s.isOptional&&delete s.isOptional,s.isOptional||(a=!1)}}catch(e){l.e(e)}finally{l.f()}}n.subfields&&_(n.subfields,t)}}function w(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=null,a=null,u=t.types[e.type],s=e.excludeOperators||[];if("!struct"!=e.type&&"!group"!=e.type){e.fieldSettings||(e.fieldSettings={});for(var c=0,d=["listValues","allowCustomValues","validateValue"];c<d.length;c++){var p=d[c];e[p]&&(e.fieldSettings[p]=e[p],delete e[p])}if(e.fieldSettings.listValues&&(e.fieldSettings.listValues=(0,f.normalizeListValues)(e.fieldSettings.listValues,e.type,e.fieldSettings)),!u)return void(e.disabled=!0);n||(t._fieldsCntByType[e.type]||(t._fieldsCntByType[e.type]=0),t._fieldsCntByType[e.type]++),e.widgets||(e.widgets={}),n&&(e._isFuncArg=!0),e.mainWidget=e.mainWidget||u.mainWidget,e.valueSources=e.valueSources||u.valueSources;var g=u.excludeOperators||[],v=function(){var t=e.widgets[h]||{},r=u.widgets[h]||{};if(!n){var c=[].concat((0,o.default)(s),(0,o.default)(g)),d=e.preferWidgets&&("field"==h||e.preferWidgets.includes(h))||c.length>0;if(t.operators){var f=t.operators.filter((function(e){return!c.includes(e)}));i=[].concat((0,o.default)(i||[]),(0,o.default)(f))}else if(d&&r.operators){var p=r.operators.filter((function(e){return!c.includes(e)}));i=[].concat((0,o.default)(i||[]),(0,o.default)(p))}t.defaultOperator&&(a=t.defaultOperator)}h==e.mainWidget&&(t=(0,l.default)({},{widgetProps:e.mainWidgetProps||{}},t)),e.widgets[h]=t};for(var h in u.widgets)v();n||(!e.operators&&i&&(e.operators=Array.from(new Set(i))),!e.defaultOperator&&a&&(e.defaultOperator=a))}var m=P(t,r);m&&(e.fieldName=m),r&&e.fieldName&&(t.__fieldNames[e.fieldName]=r)}t.extendConfig=E;var T=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"fields",n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";if(!t)return null;if("!case_value"==t)return{type:"case_value",mainWidget:"case_value",widgets:{case_value:e.widgets.case_value}};var o=e.settings.fieldSeparator,i=Array.isArray(t)?t:t.split(o),a=e[r];if(!a)return null;for(var l=a,u=null,s=[],c=0;c<i.length;c++){var d=i[c];s.push(d),u=l[s.join(o)],c<i.length-1&&(u&&u[n]?(l=u[n],s=[]):u=null)}return u};t.getFieldRawConfig=T;var P=function(e,t){if(!t)return null;for(var r,n,i=e.settings.fieldSeparator,a=(0,o.default)(t),l=[];void 0!==(r=a.pop())&&a.length>0;)if(l.unshift(r),(n=T(e,a)).fieldName)return[n.fieldName].concat(l).join(i);return null};t.normalizeField=function(e,t){var r=e.settings.fieldSeparator,n=Array.isArray(t)?t.join(r):t;return e.__fieldNames[n]?e.__fieldNames[n].join(r):n};var C=function(e,t){return t&&T(e,t,"funcs","subfields")||null};t.getFuncConfig=C;var I=function(e,t,r){var n=C(e,t);if(!n)return null;var o=n.args&&n.args[r]||null;if(!o)return null;var i=e.types[o.type]||{};return(0,s.default)({},i,o||{},(function(e,t,r,n,o,i){if(Array.isArray(e))return t}))};t.getFuncArgConfig=I;var A=function(e,t){if(!t)return null;if("object"==(0,a.default)(t)&&!t.func&&t.type)return t;if("object"==(0,a.default)(t)&&t.func&&t.arg)return I(e,t.func,t.arg);var r=T(e,t);if(!r)return null;var n=e.types[r.type]||{};return(0,s.default)({},n,r||{},(function(e,t,r,n,o,i){if(Array.isArray(e))return t}))};t.getFieldConfig=A,t.getOperatorConfig=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return null;var n=e.operators[t];if(r){var o=A(e,r),i=(0,p.getWidgetForFieldOp)(e,r,t),a=e.widgets[i]||{},u=(o&&o.widgets?o.widgets[i]:{})||{},s=(a.opProps||{})[t],c=(u.opProps||{})[t];return(0,l.default)({},n,s,c)}return n},t.getFieldWidgetConfig=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!t)return null;if(!r&&!n&&"const"!=o&&"!case_value"!=t)return null;var i=A(e,t);n||(n=(0,p.getWidgetForFieldOp)(e,t,r,o));var a=e.widgets[n]||{},u=((i&&i.widgets?i.widgets[n]:{})||{}).widgetProps||{},s=("value"==o||!o)&&i&&i.fieldSettings||{};return(0,l.default)({},a,u,s)}},18313:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.defaultRuleProperties=t.defaultRule=t.defaultRoot=t.defaultOperatorOptions=t.defaultOperator=t.defaultItemProperties=t.defaultGroupProperties=t.defaultGroupConjunction=t.defaultField=t.defaultConjunction=void 0;var o=n(r(85707)),i=n(r(37512)),a=n(r(58048)),l=r(40112),u=r(89112);function s(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function c(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?s(Object(r),!0).forEach((function(t){(0,o.default)(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):s(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var d=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;return"function"==typeof e.settings.defaultField?e.settings.defaultField(r):e.settings.defaultField||(t?(0,u.getFirstField)(e,r):null)};t.defaultField=d;var f=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=(0,l.getFieldConfig)(e,t),o=n&&n.operators||[],i=n&&n.defaultOperator;return o.includes(i)||(i=null),!i&&r&&(i=(0,u.getFirstOperator)(e,t)),"function"==typeof e.settings.defaultOperator?e.settings.defaultOperator(t,n):i};t.defaultOperator=f;var p=function(e,t,r){var n=t?(0,l.getOperatorConfig)(e,t,r):null;return n&&n.options?new i.default.Map(n.options&&n.options.defaults||{}):null};t.defaultOperatorOptions=p;var g=function(e){var t,r,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,a=null,l=null,s=e.settings,c=s.setDefaultFieldAndOp,g=s.showErrorMessage;o?(a=null==o||null===(t=o.properties)||void 0===t?void 0:t.field,l=null==o||null===(r=o.properties)||void 0===r?void 0:r.operator):c&&(a=d(e,!0,n),l=f(e,a));var v=new i.default.Map({field:a,operator:l,value:new i.default.List,valueSrc:new i.default.List,operatorOptions:p(e,l,a)});if(g&&(v=v.set("valueError",new i.default.List)),a&&l){var h=(0,u.getNewValueForFieldOp)(e,e,v,a,l,"operator",!1),m=h.newValue,y=h.newValueSrc,b=h.newValueType,E=h.newValueError;v=v.set("value",m).set("valueSrc",y).set("valueType",b),g&&(v=v.set("valueError",E))}return v};t.defaultRuleProperties=g;var v=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(t=(0,l.getFieldConfig)(e,t))&&t.conjunctions||Object.keys(e.conjunctions);return 1==r.length?r[0]:e.settings.defaultGroupConjunction||e.settings.defaultConjunction||r[0]};t.defaultGroupConjunction=v,t.defaultConjunction=function(e){return e.settings.defaultConjunction||Object.keys(e.conjunctions)[0]};var h=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return new i.default.Map({conjunction:v(e,t),not:!1})};t.defaultGroupProperties=h,t.defaultItemProperties=function(e,t){var r;return t&&"group"==t.type?h(e,null==t||null===(r=t.properties)||void 0===r?void 0:r.field):g(e,null,t)};var m=function(e,t){return(0,o.default)({},e,new i.default.Map({type:"rule",id:e,properties:g(t)}))};t.defaultRule=m,t.defaultRoot=function(e){return new i.default.Map({type:"group",id:(0,a.default)(),children1:new i.default.OrderedMap(c({},m((0,a.default)(),e))),properties:h(e)})}},22777:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.sqlEmptyValue=t.spelImportConcat=t.spelFormatConcat=t.spelFixList=t.spelEscape=t.mongoEmptyValue=t.SqlString=void 0;var o=n(r(10564)),i=r(41194);t.SqlString=i,i.trim=function(e){return"'"==e.charAt(0)?e.substring(1,e.length-1):e},i.escapeLike=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=i.escape(e);return"'"+(n=(t?"%":"")+(n=(n=i.trim(n)).replace(/[%_]/g,"\\$&"))+(r?"%":""))+"'"},t.sqlEmptyValue=function(e){var t="''",r=null==e?void 0:e.type;return"date"==r?t="'0000-00-00'":"datetime"==r?t="'0000-00-00 00:00'":"time"==r?t="'00:00'":"number"==r&&(t="0"),t},t.mongoEmptyValue=function(e){var t="";return"number"==(null==e?void 0:e.type)&&(t=0),t};t.spelFixList=function(e){return"".concat(e,".?[true]")};var a=function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==e)return"null";switch((0,o.default)(e)){case"boolean":return e?"true":"false";case"number":if(!Number.isFinite(e)||isNaN(e))return;return e+(!Number.isInteger(e)||t?"f":"");case"object":if(Array.isArray(e))return function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=["int","float"];return e.map((function(e){if(null!=e){if("string"==typeof e)r="String";else{if("number"!=typeof e)throw new Error("spelEscape: Can't use value ".concat(e," in array"));r=Number.isInteger(e)?"int":"float"}if(t){if(t!=r){if(!i.includes(t)||!i.includes(r))throw new Error("spelEscape: Can't use different types in array: found ".concat(t," and ").concat(r));t="float"}}else t=r}})),t||(t="String"),n="float"==t?e.map((function(e){return a(e,!0)})):e.map((function(e){return a(e)})),o?"new ".concat(t,"[]{").concat(n.join(", "),"}"):"{".concat(n.join(", "),"}")}(e,r);throw new Error("spelEscape: Object is not supported");default:return function(e){return"'"+e.replace(/'/g,"''")+"'"}(e)}};t.spelEscape=a,t.spelFormatConcat=function(e){return e&&Array.isArray(e)&&e.length?e.map((function(e){return"const"==e.type?a(e.value):"property"==e.type?""+e.value:"variable"==e.type?"#"+e.value:void 0})).filter((function(e){return null!=e})).join(" + "):"null"},t.spelImportConcat=function(e){if(null==e)return[void 0,[]];var t=[];return[("case_value"==e.valueType?e.value:[e]).map((function(e){return"value"==e.valueSrc?null===e.value?void 0:{type:"const",value:e.value}:"field"==e.valueSrc?{type:e.isVariable?"variable":"property",value:e.value}:void t.push("Unsupported valueSrc ".concat(e.valueSrc," in concatenation"))})).filter((function(e){return null!=e})),t]}},63968:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.setFunc=t.setArgValueSrc=t.setArgValue=t.completeValue=t.completeFuncValue=void 0;var o=n(r(10564)),i=r(40112),a=r(89112),l=n(r(37512)),u=function(e){return"object"==(0,o.default)(e)&&null!==e&&!Array.isArray(e)},s=function(e,t,r){return"func"==t?c(e,r):e};t.completeValue=s;var c=function(e,t){return function(e){if(e){var r=e.get("func"),n=r&&(0,i.getFuncConfig)(t,r);if(n){var o=e,l=!1;for(var c in n.args){var f=n.args[c],p=f.valueSources,g=f.isOptional,v=f.defaultValue,h=(0,a.filterValueSourcesForField)(t,p,f),m=o.get("args"),y=1==h.length?h[0]:void 0,b=m?m.get(c):void 0,E=b?b.get("value"):void 0,O=(b?b.get("valueSrc"):void 0)||y;if(void 0!==E){var S=s(E,O,t);if(void 0===S)return;if(S!==E&&(o=o.setIn(["args",c,"value"],S)),l)return}else if(void 0===v||u(v)){if(!g)return;l=!0}else o=(o=o.setIn(["args",c,"value"],d(f))).setIn(["args",c,"valueSrc"],"value")}return o}}}(e)};t.completeFuncValue=c,t.setFunc=function(e,t,r){var n=r.settings.fieldSeparator;e=e||new l.default.Map,Array.isArray(t)&&(t=t.join(n)),e=(e=e.set("func",t)).set("args",new l.default.Map);var o=t&&(0,i.getFuncConfig)(r,t);if(o)for(var s in o.args){var c=o.args[s],f=c.valueSources,p=c.defaultValue,g=(0,a.filterValueSourcesForField)(r,f,c),v=g.length?g[0]:void 0,h=(p?u(p)&&p.func?"func":"value":void 0)||v;void 0!==p&&(e=e.setIn(["args",s,"value"],d(c))),h&&(e=e.setIn(["args",s,"valueSrc"],h))}return e};var d=function(e){var t=e.defaultValue;return u(t)&&!l.default.Map.isMap(t)&&t.func?l.default.fromJS(t,(function(e,t){return l.default.Iterable.isIndexed(t)?t.toList():t.toOrderedMap()})):t};t.setArgValue=function(e,t,r,n,o){if(e&&e.get("func")){e=e.setIn(["args",t,"value"],r);var i=n.valueSources,l=(0,a.filterValueSourcesForField)(o,i,n),u=1==l.length?l[0]:void 0;u&&(e=e.setIn(["args",t,"valueSrc"],u))}return e},t.setArgValueSrc=function(e,t,r,n,o){return e&&e.get("func")&&(e=e.setIn(["args",t],new l.default.Map({valueSrc:r}))),e}},35795:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.TreeUtils=t.ExportUtils=t.DefaultUtils=t.ConfigUtils=void 0,Object.defineProperty(t,"getSwitchValues",{enumerable:!0,get:function(){return c.getSwitchValues}}),Object.defineProperty(t,"simulateAsyncFetch",{enumerable:!0,get:function(){return a.simulateAsyncFetch}}),Object.defineProperty(t,"uuid",{enumerable:!0,get:function(){return l.default}}),Object.defineProperty(t,"validateTree",{enumerable:!0,get:function(){return i.validateTree}});var i=r(40056),a=r(13875),l=n(r(58048)),u=p(r(40112));t.ConfigUtils=u;var s=p(r(18313));t.DefaultUtils=s;var c=p(r(53502));t.TreeUtils=c;var d=p(r(22777));function f(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(f=function(e){return e?r:t})(e)}function p(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=f(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}t.ExportUtils=d},92895:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.useOnPropsChanged=t.pureShouldComponentUpdate=t.liteShouldComponentUpdate=t.isUsingLegacyReactDomRender=t.bindActionCreators=void 0;var o=n(r(85959)),i=n(r(9680)),a=r(98477),l=function e(t){if(t){var r,n=(r=t)._reactRootContainer?"root":Object.getOwnPropertyNames(r).filter((function(e){return e.startsWith("__reactContainer")})).length>0?"container":void 0;return void 0!==n?n:e(t.parentNode)}};t.isUsingLegacyReactDomRender=function(e){return"root"===l(e)},t.liteShouldComponentUpdate=function(e,t){return function(r,n){var o=e.props,i=e.state,l=r!=o||n!=i;if(l&&i==n&&o!=r){var u=[];for(var s in r){var c=r[s]!=o[s];c&&("ignore"==t[s]?c=!1:"shallow_deep"==t[s]?c=!(0,a.shallowEqual)(r[s],o[s],!0):"shallow"==t[s]?c=!(0,a.shallowEqual)(r[s],o[s]):"function"==typeof t[s]&&(c=t[s](r[s],o[s],n))),c&&u.push(s)}u.length||(l=!1)}return l}},t.pureShouldComponentUpdate=function(e){return function(t,r){return!(0,a.shallowEqual)(e.props,t)||!(0,a.shallowEqual)(e.state,r)}};var u=function(){var e=o.default.version.split(".").map(parseInt.bind(null,10));return 16==e[0]&&e[1]>=3||e[0]>16};t.useOnPropsChanged=function(e){u?e.UNSAFE_componentWillReceiveProps=function(t){e.onPropsChanged(t)}:e.componentWillReceiveProps=function(t){e.onPropsChanged(t)}},t.bindActionCreators=function(e,t,r){return(0,i.default)(e,(function(e){return function(){for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];return r(e.apply(void 0,[t].concat(o)))}}))}},89112:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.getWidgetsForFieldOp=t.getWidgetForFieldOp=t.getValueSourcesForFieldOp=t.getValueLabel=t.getOperatorsForField=t.getNewValueForFieldOp=t.getFuncPathLabels=t.getFirstOperator=t.getFirstField=t.getFieldPathLabels=t.getFieldPath=t.getFieldPartsConfigs=t.formatFieldName=t.filterValueSourcesForField=void 0;var o=n(r(10564)),i=n(r(10906)),a=n(r(18821)),l=r(40112),u=r(98477),s=n(r(37512)),c=r(40056),d=n(r(75342)),f=["select","multiselect","treeselect","treemultiselect"];t.getNewValueForFieldOp=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=arguments.length>2?arguments[2]:void 0,n=arguments.length>3?arguments[3]:void 0,o=arguments.length>4?arguments[4]:void 0,i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,d=!(arguments.length>6&&void 0!==arguments[6])||arguments[6],p=arguments.length>7&&void 0!==arguments[7]&&arguments[7];t||(t=e);var g=r.get("field"),v=r.get("operator"),h=r.get("value"),b=r.get("valueSrc",new s.default.List),E=r.get("valueType",new s.default.List),O=r.get("asyncListValues"),S=e.settings,_=S.convertableWidgets,w=S.clearValueOnChangeField,T=S.clearValueOnChangeOp,P=S.showErrorMessage,C=(0,l.getOperatorConfig)(e,o,n),I=o?(0,u.defaultValue)(C.cardinality,1):null,A=(0,l.getFieldConfig)(t,g),R=(0,l.getFieldConfig)(e,n),x=g&&v&&o&&null!=h&&(!i||"field"==i&&!w||"operator"==i&&!T)&&A&&R&&A.type==R.type;x&&f.includes(A.type)&&"field"==i&&(x=!1);for(var N=0;N<I;N++){var D=b.get(N)||null,L=y(t,g,v,D),j=y(e,n,o,D),M="value"==D?L:y(t,g,v,"value"),k="value"==D?j:y(e,n,o,"value");k==M||(_[M]||[]).includes(k)||(x=!1)}v!=o&&[v,o].includes("proximity")&&(x=!1);var F=(0,l.getFieldWidgetConfig)(e,n,o,null,b.first()),q=m(e,n,o),V={},B=Array.from({length:I},(function(){return null}));if(x)for(var U=function(){var t=h.get(W),r=E.get(W)||null,l=b.get(W)||null,u=null!=q.find((function(e){return e==l}));!u&&W>0&&null==l&&(u=!0);var s=O,f=(0,c.validateValue)(e,n,n,o,t,r,l,s,d,p),g=(0,a.default)(f,2),v=g[0],m=g[1],y=m!==t,S=!u||!!v&&("field"==i||!P&&!y);if(!!v&&P&&!S&&!y&&(B[W]=v),y&&(V[W]=m),S)return x=!1,"break"},W=0;W<I&&"break"!==U();W++);var G,H=null,K=null,$=null;if(H=new s.default.List(Array.from({length:I},(function(e,t){var r=void 0;if(x)t<h.size&&(r=h.get(t),void 0!==V[t]&&(r=V[t]));else if(1==I){var n;r=(0,u.getFirstDefined)([null==R?void 0:R.defaultValue,null==R||null===(n=R.fieldSettings)||void 0===n?void 0:n.defaultValue,null==F?void 0:F.defaultValue])}return r}))),K=new s.default.List(Array.from({length:I},(function(e,t){var r=null;return x?t<b.size&&(r=b.get(t)):(1==q.length||q.length>1)&&(r=q[0]),r}))),P){if(C&&C.validateValues&&K.toJS().filter((function(e){return"value"==e||null==e})).length==I){var z=F&&F.toJS?H.toJS().map((function(e){return F.toJS(e,F)})):H.toJS(),Y=C.validateValues(z);P&&B.push(Y)}$=new s.default.List(B)}return G=new s.default.List(Array.from({length:I},(function(e,t){var r=null;return x?t<E.size&&(r=E.get(t)):1==I&&F&&void 0!==F.type?r=F.type:1==I&&R&&void 0!==R.type&&(r="!group"==R.type?"number":R.type),r}))),{canReuseValue:x,newValue:H,newValueSrc:K,newValueType:G,newValueError:$,operatorCardinality:I}},t.getFirstField=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=e.settings.fieldSeparator,n="string"==typeof t?t.split(r):t,o=t?(0,l.getFieldRawConfig)(e,t):e,i=null,a=[];do{var u=o===e?e.fields:o.subfields;if(!u||!Object.keys(u).length){o=i=null;break}i=Object.keys(u)[0],a.push(i),o=u[i]}while("!struct"==o.type||"!group"==o.type);return(n||[]).concat(a).join(r)};var p=function(e,t){var r=(0,l.getFieldConfig)(e,t);return r?r.operators:[]};t.getOperatorsForField=p,t.getFirstOperator=function(e,t){var r=p(e,t);return r?r[0]:null},t.getFieldPath=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(!e)return null;var n=t.settings.fieldSeparator,o=Array.isArray(e)?e:e.split(n);return r?o:o.map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return e.join(n)}))},t.getFuncPathLabels=function(e,t){return g(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,"funcs","subfields")};var g=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"fields",o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"subfields";if(!e)return null;var a=t.settings.fieldSeparator,u=Array.isArray(e)?e:e.split(a),s=r?Array.isArray(r)?r:r.split(a):[];return u.slice(s.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return[].concat((0,i.default)(s),(0,i.default)(e)).join(a)})).map((function(e){var r=(0,l.getFieldRawConfig)(t,e,n,o);return r&&r.label||r&&(0,d.default)(e.split(a))})).filter((function(e){return null!=e}))};function v(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=[],a=[];if(!t)return{widgets:i,valueSrcs:a};var u="object"==(0,o.default)(t)&&(!!t.func&&!!t.arg||t._isFuncArg),s=(0,l.getFieldConfig)(e,t),c=r?e.operators[r]:null;if(s&&s.widgets){var d=function(){var o=s.widgets[f],l=e.widgets[f].valueSrc||"value",d=!0;if("field"==f&&(d=d&&h(e,["field"],s).length>0),"func"==f&&(d=d&&h(e,["func"],s).length>0),"value"!=n||o.operators||u||"!case_value"==t||(d=!1),o.operators&&r&&(d=d&&-1!=o.operators.indexOf(r)),n&&n!=l&&"const"!=n&&(d=!1),c&&0==c.cardinality&&"value"!=l&&(d=!1),d){i.push(f);var p=s.valueSources&&-1!=s.valueSources.indexOf(l);c&&c.valueSources&&-1==c.valueSources.indexOf(l)&&(p=!1),p&&!a.find((function(e){return e==l}))&&a.push(l)}};for(var f in s.widgets)d()}var p=function(e){var t=0;return s.preferWidgets?s.preferWidgets.includes(e)&&(t+=10-s.preferWidgets.indexOf(e)):e==s.mainWidget&&(t+=100),"field"==e&&(t-=1),"func"==e&&(t-=2),t};return i.sort((function(e,t){return p(t)-p(e)})),{widgets:i,valueSrcs:a}}t.getFieldPathLabels=g,t.getFieldPartsConfigs=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!e)return null;var n=r&&(0,l.getFieldRawConfig)(t,r)||null,o=t.settings.fieldSeparator,a=Array.isArray(e)?e:e.split(o),u=r?Array.isArray(r)?r:r.split(o):[];return a.slice(u.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return{part:[].concat((0,i.default)(u),(0,i.default)(e)).join(o),key:e[e.length-1]}})).map((function(e){var r=e.part;return{key:e.key,cnf:(0,l.getFieldRawConfig)(t,r)}})).map((function(e,t,r){return[e.key,e.cnf,t>0?r[t-1].cnf:n]}))},t.getValueLabel=function(e,t,r,n){var i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]&&arguments[5],u=t&&"object"==(0,o.default)(t)&&!!t.func&&!!t.arg,s=e.settings.showLabels,c=(0,l.getFieldConfig)(e,t),d=(0,l.getFieldWidgetConfig)(e,t,r,null,i)||{},f=(0,l.getOperatorConfig)(e,r,t)||{},p=null;if((a?1:f.cardinality)>1){var g=d.valueLabels||f.valueLabels;g&&(p=g[n]),p&&"object"!=(0,o.default)(p)&&(p={label:p,placeholder:p}),p||(p={label:e.settings.valueLabel+" "+(n+1),placeholder:e.settings.valuePlaceholder+" "+(n+1)})}else{var v=d.valueLabel,h=d.valuePlaceholder;u&&(v||(v=c.label||t.arg),h||s||(h=c.label||t.arg)),p={label:v||e.settings.valueLabel,placeholder:h||e.settings.valuePlaceholder}}return p},t.getWidgetsForFieldOp=function(e,t,r){return v(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets};var h=function(e,t,r){return r?t.filter((function(t){var n=!0;if("field"==t&&e._fieldsCntByType){var o=r._isFuncArg?0:1;n=n&&e._fieldsCntByType[r.type]>o}return"func"==t&&(e._funcsCntByType&&(n=n&&!!e._funcsCntByType[r.type]),r.funcs&&(n=n&&r.funcs.length>0)),n})):t};t.filterValueSourcesForField=h;var m=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=v(e,t,r,null).valueSrcs;return h(e,o,n)};t.getValueSourcesForFieldOp=m;var y=function(e,t,r){var n=v(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets,o=null;return n.length&&(o=n[0]),o};t.getWidgetForFieldOp=y,t.formatFieldName=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=(0,l.getFieldConfig)(t,e)||{},a=t.settings.fieldSeparator,u=Array.isArray(e)?e:e.split(a),s=Array.isArray(e)?e.join(a):e;if(o.tableName){var c=(0,i.default)(u);c[0]=o.tableName,s=c.join(a)}if(o.fieldName&&(s=o.fieldName),n){var d=(0,l.getFieldConfig)(t,n)||{},f=n;d.fieldName&&(f=d.fieldName),0==s.indexOf(f+a)?s=s.slice((f+a).length):r.errors.push("Can't cut group ".concat(f," from field ").concat(s))}return s}}},98477:(e,t,r)=>{"use strict";var n=r(96784),o=r(10564);Object.defineProperty(t,"__esModule",{value:!0}),t.applyToJS=function(e){return S(e)?e.toJS():e},t.mapListValues=t.logger=t.listValuesToArray=t.isJsonLogic=t.isImmutable=t.immutableEqual=t.getValueInListValues=t.getTitleInListValues=t.getLogger=t.getItemInListValues=t.getFirstDefined=t.flatizeTreeData=t.escapeRegExp=t.eqSet=t.eqArrSet=t.defaultValue=t.defaultTreeDataMap=t.deepEqual=void 0,t.mergeArraysSmart=function(e,t){return e||(e=[]),t||(t=[]),t.map((function(t){return[t,e.indexOf(t)]})).map((function(e,t,r){var n=(0,i.default)(e,2),o=n[0];if(-1==n[1]){var a=r.slice(t+1),l=r.slice(0,t).reverse().find((function(e){var t=(0,i.default)(e,2);return t[0],-1!=t[1]})),u=a.find((function(e){var t=(0,i.default)(e,2);return t[0],-1!=t[1]}));return u?[o,"before",u[0]]:l?[o,"after",l[0]]:[o,"append",null]}return null})).filter((function(e){return null!==e})).reduce((function(e,t){var r=(0,i.default)(t,3),n=r[0],o=r[1],a=r[2],l=e.indexOf(a);return-1==e.indexOf(n)&&(l>-1?e.splice(l+("after"==o?1:0),0,n):e.splice("append"==o?1/0:0,0,n)),e}),e.slice())},t.shallowEqual=t.removePrefixPath=t.normalizeListValues=void 0,t.sleep=function(e){return new Promise((function(t){setTimeout(t,e)}))},t.toImmutableList=function(e){return S(e)?e:new u.default.List(e)},t.truncateString=void 0;var i=n(r(18821)),a=n(r(10906)),l=n(r(10564)),u=function(e,t){if(e&&e.__esModule)return e;if(null===e||"object"!==o(e)&&"function"!=typeof e)return{default:e};var r=s(t);if(r&&r.has(e))return r.get(e);var n={},i=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var a in e)if("default"!==a&&Object.prototype.hasOwnProperty.call(e,a)){var l=i?Object.getOwnPropertyDescriptor(e,a):null;l&&(l.get||l.set)?Object.defineProperty(n,a,l):n[a]=e[a]}return n.default=e,r&&r.set(e,n),n}(r(37512));function s(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,r=new WeakMap;return(s=function(e){return e?r:t})(e)}function c(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return d(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?d(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function d(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}t.defaultValue=function(e,t){return void 0===e?t:e},t.truncateString=function(e,t,r){if(!t||e.length<=t)return e;var n=e.substr(0,t-1);return(r?n.substr(0,n.lastIndexOf(" ")):n)+"..."},t.immutableEqual=function(e,t){return e===t||e.equals(t)},t.deepEqual=function(e,t){return e===t||(u.Map.isMap(e)?e.equals(t):JSON.stringify(e)==JSON.stringify(t))};var f=function(e,t){if(e.size!==t.size)return!1;var r,n=c(e);try{for(n.s();!(r=n.n()).done;){var o=r.value;if(!t.has(o))return!1}}catch(e){n.e(e)}finally{n.f()}return!0};t.eqSet=f,t.eqArrSet=function(e,t){return f(new Set(e),new Set(t))};var p=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?p(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):u.Map.isMap(e)?e.equals(t):"object"==(0,l.default)(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var l=n[a];if(!(r?p(e[l],t[l],r):e[l]===t[l]))return!1}return!0}(e,t,r):e===t)};t.shallowEqual=p,t.escapeRegExp=function(e){return e.replace(/[.*+?^${}()|[\]\\/]/g,"\\$&")};var g=function(e){return"object"==(0,l.default)(e)&&null!==e},v=function(e,t){return g(e)?e:{value:e,title:void 0!==t?t:e}},h=function(e){if(!g(e))return e;if(Array.isArray(e))return e.map((function(e){return v(e)}));var t=[];for(var r in e){var n=e[r];t.push(v(r,n))}return t};t.listValuesToArray=h;var m=function(e,t){if(Array.isArray(e)){var r=e.map((function(e){return v(e)}));return r.find((function(e){return e.value===t}))||r.find((function(e){return"".concat(e.value)===t}))}return void 0!==e[t]?v(t,e[t]):void 0};t.getItemInListValues=m,t.getTitleInListValues=function(e,t){if(null==e)return t;var r=m(e,t);return void 0!==r?r.title:t},t.getValueInListValues=function(e,t){if(null==e)return t;var r=m(e,t);return void 0!==r?r.value:t},t.mapListValues=function(e,t){var r=[];if(Array.isArray(e)){var n,o=c(e);try{for(o.s();!(n=o.n()).done;){var i=n.value,a=t(v(i));null!=a&&r.push(a)}}catch(e){o.e(e)}finally{o.f()}}else for(var l in e){var u=t(v(l,e[l]));null!=u&&r.push(u)}return r};var y={id:"value",pId:"parent",rootPId:void 0};t.defaultTreeDataMap=y;var b=function(e){var t,r,n=y,o=function e(o,i,a){if(o.children){1==a&&(o[n.pId]=n.rootPId);var l,u=o.children.length,s=c(o.children);try{for(s.s();!(l=s.n()).done;){var d=l.value;d[n.pId]=o[n.id],t++,i.splice(t,0,d),r++,e(d,i,a+1)}}catch(e){s.e(e)}finally{s.f()}delete o.children,0==u&&(i.splice(t,1),t--,r--)}};if(Array.isArray(e))for(r=e.length,t=0;t<r;t++){var i=e[t];g(i)&&(void 0!==i[n.pId]&&i[n.pId]!=n.rootPId||o(i,e,1))}return e};t.flatizeTreeData=b;var E=function e(t,r){var n=y,o=m(t,r),i=o?o[n.pId]:void 0,l=i?t.find((function(e){return e[n.id]===i})):void 0;return l?[l.value].concat((0,a.default)(e(t,l.value))):[]},O=function(e,t){var r=y,n=m(e,t);return n?e.filter((function(e){return e[r.pId]===n[r.id]})).map((function(e){return e.value})):[]};t.normalizeListValues=function(e,t,r){var n=["treeselect","treemultiselect"].includes(t),o=["multiselect","treemultiselect"].includes(t);return n&&(e=h(e),e=function(e,t,r){var n,o=c(e);try{for(o.s();!(n=o.n()).done;){var i=n.value;if(i.path=E(e,i.value),0!=t.treeSelectOnlyLeafs){var a=O(e,i.value);r||(i.selectable=0==a.length)}}}catch(e){o.e(e)}finally{o.f()}return e}(e=b(e),r,o)),e},t.removePrefixPath=function(e,t){if(!e)return e;for(var r=!0,n=0;n<t.length;n++){var o=t[n];if(void 0===e[n]||o!=e[n]){r=!1;break}}return r?e.slice(t.length):e},t.isJsonLogic=function(e){return"object"===(0,l.default)(e)&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length};var S=function(e){return"object"===(0,l.default)(e)&&null!==e&&"function"==typeof e.toJS};t.isImmutable=S;var _=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}};t.getLogger=_,t.getFirstDefined=function(){for(var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=0;r<t.length;r++){var n=t[r];if(void 0!==n){e=n;break}}return e};var w=_();t.logger=w},53502:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.removePathsInTree=t.removeIsLockedInTree=t.isEmptyTree=t.hasChildren=t.getTreeBadFields=t.getTotalRulesCountInTree=t.getTotalReordableNodesCountInTree=t.getSwitchValues=t.getLightTree=t.getItemByPath=t.getFlatTree=t.fixPathsInTree=t.fixEmptyGroupsInTree=t.expandTreeSubpath=t.expandTreePath=void 0;var o=n(r(10906)),i=n(r(85707)),a=n(r(37512)),l=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.skip(1),e.push.apply(e,r),e}))};t.expandTreePath=l,t.expandTreeSubpath=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.push.apply(e,r),e}))},t.getItemByPath=function(e,t){var r=new a.default.OrderedMap((0,i.default)({},e.get("id"),e)),n=e;return t.forEach((function(e){n=r.get(e),r=n.get("children1")})),n},t.removePathsInTree=function(e){var t=e;return function e(r,n){var o=n.push(r.get("id"));r.get("path")&&(t=t.removeIn(l(o,"path")));var i=r.get("children1");i&&i.map((function(t,r){e(t,o)}))}(e,new a.default.List),t},t.removeIsLockedInTree=function(e){var t=e;return function e(r,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=n.push(r.get("id")),a=r.getIn(["properties","isLocked"]);o&&a&&(t=t.deleteIn(l(i,"properties","isLocked")));var u=r.get("children1");u&&u.map((function(t,r){e(t,i,a||o)}))}(e,new a.default.List),t},t.fixPathsInTree=function(e){var t=e;return function e(r,n,o,i){if(r){var u=r.get("path"),s=r.get("id"),c=s||i,d=n.push(c);u&&u.equals(d)||(t=t.setIn(l(d,"path"),d)),s||(t=t.setIn(l(d,"id"),c));var f=r.get("children1");f&&("Map"==f.constructor.name&&(t=t.setIn(l(d,"children1"),new a.default.OrderedMap(f))),f.map((function(t,r){e(t,d,o+1,r)})))}}(e,new a.default.List,0),t},t.fixEmptyGroupsInTree=function(e){var t=e;return function e(r,n,o,i){if(!r)return!1;var a=r.get("id")||i,u=n.push(a),s=r.get("children1");if(s){var c=s.map((function(t,r){return e(t,u,o+1,r)})).reduce((function(e,t){return e&&t}),!0);if((0==s.size||c)&&o>0)return t=t.deleteIn(l(u)),!0}return!1}(e,new a.default.List,0),t},t.getFlatTree=function(e){var t=[],r={},n=0;!function e(o,i,a,l,u,s,c,d,f){var p=o.get("type"),g=o.get("collapsed"),v=o.get("id"),h=o.get("children1"),m=o.getIn(["properties","isLocked"]),y=h?h.map((function(e,t){return t})):null,b="rule_group"==p,E=!u&&(!h||b),O=t.length,S=n;if(t.push(v),a||(n+=1),c.height=(c.height||0)+1,r[v]={type:p,parent:i.length?i[i.length-1]:null,parentType:d,caseId:"case_group"==p?v:f,isDefaultCase:"case_group"==p&&!h,path:i.concat(v),lev:s,leaf:!h,index:O,id:v,children:y,leafsCount:0,_top:O,_height:w-O,top:a?null:S,height:T,bottom:(a?null:S)+T,collapsed:g,node:o,isLocked:m||l},h){var _={};h.map((function(t,r){e(t,i.concat(v),a||g,l||m,u||b,s+1,_,p,"case_group"==p?v:f)})),g||(c.height=(c.height||0)+(_.height||0))}f&&E&&r[f].leafsCount++;var w=t.length,T=c.height;Object.assign(r[v],{_height:w-O,height:T,bottom:(a?null:S)+T})}(e,[],!1,!1,!1,0,{},null,null);for(var o=0;o<t.length;o++){var i=o>0?t[o-1]:null,a=o<t.length-1?t[o+1]:null,l=r[t[o]];l.prev=i,l.next=a}return{flat:t,items:r}},t.getTotalReordableNodesCountInTree=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,l;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),l=r.get("type")):(i=r.id,a=r.children1,l=r.type),t++,a&&"rule_group"!=l&&a.map((function(t,r){e(t,n.concat(i),o+1)}))}(e,[],0),t-1},t.getTotalRulesCountInTree=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,l;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),l=r.get("type")):(i=r.id,a=r.children1,l=r.type),"rule"==l||"rule_group"==l?t++:a&&a.map((function(t,r){e(t,n.concat(i),o+1)}))}(e,[],0),t},t.getTreeBadFields=function(e){var t=[];return e&&function e(r,n,o){var i=r.get("id"),a=r.get("children1"),l=r.getIn(["properties","valueError"]),u=r.getIn(["properties","field"]);l&&l.size>0&&l.filter((function(e){return null!=e})).size>0&&t.push(u),a&&a.map((function(t,r){e(t,n.concat(i),o+1)}))}(e,[],0),Array.from(new Set(t))},t.getLightTree=function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=e;return function e(r,n){r.path&&delete r.path,!t&&n&&delete r.id;var o=r.properties;o&&null==o.operatorOptions&&delete o.operatorOptions;var i=r.children1;if(i){for(var a in i)e(i[a],a);t&&(r.children1=Object.values(i))}}(e,null),r},t.getSwitchValues=function(e){var t=[],r=e.get("children1");return r&&r.map((function(e){var r,n=e.getIn(["properties","value"]);n&&1==n.size?(r=n.get(0),Array.isArray(r)&&0==r.length&&(r=null)):r=null,t=[].concat((0,o.default)(t),[r])})),t},t.isEmptyTree=function(e){return!e.get("children1")||0==e.get("children1").size},t.hasChildren=function(e,t){return e.getIn(l(t,"children1")).size>0}},58048:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var r=0;t.default=function(){var e=((new Date).getTime().toString(16)+"FF").substr(0,11);return"ssssssss-xxxx-4xxx-yxxx-x".replace(/[xys]/g,(function(e){var t="s"===e?Math.floor(16*Math.random()):15&r++;return("x"===e?t:3&t|8).toString(16)}))+e}},40056:(e,t,r)=>{"use strict";var n=r(96784);Object.defineProperty(t,"__esModule",{value:!0}),t.validateValue=t.validateTree=t.validateAndFixTree=t.createValidationMemo=void 0;var o=n(r(10906)),i=n(r(18821)),a=n(r(10564)),l=r(40112),u=r(89112),s=r(98477),c=r(18313),d=r(53502),f=n(r(24319)),p=r(37512);t.createValidationMemo=function(){var e,t,r;return function(n,o,i){return o?n.__configId===r&&((0,s.immutableEqual)(o,e)||(0,s.immutableEqual)(o,t))?t:(r=n.__configId,e=o,t=g(o,null,n,i||n)):null}};var g=function(e,t,r,n){var o=v(e,t,r,n);return(0,d.fixPathsInTree)(o)};t.validateAndFixTree=g;var v=function(e,t,r,n,o,i){return void 0===o&&(o=r.settings.removeEmptyGroupsOnLoad),void 0===i&&(i=r.settings.removeIncompleteRulesOnLoad),h(e,[],null,{},{config:r,oldConfig:n,removeEmptyGroups:o,removeIncompleteRules:i})};function h(e,t,r,n,o){var i=e.get("type"),a=e.get("children1");return("group"===i||"rule_group"===i||"case_group"==i||"switch_group"==i)&&a&&a.size?function(e,t,r,n,o){var i=o.removeEmptyGroups,a=e.get("id"),l=e.get("children1"),u=l;!a&&r&&(a=r,e=e.set("id",a),n.sanitized=!0);var s={};l=l.map((function(e,r){return h(e,t.concat(a),r,s,o)})),i&&(l=l.filter((function(e){return null!=e})));var c=s.sanitized||u.size!=l.size;return!l.size&&i&&t.length&&(c=!0,e=void 0),c&&(n.sanitized=!0),c&&e&&(e=e.set("children1",l)),e}(e,t,r,n,o):"rule"===i?function(e,t,r,n,o){var i=o.removeIncompleteRules,a=o.config,d=o.oldConfig,f=a.settings.showErrorMessage,p=e.get("id"),g=e.get("properties"),v=g.get("field")||null,h=g.get("operator")||null,m=g.get("operatorOptions"),y=g.get("valueSrc"),b=g.get("value"),E=g.get("valueError"),O={field:v,operator:h,operatorOptions:m?m.toJS():{},valueSrc:y?y.toJS():null,value:b?b.toJS():null,valueError:E?E.toJS():null};v&&h&&b&&b.includes(void 0),!p&&r&&(p=r,e=e.set("id",p),n.sanitized=!0);var S=v?(0,l.getFieldConfig)(a,v):null;v&&!S&&(s.logger.warn("No config for field ".concat(v)),v=null),null==v&&(g=["operator","operatorOptions","valueSrc","value"].reduce((function(e,t){return e.delete(t)}),g),h=null),"range_between"!=h&&"range_not_between"!=h||(h="range_between"==h?"between":"not_between",console.info("Fixed operator ".concat(g.get("operator")," to ").concat(h)),g=g.set("operator",h));var _=h?(0,l.getOperatorConfig)(a,h,v):null;h&&!_&&(console.warn("No config for operator ".concat(h)),h=null);var w=v?(0,u.getOperatorsForField)(a,v):[];w?h&&-1==w.indexOf(h)&&("is_empty"==h||"is_not_empty"==h?(h="is_empty"==h?"is_null":"is_not_null",console.info("Fixed operator ".concat(g.get("operator")," to ").concat(h," for ").concat(v)),g=g.set("operator",h)):(console.warn("Operator ".concat(h," is not supported for field ").concat(v)),h=null)):(console.warn("Type of field ".concat(v," is not supported")),h=null),null==h&&(g=(g=(g=g.delete("operatorOptions")).delete("valueSrc")).delete("value")),m=g.get("operatorOptions"),h&&(0,s.defaultValue)(_.cardinality,1),!h||m&&!_.options?(m=null,g=g.delete("operatorOptions")):h&&!m&&_.options&&(m=(0,c.defaultOperatorOptions)(a,h,v),g=g.set("operatorOptions",m)),y=g.get("valueSrc"),b=g.get("value");var T=!f,P=(0,u.getNewValueForFieldOp)(a,d,g,v,h,null,T,!0);b=P.newValue,y=P.newValueSrc,E=P.newValueError,g=(g=g.set("value",b)).set("valueSrc",y),f&&(g=g.set("valueError",E));var C={field:v,operator:h,operatorOptions:m?m.toJS():{},valueSrc:y?y.toJS():null,value:b?b.toJS():null,valueError:E?E.toJS():null},I=!(0,s.deepEqual)(O,C),A=v&&h&&b&&!b.includes(void 0);return I&&(n.sanitized=!0),!A&&i?e=void 0:I&&(e=e.set("properties",g)),e}(e,0,r,n,o):e}t.validateTree=v;var m=function(e,t,r,n,o,a,s,c){var d=arguments.length>8&&void 0!==arguments[8]&&arguments[8],p=arguments.length>9&&void 0!==arguments[9]&&arguments[9],g=!(arguments.length>10&&void 0!==arguments[10])||arguments[10],v=null,h=o;if(null!=o){if("field"==s){var m=b(t,r,o,s,a,c,e,n,p,d),O=(0,i.default)(m,2);v=O[0],h=O[1]}else if("func"==s){var S=E(t,r,o,s,a,c,e,n,p,d),_=(0,i.default)(S,2);v=_[0],h=_[1]}else if("value"==s||!s){var w=y(t,r,o,s,a,c,e,n,p,d),T=(0,i.default)(w,2);v=T[0],h=T[1]}if(!v){(0,l.getFieldConfig)(e,r);var P=(0,u.getWidgetForFieldOp)(e,r,n,s),C=n?(0,l.getOperatorConfig)(e,n,r):null,I=(0,f.default)((0,l.getFieldWidgetConfig)(e,r,n,P,s),["factory"]),A="field"==s?(0,l.getFieldConfig)(e,o):null,R=I,x=I.validateValue;if("function"==typeof x){var N=[h,R,n,C];"field"==s&&N.push(A);var D=x.apply(void 0,N);"boolean"==typeof D?0==D&&(v="Invalid value"):v=D}}}return g&&v&&console.warn("[RAQB validate]","Field ".concat(r,": ").concat(v)),[v,h]};t.validateValue=m;var y=function(e,t,r,n,c,d,f){var g,v,h=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,m=arguments.length>8&&void 0!==arguments[8]&&arguments[8],y=arguments.length>9&&void 0!==arguments[9]&&arguments[9];if(t){var b=(0,l.getFieldConfig)(f,t),E=(0,u.getWidgetForFieldOp)(f,t,h,n),O=f.widgets[E],S=O.type,_=O.jsType,w=b.fieldSettings;if(c!=S)return["Value should have type ".concat(S,", but got value of type ").concat(c),r];if(_&&(v=_,function(e){return"object"==(0,a.default)(e)&&null!==e&&Array.isArray(e)?"array":(0,a.default)(e)}(g=r)!=v&&("number"!=v||isNaN(g)))&&!w.listValues)return["Value should have JS type ".concat(_,", but got value of type ").concat((0,a.default)(r)),r];if(w){var T=d||w.listValues;if(T&&!w.allowCustomValues)return function(e,t,r,n,a){var l=p.List.isList(e)?e.toJS():e instanceof Array?(0,o.default)(e):void 0;if(l){var u=l.reduce((function(e,r){var n=(0,i.default)(e,2),a=n[0],l=n[1],u=(0,s.getItemInListValues)(t,r);return null==u?[a,[].concat((0,o.default)(l),[r])]:[[].concat((0,o.default)(a),[u.value]),l]}),[[],[]]),c=(0,i.default)(u,2),d=c[0],f=c[1],g=f.length>1;return[f.length?"".concat(g?"Values":"Value"," ").concat(f.join(", ")," ").concat(g?"are":"is"," not in list of values"):null,(r=void 0!==a?a:r||n)?d:e]}var v=(0,s.getItemInListValues)(t,e);return null==v?["Value ".concat(e," is not in list of values"),e]:[null,e=v.value]}(r,T,y,m,f.settings.removeInvalidMultiSelectValuesOnLoad);if(null!=w.min&&r<w.min)return["Value ".concat(r," < min ").concat(w.min),y?w.min:r];if(null!=w.max&&r>w.max)return["Value ".concat(r," > max ").concat(w.max),y?w.max:r]}}return[null,r]},b=function(e,t,r,n,o,i,u){var s=u.settings.fieldSeparator,c="object"==(0,a.default)(t)&&(null==t?void 0:t._isFuncArg),d=Array.isArray(e)?e.join(s):e,f=Array.isArray(r)?r.join(s):r,p=(0,l.getFieldConfig)(u,r);return p?f!=d||c?o&&o!=p.type?["Field ".concat(r," is of type ").concat(p.type,", but expected ").concat(o),r]:[null,r]:["Can't compare field ".concat(e," with itself"),r]:["Unknown field ".concat(r),r]},E=function(e,t,r,n,o,a,u){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,c=arguments.length>8&&void 0!==arguments[8]&&arguments[8],d=arguments.length>9&&void 0!==arguments[9]&&arguments[9],f=r;if(r){var p=r.get("func");if(p){var g=(0,l.getFuncConfig)(u,p);if(!g)return["Unknown function ".concat(p),r];if(o&&g.returnType!=o)return["Function ".concat(p," should return value of type ").concat(g.returnType,", but got ").concat(o),r];for(var v in g.args){var h=g.args[v],y=f.get("args"),b=y?y.get(v):void 0,E=(0,l.getFieldConfig)(u,h),O=b?b.get("value"):void 0,S=b?b.get("valueSrc"):void 0;if(void 0!==O){var _=m(u,e,E,s,O,h.type,S,a,d,c,!1),w=(0,i.default)(_,2),T=w[0],P=w[1];if(null!==T){if(!d)return["Invalid value of arg ".concat(v," for func ").concat(p,": ").concat(T),r];f=f.deleteIn(["args",v]),void 0!==h.defaultValue&&(f=(f=f.setIn(["args",v,"value"],h.defaultValue)).setIn(["args",v,"valueSrc"],"value"))}else P!==O&&(f=f.setIn(["args",v,"value"],P))}else if(c&&void 0===h.defaultValue&&!d)return["Value of arg ".concat(v," for func ").concat(p," is required"),r]}}}return[null,f]}},37512:function(e){e.exports=function(){"use strict";var e=Array.prototype.slice;function t(e,t){t&&(e.prototype=Object.create(t.prototype)),e.prototype.constructor=e}function r(e){return a(e)?e:$(e)}function n(e){return l(e)?e:z(e)}function o(e){return u(e)?e:Y(e)}function i(e){return a(e)&&!s(e)?e:Q(e)}function a(e){return!(!e||!e[d])}function l(e){return!(!e||!e[f])}function u(e){return!(!e||!e[p])}function s(e){return l(e)||u(e)}function c(e){return!(!e||!e[g])}t(n,r),t(o,r),t(i,r),r.isIterable=a,r.isKeyed=l,r.isIndexed=u,r.isAssociative=s,r.isOrdered=c,r.Keyed=n,r.Indexed=o,r.Set=i;var d="@@__IMMUTABLE_ITERABLE__@@",f="@@__IMMUTABLE_KEYED__@@",p="@@__IMMUTABLE_INDEXED__@@",g="@@__IMMUTABLE_ORDERED__@@",v="delete",h=5,m=1<<h,y=m-1,b={},E={value:!1},O={value:!1};function S(e){return e.value=!1,e}function _(e){e&&(e.value=!0)}function w(){}function T(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),o=0;o<r;o++)n[o]=e[o+t];return n}function P(e){return void 0===e.size&&(e.size=e.__iterate(I)),e.size}function C(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?P(e)+t:t}function I(){return!0}function A(e,t,r){return(0===e||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function R(e,t){return N(e,t,0)}function x(e,t){return N(e,t,t)}function N(e,t,r){return void 0===e?r:e<0?Math.max(0,t+e):void 0===t?e:Math.min(t,e)}var D=0,L=1,j=2,M="function"==typeof Symbol&&Symbol.iterator,k="@@iterator",F=M||k;function q(e){this.next=e}function V(e,t,r,n){var o=0===e?t:1===e?r:[t,r];return n?n.value=o:n={value:o,done:!1},n}function B(){return{value:void 0,done:!0}}function U(e){return!!H(e)}function W(e){return e&&"function"==typeof e.next}function G(e){var t=H(e);return t&&t.call(e)}function H(e){var t=e&&(M&&e[M]||e[k]);if("function"==typeof t)return t}function K(e){return e&&"number"==typeof e.length}function $(e){return null==e?ae():a(e)?e.toSeq():function(e){var t=se(e)||"object"==typeof e&&new re(e);if(!t)throw new TypeError("Expected Array or iterable object of values, or keyed object: "+e);return t}(e)}function z(e){return null==e?ae().toKeyedSeq():a(e)?l(e)?e.toSeq():e.fromEntrySeq():le(e)}function Y(e){return null==e?ae():a(e)?l(e)?e.entrySeq():e.toIndexedSeq():ue(e)}function Q(e){return(null==e?ae():a(e)?l(e)?e.entrySeq():e:ue(e)).toSetSeq()}q.prototype.toString=function(){return"[Iterator]"},q.KEYS=D,q.VALUES=L,q.ENTRIES=j,q.prototype.inspect=q.prototype.toSource=function(){return this.toString()},q.prototype[F]=function(){return this},t($,r),$.of=function(){return $(arguments)},$.prototype.toSeq=function(){return this},$.prototype.toString=function(){return this.__toString("Seq {","}")},$.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},$.prototype.__iterate=function(e,t){return ce(this,e,t,!0)},$.prototype.__iterator=function(e,t){return de(this,e,t,!0)},t(z,$),z.prototype.toKeyedSeq=function(){return this},t(Y,$),Y.of=function(){return Y(arguments)},Y.prototype.toIndexedSeq=function(){return this},Y.prototype.toString=function(){return this.__toString("Seq [","]")},Y.prototype.__iterate=function(e,t){return ce(this,e,t,!1)},Y.prototype.__iterator=function(e,t){return de(this,e,t,!1)},t(Q,$),Q.of=function(){return Q(arguments)},Q.prototype.toSetSeq=function(){return this},$.isSeq=ie,$.Keyed=z,$.Set=Q,$.Indexed=Y;var X,J,Z,ee="@@__IMMUTABLE_SEQ__@@";function te(e){this._array=e,this.size=e.length}function re(e){var t=Object.keys(e);this._object=e,this._keys=t,this.size=t.length}function ne(e){this._iterable=e,this.size=e.length||e.size}function oe(e){this._iterator=e,this._iteratorCache=[]}function ie(e){return!(!e||!e[ee])}function ae(){return X||(X=new te([]))}function le(e){var t=Array.isArray(e)?new te(e).fromEntrySeq():W(e)?new oe(e).fromEntrySeq():U(e)?new ne(e).fromEntrySeq():"object"==typeof e?new re(e):void 0;if(!t)throw new TypeError("Expected Array or iterable object of [k, v] entries, or keyed object: "+e);return t}function ue(e){var t=se(e);if(!t)throw new TypeError("Expected Array or iterable object of values: "+e);return t}function se(e){return K(e)?new te(e):W(e)?new oe(e):U(e)?new ne(e):void 0}function ce(e,t,r,n){var o=e._cache;if(o){for(var i=o.length-1,a=0;a<=i;a++){var l=o[r?i-a:a];if(!1===t(l[1],n?l[0]:a,e))return a+1}return a}return e.__iterateUncached(t,r)}function de(e,t,r,n){var o=e._cache;if(o){var i=o.length-1,a=0;return new q((function(){var e=o[r?i-a:a];return a++>i?{value:void 0,done:!0}:V(t,n?e[0]:a-1,e[1])}))}return e.__iteratorUncached(t,r)}function fe(e,t){return t?pe(t,e,"",{"":e}):ge(e)}function pe(e,t,r,n){return Array.isArray(t)?e.call(n,r,Y(t).map((function(r,n){return pe(e,r,n,t)}))):ve(t)?e.call(n,r,z(t).map((function(r,n){return pe(e,r,n,t)}))):t}function ge(e){return Array.isArray(e)?Y(e).map(ge).toList():ve(e)?z(e).map(ge).toMap():e}function ve(e){return e&&(e.constructor===Object||void 0===e.constructor)}function he(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if((e=e.valueOf())===(t=t.valueOf())||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!("function"!=typeof e.equals||"function"!=typeof t.equals||!e.equals(t))}function me(e,t){if(e===t)return!0;if(!a(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||l(e)!==l(t)||u(e)!==u(t)||c(e)!==c(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!s(e);if(c(e)){var n=e.entries();return t.every((function(e,t){var o=n.next().value;return o&&he(o[1],e)&&(r||he(o[0],t))}))&&n.next().done}var o=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{o=!0;var i=e;e=t,t=i}var d=!0,f=t.__iterate((function(t,n){if(r?!e.has(t):o?!he(t,e.get(n,b)):!he(e.get(n,b),t))return d=!1,!1}));return d&&e.size===f}function ye(e,t){if(!(this instanceof ye))return new ye(e,t);if(this._value=e,this.size=void 0===t?1/0:Math.max(0,t),0===this.size){if(J)return J;J=this}}function be(e,t){if(!e)throw new Error(t)}function Ee(e,t,r){if(!(this instanceof Ee))return new Ee(e,t,r);if(be(0!==r,"Cannot step a Range by 0"),e=e||0,void 0===t&&(t=1/0),r=void 0===r?1:Math.abs(r),t<e&&(r=-r),this._start=e,this._end=t,this._step=r,this.size=Math.max(0,Math.ceil((t-e)/r-1)+1),0===this.size){if(Z)return Z;Z=this}}function Oe(){throw TypeError("Abstract")}function Se(){}function _e(){}function we(){}$.prototype[ee]=!0,t(te,Y),te.prototype.get=function(e,t){return this.has(e)?this._array[C(this,e)]:t},te.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length-1,o=0;o<=n;o++)if(!1===e(r[t?n-o:o],o,this))return o+1;return o},te.prototype.__iterator=function(e,t){var r=this._array,n=r.length-1,o=0;return new q((function(){return o>n?{value:void 0,done:!0}:V(e,o,r[t?n-o++:o++])}))},t(re,z),re.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},re.prototype.has=function(e){return this._object.hasOwnProperty(e)},re.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,o=n.length-1,i=0;i<=o;i++){var a=n[t?o-i:i];if(!1===e(r[a],a,this))return i+1}return i},re.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,o=n.length-1,i=0;return new q((function(){var a=n[t?o-i:i];return i++>o?{value:void 0,done:!0}:V(e,a,r[a])}))},re.prototype[g]=!0,t(ne,Y),ne.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=G(this._iterable),n=0;if(W(r))for(var o;!(o=r.next()).done&&!1!==e(o.value,n++,this););return n},ne.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=G(this._iterable);if(!W(r))return new q(B);var n=0;return new q((function(){var t=r.next();return t.done?t:V(e,n++,t.value)}))},t(oe,Y),oe.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);for(var r,n=this._iterator,o=this._iteratorCache,i=0;i<o.length;)if(!1===e(o[i],i++,this))return i;for(;!(r=n.next()).done;){var a=r.value;if(o[i]=a,!1===e(a,i++,this))break}return i},oe.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=this._iterator,n=this._iteratorCache,o=0;return new q((function(){if(o>=n.length){var t=r.next();if(t.done)return t;n[o]=t.value}return V(e,o,n[o++])}))},t(ye,Y),ye.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},ye.prototype.get=function(e,t){return this.has(e)?this._value:t},ye.prototype.includes=function(e){return he(this._value,e)},ye.prototype.slice=function(e,t){var r=this.size;return A(e,t,r)?this:new ye(this._value,x(t,r)-R(e,r))},ye.prototype.reverse=function(){return this},ye.prototype.indexOf=function(e){return he(this._value,e)?0:-1},ye.prototype.lastIndexOf=function(e){return he(this._value,e)?this.size:-1},ye.prototype.__iterate=function(e,t){for(var r=0;r<this.size;r++)if(!1===e(this._value,r,this))return r+1;return r},ye.prototype.__iterator=function(e,t){var r=this,n=0;return new q((function(){return n<r.size?V(e,n++,r._value):{value:void 0,done:!0}}))},ye.prototype.equals=function(e){return e instanceof ye?he(this._value,e._value):me(e)},t(Ee,Y),Ee.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},Ee.prototype.get=function(e,t){return this.has(e)?this._start+C(this,e)*this._step:t},Ee.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},Ee.prototype.slice=function(e,t){return A(e,t,this.size)?this:(e=R(e,this.size),(t=x(t,this.size))<=e?new Ee(0,0):new Ee(this.get(e,this._end),this.get(t,this._end),this._step))},Ee.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},Ee.prototype.lastIndexOf=function(e){return this.indexOf(e)},Ee.prototype.__iterate=function(e,t){for(var r=this.size-1,n=this._step,o=t?this._start+r*n:this._start,i=0;i<=r;i++){if(!1===e(o,i,this))return i+1;o+=t?-n:n}return i},Ee.prototype.__iterator=function(e,t){var r=this.size-1,n=this._step,o=t?this._start+r*n:this._start,i=0;return new q((function(){var a=o;return o+=t?-n:n,i>r?{value:void 0,done:!0}:V(e,i++,a)}))},Ee.prototype.equals=function(e){return e instanceof Ee?this._start===e._start&&this._end===e._end&&this._step===e._step:me(this,e)},t(Oe,r),t(Se,Oe),t(_e,Oe),t(we,Oe),Oe.Keyed=Se,Oe.Indexed=_e,Oe.Set=we;var Te="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function Pe(e){return e>>>1&1073741824|3221225471&e}function Ce(e){if(!1===e||null==e)return 0;if("function"==typeof e.valueOf&&(!1===(e=e.valueOf())||null==e))return 0;if(!0===e)return 1;var t=typeof e;if("number"===t){if(e!=e||e===1/0)return 0;var r=0|e;for(r!==e&&(r^=4294967295*e);e>4294967295;)r^=e/=4294967295;return Pe(r)}if("string"===t)return e.length>je?function(e){var t=Fe[e];return void 0===t&&(t=Ie(e),ke===Me&&(ke=0,Fe={}),ke++,Fe[e]=t),t}(e):Ie(e);if("function"==typeof e.hashCode)return e.hashCode();if("object"===t)return function(e){var t;if(Ne&&void 0!==(t=xe.get(e)))return t;if(void 0!==(t=e[Le]))return t;if(!Re){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[Le]))return t;if(void 0!==(t=function(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}(e)))return t}if(t=++De,1073741824&De&&(De=0),Ne)xe.set(e,t);else{if(void 0!==Ae&&!1===Ae(e))throw new Error("Non-extensible objects are not allowed as keys.");if(Re)Object.defineProperty(e,Le,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[Le]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[Le]=t}}return t}(e);if("function"==typeof e.toString)return Ie(e.toString());throw new Error("Value type "+t+" cannot be hashed.")}function Ie(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return Pe(t)}var Ae=Object.isExtensible,Re=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}();var xe,Ne="function"==typeof WeakMap;Ne&&(xe=new WeakMap);var De=0,Le="__immutablehash__";"function"==typeof Symbol&&(Le=Symbol(Le));var je=16,Me=255,ke=0,Fe={};function qe(e){be(e!==1/0,"Cannot perform this action with an infinite size.")}function Ve(e){return null==e?et():Be(e)&&!c(e)?e:et().withMutations((function(t){var r=n(e);qe(r.size),r.forEach((function(e,r){return t.set(r,e)}))}))}function Be(e){return!(!e||!e[We])}t(Ve,Se),Ve.of=function(){var t=e.call(arguments,0);return et().withMutations((function(e){for(var r=0;r<t.length;r+=2){if(r+1>=t.length)throw new Error("Missing value for key: "+t[r]);e.set(t[r],t[r+1])}}))},Ve.prototype.toString=function(){return this.__toString("Map {","}")},Ve.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},Ve.prototype.set=function(e,t){return tt(this,e,t)},Ve.prototype.setIn=function(e,t){return this.updateIn(e,b,(function(){return t}))},Ve.prototype.remove=function(e){return tt(this,e,b)},Ve.prototype.deleteIn=function(e){return this.updateIn(e,(function(){return b}))},Ve.prototype.update=function(e,t,r){return 1===arguments.length?e(this):this.updateIn([e],t,r)},Ve.prototype.updateIn=function(e,t,r){r||(r=t,t=void 0);var n=st(this,ir(e),t,r);return n===b?void 0:n},Ve.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):et()},Ve.prototype.merge=function(){return it(this,void 0,arguments)},Ve.prototype.mergeWith=function(t){return it(this,t,e.call(arguments,1))},Ve.prototype.mergeIn=function(t){var r=e.call(arguments,1);return this.updateIn(t,et(),(function(e){return"function"==typeof e.merge?e.merge.apply(e,r):r[r.length-1]}))},Ve.prototype.mergeDeep=function(){return it(this,at,arguments)},Ve.prototype.mergeDeepWith=function(t){var r=e.call(arguments,1);return it(this,lt(t),r)},Ve.prototype.mergeDeepIn=function(t){var r=e.call(arguments,1);return this.updateIn(t,et(),(function(e){return"function"==typeof e.mergeDeep?e.mergeDeep.apply(e,r):r[r.length-1]}))},Ve.prototype.sort=function(e){return Nt(zt(this,e))},Ve.prototype.sortBy=function(e,t){return Nt(zt(this,t,e))},Ve.prototype.withMutations=function(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this},Ve.prototype.asMutable=function(){return this.__ownerID?this:this.__ensureOwner(new w)},Ve.prototype.asImmutable=function(){return this.__ensureOwner()},Ve.prototype.wasAltered=function(){return this.__altered},Ve.prototype.__iterator=function(e,t){return new Qe(this,e,t)},Ve.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate((function(t){return n++,e(t[1],t[0],r)}),t),n},Ve.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Ze(this.size,this._root,e,this.__hash):(this.__ownerID=e,this.__altered=!1,this)},Ve.isMap=Be;var Ue,We="@@__IMMUTABLE_MAP__@@",Ge=Ve.prototype;function He(e,t){this.ownerID=e,this.entries=t}function Ke(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r}function $e(e,t,r){this.ownerID=e,this.count=t,this.nodes=r}function ze(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r}function Ye(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r}function Qe(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&Je(e._root)}function Xe(e,t){return V(e,t[0],t[1])}function Je(e,t){return{node:e,index:0,__prev:t}}function Ze(e,t,r,n){var o=Object.create(Ge);return o.size=e,o._root=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function et(){return Ue||(Ue=Ze(0))}function tt(e,t,r){var n,o;if(e._root){var i=S(E),a=S(O);if(n=rt(e._root,e.__ownerID,0,void 0,t,r,i,a),!a.value)return e;o=e.size+(i.value?r===b?-1:1:0)}else{if(r===b)return e;o=1,n=new He(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=o,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?Ze(o,n):et()}function rt(e,t,r,n,o,i,a,l){return e?e.update(t,r,n,o,i,a,l):i===b?e:(_(l),_(a),new Ye(t,n,[o,i]))}function nt(e){return e.constructor===Ye||e.constructor===ze}function ot(e,t,r,n,o){if(e.keyHash===n)return new ze(t,n,[e.entry,o]);var i,a=(0===r?e.keyHash:e.keyHash>>>r)&y,l=(0===r?n:n>>>r)&y;return new Ke(t,1<<a|1<<l,a===l?[ot(e,t,r+h,n,o)]:(i=new Ye(t,n,o),a<l?[e,i]:[i,e]))}function it(e,t,r){for(var o=[],i=0;i<r.length;i++){var l=r[i],u=n(l);a(l)||(u=u.map((function(e){return fe(e)}))),o.push(u)}return ut(e,t,o)}function at(e,t,r){return e&&e.mergeDeep&&a(t)?e.mergeDeep(t):he(e,t)?e:t}function lt(e){return function(t,r,n){if(t&&t.mergeDeepWith&&a(r))return t.mergeDeepWith(e,r);var o=e(t,r,n);return he(t,o)?t:o}}function ut(e,t,r){return 0===(r=r.filter((function(e){return 0!==e.size}))).length?e:0!==e.size||e.__ownerID||1!==r.length?e.withMutations((function(e){for(var n=t?function(r,n){e.update(n,b,(function(e){return e===b?r:t(e,r,n)}))}:function(t,r){e.set(r,t)},o=0;o<r.length;o++)r[o].forEach(n)})):e.constructor(r[0])}function st(e,t,r,n){var o=e===b,i=t.next();if(i.done){var a=o?r:e,l=n(a);return l===a?e:l}be(o||e&&e.set,"invalid keyPath");var u=i.value,s=o?b:e.get(u,b),c=st(s,t,r,n);return c===s?e:c===b?e.remove(u):(o?et():e).set(u,c)}function ct(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,127&(e+=e>>8)+(e>>16)}function dt(e,t,r,n){var o=n?e:T(e);return o[t]=r,o}Ge[We]=!0,Ge[v]=Ge.remove,Ge.removeIn=Ge.deleteIn,He.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(he(r,o[i][0]))return o[i][1];return n},He.prototype.update=function(e,t,r,n,o,i,a){for(var l=o===b,u=this.entries,s=0,c=u.length;s<c&&!he(n,u[s][0]);s++);var d=s<c;if(d?u[s][1]===o:l)return this;if(_(a),(l||!d)&&_(i),!l||1!==u.length){if(!d&&!l&&u.length>=ft)return function(e,t,r,n){e||(e=new w);for(var o=new Ye(e,Ce(r),[r,n]),i=0;i<t.length;i++){var a=t[i];o=o.update(e,0,void 0,a[0],a[1])}return o}(e,u,n,o);var f=e&&e===this.ownerID,p=f?u:T(u);return d?l?s===c-1?p.pop():p[s]=p.pop():p[s]=[n,o]:p.push([n,o]),f?(this.entries=p,this):new He(e,p)}},Ke.prototype.get=function(e,t,r,n){void 0===t&&(t=Ce(r));var o=1<<((0===e?t:t>>>e)&y),i=this.bitmap;return i&o?this.nodes[ct(i&o-1)].get(e+h,t,r,n):n},Ke.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=Ce(n));var l=(0===t?r:r>>>t)&y,u=1<<l,s=this.bitmap,c=!!(s&u);if(!c&&o===b)return this;var d=ct(s&u-1),f=this.nodes,p=c?f[d]:void 0,g=rt(p,e,t+h,r,n,o,i,a);if(g===p)return this;if(!c&&g&&f.length>=pt)return function(e,t,r,n,o){for(var i=0,a=new Array(m),l=0;0!==r;l++,r>>>=1)a[l]=1&r?t[i++]:void 0;return a[n]=o,new $e(e,i+1,a)}(e,f,s,l,g);if(c&&!g&&2===f.length&&nt(f[1^d]))return f[1^d];if(c&&g&&1===f.length&&nt(g))return g;var v=e&&e===this.ownerID,E=c?g?s:s^u:s|u,O=c?g?dt(f,d,g,v):function(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var o=new Array(n),i=0,a=0;a<n;a++)a===t&&(i=1),o[a]=e[a+i];return o}(f,d,v):function(e,t,r,n){var o=e.length+1;if(n&&t+1===o)return e[t]=r,e;for(var i=new Array(o),a=0,l=0;l<o;l++)l===t?(i[l]=r,a=-1):i[l]=e[l+a];return i}(f,d,g,v);return v?(this.bitmap=E,this.nodes=O,this):new Ke(e,E,O)},$e.prototype.get=function(e,t,r,n){void 0===t&&(t=Ce(r));var o=(0===e?t:t>>>e)&y,i=this.nodes[o];return i?i.get(e+h,t,r,n):n},$e.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=Ce(n));var l=(0===t?r:r>>>t)&y,u=o===b,s=this.nodes,c=s[l];if(u&&!c)return this;var d=rt(c,e,t+h,r,n,o,i,a);if(d===c)return this;var f=this.count;if(c){if(!d&&--f<gt)return function(e,t,r,n){for(var o=0,i=0,a=new Array(r),l=0,u=1,s=t.length;l<s;l++,u<<=1){var c=t[l];void 0!==c&&l!==n&&(o|=u,a[i++]=c)}return new Ke(e,o,a)}(e,s,f,l)}else f++;var p=e&&e===this.ownerID,g=dt(s,l,d,p);return p?(this.count=f,this.nodes=g,this):new $e(e,f,g)},ze.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(he(r,o[i][0]))return o[i][1];return n},ze.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=Ce(n));var l=o===b;if(r!==this.keyHash)return l?this:(_(a),_(i),ot(this,e,t,r,[n,o]));for(var u=this.entries,s=0,c=u.length;s<c&&!he(n,u[s][0]);s++);var d=s<c;if(d?u[s][1]===o:l)return this;if(_(a),(l||!d)&&_(i),l&&2===c)return new Ye(e,this.keyHash,u[1^s]);var f=e&&e===this.ownerID,p=f?u:T(u);return d?l?s===c-1?p.pop():p[s]=p.pop():p[s]=[n,o]:p.push([n,o]),f?(this.entries=p,this):new ze(e,this.keyHash,p)},Ye.prototype.get=function(e,t,r,n){return he(r,this.entry[0])?this.entry[1]:n},Ye.prototype.update=function(e,t,r,n,o,i,a){var l=o===b,u=he(n,this.entry[0]);return(u?o===this.entry[1]:l)?this:(_(a),l?void _(i):u?e&&e===this.ownerID?(this.entry[1]=o,this):new Ye(e,this.keyHash,[n,o]):(_(i),ot(this,e,t,Ce(n),[n,o])))},He.prototype.iterate=ze.prototype.iterate=function(e,t){for(var r=this.entries,n=0,o=r.length-1;n<=o;n++)if(!1===e(r[t?o-n:n]))return!1},Ke.prototype.iterate=$e.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,o=r.length-1;n<=o;n++){var i=r[t?o-n:n];if(i&&!1===i.iterate(e,t))return!1}},Ye.prototype.iterate=function(e,t){return e(this.entry)},t(Qe,q),Qe.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r,n=t.node,o=t.index++;if(n.entry){if(0===o)return Xe(e,n.entry)}else if(n.entries){if(o<=(r=n.entries.length-1))return Xe(e,n.entries[this._reverse?r-o:o])}else if(o<=(r=n.nodes.length-1)){var i=n.nodes[this._reverse?r-o:o];if(i){if(i.entry)return Xe(e,i.entry);t=this._stack=Je(i,t)}continue}t=this._stack=this._stack.__prev}return{value:void 0,done:!0}};var ft=m/4,pt=m/2,gt=m/4;function vt(e){var t=Tt();if(null==e)return t;if(ht(e))return e;var r=o(e),n=r.size;return 0===n?t:(qe(n),n>0&&n<m?wt(0,n,h,null,new bt(r.toArray())):t.withMutations((function(e){e.setSize(n),r.forEach((function(t,r){return e.set(r,t)}))})))}function ht(e){return!(!e||!e[mt])}t(vt,_e),vt.of=function(){return this(arguments)},vt.prototype.toString=function(){return this.__toString("List [","]")},vt.prototype.get=function(e,t){if((e=C(this,e))>=0&&e<this.size){var r=It(this,e+=this._origin);return r&&r.array[e&y]}return t},vt.prototype.set=function(e,t){return function(e,t,r){if((t=C(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations((function(e){t<0?At(e,t).set(0,r):At(e,0,t+1).set(t,r)}));t+=e._origin;var n=e._tail,o=e._root,i=S(O);return t>=xt(e._capacity)?n=Pt(n,e.__ownerID,0,t,r,i):o=Pt(o,e.__ownerID,e._level,t,r,i),i.value?e.__ownerID?(e._root=o,e._tail=n,e.__hash=void 0,e.__altered=!0,e):wt(e._origin,e._capacity,e._level,o,n):e}(this,e,t)},vt.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},vt.prototype.insert=function(e,t){return this.splice(e,0,t)},vt.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=h,this._root=this._tail=null,this.__hash=void 0,this.__altered=!0,this):Tt()},vt.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations((function(r){At(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])}))},vt.prototype.pop=function(){return At(this,0,-1)},vt.prototype.unshift=function(){var e=arguments;return this.withMutations((function(t){At(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])}))},vt.prototype.shift=function(){return At(this,1)},vt.prototype.merge=function(){return Rt(this,void 0,arguments)},vt.prototype.mergeWith=function(t){return Rt(this,t,e.call(arguments,1))},vt.prototype.mergeDeep=function(){return Rt(this,at,arguments)},vt.prototype.mergeDeepWith=function(t){var r=e.call(arguments,1);return Rt(this,lt(t),r)},vt.prototype.setSize=function(e){return At(this,0,e)},vt.prototype.slice=function(e,t){var r=this.size;return A(e,t,r)?this:At(this,R(e,r),x(t,r))},vt.prototype.__iterator=function(e,t){var r=0,n=_t(this,t);return new q((function(){var t=n();return t===St?{value:void 0,done:!0}:V(e,r++,t)}))},vt.prototype.__iterate=function(e,t){for(var r,n=0,o=_t(this,t);(r=o())!==St&&!1!==e(r,n++,this););return n},vt.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?wt(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):(this.__ownerID=e,this)},vt.isList=ht;var mt="@@__IMMUTABLE_LIST__@@",yt=vt.prototype;function bt(e,t){this.array=e,this.ownerID=t}yt[mt]=!0,yt[v]=yt.remove,yt.setIn=Ge.setIn,yt.deleteIn=yt.removeIn=Ge.removeIn,yt.update=Ge.update,yt.updateIn=Ge.updateIn,yt.mergeIn=Ge.mergeIn,yt.mergeDeepIn=Ge.mergeDeepIn,yt.withMutations=Ge.withMutations,yt.asMutable=Ge.asMutable,yt.asImmutable=Ge.asImmutable,yt.wasAltered=Ge.wasAltered,bt.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&y;if(n>=this.array.length)return new bt([],e);var o,i=0===n;if(t>0){var a=this.array[n];if((o=a&&a.removeBefore(e,t-h,r))===a&&i)return this}if(i&&!o)return this;var l=Ct(this,e);if(!i)for(var u=0;u<n;u++)l.array[u]=void 0;return o&&(l.array[n]=o),l},bt.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,o=r-1>>>t&y;if(o>=this.array.length)return this;if(t>0){var i=this.array[o];if((n=i&&i.removeAfter(e,t-h,r))===i&&o===this.array.length-1)return this}var a=Ct(this,e);return a.array.splice(o+1),n&&(a.array[o]=n),a};var Et,Ot,St={};function _t(e,t){var r=e._origin,n=e._capacity,o=xt(n),i=e._tail;return a(e._root,e._level,0);function a(e,l,u){return 0===l?function(e,a){var l=a===o?i&&i.array:e&&e.array,u=a>r?0:r-a,s=n-a;return s>m&&(s=m),function(){if(u===s)return St;var e=t?--s:u++;return l&&l[e]}}(e,u):function(e,o,i){var l,u=e&&e.array,s=i>r?0:r-i>>o,c=1+(n-i>>o);return c>m&&(c=m),function(){for(;;){if(l){var e=l();if(e!==St)return e;l=null}if(s===c)return St;var r=t?--c:s++;l=a(u&&u[r],o-h,i+(r<<o))}}}(e,l,u)}}function wt(e,t,r,n,o,i,a){var l=Object.create(yt);return l.size=t-e,l._origin=e,l._capacity=t,l._level=r,l._root=n,l._tail=o,l.__ownerID=i,l.__hash=a,l.__altered=!1,l}function Tt(){return Et||(Et=wt(0,0,h))}function Pt(e,t,r,n,o,i){var a,l=n>>>r&y,u=e&&l<e.array.length;if(!u&&void 0===o)return e;if(r>0){var s=e&&e.array[l],c=Pt(s,t,r-h,n,o,i);return c===s?e:((a=Ct(e,t)).array[l]=c,a)}return u&&e.array[l]===o?e:(_(i),a=Ct(e,t),void 0===o&&l===a.array.length-1?a.array.pop():a.array[l]=o,a)}function Ct(e,t){return t&&e&&t===e.ownerID?e:new bt(e?e.array.slice():[],t)}function It(e,t){if(t>=xt(e._capacity))return e._tail;if(t<1<<e._level+h){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&y],n-=h;return r}}function At(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new w,o=e._origin,i=e._capacity,a=o+t,l=void 0===r?i:r<0?i+r:o+r;if(a===o&&l===i)return e;if(a>=l)return e.clear();for(var u=e._level,s=e._root,c=0;a+c<0;)s=new bt(s&&s.array.length?[void 0,s]:[],n),c+=1<<(u+=h);c&&(a+=c,o+=c,l+=c,i+=c);for(var d=xt(i),f=xt(l);f>=1<<u+h;)s=new bt(s&&s.array.length?[s]:[],n),u+=h;var p=e._tail,g=f<d?It(e,l-1):f>d?new bt([],n):p;if(p&&f>d&&a<i&&p.array.length){for(var v=s=Ct(s,n),m=u;m>h;m-=h){var b=d>>>m&y;v=v.array[b]=Ct(v.array[b],n)}v.array[d>>>h&y]=p}if(l<i&&(g=g&&g.removeAfter(n,0,l)),a>=f)a-=f,l-=f,u=h,s=null,g=g&&g.removeBefore(n,0,a);else if(a>o||f<d){for(c=0;s;){var E=a>>>u&y;if(E!==f>>>u&y)break;E&&(c+=(1<<u)*E),u-=h,s=s.array[E]}s&&a>o&&(s=s.removeBefore(n,u,a-c)),s&&f<d&&(s=s.removeAfter(n,u,f-c)),c&&(a-=c,l-=c)}return e.__ownerID?(e.size=l-a,e._origin=a,e._capacity=l,e._level=u,e._root=s,e._tail=g,e.__hash=void 0,e.__altered=!0,e):wt(a,l,u,s,g)}function Rt(e,t,r){for(var n=[],i=0,l=0;l<r.length;l++){var u=r[l],s=o(u);s.size>i&&(i=s.size),a(u)||(s=s.map((function(e){return fe(e)}))),n.push(s)}return i>e.size&&(e=e.setSize(i)),ut(e,t,n)}function xt(e){return e<m?0:e-1>>>h<<h}function Nt(e){return null==e?jt():Dt(e)?e:jt().withMutations((function(t){var r=n(e);qe(r.size),r.forEach((function(e,r){return t.set(r,e)}))}))}function Dt(e){return Be(e)&&c(e)}function Lt(e,t,r,n){var o=Object.create(Nt.prototype);return o.size=e?e.size:0,o._map=e,o._list=t,o.__ownerID=r,o.__hash=n,o}function jt(){return Ot||(Ot=Lt(et(),Tt()))}function Mt(e,t,r){var n,o,i=e._map,a=e._list,l=i.get(t),u=void 0!==l;if(r===b){if(!u)return e;a.size>=m&&a.size>=2*i.size?(n=(o=a.filter((function(e,t){return void 0!==e&&l!==t}))).toKeyedSeq().map((function(e){return e[0]})).flip().toMap(),e.__ownerID&&(n.__ownerID=o.__ownerID=e.__ownerID)):(n=i.remove(t),o=l===a.size-1?a.pop():a.set(l,void 0))}else if(u){if(r===a.get(l)[1])return e;n=i,o=a.set(l,[t,r])}else n=i.set(t,a.size),o=a.set(a.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=o,e.__hash=void 0,e):Lt(n,o)}function kt(e,t){this._iter=e,this._useKeys=t,this.size=e.size}function Ft(e){this._iter=e,this.size=e.size}function qt(e){this._iter=e,this.size=e.size}function Vt(e){this._iter=e,this.size=e.size}function Bt(e){var t=rr(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=nr,t.__iterateUncached=function(t,r){var n=this;return e.__iterate((function(e,r){return!1!==t(r,e,n)}),r)},t.__iteratorUncached=function(t,r){if(t===j){var n=e.__iterator(t,r);return new q((function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e}))}return e.__iterator(t===L?D:L,r)},t}function Ut(e,t,r){var n=rr(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,o){var i=e.get(n,b);return i===b?o:t.call(r,i,n,e)},n.__iterateUncached=function(n,o){var i=this;return e.__iterate((function(e,o,a){return!1!==n(t.call(r,e,o,a),o,i)}),o)},n.__iteratorUncached=function(n,o){var i=e.__iterator(j,o);return new q((function(){var o=i.next();if(o.done)return o;var a=o.value,l=a[0];return V(n,l,t.call(r,a[1],l,e),o)}))},n}function Wt(e,t){var r=rr(e);return r._iter=e,r.size=e.size,r.reverse=function(){return e},e.flip&&(r.flip=function(){var t=Bt(e);return t.reverse=function(){return e.flip()},t}),r.get=function(r,n){return e.get(t?r:-1-r,n)},r.has=function(r){return e.has(t?r:-1-r)},r.includes=function(t){return e.includes(t)},r.cacheResult=nr,r.__iterate=function(t,r){var n=this;return e.__iterate((function(e,r){return t(e,r,n)}),!r)},r.__iterator=function(t,r){return e.__iterator(t,!r)},r}function Gt(e,t,r,n){var o=rr(e);return n&&(o.has=function(n){var o=e.get(n,b);return o!==b&&!!t.call(r,o,n,e)},o.get=function(n,o){var i=e.get(n,b);return i!==b&&t.call(r,i,n,e)?i:o}),o.__iterateUncached=function(o,i){var a=this,l=0;return e.__iterate((function(e,i,u){if(t.call(r,e,i,u))return l++,o(e,n?i:l-1,a)}),i),l},o.__iteratorUncached=function(o,i){var a=e.__iterator(j,i),l=0;return new q((function(){for(;;){var i=a.next();if(i.done)return i;var u=i.value,s=u[0],c=u[1];if(t.call(r,c,s,e))return V(o,n?s:l++,c,i)}}))},o}function Ht(e,t,r,n){var o=e.size;if(void 0!==t&&(t|=0),void 0!==r&&(r===1/0?r=o:r|=0),A(t,r,o))return e;var i=R(t,o),a=x(r,o);if(i!=i||a!=a)return Ht(e.toSeq().cacheResult(),t,r,n);var l,u=a-i;u==u&&(l=u<0?0:u);var s=rr(e);return s.size=0===l?l:e.size&&l||void 0,!n&&ie(e)&&l>=0&&(s.get=function(t,r){return(t=C(this,t))>=0&&t<l?e.get(t+i,r):r}),s.__iterateUncached=function(t,r){var o=this;if(0===l)return 0;if(r)return this.cacheResult().__iterate(t,r);var a=0,u=!0,s=0;return e.__iterate((function(e,r){if(!u||!(u=a++<i))return s++,!1!==t(e,n?r:s-1,o)&&s!==l})),s},s.__iteratorUncached=function(t,r){if(0!==l&&r)return this.cacheResult().__iterator(t,r);var o=0!==l&&e.__iterator(t,r),a=0,u=0;return new q((function(){for(;a++<i;)o.next();if(++u>l)return{value:void 0,done:!0};var e=o.next();return n||t===L?e:V(t,u-1,t===D?void 0:e.value[1],e)}))},s}function Kt(e,t,r,n){var o=rr(e);return o.__iterateUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterate(o,i);var l=!0,u=0;return e.__iterate((function(e,i,s){if(!l||!(l=t.call(r,e,i,s)))return u++,o(e,n?i:u-1,a)})),u},o.__iteratorUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterator(o,i);var l=e.__iterator(j,i),u=!0,s=0;return new q((function(){var e,i,c;do{if((e=l.next()).done)return n||o===L?e:V(o,s++,o===D?void 0:e.value[1],e);var d=e.value;i=d[0],c=d[1],u&&(u=t.call(r,c,i,a))}while(u);return o===j?e:V(o,i,c,e)}))},o}function $t(e,t,r){var n=rr(e);return n.__iterateUncached=function(n,o){var i=0,l=!1;return function e(u,s){var c=this;u.__iterate((function(o,u){return(!t||s<t)&&a(o)?e(o,s+1):!1===n(o,r?u:i++,c)&&(l=!0),!l}),o)}(e,0),i},n.__iteratorUncached=function(n,o){var i=e.__iterator(n,o),l=[],u=0;return new q((function(){for(;i;){var e=i.next();if(!1===e.done){var s=e.value;if(n===j&&(s=s[1]),t&&!(l.length<t)||!a(s))return r?e:V(n,u++,s,e);l.push(i),i=s.__iterator(n,o)}else i=l.pop()}return{value:void 0,done:!0}}))},n}function zt(e,t,r){t||(t=or);var n=l(e),o=0,i=e.toSeq().map((function(t,n){return[n,t,o++,r?r(t,n,e):t]})).toArray();return i.sort((function(e,r){return t(e[3],r[3])||e[2]-r[2]})).forEach(n?function(e,t){i[t].length=2}:function(e,t){i[t]=e[1]}),n?z(i):u(e)?Y(i):Q(i)}function Yt(e,t,r){if(t||(t=or),r){var n=e.toSeq().map((function(t,n){return[t,r(t,n,e)]})).reduce((function(e,r){return Qt(t,e[1],r[1])?r:e}));return n&&n[0]}return e.reduce((function(e,r){return Qt(t,e,r)?r:e}))}function Qt(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function Xt(e,t,n){var o=rr(e);return o.size=new te(n).map((function(e){return e.size})).min(),o.__iterate=function(e,t){for(var r,n=this.__iterator(L,t),o=0;!(r=n.next()).done&&!1!==e(r.value,o++,this););return o},o.__iteratorUncached=function(e,o){var i=n.map((function(e){return e=r(e),G(o?e.reverse():e)})),a=0,l=!1;return new q((function(){var r;return l||(r=i.map((function(e){return e.next()})),l=r.some((function(e){return e.done}))),l?{value:void 0,done:!0}:V(e,a++,t.apply(null,r.map((function(e){return e.value}))))}))},o}function Jt(e,t){return ie(e)?t:e.constructor(t)}function Zt(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function er(e){return qe(e.size),P(e)}function tr(e){return l(e)?n:u(e)?o:i}function rr(e){return Object.create((l(e)?z:u(e)?Y:Q).prototype)}function nr(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):$.prototype.cacheResult.call(this)}function or(e,t){return e>t?1:e<t?-1:0}function ir(e){var t=G(e);if(!t){if(!K(e))throw new TypeError("Expected iterable or array-like: "+e);t=G(r(e))}return t}function ar(e,t){var r,n=function(i){if(i instanceof n)return i;if(!(this instanceof n))return new n(i);if(!r){r=!0;var a=Object.keys(e);(function(e,t){try{t.forEach(cr.bind(void 0,e))}catch(e){}})(o,a),o.size=a.length,o._name=t,o._keys=a,o._defaultValues=e}this._map=Ve(i)},o=n.prototype=Object.create(lr);return o.constructor=n,n}t(Nt,Ve),Nt.of=function(){return this(arguments)},Nt.prototype.toString=function(){return this.__toString("OrderedMap {","}")},Nt.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},Nt.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this):jt()},Nt.prototype.set=function(e,t){return Mt(this,e,t)},Nt.prototype.remove=function(e){return Mt(this,e,b)},Nt.prototype.wasAltered=function(){return this._map.wasAltered()||this._list.wasAltered()},Nt.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate((function(t){return t&&e(t[1],t[0],r)}),t)},Nt.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},Nt.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?Lt(t,r,e,this.__hash):(this.__ownerID=e,this._map=t,this._list=r,this)},Nt.isOrderedMap=Dt,Nt.prototype[g]=!0,Nt.prototype[v]=Nt.prototype.remove,t(kt,z),kt.prototype.get=function(e,t){return this._iter.get(e,t)},kt.prototype.has=function(e){return this._iter.has(e)},kt.prototype.valueSeq=function(){return this._iter.valueSeq()},kt.prototype.reverse=function(){var e=this,t=Wt(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},kt.prototype.map=function(e,t){var r=this,n=Ut(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},kt.prototype.__iterate=function(e,t){var r,n=this;return this._iter.__iterate(this._useKeys?function(t,r){return e(t,r,n)}:(r=t?er(this):0,function(o){return e(o,t?--r:r++,n)}),t)},kt.prototype.__iterator=function(e,t){if(this._useKeys)return this._iter.__iterator(e,t);var r=this._iter.__iterator(L,t),n=t?er(this):0;return new q((function(){var o=r.next();return o.done?o:V(e,t?--n:n++,o.value,o)}))},kt.prototype[g]=!0,t(Ft,Y),Ft.prototype.includes=function(e){return this._iter.includes(e)},Ft.prototype.__iterate=function(e,t){var r=this,n=0;return this._iter.__iterate((function(t){return e(t,n++,r)}),t)},Ft.prototype.__iterator=function(e,t){var r=this._iter.__iterator(L,t),n=0;return new q((function(){var t=r.next();return t.done?t:V(e,n++,t.value,t)}))},t(qt,Q),qt.prototype.has=function(e){return this._iter.includes(e)},qt.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){return e(t,t,r)}),t)},qt.prototype.__iterator=function(e,t){var r=this._iter.__iterator(L,t);return new q((function(){var t=r.next();return t.done?t:V(e,t.value,t.value,t)}))},t(Vt,z),Vt.prototype.entrySeq=function(){return this._iter.toSeq()},Vt.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){if(t){Zt(t);var n=a(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}}),t)},Vt.prototype.__iterator=function(e,t){var r=this._iter.__iterator(L,t);return new q((function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){Zt(n);var o=a(n);return V(e,o?n.get(0):n[0],o?n.get(1):n[1],t)}}}))},Ft.prototype.cacheResult=kt.prototype.cacheResult=qt.prototype.cacheResult=Vt.prototype.cacheResult=nr,t(ar,Se),ar.prototype.toString=function(){return this.__toString(sr(this)+" {","}")},ar.prototype.has=function(e){return this._defaultValues.hasOwnProperty(e)},ar.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._defaultValues[e];return this._map?this._map.get(e,r):r},ar.prototype.clear=function(){if(this.__ownerID)return this._map&&this._map.clear(),this;var e=this.constructor;return e._empty||(e._empty=ur(this,et()))},ar.prototype.set=function(e,t){if(!this.has(e))throw new Error('Cannot set unknown key "'+e+'" on '+sr(this));if(this._map&&!this._map.has(e)&&t===this._defaultValues[e])return this;var r=this._map&&this._map.set(e,t);return this.__ownerID||r===this._map?this:ur(this,r)},ar.prototype.remove=function(e){if(!this.has(e))return this;var t=this._map&&this._map.remove(e);return this.__ownerID||t===this._map?this:ur(this,t)},ar.prototype.wasAltered=function(){return this._map.wasAltered()},ar.prototype.__iterator=function(e,t){var r=this;return n(this._defaultValues).map((function(e,t){return r.get(t)})).__iterator(e,t)},ar.prototype.__iterate=function(e,t){var r=this;return n(this._defaultValues).map((function(e,t){return r.get(t)})).__iterate(e,t)},ar.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map&&this._map.__ensureOwner(e);return e?ur(this,t,e):(this.__ownerID=e,this._map=t,this)};var lr=ar.prototype;function ur(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._map=t,n.__ownerID=r,n}function sr(e){return e._name||e.constructor.name||"Record"}function cr(e,t){Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){be(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}function dr(e){return null==e?yr():fr(e)&&!c(e)?e:yr().withMutations((function(t){var r=i(e);qe(r.size),r.forEach((function(e){return t.add(e)}))}))}function fr(e){return!(!e||!e[gr])}lr[v]=lr.remove,lr.deleteIn=lr.removeIn=Ge.removeIn,lr.merge=Ge.merge,lr.mergeWith=Ge.mergeWith,lr.mergeIn=Ge.mergeIn,lr.mergeDeep=Ge.mergeDeep,lr.mergeDeepWith=Ge.mergeDeepWith,lr.mergeDeepIn=Ge.mergeDeepIn,lr.setIn=Ge.setIn,lr.update=Ge.update,lr.updateIn=Ge.updateIn,lr.withMutations=Ge.withMutations,lr.asMutable=Ge.asMutable,lr.asImmutable=Ge.asImmutable,t(dr,we),dr.of=function(){return this(arguments)},dr.fromKeys=function(e){return this(n(e).keySeq())},dr.prototype.toString=function(){return this.__toString("Set {","}")},dr.prototype.has=function(e){return this._map.has(e)},dr.prototype.add=function(e){return hr(this,this._map.set(e,!0))},dr.prototype.remove=function(e){return hr(this,this._map.remove(e))},dr.prototype.clear=function(){return hr(this,this._map.clear())},dr.prototype.union=function(){var t=e.call(arguments,0);return 0===(t=t.filter((function(e){return 0!==e.size}))).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations((function(e){for(var r=0;r<t.length;r++)i(t[r]).forEach((function(t){return e.add(t)}))})):this.constructor(t[0])},dr.prototype.intersect=function(){var t=e.call(arguments,0);if(0===t.length)return this;t=t.map((function(e){return i(e)}));var r=this;return this.withMutations((function(e){r.forEach((function(r){t.every((function(e){return e.includes(r)}))||e.remove(r)}))}))},dr.prototype.subtract=function(){var t=e.call(arguments,0);if(0===t.length)return this;t=t.map((function(e){return i(e)}));var r=this;return this.withMutations((function(e){r.forEach((function(r){t.some((function(e){return e.includes(r)}))&&e.remove(r)}))}))},dr.prototype.merge=function(){return this.union.apply(this,arguments)},dr.prototype.mergeWith=function(t){var r=e.call(arguments,1);return this.union.apply(this,r)},dr.prototype.sort=function(e){return br(zt(this,e))},dr.prototype.sortBy=function(e,t){return br(zt(this,t,e))},dr.prototype.wasAltered=function(){return this._map.wasAltered()},dr.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate((function(t,n){return e(n,n,r)}),t)},dr.prototype.__iterator=function(e,t){return this._map.map((function(e,t){return t})).__iterator(e,t)},dr.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):(this.__ownerID=e,this._map=t,this)},dr.isSet=fr;var pr,gr="@@__IMMUTABLE_SET__@@",vr=dr.prototype;function hr(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function mr(e,t){var r=Object.create(vr);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function yr(){return pr||(pr=mr(et()))}function br(e){return null==e?wr():Er(e)?e:wr().withMutations((function(t){var r=i(e);qe(r.size),r.forEach((function(e){return t.add(e)}))}))}function Er(e){return fr(e)&&c(e)}vr[gr]=!0,vr[v]=vr.remove,vr.mergeDeep=vr.merge,vr.mergeDeepWith=vr.mergeWith,vr.withMutations=Ge.withMutations,vr.asMutable=Ge.asMutable,vr.asImmutable=Ge.asImmutable,vr.__empty=yr,vr.__make=mr,t(br,dr),br.of=function(){return this(arguments)},br.fromKeys=function(e){return this(n(e).keySeq())},br.prototype.toString=function(){return this.__toString("OrderedSet {","}")},br.isOrderedSet=Er;var Or,Sr=br.prototype;function _r(e,t){var r=Object.create(Sr);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function wr(){return Or||(Or=_r(jt()))}function Tr(e){return null==e?xr():Pr(e)?e:xr().unshiftAll(e)}function Pr(e){return!(!e||!e[Ir])}Sr[g]=!0,Sr.__empty=wr,Sr.__make=_r,t(Tr,_e),Tr.of=function(){return this(arguments)},Tr.prototype.toString=function(){return this.__toString("Stack [","]")},Tr.prototype.get=function(e,t){var r=this._head;for(e=C(this,e);r&&e--;)r=r.next;return r?r.value:t},Tr.prototype.peek=function(){return this._head&&this._head.value},Tr.prototype.push=function(){if(0===arguments.length)return this;for(var e=this.size+arguments.length,t=this._head,r=arguments.length-1;r>=0;r--)t={value:arguments[r],next:t};return this.__ownerID?(this.size=e,this._head=t,this.__hash=void 0,this.__altered=!0,this):Rr(e,t)},Tr.prototype.pushAll=function(e){if(0===(e=o(e)).size)return this;qe(e.size);var t=this.size,r=this._head;return e.reverse().forEach((function(e){t++,r={value:e,next:r}})),this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):Rr(t,r)},Tr.prototype.pop=function(){return this.slice(1)},Tr.prototype.unshift=function(){return this.push.apply(this,arguments)},Tr.prototype.unshiftAll=function(e){return this.pushAll(e)},Tr.prototype.shift=function(){return this.pop.apply(this,arguments)},Tr.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):xr()},Tr.prototype.slice=function(e,t){if(A(e,t,this.size))return this;var r=R(e,this.size);if(x(t,this.size)!==this.size)return _e.prototype.slice.call(this,e,t);for(var n=this.size-r,o=this._head;r--;)o=o.next;return this.__ownerID?(this.size=n,this._head=o,this.__hash=void 0,this.__altered=!0,this):Rr(n,o)},Tr.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Rr(this.size,this._head,e,this.__hash):(this.__ownerID=e,this.__altered=!1,this)},Tr.prototype.__iterate=function(e,t){if(t)return this.reverse().__iterate(e);for(var r=0,n=this._head;n&&!1!==e(n.value,r++,this);)n=n.next;return r},Tr.prototype.__iterator=function(e,t){if(t)return this.reverse().__iterator(e);var r=0,n=this._head;return new q((function(){if(n){var t=n.value;return n=n.next,V(e,r++,t)}return{value:void 0,done:!0}}))},Tr.isStack=Pr;var Cr,Ir="@@__IMMUTABLE_STACK__@@",Ar=Tr.prototype;function Rr(e,t,r,n){var o=Object.create(Ar);return o.size=e,o._head=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function xr(){return Cr||(Cr=Rr(0))}function Nr(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}Ar[Ir]=!0,Ar.withMutations=Ge.withMutations,Ar.asMutable=Ge.asMutable,Ar.asImmutable=Ge.asImmutable,Ar.wasAltered=Ge.wasAltered,r.Iterator=q,Nr(r,{toArray:function(){qe(this.size);var e=new Array(this.size||0);return this.valueSeq().__iterate((function(t,r){e[r]=t})),e},toIndexedSeq:function(){return new Ft(this)},toJS:function(){return this.toSeq().map((function(e){return e&&"function"==typeof e.toJS?e.toJS():e})).__toJS()},toJSON:function(){return this.toSeq().map((function(e){return e&&"function"==typeof e.toJSON?e.toJSON():e})).__toJS()},toKeyedSeq:function(){return new kt(this,!0)},toMap:function(){return Ve(this.toKeyedSeq())},toObject:function(){qe(this.size);var e={};return this.__iterate((function(t,r){e[r]=t})),e},toOrderedMap:function(){return Nt(this.toKeyedSeq())},toOrderedSet:function(){return br(l(this)?this.valueSeq():this)},toSet:function(){return dr(l(this)?this.valueSeq():this)},toSetSeq:function(){return new qt(this)},toSeq:function(){return u(this)?this.toIndexedSeq():l(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return Tr(l(this)?this.valueSeq():this)},toList:function(){return vt(l(this)?this.valueSeq():this)},toString:function(){return"[Iterable]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){return Jt(this,function(e,t){var r=l(e),o=[e].concat(t).map((function(e){return a(e)?r&&(e=n(e)):e=r?le(e):ue(Array.isArray(e)?e:[e]),e})).filter((function(e){return 0!==e.size}));if(0===o.length)return e;if(1===o.length){var i=o[0];if(i===e||r&&l(i)||u(e)&&u(i))return i}var s=new te(o);return r?s=s.toKeyedSeq():u(e)||(s=s.toSetSeq()),(s=s.flatten(!0)).size=o.reduce((function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}}),0),s}(this,e.call(arguments,0)))},includes:function(e){return this.some((function(t){return he(t,e)}))},entries:function(){return this.__iterator(j)},every:function(e,t){qe(this.size);var r=!0;return this.__iterate((function(n,o,i){if(!e.call(t,n,o,i))return r=!1,!1})),r},filter:function(e,t){return Jt(this,Gt(this,e,t,!0))},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return qe(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){qe(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate((function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""})),t},keys:function(){return this.__iterator(D)},map:function(e,t){return Jt(this,Ut(this,e,t))},reduce:function(e,t,r){var n,o;return qe(this.size),arguments.length<2?o=!0:n=t,this.__iterate((function(t,i,a){o?(o=!1,n=t):n=e.call(r,n,t,i,a)})),n},reduceRight:function(e,t,r){var n=this.toKeyedSeq().reverse();return n.reduce.apply(n,arguments)},reverse:function(){return Jt(this,Wt(this,!0))},slice:function(e,t){return Jt(this,Ht(this,e,t,!0))},some:function(e,t){return!this.every(kr(e),t)},sort:function(e){return Jt(this,zt(this,e))},values:function(){return this.__iterator(L)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some((function(){return!0}))},count:function(e,t){return P(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return function(e,t,r){var n=Ve().asMutable();return e.__iterate((function(o,i){n.update(t.call(r,o,i,e),0,(function(e){return e+1}))})),n.asImmutable()}(this,e,t)},equals:function(e){return me(this,e)},entrySeq:function(){var e=this;if(e._cache)return new te(e._cache);var t=e.toSeq().map(Mr).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(kr(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate((function(r,o,i){if(e.call(t,r,o,i))return n=[o,r],!1})),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(){return this.find(I)},flatMap:function(e,t){return Jt(this,function(e,t,r){var n=tr(e);return e.toSeq().map((function(o,i){return n(t.call(r,o,i,e))})).flatten(!0)}(this,e,t))},flatten:function(e){return Jt(this,$t(this,e,!0))},fromEntrySeq:function(){return new Vt(this)},get:function(e,t){return this.find((function(t,r){return he(r,e)}),void 0,t)},getIn:function(e,t){for(var r,n=this,o=ir(e);!(r=o.next()).done;){var i=r.value;if((n=n&&n.get?n.get(i,b):b)===b)return t}return n},groupBy:function(e,t){return function(e,t,r){var n=l(e),o=(c(e)?Nt():Ve()).asMutable();e.__iterate((function(i,a){o.update(t.call(r,i,a,e),(function(e){return(e=e||[]).push(n?[a,i]:i),e}))}));var i=tr(e);return o.map((function(t){return Jt(e,i(t))}))}(this,e,t)},has:function(e){return this.get(e,b)!==b},hasIn:function(e){return this.getIn(e,b)!==b},isSubset:function(e){return e="function"==typeof e.includes?e:r(e),this.every((function(t){return e.includes(t)}))},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:r(e)).isSubset(this)},keyOf:function(e){return this.findKey((function(t){return he(t,e)}))},keySeq:function(){return this.toSeq().map(jr).toIndexedSeq()},last:function(){return this.toSeq().reverse().first()},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return Yt(this,e)},maxBy:function(e,t){return Yt(this,t,e)},min:function(e){return Yt(this,e?Fr(e):Br)},minBy:function(e,t){return Yt(this,t?Fr(t):Br,e)},rest:function(){return this.slice(1)},skip:function(e){return this.slice(Math.max(0,e))},skipLast:function(e){return Jt(this,this.toSeq().reverse().skip(e).reverse())},skipWhile:function(e,t){return Jt(this,Kt(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(kr(e),t)},sortBy:function(e,t){return Jt(this,zt(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return Jt(this,this.toSeq().reverse().take(e).reverse())},takeWhile:function(e,t){return Jt(this,function(e,t,r){var n=rr(e);return n.__iterateUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterate(n,o);var a=0;return e.__iterate((function(e,o,l){return t.call(r,e,o,l)&&++a&&n(e,o,i)})),a},n.__iteratorUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterator(n,o);var a=e.__iterator(j,o),l=!0;return new q((function(){if(!l)return{value:void 0,done:!0};var e=a.next();if(e.done)return e;var o=e.value,u=o[0],s=o[1];return t.call(r,s,u,i)?n===j?e:V(n,u,s,e):(l=!1,{value:void 0,done:!0})}))},n}(this,e,t))},takeUntil:function(e,t){return this.takeWhile(kr(e),t)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(e){if(e.size===1/0)return 0;var t=c(e),r=l(e),n=t?1:0;return function(e,t){return t=Te(t,3432918353),t=Te(t<<15|t>>>-15,461845907),t=Te(t<<13|t>>>-13,5),t=Te((t=t+3864292196^e)^t>>>16,2246822507),Pe((t=Te(t^t>>>13,3266489909))^t>>>16)}(e.__iterate(r?t?function(e,t){n=31*n+Ur(Ce(e),Ce(t))|0}:function(e,t){n=n+Ur(Ce(e),Ce(t))|0}:t?function(e){n=31*n+Ce(e)|0}:function(e){n=n+Ce(e)|0}),n)}(this))}});var Dr=r.prototype;Dr[d]=!0,Dr[F]=Dr.values,Dr.__toJS=Dr.toArray,Dr.__toStringMapper=qr,Dr.inspect=Dr.toSource=function(){return this.toString()},Dr.chain=Dr.flatMap,Dr.contains=Dr.includes,Nr(n,{flip:function(){return Jt(this,Bt(this))},mapEntries:function(e,t){var r=this,n=0;return Jt(this,this.toSeq().map((function(o,i){return e.call(t,[i,o],n++,r)})).fromEntrySeq())},mapKeys:function(e,t){var r=this;return Jt(this,this.toSeq().flip().map((function(n,o){return e.call(t,n,o,r)})).flip())}});var Lr=n.prototype;function jr(e,t){return t}function Mr(e,t){return[t,e]}function kr(e){return function(){return!e.apply(this,arguments)}}function Fr(e){return function(){return-e.apply(this,arguments)}}function qr(e){return"string"==typeof e?JSON.stringify(e):String(e)}function Vr(){return T(arguments)}function Br(e,t){return e<t?1:e>t?-1:0}function Ur(e,t){return e^t+2654435769+(e<<6)+(e>>2)}return Lr[f]=!0,Lr[F]=Dr.entries,Lr.__toJS=Dr.toObject,Lr.__toStringMapper=function(e,t){return JSON.stringify(t)+": "+qr(e)},Nr(o,{toKeyedSeq:function(){return new kt(this,!1)},filter:function(e,t){return Jt(this,Gt(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return Jt(this,Wt(this,!1))},slice:function(e,t){return Jt(this,Ht(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(0|t,0),0===r||2===r&&!t)return this;e=R(e,e<0?this.count():this.size);var n=this.slice(0,e);return Jt(this,1===r?n:n.concat(T(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(){return this.get(0)},flatten:function(e){return Jt(this,$t(this,e,!1))},get:function(e,t){return(e=C(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find((function(t,r){return r===e}),void 0,t)},has:function(e){return(e=C(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return Jt(this,function(e,t){var r=rr(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var o=this,i=0;return e.__iterate((function(e,n){return(!i||!1!==r(t,i++,o))&&!1!==r(e,i++,o)}),n),i},r.__iteratorUncached=function(r,n){var o,i=e.__iterator(L,n),a=0;return new q((function(){return(!o||a%2)&&(o=i.next()).done?o:a%2?V(r,a++,t):V(r,a++,o.value,o)}))},r}(this,e))},interleave:function(){var e=[this].concat(T(arguments)),t=Xt(this.toSeq(),Y.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),Jt(this,r)},keySeq:function(){return Ee(0,this.size)},last:function(){return this.get(-1)},skipWhile:function(e,t){return Jt(this,Kt(this,e,t,!1))},zip:function(){return Jt(this,Xt(this,Vr,[this].concat(T(arguments))))},zipWith:function(e){var t=T(arguments);return t[0]=this,Jt(this,Xt(this,e,t))}}),o.prototype[p]=!0,o.prototype[g]=!0,Nr(i,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}}),i.prototype.has=Dr.includes,i.prototype.contains=i.prototype.includes,Nr(z,n.prototype),Nr(Y,o.prototype),Nr(Q,i.prototype),Nr(Se,n.prototype),Nr(_e,o.prototype),Nr(we,i.prototype),{Iterable:r,Seq:$,Collection:Oe,Map:Ve,OrderedMap:Nt,List:vt,Stack:Tr,Set:dr,OrderedSet:br,Record:ar,Range:Ee,Repeat:ye,is:he,fromJS:fe}}()},26010:(e,t,r)=>{"use strict";var n=r(77929);function o(){}function i(){}i.resetWarningCache=o,e.exports=function(){function e(e,t,r,o,i,a){if(a!==n){var l=new Error("Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types");throw l.name="Invariant Violation",l}}function t(){return e}e.isRequired=e;var r={array:e,bigint:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,elementType:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t,exact:t,checkPropTypes:i,resetWarningCache:o};return r.PropTypes=r,r}},91504:(e,t,r)=>{e.exports=r(26010)()},77929:e=>{"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},90206:(e,t,r)=>{"use strict";var n=r(23525);function o(){}function i(){}i.resetWarningCache=o,e.exports=function(){function e(e,t,r,o,i,a){if(a!==n){var l=new Error("Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types");throw l.name="Invariant Violation",l}}function t(){return e}e.isRequired=e;var r={array:e,bigint:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,elementType:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t,exact:t,checkPropTypes:i,resetWarningCache:o};return r.PropTypes=r,r}},50012:(e,t,r)=>{e.exports=r(90206)()},23525:e=>{"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},97383:e=>{var t="undefined"!=typeof Element,r="function"==typeof Map,n="function"==typeof Set,o="function"==typeof ArrayBuffer&&!!ArrayBuffer.isView;function i(e,a){if(e===a)return!0;if(e&&a&&"object"==typeof e&&"object"==typeof a){if(e.constructor!==a.constructor)return!1;var l,u,s,c;if(Array.isArray(e)){if((l=e.length)!=a.length)return!1;for(u=l;0!=u--;)if(!i(e[u],a[u]))return!1;return!0}if(r&&e instanceof Map&&a instanceof Map){if(e.size!==a.size)return!1;for(c=e.entries();!(u=c.next()).done;)if(!a.has(u.value[0]))return!1;for(c=e.entries();!(u=c.next()).done;)if(!i(u.value[1],a.get(u.value[0])))return!1;return!0}if(n&&e instanceof Set&&a instanceof Set){if(e.size!==a.size)return!1;for(c=e.entries();!(u=c.next()).done;)if(!a.has(u.value[0]))return!1;return!0}if(o&&ArrayBuffer.isView(e)&&ArrayBuffer.isView(a)){if((l=e.length)!=a.length)return!1;for(u=l;0!=u--;)if(e[u]!==a[u])return!1;return!0}if(e.constructor===RegExp)return e.source===a.source&&e.flags===a.flags;if(e.valueOf!==Object.prototype.valueOf&&"function"==typeof e.valueOf&&"function"==typeof a.valueOf)return e.valueOf()===a.valueOf();if(e.toString!==Object.prototype.toString&&"function"==typeof e.toString&&"function"==typeof a.toString)return e.toString()===a.toString();if((l=(s=Object.keys(e)).length)!==Object.keys(a).length)return!1;for(u=l;0!=u--;)if(!Object.prototype.hasOwnProperty.call(a,s[u]))return!1;if(t&&e instanceof Element)return!1;for(u=l;0!=u--;)if(("_owner"!==s[u]&&"__v"!==s[u]&&"__o"!==s[u]||!e.$$typeof)&&!i(e[s[u]],a[s[u]]))return!1;return!0}return e!=e&&a!=a}e.exports=function(e,t){try{return i(e,t)}catch(e){if((e.message||"").match(/stack|recursion/i))return console.warn("react-fast-compare cannot handle circular refs"),!1;throw e}}},38299:(e,t)=>{"use strict";var r="function"==typeof Symbol&&Symbol.for;r&&Symbol.for("react.element"),r&&Symbol.for("react.portal"),r&&Symbol.for("react.fragment"),r&&Symbol.for("react.strict_mode"),r&&Symbol.for("react.profiler"),r&&Symbol.for("react.provider"),r&&Symbol.for("react.context"),r&&Symbol.for("react.async_mode"),r&&Symbol.for("react.concurrent_mode"),r&&Symbol.for("react.forward_ref"),r&&Symbol.for("react.suspense"),r&&Symbol.for("react.suspense_list"),r&&Symbol.for("react.memo"),r&&Symbol.for("react.lazy"),r&&Symbol.for("react.block"),r&&Symbol.for("react.fundamental"),r&&Symbol.for("react.responder"),r&&Symbol.for("react.scope")},84271:(e,t,r)=>{"use strict";r(38299)},67223:(e,t,r)=>{"use strict";r.r(t),r.d(t,{usePopperTooltip:()=>Ce});var n=r(49257);function o(){return o=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},o.apply(this,arguments)}var i=r(85959),a=r(48398);function l(e){if(null==e)return window;if("[object Window]"!==e.toString()){var t=e.ownerDocument;return t&&t.defaultView||window}return e}function u(e){return e instanceof l(e).Element||e instanceof Element}function s(e){return e instanceof l(e).HTMLElement||e instanceof HTMLElement}function c(e){return"undefined"!=typeof ShadowRoot&&(e instanceof l(e).ShadowRoot||e instanceof ShadowRoot)}var d=Math.max,f=Math.min,p=Math.round;function g(){var e=navigator.userAgentData;return null!=e&&e.brands&&Array.isArray(e.brands)?e.brands.map((function(e){return e.brand+"/"+e.version})).join(" "):navigator.userAgent}function v(){return!/^((?!chrome|android).)*safari/i.test(g())}function h(e,t,r){void 0===t&&(t=!1),void 0===r&&(r=!1);var n=e.getBoundingClientRect(),o=1,i=1;t&&s(e)&&(o=e.offsetWidth>0&&p(n.width)/e.offsetWidth||1,i=e.offsetHeight>0&&p(n.height)/e.offsetHeight||1);var a=(u(e)?l(e):window).visualViewport,c=!v()&&r,d=(n.left+(c&&a?a.offsetLeft:0))/o,f=(n.top+(c&&a?a.offsetTop:0))/i,g=n.width/o,h=n.height/i;return{width:g,height:h,top:f,right:d+g,bottom:f+h,left:d,x:d,y:f}}function m(e){var t=l(e);return{scrollLeft:t.pageXOffset,scrollTop:t.pageYOffset}}function y(e){return e?(e.nodeName||"").toLowerCase():null}function b(e){return((u(e)?e.ownerDocument:e.document)||window.document).documentElement}function E(e){return h(b(e)).left+m(e).scrollLeft}function O(e){return l(e).getComputedStyle(e)}function S(e){var t=O(e),r=t.overflow,n=t.overflowX,o=t.overflowY;return/auto|scroll|overlay|hidden/.test(r+o+n)}function _(e,t,r){void 0===r&&(r=!1);var n,o,i=s(t),a=s(t)&&function(e){var t=e.getBoundingClientRect(),r=p(t.width)/e.offsetWidth||1,n=p(t.height)/e.offsetHeight||1;return 1!==r||1!==n}(t),u=b(t),c=h(e,a,r),d={scrollLeft:0,scrollTop:0},f={x:0,y:0};return(i||!i&&!r)&&(("body"!==y(t)||S(u))&&(d=(n=t)!==l(n)&&s(n)?{scrollLeft:(o=n).scrollLeft,scrollTop:o.scrollTop}:m(n)),s(t)?((f=h(t,!0)).x+=t.clientLeft,f.y+=t.clientTop):u&&(f.x=E(u))),{x:c.left+d.scrollLeft-f.x,y:c.top+d.scrollTop-f.y,width:c.width,height:c.height}}function w(e){var t=h(e),r=e.offsetWidth,n=e.offsetHeight;return Math.abs(t.width-r)<=1&&(r=t.width),Math.abs(t.height-n)<=1&&(n=t.height),{x:e.offsetLeft,y:e.offsetTop,width:r,height:n}}function T(e){return"html"===y(e)?e:e.assignedSlot||e.parentNode||(c(e)?e.host:null)||b(e)}function P(e){return["html","body","#document"].indexOf(y(e))>=0?e.ownerDocument.body:s(e)&&S(e)?e:P(T(e))}function C(e,t){var r;void 0===t&&(t=[]);var n=P(e),o=n===(null==(r=e.ownerDocument)?void 0:r.body),i=l(n),a=o?[i].concat(i.visualViewport||[],S(n)?n:[]):n,u=t.concat(a);return o?u:u.concat(C(T(a)))}function I(e){return["table","td","th"].indexOf(y(e))>=0}function A(e){return s(e)&&"fixed"!==O(e).position?e.offsetParent:null}function R(e){for(var t=l(e),r=A(e);r&&I(r)&&"static"===O(r).position;)r=A(r);return r&&("html"===y(r)||"body"===y(r)&&"static"===O(r).position)?t:r||function(e){var t=/firefox/i.test(g());if(/Trident/i.test(g())&&s(e)&&"fixed"===O(e).position)return null;var r=T(e);for(c(r)&&(r=r.host);s(r)&&["html","body"].indexOf(y(r))<0;){var n=O(r);if("none"!==n.transform||"none"!==n.perspective||"paint"===n.contain||-1!==["transform","perspective"].indexOf(n.willChange)||t&&"filter"===n.willChange||t&&n.filter&&"none"!==n.filter)return r;r=r.parentNode}return null}(e)||t}var x="top",N="bottom",D="right",L="left",j="auto",M=[x,N,D,L],k="start",F="end",q="viewport",V="popper",B=M.reduce((function(e,t){return e.concat([t+"-"+k,t+"-"+F])}),[]),U=[].concat(M,[j]).reduce((function(e,t){return e.concat([t,t+"-"+k,t+"-"+F])}),[]),W=["beforeRead","read","afterRead","beforeMain","main","afterMain","beforeWrite","write","afterWrite"];function G(e){var t=new Map,r=new Set,n=[];function o(e){r.add(e.name),[].concat(e.requires||[],e.requiresIfExists||[]).forEach((function(e){if(!r.has(e)){var n=t.get(e);n&&o(n)}})),n.push(e)}return e.forEach((function(e){t.set(e.name,e)})),e.forEach((function(e){r.has(e.name)||o(e)})),n}var H={placement:"bottom",modifiers:[],strategy:"absolute"};function K(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return!t.some((function(e){return!(e&&"function"==typeof e.getBoundingClientRect)}))}function $(e){void 0===e&&(e={});var t=e,r=t.defaultModifiers,n=void 0===r?[]:r,o=t.defaultOptions,i=void 0===o?H:o;return function(e,t,r){void 0===r&&(r=i);var o,a,l={placement:"bottom",orderedModifiers:[],options:Object.assign({},H,i),modifiersData:{},elements:{reference:e,popper:t},attributes:{},styles:{}},s=[],c=!1,d={state:l,setOptions:function(r){var o="function"==typeof r?r(l.options):r;f(),l.options=Object.assign({},i,l.options,o),l.scrollParents={reference:u(e)?C(e):e.contextElement?C(e.contextElement):[],popper:C(t)};var a,c,p=function(e){var t=G(e);return W.reduce((function(e,r){return e.concat(t.filter((function(e){return e.phase===r})))}),[])}((a=[].concat(n,l.options.modifiers),c=a.reduce((function(e,t){var r=e[t.name];return e[t.name]=r?Object.assign({},r,t,{options:Object.assign({},r.options,t.options),data:Object.assign({},r.data,t.data)}):t,e}),{}),Object.keys(c).map((function(e){return c[e]}))));return l.orderedModifiers=p.filter((function(e){return e.enabled})),l.orderedModifiers.forEach((function(e){var t=e.name,r=e.options,n=void 0===r?{}:r,o=e.effect;if("function"==typeof o){var i=o({state:l,name:t,instance:d,options:n});s.push(i||function(){})}})),d.update()},forceUpdate:function(){if(!c){var e=l.elements,t=e.reference,r=e.popper;if(K(t,r)){l.rects={reference:_(t,R(r),"fixed"===l.options.strategy),popper:w(r)},l.reset=!1,l.placement=l.options.placement,l.orderedModifiers.forEach((function(e){return l.modifiersData[e.name]=Object.assign({},e.data)}));for(var n=0;n<l.orderedModifiers.length;n++)if(!0!==l.reset){var o=l.orderedModifiers[n],i=o.fn,a=o.options,u=void 0===a?{}:a,s=o.name;"function"==typeof i&&(l=i({state:l,options:u,name:s,instance:d})||l)}else l.reset=!1,n=-1}}},update:(o=function(){return new Promise((function(e){d.forceUpdate(),e(l)}))},function(){return a||(a=new Promise((function(e){Promise.resolve().then((function(){a=void 0,e(o())}))}))),a}),destroy:function(){f(),c=!0}};if(!K(e,t))return d;function f(){s.forEach((function(e){return e()})),s=[]}return d.setOptions(r).then((function(e){!c&&r.onFirstUpdate&&r.onFirstUpdate(e)})),d}}var z={passive:!0};function Y(e){return e.split("-")[0]}function Q(e){return e.split("-")[1]}function X(e){return["top","bottom"].indexOf(e)>=0?"x":"y"}function J(e){var t,r=e.reference,n=e.element,o=e.placement,i=o?Y(o):null,a=o?Q(o):null,l=r.x+r.width/2-n.width/2,u=r.y+r.height/2-n.height/2;switch(i){case x:t={x:l,y:r.y-n.height};break;case N:t={x:l,y:r.y+r.height};break;case D:t={x:r.x+r.width,y:u};break;case L:t={x:r.x-n.width,y:u};break;default:t={x:r.x,y:r.y}}var s=i?X(i):null;if(null!=s){var c="y"===s?"height":"width";switch(a){case k:t[s]=t[s]-(r[c]/2-n[c]/2);break;case F:t[s]=t[s]+(r[c]/2-n[c]/2)}}return t}var Z={top:"auto",right:"auto",bottom:"auto",left:"auto"};function ee(e){var t,r=e.popper,n=e.popperRect,o=e.placement,i=e.variation,a=e.offsets,u=e.position,s=e.gpuAcceleration,c=e.adaptive,d=e.roundOffsets,f=e.isFixed,g=a.x,v=void 0===g?0:g,h=a.y,m=void 0===h?0:h,y="function"==typeof d?d({x:v,y:m}):{x:v,y:m};v=y.x,m=y.y;var E=a.hasOwnProperty("x"),S=a.hasOwnProperty("y"),_=L,w=x,T=window;if(c){var P=R(r),C="clientHeight",I="clientWidth";P===l(r)&&"static"!==O(P=b(r)).position&&"absolute"===u&&(C="scrollHeight",I="scrollWidth"),(o===x||(o===L||o===D)&&i===F)&&(w=N,m-=(f&&P===T&&T.visualViewport?T.visualViewport.height:P[C])-n.height,m*=s?1:-1),o!==L&&(o!==x&&o!==N||i!==F)||(_=D,v-=(f&&P===T&&T.visualViewport?T.visualViewport.width:P[I])-n.width,v*=s?1:-1)}var A,j=Object.assign({position:u},c&&Z),M=!0===d?function(e,t){var r=e.x,n=e.y,o=t.devicePixelRatio||1;return{x:p(r*o)/o||0,y:p(n*o)/o||0}}({x:v,y:m},l(r)):{x:v,y:m};return v=M.x,m=M.y,s?Object.assign({},j,((A={})[w]=S?"0":"",A[_]=E?"0":"",A.transform=(T.devicePixelRatio||1)<=1?"translate("+v+"px, "+m+"px)":"translate3d("+v+"px, "+m+"px, 0)",A)):Object.assign({},j,((t={})[w]=S?m+"px":"",t[_]=E?v+"px":"",t.transform="",t))}var te={left:"right",right:"left",bottom:"top",top:"bottom"};function re(e){return e.replace(/left|right|bottom|top/g,(function(e){return te[e]}))}var ne={start:"end",end:"start"};function oe(e){return e.replace(/start|end/g,(function(e){return ne[e]}))}function ie(e,t){var r=t.getRootNode&&t.getRootNode();if(e.contains(t))return!0;if(r&&c(r)){var n=t;do{if(n&&e.isSameNode(n))return!0;n=n.parentNode||n.host}while(n)}return!1}function ae(e){return Object.assign({},e,{left:e.x,top:e.y,right:e.x+e.width,bottom:e.y+e.height})}function le(e,t,r){return t===q?ae(function(e,t){var r=l(e),n=b(e),o=r.visualViewport,i=n.clientWidth,a=n.clientHeight,u=0,s=0;if(o){i=o.width,a=o.height;var c=v();(c||!c&&"fixed"===t)&&(u=o.offsetLeft,s=o.offsetTop)}return{width:i,height:a,x:u+E(e),y:s}}(e,r)):u(t)?function(e,t){var r=h(e,!1,"fixed"===t);return r.top=r.top+e.clientTop,r.left=r.left+e.clientLeft,r.bottom=r.top+e.clientHeight,r.right=r.left+e.clientWidth,r.width=e.clientWidth,r.height=e.clientHeight,r.x=r.left,r.y=r.top,r}(t,r):ae(function(e){var t,r=b(e),n=m(e),o=null==(t=e.ownerDocument)?void 0:t.body,i=d(r.scrollWidth,r.clientWidth,o?o.scrollWidth:0,o?o.clientWidth:0),a=d(r.scrollHeight,r.clientHeight,o?o.scrollHeight:0,o?o.clientHeight:0),l=-n.scrollLeft+E(e),u=-n.scrollTop;return"rtl"===O(o||r).direction&&(l+=d(r.clientWidth,o?o.clientWidth:0)-i),{width:i,height:a,x:l,y:u}}(b(e)))}function ue(e){return Object.assign({},{top:0,right:0,bottom:0,left:0},e)}function se(e,t){return t.reduce((function(t,r){return t[r]=e,t}),{})}function ce(e,t){void 0===t&&(t={});var r=t,n=r.placement,o=void 0===n?e.placement:n,i=r.strategy,a=void 0===i?e.strategy:i,l=r.boundary,c=void 0===l?"clippingParents":l,p=r.rootBoundary,g=void 0===p?q:p,v=r.elementContext,m=void 0===v?V:v,E=r.altBoundary,S=void 0!==E&&E,_=r.padding,w=void 0===_?0:_,P=ue("number"!=typeof w?w:se(w,M)),I=m===V?"reference":V,A=e.rects.popper,L=e.elements[S?I:m],j=function(e,t,r,n){var o="clippingParents"===t?function(e){var t=C(T(e)),r=["absolute","fixed"].indexOf(O(e).position)>=0&&s(e)?R(e):e;return u(r)?t.filter((function(e){return u(e)&&ie(e,r)&&"body"!==y(e)})):[]}(e):[].concat(t),i=[].concat(o,[r]),a=i[0],l=i.reduce((function(t,r){var o=le(e,r,n);return t.top=d(o.top,t.top),t.right=f(o.right,t.right),t.bottom=f(o.bottom,t.bottom),t.left=d(o.left,t.left),t}),le(e,a,n));return l.width=l.right-l.left,l.height=l.bottom-l.top,l.x=l.left,l.y=l.top,l}(u(L)?L:L.contextElement||b(e.elements.popper),c,g,a),k=h(e.elements.reference),F=J({reference:k,element:A,strategy:"absolute",placement:o}),B=ae(Object.assign({},A,F)),U=m===V?B:k,W={top:j.top-U.top+P.top,bottom:U.bottom-j.bottom+P.bottom,left:j.left-U.left+P.left,right:U.right-j.right+P.right},G=e.modifiersData.offset;if(m===V&&G){var H=G[o];Object.keys(W).forEach((function(e){var t=[D,N].indexOf(e)>=0?1:-1,r=[x,N].indexOf(e)>=0?"y":"x";W[e]+=H[r]*t}))}return W}function de(e,t,r){return d(e,f(t,r))}function fe(e,t,r){return void 0===r&&(r={x:0,y:0}),{top:e.top-t.height-r.y,right:e.right-t.width+r.x,bottom:e.bottom-t.height+r.y,left:e.left-t.width-r.x}}function pe(e){return[x,D,N,L].some((function(t){return e[t]>=0}))}var ge=$({defaultModifiers:[{name:"eventListeners",enabled:!0,phase:"write",fn:function(){},effect:function(e){var t=e.state,r=e.instance,n=e.options,o=n.scroll,i=void 0===o||o,a=n.resize,u=void 0===a||a,s=l(t.elements.popper),c=[].concat(t.scrollParents.reference,t.scrollParents.popper);return i&&c.forEach((function(e){e.addEventListener("scroll",r.update,z)})),u&&s.addEventListener("resize",r.update,z),function(){i&&c.forEach((function(e){e.removeEventListener("scroll",r.update,z)})),u&&s.removeEventListener("resize",r.update,z)}},data:{}},{name:"popperOffsets",enabled:!0,phase:"read",fn:function(e){var t=e.state,r=e.name;t.modifiersData[r]=J({reference:t.rects.reference,element:t.rects.popper,strategy:"absolute",placement:t.placement})},data:{}},{name:"computeStyles",enabled:!0,phase:"beforeWrite",fn:function(e){var t=e.state,r=e.options,n=r.gpuAcceleration,o=void 0===n||n,i=r.adaptive,a=void 0===i||i,l=r.roundOffsets,u=void 0===l||l,s={placement:Y(t.placement),variation:Q(t.placement),popper:t.elements.popper,popperRect:t.rects.popper,gpuAcceleration:o,isFixed:"fixed"===t.options.strategy};null!=t.modifiersData.popperOffsets&&(t.styles.popper=Object.assign({},t.styles.popper,ee(Object.assign({},s,{offsets:t.modifiersData.popperOffsets,position:t.options.strategy,adaptive:a,roundOffsets:u})))),null!=t.modifiersData.arrow&&(t.styles.arrow=Object.assign({},t.styles.arrow,ee(Object.assign({},s,{offsets:t.modifiersData.arrow,position:"absolute",adaptive:!1,roundOffsets:u})))),t.attributes.popper=Object.assign({},t.attributes.popper,{"data-popper-placement":t.placement})},data:{}},{name:"applyStyles",enabled:!0,phase:"write",fn:function(e){var t=e.state;Object.keys(t.elements).forEach((function(e){var r=t.styles[e]||{},n=t.attributes[e]||{},o=t.elements[e];s(o)&&y(o)&&(Object.assign(o.style,r),Object.keys(n).forEach((function(e){var t=n[e];!1===t?o.removeAttribute(e):o.setAttribute(e,!0===t?"":t)})))}))},effect:function(e){var t=e.state,r={popper:{position:t.options.strategy,left:"0",top:"0",margin:"0"},arrow:{position:"absolute"},reference:{}};return Object.assign(t.elements.popper.style,r.popper),t.styles=r,t.elements.arrow&&Object.assign(t.elements.arrow.style,r.arrow),function(){Object.keys(t.elements).forEach((function(e){var n=t.elements[e],o=t.attributes[e]||{},i=Object.keys(t.styles.hasOwnProperty(e)?t.styles[e]:r[e]).reduce((function(e,t){return e[t]="",e}),{});s(n)&&y(n)&&(Object.assign(n.style,i),Object.keys(o).forEach((function(e){n.removeAttribute(e)})))}))}},requires:["computeStyles"]},{name:"offset",enabled:!0,phase:"main",requires:["popperOffsets"],fn:function(e){var t=e.state,r=e.options,n=e.name,o=r.offset,i=void 0===o?[0,0]:o,a=U.reduce((function(e,r){return e[r]=function(e,t,r){var n=Y(e),o=[L,x].indexOf(n)>=0?-1:1,i="function"==typeof r?r(Object.assign({},t,{placement:e})):r,a=i[0],l=i[1];return a=a||0,l=(l||0)*o,[L,D].indexOf(n)>=0?{x:l,y:a}:{x:a,y:l}}(r,t.rects,i),e}),{}),l=a[t.placement],u=l.x,s=l.y;null!=t.modifiersData.popperOffsets&&(t.modifiersData.popperOffsets.x+=u,t.modifiersData.popperOffsets.y+=s),t.modifiersData[n]=a}},{name:"flip",enabled:!0,phase:"main",fn:function(e){var t=e.state,r=e.options,n=e.name;if(!t.modifiersData[n]._skip){for(var o=r.mainAxis,i=void 0===o||o,a=r.altAxis,l=void 0===a||a,u=r.fallbackPlacements,s=r.padding,c=r.boundary,d=r.rootBoundary,f=r.altBoundary,p=r.flipVariations,g=void 0===p||p,v=r.allowedAutoPlacements,h=t.options.placement,m=Y(h),y=u||(m!==h&&g?function(e){if(Y(e)===j)return[];var t=re(e);return[oe(e),t,oe(t)]}(h):[re(h)]),b=[h].concat(y).reduce((function(e,r){return e.concat(Y(r)===j?function(e,t){void 0===t&&(t={});var r=t,n=r.placement,o=r.boundary,i=r.rootBoundary,a=r.padding,l=r.flipVariations,u=r.allowedAutoPlacements,s=void 0===u?U:u,c=Q(n),d=c?l?B:B.filter((function(e){return Q(e)===c})):M,f=d.filter((function(e){return s.indexOf(e)>=0}));0===f.length&&(f=d);var p=f.reduce((function(t,r){return t[r]=ce(e,{placement:r,boundary:o,rootBoundary:i,padding:a})[Y(r)],t}),{});return Object.keys(p).sort((function(e,t){return p[e]-p[t]}))}(t,{placement:r,boundary:c,rootBoundary:d,padding:s,flipVariations:g,allowedAutoPlacements:v}):r)}),[]),E=t.rects.reference,O=t.rects.popper,S=new Map,_=!0,w=b[0],T=0;T<b.length;T++){var P=b[T],C=Y(P),I=Q(P)===k,A=[x,N].indexOf(C)>=0,R=A?"width":"height",F=ce(t,{placement:P,boundary:c,rootBoundary:d,altBoundary:f,padding:s}),q=A?I?D:L:I?N:x;E[R]>O[R]&&(q=re(q));var V=re(q),W=[];if(i&&W.push(F[C]<=0),l&&W.push(F[q]<=0,F[V]<=0),W.every((function(e){return e}))){w=P,_=!1;break}S.set(P,W)}if(_)for(var G=function(e){var t=b.find((function(t){var r=S.get(t);if(r)return r.slice(0,e).every((function(e){return e}))}));if(t)return w=t,"break"},H=g?3:1;H>0&&"break"!==G(H);H--);t.placement!==w&&(t.modifiersData[n]._skip=!0,t.placement=w,t.reset=!0)}},requiresIfExists:["offset"],data:{_skip:!1}},{name:"preventOverflow",enabled:!0,phase:"main",fn:function(e){var t=e.state,r=e.options,n=e.name,o=r.mainAxis,i=void 0===o||o,a=r.altAxis,l=void 0!==a&&a,u=r.boundary,s=r.rootBoundary,c=r.altBoundary,p=r.padding,g=r.tether,v=void 0===g||g,h=r.tetherOffset,m=void 0===h?0:h,y=ce(t,{boundary:u,rootBoundary:s,padding:p,altBoundary:c}),b=Y(t.placement),E=Q(t.placement),O=!E,S=X(b),_="x"===S?"y":"x",T=t.modifiersData.popperOffsets,P=t.rects.reference,C=t.rects.popper,I="function"==typeof m?m(Object.assign({},t.rects,{placement:t.placement})):m,A="number"==typeof I?{mainAxis:I,altAxis:I}:Object.assign({mainAxis:0,altAxis:0},I),j=t.modifiersData.offset?t.modifiersData.offset[t.placement]:null,M={x:0,y:0};if(T){if(i){var F,q="y"===S?x:L,V="y"===S?N:D,B="y"===S?"height":"width",U=T[S],W=U+y[q],G=U-y[V],H=v?-C[B]/2:0,K=E===k?P[B]:C[B],$=E===k?-C[B]:-P[B],z=t.elements.arrow,J=v&&z?w(z):{width:0,height:0},Z=t.modifiersData["arrow#persistent"]?t.modifiersData["arrow#persistent"].padding:{top:0,right:0,bottom:0,left:0},ee=Z[q],te=Z[V],re=de(0,P[B],J[B]),ne=O?P[B]/2-H-re-ee-A.mainAxis:K-re-ee-A.mainAxis,oe=O?-P[B]/2+H+re+te+A.mainAxis:$+re+te+A.mainAxis,ie=t.elements.arrow&&R(t.elements.arrow),ae=ie?"y"===S?ie.clientTop||0:ie.clientLeft||0:0,le=null!=(F=null==j?void 0:j[S])?F:0,ue=U+oe-le,se=de(v?f(W,U+ne-le-ae):W,U,v?d(G,ue):G);T[S]=se,M[S]=se-U}if(l){var fe,pe="x"===S?x:L,ge="x"===S?N:D,ve=T[_],he="y"===_?"height":"width",me=ve+y[pe],ye=ve-y[ge],be=-1!==[x,L].indexOf(b),Ee=null!=(fe=null==j?void 0:j[_])?fe:0,Oe=be?me:ve-P[he]-C[he]-Ee+A.altAxis,Se=be?ve+P[he]+C[he]-Ee-A.altAxis:ye,_e=v&&be?function(e,t,r){var n=de(e,t,r);return n>r?r:n}(Oe,ve,Se):de(v?Oe:me,ve,v?Se:ye);T[_]=_e,M[_]=_e-ve}t.modifiersData[n]=M}},requiresIfExists:["offset"]},{name:"arrow",enabled:!0,phase:"main",fn:function(e){var t,r=e.state,n=e.name,o=e.options,i=r.elements.arrow,a=r.modifiersData.popperOffsets,l=Y(r.placement),u=X(l),s=[L,D].indexOf(l)>=0?"height":"width";if(i&&a){var c=function(e,t){return ue("number"!=typeof(e="function"==typeof e?e(Object.assign({},t.rects,{placement:t.placement})):e)?e:se(e,M))}(o.padding,r),d=w(i),f="y"===u?x:L,p="y"===u?N:D,g=r.rects.reference[s]+r.rects.reference[u]-a[u]-r.rects.popper[s],v=a[u]-r.rects.reference[u],h=R(i),m=h?"y"===u?h.clientHeight||0:h.clientWidth||0:0,y=g/2-v/2,b=c[f],E=m-d[s]-c[p],O=m/2-d[s]/2+y,S=de(b,O,E),_=u;r.modifiersData[n]=((t={})[_]=S,t.centerOffset=S-O,t)}},effect:function(e){var t=e.state,r=e.options.element,n=void 0===r?"[data-popper-arrow]":r;null!=n&&("string"!=typeof n||(n=t.elements.popper.querySelector(n)))&&ie(t.elements.popper,n)&&(t.elements.arrow=n)},requires:["popperOffsets"],requiresIfExists:["preventOverflow"]},{name:"hide",enabled:!0,phase:"main",requiresIfExists:["preventOverflow"],fn:function(e){var t=e.state,r=e.name,n=t.rects.reference,o=t.rects.popper,i=t.modifiersData.preventOverflow,a=ce(t,{elementContext:"reference"}),l=ce(t,{altBoundary:!0}),u=fe(a,n),s=fe(l,o,i),c=pe(u),d=pe(s);t.modifiersData[r]={referenceClippingOffsets:u,popperEscapeOffsets:s,isReferenceHidden:c,hasPopperEscaped:d},t.attributes.popper=Object.assign({},t.attributes.popper,{"data-popper-reference-hidden":c,"data-popper-escaped":d})}}]}),ve=r(97383),he=r.n(ve),me=function(e){return e.reduce((function(e,t){var r=t[0],n=t[1];return e[r]=n,e}),{})},ye="undefined"!=typeof window&&window.document&&window.document.createElement?i.useLayoutEffect:i.useEffect,be=[],Ee=function(e,t,r){void 0===r&&(r={});var n=i.useRef(null),o={onFirstUpdate:r.onFirstUpdate,placement:r.placement||"bottom",strategy:r.strategy||"absolute",modifiers:r.modifiers||be},l=i.useState({styles:{popper:{position:o.strategy,left:"0",top:"0"},arrow:{position:"absolute"}},attributes:{}}),u=l[0],s=l[1],c=i.useMemo((function(){return{name:"updateState",enabled:!0,phase:"write",fn:function(e){var t=e.state,r=Object.keys(t.elements);a.flushSync((function(){s({styles:me(r.map((function(e){return[e,t.styles[e]||{}]}))),attributes:me(r.map((function(e){return[e,t.attributes[e]]})))})}))},requires:["computeStyles"]}}),[]),d=i.useMemo((function(){var e={onFirstUpdate:o.onFirstUpdate,placement:o.placement,strategy:o.strategy,modifiers:[].concat(o.modifiers,[c,{name:"applyStyles",enabled:!1}])};return he()(n.current,e)?n.current||e:(n.current=e,e)}),[o.onFirstUpdate,o.placement,o.strategy,o.modifiers,c]),f=i.useRef();return ye((function(){f.current&&f.current.setOptions(d)}),[d]),ye((function(){if(null!=e&&null!=t){var n=(r.createPopper||ge)(e,t,d);return f.current=n,function(){n.destroy(),f.current=null}}}),[e,t,r.createPopper]),{state:f.current?f.current.state:null,styles:u.styles,attributes:u.attributes,update:f.current?f.current.update:null,forceUpdate:f.current?f.current.forceUpdate:null}};function Oe(e){var t=i.useRef(e);return t.current=e,i.useCallback((function(){return t.current}),[])}var Se=function(){};function _e(e,t){return void 0===e&&(e=0),void 0===t&&(t=0),function(){return{width:0,height:0,top:t,right:e,bottom:t,left:e,x:0,y:0,toJSON:function(){return null}}}}var we=["styles","attributes"],Te={getBoundingClientRect:_e()},Pe={closeOnOutsideClick:!0,closeOnTriggerHidden:!1,defaultVisible:!1,delayHide:0,delayShow:0,followCursor:!1,interactive:!1,mutationObserverOptions:{attributes:!0,childList:!0,subtree:!0},offset:[0,6],trigger:"hover"};function Ce(e,t){var r,a,l;void 0===e&&(e={}),void 0===t&&(t={});var u=Object.keys(Pe).reduce((function(e,t){var r;return o({},e,((r={})[t]=void 0!==e[t]?e[t]:Pe[t],r))}),e),s=i.useMemo((function(){return[{name:"offset",options:{offset:u.offset}}]}),Array.isArray(u.offset)?u.offset:[]),c=o({},t,{placement:t.placement||u.placement,modifiers:t.modifiers||s}),d=i.useState(null),f=d[0],p=d[1],g=i.useState(null),v=g[0],h=g[1],m=function(e){var t=e.initial,r=e.value,n=e.onChange,o=void 0===n?Se:n;if(void 0===t&&void 0===r)throw new TypeError('Either "value" or "initial" variable must be set. Now both are undefined');var a=i.useState(t),l=a[0],u=a[1],s=Oe(l),c=i.useCallback((function(e){var t=s(),r="function"==typeof e?e(t):e;"function"==typeof r.persist&&r.persist(),u(r),"function"==typeof o&&o(r)}),[s,o]),d=void 0!==r;return[d?r:l,d?o:c]}({initial:u.defaultVisible,value:u.visible,onChange:u.onVisibleChange}),y=m[0],b=m[1],E=i.useRef();i.useEffect((function(){return function(){return clearTimeout(E.current)}}),[]);var O=Ee(u.followCursor?Te:f,v,c),S=O.styles,_=O.attributes,w=(0,n.A)(O,we),T=w.update,P=Oe({visible:y,triggerRef:f,tooltipRef:v,finalConfig:u}),C=i.useCallback((function(e){return Array.isArray(u.trigger)?u.trigger.includes(e):u.trigger===e}),Array.isArray(u.trigger)?u.trigger:[u.trigger]),I=i.useCallback((function(){clearTimeout(E.current),E.current=window.setTimeout((function(){return b(!1)}),u.delayHide)}),[u.delayHide,b]),A=i.useCallback((function(){clearTimeout(E.current),E.current=window.setTimeout((function(){return b(!0)}),u.delayShow)}),[u.delayShow,b]),R=i.useCallback((function(){P().visible?I():A()}),[P,I,A]);i.useEffect((function(){if(P().finalConfig.closeOnOutsideClick){var e=function(e){var t,r=P(),n=r.tooltipRef,o=r.triggerRef,i=(null==e.composedPath||null==(t=e.composedPath())?void 0:t[0])||e.target;i instanceof Node&&(null==n||null==o||n.contains(i)||o.contains(i)||I())};return document.addEventListener("mousedown",e),function(){return document.removeEventListener("mousedown",e)}}}),[P,I]),i.useEffect((function(){if(null!=f&&C("click"))return f.addEventListener("click",R),function(){return f.removeEventListener("click",R)}}),[f,C,R]),i.useEffect((function(){if(null!=f&&C("double-click"))return f.addEventListener("dblclick",R),function(){return f.removeEventListener("dblclick",R)}}),[f,C,R]),i.useEffect((function(){if(null!=f&&C("right-click")){var e=function(e){e.preventDefault(),R()};return f.addEventListener("contextmenu",e),function(){return f.removeEventListener("contextmenu",e)}}}),[f,C,R]),i.useEffect((function(){if(null!=f&&C("focus"))return f.addEventListener("focus",A),f.addEventListener("blur",I),function(){f.removeEventListener("focus",A),f.removeEventListener("blur",I)}}),[f,C,A,I]),i.useEffect((function(){if(null!=f&&C("hover"))return f.addEventListener("mouseenter",A),f.addEventListener("mouseleave",I),function(){f.removeEventListener("mouseenter",A),f.removeEventListener("mouseleave",I)}}),[f,C,A,I]),i.useEffect((function(){if(null!=v&&C("hover")&&P().finalConfig.interactive)return v.addEventListener("mouseenter",A),v.addEventListener("mouseleave",I),function(){v.removeEventListener("mouseenter",A),v.removeEventListener("mouseleave",I)}}),[v,C,A,I,P]);var x=null==w||null==(r=w.state)||null==(a=r.modifiersData)||null==(l=a.hide)?void 0:l.isReferenceHidden;return i.useEffect((function(){u.closeOnTriggerHidden&&x&&I()}),[u.closeOnTriggerHidden,I,x]),i.useEffect((function(){if(u.followCursor&&null!=f)return f.addEventListener("mousemove",e),function(){return f.removeEventListener("mousemove",e)};function e(e){var t=e.clientX,r=e.clientY;Te.getBoundingClientRect=_e(t,r),null==T||T()}}),[u.followCursor,f,T]),i.useEffect((function(){if(null!=v&&null!=T&&null!=u.mutationObserverOptions){var e=new MutationObserver(T);return e.observe(v,u.mutationObserverOptions),function(){return e.disconnect()}}}),[u.mutationObserverOptions,v,T]),o({getArrowProps:function(e){return void 0===e&&(e={}),o({},e,_.arrow,{style:o({},e.style,S.arrow),"data-popper-arrow":!0})},getTooltipProps:function(e){return void 0===e&&(e={}),o({},e,{style:o({},e.style,S.popper)},_.popper,{"data-popper-interactive":u.interactive})},setTooltipRef:h,setTriggerRef:p,tooltipRef:v,triggerRef:f,visible:y},w)}},52445:(e,t,r)=>{"use strict";r.r(t),r.d(t,{default:()=>d,isHeightAndWidthProps:()=>f,isHeightOnlyProps:()=>p,isWidthOnlyProps:()=>g});var n=r(85959);let o;o="undefined"!=typeof window?window:"undefined"!=typeof self?self:r.g;let i=null,a=null;const l=o.clearTimeout,u=o.setTimeout,s=o.cancelAnimationFrame||o.mozCancelAnimationFrame||o.webkitCancelAnimationFrame,c=o.requestAnimationFrame||o.mozRequestAnimationFrame||o.webkitRequestAnimationFrame;null==s||null==c?(i=l,a=function(e){return u(e,20)}):(i=function([e,t]){s(e),l(t)},a=function(e){const t=c((function(){l(r),e()})),r=u((function(){s(t),e()}),20);return[t,r]});class d extends n.Component{constructor(...e){super(...e),this.state={height:this.props.defaultHeight||0,scaledHeight:this.props.defaultHeight||0,scaledWidth:this.props.defaultWidth||0,width:this.props.defaultWidth||0},this._autoSizer=null,this._detectElementResize=null,this._parentNode=null,this._resizeObserver=null,this._timeoutId=null,this._onResize=()=>{this._timeoutId=null;const{disableHeight:e,disableWidth:t,onResize:r}=this.props;if(this._parentNode){const n=window.getComputedStyle(this._parentNode)||{},o=parseFloat(n.paddingLeft||"0"),i=parseFloat(n.paddingRight||"0"),a=parseFloat(n.paddingTop||"0"),l=parseFloat(n.paddingBottom||"0"),u=this._parentNode.getBoundingClientRect(),s=u.height-a-l,c=u.width-o-i,d=this._parentNode.offsetHeight-a-l,f=this._parentNode.offsetWidth-o-i;(e||this.state.height===d&&this.state.scaledHeight===s)&&(t||this.state.width===f&&this.state.scaledWidth===c)||(this.setState({height:d,width:f,scaledHeight:s,scaledWidth:c}),"function"==typeof r&&r({height:d,scaledHeight:s,scaledWidth:c,width:f}))}},this._setRef=e=>{this._autoSizer=e}}componentDidMount(){const{nonce:e}=this.props,t=this._autoSizer?this._autoSizer.parentNode:null;if(null!=t&&t.ownerDocument&&t.ownerDocument.defaultView&&t instanceof t.ownerDocument.defaultView.HTMLElement){this._parentNode=t;const r=t.ownerDocument.defaultView.ResizeObserver;null!=r?(this._resizeObserver=new r((()=>{this._timeoutId=setTimeout(this._onResize,0)})),this._resizeObserver.observe(t)):(this._detectElementResize=function(e){let t,r,n,l,u,s,c;const d="undefined"!=typeof document&&document.attachEvent;if(!d){s=function(e){const t=e.__resizeTriggers__,r=t.firstElementChild,n=t.lastElementChild,o=r.firstElementChild;n.scrollLeft=n.scrollWidth,n.scrollTop=n.scrollHeight,o.style.width=r.offsetWidth+1+"px",o.style.height=r.offsetHeight+1+"px",r.scrollLeft=r.scrollWidth,r.scrollTop=r.scrollHeight},u=function(e){return e.offsetWidth!==e.__resizeLast__.width||e.offsetHeight!==e.__resizeLast__.height},c=function(e){if(e.target.className&&"function"==typeof e.target.className.indexOf&&e.target.className.indexOf("contract-trigger")<0&&e.target.className.indexOf("expand-trigger")<0)return;const t=this;s(this),this.__resizeRAF__&&i(this.__resizeRAF__),this.__resizeRAF__=a((function(){u(t)&&(t.__resizeLast__.width=t.offsetWidth,t.__resizeLast__.height=t.offsetHeight,t.__resizeListeners__.forEach((function(r){r.call(t,e)})))}))};let e=!1,o="";n="animationstart";const d="Webkit Moz O ms".split(" ");let f="webkitAnimationStart animationstart oAnimationStart MSAnimationStart".split(" "),p="";{const t=document.createElement("fakeelement");if(void 0!==t.style.animationName&&(e=!0),!1===e)for(let r=0;r<d.length;r++)if(void 0!==t.style[d[r]+"AnimationName"]){p=d[r],o="-"+p.toLowerCase()+"-",n=f[r],e=!0;break}}r="resizeanim",t="@"+o+"keyframes "+r+" { from { opacity: 0; } to { opacity: 0; } } ",l=o+"animation: 1ms "+r+"; "}return{addResizeListener:function(i,a){if(d)i.attachEvent("onresize",a);else{if(!i.__resizeTriggers__){const a=i.ownerDocument,u=o.getComputedStyle(i);u&&"static"===u.position&&(i.style.position="relative"),function(r){if(!r.getElementById("detectElementResize")){const n=(t||"")+".resize-triggers { "+(l||"")+'visibility: hidden; opacity: 0; } .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',o=r.head||r.getElementsByTagName("head")[0],i=r.createElement("style");i.id="detectElementResize",i.type="text/css",null!=e&&i.setAttribute("nonce",e),i.styleSheet?i.styleSheet.cssText=n:i.appendChild(r.createTextNode(n)),o.appendChild(i)}}(a),i.__resizeLast__={},i.__resizeListeners__=[],(i.__resizeTriggers__=a.createElement("div")).className="resize-triggers";const d=a.createElement("div");d.className="expand-trigger",d.appendChild(a.createElement("div"));const f=a.createElement("div");f.className="contract-trigger",i.__resizeTriggers__.appendChild(d),i.__resizeTriggers__.appendChild(f),i.appendChild(i.__resizeTriggers__),s(i),i.addEventListener("scroll",c,!0),n&&(i.__resizeTriggers__.__animationListener__=function(e){e.animationName===r&&s(i)},i.__resizeTriggers__.addEventListener(n,i.__resizeTriggers__.__animationListener__))}i.__resizeListeners__.push(a)}},removeResizeListener:function(e,t){if(d)e.detachEvent("onresize",t);else if(e.__resizeListeners__.splice(e.__resizeListeners__.indexOf(t),1),!e.__resizeListeners__.length){e.removeEventListener("scroll",c,!0),e.__resizeTriggers__.__animationListener__&&(e.__resizeTriggers__.removeEventListener(n,e.__resizeTriggers__.__animationListener__),e.__resizeTriggers__.__animationListener__=null);try{e.__resizeTriggers__=!e.removeChild(e.__resizeTriggers__)}catch(e){}}}}}(e),this._detectElementResize.addResizeListener(t,this._onResize)),this._onResize()}}componentWillUnmount(){this._parentNode&&(this._detectElementResize&&this._detectElementResize.removeResizeListener(this._parentNode,this._onResize),null!==this._timeoutId&&clearTimeout(this._timeoutId),this._resizeObserver&&this._resizeObserver.disconnect())}render(){const{children:e,defaultHeight:t,defaultWidth:r,disableHeight:o=!1,disableWidth:i=!1,doNotBailOutOnEmptyChildren:a=!1,nonce:l,onResize:u,style:s={},tagName:c="div",...d}=this.props,{height:f,scaledHeight:p,scaledWidth:g,width:v}=this.state,h={overflow:"visible"},m={};let y=!1;return o||(0===f&&(y=!0),h.height=0,m.height=f,m.scaledHeight=p),i||(0===v&&(y=!0),h.width=0,m.width=v,m.scaledWidth=g),a&&(y=!1),(0,n.createElement)(c,{ref:this._setRef,style:{...h,...s},...d},!y&&e(m))}}function f(e){return e&&!0!==e.disableHeight&&!0!==e.disableWidth}function p(e){return e&&!0!==e.disableHeight&&!0===e.disableWidth}function g(e){return e&&!0===e.disableHeight&&!0!==e.disableWidth}},55366:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncSubject=void 0;var i=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._value=null,t._hasValue=!1,t._isComplete=!1,t}return o(t,e),t.prototype._checkFinalizedStatuses=function(e){var t=this,r=t.hasError,n=t._hasValue,o=t._value,i=t.thrownError,a=t.isStopped,l=t._isComplete;r?e.error(i):(a||l)&&(n&&e.next(o),e.complete())},t.prototype.next=function(e){this.isStopped||(this._value=e,this._hasValue=!0)},t.prototype.complete=function(){var t=this,r=t._hasValue,n=t._value;t._isComplete||(this._isComplete=!0,r&&e.prototype.next.call(this,n),e.prototype.complete.call(this))},t}(r(20020).Subject);t.AsyncSubject=i},71222:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.BehaviorSubject=void 0;var i=function(e){function t(t){var r=e.call(this)||this;return r._value=t,r}return o(t,e),Object.defineProperty(t.prototype,"value",{get:function(){return this.getValue()},enumerable:!1,configurable:!0}),t.prototype._subscribe=function(t){var r=e.prototype._subscribe.call(this,t);return!r.closed&&t.next(this._value),r},t.prototype.getValue=function(){var e=this,t=e.hasError,r=e.thrownError,n=e._value;if(t)throw r;return this._throwIfClosed(),n},t.prototype.next=function(t){e.prototype.next.call(this,this._value=t)},t}(r(20020).Subject);t.BehaviorSubject=i},26145:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observeNotification=t.Notification=t.NotificationKind=void 0;var n,o=r(47209),i=r(48743),a=r(26612),l=r(44717);(n=t.NotificationKind||(t.NotificationKind={})).NEXT="N",n.ERROR="E",n.COMPLETE="C";var u=function(){function e(e,t,r){this.kind=e,this.value=t,this.error=r,this.hasValue="N"===e}return e.prototype.observe=function(e){return s(this,e)},e.prototype.do=function(e,t,r){var n=this,o=n.kind,i=n.value,a=n.error;return"N"===o?null==e?void 0:e(i):"E"===o?null==t?void 0:t(a):null==r?void 0:r()},e.prototype.accept=function(e,t,r){var n;return l.isFunction(null===(n=e)||void 0===n?void 0:n.next)?this.observe(e):this.do(e,t,r)},e.prototype.toObservable=function(){var e=this,t=e.kind,r=e.value,n=e.error,l="N"===t?i.of(r):"E"===t?a.throwError((function(){return n})):"C"===t?o.EMPTY:0;if(!l)throw new TypeError("Unexpected notification kind "+t);return l},e.createNext=function(t){return new e("N",t)},e.createError=function(t){return new e("E",void 0,t)},e.createComplete=function(){return e.completeNotification},e.completeNotification=new e("C"),e}();function s(e,t){var r,n,o,i=e,a=i.kind,l=i.value,u=i.error;if("string"!=typeof a)throw new TypeError('Invalid notification, missing "kind"');"N"===a?null===(r=t.next)||void 0===r||r.call(t,l):"E"===a?null===(n=t.error)||void 0===n||n.call(t,u):null===(o=t.complete)||void 0===o||o.call(t)}t.Notification=u,t.observeNotification=s},90795:(e,t)=>{"use strict";function r(e,t,r){return{kind:e,value:t,error:r}}Object.defineProperty(t,"__esModule",{value:!0}),t.createNotification=t.nextNotification=t.errorNotification=t.COMPLETE_NOTIFICATION=void 0,t.COMPLETE_NOTIFICATION=r("C",void 0,void 0),t.errorNotification=function(e){return r("E",void 0,e)},t.nextNotification=function(e){return r("N",e,void 0)},t.createNotification=r},92023:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Observable=void 0;var n=r(4512),o=r(27491),i=r(84512),a=r(72393),l=r(87820),u=r(44717),s=r(79916),c=function(){function e(e){e&&(this._subscribe=e)}return e.prototype.lift=function(t){var r=new e;return r.source=this,r.operator=t,r},e.prototype.subscribe=function(e,t,r){var i,a=this,l=(i=e)&&i instanceof n.Subscriber||function(e){return e&&u.isFunction(e.next)&&u.isFunction(e.error)&&u.isFunction(e.complete)}(i)&&o.isSubscription(i)?e:new n.SafeSubscriber(e,t,r);return s.errorContext((function(){var e=a,t=e.operator,r=e.source;l.add(t?t.call(l,r):r?a._subscribe(l):a._trySubscribe(l))})),l},e.prototype._trySubscribe=function(e){try{return this._subscribe(e)}catch(t){e.error(t)}},e.prototype.forEach=function(e,t){var r=this;return new(t=d(t))((function(t,o){var i=new n.SafeSubscriber({next:function(t){try{e(t)}catch(e){o(e),i.unsubscribe()}},error:o,complete:t});r.subscribe(i)}))},e.prototype._subscribe=function(e){var t;return null===(t=this.source)||void 0===t?void 0:t.subscribe(e)},e.prototype[i.observable]=function(){return this},e.prototype.pipe=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return a.pipeFromArray(e)(this)},e.prototype.toPromise=function(e){var t=this;return new(e=d(e))((function(e,r){var n;t.subscribe((function(e){return n=e}),(function(e){return r(e)}),(function(){return e(n)}))}))},e.create=function(t){return new e(t)},e}();function d(e){var t;return null!==(t=null!=e?e:l.config.Promise)&&void 0!==t?t:Promise}t.Observable=c},35129:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.ReplaySubject=void 0;var i=r(20020),a=r(26956),l=function(e){function t(t,r,n){void 0===t&&(t=1/0),void 0===r&&(r=1/0),void 0===n&&(n=a.dateTimestampProvider);var o=e.call(this)||this;return o._bufferSize=t,o._windowTime=r,o._timestampProvider=n,o._buffer=[],o._infiniteTimeWindow=!0,o._infiniteTimeWindow=r===1/0,o._bufferSize=Math.max(1,t),o._windowTime=Math.max(1,r),o}return o(t,e),t.prototype.next=function(t){var r=this,n=r.isStopped,o=r._buffer,i=r._infiniteTimeWindow,a=r._timestampProvider,l=r._windowTime;n||(o.push(t),!i&&o.push(a.now()+l)),this._trimBuffer(),e.prototype.next.call(this,t)},t.prototype._subscribe=function(e){this._throwIfClosed(),this._trimBuffer();for(var t=this._innerSubscribe(e),r=this._infiniteTimeWindow,n=this._buffer.slice(),o=0;o<n.length&&!e.closed;o+=r?1:2)e.next(n[o]);return this._checkFinalizedStatuses(e),t},t.prototype._trimBuffer=function(){var e=this,t=e._bufferSize,r=e._timestampProvider,n=e._buffer,o=e._infiniteTimeWindow,i=(o?1:2)*t;if(t<1/0&&i<n.length&&n.splice(0,n.length-i),!o){for(var a=r.now(),l=0,u=1;u<n.length&&n[u]<=a;u+=2)l=u;l&&n.splice(0,l+1)}},t}(i.Subject);t.ReplaySubject=l},30469:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Scheduler=void 0;var n=r(26956),o=function(){function e(t,r){void 0===r&&(r=e.now),this.schedulerActionCtor=t,this.now=r}return e.prototype.schedule=function(e,t,r){return void 0===t&&(t=0),new this.schedulerActionCtor(this,e).schedule(r,t)},e.now=n.dateTimestampProvider.now,e}();t.Scheduler=o},20020:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),i=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.AnonymousSubject=t.Subject=void 0;var a=r(92023),l=r(27491),u=r(98083),s=r(7394),c=r(79916),d=function(e){function t(){var t=e.call(this)||this;return t.closed=!1,t.currentObservers=null,t.observers=[],t.isStopped=!1,t.hasError=!1,t.thrownError=null,t}return o(t,e),t.prototype.lift=function(e){var t=new f(this,this);return t.operator=e,t},t.prototype._throwIfClosed=function(){if(this.closed)throw new u.ObjectUnsubscribedError},t.prototype.next=function(e){var t=this;c.errorContext((function(){var r,n;if(t._throwIfClosed(),!t.isStopped){t.currentObservers||(t.currentObservers=Array.from(t.observers));try{for(var o=i(t.currentObservers),a=o.next();!a.done;a=o.next())a.value.next(e)}catch(e){r={error:e}}finally{try{a&&!a.done&&(n=o.return)&&n.call(o)}finally{if(r)throw r.error}}}}))},t.prototype.error=function(e){var t=this;c.errorContext((function(){if(t._throwIfClosed(),!t.isStopped){t.hasError=t.isStopped=!0,t.thrownError=e;for(var r=t.observers;r.length;)r.shift().error(e)}}))},t.prototype.complete=function(){var e=this;c.errorContext((function(){if(e._throwIfClosed(),!e.isStopped){e.isStopped=!0;for(var t=e.observers;t.length;)t.shift().complete()}}))},t.prototype.unsubscribe=function(){this.isStopped=this.closed=!0,this.observers=this.currentObservers=null},Object.defineProperty(t.prototype,"observed",{get:function(){var e;return(null===(e=this.observers)||void 0===e?void 0:e.length)>0},enumerable:!1,configurable:!0}),t.prototype._trySubscribe=function(t){return this._throwIfClosed(),e.prototype._trySubscribe.call(this,t)},t.prototype._subscribe=function(e){return this._throwIfClosed(),this._checkFinalizedStatuses(e),this._innerSubscribe(e)},t.prototype._innerSubscribe=function(e){var t=this,r=this,n=r.hasError,o=r.isStopped,i=r.observers;return n||o?l.EMPTY_SUBSCRIPTION:(this.currentObservers=null,i.push(e),new l.Subscription((function(){t.currentObservers=null,s.arrRemove(i,e)})))},t.prototype._checkFinalizedStatuses=function(e){var t=this,r=t.hasError,n=t.thrownError,o=t.isStopped;r?e.error(n):o&&e.complete()},t.prototype.asObservable=function(){var e=new a.Observable;return e.source=this,e},t.create=function(e,t){return new f(e,t)},t}(a.Observable);t.Subject=d;var f=function(e){function t(t,r){var n=e.call(this)||this;return n.destination=t,n.source=r,n}return o(t,e),t.prototype.next=function(e){var t,r;null===(r=null===(t=this.destination)||void 0===t?void 0:t.next)||void 0===r||r.call(t,e)},t.prototype.error=function(e){var t,r;null===(r=null===(t=this.destination)||void 0===t?void 0:t.error)||void 0===r||r.call(t,e)},t.prototype.complete=function(){var e,t;null===(t=null===(e=this.destination)||void 0===e?void 0:e.complete)||void 0===t||t.call(e)},t.prototype._subscribe=function(e){var t,r;return null!==(r=null===(t=this.source)||void 0===t?void 0:t.subscribe(e))&&void 0!==r?r:l.EMPTY_SUBSCRIPTION},t}(d);t.AnonymousSubject=f},4512:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.EMPTY_OBSERVER=t.SafeSubscriber=t.Subscriber=void 0;var i=r(44717),a=r(27491),l=r(87820),u=r(34696),s=r(16129),c=r(90795),d=r(56476),f=r(79916),p=function(e){function r(r){var n=e.call(this)||this;return n.isStopped=!1,r?(n.destination=r,a.isSubscription(r)&&r.add(n)):n.destination=t.EMPTY_OBSERVER,n}return o(r,e),r.create=function(e,t,r){return new m(e,t,r)},r.prototype.next=function(e){this.isStopped?b(c.nextNotification(e),this):this._next(e)},r.prototype.error=function(e){this.isStopped?b(c.errorNotification(e),this):(this.isStopped=!0,this._error(e))},r.prototype.complete=function(){this.isStopped?b(c.COMPLETE_NOTIFICATION,this):(this.isStopped=!0,this._complete())},r.prototype.unsubscribe=function(){this.closed||(this.isStopped=!0,e.prototype.unsubscribe.call(this),this.destination=null)},r.prototype._next=function(e){this.destination.next(e)},r.prototype._error=function(e){try{this.destination.error(e)}finally{this.unsubscribe()}},r.prototype._complete=function(){try{this.destination.complete()}finally{this.unsubscribe()}},r}(a.Subscription);t.Subscriber=p;var g=Function.prototype.bind;function v(e,t){return g.call(e,t)}var h=function(){function e(e){this.partialObserver=e}return e.prototype.next=function(e){var t=this.partialObserver;if(t.next)try{t.next(e)}catch(e){y(e)}},e.prototype.error=function(e){var t=this.partialObserver;if(t.error)try{t.error(e)}catch(e){y(e)}else y(e)},e.prototype.complete=function(){var e=this.partialObserver;if(e.complete)try{e.complete()}catch(e){y(e)}},e}(),m=function(e){function t(t,r,n){var o,a,u=e.call(this)||this;return i.isFunction(t)||!t?o={next:null!=t?t:void 0,error:null!=r?r:void 0,complete:null!=n?n:void 0}:u&&l.config.useDeprecatedNextContext?((a=Object.create(t)).unsubscribe=function(){return u.unsubscribe()},o={next:t.next&&v(t.next,a),error:t.error&&v(t.error,a),complete:t.complete&&v(t.complete,a)}):o=t,u.destination=new h(o),u}return o(t,e),t}(p);function y(e){l.config.useDeprecatedSynchronousErrorHandling?f.captureError(e):u.reportUnhandledError(e)}function b(e,t){var r=l.config.onStoppedNotification;r&&d.timeoutProvider.setTimeout((function(){return r(e,t)}))}t.SafeSubscriber=m,t.EMPTY_OBSERVER={closed:!0,next:s.noop,error:function(e){throw e},complete:s.noop}},27491:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},o=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},i=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.isSubscription=t.EMPTY_SUBSCRIPTION=t.Subscription=void 0;var a=r(44717),l=r(30665),u=r(7394),s=function(){function e(e){this.initialTeardown=e,this.closed=!1,this._parentage=null,this._finalizers=null}var t;return e.prototype.unsubscribe=function(){var e,t,r,u,s;if(!this.closed){this.closed=!0;var d=this._parentage;if(d)if(this._parentage=null,Array.isArray(d))try{for(var f=n(d),p=f.next();!p.done;p=f.next())p.value.remove(this)}catch(t){e={error:t}}finally{try{p&&!p.done&&(t=f.return)&&t.call(f)}finally{if(e)throw e.error}}else d.remove(this);var g=this.initialTeardown;if(a.isFunction(g))try{g()}catch(e){s=e instanceof l.UnsubscriptionError?e.errors:[e]}var v=this._finalizers;if(v){this._finalizers=null;try{for(var h=n(v),m=h.next();!m.done;m=h.next()){var y=m.value;try{c(y)}catch(e){s=null!=s?s:[],e instanceof l.UnsubscriptionError?s=i(i([],o(s)),o(e.errors)):s.push(e)}}}catch(e){r={error:e}}finally{try{m&&!m.done&&(u=h.return)&&u.call(h)}finally{if(r)throw r.error}}}if(s)throw new l.UnsubscriptionError(s)}},e.prototype.add=function(t){var r;if(t&&t!==this)if(this.closed)c(t);else{if(t instanceof e){if(t.closed||t._hasParent(this))return;t._addParent(this)}(this._finalizers=null!==(r=this._finalizers)&&void 0!==r?r:[]).push(t)}},e.prototype._hasParent=function(e){var t=this._parentage;return t===e||Array.isArray(t)&&t.includes(e)},e.prototype._addParent=function(e){var t=this._parentage;this._parentage=Array.isArray(t)?(t.push(e),t):t?[t,e]:e},e.prototype._removeParent=function(e){var t=this._parentage;t===e?this._parentage=null:Array.isArray(t)&&u.arrRemove(t,e)},e.prototype.remove=function(t){var r=this._finalizers;r&&u.arrRemove(r,t),t instanceof e&&t._removeParent(this)},e.EMPTY=((t=new e).closed=!0,t),e}();function c(e){a.isFunction(e)?e():e.unsubscribe()}t.Subscription=s,t.EMPTY_SUBSCRIPTION=s.EMPTY,t.isSubscription=function(e){return e instanceof s||e&&"closed"in e&&a.isFunction(e.remove)&&a.isFunction(e.add)&&a.isFunction(e.unsubscribe)}},87820:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.config=void 0,t.config={onUnhandledError:null,onStoppedNotification:null,Promise:void 0,useDeprecatedSynchronousErrorHandling:!1,useDeprecatedNextContext:!1}},51507:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.ConnectableObservable=void 0;var i=r(92023),a=r(27491),l=r(85884),u=r(1266),s=r(35416),c=function(e){function t(t,r){var n=e.call(this)||this;return n.source=t,n.subjectFactory=r,n._subject=null,n._refCount=0,n._connection=null,s.hasLift(t)&&(n.lift=t.lift),n}return o(t,e),t.prototype._subscribe=function(e){return this.getSubject().subscribe(e)},t.prototype.getSubject=function(){var e=this._subject;return e&&!e.isStopped||(this._subject=this.subjectFactory()),this._subject},t.prototype._teardown=function(){this._refCount=0;var e=this._connection;this._subject=this._connection=null,null==e||e.unsubscribe()},t.prototype.connect=function(){var e=this,t=this._connection;if(!t){t=this._connection=new a.Subscription;var r=this.getSubject();t.add(this.source.subscribe(u.createOperatorSubscriber(r,void 0,(function(){e._teardown(),r.complete()}),(function(t){e._teardown(),r.error(t)}),(function(){return e._teardown()})))),t.closed&&(this._connection=null,t=a.Subscription.EMPTY)}return t},t.prototype.refCount=function(){return l.refCount()(this)},t}(i.Observable);t.ConnectableObservable=c},30994:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.combineLatestInit=t.combineLatest=void 0;var n=r(92023),o=r(43787),i=r(45294),a=r(79391),l=r(88240),u=r(11824),s=r(34950),c=r(1266),d=r(75031);function f(e,t,r){return void 0===r&&(r=a.identity),function(n){p(t,(function(){for(var o=e.length,a=new Array(o),l=o,u=o,s=function(o){p(t,(function(){var s=i.from(e[o],t),d=!1;s.subscribe(c.createOperatorSubscriber(n,(function(e){a[o]=e,d||(d=!0,u--),u||n.next(r(a.slice()))}),(function(){--l||n.complete()})))}),n)},d=0;d<o;d++)s(d)}),n)}}function p(e,t,r){e?d.executeSchedule(r,e,t):t()}t.combineLatest=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=u.popScheduler(e),c=u.popResultSelector(e),d=o.argsArgArrayOrObject(e),p=d.args,g=d.keys;if(0===p.length)return i.from([],r);var v=new n.Observable(f(p,r,g?function(e){return s.createObject(g,e)}:a.identity));return c?v.pipe(l.mapOneOrManyArgs(c)):v},t.combineLatestInit=f},62070:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.concat=void 0;var n=r(80861),o=r(11824),i=r(45294);t.concat=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return n.concatAll()(i.from(e,o.popScheduler(e)))}},47209:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.empty=t.EMPTY=void 0;var n=r(92023);t.EMPTY=new n.Observable((function(e){return e.complete()})),t.empty=function(e){return e?function(e){return new n.Observable((function(t){return e.schedule((function(){return t.complete()}))}))}(e):t.EMPTY}},45294:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.from=void 0;var n=r(54463),o=r(52296);t.from=function(e,t){return t?n.scheduled(e,t):o.innerFrom(e)}},3123:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fromSubscribable=void 0;var n=r(92023);t.fromSubscribable=function(e){return new n.Observable((function(t){return e.subscribe(t)}))}},52296:function(e,t,r){"use strict";var n=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))((function(o,i){function a(e){try{u(n.next(e))}catch(e){i(e)}}function l(e){try{u(n.throw(e))}catch(e){i(e)}}function u(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t)}))).then(a,l)}u((n=n.apply(e,t||[])).next())}))},o=this&&this.__generator||function(e,t){var r,n,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function l(i){return function(l){return function(i){if(r)throw new TypeError("Generator is already executing.");for(;a;)try{if(r=1,n&&(o=2&i[0]?n.return:i[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,i[1])).done)return o;switch(n=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,n=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!((o=(o=a.trys).length>0&&o[o.length-1])||6!==i[0]&&2!==i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],n=0}finally{r=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,l])}}},i=this&&this.__asyncValues||function(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,r=e[Symbol.asyncIterator];return r?r.call(e):(e="function"==typeof a?a(e):e[Symbol.iterator](),t={},n("next"),n("throw"),n("return"),t[Symbol.asyncIterator]=function(){return this},t);function n(r){t[r]=e[r]&&function(t){return new Promise((function(n,o){!function(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}(n,o,(t=e[r](t)).done,t.value)}))}}},a=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.fromReadableStreamLike=t.fromAsyncIterable=t.fromIterable=t.fromPromise=t.fromArrayLike=t.fromInteropObservable=t.innerFrom=void 0;var l=r(65547),u=r(60452),s=r(92023),c=r(31801),d=r(69451),f=r(63533),p=r(26847),g=r(43026),v=r(44717),h=r(34696),m=r(84512);function y(e){return new s.Observable((function(t){var r=e[m.observable]();if(v.isFunction(r.subscribe))return r.subscribe(t);throw new TypeError("Provided object does not correctly implement Symbol.observable")}))}function b(e){return new s.Observable((function(t){for(var r=0;r<e.length&&!t.closed;r++)t.next(e[r]);t.complete()}))}function E(e){return new s.Observable((function(t){e.then((function(e){t.closed||(t.next(e),t.complete())}),(function(e){return t.error(e)})).then(null,h.reportUnhandledError)}))}function O(e){return new s.Observable((function(t){var r,n;try{for(var o=a(e),i=o.next();!i.done;i=o.next()){var l=i.value;if(t.next(l),t.closed)return}}catch(e){r={error:e}}finally{try{i&&!i.done&&(n=o.return)&&n.call(o)}finally{if(r)throw r.error}}t.complete()}))}function S(e){return new s.Observable((function(t){(function(e,t){var r,a,l,u;return n(this,void 0,void 0,(function(){var n,s;return o(this,(function(o){switch(o.label){case 0:o.trys.push([0,5,6,11]),r=i(e),o.label=1;case 1:return[4,r.next()];case 2:if((a=o.sent()).done)return[3,4];if(n=a.value,t.next(n),t.closed)return[2];o.label=3;case 3:return[3,1];case 4:return[3,11];case 5:return s=o.sent(),l={error:s},[3,11];case 6:return o.trys.push([6,,9,10]),a&&!a.done&&(u=r.return)?[4,u.call(r)]:[3,8];case 7:o.sent(),o.label=8;case 8:return[3,10];case 9:if(l)throw l.error;return[7];case 10:return[7];case 11:return t.complete(),[2]}}))}))})(e,t).catch((function(e){return t.error(e)}))}))}function _(e){return S(g.readableStreamLikeToAsyncGenerator(e))}t.innerFrom=function(e){if(e instanceof s.Observable)return e;if(null!=e){if(c.isInteropObservable(e))return y(e);if(l.isArrayLike(e))return b(e);if(u.isPromise(e))return E(e);if(d.isAsyncIterable(e))return S(e);if(p.isIterable(e))return O(e);if(g.isReadableStreamLike(e))return _(e)}throw f.createInvalidObservableTypeError(e)},t.fromInteropObservable=y,t.fromArrayLike=b,t.fromPromise=E,t.fromIterable=O,t.fromAsyncIterable=S,t.fromReadableStreamLike=_},38767:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.interval=void 0;var n=r(4386),o=r(35461);t.interval=function(e,t){return void 0===e&&(e=0),void 0===t&&(t=n.asyncScheduler),e<0&&(e=0),o.timer(e,e,t)}},48743:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.of=void 0;var n=r(11824),o=r(45294);t.of=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=n.popScheduler(e);return o.from(e,r)}},66467:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.onErrorResumeNext=void 0;var n=r(92023),o=r(90160),i=r(1266),a=r(16129),l=r(52296);t.onErrorResumeNext=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=o.argsOrArgArray(e);return new n.Observable((function(e){var t=0,n=function(){if(t<r.length){var o=void 0;try{o=l.innerFrom(r[t++])}catch(e){return void n()}var u=new i.OperatorSubscriber(e,void 0,a.noop,a.noop);o.subscribe(u),u.add(n)}else e.complete()};n()}))}},64143:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.raceInit=t.race=void 0;var n=r(92023),o=r(52296),i=r(90160),a=r(1266);function l(e){return function(t){for(var r=[],n=function(n){r.push(o.innerFrom(e[n]).subscribe(a.createOperatorSubscriber(t,(function(e){if(r){for(var o=0;o<r.length;o++)o!==n&&r[o].unsubscribe();r=null}t.next(e)}))))},i=0;r&&!t.closed&&i<e.length;i++)n(i)}}t.race=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return 1===(e=i.argsOrArgArray(e)).length?o.innerFrom(e[0]):new n.Observable(l(e))},t.raceInit=l},26612:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throwError=void 0;var n=r(92023),o=r(44717);t.throwError=function(e,t){var r=o.isFunction(e)?e:function(){return e},i=function(e){return e.error(r())};return new n.Observable(t?function(e){return t.schedule(i,0,e)}:i)}},35461:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.timer=void 0;var n=r(92023),o=r(4386),i=r(64568),a=r(96349);t.timer=function(e,t,r){void 0===e&&(e=0),void 0===r&&(r=o.async);var l=-1;return null!=t&&(i.isScheduler(t)?r=t:l=t),new n.Observable((function(t){var n=a.isValidDate(e)?+e-r.now():e;n<0&&(n=0);var o=0;return r.schedule((function(){t.closed||(t.next(o++),0<=l?this.schedule(void 0,l):t.complete())}),n)}))}},61763:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.zip=void 0;var i=r(92023),a=r(52296),l=r(90160),u=r(47209),s=r(1266),c=r(11824);t.zip=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=c.popResultSelector(e),d=l.argsOrArgArray(e);return d.length?new i.Observable((function(e){var t=d.map((function(){return[]})),i=d.map((function(){return!1}));e.add((function(){t=i=null}));for(var l=function(l){a.innerFrom(d[l]).subscribe(s.createOperatorSubscriber(e,(function(a){if(t[l].push(a),t.every((function(e){return e.length}))){var u=t.map((function(e){return e.shift()}));e.next(r?r.apply(void 0,o([],n(u))):u),t.some((function(e,t){return!e.length&&i[t]}))&&e.complete()}}),(function(){i[l]=!0,!t[l].length&&e.complete()})))},u=0;!e.closed&&u<d.length;u++)l(u);return function(){t=i=null}})):u.EMPTY}},1266:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.OperatorSubscriber=t.createOperatorSubscriber=void 0;var i=r(4512);t.createOperatorSubscriber=function(e,t,r,n,o){return new a(e,t,r,n,o)};var a=function(e){function t(t,r,n,o,i,a){var l=e.call(this,t)||this;return l.onFinalize=i,l.shouldUnsubscribe=a,l._next=r?function(e){try{r(e)}catch(e){t.error(e)}}:e.prototype._next,l._error=o?function(e){try{o(e)}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._error,l._complete=n?function(){try{n()}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._complete,l}return o(t,e),t.prototype.unsubscribe=function(){var t;if(!this.shouldUnsubscribe||this.shouldUnsubscribe()){var r=this.closed;e.prototype.unsubscribe.call(this),!r&&(null===(t=this.onFinalize)||void 0===t||t.call(this))}},t}(i.Subscriber);t.OperatorSubscriber=a},66993:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.audit=void 0;var n=r(35416),o=r(52296),i=r(1266);t.audit=function(e){return n.operate((function(t,r){var n=!1,a=null,l=null,u=!1,s=function(){if(null==l||l.unsubscribe(),l=null,n){n=!1;var e=a;a=null,r.next(e)}u&&r.complete()},c=function(){l=null,u&&r.complete()};t.subscribe(i.createOperatorSubscriber(r,(function(t){n=!0,a=t,l||o.innerFrom(e(t)).subscribe(l=i.createOperatorSubscriber(r,s,c))}),(function(){u=!0,(!n||!l||l.closed)&&r.complete()})))}))}},54116:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.auditTime=void 0;var n=r(4386),o=r(66993),i=r(35461);t.auditTime=function(e,t){return void 0===t&&(t=n.asyncScheduler),o.audit((function(){return i.timer(e,t)}))}},47190:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=void 0;var n=r(35416),o=r(16129),i=r(1266),a=r(52296);t.buffer=function(e){return n.operate((function(t,r){var n=[];return t.subscribe(i.createOperatorSubscriber(r,(function(e){return n.push(e)}),(function(){r.next(n),r.complete()}))),a.innerFrom(e).subscribe(i.createOperatorSubscriber(r,(function(){var e=n;n=[],r.next(e)}),o.noop)),function(){n=null}}))}},76835:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.bufferCount=void 0;var o=r(35416),i=r(1266),a=r(7394);t.bufferCount=function(e,t){return void 0===t&&(t=null),t=null!=t?t:e,o.operate((function(r,o){var l=[],u=0;r.subscribe(i.createOperatorSubscriber(o,(function(r){var i,s,c,d,f=null;u++%t==0&&l.push([]);try{for(var p=n(l),g=p.next();!g.done;g=p.next())(m=g.value).push(r),e<=m.length&&(f=null!=f?f:[]).push(m)}catch(e){i={error:e}}finally{try{g&&!g.done&&(s=p.return)&&s.call(p)}finally{if(i)throw i.error}}if(f)try{for(var v=n(f),h=v.next();!h.done;h=v.next()){var m=h.value;a.arrRemove(l,m),o.next(m)}}catch(e){c={error:e}}finally{try{h&&!h.done&&(d=v.return)&&d.call(v)}finally{if(c)throw c.error}}}),(function(){var e,t;try{for(var r=n(l),i=r.next();!i.done;i=r.next()){var a=i.value;o.next(a)}}catch(t){e={error:t}}finally{try{i&&!i.done&&(t=r.return)&&t.call(r)}finally{if(e)throw e.error}}o.complete()}),void 0,(function(){l=null})))}))}},25219:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.bufferTime=void 0;var o=r(27491),i=r(35416),a=r(1266),l=r(7394),u=r(4386),s=r(11824),c=r(75031);t.bufferTime=function(e){for(var t,r,d=[],f=1;f<arguments.length;f++)d[f-1]=arguments[f];var p=null!==(t=s.popScheduler(d))&&void 0!==t?t:u.asyncScheduler,g=null!==(r=d[0])&&void 0!==r?r:null,v=d[1]||1/0;return i.operate((function(t,r){var i=[],u=!1,s=function(e){var t=e.buffer;e.subs.unsubscribe(),l.arrRemove(i,e),r.next(t),u&&d()},d=function(){if(i){var t=new o.Subscription;r.add(t);var n={buffer:[],subs:t};i.push(n),c.executeSchedule(t,p,(function(){return s(n)}),e)}};null!==g&&g>=0?c.executeSchedule(r,p,d,g,!0):u=!0,d();var f=a.createOperatorSubscriber(r,(function(e){var t,r,o=i.slice();try{for(var a=n(o),l=a.next();!l.done;l=a.next()){var u=l.value,c=u.buffer;c.push(e),v<=c.length&&s(u)}}catch(e){t={error:e}}finally{try{l&&!l.done&&(r=a.return)&&r.call(a)}finally{if(t)throw t.error}}}),(function(){for(;null==i?void 0:i.length;)r.next(i.shift().buffer);null==f||f.unsubscribe(),r.complete(),r.unsubscribe()}),void 0,(function(){return i=null}));t.subscribe(f)}))}},80118:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.bufferToggle=void 0;var o=r(27491),i=r(35416),a=r(52296),l=r(1266),u=r(16129),s=r(7394);t.bufferToggle=function(e,t){return i.operate((function(r,i){var c=[];a.innerFrom(e).subscribe(l.createOperatorSubscriber(i,(function(e){var r=[];c.push(r);var n=new o.Subscription;n.add(a.innerFrom(t(e)).subscribe(l.createOperatorSubscriber(i,(function(){s.arrRemove(c,r),i.next(r),n.unsubscribe()}),u.noop)))}),u.noop)),r.subscribe(l.createOperatorSubscriber(i,(function(e){var t,r;try{for(var o=n(c),i=o.next();!i.done;i=o.next())i.value.push(e)}catch(e){t={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(t)throw t.error}}}),(function(){for(;c.length>0;)i.next(c.shift());i.complete()})))}))}},27514:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.bufferWhen=void 0;var n=r(35416),o=r(16129),i=r(1266),a=r(52296);t.bufferWhen=function(e){return n.operate((function(t,r){var n=null,l=null,u=function(){null==l||l.unsubscribe();var t=n;n=[],t&&r.next(t),a.innerFrom(e()).subscribe(l=i.createOperatorSubscriber(r,u,o.noop))};u(),t.subscribe(i.createOperatorSubscriber(r,(function(e){return null==n?void 0:n.push(e)}),(function(){n&&r.next(n),r.complete()}),void 0,(function(){return n=l=null})))}))}},58251:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.catchError=void 0;var n=r(52296),o=r(1266),i=r(35416);t.catchError=function e(t){return i.operate((function(r,i){var a,l=null,u=!1;l=r.subscribe(o.createOperatorSubscriber(i,void 0,void 0,(function(o){a=n.innerFrom(t(o,e(t)(r))),l?(l.unsubscribe(),l=null,a.subscribe(i)):u=!0}))),u&&(l.unsubscribe(),l=null,a.subscribe(i))}))}},21424:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.combineAll=void 0;var n=r(42945);t.combineAll=n.combineLatestAll},52e3:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.combineLatest=void 0;var i=r(30994),a=r(35416),l=r(90160),u=r(88240),s=r(72393),c=r(11824);t.combineLatest=function e(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var d=c.popResultSelector(t);return d?s.pipe(e.apply(void 0,o([],n(t))),u.mapOneOrManyArgs(d)):a.operate((function(e,r){i.combineLatestInit(o([e],n(l.argsOrArgArray(t))))(r)}))}},42945:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.combineLatestAll=void 0;var n=r(30994),o=r(10587);t.combineLatestAll=function(e){return o.joinAllInternals(n.combineLatest,e)}},93928:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.combineLatestWith=void 0;var i=r(52e3);t.combineLatestWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return i.combineLatest.apply(void 0,o([],n(e)))}},1812:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.concat=void 0;var i=r(35416),a=r(80861),l=r(11824),u=r(45294);t.concat=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=l.popScheduler(e);return i.operate((function(t,i){a.concatAll()(u.from(o([t],n(e)),r)).subscribe(i)}))}},80861:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.concatAll=void 0;var n=r(1867);t.concatAll=function(){return n.mergeAll(1)}},71012:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.concatMap=void 0;var n=r(11282),o=r(44717);t.concatMap=function(e,t){return o.isFunction(t)?n.mergeMap(e,t,1):n.mergeMap(e,1)}},61157:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.concatMapTo=void 0;var n=r(71012),o=r(44717);t.concatMapTo=function(e,t){return o.isFunction(t)?n.concatMap((function(){return e}),t):n.concatMap((function(){return e}))}},33692:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.concatWith=void 0;var i=r(1812);t.concatWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return i.concat.apply(void 0,o([],n(e)))}},32216:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.connect=void 0;var n=r(20020),o=r(52296),i=r(35416),a=r(3123),l={connector:function(){return new n.Subject}};t.connect=function(e,t){void 0===t&&(t=l);var r=t.connector;return i.operate((function(t,n){var i=r();o.innerFrom(e(a.fromSubscribable(i))).subscribe(n),n.add(t.subscribe(i))}))}},18041:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.count=void 0;var n=r(3818);t.count=function(e){return n.reduce((function(t,r,n){return!e||e(r,n)?t+1:t}),0)}},72747:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.debounce=void 0;var n=r(35416),o=r(16129),i=r(1266),a=r(52296);t.debounce=function(e){return n.operate((function(t,r){var n=!1,l=null,u=null,s=function(){if(null==u||u.unsubscribe(),u=null,n){n=!1;var e=l;l=null,r.next(e)}};t.subscribe(i.createOperatorSubscriber(r,(function(t){null==u||u.unsubscribe(),n=!0,l=t,u=i.createOperatorSubscriber(r,s,o.noop),a.innerFrom(e(t)).subscribe(u)}),(function(){s(),r.complete()}),void 0,(function(){l=u=null})))}))}},33870:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.debounceTime=void 0;var n=r(4386),o=r(35416),i=r(1266);t.debounceTime=function(e,t){return void 0===t&&(t=n.asyncScheduler),o.operate((function(r,n){var o=null,a=null,l=null,u=function(){if(o){o.unsubscribe(),o=null;var e=a;a=null,n.next(e)}};function s(){var r=l+e,i=t.now();if(i<r)return o=this.schedule(void 0,r-i),void n.add(o);u()}r.subscribe(i.createOperatorSubscriber(n,(function(r){a=r,l=t.now(),o||(o=t.schedule(s,e),n.add(o))}),(function(){u(),n.complete()}),void 0,(function(){a=o=null})))}))}},87507:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultIfEmpty=void 0;var n=r(35416),o=r(1266);t.defaultIfEmpty=function(e){return n.operate((function(t,r){var n=!1;t.subscribe(o.createOperatorSubscriber(r,(function(e){n=!0,r.next(e)}),(function(){n||r.next(e),r.complete()})))}))}},62409:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delay=void 0;var n=r(4386),o=r(85137),i=r(35461);t.delay=function(e,t){void 0===t&&(t=n.asyncScheduler);var r=i.timer(e,t);return o.delayWhen((function(){return r}))}},85137:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delayWhen=void 0;var n=r(62070),o=r(46803),i=r(52507),a=r(31357),l=r(11282),u=r(52296);t.delayWhen=function e(t,r){return r?function(a){return n.concat(r.pipe(o.take(1),i.ignoreElements()),a.pipe(e(t)))}:l.mergeMap((function(e,r){return u.innerFrom(t(e,r)).pipe(o.take(1),a.mapTo(e))}))}},84126:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.dematerialize=void 0;var n=r(26145),o=r(35416),i=r(1266);t.dematerialize=function(){return o.operate((function(e,t){e.subscribe(i.createOperatorSubscriber(t,(function(e){return n.observeNotification(e,t)})))}))}},15208:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.distinct=void 0;var n=r(35416),o=r(1266),i=r(16129),a=r(52296);t.distinct=function(e,t){return n.operate((function(r,n){var l=new Set;r.subscribe(o.createOperatorSubscriber(n,(function(t){var r=e?e(t):t;l.has(r)||(l.add(r),n.next(t))}))),t&&a.innerFrom(t).subscribe(o.createOperatorSubscriber(n,(function(){return l.clear()}),i.noop))}))}},29939:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.distinctUntilChanged=void 0;var n=r(79391),o=r(35416),i=r(1266);function a(e,t){return e===t}t.distinctUntilChanged=function(e,t){return void 0===t&&(t=n.identity),e=null!=e?e:a,o.operate((function(r,n){var o,a=!0;r.subscribe(i.createOperatorSubscriber(n,(function(r){var i=t(r);!a&&e(o,i)||(a=!1,o=i,n.next(r))})))}))}},10183:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.distinctUntilKeyChanged=void 0;var n=r(29939);t.distinctUntilKeyChanged=function(e,t){return n.distinctUntilChanged((function(r,n){return t?t(r[e],n[e]):r[e]===n[e]}))}},61195:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.elementAt=void 0;var n=r(49148),o=r(72914),i=r(45956),a=r(87507),l=r(46803);t.elementAt=function(e,t){if(e<0)throw new n.ArgumentOutOfRangeError;var r=arguments.length>=2;return function(u){return u.pipe(o.filter((function(t,r){return r===e})),l.take(1),r?a.defaultIfEmpty(t):i.throwIfEmpty((function(){return new n.ArgumentOutOfRangeError})))}}},93723:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.endWith=void 0;var i=r(62070),a=r(48743);t.endWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return function(t){return i.concat(t,a.of.apply(void 0,o([],n(e))))}}},61909:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.every=void 0;var n=r(35416),o=r(1266);t.every=function(e,t){return n.operate((function(r,n){var i=0;r.subscribe(o.createOperatorSubscriber(n,(function(o){e.call(t,o,i++,r)||(n.next(!1),n.complete())}),(function(){n.next(!0),n.complete()})))}))}},79228:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.exhaust=void 0;var n=r(79765);t.exhaust=n.exhaustAll},79765:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.exhaustAll=void 0;var n=r(8748),o=r(79391);t.exhaustAll=function(){return n.exhaustMap(o.identity)}},8748:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.exhaustMap=void 0;var n=r(74828),o=r(52296),i=r(35416),a=r(1266);t.exhaustMap=function e(t,r){return r?function(i){return i.pipe(e((function(e,i){return o.innerFrom(t(e,i)).pipe(n.map((function(t,n){return r(e,t,i,n)})))})))}:i.operate((function(e,r){var n=0,i=null,l=!1;e.subscribe(a.createOperatorSubscriber(r,(function(e){i||(i=a.createOperatorSubscriber(r,void 0,(function(){i=null,l&&r.complete()})),o.innerFrom(t(e,n++)).subscribe(i))}),(function(){l=!0,!i&&r.complete()})))}))}},68324:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.expand=void 0;var n=r(35416),o=r(13754);t.expand=function(e,t,r){return void 0===t&&(t=1/0),t=(t||0)<1?1/0:t,n.operate((function(n,i){return o.mergeInternals(n,i,e,t,void 0,!0,r)}))}},72914:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=void 0;var n=r(35416),o=r(1266);t.filter=function(e,t){return n.operate((function(r,n){var i=0;r.subscribe(o.createOperatorSubscriber(n,(function(r){return e.call(t,r,i++)&&n.next(r)})))}))}},89822:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.finalize=void 0;var n=r(35416);t.finalize=function(e){return n.operate((function(t,r){try{t.subscribe(r)}finally{r.add(e)}}))}},52819:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFind=t.find=void 0;var n=r(35416),o=r(1266);function i(e,t,r){var n="index"===r;return function(r,i){var a=0;r.subscribe(o.createOperatorSubscriber(i,(function(o){var l=a++;e.call(t,o,l,r)&&(i.next(n?l:o),i.complete())}),(function(){i.next(n?-1:void 0),i.complete()})))}}t.find=function(e,t){return n.operate(i(e,t,"value"))},t.createFind=i},3367:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.findIndex=void 0;var n=r(35416),o=r(52819);t.findIndex=function(e,t){return n.operate(o.createFind(e,t,"index"))}},41432:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.first=void 0;var n=r(37676),o=r(72914),i=r(46803),a=r(87507),l=r(45956),u=r(79391);t.first=function(e,t){var r=arguments.length>=2;return function(s){return s.pipe(e?o.filter((function(t,r){return e(t,r,s)})):u.identity,i.take(1),r?a.defaultIfEmpty(t):l.throwIfEmpty((function(){return new n.EmptyError})))}}},26977:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.flatMap=void 0;var n=r(11282);t.flatMap=n.mergeMap},34956:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=void 0;var n=r(92023),o=r(52296),i=r(20020),a=r(35416),l=r(1266);t.groupBy=function(e,t,r,u){return a.operate((function(a,s){var c;t&&"function"!=typeof t?(r=t.duration,c=t.element,u=t.connector):c=t;var d=new Map,f=function(e){d.forEach(e),e(s)},p=function(e){return f((function(t){return t.error(e)}))},g=0,v=!1,h=new l.OperatorSubscriber(s,(function(t){try{var a=e(t),f=d.get(a);if(!f){d.set(a,f=u?u():new i.Subject);var m=(b=a,E=f,(O=new n.Observable((function(e){g++;var t=E.subscribe(e);return function(){t.unsubscribe(),0==--g&&v&&h.unsubscribe()}}))).key=b,O);if(s.next(m),r){var y=l.createOperatorSubscriber(f,(function(){f.complete(),null==y||y.unsubscribe()}),void 0,void 0,(function(){return d.delete(a)}));h.add(o.innerFrom(r(m)).subscribe(y))}}f.next(c?c(t):t)}catch(e){p(e)}var b,E,O}),(function(){return f((function(e){return e.complete()}))}),p,(function(){return d.clear()}),(function(){return v=!0,0===g}));a.subscribe(h)}))}},52507:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ignoreElements=void 0;var n=r(35416),o=r(1266),i=r(16129);t.ignoreElements=function(){return n.operate((function(e,t){e.subscribe(o.createOperatorSubscriber(t,i.noop))}))}},66095:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEmpty=void 0;var n=r(35416),o=r(1266);t.isEmpty=function(){return n.operate((function(e,t){e.subscribe(o.createOperatorSubscriber(t,(function(){t.next(!1),t.complete()}),(function(){t.next(!0),t.complete()})))}))}},10587:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.joinAllInternals=void 0;var n=r(79391),o=r(88240),i=r(72393),a=r(11282),l=r(22984);t.joinAllInternals=function(e,t){return i.pipe(l.toArray(),a.mergeMap((function(t){return e(t)})),t?o.mapOneOrManyArgs(t):n.identity)}},33484:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.last=void 0;var n=r(37676),o=r(72914),i=r(20787),a=r(45956),l=r(87507),u=r(79391);t.last=function(e,t){var r=arguments.length>=2;return function(s){return s.pipe(e?o.filter((function(t,r){return e(t,r,s)})):u.identity,i.takeLast(1),r?l.defaultIfEmpty(t):a.throwIfEmpty((function(){return new n.EmptyError})))}}},74828:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.map=void 0;var n=r(35416),o=r(1266);t.map=function(e,t){return n.operate((function(r,n){var i=0;r.subscribe(o.createOperatorSubscriber(n,(function(r){n.next(e.call(t,r,i++))})))}))}},31357:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapTo=void 0;var n=r(74828);t.mapTo=function(e){return n.map((function(){return e}))}},37967:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.materialize=void 0;var n=r(26145),o=r(35416),i=r(1266);t.materialize=function(){return o.operate((function(e,t){e.subscribe(i.createOperatorSubscriber(t,(function(e){t.next(n.Notification.createNext(e))}),(function(){t.next(n.Notification.createComplete()),t.complete()}),(function(e){t.next(n.Notification.createError(e)),t.complete()})))}))}},94388:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.max=void 0;var n=r(3818),o=r(44717);t.max=function(e){return n.reduce(o.isFunction(e)?function(t,r){return e(t,r)>0?t:r}:function(e,t){return e>t?e:t})}},61550:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.merge=void 0;var i=r(35416),a=r(90160),l=r(1867),u=r(11824),s=r(45294);t.merge=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=u.popScheduler(e),c=u.popNumber(e,1/0);return e=a.argsOrArgArray(e),i.operate((function(t,i){l.mergeAll(c)(s.from(o([t],n(e)),r)).subscribe(i)}))}},1867:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mergeAll=void 0;var n=r(11282),o=r(79391);t.mergeAll=function(e){return void 0===e&&(e=1/0),n.mergeMap(o.identity,e)}},13754:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mergeInternals=void 0;var n=r(52296),o=r(75031),i=r(1266);t.mergeInternals=function(e,t,r,a,l,u,s,c){var d=[],f=0,p=0,g=!1,v=function(){!g||d.length||f||t.complete()},h=function(e){return f<a?m(e):d.push(e)},m=function(e){u&&t.next(e),f++;var c=!1;n.innerFrom(r(e,p++)).subscribe(i.createOperatorSubscriber(t,(function(e){null==l||l(e),u?h(e):t.next(e)}),(function(){c=!0}),void 0,(function(){if(c)try{f--;for(var e=function(){var e=d.shift();s?o.executeSchedule(t,s,(function(){return m(e)})):m(e)};d.length&&f<a;)e();v()}catch(e){t.error(e)}})))};return e.subscribe(i.createOperatorSubscriber(t,h,(function(){g=!0,v()}))),function(){null==c||c()}}},11282:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mergeMap=void 0;var n=r(74828),o=r(52296),i=r(35416),a=r(13754),l=r(44717);t.mergeMap=function e(t,r,u){return void 0===u&&(u=1/0),l.isFunction(r)?e((function(e,i){return n.map((function(t,n){return r(e,t,i,n)}))(o.innerFrom(t(e,i)))}),u):("number"==typeof r&&(u=r),i.operate((function(e,r){return a.mergeInternals(e,r,t,u)})))}},86295:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mergeMapTo=void 0;var n=r(11282),o=r(44717);t.mergeMapTo=function(e,t,r){return void 0===r&&(r=1/0),o.isFunction(t)?n.mergeMap((function(){return e}),t,r):("number"==typeof t&&(r=t),n.mergeMap((function(){return e}),r))}},9527:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mergeScan=void 0;var n=r(35416),o=r(13754);t.mergeScan=function(e,t,r){return void 0===r&&(r=1/0),n.operate((function(n,i){var a=t;return o.mergeInternals(n,i,(function(t,r){return e(a,t,r)}),r,(function(e){a=e}),!1,void 0,(function(){return a=null}))}))}},25834:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.mergeWith=void 0;var i=r(61550);t.mergeWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return i.merge.apply(void 0,o([],n(e)))}},61306:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.min=void 0;var n=r(3818),o=r(44717);t.min=function(e){return n.reduce(o.isFunction(e)?function(t,r){return e(t,r)<0?t:r}:function(e,t){return e<t?e:t})}},59924:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multicast=void 0;var n=r(51507),o=r(44717),i=r(32216);t.multicast=function(e,t){var r=o.isFunction(e)?e:function(){return e};return o.isFunction(t)?i.connect(t,{connector:r}):function(e){return new n.ConnectableObservable(e,r)}}},82803:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observeOn=void 0;var n=r(75031),o=r(35416),i=r(1266);t.observeOn=function(e,t){return void 0===t&&(t=0),o.operate((function(r,o){r.subscribe(i.createOperatorSubscriber(o,(function(r){return n.executeSchedule(o,e,(function(){return o.next(r)}),t)}),(function(){return n.executeSchedule(o,e,(function(){return o.complete()}),t)}),(function(r){return n.executeSchedule(o,e,(function(){return o.error(r)}),t)})))}))}},21997:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.onErrorResumeNext=t.onErrorResumeNextWith=void 0;var i=r(90160),a=r(66467);function l(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=i.argsOrArgArray(e);return function(e){return a.onErrorResumeNext.apply(void 0,o([e],n(r)))}}t.onErrorResumeNextWith=l,t.onErrorResumeNext=l},74492:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.pairwise=void 0;var n=r(35416),o=r(1266);t.pairwise=function(){return n.operate((function(e,t){var r,n=!1;e.subscribe(o.createOperatorSubscriber(t,(function(e){var o=r;r=e,n&&t.next([o,e]),n=!0})))}))}},35352:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.partition=void 0;var n=r(31276),o=r(72914);t.partition=function(e,t){return function(r){return[o.filter(e,t)(r),o.filter(n.not(e,t))(r)]}}},43391:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.pluck=void 0;var n=r(74828);t.pluck=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=e.length;if(0===r)throw new Error("list of properties cannot be empty.");return n.map((function(t){for(var n=t,o=0;o<r;o++){var i=null==n?void 0:n[e[o]];if(void 0===i)return;n=i}return n}))}},20297:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.publish=void 0;var n=r(20020),o=r(59924),i=r(32216);t.publish=function(e){return e?function(t){return i.connect(e)(t)}:function(e){return o.multicast(new n.Subject)(e)}}},46383:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.publishBehavior=void 0;var n=r(71222),o=r(51507);t.publishBehavior=function(e){return function(t){var r=new n.BehaviorSubject(e);return new o.ConnectableObservable(t,(function(){return r}))}}},58229:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.publishLast=void 0;var n=r(55366),o=r(51507);t.publishLast=function(){return function(e){var t=new n.AsyncSubject;return new o.ConnectableObservable(e,(function(){return t}))}}},28226:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.publishReplay=void 0;var n=r(35129),o=r(59924),i=r(44717);t.publishReplay=function(e,t,r,a){r&&!i.isFunction(r)&&(a=r);var l=i.isFunction(r)?r:void 0;return function(r){return o.multicast(new n.ReplaySubject(e,t,a),l)(r)}}},78973:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.race=void 0;var i=r(90160),a=r(177);t.race=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return a.raceWith.apply(void 0,o([],n(i.argsOrArgArray(e))))}},177:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.raceWith=void 0;var i=r(64143),a=r(35416),l=r(79391);t.raceWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return e.length?a.operate((function(t,r){i.raceInit(o([t],n(e)))(r)})):l.identity}},3818:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.reduce=void 0;var n=r(47071),o=r(35416);t.reduce=function(e,t){return o.operate(n.scanInternals(e,t,arguments.length>=2,!1,!0))}},85884:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refCount=void 0;var n=r(35416),o=r(1266);t.refCount=function(){return n.operate((function(e,t){var r=null;e._refCount++;var n=o.createOperatorSubscriber(t,void 0,void 0,void 0,(function(){if(!e||e._refCount<=0||0<--e._refCount)r=null;else{var n=e._connection,o=r;r=null,!n||o&&n!==o||n.unsubscribe(),t.unsubscribe()}}));e.subscribe(n),n.closed||(r=e.connect())}))}},7775:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.repeat=void 0;var n=r(47209),o=r(35416),i=r(1266),a=r(52296),l=r(35461);t.repeat=function(e){var t,r,u=1/0;return null!=e&&("object"==typeof e?(t=e.count,u=void 0===t?1/0:t,r=e.delay):u=e),u<=0?function(){return n.EMPTY}:o.operate((function(e,t){var n,o=0,s=function(){if(null==n||n.unsubscribe(),n=null,null!=r){var e="number"==typeof r?l.timer(r):a.innerFrom(r(o)),u=i.createOperatorSubscriber(t,(function(){u.unsubscribe(),c()}));e.subscribe(u)}else c()},c=function(){var r=!1;n=e.subscribe(i.createOperatorSubscriber(t,void 0,(function(){++o<u?n?s():r=!0:t.complete()}))),r&&s()};c()}))}},25567:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.repeatWhen=void 0;var n=r(52296),o=r(20020),i=r(35416),a=r(1266);t.repeatWhen=function(e){return i.operate((function(t,r){var i,l,u=!1,s=!1,c=!1,d=function(){return c&&s&&(r.complete(),!0)},f=function(){c=!1,i=t.subscribe(a.createOperatorSubscriber(r,void 0,(function(){c=!0,!d()&&(l||(l=new o.Subject,n.innerFrom(e(l)).subscribe(a.createOperatorSubscriber(r,(function(){i?f():u=!0}),(function(){s=!0,d()})))),l).next()}))),u&&(i.unsubscribe(),i=null,u=!1,f())};f()}))}},14740:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.retry=void 0;var n=r(35416),o=r(1266),i=r(79391),a=r(35461),l=r(52296);t.retry=function(e){var t;void 0===e&&(e=1/0);var r=(t=e&&"object"==typeof e?e:{count:e}).count,u=void 0===r?1/0:r,s=t.delay,c=t.resetOnSuccess,d=void 0!==c&&c;return u<=0?i.identity:n.operate((function(e,t){var r,n=0,i=function(){var c=!1;r=e.subscribe(o.createOperatorSubscriber(t,(function(e){d&&(n=0),t.next(e)}),void 0,(function(e){if(n++<u){var d=function(){r?(r.unsubscribe(),r=null,i()):c=!0};if(null!=s){var f="number"==typeof s?a.timer(s):l.innerFrom(s(e,n)),p=o.createOperatorSubscriber(t,(function(){p.unsubscribe(),d()}),(function(){t.complete()}));f.subscribe(p)}else d()}else t.error(e)}))),c&&(r.unsubscribe(),r=null,i())};i()}))}},40264:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.retryWhen=void 0;var n=r(52296),o=r(20020),i=r(35416),a=r(1266);t.retryWhen=function(e){return i.operate((function(t,r){var i,l,u=!1,s=function(){i=t.subscribe(a.createOperatorSubscriber(r,void 0,void 0,(function(t){l||(l=new o.Subject,n.innerFrom(e(l)).subscribe(a.createOperatorSubscriber(r,(function(){return i?s():u=!0})))),l&&l.next(t)}))),u&&(i.unsubscribe(),i=null,u=!1,s())};s()}))}},86870:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sample=void 0;var n=r(52296),o=r(35416),i=r(16129),a=r(1266);t.sample=function(e){return o.operate((function(t,r){var o=!1,l=null;t.subscribe(a.createOperatorSubscriber(r,(function(e){o=!0,l=e}))),n.innerFrom(e).subscribe(a.createOperatorSubscriber(r,(function(){if(o){o=!1;var e=l;l=null,r.next(e)}}),i.noop))}))}},85411:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sampleTime=void 0;var n=r(4386),o=r(86870),i=r(38767);t.sampleTime=function(e,t){return void 0===t&&(t=n.asyncScheduler),o.sample(i.interval(e,t))}},82457:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scan=void 0;var n=r(35416),o=r(47071);t.scan=function(e,t){return n.operate(o.scanInternals(e,t,arguments.length>=2,!0))}},47071:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scanInternals=void 0;var n=r(1266);t.scanInternals=function(e,t,r,o,i){return function(a,l){var u=r,s=t,c=0;a.subscribe(n.createOperatorSubscriber(l,(function(t){var r=c++;s=u?e(s,t,r):(u=!0,t),o&&l.next(s)}),i&&function(){u&&l.next(s),l.complete()}))}}},55109:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sequenceEqual=void 0;var n=r(35416),o=r(1266),i=r(52296);t.sequenceEqual=function(e,t){return void 0===t&&(t=function(e,t){return e===t}),n.operate((function(r,n){var a={buffer:[],complete:!1},l={buffer:[],complete:!1},u=function(e){n.next(e),n.complete()},s=function(e,r){var i=o.createOperatorSubscriber(n,(function(n){var o=r.buffer,i=r.complete;0===o.length?i?u(!1):e.buffer.push(n):!t(n,o.shift())&&u(!1)}),(function(){e.complete=!0;var t=r.complete,n=r.buffer;t&&u(0===n.length),null==i||i.unsubscribe()}));return i};r.subscribe(s(a,l)),i.innerFrom(e).subscribe(s(l,a))}))}},83329:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.share=void 0;var i=r(52296),a=r(20020),l=r(4512),u=r(35416);function s(e,t){for(var r=[],a=2;a<arguments.length;a++)r[a-2]=arguments[a];if(!0!==t){if(!1!==t){var u=new l.SafeSubscriber({next:function(){u.unsubscribe(),e()}});return i.innerFrom(t.apply(void 0,o([],n(r)))).subscribe(u)}}else e()}t.share=function(e){void 0===e&&(e={});var t=e.connector,r=void 0===t?function(){return new a.Subject}:t,n=e.resetOnError,o=void 0===n||n,c=e.resetOnComplete,d=void 0===c||c,f=e.resetOnRefCountZero,p=void 0===f||f;return function(e){var t,n,a,c=0,f=!1,g=!1,v=function(){null==n||n.unsubscribe(),n=void 0},h=function(){v(),t=a=void 0,f=g=!1},m=function(){var e=t;h(),null==e||e.unsubscribe()};return u.operate((function(e,u){c++,g||f||v();var y=a=null!=a?a:r();u.add((function(){0!=--c||g||f||(n=s(m,p))})),y.subscribe(u),!t&&c>0&&(t=new l.SafeSubscriber({next:function(e){return y.next(e)},error:function(e){g=!0,v(),n=s(h,o,e),y.error(e)},complete:function(){f=!0,v(),n=s(h,d),y.complete()}}),i.innerFrom(e).subscribe(t))}))(e)}}},11738:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shareReplay=void 0;var n=r(35129),o=r(83329);t.shareReplay=function(e,t,r){var i,a,l,u,s=!1;return e&&"object"==typeof e?(i=e.bufferSize,u=void 0===i?1/0:i,a=e.windowTime,t=void 0===a?1/0:a,s=void 0!==(l=e.refCount)&&l,r=e.scheduler):u=null!=e?e:1/0,o.share({connector:function(){return new n.ReplaySubject(u,t,r)},resetOnError:!0,resetOnComplete:!1,resetOnRefCountZero:s})}},70884:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.single=void 0;var n=r(37676),o=r(18168),i=r(2318),a=r(35416),l=r(1266);t.single=function(e){return a.operate((function(t,r){var a,u=!1,s=!1,c=0;t.subscribe(l.createOperatorSubscriber(r,(function(n){s=!0,e&&!e(n,c++,t)||(u&&r.error(new o.SequenceError("Too many matching values")),u=!0,a=n)}),(function(){u?(r.next(a),r.complete()):r.error(s?new i.NotFoundError("No matching values"):new n.EmptyError)})))}))}},14411:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.skip=void 0;var n=r(72914);t.skip=function(e){return n.filter((function(t,r){return e<=r}))}},19355:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.skipLast=void 0;var n=r(79391),o=r(35416),i=r(1266);t.skipLast=function(e){return e<=0?n.identity:o.operate((function(t,r){var n=new Array(e),o=0;return t.subscribe(i.createOperatorSubscriber(r,(function(t){var i=o++;if(i<e)n[i]=t;else{var a=i%e,l=n[a];n[a]=t,r.next(l)}}))),function(){n=null}}))}},82947:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.skipUntil=void 0;var n=r(35416),o=r(1266),i=r(52296),a=r(16129);t.skipUntil=function(e){return n.operate((function(t,r){var n=!1,l=o.createOperatorSubscriber(r,(function(){null==l||l.unsubscribe(),n=!0}),a.noop);i.innerFrom(e).subscribe(l),t.subscribe(o.createOperatorSubscriber(r,(function(e){return n&&r.next(e)})))}))}},29842:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.skipWhile=void 0;var n=r(35416),o=r(1266);t.skipWhile=function(e){return n.operate((function(t,r){var n=!1,i=0;t.subscribe(o.createOperatorSubscriber(r,(function(t){return(n||(n=!e(t,i++)))&&r.next(t)})))}))}},62778:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startWith=void 0;var n=r(62070),o=r(11824),i=r(35416);t.startWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=o.popScheduler(e);return i.operate((function(t,o){(r?n.concat(e,t,r):n.concat(e,t)).subscribe(o)}))}},44027:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.subscribeOn=void 0;var n=r(35416);t.subscribeOn=function(e,t){return void 0===t&&(t=0),n.operate((function(r,n){n.add(e.schedule((function(){return r.subscribe(n)}),t))}))}},89061:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.switchAll=void 0;var n=r(6300),o=r(79391);t.switchAll=function(){return n.switchMap(o.identity)}},6300:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.switchMap=void 0;var n=r(52296),o=r(35416),i=r(1266);t.switchMap=function(e,t){return o.operate((function(r,o){var a=null,l=0,u=!1,s=function(){return u&&!a&&o.complete()};r.subscribe(i.createOperatorSubscriber(o,(function(r){null==a||a.unsubscribe();var u=0,c=l++;n.innerFrom(e(r,c)).subscribe(a=i.createOperatorSubscriber(o,(function(e){return o.next(t?t(r,e,c,u++):e)}),(function(){a=null,s()})))}),(function(){u=!0,s()})))}))}},61933:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.switchMapTo=void 0;var n=r(6300),o=r(44717);t.switchMapTo=function(e,t){return o.isFunction(t)?n.switchMap((function(){return e}),t):n.switchMap((function(){return e}))}},51689:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.switchScan=void 0;var n=r(6300),o=r(35416);t.switchScan=function(e,t){return o.operate((function(r,o){var i=t;return n.switchMap((function(t,r){return e(i,t,r)}),(function(e,t){return i=t,t}))(r).subscribe(o),function(){i=null}}))}},46803:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.take=void 0;var n=r(47209),o=r(35416),i=r(1266);t.take=function(e){return e<=0?function(){return n.EMPTY}:o.operate((function(t,r){var n=0;t.subscribe(i.createOperatorSubscriber(r,(function(t){++n<=e&&(r.next(t),e<=n&&r.complete())})))}))}},20787:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.takeLast=void 0;var o=r(47209),i=r(35416),a=r(1266);t.takeLast=function(e){return e<=0?function(){return o.EMPTY}:i.operate((function(t,r){var o=[];t.subscribe(a.createOperatorSubscriber(r,(function(t){o.push(t),e<o.length&&o.shift()}),(function(){var e,t;try{for(var i=n(o),a=i.next();!a.done;a=i.next()){var l=a.value;r.next(l)}}catch(t){e={error:t}}finally{try{a&&!a.done&&(t=i.return)&&t.call(i)}finally{if(e)throw e.error}}r.complete()}),void 0,(function(){o=null})))}))}},24811:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.takeUntil=void 0;var n=r(35416),o=r(1266),i=r(52296),a=r(16129);t.takeUntil=function(e){return n.operate((function(t,r){i.innerFrom(e).subscribe(o.createOperatorSubscriber(r,(function(){return r.complete()}),a.noop)),!r.closed&&t.subscribe(r)}))}},47770:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.takeWhile=void 0;var n=r(35416),o=r(1266);t.takeWhile=function(e,t){return void 0===t&&(t=!1),n.operate((function(r,n){var i=0;r.subscribe(o.createOperatorSubscriber(n,(function(r){var o=e(r,i++);(o||t)&&n.next(r),!o&&n.complete()})))}))}},79967:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.tap=void 0;var n=r(44717),o=r(35416),i=r(1266),a=r(79391);t.tap=function(e,t,r){var l=n.isFunction(e)||t||r?{next:e,error:t,complete:r}:e;return l?o.operate((function(e,t){var r;null===(r=l.subscribe)||void 0===r||r.call(l);var n=!0;e.subscribe(i.createOperatorSubscriber(t,(function(e){var r;null===(r=l.next)||void 0===r||r.call(l,e),t.next(e)}),(function(){var e;n=!1,null===(e=l.complete)||void 0===e||e.call(l),t.complete()}),(function(e){var r;n=!1,null===(r=l.error)||void 0===r||r.call(l,e),t.error(e)}),(function(){var e,t;n&&(null===(e=l.unsubscribe)||void 0===e||e.call(l)),null===(t=l.finalize)||void 0===t||t.call(l)})))})):a.identity}},16516:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=void 0;var n=r(35416),o=r(1266),i=r(52296);t.throttle=function(e,t){return n.operate((function(r,n){var a=null!=t?t:{},l=a.leading,u=void 0===l||l,s=a.trailing,c=void 0!==s&&s,d=!1,f=null,p=null,g=!1,v=function(){null==p||p.unsubscribe(),p=null,c&&(y(),g&&n.complete())},h=function(){p=null,g&&n.complete()},m=function(t){return p=i.innerFrom(e(t)).subscribe(o.createOperatorSubscriber(n,v,h))},y=function(){if(d){d=!1;var e=f;f=null,n.next(e),!g&&m(e)}};r.subscribe(o.createOperatorSubscriber(n,(function(e){d=!0,f=e,(!p||p.closed)&&(u?y():m(e))}),(function(){g=!0,(!(c&&d&&p)||p.closed)&&n.complete()})))}))}},75945:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttleTime=void 0;var n=r(4386),o=r(16516),i=r(35461);t.throttleTime=function(e,t,r){void 0===t&&(t=n.asyncScheduler);var a=i.timer(e,t);return o.throttle((function(){return a}),r)}},45956:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throwIfEmpty=void 0;var n=r(37676),o=r(35416),i=r(1266);function a(){return new n.EmptyError}t.throwIfEmpty=function(e){return void 0===e&&(e=a),o.operate((function(t,r){var n=!1;t.subscribe(i.createOperatorSubscriber(r,(function(e){n=!0,r.next(e)}),(function(){return n?r.complete():r.error(e())})))}))}},99712:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TimeInterval=t.timeInterval=void 0;var n=r(4386),o=r(35416),i=r(1266);t.timeInterval=function(e){return void 0===e&&(e=n.asyncScheduler),o.operate((function(t,r){var n=e.now();t.subscribe(i.createOperatorSubscriber(r,(function(t){var o=e.now(),i=o-n;n=o,r.next(new a(t,i))})))}))};var a=function(e,t){this.value=e,this.interval=t};t.TimeInterval=a},87517:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.timeout=t.TimeoutError=void 0;var n=r(4386),o=r(96349),i=r(35416),a=r(52296),l=r(56871),u=r(1266),s=r(75031);function c(e){throw new t.TimeoutError(e)}t.TimeoutError=l.createErrorClass((function(e){return function(t){void 0===t&&(t=null),e(this),this.message="Timeout has occurred",this.name="TimeoutError",this.info=t}})),t.timeout=function(e,t){var r=o.isValidDate(e)?{first:e}:"number"==typeof e?{each:e}:e,l=r.first,d=r.each,f=r.with,p=void 0===f?c:f,g=r.scheduler,v=void 0===g?null!=t?t:n.asyncScheduler:g,h=r.meta,m=void 0===h?null:h;if(null==l&&null==d)throw new TypeError("No timeout provided.");return i.operate((function(e,t){var r,n,o=null,i=0,c=function(e){n=s.executeSchedule(t,v,(function(){try{r.unsubscribe(),a.innerFrom(p({meta:m,lastValue:o,seen:i})).subscribe(t)}catch(e){t.error(e)}}),e)};r=e.subscribe(u.createOperatorSubscriber(t,(function(e){null==n||n.unsubscribe(),i++,t.next(o=e),d>0&&c(d)}),void 0,void 0,(function(){(null==n?void 0:n.closed)||null==n||n.unsubscribe(),o=null}))),!i&&c(null!=l?"number"==typeof l?l:+l-v.now():d)}))}},62001:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.timeoutWith=void 0;var n=r(4386),o=r(96349),i=r(87517);t.timeoutWith=function(e,t,r){var a,l,u;if(r=null!=r?r:n.async,o.isValidDate(e)?a=e:"number"==typeof e&&(l=e),!t)throw new TypeError("No observable provided to switch to");if(u=function(){return t},null==a&&null==l)throw new TypeError("No timeout provided.");return i.timeout({first:a,each:l,scheduler:r,with:u})}},68158:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.timestamp=void 0;var n=r(26956),o=r(74828);t.timestamp=function(e){return void 0===e&&(e=n.dateTimestampProvider),o.map((function(t){return{value:t,timestamp:e.now()}}))}},22984:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toArray=void 0;var n=r(3818),o=r(35416),i=function(e,t){return e.push(t),e};t.toArray=function(){return o.operate((function(e,t){n.reduce(i,[])(e).subscribe(t)}))}},75492:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.window=void 0;var n=r(20020),o=r(35416),i=r(1266),a=r(16129),l=r(52296);t.window=function(e){return o.operate((function(t,r){var o=new n.Subject;r.next(o.asObservable());var u=function(e){o.error(e),r.error(e)};return t.subscribe(i.createOperatorSubscriber(r,(function(e){return null==o?void 0:o.next(e)}),(function(){o.complete(),r.complete()}),u)),l.innerFrom(e).subscribe(i.createOperatorSubscriber(r,(function(){o.complete(),r.next(o=new n.Subject)}),a.noop,u)),function(){null==o||o.unsubscribe(),o=null}}))}},56817:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.windowCount=void 0;var o=r(20020),i=r(35416),a=r(1266);t.windowCount=function(e,t){void 0===t&&(t=0);var r=t>0?t:e;return i.operate((function(t,i){var l=[new o.Subject],u=0;i.next(l[0].asObservable()),t.subscribe(a.createOperatorSubscriber(i,(function(t){var a,s;try{for(var c=n(l),d=c.next();!d.done;d=c.next())d.value.next(t)}catch(e){a={error:e}}finally{try{d&&!d.done&&(s=c.return)&&s.call(c)}finally{if(a)throw a.error}}var f=u-e+1;if(f>=0&&f%r==0&&l.shift().complete(),++u%r==0){var p=new o.Subject;l.push(p),i.next(p.asObservable())}}),(function(){for(;l.length>0;)l.shift().complete();i.complete()}),(function(e){for(;l.length>0;)l.shift().error(e);i.error(e)}),(function(){l=null})))}))}},96841:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.windowTime=void 0;var n=r(20020),o=r(4386),i=r(27491),a=r(35416),l=r(1266),u=r(7394),s=r(11824),c=r(75031);t.windowTime=function(e){for(var t,r,d=[],f=1;f<arguments.length;f++)d[f-1]=arguments[f];var p=null!==(t=s.popScheduler(d))&&void 0!==t?t:o.asyncScheduler,g=null!==(r=d[0])&&void 0!==r?r:null,v=d[1]||1/0;return a.operate((function(t,r){var o=[],a=!1,s=function(e){var t=e.window,r=e.subs;t.complete(),r.unsubscribe(),u.arrRemove(o,e),a&&d()},d=function(){if(o){var t=new i.Subscription;r.add(t);var a=new n.Subject,l={window:a,subs:t,seen:0};o.push(l),r.next(a.asObservable()),c.executeSchedule(t,p,(function(){return s(l)}),e)}};null!==g&&g>=0?c.executeSchedule(r,p,d,g,!0):a=!0,d();var f=function(e){return o.slice().forEach(e)},h=function(e){f((function(t){var r=t.window;return e(r)})),e(r),r.unsubscribe()};return t.subscribe(l.createOperatorSubscriber(r,(function(e){f((function(t){t.window.next(e),v<=++t.seen&&s(t)}))}),(function(){return h((function(e){return e.complete()}))}),(function(e){return h((function(t){return t.error(e)}))}))),function(){o=null}}))}},4880:function(e,t,r){"use strict";var n=this&&this.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")};Object.defineProperty(t,"__esModule",{value:!0}),t.windowToggle=void 0;var o=r(20020),i=r(27491),a=r(35416),l=r(52296),u=r(1266),s=r(16129),c=r(7394);t.windowToggle=function(e,t){return a.operate((function(r,a){var d=[],f=function(e){for(;0<d.length;)d.shift().error(e);a.error(e)};l.innerFrom(e).subscribe(u.createOperatorSubscriber(a,(function(e){var r=new o.Subject;d.push(r);var n,p=new i.Subscription;try{n=l.innerFrom(t(e))}catch(e){return void f(e)}a.next(r.asObservable()),p.add(n.subscribe(u.createOperatorSubscriber(a,(function(){c.arrRemove(d,r),r.complete(),p.unsubscribe()}),s.noop,f)))}),s.noop)),r.subscribe(u.createOperatorSubscriber(a,(function(e){var t,r,o=d.slice();try{for(var i=n(o),a=i.next();!a.done;a=i.next())a.value.next(e)}catch(e){t={error:e}}finally{try{a&&!a.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}}),(function(){for(;0<d.length;)d.shift().complete();a.complete()}),f,(function(){for(;0<d.length;)d.shift().unsubscribe()})))}))}},33016:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.windowWhen=void 0;var n=r(20020),o=r(35416),i=r(1266),a=r(52296);t.windowWhen=function(e){return o.operate((function(t,r){var o,l,u=function(e){o.error(e),r.error(e)},s=function(){var t;null==l||l.unsubscribe(),null==o||o.complete(),o=new n.Subject,r.next(o.asObservable());try{t=a.innerFrom(e())}catch(e){return void u(e)}t.subscribe(l=i.createOperatorSubscriber(r,s,s,u))};s(),t.subscribe(i.createOperatorSubscriber(r,(function(e){return o.next(e)}),(function(){o.complete(),r.complete()}),u,(function(){null==l||l.unsubscribe(),o=null})))}))}},99163:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.withLatestFrom=void 0;var i=r(35416),a=r(1266),l=r(52296),u=r(79391),s=r(16129),c=r(11824);t.withLatestFrom=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=c.popResultSelector(e);return i.operate((function(t,i){for(var c=e.length,d=new Array(c),f=e.map((function(){return!1})),p=!1,g=function(t){l.innerFrom(e[t]).subscribe(a.createOperatorSubscriber(i,(function(e){d[t]=e,p||f[t]||(f[t]=!0,(p=f.every(u.identity))&&(f=null))}),s.noop))},v=0;v<c;v++)g(v);t.subscribe(a.createOperatorSubscriber(i,(function(e){if(p){var t=o([e],n(d));i.next(r?r.apply(void 0,o([],n(t))):t)}})))}))}},32681:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.zip=void 0;var i=r(61763),a=r(35416);t.zip=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return a.operate((function(t,r){i.zip.apply(void 0,o([t],n(e))).subscribe(r)}))}},5606:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zipAll=void 0;var n=r(61763),o=r(10587);t.zipAll=function(e){return o.joinAllInternals(n.zip,e)}},50973:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.zipWith=void 0;var i=r(32681);t.zipWith=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return i.zip.apply(void 0,o([],n(e)))}},18762:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scheduleArray=void 0;var n=r(92023);t.scheduleArray=function(e,t){return new n.Observable((function(r){var n=0;return t.schedule((function(){n===e.length?r.complete():(r.next(e[n++]),r.closed||this.schedule())}))}))}},63741:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scheduleAsyncIterable=void 0;var n=r(92023),o=r(75031);t.scheduleAsyncIterable=function(e,t){if(!e)throw new Error("Iterable cannot be null");return new n.Observable((function(r){o.executeSchedule(r,t,(function(){var n=e[Symbol.asyncIterator]();o.executeSchedule(r,t,(function(){n.next().then((function(e){e.done?r.complete():r.next(e.value)}))}),0,!0)}))}))}},63585:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scheduleIterable=void 0;var n=r(92023),o=r(33967),i=r(44717),a=r(75031);t.scheduleIterable=function(e,t){return new n.Observable((function(r){var n;return a.executeSchedule(r,t,(function(){n=e[o.iterator](),a.executeSchedule(r,t,(function(){var e,t,o;try{t=(e=n.next()).value,o=e.done}catch(e){return void r.error(e)}o?r.complete():r.next(t)}),0,!0)})),function(){return i.isFunction(null==n?void 0:n.return)&&n.return()}}))}},14502:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scheduleObservable=void 0;var n=r(52296),o=r(82803),i=r(44027);t.scheduleObservable=function(e,t){return n.innerFrom(e).pipe(i.subscribeOn(t),o.observeOn(t))}},12366:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.schedulePromise=void 0;var n=r(52296),o=r(82803),i=r(44027);t.schedulePromise=function(e,t){return n.innerFrom(e).pipe(i.subscribeOn(t),o.observeOn(t))}},39136:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scheduleReadableStreamLike=void 0;var n=r(63741),o=r(43026);t.scheduleReadableStreamLike=function(e,t){return n.scheduleAsyncIterable(o.readableStreamLikeToAsyncGenerator(e),t)}},54463:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scheduled=void 0;var n=r(14502),o=r(12366),i=r(18762),a=r(63585),l=r(63741),u=r(31801),s=r(60452),c=r(65547),d=r(26847),f=r(69451),p=r(63533),g=r(43026),v=r(39136);t.scheduled=function(e,t){if(null!=e){if(u.isInteropObservable(e))return n.scheduleObservable(e,t);if(c.isArrayLike(e))return i.scheduleArray(e,t);if(s.isPromise(e))return o.schedulePromise(e,t);if(f.isAsyncIterable(e))return l.scheduleAsyncIterable(e,t);if(d.isIterable(e))return a.scheduleIterable(e,t);if(g.isReadableStreamLike(e))return v.scheduleReadableStreamLike(e,t)}throw p.createInvalidObservableTypeError(e)}},77638:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.Action=void 0;var i=function(e){function t(t,r){return e.call(this)||this}return o(t,e),t.prototype.schedule=function(e,t){return void 0===t&&(t=0),this},t}(r(27491).Subscription);t.Action=i},1080:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncAction=void 0;var i=r(77638),a=r(52320),l=r(7394),u=function(e){function t(t,r){var n=e.call(this,t,r)||this;return n.scheduler=t,n.work=r,n.pending=!1,n}return o(t,e),t.prototype.schedule=function(e,t){var r;if(void 0===t&&(t=0),this.closed)return this;this.state=e;var n=this.id,o=this.scheduler;return null!=n&&(this.id=this.recycleAsyncId(o,n,t)),this.pending=!0,this.delay=t,this.id=null!==(r=this.id)&&void 0!==r?r:this.requestAsyncId(o,this.id,t),this},t.prototype.requestAsyncId=function(e,t,r){return void 0===r&&(r=0),a.intervalProvider.setInterval(e.flush.bind(e,this),r)},t.prototype.recycleAsyncId=function(e,t,r){if(void 0===r&&(r=0),null!=r&&this.delay===r&&!1===this.pending)return t;null!=t&&a.intervalProvider.clearInterval(t)},t.prototype.execute=function(e,t){if(this.closed)return new Error("executing a cancelled action");this.pending=!1;var r=this._execute(e,t);if(r)return r;!1===this.pending&&null!=this.id&&(this.id=this.recycleAsyncId(this.scheduler,this.id,null))},t.prototype._execute=function(e,t){var r,n=!1;try{this.work(e)}catch(e){n=!0,r=e||new Error("Scheduled action threw falsy error")}if(n)return this.unsubscribe(),r},t.prototype.unsubscribe=function(){if(!this.closed){var t=this.id,r=this.scheduler,n=r.actions;this.work=this.state=this.scheduler=null,this.pending=!1,l.arrRemove(n,this),null!=t&&(this.id=this.recycleAsyncId(r,t,null)),this.delay=null,e.prototype.unsubscribe.call(this)}},t}(i.Action);t.AsyncAction=u},61017:function(e,t,r){"use strict";var n,o=this&&this.__extends||(n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)});Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncScheduler=void 0;var i=r(30469),a=function(e){function t(t,r){void 0===r&&(r=i.Scheduler.now);var n=e.call(this,t,r)||this;return n.actions=[],n._active=!1,n}return o(t,e),t.prototype.flush=function(e){var t=this.actions;if(this._active)t.push(e);else{var r;this._active=!0;do{if(r=e.execute(e.state,e.delay))break}while(e=t.shift());if(this._active=!1,r){for(;e=t.shift();)e.unsubscribe();throw r}}},t}(i.Scheduler);t.AsyncScheduler=a},4386:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.async=t.asyncScheduler=void 0;var n=r(1080),o=r(61017);t.asyncScheduler=new o.AsyncScheduler(n.AsyncAction),t.async=t.asyncScheduler},26956:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.dateTimestampProvider=void 0,t.dateTimestampProvider={now:function(){return(t.dateTimestampProvider.delegate||Date).now()},delegate:void 0}},52320:function(e,t){"use strict";var r=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},n=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.intervalProvider=void 0,t.intervalProvider={setInterval:function(e,o){for(var i=[],a=2;a<arguments.length;a++)i[a-2]=arguments[a];var l=t.intervalProvider.delegate;return(null==l?void 0:l.setInterval)?l.setInterval.apply(l,n([e,o],r(i))):setInterval.apply(void 0,n([e,o],r(i)))},clearInterval:function(e){var r=t.intervalProvider.delegate;return((null==r?void 0:r.clearInterval)||clearInterval)(e)},delegate:void 0}},56476:function(e,t){"use strict";var r=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},n=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.timeoutProvider=void 0,t.timeoutProvider={setTimeout:function(e,o){for(var i=[],a=2;a<arguments.length;a++)i[a-2]=arguments[a];var l=t.timeoutProvider.delegate;return(null==l?void 0:l.setTimeout)?l.setTimeout.apply(l,n([e,o],r(i))):setTimeout.apply(void 0,n([e,o],r(i)))},clearTimeout:function(e){var r=t.timeoutProvider.delegate;return((null==r?void 0:r.clearTimeout)||clearTimeout)(e)},delegate:void 0}},33967:(e,t)=>{"use strict";function r(){return"function"==typeof Symbol&&Symbol.iterator?Symbol.iterator:"@@iterator"}Object.defineProperty(t,"__esModule",{value:!0}),t.iterator=t.getSymbolIterator=void 0,t.getSymbolIterator=r,t.iterator=r()},84512:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observable=void 0,t.observable="function"==typeof Symbol&&Symbol.observable||"@@observable"},49148:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArgumentOutOfRangeError=void 0;var n=r(56871);t.ArgumentOutOfRangeError=n.createErrorClass((function(e){return function(){e(this),this.name="ArgumentOutOfRangeError",this.message="argument out of range"}}))},37676:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptyError=void 0;var n=r(56871);t.EmptyError=n.createErrorClass((function(e){return function(){e(this),this.name="EmptyError",this.message="no elements in sequence"}}))},2318:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotFoundError=void 0;var n=r(56871);t.NotFoundError=n.createErrorClass((function(e){return function(t){e(this),this.name="NotFoundError",this.message=t}}))},98083:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectUnsubscribedError=void 0;var n=r(56871);t.ObjectUnsubscribedError=n.createErrorClass((function(e){return function(){e(this),this.name="ObjectUnsubscribedError",this.message="object unsubscribed"}}))},18168:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SequenceError=void 0;var n=r(56871);t.SequenceError=n.createErrorClass((function(e){return function(t){e(this),this.name="SequenceError",this.message=t}}))},30665:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnsubscriptionError=void 0;var n=r(56871);t.UnsubscriptionError=n.createErrorClass((function(e){return function(t){e(this),this.message=t?t.length+" errors occurred during unsubscription:\n"+t.map((function(e,t){return t+1+") "+e.toString()})).join("\n  "):"",this.name="UnsubscriptionError",this.errors=t}}))},11824:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popNumber=t.popScheduler=t.popResultSelector=void 0;var n=r(44717),o=r(64568);function i(e){return e[e.length-1]}t.popResultSelector=function(e){return n.isFunction(i(e))?e.pop():void 0},t.popScheduler=function(e){return o.isScheduler(i(e))?e.pop():void 0},t.popNumber=function(e,t){return"number"==typeof i(e)?e.pop():t}},43787:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.argsArgArrayOrObject=void 0;var r=Array.isArray,n=Object.getPrototypeOf,o=Object.prototype,i=Object.keys;t.argsArgArrayOrObject=function(e){if(1===e.length){var t=e[0];if(r(t))return{args:t,keys:null};if((l=t)&&"object"==typeof l&&n(l)===o){var a=i(t);return{args:a.map((function(e){return t[e]})),keys:a}}}var l;return{args:e,keys:null}}},90160:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.argsOrArgArray=void 0;var r=Array.isArray;t.argsOrArgArray=function(e){return 1===e.length&&r(e[0])?e[0]:e}},7394:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arrRemove=void 0,t.arrRemove=function(e,t){if(e){var r=e.indexOf(t);0<=r&&e.splice(r,1)}}},56871:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorClass=void 0,t.createErrorClass=function(e){var t=e((function(e){Error.call(e),e.stack=(new Error).stack}));return t.prototype=Object.create(Error.prototype),t.prototype.constructor=t,t}},34950:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createObject=void 0,t.createObject=function(e,t){return e.reduce((function(e,r,n){return e[r]=t[n],e}),{})}},79916:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.captureError=t.errorContext=void 0;var n=r(87820),o=null;t.errorContext=function(e){if(n.config.useDeprecatedSynchronousErrorHandling){var t=!o;if(t&&(o={errorThrown:!1,error:null}),e(),t){var r=o,i=r.errorThrown,a=r.error;if(o=null,i)throw a}}else e()},t.captureError=function(e){n.config.useDeprecatedSynchronousErrorHandling&&o&&(o.errorThrown=!0,o.error=e)}},75031:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.executeSchedule=void 0,t.executeSchedule=function(e,t,r,n,o){void 0===n&&(n=0),void 0===o&&(o=!1);var i=t.schedule((function(){r(),o?e.add(this.schedule(null,n)):this.unsubscribe()}),n);if(e.add(i),!o)return i}},79391:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.identity=void 0,t.identity=function(e){return e}},65547:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isArrayLike=void 0,t.isArrayLike=function(e){return e&&"number"==typeof e.length&&"function"!=typeof e}},69451:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAsyncIterable=void 0;var n=r(44717);t.isAsyncIterable=function(e){return Symbol.asyncIterator&&n.isFunction(null==e?void 0:e[Symbol.asyncIterator])}},96349:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidDate=void 0,t.isValidDate=function(e){return e instanceof Date&&!isNaN(e)}},44717:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isFunction=void 0,t.isFunction=function(e){return"function"==typeof e}},31801:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isInteropObservable=void 0;var n=r(84512),o=r(44717);t.isInteropObservable=function(e){return o.isFunction(e[n.observable])}},26847:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isIterable=void 0;var n=r(33967),o=r(44717);t.isIterable=function(e){return o.isFunction(null==e?void 0:e[n.iterator])}},60452:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPromise=void 0;var n=r(44717);t.isPromise=function(e){return n.isFunction(null==e?void 0:e.then)}},43026:function(e,t,r){"use strict";var n=this&&this.__generator||function(e,t){var r,n,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function l(i){return function(l){return function(i){if(r)throw new TypeError("Generator is already executing.");for(;a;)try{if(r=1,n&&(o=2&i[0]?n.return:i[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,i[1])).done)return o;switch(n=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,n=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!((o=(o=a.trys).length>0&&o[o.length-1])||6!==i[0]&&2!==i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],n=0}finally{r=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,l])}}},o=this&&this.__await||function(e){return this instanceof o?(this.v=e,this):new o(e)},i=this&&this.__asyncGenerator||function(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n,i=r.apply(e,t||[]),a=[];return n={},l("next"),l("throw"),l("return"),n[Symbol.asyncIterator]=function(){return this},n;function l(e){i[e]&&(n[e]=function(t){return new Promise((function(r,n){a.push([e,t,r,n])>1||u(e,t)}))})}function u(e,t){try{(r=i[e](t)).value instanceof o?Promise.resolve(r.value.v).then(s,c):d(a[0][2],r)}catch(e){d(a[0][3],e)}var r}function s(e){u("next",e)}function c(e){u("throw",e)}function d(e,t){e(t),a.shift(),a.length&&u(a[0][0],a[0][1])}};Object.defineProperty(t,"__esModule",{value:!0}),t.isReadableStreamLike=t.readableStreamLikeToAsyncGenerator=void 0;var a=r(44717);t.readableStreamLikeToAsyncGenerator=function(e){return i(this,arguments,(function(){var t,r,i;return n(this,(function(n){switch(n.label){case 0:t=e.getReader(),n.label=1;case 1:n.trys.push([1,,9,10]),n.label=2;case 2:return[4,o(t.read())];case 3:return r=n.sent(),i=r.value,r.done?[4,o(void 0)]:[3,5];case 4:return[2,n.sent()];case 5:return[4,o(i)];case 6:return[4,n.sent()];case 7:return n.sent(),[3,2];case 8:return[3,10];case 9:return t.releaseLock(),[7];case 10:return[2]}}))}))},t.isReadableStreamLike=function(e){return a.isFunction(null==e?void 0:e.getReader)}},64568:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isScheduler=void 0;var n=r(44717);t.isScheduler=function(e){return e&&n.isFunction(e.schedule)}},35416:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.operate=t.hasLift=void 0;var n=r(44717);function o(e){return n.isFunction(null==e?void 0:e.lift)}t.hasLift=o,t.operate=function(e){return function(t){if(o(t))return t.lift((function(t){try{return e(t,this)}catch(e){this.error(e)}}));throw new TypeError("Unable to lift unknown Observable type")}}},88240:function(e,t,r){"use strict";var n=this&&this.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},o=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};Object.defineProperty(t,"__esModule",{value:!0}),t.mapOneOrManyArgs=void 0;var i=r(74828),a=Array.isArray;t.mapOneOrManyArgs=function(e){return i.map((function(t){return function(e,t){return a(t)?e.apply(void 0,o([],n(t))):e(t)}(e,t)}))}},16129:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.noop=void 0,t.noop=function(){}},31276:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.not=void 0,t.not=function(e,t){return function(r,n){return!e.call(t,r,n)}}},72393:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.pipeFromArray=t.pipe=void 0;var n=r(79391);function o(e){return 0===e.length?n.identity:1===e.length?e[0]:function(t){return e.reduce((function(e,t){return t(e)}),t)}}t.pipe=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return o(e)},t.pipeFromArray=o},34696:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.reportUnhandledError=void 0;var n=r(87820),o=r(56476);t.reportUnhandledError=function(e){o.timeoutProvider.setTimeout((function(){var t=n.config.onUnhandledError;if(!t)throw e;t(e)}))}},63533:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createInvalidObservableTypeError=void 0,t.createInvalidObservableTypeError=function(e){return new TypeError("You provided "+(null!==e&&"object"==typeof e?"an invalid object":"'"+e+"'")+" where a stream was expected. You can provide an Observable, Promise, ReadableStream, Array, AsyncIterable, or Iterable.")}},46022:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mergeAll=t.merge=t.max=t.materialize=t.mapTo=t.map=t.last=t.isEmpty=t.ignoreElements=t.groupBy=t.first=t.findIndex=t.find=t.finalize=t.filter=t.expand=t.exhaustMap=t.exhaustAll=t.exhaust=t.every=t.endWith=t.elementAt=t.distinctUntilKeyChanged=t.distinctUntilChanged=t.distinct=t.dematerialize=t.delayWhen=t.delay=t.defaultIfEmpty=t.debounceTime=t.debounce=t.count=t.connect=t.concatWith=t.concatMapTo=t.concatMap=t.concatAll=t.concat=t.combineLatestWith=t.combineLatest=t.combineLatestAll=t.combineAll=t.catchError=t.bufferWhen=t.bufferToggle=t.bufferTime=t.bufferCount=t.buffer=t.auditTime=t.audit=void 0,t.timeInterval=t.throwIfEmpty=t.throttleTime=t.throttle=t.tap=t.takeWhile=t.takeUntil=t.takeLast=t.take=t.switchScan=t.switchMapTo=t.switchMap=t.switchAll=t.subscribeOn=t.startWith=t.skipWhile=t.skipUntil=t.skipLast=t.skip=t.single=t.shareReplay=t.share=t.sequenceEqual=t.scan=t.sampleTime=t.sample=t.refCount=t.retryWhen=t.retry=t.repeatWhen=t.repeat=t.reduce=t.raceWith=t.race=t.publishReplay=t.publishLast=t.publishBehavior=t.publish=t.pluck=t.partition=t.pairwise=t.onErrorResumeNext=t.observeOn=t.multicast=t.min=t.mergeWith=t.mergeScan=t.mergeMapTo=t.mergeMap=t.flatMap=void 0,t.zipWith=t.zipAll=t.zip=t.withLatestFrom=t.windowWhen=t.windowToggle=t.windowTime=t.windowCount=t.window=t.toArray=t.timestamp=t.timeoutWith=t.timeout=void 0;var n=r(66993);Object.defineProperty(t,"audit",{enumerable:!0,get:function(){return n.audit}});var o=r(54116);Object.defineProperty(t,"auditTime",{enumerable:!0,get:function(){return o.auditTime}});var i=r(47190);Object.defineProperty(t,"buffer",{enumerable:!0,get:function(){return i.buffer}});var a=r(76835);Object.defineProperty(t,"bufferCount",{enumerable:!0,get:function(){return a.bufferCount}});var l=r(25219);Object.defineProperty(t,"bufferTime",{enumerable:!0,get:function(){return l.bufferTime}});var u=r(80118);Object.defineProperty(t,"bufferToggle",{enumerable:!0,get:function(){return u.bufferToggle}});var s=r(27514);Object.defineProperty(t,"bufferWhen",{enumerable:!0,get:function(){return s.bufferWhen}});var c=r(58251);Object.defineProperty(t,"catchError",{enumerable:!0,get:function(){return c.catchError}});var d=r(21424);Object.defineProperty(t,"combineAll",{enumerable:!0,get:function(){return d.combineAll}});var f=r(42945);Object.defineProperty(t,"combineLatestAll",{enumerable:!0,get:function(){return f.combineLatestAll}});var p=r(52e3);Object.defineProperty(t,"combineLatest",{enumerable:!0,get:function(){return p.combineLatest}});var g=r(93928);Object.defineProperty(t,"combineLatestWith",{enumerable:!0,get:function(){return g.combineLatestWith}});var v=r(1812);Object.defineProperty(t,"concat",{enumerable:!0,get:function(){return v.concat}});var h=r(80861);Object.defineProperty(t,"concatAll",{enumerable:!0,get:function(){return h.concatAll}});var m=r(71012);Object.defineProperty(t,"concatMap",{enumerable:!0,get:function(){return m.concatMap}});var y=r(61157);Object.defineProperty(t,"concatMapTo",{enumerable:!0,get:function(){return y.concatMapTo}});var b=r(33692);Object.defineProperty(t,"concatWith",{enumerable:!0,get:function(){return b.concatWith}});var E=r(32216);Object.defineProperty(t,"connect",{enumerable:!0,get:function(){return E.connect}});var O=r(18041);Object.defineProperty(t,"count",{enumerable:!0,get:function(){return O.count}});var S=r(72747);Object.defineProperty(t,"debounce",{enumerable:!0,get:function(){return S.debounce}});var _=r(33870);Object.defineProperty(t,"debounceTime",{enumerable:!0,get:function(){return _.debounceTime}});var w=r(87507);Object.defineProperty(t,"defaultIfEmpty",{enumerable:!0,get:function(){return w.defaultIfEmpty}});var T=r(62409);Object.defineProperty(t,"delay",{enumerable:!0,get:function(){return T.delay}});var P=r(85137);Object.defineProperty(t,"delayWhen",{enumerable:!0,get:function(){return P.delayWhen}});var C=r(84126);Object.defineProperty(t,"dematerialize",{enumerable:!0,get:function(){return C.dematerialize}});var I=r(15208);Object.defineProperty(t,"distinct",{enumerable:!0,get:function(){return I.distinct}});var A=r(29939);Object.defineProperty(t,"distinctUntilChanged",{enumerable:!0,get:function(){return A.distinctUntilChanged}});var R=r(10183);Object.defineProperty(t,"distinctUntilKeyChanged",{enumerable:!0,get:function(){return R.distinctUntilKeyChanged}});var x=r(61195);Object.defineProperty(t,"elementAt",{enumerable:!0,get:function(){return x.elementAt}});var N=r(93723);Object.defineProperty(t,"endWith",{enumerable:!0,get:function(){return N.endWith}});var D=r(61909);Object.defineProperty(t,"every",{enumerable:!0,get:function(){return D.every}});var L=r(79228);Object.defineProperty(t,"exhaust",{enumerable:!0,get:function(){return L.exhaust}});var j=r(79765);Object.defineProperty(t,"exhaustAll",{enumerable:!0,get:function(){return j.exhaustAll}});var M=r(8748);Object.defineProperty(t,"exhaustMap",{enumerable:!0,get:function(){return M.exhaustMap}});var k=r(68324);Object.defineProperty(t,"expand",{enumerable:!0,get:function(){return k.expand}});var F=r(72914);Object.defineProperty(t,"filter",{enumerable:!0,get:function(){return F.filter}});var q=r(89822);Object.defineProperty(t,"finalize",{enumerable:!0,get:function(){return q.finalize}});var V=r(52819);Object.defineProperty(t,"find",{enumerable:!0,get:function(){return V.find}});var B=r(3367);Object.defineProperty(t,"findIndex",{enumerable:!0,get:function(){return B.findIndex}});var U=r(41432);Object.defineProperty(t,"first",{enumerable:!0,get:function(){return U.first}});var W=r(34956);Object.defineProperty(t,"groupBy",{enumerable:!0,get:function(){return W.groupBy}});var G=r(52507);Object.defineProperty(t,"ignoreElements",{enumerable:!0,get:function(){return G.ignoreElements}});var H=r(66095);Object.defineProperty(t,"isEmpty",{enumerable:!0,get:function(){return H.isEmpty}});var K=r(33484);Object.defineProperty(t,"last",{enumerable:!0,get:function(){return K.last}});var $=r(74828);Object.defineProperty(t,"map",{enumerable:!0,get:function(){return $.map}});var z=r(31357);Object.defineProperty(t,"mapTo",{enumerable:!0,get:function(){return z.mapTo}});var Y=r(37967);Object.defineProperty(t,"materialize",{enumerable:!0,get:function(){return Y.materialize}});var Q=r(94388);Object.defineProperty(t,"max",{enumerable:!0,get:function(){return Q.max}});var X=r(61550);Object.defineProperty(t,"merge",{enumerable:!0,get:function(){return X.merge}});var J=r(1867);Object.defineProperty(t,"mergeAll",{enumerable:!0,get:function(){return J.mergeAll}});var Z=r(26977);Object.defineProperty(t,"flatMap",{enumerable:!0,get:function(){return Z.flatMap}});var ee=r(11282);Object.defineProperty(t,"mergeMap",{enumerable:!0,get:function(){return ee.mergeMap}});var te=r(86295);Object.defineProperty(t,"mergeMapTo",{enumerable:!0,get:function(){return te.mergeMapTo}});var re=r(9527);Object.defineProperty(t,"mergeScan",{enumerable:!0,get:function(){return re.mergeScan}});var ne=r(25834);Object.defineProperty(t,"mergeWith",{enumerable:!0,get:function(){return ne.mergeWith}});var oe=r(61306);Object.defineProperty(t,"min",{enumerable:!0,get:function(){return oe.min}});var ie=r(59924);Object.defineProperty(t,"multicast",{enumerable:!0,get:function(){return ie.multicast}});var ae=r(82803);Object.defineProperty(t,"observeOn",{enumerable:!0,get:function(){return ae.observeOn}});var le=r(21997);Object.defineProperty(t,"onErrorResumeNext",{enumerable:!0,get:function(){return le.onErrorResumeNext}});var ue=r(74492);Object.defineProperty(t,"pairwise",{enumerable:!0,get:function(){return ue.pairwise}});var se=r(35352);Object.defineProperty(t,"partition",{enumerable:!0,get:function(){return se.partition}});var ce=r(43391);Object.defineProperty(t,"pluck",{enumerable:!0,get:function(){return ce.pluck}});var de=r(20297);Object.defineProperty(t,"publish",{enumerable:!0,get:function(){return de.publish}});var fe=r(46383);Object.defineProperty(t,"publishBehavior",{enumerable:!0,get:function(){return fe.publishBehavior}});var pe=r(58229);Object.defineProperty(t,"publishLast",{enumerable:!0,get:function(){return pe.publishLast}});var ge=r(28226);Object.defineProperty(t,"publishReplay",{enumerable:!0,get:function(){return ge.publishReplay}});var ve=r(78973);Object.defineProperty(t,"race",{enumerable:!0,get:function(){return ve.race}});var he=r(177);Object.defineProperty(t,"raceWith",{enumerable:!0,get:function(){return he.raceWith}});var me=r(3818);Object.defineProperty(t,"reduce",{enumerable:!0,get:function(){return me.reduce}});var ye=r(7775);Object.defineProperty(t,"repeat",{enumerable:!0,get:function(){return ye.repeat}});var be=r(25567);Object.defineProperty(t,"repeatWhen",{enumerable:!0,get:function(){return be.repeatWhen}});var Ee=r(14740);Object.defineProperty(t,"retry",{enumerable:!0,get:function(){return Ee.retry}});var Oe=r(40264);Object.defineProperty(t,"retryWhen",{enumerable:!0,get:function(){return Oe.retryWhen}});var Se=r(85884);Object.defineProperty(t,"refCount",{enumerable:!0,get:function(){return Se.refCount}});var _e=r(86870);Object.defineProperty(t,"sample",{enumerable:!0,get:function(){return _e.sample}});var we=r(85411);Object.defineProperty(t,"sampleTime",{enumerable:!0,get:function(){return we.sampleTime}});var Te=r(82457);Object.defineProperty(t,"scan",{enumerable:!0,get:function(){return Te.scan}});var Pe=r(55109);Object.defineProperty(t,"sequenceEqual",{enumerable:!0,get:function(){return Pe.sequenceEqual}});var Ce=r(83329);Object.defineProperty(t,"share",{enumerable:!0,get:function(){return Ce.share}});var Ie=r(11738);Object.defineProperty(t,"shareReplay",{enumerable:!0,get:function(){return Ie.shareReplay}});var Ae=r(70884);Object.defineProperty(t,"single",{enumerable:!0,get:function(){return Ae.single}});var Re=r(14411);Object.defineProperty(t,"skip",{enumerable:!0,get:function(){return Re.skip}});var xe=r(19355);Object.defineProperty(t,"skipLast",{enumerable:!0,get:function(){return xe.skipLast}});var Ne=r(82947);Object.defineProperty(t,"skipUntil",{enumerable:!0,get:function(){return Ne.skipUntil}});var De=r(29842);Object.defineProperty(t,"skipWhile",{enumerable:!0,get:function(){return De.skipWhile}});var Le=r(62778);Object.defineProperty(t,"startWith",{enumerable:!0,get:function(){return Le.startWith}});var je=r(44027);Object.defineProperty(t,"subscribeOn",{enumerable:!0,get:function(){return je.subscribeOn}});var Me=r(89061);Object.defineProperty(t,"switchAll",{enumerable:!0,get:function(){return Me.switchAll}});var ke=r(6300);Object.defineProperty(t,"switchMap",{enumerable:!0,get:function(){return ke.switchMap}});var Fe=r(61933);Object.defineProperty(t,"switchMapTo",{enumerable:!0,get:function(){return Fe.switchMapTo}});var qe=r(51689);Object.defineProperty(t,"switchScan",{enumerable:!0,get:function(){return qe.switchScan}});var Ve=r(46803);Object.defineProperty(t,"take",{enumerable:!0,get:function(){return Ve.take}});var Be=r(20787);Object.defineProperty(t,"takeLast",{enumerable:!0,get:function(){return Be.takeLast}});var Ue=r(24811);Object.defineProperty(t,"takeUntil",{enumerable:!0,get:function(){return Ue.takeUntil}});var We=r(47770);Object.defineProperty(t,"takeWhile",{enumerable:!0,get:function(){return We.takeWhile}});var Ge=r(79967);Object.defineProperty(t,"tap",{enumerable:!0,get:function(){return Ge.tap}});var He=r(16516);Object.defineProperty(t,"throttle",{enumerable:!0,get:function(){return He.throttle}});var Ke=r(75945);Object.defineProperty(t,"throttleTime",{enumerable:!0,get:function(){return Ke.throttleTime}});var $e=r(45956);Object.defineProperty(t,"throwIfEmpty",{enumerable:!0,get:function(){return $e.throwIfEmpty}});var ze=r(99712);Object.defineProperty(t,"timeInterval",{enumerable:!0,get:function(){return ze.timeInterval}});var Ye=r(87517);Object.defineProperty(t,"timeout",{enumerable:!0,get:function(){return Ye.timeout}});var Qe=r(62001);Object.defineProperty(t,"timeoutWith",{enumerable:!0,get:function(){return Qe.timeoutWith}});var Xe=r(68158);Object.defineProperty(t,"timestamp",{enumerable:!0,get:function(){return Xe.timestamp}});var Je=r(22984);Object.defineProperty(t,"toArray",{enumerable:!0,get:function(){return Je.toArray}});var Ze=r(75492);Object.defineProperty(t,"window",{enumerable:!0,get:function(){return Ze.window}});var et=r(56817);Object.defineProperty(t,"windowCount",{enumerable:!0,get:function(){return et.windowCount}});var tt=r(96841);Object.defineProperty(t,"windowTime",{enumerable:!0,get:function(){return tt.windowTime}});var rt=r(4880);Object.defineProperty(t,"windowToggle",{enumerable:!0,get:function(){return rt.windowToggle}});var nt=r(33016);Object.defineProperty(t,"windowWhen",{enumerable:!0,get:function(){return nt.windowWhen}});var ot=r(99163);Object.defineProperty(t,"withLatestFrom",{enumerable:!0,get:function(){return ot.withLatestFrom}});var it=r(32681);Object.defineProperty(t,"zip",{enumerable:!0,get:function(){return it.zip}});var at=r(5606);Object.defineProperty(t,"zipAll",{enumerable:!0,get:function(){return at.zipAll}});var lt=r(50973);Object.defineProperty(t,"zipWith",{enumerable:!0,get:function(){return lt.zipWith}})},6776:e=>{!function(){"use strict";var t="undefined"!=typeof window&&void 0!==window.document?window.document:{},r=e.exports,n=function(){for(var e,r=[["requestFullscreen","exitFullscreen","fullscreenElement","fullscreenEnabled","fullscreenchange","fullscreenerror"],["webkitRequestFullscreen","webkitExitFullscreen","webkitFullscreenElement","webkitFullscreenEnabled","webkitfullscreenchange","webkitfullscreenerror"],["webkitRequestFullScreen","webkitCancelFullScreen","webkitCurrentFullScreenElement","webkitCancelFullScreen","webkitfullscreenchange","webkitfullscreenerror"],["mozRequestFullScreen","mozCancelFullScreen","mozFullScreenElement","mozFullScreenEnabled","mozfullscreenchange","mozfullscreenerror"],["msRequestFullscreen","msExitFullscreen","msFullscreenElement","msFullscreenEnabled","MSFullscreenChange","MSFullscreenError"]],n=0,o=r.length,i={};n<o;n++)if((e=r[n])&&e[1]in t){for(n=0;n<e.length;n++)i[r[0][n]]=e[n];return i}return!1}(),o={change:n.fullscreenchange,error:n.fullscreenerror},i={request:function(e,r){return new Promise(function(o,i){var a=function(){this.off("change",a),o()}.bind(this);this.on("change",a);var l=(e=e||t.documentElement)[n.requestFullscreen](r);l instanceof Promise&&l.then(a).catch(i)}.bind(this))},exit:function(){return new Promise(function(e,r){if(this.isFullscreen){var o=function(){this.off("change",o),e()}.bind(this);this.on("change",o);var i=t[n.exitFullscreen]();i instanceof Promise&&i.then(o).catch(r)}else e()}.bind(this))},toggle:function(e,t){return this.isFullscreen?this.exit():this.request(e,t)},onchange:function(e){this.on("change",e)},onerror:function(e){this.on("error",e)},on:function(e,r){var n=o[e];n&&t.addEventListener(n,r,!1)},off:function(e,r){var n=o[e];n&&t.removeEventListener(n,r,!1)},raw:n};n?(Object.defineProperties(i,{isFullscreen:{get:function(){return Boolean(t[n.fullscreenElement])}},element:{enumerable:!0,get:function(){return t[n.fullscreenElement]}},isEnabled:{enumerable:!0,get:function(){return Boolean(t[n.fullscreenEnabled])}}}),r?e.exports=i:window.screenfull=i):r?e.exports={isEnabled:!1}:window.screenfull={isEnabled:!1}}()},79524:(e,t,r)=>{const n=Symbol("SemVer ANY");class o{static get ANY(){return n}constructor(e,t){if(t=i(t),e instanceof o){if(e.loose===!!t.loose)return e;e=e.value}e=e.trim().split(/\s+/).join(" "),s("comparator",e,t),this.options=t,this.loose=!!t.loose,this.parse(e),this.semver===n?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}parse(e){const t=this.options.loose?a[l.COMPARATORLOOSE]:a[l.COMPARATOR],r=e.match(t);if(!r)throw new TypeError(`Invalid comparator: ${e}`);this.operator=void 0!==r[1]?r[1]:"","="===this.operator&&(this.operator=""),r[2]?this.semver=new c(r[2],this.options.loose):this.semver=n}toString(){return this.value}test(e){if(s("Comparator.test",e,this.options.loose),this.semver===n||e===n)return!0;if("string"==typeof e)try{e=new c(e,this.options)}catch(e){return!1}return u(e,this.operator,this.semver,this.options)}intersects(e,t){if(!(e instanceof o))throw new TypeError("a Comparator is required");return""===this.operator?""===this.value||new d(e.value,t).test(this.value):""===e.operator?""===e.value||new d(this.value,t).test(e.semver):!((t=i(t)).includePrerelease&&("<0.0.0-0"===this.value||"<0.0.0-0"===e.value)||!t.includePrerelease&&(this.value.startsWith("<0.0.0")||e.value.startsWith("<0.0.0"))||(!this.operator.startsWith(">")||!e.operator.startsWith(">"))&&(!this.operator.startsWith("<")||!e.operator.startsWith("<"))&&(this.semver.version!==e.semver.version||!this.operator.includes("=")||!e.operator.includes("="))&&!(u(this.semver,"<",e.semver,t)&&this.operator.startsWith(">")&&e.operator.startsWith("<"))&&!(u(this.semver,">",e.semver,t)&&this.operator.startsWith("<")&&e.operator.startsWith(">")))}}e.exports=o;const i=r(57095),{safeRe:a,t:l}=r(86850),u=r(23811),s=r(79796),c=r(37944),d=r(68395)},68395:(e,t,r)=>{class n{constructor(e,t){if(t=i(t),e instanceof n)return e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease?e:new n(e.raw,t);if(e instanceof a)return this.raw=e.value,this.set=[[e]],this.format(),this;if(this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease,this.raw=e.trim().split(/\s+/).join(" "),this.set=this.raw.split("||").map((e=>this.parseRange(e.trim()))).filter((e=>e.length)),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){const e=this.set[0];if(this.set=this.set.filter((e=>!h(e[0]))),0===this.set.length)this.set=[e];else if(this.set.length>1)for(const e of this.set)if(1===e.length&&m(e[0])){this.set=[e];break}}this.format()}format(){return this.range=this.set.map((e=>e.join(" ").trim())).join("||").trim(),this.range}toString(){return this.range}parseRange(e){const t=((this.options.includePrerelease&&g)|(this.options.loose&&v))+":"+e,r=o.get(t);if(r)return r;const n=this.options.loose,i=n?s[c.HYPHENRANGELOOSE]:s[c.HYPHENRANGE];e=e.replace(i,A(this.options.includePrerelease)),l("hyphen replace",e),e=e.replace(s[c.COMPARATORTRIM],d),l("comparator trim",e),e=e.replace(s[c.TILDETRIM],f),l("tilde trim",e),e=e.replace(s[c.CARETTRIM],p),l("caret trim",e);let u=e.split(" ").map((e=>b(e,this.options))).join(" ").split(/\s+/).map((e=>I(e,this.options)));n&&(u=u.filter((e=>(l("loose invalid filter",e,this.options),!!e.match(s[c.COMPARATORLOOSE]))))),l("range list",u);const m=new Map,y=u.map((e=>new a(e,this.options)));for(const e of y){if(h(e))return[e];m.set(e.value,e)}m.size>1&&m.has("")&&m.delete("");const E=[...m.values()];return o.set(t,E),E}intersects(e,t){if(!(e instanceof n))throw new TypeError("a Range is required");return this.set.some((r=>y(r,t)&&e.set.some((e=>y(e,t)&&r.every((r=>e.every((e=>r.intersects(e,t)))))))))}test(e){if(!e)return!1;if("string"==typeof e)try{e=new u(e,this.options)}catch(e){return!1}for(let t=0;t<this.set.length;t++)if(R(this.set[t],e,this.options))return!0;return!1}}e.exports=n;const o=new(r(95689))({max:1e3}),i=r(57095),a=r(79524),l=r(79796),u=r(37944),{safeRe:s,t:c,comparatorTrimReplace:d,tildeTrimReplace:f,caretTrimReplace:p}=r(86850),{FLAG_INCLUDE_PRERELEASE:g,FLAG_LOOSE:v}=r(59630),h=e=>"<0.0.0-0"===e.value,m=e=>""===e.value,y=(e,t)=>{let r=!0;const n=e.slice();let o=n.pop();for(;r&&n.length;)r=n.every((e=>o.intersects(e,t))),o=n.pop();return r},b=(e,t)=>(l("comp",e,t),e=_(e,t),l("caret",e),e=O(e,t),l("tildes",e),e=T(e,t),l("xrange",e),e=C(e,t),l("stars",e),e),E=e=>!e||"x"===e.toLowerCase()||"*"===e,O=(e,t)=>e.trim().split(/\s+/).map((e=>S(e,t))).join(" "),S=(e,t)=>{const r=t.loose?s[c.TILDELOOSE]:s[c.TILDE];return e.replace(r,((t,r,n,o,i)=>{let a;return l("tilde",e,t,r,n,o,i),E(r)?a="":E(n)?a=`>=${r}.0.0 <${+r+1}.0.0-0`:E(o)?a=`>=${r}.${n}.0 <${r}.${+n+1}.0-0`:i?(l("replaceTilde pr",i),a=`>=${r}.${n}.${o}-${i} <${r}.${+n+1}.0-0`):a=`>=${r}.${n}.${o} <${r}.${+n+1}.0-0`,l("tilde return",a),a}))},_=(e,t)=>e.trim().split(/\s+/).map((e=>w(e,t))).join(" "),w=(e,t)=>{l("caret",e,t);const r=t.loose?s[c.CARETLOOSE]:s[c.CARET],n=t.includePrerelease?"-0":"";return e.replace(r,((t,r,o,i,a)=>{let u;return l("caret",e,t,r,o,i,a),E(r)?u="":E(o)?u=`>=${r}.0.0${n} <${+r+1}.0.0-0`:E(i)?u="0"===r?`>=${r}.${o}.0${n} <${r}.${+o+1}.0-0`:`>=${r}.${o}.0${n} <${+r+1}.0.0-0`:a?(l("replaceCaret pr",a),u="0"===r?"0"===o?`>=${r}.${o}.${i}-${a} <${r}.${o}.${+i+1}-0`:`>=${r}.${o}.${i}-${a} <${r}.${+o+1}.0-0`:`>=${r}.${o}.${i}-${a} <${+r+1}.0.0-0`):(l("no pr"),u="0"===r?"0"===o?`>=${r}.${o}.${i}${n} <${r}.${o}.${+i+1}-0`:`>=${r}.${o}.${i}${n} <${r}.${+o+1}.0-0`:`>=${r}.${o}.${i} <${+r+1}.0.0-0`),l("caret return",u),u}))},T=(e,t)=>(l("replaceXRanges",e,t),e.split(/\s+/).map((e=>P(e,t))).join(" ")),P=(e,t)=>{e=e.trim();const r=t.loose?s[c.XRANGELOOSE]:s[c.XRANGE];return e.replace(r,((r,n,o,i,a,u)=>{l("xRange",e,r,n,o,i,a,u);const s=E(o),c=s||E(i),d=c||E(a),f=d;return"="===n&&f&&(n=""),u=t.includePrerelease?"-0":"",s?r=">"===n||"<"===n?"<0.0.0-0":"*":n&&f?(c&&(i=0),a=0,">"===n?(n=">=",c?(o=+o+1,i=0,a=0):(i=+i+1,a=0)):"<="===n&&(n="<",c?o=+o+1:i=+i+1),"<"===n&&(u="-0"),r=`${n+o}.${i}.${a}${u}`):c?r=`>=${o}.0.0${u} <${+o+1}.0.0-0`:d&&(r=`>=${o}.${i}.0${u} <${o}.${+i+1}.0-0`),l("xRange return",r),r}))},C=(e,t)=>(l("replaceStars",e,t),e.trim().replace(s[c.STAR],"")),I=(e,t)=>(l("replaceGTE0",e,t),e.trim().replace(s[t.includePrerelease?c.GTE0PRE:c.GTE0],"")),A=e=>(t,r,n,o,i,a,l,u,s,c,d,f,p)=>`${r=E(n)?"":E(o)?`>=${n}.0.0${e?"-0":""}`:E(i)?`>=${n}.${o}.0${e?"-0":""}`:a?`>=${r}`:`>=${r}${e?"-0":""}`} ${u=E(s)?"":E(c)?`<${+s+1}.0.0-0`:E(d)?`<${s}.${+c+1}.0-0`:f?`<=${s}.${c}.${d}-${f}`:e?`<${s}.${c}.${+d+1}-0`:`<=${u}`}`.trim(),R=(e,t,r)=>{for(let r=0;r<e.length;r++)if(!e[r].test(t))return!1;if(t.prerelease.length&&!r.includePrerelease){for(let r=0;r<e.length;r++)if(l(e[r].semver),e[r].semver!==a.ANY&&e[r].semver.prerelease.length>0){const n=e[r].semver;if(n.major===t.major&&n.minor===t.minor&&n.patch===t.patch)return!0}return!1}return!0}},37944:(e,t,r)=>{const n=r(79796),{MAX_LENGTH:o,MAX_SAFE_INTEGER:i}=r(59630),{safeRe:a,t:l}=r(86850),u=r(57095),{compareIdentifiers:s}=r(14031);class c{constructor(e,t){if(t=u(t),e instanceof c){if(e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease)return e;e=e.version}else if("string"!=typeof e)throw new TypeError(`Invalid version. Must be a string. Got type "${typeof e}".`);if(e.length>o)throw new TypeError(`version is longer than ${o} characters`);n("SemVer",e,t),this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease;const r=e.trim().match(t.loose?a[l.LOOSE]:a[l.FULL]);if(!r)throw new TypeError(`Invalid Version: ${e}`);if(this.raw=e,this.major=+r[1],this.minor=+r[2],this.patch=+r[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");r[4]?this.prerelease=r[4].split(".").map((e=>{if(/^[0-9]+$/.test(e)){const t=+e;if(t>=0&&t<i)return t}return e})):this.prerelease=[],this.build=r[5]?r[5].split("."):[],this.format()}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(e){if(n("SemVer.compare",this.version,this.options,e),!(e instanceof c)){if("string"==typeof e&&e===this.version)return 0;e=new c(e,this.options)}return e.version===this.version?0:this.compareMain(e)||this.comparePre(e)}compareMain(e){return e instanceof c||(e=new c(e,this.options)),s(this.major,e.major)||s(this.minor,e.minor)||s(this.patch,e.patch)}comparePre(e){if(e instanceof c||(e=new c(e,this.options)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;let t=0;do{const r=this.prerelease[t],o=e.prerelease[t];if(n("prerelease compare",t,r,o),void 0===r&&void 0===o)return 0;if(void 0===o)return 1;if(void 0===r)return-1;if(r!==o)return s(r,o)}while(++t)}compareBuild(e){e instanceof c||(e=new c(e,this.options));let t=0;do{const r=this.build[t],o=e.build[t];if(n("prerelease compare",t,r,o),void 0===r&&void 0===o)return 0;if(void 0===o)return 1;if(void 0===r)return-1;if(r!==o)return s(r,o)}while(++t)}inc(e,t,r){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t,r);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t,r);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t,r),this.inc("pre",t,r);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t,r),this.inc("pre",t,r);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":{const e=Number(r)?1:0;if(!t&&!1===r)throw new Error("invalid increment argument: identifier is empty");if(0===this.prerelease.length)this.prerelease=[e];else{let n=this.prerelease.length;for(;--n>=0;)"number"==typeof this.prerelease[n]&&(this.prerelease[n]++,n=-2);if(-1===n){if(t===this.prerelease.join(".")&&!1===r)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(e)}}if(t){let n=[t,e];!1===r&&(n=[t]),0===s(this.prerelease[0],t)?isNaN(this.prerelease[1])&&(this.prerelease=n):this.prerelease=n}break}default:throw new Error(`invalid increment argument: ${e}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}}e.exports=c},37994:(e,t,r)=>{const n=r(15860);e.exports=(e,t)=>{const r=n(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null}},23811:(e,t,r)=>{const n=r(36909),o=r(97659),i=r(60144),a=r(82077),l=r(30599),u=r(17092);e.exports=(e,t,r,s)=>{switch(t){case"===":return"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),e===r;case"!==":return"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),e!==r;case"":case"=":case"==":return n(e,r,s);case"!=":return o(e,r,s);case">":return i(e,r,s);case">=":return a(e,r,s);case"<":return l(e,r,s);case"<=":return u(e,r,s);default:throw new TypeError(`Invalid operator: ${t}`)}}},45334:(e,t,r)=>{const n=r(37944),o=r(15860),{safeRe:i,t:a}=r(86850);e.exports=(e,t)=>{if(e instanceof n)return e;if("number"==typeof e&&(e=String(e)),"string"!=typeof e)return null;let r=null;if((t=t||{}).rtl){let t;for(;(t=i[a.COERCERTL].exec(e))&&(!r||r.index+r[0].length!==e.length);)r&&t.index+t[0].length===r.index+r[0].length||(r=t),i[a.COERCERTL].lastIndex=t.index+t[1].length+t[2].length;i[a.COERCERTL].lastIndex=-1}else r=e.match(i[a.COERCE]);return null===r?null:o(`${r[2]}.${r[3]||"0"}.${r[4]||"0"}`,t)}},2801:(e,t,r)=>{const n=r(37944);e.exports=(e,t,r)=>{const o=new n(e,r),i=new n(t,r);return o.compare(i)||o.compareBuild(i)}},97023:(e,t,r)=>{const n=r(55380);e.exports=(e,t)=>n(e,t,!0)},55380:(e,t,r)=>{const n=r(37944);e.exports=(e,t,r)=>new n(e,r).compare(new n(t,r))},80660:(e,t,r)=>{const n=r(15860);e.exports=(e,t)=>{const r=n(e,null,!0),o=n(t,null,!0),i=r.compare(o);if(0===i)return null;const a=i>0,l=a?r:o,u=a?o:r,s=!!l.prerelease.length;if(u.prerelease.length&&!s)return u.patch||u.minor?l.patch?"patch":l.minor?"minor":"major":"major";const c=s?"pre":"";return r.major!==o.major?c+"major":r.minor!==o.minor?c+"minor":r.patch!==o.patch?c+"patch":"prerelease"}},36909:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>0===n(e,t,r)},60144:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>n(e,t,r)>0},82077:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>n(e,t,r)>=0},35955:(e,t,r)=>{const n=r(37944);e.exports=(e,t,r,o,i)=>{"string"==typeof r&&(i=o,o=r,r=void 0);try{return new n(e instanceof n?e.version:e,r).inc(t,o,i).version}catch(e){return null}}},30599:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>n(e,t,r)<0},17092:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>n(e,t,r)<=0},82966:(e,t,r)=>{const n=r(37944);e.exports=(e,t)=>new n(e,t).major},65986:(e,t,r)=>{const n=r(37944);e.exports=(e,t)=>new n(e,t).minor},97659:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>0!==n(e,t,r)},15860:(e,t,r)=>{const n=r(37944);e.exports=(e,t,r=!1)=>{if(e instanceof n)return e;try{return new n(e,t)}catch(e){if(!r)return null;throw e}}},71617:(e,t,r)=>{const n=r(37944);e.exports=(e,t)=>new n(e,t).patch},59613:(e,t,r)=>{const n=r(15860);e.exports=(e,t)=>{const r=n(e,t);return r&&r.prerelease.length?r.prerelease:null}},22862:(e,t,r)=>{const n=r(55380);e.exports=(e,t,r)=>n(t,e,r)},36033:(e,t,r)=>{const n=r(2801);e.exports=(e,t)=>e.sort(((e,r)=>n(r,e,t)))},81722:(e,t,r)=>{const n=r(68395);e.exports=(e,t,r)=>{try{t=new n(t,r)}catch(e){return!1}return t.test(e)}},90603:(e,t,r)=>{const n=r(2801);e.exports=(e,t)=>e.sort(((e,r)=>n(e,r,t)))},87645:(e,t,r)=>{const n=r(15860);e.exports=(e,t)=>{const r=n(e,t);return r?r.version:null}},98449:(e,t,r)=>{const n=r(86850),o=r(59630),i=r(37944),a=r(14031),l=r(15860),u=r(87645),s=r(37994),c=r(35955),d=r(80660),f=r(82966),p=r(65986),g=r(71617),v=r(59613),h=r(55380),m=r(22862),y=r(97023),b=r(2801),E=r(90603),O=r(36033),S=r(60144),_=r(30599),w=r(36909),T=r(97659),P=r(82077),C=r(17092),I=r(23811),A=r(45334),R=r(79524),x=r(68395),N=r(81722),D=r(10651),L=r(47840),j=r(7930),M=r(3489),k=r(17494),F=r(45463),q=r(67871),V=r(74266),B=r(81112),U=r(61465),W=r(19252);e.exports={parse:l,valid:u,clean:s,inc:c,diff:d,major:f,minor:p,patch:g,prerelease:v,compare:h,rcompare:m,compareLoose:y,compareBuild:b,sort:E,rsort:O,gt:S,lt:_,eq:w,neq:T,gte:P,lte:C,cmp:I,coerce:A,Comparator:R,Range:x,satisfies:N,toComparators:D,maxSatisfying:L,minSatisfying:j,minVersion:M,validRange:k,outside:F,gtr:q,ltr:V,intersects:B,simplifyRange:U,subset:W,SemVer:i,re:n.re,src:n.src,tokens:n.t,SEMVER_SPEC_VERSION:o.SEMVER_SPEC_VERSION,RELEASE_TYPES:o.RELEASE_TYPES,compareIdentifiers:a.compareIdentifiers,rcompareIdentifiers:a.rcompareIdentifiers}},59630:e=>{const t=Number.MAX_SAFE_INTEGER||9007199254740991;e.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:16,MAX_SAFE_BUILD_LENGTH:250,MAX_SAFE_INTEGER:t,RELEASE_TYPES:["major","premajor","minor","preminor","patch","prepatch","prerelease"],SEMVER_SPEC_VERSION:"2.0.0",FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2}},79796:e=>{const t="object"==typeof process&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...e)=>console.error("SEMVER",...e):()=>{};e.exports=t},14031:e=>{const t=/^[0-9]+$/,r=(e,r)=>{const n=t.test(e),o=t.test(r);return n&&o&&(e=+e,r=+r),e===r?0:n&&!o?-1:o&&!n?1:e<r?-1:1};e.exports={compareIdentifiers:r,rcompareIdentifiers:(e,t)=>r(t,e)}},57095:e=>{const t=Object.freeze({loose:!0}),r=Object.freeze({});e.exports=e=>e?"object"!=typeof e?t:e:r},86850:(e,t,r)=>{const{MAX_SAFE_COMPONENT_LENGTH:n,MAX_SAFE_BUILD_LENGTH:o,MAX_LENGTH:i}=r(59630),a=r(79796),l=(t=e.exports={}).re=[],u=t.safeRe=[],s=t.src=[],c=t.t={};let d=0;const f="[a-zA-Z0-9-]",p=[["\\s",1],["\\d",i],[f,o]],g=(e,t,r)=>{const n=(e=>{for(const[t,r]of p)e=e.split(`${t}*`).join(`${t}{0,${r}}`).split(`${t}+`).join(`${t}{1,${r}}`);return e})(t),o=d++;a(e,o,t),c[e]=o,s[o]=t,l[o]=new RegExp(t,r?"g":void 0),u[o]=new RegExp(n,r?"g":void 0)};g("NUMERICIDENTIFIER","0|[1-9]\\d*"),g("NUMERICIDENTIFIERLOOSE","\\d+"),g("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${f}*`),g("MAINVERSION",`(${s[c.NUMERICIDENTIFIER]})\\.(${s[c.NUMERICIDENTIFIER]})\\.(${s[c.NUMERICIDENTIFIER]})`),g("MAINVERSIONLOOSE",`(${s[c.NUMERICIDENTIFIERLOOSE]})\\.(${s[c.NUMERICIDENTIFIERLOOSE]})\\.(${s[c.NUMERICIDENTIFIERLOOSE]})`),g("PRERELEASEIDENTIFIER",`(?:${s[c.NUMERICIDENTIFIER]}|${s[c.NONNUMERICIDENTIFIER]})`),g("PRERELEASEIDENTIFIERLOOSE",`(?:${s[c.NUMERICIDENTIFIERLOOSE]}|${s[c.NONNUMERICIDENTIFIER]})`),g("PRERELEASE",`(?:-(${s[c.PRERELEASEIDENTIFIER]}(?:\\.${s[c.PRERELEASEIDENTIFIER]})*))`),g("PRERELEASELOOSE",`(?:-?(${s[c.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${s[c.PRERELEASEIDENTIFIERLOOSE]})*))`),g("BUILDIDENTIFIER",`${f}+`),g("BUILD",`(?:\\+(${s[c.BUILDIDENTIFIER]}(?:\\.${s[c.BUILDIDENTIFIER]})*))`),g("FULLPLAIN",`v?${s[c.MAINVERSION]}${s[c.PRERELEASE]}?${s[c.BUILD]}?`),g("FULL",`^${s[c.FULLPLAIN]}$`),g("LOOSEPLAIN",`[v=\\s]*${s[c.MAINVERSIONLOOSE]}${s[c.PRERELEASELOOSE]}?${s[c.BUILD]}?`),g("LOOSE",`^${s[c.LOOSEPLAIN]}$`),g("GTLT","((?:<|>)?=?)"),g("XRANGEIDENTIFIERLOOSE",`${s[c.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`),g("XRANGEIDENTIFIER",`${s[c.NUMERICIDENTIFIER]}|x|X|\\*`),g("XRANGEPLAIN",`[v=\\s]*(${s[c.XRANGEIDENTIFIER]})(?:\\.(${s[c.XRANGEIDENTIFIER]})(?:\\.(${s[c.XRANGEIDENTIFIER]})(?:${s[c.PRERELEASE]})?${s[c.BUILD]}?)?)?`),g("XRANGEPLAINLOOSE",`[v=\\s]*(${s[c.XRANGEIDENTIFIERLOOSE]})(?:\\.(${s[c.XRANGEIDENTIFIERLOOSE]})(?:\\.(${s[c.XRANGEIDENTIFIERLOOSE]})(?:${s[c.PRERELEASELOOSE]})?${s[c.BUILD]}?)?)?`),g("XRANGE",`^${s[c.GTLT]}\\s*${s[c.XRANGEPLAIN]}$`),g("XRANGELOOSE",`^${s[c.GTLT]}\\s*${s[c.XRANGEPLAINLOOSE]}$`),g("COERCE",`(^|[^\\d])(\\d{1,${n}})(?:\\.(\\d{1,${n}}))?(?:\\.(\\d{1,${n}}))?(?:$|[^\\d])`),g("COERCERTL",s[c.COERCE],!0),g("LONETILDE","(?:~>?)"),g("TILDETRIM",`(\\s*)${s[c.LONETILDE]}\\s+`,!0),t.tildeTrimReplace="$1~",g("TILDE",`^${s[c.LONETILDE]}${s[c.XRANGEPLAIN]}$`),g("TILDELOOSE",`^${s[c.LONETILDE]}${s[c.XRANGEPLAINLOOSE]}$`),g("LONECARET","(?:\\^)"),g("CARETTRIM",`(\\s*)${s[c.LONECARET]}\\s+`,!0),t.caretTrimReplace="$1^",g("CARET",`^${s[c.LONECARET]}${s[c.XRANGEPLAIN]}$`),g("CARETLOOSE",`^${s[c.LONECARET]}${s[c.XRANGEPLAINLOOSE]}$`),g("COMPARATORLOOSE",`^${s[c.GTLT]}\\s*(${s[c.LOOSEPLAIN]})$|^$`),g("COMPARATOR",`^${s[c.GTLT]}\\s*(${s[c.FULLPLAIN]})$|^$`),g("COMPARATORTRIM",`(\\s*)${s[c.GTLT]}\\s*(${s[c.LOOSEPLAIN]}|${s[c.XRANGEPLAIN]})`,!0),t.comparatorTrimReplace="$1$2$3",g("HYPHENRANGE",`^\\s*(${s[c.XRANGEPLAIN]})\\s+-\\s+(${s[c.XRANGEPLAIN]})\\s*$`),g("HYPHENRANGELOOSE",`^\\s*(${s[c.XRANGEPLAINLOOSE]})\\s+-\\s+(${s[c.XRANGEPLAINLOOSE]})\\s*$`),g("STAR","(<|>)?=?\\s*\\*"),g("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$"),g("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$")},67871:(e,t,r)=>{const n=r(45463);e.exports=(e,t,r)=>n(e,t,">",r)},81112:(e,t,r)=>{const n=r(68395);e.exports=(e,t,r)=>(e=new n(e,r),t=new n(t,r),e.intersects(t,r))},74266:(e,t,r)=>{const n=r(45463);e.exports=(e,t,r)=>n(e,t,"<",r)},47840:(e,t,r)=>{const n=r(37944),o=r(68395);e.exports=(e,t,r)=>{let i=null,a=null,l=null;try{l=new o(t,r)}catch(e){return null}return e.forEach((e=>{l.test(e)&&(i&&-1!==a.compare(e)||(i=e,a=new n(i,r)))})),i}},7930:(e,t,r)=>{const n=r(37944),o=r(68395);e.exports=(e,t,r)=>{let i=null,a=null,l=null;try{l=new o(t,r)}catch(e){return null}return e.forEach((e=>{l.test(e)&&(i&&1!==a.compare(e)||(i=e,a=new n(i,r)))})),i}},3489:(e,t,r)=>{const n=r(37944),o=r(68395),i=r(60144);e.exports=(e,t)=>{e=new o(e,t);let r=new n("0.0.0");if(e.test(r))return r;if(r=new n("0.0.0-0"),e.test(r))return r;r=null;for(let t=0;t<e.set.length;++t){const o=e.set[t];let a=null;o.forEach((e=>{const t=new n(e.semver.version);switch(e.operator){case">":0===t.prerelease.length?t.patch++:t.prerelease.push(0),t.raw=t.format();case"":case">=":a&&!i(t,a)||(a=t);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${e.operator}`)}})),!a||r&&!i(r,a)||(r=a)}return r&&e.test(r)?r:null}},45463:(e,t,r)=>{const n=r(37944),o=r(79524),{ANY:i}=o,a=r(68395),l=r(81722),u=r(60144),s=r(30599),c=r(17092),d=r(82077);e.exports=(e,t,r,f)=>{let p,g,v,h,m;switch(e=new n(e,f),t=new a(t,f),r){case">":p=u,g=c,v=s,h=">",m=">=";break;case"<":p=s,g=d,v=u,h="<",m="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(l(e,t,f))return!1;for(let r=0;r<t.set.length;++r){const n=t.set[r];let a=null,l=null;if(n.forEach((e=>{e.semver===i&&(e=new o(">=0.0.0")),a=a||e,l=l||e,p(e.semver,a.semver,f)?a=e:v(e.semver,l.semver,f)&&(l=e)})),a.operator===h||a.operator===m)return!1;if((!l.operator||l.operator===h)&&g(e,l.semver))return!1;if(l.operator===m&&v(e,l.semver))return!1}return!0}},61465:(e,t,r)=>{const n=r(81722),o=r(55380);e.exports=(e,t,r)=>{const i=[];let a=null,l=null;const u=e.sort(((e,t)=>o(e,t,r)));for(const e of u)n(e,t,r)?(l=e,a||(a=e)):(l&&i.push([a,l]),l=null,a=null);a&&i.push([a,null]);const s=[];for(const[e,t]of i)e===t?s.push(e):t||e!==u[0]?t?e===u[0]?s.push(`<=${t}`):s.push(`${e} - ${t}`):s.push(`>=${e}`):s.push("*");const c=s.join(" || "),d="string"==typeof t.raw?t.raw:String(t);return c.length<d.length?c:t}},19252:(e,t,r)=>{const n=r(68395),o=r(79524),{ANY:i}=o,a=r(81722),l=r(55380),u=[new o(">=0.0.0-0")],s=[new o(">=0.0.0")],c=(e,t,r)=>{if(e===t)return!0;if(1===e.length&&e[0].semver===i){if(1===t.length&&t[0].semver===i)return!0;e=r.includePrerelease?u:s}if(1===t.length&&t[0].semver===i){if(r.includePrerelease)return!0;t=s}const n=new Set;let o,c,p,g,v,h,m;for(const t of e)">"===t.operator||">="===t.operator?o=d(o,t,r):"<"===t.operator||"<="===t.operator?c=f(c,t,r):n.add(t.semver);if(n.size>1)return null;if(o&&c){if(p=l(o.semver,c.semver,r),p>0)return null;if(0===p&&(">="!==o.operator||"<="!==c.operator))return null}for(const e of n){if(o&&!a(e,String(o),r))return null;if(c&&!a(e,String(c),r))return null;for(const n of t)if(!a(e,String(n),r))return!1;return!0}let y=!(!c||r.includePrerelease||!c.semver.prerelease.length)&&c.semver,b=!(!o||r.includePrerelease||!o.semver.prerelease.length)&&o.semver;y&&1===y.prerelease.length&&"<"===c.operator&&0===y.prerelease[0]&&(y=!1);for(const e of t){if(m=m||">"===e.operator||">="===e.operator,h=h||"<"===e.operator||"<="===e.operator,o)if(b&&e.semver.prerelease&&e.semver.prerelease.length&&e.semver.major===b.major&&e.semver.minor===b.minor&&e.semver.patch===b.patch&&(b=!1),">"===e.operator||">="===e.operator){if(g=d(o,e,r),g===e&&g!==o)return!1}else if(">="===o.operator&&!a(o.semver,String(e),r))return!1;if(c)if(y&&e.semver.prerelease&&e.semver.prerelease.length&&e.semver.major===y.major&&e.semver.minor===y.minor&&e.semver.patch===y.patch&&(y=!1),"<"===e.operator||"<="===e.operator){if(v=f(c,e,r),v===e&&v!==c)return!1}else if("<="===c.operator&&!a(c.semver,String(e),r))return!1;if(!e.operator&&(c||o)&&0!==p)return!1}return!(o&&h&&!c&&0!==p||c&&m&&!o&&0!==p||b||y)},d=(e,t,r)=>{if(!e)return t;const n=l(e.semver,t.semver,r);return n>0?e:n<0||">"===t.operator&&">="===e.operator?t:e},f=(e,t,r)=>{if(!e)return t;const n=l(e.semver,t.semver,r);return n<0?e:n>0||"<"===t.operator&&"<="===e.operator?t:e};e.exports=(e,t,r={})=>{if(e===t)return!0;e=new n(e,r),t=new n(t,r);let o=!1;e:for(const n of e.set){for(const e of t.set){const t=c(n,e,r);if(o=o||null!==t,t)continue e}if(o)return!1}return!0}},10651:(e,t,r)=>{const n=r(68395);e.exports=(e,t)=>new n(e,t).set.map((e=>e.map((e=>e.value)).join(" ").trim().split(" ")))},17494:(e,t,r)=>{const n=r(68395);e.exports=(e,t)=>{try{return new n(e,t).range||"*"}catch(e){return null}}},22262:function(e){var t;t=function(){return function(e){var t={};function r(n){if(t[n])return t[n].exports;var o=t[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,n){r.o(e,t)||Object.defineProperty(e,t,{configurable:!1,enumerable:!0,get:n})},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=3)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelNode={create:function(e,t){var r,n={},o=e||"Abstract",i=[],a=null;if(n._type=o,n.getType=function(){return o},n.setType=function(e){o=e},n.getChildren=function(){return i},n.addChild=function(e){if(e){if(!e.setParent)throw{name:"Error",message:"Trying to add a child which is not a node: "+JSON.stringify(e)};e.setParent(n),i.push(e)}},n.getParent=function(){return a},n.setParent=function(e){a=e},n.getContext=function(e){return r||e.activeContext.peek()},n.setContext=function(e){r=e},n.getStartPosition=function(){return t>>16},n.getEndPosition=function(){return 65535&t},n.getValue=function(){throw{name:"MethodNotImplementedException",message:"SpelNode#getValue() must be overridden."}},n.toString=function(){var e="Kind: "+n.getType();e+=", Children: [";for(var t=0,r=n.getChildren().length;t<r;t+=1)e+="{"+n.getChildren()[t]+"}, ";return e+"]"},0===t)throw{name:"Error",message:"Position cannot be 0"};for(var l=arguments.length,u=Array(l>2?l-2:0),s=2;s<l;s++)u[s-2]=arguments[s];return u&&u.forEach((function(e){n.addChild(e)})),n}}},function(e,t,r){"use strict";function n(e){this.elements=e||[]}Object.defineProperty(t,"__esModule",{value:!0}),t.Stack=n,n.prototype.push=function(e){return this.elements.push(e),e},n.prototype.pop=function(){return this.elements.pop()},n.prototype.peek=function(){return this.elements[this.elements.length-1]},n.prototype.empty=function(){return this.elements.length>0},n.prototype.search=function(e){return this.elements.length-this.elements.indexOf(e)}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n={LITERAL_INT:1,LITERAL_LONG:2,LITERAL_HEXINT:3,LITERAL_HEXLONG:4,LITERAL_STRING:5,LITERAL_REAL:6,LITERAL_REAL_FLOAT:7,LPAREN:"(",RPAREN:")",COMMA:",",IDENTIFIER:0,COLON:":",HASH:"#",RSQUARE:"]",LSQUARE:"[",LCURLY:"{",RCURLY:"}",DOT:".",PLUS:"+",STAR:"*",MINUS:"-",SELECT_FIRST:"^[",SELECT_LAST:"$[",QMARK:"?",PROJECT:"![",DIV:"/",GE:">=",GT:">",LE:"<=",LT:"<",EQ:"==",NE:"!=",MOD:"%",NOT:"!",ASSIGN:"=",INSTANCEOF:"instanceof",MATCHES:"matches",BETWEEN:"between",SELECT:"?[",POWER:"^",ELVIS:"?:",SAFE_NAVI:"?.",BEAN_REF:"@",SYMBOLIC_OR:"||",SYMBOLIC_AND:"&&",INC:"++",DEC:"--"};function o(e){this.type=e,this.tokenChars=n[e],this._hasPayload="string"!=typeof n[e],"number"==typeof n[e]&&(this._ordinal=n[e])}for(var i in n)n.hasOwnProperty(i)&&(o[i]=new o(i));o.prototype.toString=function(){return this.type+(0!==this.tokenChars.length?"("+this.tokenChars+")":"")},o.prototype.getLength=function(){return this.tokenChars.length},o.prototype.hasPayload=function(){return this._hasPayload},o.prototype.valueOf=function(e){for(var t in n)if(n.hasOwnProperty(t)&&n[t]===e)return o[t]},o.prototype.ordinal=function(){return this._ordinal},t.TokenKind=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext=t.SpelExpressionEvaluator=void 0;var n=r(4),o=r(50);t.SpelExpressionEvaluator=n.SpelExpressionEvaluator,t.StandardContext=o.StandardContext},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionEvaluator=void 0;var n=r(5),o=r(1),i={compile:function(e){var t=(0,n.SpelExpressionParser)().parse(e);return{eval:function(e,r){return function(e,t,r){var n,i=new o.Stack;return t||(t={}),i.push(t),n={rootContext:t,activeContext:i,locals:r},e.getValue(n)}(t,e,r)},_compiledExpression:t}},eval:function(e,t,r){return i.compile(e).eval(t,r)}};t.SpelExpressionEvaluator=i},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionParser=void 0;var n=r(2),o=r(6),i=r(8),a=r(9),l=r(10),u=r(11),s=r(12),c=r(13),d=r(14),f=r(15),p=r(16),g=r(17),v=r(18),h=r(19),m=r(20),y=r(21),b=r(22),E=r(23),O=r(24),S=r(25),_=r(26),w=r(27),T=r(28),P=r(29),C=r(30),I=r(31),A=r(32),R=r(33),x=r(34),N=r(35),D=r(36),L=r(37),j=r(38),M=r(39),k=r(40),F=r(41),q=r(42),V=r(43),B=r(44),U=r(45),W=r(46),G=r(47),H=r(48),K=r(49);t.SpelExpressionParser=function(){var e,t,r,$,z=new RegExp("[\\p{L}\\p{N}_$]+"),Y=[];function Q(){var e=X();if(Se()){var t=we();if(t.getKind()===n.TokenKind.ASSIGN){null===e&&(e=u.NullLiteral.create(Ae(t.startPos-1,t.endPos-1))),_e();var r=X();return v.Assign.create(Ie(t),e,r)}if(t.getKind()===n.TokenKind.ELVIS){null===e&&(e=u.NullLiteral.create(Ae(t.startPos-1,t.endPos-2))),_e();var o=Q();return null===o&&(o=u.NullLiteral.create(Ae(t.startPos+1,t.endPos+1))),j.Elvis.create(Ie(t),e,o)}if(t.getKind()===n.TokenKind.QMARK){null===e&&(e=u.NullLiteral.create(Ae(t.startPos-1,t.endPos-1))),_e();var i=Q();me(n.TokenKind.COLON);var a=Q();return L.Ternary.create(Ie(t),e,i,a)}}return e}function X(){for(var e=J();Oe("or")||ye(n.TokenKind.SYMBOLIC_OR);){var t=_e(),r=J();Pe(t,e,r),e=N.OpOr.create(Ie(t),e,r)}return e}function J(){for(var e=Z();Oe("and")||ye(n.TokenKind.SYMBOLIC_AND);){var t=_e(),r=Z();Pe(t,e,r),e=x.OpAnd.create(Ie(t),e,r)}return e}function Z(){var e=ee(),t=function(){var e=we();if(null===e)return null;if(e.isNumericRelationalOperator())return e;if(e.isIdentifier()){var t=e.stringValue();if("instanceof"===t.toLowerCase())return e.asInstanceOfToken();if("matches"===t.toLowerCase())return e.asMatchesToken();if("between"===t.toLowerCase())return e.asBetweenToken()}return null}();if(null!==t){var r=_e(),o=ee();Pe(r,e,o);var i=t.kind;if(t.isNumericRelationalOperator()){var a=Ie(r);return i===n.TokenKind.GT?b.OpGT.create(a,e,o):i===n.TokenKind.LT?O.OpLT.create(a,e,o):i===n.TokenKind.LE?E.OpLE.create(a,e,o):i===n.TokenKind.GE?y.OpGE.create(a,e,o):i===n.TokenKind.EQ?h.OpEQ.create(a,e,o):m.OpNE.create(a,e,o)}return i===n.TokenKind.INSTANCEOF?V.OpInstanceof.create(Ie(r),e,o):i===n.TokenKind.MATCHES?D.OpMatches.create(Ie(r),e,o):B.OpBetween.create(Ie(r),e,o)}return e}function ee(){for(var e=te();Ee(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.INC);){var t=_e(),r=te();Ce(t,r),t.getKind()===n.TokenKind.PLUS?e=S.OpPlus.create(Ie(t),e,r):t.getKind()===n.TokenKind.MINUS&&(e=_.OpMinus.create(Ie(t),e,r))}return e}function te(){for(var e=re();Ee(n.TokenKind.STAR,n.TokenKind.DIV,n.TokenKind.MOD);){var t=_e(),r=re();Pe(t,e,r),e=t.getKind()===n.TokenKind.STAR?w.OpMultiply.create(Ie(t),e,r):t.getKind()===n.TokenKind.DIV?T.OpDivide.create(Ie(t),e,r):P.OpModulus.create(Ie(t),e,r)}return e}function re(){var e,t=ne();if(ye(n.TokenKind.POWER)){e=_e();var r=ne();return Ce(e,r),C.OpPower.create(Ie(e),t,r)}return null!==t&&Ee(n.TokenKind.INC,n.TokenKind.DEC)?(e=_e()).getKind()===n.TokenKind.INC?I.OpInc.create(Ie(e),!0,t):A.OpDec.create(Ie(e),!0,t):t}function ne(){var e,t;return Ee(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.NOT)?(e=_e(),t=ne(),e.getKind()===n.TokenKind.NOT?R.OpNot.create(Ie(e),t):e.getKind()===n.TokenKind.PLUS?S.OpPlus.create(Ie(e),t):_.OpMinus.create(Ie(e),t)):Ee(n.TokenKind.INC,n.TokenKind.DEC)?(e=_e(),t=ne(),e.getKind()===n.TokenKind.INC?I.OpInc.create(Ie(e),!1,t):A.OpDec.create(Ie(e),!1,t)):function(){var e=[],t=function(){var e=we();if(null===e)return!1;if(e.getKind()===n.TokenKind.LITERAL_INT||e.getKind()===n.TokenKind.LITERAL_LONG)ve(a.NumberLiteral.create(parseInt(e.stringValue(),10),Ie(e)));else if(e.getKind()===n.TokenKind.LITERAL_REAL||e.getKind()===n.TokenKind.LITERAL_REAL_FLOAT)ve(a.NumberLiteral.create(parseFloat(e.stringValue()),Ie(e)));else if(e.getKind()===n.TokenKind.LITERAL_HEXINT||e.getKind()===n.TokenKind.LITERAL_HEXLONG)ve(a.NumberLiteral.create(parseInt(e.stringValue(),16),Ie(e)));else if(Oe("true"))ve(i.BooleanLiteral.create(!0,Ie(e)));else if(Oe("false"))ve(i.BooleanLiteral.create(!1,Ie(e)));else{if(e.getKind()!==n.TokenKind.LITERAL_STRING)return!1;ve(l.StringLiteral.create(e.stringValue(),Ie(e)))}return _e(),!0}()||function(){if(ye(n.TokenKind.LPAREN)){_e();var e=Q();return me(n.TokenKind.RPAREN),ve(e),!0}return!1}()||function(){if(ye(n.TokenKind.IDENTIFIER)){var e=we();if("T"!==e.stringValue())return!1;var t=_e();if(ye(n.TokenKind.RSQUARE))return ve(d.PropertyReference.create(t.stringValue(),Ie(t))),!0;me(n.TokenKind.LPAREN);for(var r=fe(),o=0;be(n.TokenKind.LSQUARE,!0);)me(n.TokenKind.RSQUARE),o++;return me(n.TokenKind.RPAREN),ve(U.TypeReference.create(Ie(e),r,o)),!0}return!1}()||function(){if(ye(n.TokenKind.IDENTIFIER)){var e=we();return"null"===e.stringValue().toLowerCase()&&(_e(),ve(u.NullLiteral.create(Ie(e))),!0)}return!1}()||function(){if(Oe("new")){var e=_e();if(ye(n.TokenKind.RSQUARE))return ve(d.PropertyReference.create(e.stringValue(),Ie(e))),!0;var t=fe(),r=[];if(r.push(t),ye(n.TokenKind.LSQUARE)){for(var o=[];be(n.TokenKind.LSQUARE,!0);)ye(n.TokenKind.RSQUARE)?o.push(null):o.push(Q()),me(n.TokenKind.RSQUARE);se()&&r.push(he()),ve(K.ConstructorReference.create(Ie(e),o,r))}else i=r,ye(n.TokenKind.LPAREN)||Te(Ie(we()),"MISSING_CONSTRUCTOR_ARGS"),le(i),me(n.TokenKind.RPAREN),ve(K.ConstructorReference.create(Ie(e),r));return!0}var i;return!1}()||ge(!1)||ie()||function(){if(ye(n.TokenKind.BEAN_REF)){var e=_e(),t=null,r=null;return ye(n.TokenKind.IDENTIFIER)?r=(t=me(n.TokenKind.IDENTIFIER)).data:ye(n.TokenKind.LITERAL_STRING)?r=(r=(t=me(n.TokenKind.LITERAL_STRING)).stringValue()).substring(1,r.length()-1):Te(e.startPos,"INVALID_BEAN_REFERENCE"),ve(W.BeanReference.create(Ie(t),r)),!0}return!1}()||ue(!1)||de(!1)||ce()||se()?he():null;for(e.push(t);oe();)e.push(he());return 1===e.length?e[0]:p.CompoundExpression.create(Ae(t.getStartPosition(),e[e.length-1].getEndPosition()),e)}()}function oe(){var e,t,r;return null!==(r=Ee(n.TokenKind.DOT,n.TokenKind.SAFE_NAVI)?ge(t=(e=_e()).getKind()===n.TokenKind.SAFE_NAVI)||ie()||ue(t)||de(t)?he():(null===we()?Te(e.startPos,"OOD"):Te(e.startPos,"UNEXPECTED_DATA_AFTER_DOT",function(e){return e.getKind().hasPayload()?e.stringValue():e.getKind().toString().toLowerCase()}(we())),null):ye(n.TokenKind.LSQUARE)&&ce()?he():null)&&(ve(r),!0)}function ie(){if(!ye(n.TokenKind.HASH))return!1;var e=_e(),t=me(n.TokenKind.IDENTIFIER),r=ae();return null===r?(ve(f.VariableReference.create(t.data,Ae(e.startPos,t.endPos))),!0):(ve(s.FunctionReference.create(t.data,Ae(e.startPos,t.endPos),r)),!0)}function ae(){if(!ye(n.TokenKind.LPAREN))return null;var e=[];return le(e),me(n.TokenKind.RPAREN),e}function le(e){var t,r=we().startPos;do{_e();var o=we();null===o&&Te(r,"RUN_OUT_OF_ARGUMENTS"),o.getKind()!==n.TokenKind.RPAREN&&e.push(Q()),t=we()}while(null!==t&&t.kind===n.TokenKind.COMMA);null===t&&Te(r,"RUN_OUT_OF_ARGUMENTS")}function ue(e){var t=we();if(!be(n.TokenKind.PROJECT,!0))return!1;var r=Q();return me(n.TokenKind.RSQUARE),ve(q.Projection.create(e,Ie(t),r)),!0}function se(){var e=we(),t=[];if(!be(n.TokenKind.LCURLY,!0))return!1;var r=null,o=we();if(be(n.TokenKind.RCURLY,!0))r=M.InlineList.create(Ae(e.startPos,o.endPos));else if(be(n.TokenKind.COLON,!0))o=me(n.TokenKind.RCURLY),r=k.InlineMap.create(Ae(e.startPos,o.endPos));else{var i=Q();if(ye(n.TokenKind.RCURLY))t.push(i),o=me(n.TokenKind.RCURLY),r=M.InlineList.create(Ae(e.startPos,o.endPos),t);else if(be(n.TokenKind.COMMA,!0)){t.push(i);do{t.push(Q())}while(be(n.TokenKind.COMMA,!0));o=me(n.TokenKind.RCURLY),r=M.InlineList.create(Ie(e.startPos,o.endPos),t)}else if(be(n.TokenKind.COLON,!0)){var a=[];for(a.push(i),a.push(Q());be(n.TokenKind.COMMA,!0);)a.push(Q()),me(n.TokenKind.COLON),a.push(Q());o=me(n.TokenKind.RCURLY),r=k.InlineMap.create(Ae(e.startPos,o.endPos),a)}else Te(e.startPos,"OOD")}return ve(r),!0}function ce(){var e=we();if(!be(n.TokenKind.LSQUARE,!0))return!1;var t=Q();return me(n.TokenKind.RSQUARE),ve(g.Indexer.create(Ie(e),t)),!0}function de(e){var t=we();if(!function(){if(!Se())return!1;var e=we();return e.getKind()===n.TokenKind.SELECT||e.getKind()===n.TokenKind.SELECT_FIRST||e.getKind()===n.TokenKind.SELECT_LAST}())return!1;_e();var r=Q();return null===r&&Te(Ie(t),"MISSING_SELECTION_EXPRESSION"),me(n.TokenKind.RSQUARE),t.getKind()===n.TokenKind.SELECT_FIRST?ve(F.Selection.create(e,F.Selection.FIRST,Ie(t),r)):t.getKind()===n.TokenKind.SELECT_LAST?ve(F.Selection.create(e,F.Selection.LAST,Ie(t),r)):ve(F.Selection.create(e,F.Selection.ALL,Ie(t),r)),!0}function fe(){for(var t=[],r=we();pe(r);)_e(),r.kind!==n.TokenKind.DOT&&t.push(G.Identifier.create(r.stringValue(),Ie(r))),r=we();t.length||(null===r&&Te(e.length(),"OOD"),Te(r.startPos,"NOT_EXPECTED_TOKEN","qualified ID",r.getKind().toString().toLowerCase()));var o=Ae(t[0].getStartPosition(),t[t.length-1].getEndPosition());return H.QualifiedIdentifier.create(o,t)}function pe(e){if(null===e||e.kind===n.TokenKind.LITERAL_STRING)return!1;if(e.kind===n.TokenKind.DOT||e.kind===n.TokenKind.IDENTIFIER)return!0;var t=e.stringValue();return t&&t.length&&z.test(t)}function ge(e){if(ye(n.TokenKind.IDENTIFIER)){var t=_e(),r=ae();return null===r?(ve(d.PropertyReference.create(e,t.stringValue(),Ie(t))),!0):(ve(c.MethodReference.create(e,t.stringValue(),Ie(t),r)),!0)}return!1}function ve(e){Y.push(e)}function he(){return Y.pop()}function me(t){var r=_e();return null===r&&Te(e.length,"OOD"),r.getKind()!==t&&Te(r.startPos,"NOT_EXPECTED_TOKEN",t.toString().toLowerCase(),r.getKind().toString().toLowerCase()),r}function ye(e){return be(e,!1)}function be(e,t){if(!Se())return!1;var r=we();return r.getKind()===e?(t&&$++,!0):e===n.TokenKind.IDENTIFIER&&r.getKind().ordinal()>=n.TokenKind.DIV.ordinal()&&r.getKind().ordinal()<=n.TokenKind.NOT.ordinal()&&null!==r.data}function Ee(){if(!Se())return!1;for(var e=we(),t=Array.prototype.slice.call(arguments),r=0,n=t.length;r<n;r+=1)if(e.getKind()===t[r])return!0;return!1}function Oe(e){if(!Se())return!1;var t=we();return t.getKind()===n.TokenKind.IDENTIFIER&&t.stringValue().toLowerCase()===e.toLowerCase()}function Se(){return $<t.length}function _e(){return $>=r?null:t[$++]}function we(){return $>=r?null:t[$]}function Te(t,r,n,o){throw n&&(r+="\nExpected: "+n),o&&(r+="\nActual: "+o),{name:"InternalParseException",message:"Error occurred while attempting to parse expression '"+e+"' at position "+t+". Message: "+r}}function Pe(e,t,r){!function(e,t){null===t&&Te(e.startPos,"LEFT_OPERAND_PROBLEM")}(e,t),Ce(e,r)}function Ce(e,t){null===t&&Te(e.startPos,"RIGHT_OPERAND_PROBLEM")}function Ie(e){return(e.startPos<<16)+e.endPos}function Ae(e,t){return(e<<16)+t}return{setConfiguration:function(e){},parse:function(n,i){try{e=n,t=o.Tokenizer.tokenize(n),r=t.length,$=0,Y=[];var a=Q();return Se()&&Te(we().startPos,"MORE_INPUT",_e().toString()),a}catch(e){throw e.message}}}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Tokenizer=void 0;var n=r(7),o=r(2),i=["DIV","EQ","GE","GT","LE","LT","MOD","NE","NOT"],a=[];!function(){var e;for(e="0".charCodeAt(0);e<="9".charCodeAt(0);e+=1)a[e]|=3;for(e="A".charCodeAt(0);e<="F".charCodeAt(0);e+=1)a[e]|=2;for(e="a".charCodeAt(0);e<="f".charCodeAt(0);e+=1)a[e]|=2;for(e="A".charCodeAt(0);e<="Z".charCodeAt(0);e+=1)a[e]|=4;for(e="a".charCodeAt(0);e<="z".charCodeAt(0);e+=1)a[e]|=4}(),t.Tokenizer={tokenize:function(e){var t=e,r=e+"\0",l=r.length,u=0,s=[];function c(){for(var e,i=u,a=!1;!a;)if("'"===(e=r[u+=1])&&("'"===r[u+1]?u+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating quoted string in expression ("+t+") at position "+u};u+=1,s.push(new n.Token(o.TokenKind.LITERAL_STRING,m(i,u),i,u))}function d(){for(var e,i=u,a=!1;!a;)if('"'===(e=r[u+=1])&&('"'===r[u+1]?u+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating double-quoted string in expression ("+t+") at position "+u};u+=1,s.push(new n.Token(o.TokenKind.LITERAL_STRING,m(i,u),i,u))}function f(e){var n,o,i,a=!1,l=u,s=r[u+1];if(!e||"x"!==s&&"X"!==s){do{u+=1}while(w(r[u]));if("."===(s=r[u])){a=!0,n=u;do{u+=1}while(w(r[u]));if(u===n+1)return void g(m(l,u=n),!1,l,u)}if(o=u,O("L","l")){if(a)throw{name:"SpelParseException",message:"Real cannot be long in expression ("+t+") at position "+u};g(m(l,o),!0,l,o),u+=1}else if(function(e){return"e"===e||"E"===e}(r[u])){a=!0,function(e){return"+"===e||"-"===e}(r[u+=1])&&(u+=1);do{u+=1}while(w(r[u]));i=!1,S(r[u])?(i=!0,o=u+=1):_(r[u])&&(o=u+=1),h(m(l,u),i,l,u)}else i=!1,S(s=r[u])?(a=!0,i=!0,o=u+=1):_(s)&&(a=!0,o=u+=1),a?h(m(l,o),i,l,o):g(m(l,o),!1,l,o)}else{u+=1;do{u+=1}while(P(r[u]));O("L","l")?(v(m(l+2,u),!0,l,u),u+=1):v(m(l+2,u),!1,l,u)}}function p(){var e,t,a,l=u;do{u+=1}while(T(a=r[u])||w(a)||"_"===a||"$"===a);e=m(l,u),(u-l==2||u-l==3)&&(t=e.toUpperCase(),i.indexOf(t)>=0)?function(e,t,r){s.push(new n.Token(e,r,t,t+e.getLength()))}(o.TokenKind.valueOf(t),l,e):s.push(new n.Token(o.TokenKind.IDENTIFIER,e.replace("\0",""),l,u))}function g(e,t,r,i){t?s.push(new n.Token(o.TokenKind.LITERAL_LONG,e,r,i)):s.push(new n.Token(o.TokenKind.LITERAL_INT,e,r,i))}function v(e,r,i,a){if(0===e.length)throw r?{name:"SpelParseException",message:"Not a long in expression ("+t+") at position "+u}:{name:"SpelParseException",message:"Not an int in expression ("+t+") at position "+u};r?s.push(new n.Token(o.TokenKind.LITERAL_HEXLONG,e,i,a)):s.push(new n.Token(o.TokenKind.LITERAL_HEXINT,e,i,a))}function h(e,t,r,i){t?s.push(new n.Token(o.TokenKind.LITERAL_REAL_FLOAT,e,r,i)):s.push(new n.Token(o.TokenKind.LITERAL_REAL,e,r,i))}function m(e,t){return r.substring(e,t)}function y(e){return 2===e.tokenChars.length&&r[u]===e.tokenChars[0]&&r[u+1]===e.tokenChars[1]}function b(e){s.push(new n.Token(e,null,u,u+1)),u+=1}function E(e){s.push(new n.Token(e,null,u,u+2)),u+=2}function O(e,t){var n=r[u];return n===e||n===t}function S(e){return"f"===e||"F"===e}function _(e){return"d"===e||"D"===e}function w(e){return!(e.charCodeAt(0)>255||!(1&a[e.charCodeAt(0)]))}function T(e){return!(e.charCodeAt(0)>255||!(4&a[e.charCodeAt(0)]))}function P(e){return!(e.charCodeAt(0)>255||!(2&a[e.charCodeAt(0)]))}return function(){for(var e;u<l;)if(T(e=r[u]))p();else switch(e){case"+":y(o.TokenKind.INC)?E(o.TokenKind.INC):b(o.TokenKind.PLUS);break;case"_":p();break;case"-":y(o.TokenKind.DEC)?E(o.TokenKind.DEC):b(o.TokenKind.MINUS);break;case":":b(o.TokenKind.COLON);break;case".":b(o.TokenKind.DOT);break;case",":b(o.TokenKind.COMMA);break;case"*":b(o.TokenKind.STAR);break;case"/":b(o.TokenKind.DIV);break;case"%":b(o.TokenKind.MOD);break;case"(":b(o.TokenKind.LPAREN);break;case")":b(o.TokenKind.RPAREN);break;case"[":b(o.TokenKind.LSQUARE);break;case"#":b(o.TokenKind.HASH);break;case"]":b(o.TokenKind.RSQUARE);break;case"{":b(o.TokenKind.LCURLY);break;case"}":b(o.TokenKind.RCURLY);break;case"@":b(o.TokenKind.BEAN_REF);break;case"^":y(o.TokenKind.SELECT_FIRST)?E(o.TokenKind.SELECT_FIRST):b(o.TokenKind.POWER);break;case"!":y(o.TokenKind.NE)?E(o.TokenKind.NE):y(o.TokenKind.PROJECT)?E(o.TokenKind.PROJECT):b(o.TokenKind.NOT);break;case"=":y(o.TokenKind.EQ)?E(o.TokenKind.EQ):b(o.TokenKind.ASSIGN);break;case"&":if(!y(o.TokenKind.SYMBOLIC_AND))throw{name:"SpelParseException",message:"Missing character '&' in expression ("+t+") at position "+u};E(o.TokenKind.SYMBOLIC_AND);break;case"|":if(!y(o.TokenKind.SYMBOLIC_OR))throw{name:"SpelParseException",message:"Missing character '|' in expression ("+t+") at position "+u};E(o.TokenKind.SYMBOLIC_OR);break;case"?":y(o.TokenKind.SELECT)?E(o.TokenKind.SELECT):y(o.TokenKind.ELVIS)?E(o.TokenKind.ELVIS):y(o.TokenKind.SAFE_NAVI)?E(o.TokenKind.SAFE_NAVI):b(o.TokenKind.QMARK);break;case"$":y(o.TokenKind.SELECT_LAST)?E(o.TokenKind.SELECT_LAST):p();break;case">":y(o.TokenKind.GE)?E(o.TokenKind.GE):b(o.TokenKind.GT);break;case"<":y(o.TokenKind.LE)?E(o.TokenKind.LE):b(o.TokenKind.LT);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":f("0"===e);break;case" ":case"\t":case"\r":case"\n":case"\0":u+=1;break;case"'":c();break;case'"':d();break;case"\\":throw{name:"SpelParseException",message:"Unexpected escape character in expression ("+t+") at position "+u};default:throw{name:"SpelParseException",message:"Cannot handle character '"+e+"' in expression ("+t+") at position "+u}}}(),s}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Token=void 0;var n=r(2);function o(e,t,r,n){this.kind=e,this.startPos=r,this.endPos=n,t&&(this.data=t)}o.prototype.getKind=function(){return this.kind},o.prototype.toString=function(){var e="[";return e+=this.kind.toString(),this.kind.hasPayload()&&(e+=":"+this.data),(e+="]")+"("+this.startPos+","+this.endPos+")"},o.prototype.isIdentifier=function(){return this.kind===n.TokenKind.IDENTIFIER},o.prototype.isNumericRelationalOperator=function(){return this.kind===n.TokenKind.GT||this.kind===n.TokenKind.GE||this.kind===n.TokenKind.LT||this.kind===n.TokenKind.LE||this.kind===n.TokenKind.EQ||this.kind===n.TokenKind.NE},o.prototype.stringValue=function(){return this.data},o.prototype.asInstanceOfToken=function(){return new o(n.TokenKind.INSTANCEOF,this.startPos,this.endPos)},o.prototype.asMatchesToken=function(){return new o(n.TokenKind.MATCHES,this.startPos,this.endPos)},o.prototype.asBetweenToken=function(){return new o(n.TokenKind.BETWEEN,this.startPos,this.endPos)},o.prototype.getStartPosition=function(){return this.startPos},o.prototype.getEndPosition=function(){return this.endPos},t.Token=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BooleanLiteral=void 0;var n=r(0);t.BooleanLiteral={create:function(e,t){var r=n.SpelNode.create("boolean",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NumberLiteral=void 0;var n=r(0);t.NumberLiteral={create:function(e,t){var r=n.SpelNode.create("number",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringLiteral=void 0;var n=r(0);t.StringLiteral={create:function(e,t){var r=n.SpelNode.create("string",t);return e=function(e){return("'"===e[0]&&"'"===e[e.length-1]||'"'===e[0]&&'"'===e[e.length-1])&&(e=e.substring(1,e.length-1)),e.replace(/''/g,"'").replace(/""/g,'"')}(e),r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullLiteral=void 0;var n=r(0);t.NullLiteral={create:function(e,t){var r=n.SpelNode.create("null",t);return r.getValue=function(){return null},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FunctionReference=void 0;var n=r(0),o=r(1);t.FunctionReference={create:function(e,t,r){var i=n.SpelNode.create("function",t);return i.getRaw=function(){return{functionName:e,args:r}},i.getValue=function(t){var n=t.locals||{},i=t.rootContext,a=[];if(r.forEach((function(e){var r=t.activeContext;t.activeContext=new o.Stack,t.activeContext.push(t.rootContext),a.push(e.getValue(t)),t.activeContext=r})),n[e])return n[e].apply(i,a);throw{name:"FunctionDoesNotExistException",message:"Function '"+e+"' does not exist."}},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MethodReference=void 0;var n=r(0),o=r(1);t.MethodReference={create:function(e,t,r,i){var a=n.SpelNode.create("method",r);return a.getRaw=function(){return{methodName:t,args:i}},a.getValue=function(r){var n,a=r.activeContext.peek(),l=[];if(!a)throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."};function u(r){if(null==r){if(e)return null;throw{name:"NullPointerException",message:"Method "+t+" does not exist."}}return r}if(i.forEach((function(e){var t=r.activeContext;r.activeContext=new o.Stack,r.activeContext.push(r.rootContext),l.push(e.getValue(r)),r.activeContext=t})),"get"===t.substr(0,3)&&!a[t])return u(a[t.charAt(3).toLowerCase()+t.substring(4)]);if("set"===t.substr(0,3)&&!a[t])return a[t.charAt(3).toLowerCase()+t.substring(4)]=l[0];if(Array.isArray(a)){if("size"===t)return a.length;if("contains"===t)return a.includes(l[0])}return(n=u(a[t]))?n.apply(a,l):null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PropertyReference=void 0;var n=r(0);t.PropertyReference={create:function(e,t,r){var o=n.SpelNode.create("property",r);return o.getRaw=function(){return t},o.getValue=function(r){var n=r.activeContext.peek();if(!n){if(e)return null;throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."}}if(void 0===n[t]||null===n[t]){if(e)return null;if("size"===t&&Array.isArray(n))return n.length;throw{name:"NullPointerException",message:"Property '"+t+"' does not exist."}}return n[t]},o.setValue=function(e,r){var n=r.activeContext.peek();if(!n)throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t+"' for an undefined context."};return n[t]=e},o.getName=function(){return t},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VariableReference=void 0;var n=r(0);t.VariableReference={create:function(e,t){var r=n.SpelNode.create("variable",t);return r.getRaw=function(){return e},r.getValue=function(t){var r=t.activeContext.peek(),n=t.locals;if(!r)throw{name:"ContextDoesNotExistException",message:"Attempting to look up variable '"+e+"' for an undefined context."};return"this"===e?r:"root"===e?t.rootContext:n[e]},r.setValue=function(t,r){return r.locals[e]=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CompoundExpression=void 0;var n=r(0);t.CompoundExpression={create:function(e,t){var r=n.SpelNode.create.apply(null,["compound",e].concat(t));function o(e){var t,n=r.getChildren().length;for(t=0;t<n;t+=1)"indexer"===r.getChildren()[t].getType()?e.activeContext.push(e.activeContext.peek()[r.getChildren()[t].getValue(e)]):e.activeContext.push(r.getChildren()[t].getValue(e));return function(){for(t=0;t<n;t+=1)e.activeContext.pop()}}return r.getValue=function(e){var t;if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};var r=o(e);return t=e.activeContext.peek(),r(),t},r.setValue=function(e,t){var n=o(t),i=r.getChildren().length;return t.activeContext.pop(),e=r.getChildren()[i-1].setValue(e,t),t.activeContext.push(null),n(),e},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Indexer=void 0;var n=r(0),o=r(1);t.Indexer={create:function(e,t){var r=n.SpelNode.create.apply(null,["indexer",e].concat(t));return r.getValue=function(e){var t,n,i=e.activeContext,a=r.getChildren().length;if(e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};for(t=0;t<a;t+=1)e.activeContext.push(r.getChildren()[t].getValue(e));for(n=e.activeContext.peek(),t=0;t<a;t+=1)e.activeContext.pop();return e.activeContext=i,n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Assign=void 0;var n=r(0);t.Assign={create:function(e,t,r){var o=n.SpelNode.create("assign",e,t,r);return o.getValue=function(e){if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t.getValue(e)+"' for an undefined context."};return t.setValue(r.getValue(e),e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpEQ=void 0;var n=r(0);t.OpEQ={create:function(e,t,r){var o=n.SpelNode.create("op-eq",e,t,r);return o.getValue=function(e){return t.getValue(e)===r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNE=void 0;var n=r(0);t.OpNE={create:function(e,t,r){var o=n.SpelNode.create("op-ne",e,t,r);return o.getValue=function(e){return t.getValue(e)!==r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGE=void 0;var n=r(0);t.OpGE={create:function(e,t,r){var o=n.SpelNode.create("op-ge",e,t,r);return o.getValue=function(e){return t.getValue(e)>=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGT=void 0;var n=r(0);t.OpGT={create:function(e,t,r){var o=n.SpelNode.create("op-gt",e,t,r);return o.getValue=function(e){return t.getValue(e)>r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLE=void 0;var n=r(0);t.OpLE={create:function(e,t,r){var o=n.SpelNode.create("op-le",e,t,r);return o.getValue=function(e){return t.getValue(e)<=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLT=void 0;var n=r(0);t.OpLT={create:function(e,t,r){var o=n.SpelNode.create("op-lt",e,t,r);return o.getValue=function(e){return t.getValue(e)<r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPlus=void 0;var n=r(0);t.OpPlus={create:function(e,t,r){var o=n.SpelNode.create("op-plus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)+r.getValue(e):+t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMinus=void 0;var n=r(0);t.OpMinus={create:function(e,t,r){var o=n.SpelNode.create("op-minus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)-r.getValue(e):-t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMultiply=void 0;var n=r(0);t.OpMultiply={create:function(e,t,r){var o=n.SpelNode.create("op-multiply",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);if("number"==typeof n&&"number"==typeof o)return n*o;if("string"==typeof n&&"number"==typeof o){for(var i="",a=0;a<o;a+=1)i+=n;return i}return null},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDivide=void 0;var n=r(0);t.OpDivide={create:function(e,t,r){var o=n.SpelNode.create("op-divide",e,t,r);return o.getValue=function(e){return t.getValue(e)/r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpModulus=void 0;var n=r(0);t.OpModulus={create:function(e,t,r){var o=n.SpelNode.create("op-modulus",e,t,r);return o.getValue=function(e){return t.getValue(e)%r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPower=void 0;var n=r(0);t.OpPower={create:function(e,t,r){var o=n.SpelNode.create("op-power",e,t,r);return o.getValue=function(e){return Math.pow(t.getValue(e),r.getValue(e))},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInc=void 0;var n=r(0);t.OpInc={create:function(e,t,r){var o=n.SpelNode.create("op-inc",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n+1,e),t?n:n+1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDec=void 0;var n=r(0);t.OpDec={create:function(e,t,r){var o=n.SpelNode.create("op-dec",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n-1,e),t?n:n-1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNot=void 0;var n=r(0);t.OpNot={create:function(e,t){var r=n.SpelNode.create("op-not",e,t);return r.getValue=function(e){return!t.getValue(e)},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpAnd=void 0;var n=r(0);t.OpAnd={create:function(e,t,r){var o=n.SpelNode.create("op-and",e,t,r);return o.getValue=function(e){return!!t.getValue(e)&&!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpOr=void 0;var n=r(0);t.OpOr={create:function(e,t,r){var o=n.SpelNode.create("op-or",e,t,r);return o.getValue=function(e){return!!t.getValue(e)||!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMatches=void 0;var n=r(0);t.OpMatches={create:function(e,t,r){var o=n.SpelNode.create("matches",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);try{return!!new RegExp(o).exec(n)}catch(e){throw{name:"EvaluationException",message:e.toString()}}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ternary=void 0;var n=r(0);t.Ternary={create:function(e,t,r,o){var i=n.SpelNode.create("ternary",e,t,r,o);return i.getValue=function(e){return t.getValue(e)?r.getValue(e):o.getValue(e)},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Elvis=void 0;var n=r(0);t.Elvis={create:function(e,t,r){var o=n.SpelNode.create("elvis",e,t,r);return o.getValue=function(e){return null!==t.getValue(e)?t.getValue(e):r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineList=void 0;var n=r(0);t.InlineList={create:function(e,t){var r=n.SpelNode.create("list",e),o=[].concat(t||[]);return r.getRaw=function(){return o},r.getValue=function(e){return o.map((function(t){return t.getValue(e)}))},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineMap=void 0;var n=r(0);t.InlineMap={create:function(e,t){var r=n.SpelNode.create("map",e),o=[].concat(t||[]);return r.getValue=function(e){var t=!0,r=null,n={};return o.forEach((function(o){t?r="property"===o.getType()?o.getName():o.getValue(e):n[r]=o.getValue(e),t=!t})),n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}t.Selection={create:function(e,t,r,a){var l=o.SpelNode.create("selection",r,a);return l.getValue=function(e){var r=e.activeContext.peek();if(r){if(Array.isArray(r))return function(e,t,r,n){var o=e.filter((function(e){return i(e,r,n)}));switch(t){case"ALL":return o;case"FIRST":return o[0]||null;case"LAST":return o.length?o[o.length-1]:null}}(r,t,a,e);if("object"===(void 0===r?"undefined":n(r)))return function(e,t,r,n){var o,a,l={},u=[],s={};for(a in e)e.hasOwnProperty(a)&&i(o={key:a,value:e[a]},r,n)&&u.push(o);switch(t){case"ALL":return u.forEach((function(e){l[e.key]=e.value})),l;case"FIRST":return u.length?(s[u[0].key]=u[0].value,s):null;case"LAST":return u.length?(s[u[u.length-1].key]=u[u.length-1].value,s):null}u.forEach((function(e){l[e.key]=e.value}))}(r,t,a,e)}return null},l},FIRST:"FIRST",LAST:"LAST",ALL:"ALL"}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Projection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){return e.map((function(e){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}))}t.Projection={create:function(e,t,r){var a=o.SpelNode.create("projection",t,r);return a.getValue=function(e){var t,o=e.activeContext.peek(),a=[];if(Array.isArray(o))return i(o,r,e);if("object"===(void 0===o?"undefined":n(o))){for(t in o)o.hasOwnProperty(t)&&a.push(o[t]);return i(a,r,e)}return null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInstanceof=void 0;var n=r(0);t.OpInstanceof={create:function(e,t,r){var o=n.SpelNode.create("instanceof",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpInstanceOf: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpBetween=void 0;var n=r(0);t.OpBetween={create:function(e,t,r){var o=n.SpelNode.create("between",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpBetween: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TypeReference=void 0;var n=r(0);t.TypeReference={create:function(e,t,r){return(t=n.SpelNode.create("typeref",e,t)).getValue=function(e){throw{name:"MethodNotImplementedException",message:"TypeReference: Not implemented"}},t}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BeanReference=void 0;var n=r(0);t.BeanReference={create:function(e,t){var r=n.SpelNode.create("beanref",e);return r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"BeanReference: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Identifier=void 0;var n=r(0);t.Identifier={create:function(e,t){var r=n.SpelNode.create("identifier",t);return r.getRaw=function(){return e},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"Identifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QualifiedIdentifier=void 0;var n=r(0);t.QualifiedIdentifier={create:function(e,t){var r=n.SpelNode.create.apply(n.SpelNode,["qualifiedidentifier",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(t)));return r.getRaw=function(){return t.map((function(e){return e.getRaw()}))},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"QualifiedIdentifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConstructorReference=void 0;var n=r(0),o=r(1);t.ConstructorReference={create:function(e,t,r){var i,a=void 0!==r;a?i=t.length&&t[0]&&"number"===t[0].getType()?t[0].getValue():null:(r=t,t=void 0);var l,u=(l=r,Array.isArray(l)?l:Array.from(l)),s=(u[0],u.slice(1)),c=n.SpelNode.create.apply(n.SpelNode,["constructorref",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(r)));return c.getRaw=function(){return i},c.getValue=function(e){if(a&&s.length<=1){var t=[];return s.forEach((function(r){var n=e.activeContext;e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),t.push(r.getValue(e)),e.activeContext=n})),1===s.length?t[0]:i?new Array(i):[]}throw{name:"MethodNotImplementedException",message:"ConstructorReference: Not implemented"}},c}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext={create:function(e,t){var r={};return r.authentication=e||{},r.principal=t||{},r.hasRole=function(e){var t=!1;return!!e&&!(!r.authentication&&!Array.isArray(r.authentication.authorities))&&(r.authentication.authorities.forEach((function(r){r.authority.toLowerCase()===e.toLowerCase()&&(t=!0)})),t)},r.hasPermission=function(){var e=Array.prototype.slice.call(arguments);if(1===e.length)return r.hasRole(e[0])},r}}}])},e.exports=t()},65697:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=u(r(39007)),o=u(r(27301)),i=u(r(71892)),a=u(r(13085)),l=u(r(42353));function u(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var c=function(e){return e.replace(/[\t ]+$/,"")},d=function(){function e(t,r,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t||{},this.indentation=new i.default(this.cfg.indent),this.inlineBlock=new a.default,this.params=new l.default(this.cfg.params),this.tokenizer=r,this.tokenOverride=n,this.previousReservedWord={},this.tokens=[],this.index=0}var t,r;return t=e,r=[{key:"format",value:function(e){return this.tokens=this.tokenizer.tokenize(e),this.getFormattedQueryFromTokens().trim()}},{key:"getFormattedQueryFromTokens",value:function(){var e=this,t="";return this.tokens.forEach((function(r,n){e.index=n,e.tokenOverride&&(r=e.tokenOverride(r,e.previousReservedWord)||r),r.type===o.default.WHITESPACE||(r.type===o.default.LINE_COMMENT?t=e.formatLineComment(r,t):r.type===o.default.BLOCK_COMMENT?t=e.formatBlockComment(r,t):r.type===o.default.RESERVED_TOP_LEVEL?(t=e.formatTopLevelReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_TOP_LEVEL_NO_INDENT?(t=e.formatTopLevelReservedWordNoIndent(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_NEWLINE?(t=e.formatNewlineReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED?(t=e.formatWithSpaces(r,t),e.previousReservedWord=r):t=r.type===o.default.OPEN_PAREN?e.formatOpeningParentheses(r,t):r.type===o.default.CLOSE_PAREN?e.formatClosingParentheses(r,t):r.type===o.default.PLACEHOLDER?e.formatPlaceholder(r,t):","===r.value?e.formatComma(r,t):":"===r.value?e.formatWithSpaceAfter(r,t):"."===r.value?e.formatWithoutSpaces(r,t):";"===r.value?e.formatQuerySeparator(r,t):e.formatWithSpaces(r,t))})),t}},{key:"formatLineComment",value:function(e,t){return this.addNewline(t+e.value)}},{key:"formatBlockComment",value:function(e,t){return this.addNewline(this.addNewline(t)+this.indentComment(e.value))}},{key:"indentComment",value:function(e){return e.replace(/\n[\t ]*/g,"\n"+this.indentation.getIndent()+" ")}},{key:"formatTopLevelReservedWordNoIndent",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatTopLevelReservedWord",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t),this.indentation.increaseTopLevel(),t+=this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatNewlineReservedWord",value:function(e,t){return this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value))+" "}},{key:"equalizeWhitespace",value:function(e){return e.replace(/[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+/g," ")}},{key:"formatOpeningParentheses",value:function(e,t){var r=[o.default.WHITESPACE,o.default.OPEN_PAREN,o.default.LINE_COMMENT];return(0,n.default)(r,this.previousToken().type)||(t=c(t)),t+=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.beginIfPossible(this.tokens,this.index),this.inlineBlock.isActive()||(this.indentation.increaseBlockLevel(),t=this.addNewline(t)),t}},{key:"formatClosingParentheses",value:function(e,t){return e.value=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.isActive()?(this.inlineBlock.end(),this.formatWithSpaceAfter(e,t)):(this.indentation.decreaseBlockLevel(),this.formatWithSpaces(e,this.addNewline(t)))}},{key:"formatPlaceholder",value:function(e,t){return t+this.params.get(e)+" "}},{key:"formatComma",value:function(e,t){return t=c(t)+e.value+" ",this.inlineBlock.isActive()||/^LIMIT$/i.test(this.previousReservedWord.value)?t:this.addNewline(t)}},{key:"formatWithSpaceAfter",value:function(e,t){return c(t)+e.value+" "}},{key:"formatWithoutSpaces",value:function(e,t){return c(t)+e.value}},{key:"formatWithSpaces",value:function(e,t){return t+("reserved"===e.type?this.formatReservedWord(e.value):e.value)+" "}},{key:"formatReservedWord",value:function(e){return this.cfg.uppercase?e.toUpperCase():e}},{key:"formatQuerySeparator",value:function(e,t){return this.indentation.resetIndentation(),c(t)+e.value+"\n".repeat(this.cfg.linesBetweenQueries||1)}},{key:"addNewline",value:function(e){return(e=c(e)).endsWith("\n")||(e+="\n"),e+this.indentation.getIndent()}},{key:"previousToken",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.tokens[this.index-e]||{}}}],r&&s(t.prototype,r),e}();t.default=d,e.exports=t.default},71892:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(54249)),o=i(r(75342));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l="top-level",u=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.indent=t||"  ",this.indentTypes=[]}var t,r;return t=e,(r=[{key:"getIndent",value:function(){return(0,n.default)(this.indent,this.indentTypes.length)}},{key:"increaseTopLevel",value:function(){this.indentTypes.push(l)}},{key:"increaseBlockLevel",value:function(){this.indentTypes.push("block-level")}},{key:"decreaseTopLevel",value:function(){(0,o.default)(this.indentTypes)===l&&this.indentTypes.pop()}},{key:"decreaseBlockLevel",value:function(){for(;this.indentTypes.length>0&&this.indentTypes.pop()===l;);}},{key:"resetIndentation",value:function(){this.indentTypes=[]}}])&&a(t.prototype,r),e}();t.default=u,e.exports=t.default},13085:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n,o=(n=r(27301))&&n.__esModule?n:{default:n};function i(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.level=0}var t,r;return t=e,(r=[{key:"beginIfPossible",value:function(e,t){0===this.level&&this.isInlineBlock(e,t)?this.level=1:this.level>0?this.level++:this.level=0}},{key:"end",value:function(){this.level--}},{key:"isActive",value:function(){return this.level>0}},{key:"isInlineBlock",value:function(e,t){for(var r=0,n=0,i=t;i<e.length;i++){var a=e[i];if((r+=a.value.length)>50)return!1;if(a.type===o.default.OPEN_PAREN)n++;else if(a.type===o.default.CLOSE_PAREN&&0==--n)return!0;if(this.isForbiddenToken(a))return!1}return!1}},{key:"isForbiddenToken",value:function(e){var t=e.type,r=e.value;return t===o.default.RESERVED_TOP_LEVEL||t===o.default.RESERVED_NEWLINE||t===o.default.COMMENT||t===o.default.BLOCK_COMMENT||";"===r}}])&&i(t.prototype,r),e}();t.default=a,e.exports=t.default},42353:(e,t)=>{"use strict";function r(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.params=t,this.index=0}var t,n;return t=e,(n=[{key:"get",value:function(e){var t=e.key,r=e.value;return this.params?t?this.params[t]:this.params[this.index++]:r}}])&&r(t.prototype,n),e}();t.default=n,e.exports=t.default},85174:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(95685)),o=a(r(27572)),i=a(r(27301));function a(e){return e&&e.__esModule?e:{default:e}}function l(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var u=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.WHITESPACE_REGEX=/^([\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+)/,this.NUMBER_REGEX=/^((\x2D[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*)?[0-9]+(\.[0-9]+)?|0x[0-9A-Fa-f]+|0b[01]+)\b/,this.OPERATOR_REGEX=/^(!=|<>|==|<=|>=|!<|!>|\|\||::|\x2D>>|\x2D>|~~\*|~~|!~~\*|!~~|~\*|!~\*|!~|:=|(?:[\0-\t\x0B\f\x0E-\u2027\u202A-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]))/,this.BLOCK_COMMENT_REGEX=/^(\/\*(?:[\0-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*?(?:\*\/|$))/,this.LINE_COMMENT_REGEX=this.createLineCommentRegex(t.lineCommentTypes),this.RESERVED_TOP_LEVEL_REGEX=this.createReservedWordRegex(t.reservedTopLevelWords),this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX=this.createReservedWordRegex(t.reservedTopLevelWordsNoIndent),this.RESERVED_NEWLINE_REGEX=this.createReservedWordRegex(t.reservedNewlineWords),this.RESERVED_PLAIN_REGEX=this.createReservedWordRegex(t.reservedWords),this.WORD_REGEX=this.createWordRegex(t.specialWordChars),this.STRING_REGEX=this.createStringRegex(t.stringTypes),this.OPEN_PAREN_REGEX=this.createParenRegex(t.openParens),this.CLOSE_PAREN_REGEX=this.createParenRegex(t.closeParens),this.INDEXED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.indexedPlaceholderTypes,"[0-9]*"),this.IDENT_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,"[a-zA-Z0-9._$]+"),this.STRING_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,this.createStringPattern(t.stringTypes))}var t,r;return t=e,r=[{key:"createLineCommentRegex",value:function(e){return new RegExp("^((?:".concat(e.map((function(e){return(0,o.default)(e)})).join("|"),").*?(?:\r\n|\r|\n|$))"),"u")}},{key:"createReservedWordRegex",value:function(e){var t=e.join("|").replace(/ /g,"\\s+");return new RegExp("^(".concat(t,")\\b"),"iu")}},{key:"createWordRegex",value:function(){return new RegExp("^([\\p{Alphabetic}\\p{Mark}\\p{Decimal_Number}\\p{Connector_Punctuation}\\p{Join_Control}".concat((arguments.length>0&&void 0!==arguments[0]?arguments[0]:[]).join(""),"]+)"),"u")}},{key:"createStringRegex",value:function(e){return new RegExp("^("+this.createStringPattern(e)+")","u")}},{key:"createStringPattern",value:function(e){var t={"``":"((`[^`]*($|`))+)","[]":"((\\[[^\\]]*($|\\]))(\\][^\\]]*($|\\]))*)",'""':'(("[^"\\\\]*(?:\\\\.[^"\\\\]*)*("|$))+)',"''":"(('[^'\\\\]*(?:\\\\.[^'\\\\]*)*('|$))+)","N''":"((N'[^N'\\\\]*(?:\\\\.[^N'\\\\]*)*('|$))+)"};return e.map((function(e){return t[e]})).join("|")}},{key:"createParenRegex",value:function(e){var t=this;return new RegExp("^("+e.map((function(e){return t.escapeParen(e)})).join("|")+")","iu")}},{key:"escapeParen",value:function(e){return 1===e.length?(0,o.default)(e):"\\b"+e+"\\b"}},{key:"createPlaceholderRegex",value:function(e,t){if((0,n.default)(e))return!1;var r=e.map(o.default).join("|");return new RegExp("^((?:".concat(r,")(?:").concat(t,"))"),"u")}},{key:"tokenize",value:function(e){if(!e)return[];for(var t,r=[];e.length;)t=this.getNextToken(e,t),e=e.substring(t.value.length),r.push(t);return r}},{key:"getNextToken",value:function(e,t){return this.getWhitespaceToken(e)||this.getCommentToken(e)||this.getStringToken(e)||this.getOpenParenToken(e)||this.getCloseParenToken(e)||this.getPlaceholderToken(e)||this.getNumberToken(e)||this.getReservedWordToken(e,t)||this.getWordToken(e)||this.getOperatorToken(e)}},{key:"getWhitespaceToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WHITESPACE,regex:this.WHITESPACE_REGEX})}},{key:"getCommentToken",value:function(e){return this.getLineCommentToken(e)||this.getBlockCommentToken(e)}},{key:"getLineCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.LINE_COMMENT,regex:this.LINE_COMMENT_REGEX})}},{key:"getBlockCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.BLOCK_COMMENT,regex:this.BLOCK_COMMENT_REGEX})}},{key:"getStringToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.STRING,regex:this.STRING_REGEX})}},{key:"getOpenParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPEN_PAREN,regex:this.OPEN_PAREN_REGEX})}},{key:"getCloseParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.CLOSE_PAREN,regex:this.CLOSE_PAREN_REGEX})}},{key:"getPlaceholderToken",value:function(e){return this.getIdentNamedPlaceholderToken(e)||this.getStringNamedPlaceholderToken(e)||this.getIndexedPlaceholderToken(e)}},{key:"getIdentNamedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.IDENT_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getStringNamedPlaceholderToken",value:function(e){var t=this;return this.getPlaceholderTokenWithKey({input:e,regex:this.STRING_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return t.getEscapedPlaceholderKey({key:e.slice(2,-1),quoteChar:e.slice(-1)})}})}},{key:"getIndexedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.INDEXED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getPlaceholderTokenWithKey",value:function(e){var t=e.input,r=e.regex,n=e.parseKey,o=this.getTokenOnFirstMatch({input:t,regex:r,type:i.default.PLACEHOLDER});return o&&(o.key=n(o.value)),o}},{key:"getEscapedPlaceholderKey",value:function(e){var t=e.key,r=e.quoteChar;return t.replace(new RegExp((0,o.default)("\\"+r),"gu"),r)}},{key:"getNumberToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.NUMBER,regex:this.NUMBER_REGEX})}},{key:"getOperatorToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPERATOR,regex:this.OPERATOR_REGEX})}},{key:"getReservedWordToken",value:function(e,t){if(!t||!t.value||"."!==t.value)return this.getTopLevelReservedToken(e)||this.getNewlineReservedToken(e)||this.getTopLevelReservedTokenNoIndent(e)||this.getPlainReservedToken(e)}},{key:"getTopLevelReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL,regex:this.RESERVED_TOP_LEVEL_REGEX})}},{key:"getNewlineReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_NEWLINE,regex:this.RESERVED_NEWLINE_REGEX})}},{key:"getTopLevelReservedTokenNoIndent",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL_NO_INDENT,regex:this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX})}},{key:"getPlainReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED,regex:this.RESERVED_PLAIN_REGEX})}},{key:"getWordToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WORD,regex:this.WORD_REGEX})}},{key:"getTokenOnFirstMatch",value:function(e){var t=e.input,r=e.type,n=e.regex,o=t.match(n);if(o)return{type:r,value:o[1]}}}],r&&l(t.prototype,r),e}();t.default=u,e.exports=t.default},27301:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,t.default={WHITESPACE:"whitespace",WORD:"word",STRING:"string",RESERVED:"reserved",RESERVED_TOP_LEVEL:"reserved-top-level",RESERVED_TOP_LEVEL_NO_INDENT:"reserved-top-level-no-indent",RESERVED_NEWLINE:"reserved-newline",OPERATOR:"operator",OPEN_PAREN:"open-paren",CLOSE_PAREN:"close-paren",LINE_COMMENT:"line-comment",BLOCK_COMMENT:"block-comment",NUMBER:"number",PLACEHOLDER:"placeholder"},e.exports=t.default},83453:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(65697)),o=i(r(85174));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,u=["ABS","ACTIVATE","ALIAS","ALL","ALLOCATE","ALLOW","ALTER","ANY","ARE","ARRAY","AS","ASC","ASENSITIVE","ASSOCIATE","ASUTIME","ASYMMETRIC","AT","ATOMIC","ATTRIBUTES","AUDIT","AUTHORIZATION","AUX","AUXILIARY","AVG","BEFORE","BEGIN","BETWEEN","BIGINT","BINARY","BLOB","BOOLEAN","BOTH","BUFFERPOOL","BY","CACHE","CALL","CALLED","CAPTURE","CARDINALITY","CASCADED","CASE","CAST","CCSID","CEIL","CEILING","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CLOB","CLONE","CLOSE","CLUSTER","COALESCE","COLLATE","COLLECT","COLLECTION","COLLID","COLUMN","COMMENT","COMMIT","CONCAT","CONDITION","CONNECT","CONNECTION","CONSTRAINT","CONTAINS","CONTINUE","CONVERT","CORR","CORRESPONDING","COUNT","COUNT_BIG","COVAR_POP","COVAR_SAMP","CREATE","CROSS","CUBE","CUME_DIST","CURRENT","CURRENT_DATE","CURRENT_DEFAULT_TRANSFORM_GROUP","CURRENT_LC_CTYPE","CURRENT_PATH","CURRENT_ROLE","CURRENT_SCHEMA","CURRENT_SERVER","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_TIMEZONE","CURRENT_TRANSFORM_GROUP_FOR_TYPE","CURRENT_USER","CURSOR","CYCLE","DATA","DATABASE","DATAPARTITIONNAME","DATAPARTITIONNUM","DATE","DAY","DAYS","DB2GENERAL","DB2GENRL","DB2SQL","DBINFO","DBPARTITIONNAME","DBPARTITIONNUM","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFAULTS","DEFINITION","DELETE","DENSERANK","DENSE_RANK","DEREF","DESCRIBE","DESCRIPTOR","DETERMINISTIC","DIAGNOSTICS","DISABLE","DISALLOW","DISCONNECT","DISTINCT","DO","DOCUMENT","DOUBLE","DROP","DSSIZE","DYNAMIC","EACH","EDITPROC","ELEMENT","ELSE","ELSEIF","ENABLE","ENCODING","ENCRYPTION","END","END-EXEC","ENDING","ERASE","ESCAPE","EVERY","EXCEPTION","EXCLUDING","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXP","EXPLAIN","EXTENDED","EXTERNAL","EXTRACT","FALSE","FENCED","FETCH","FIELDPROC","FILE","FILTER","FINAL","FIRST","FLOAT","FLOOR","FOR","FOREIGN","FREE","FULL","FUNCTION","FUSION","GENERAL","GENERATED","GET","GLOBAL","GOTO","GRANT","GRAPHIC","GROUP","GROUPING","HANDLER","HASH","HASHED_VALUE","HINT","HOLD","HOUR","HOURS","IDENTITY","IF","IMMEDIATE","IN","INCLUDING","INCLUSIVE","INCREMENT","INDEX","INDICATOR","INDICATORS","INF","INFINITY","INHERIT","INNER","INOUT","INSENSITIVE","INSERT","INT","INTEGER","INTEGRITY","INTERSECTION","INTERVAL","INTO","IS","ISOBID","ISOLATION","ITERATE","JAR","JAVA","KEEP","KEY","LABEL","LANGUAGE","LARGE","LATERAL","LC_CTYPE","LEADING","LEAVE","LEFT","LIKE","LINKTYPE","LN","LOCAL","LOCALDATE","LOCALE","LOCALTIME","LOCALTIMESTAMP","LOCATOR","LOCATORS","LOCK","LOCKMAX","LOCKSIZE","LONG","LOOP","LOWER","MAINTAINED","MATCH","MATERIALIZED","MAX","MAXVALUE","MEMBER","MERGE","METHOD","MICROSECOND","MICROSECONDS","MIN","MINUTE","MINUTES","MINVALUE","MOD","MODE","MODIFIES","MODULE","MONTH","MONTHS","MULTISET","NAN","NATIONAL","NATURAL","NCHAR","NCLOB","NEW","NEW_TABLE","NEXTVAL","NO","NOCACHE","NOCYCLE","NODENAME","NODENUMBER","NOMAXVALUE","NOMINVALUE","NONE","NOORDER","NORMALIZE","NORMALIZED","NOT","NULL","NULLIF","NULLS","NUMERIC","NUMPARTS","OBID","OCTET_LENGTH","OF","OFFSET","OLD","OLD_TABLE","ON","ONLY","OPEN","OPTIMIZATION","OPTIMIZE","OPTION","ORDER","OUT","OUTER","OVER","OVERLAPS","OVERLAY","OVERRIDING","PACKAGE","PADDED","PAGESIZE","PARAMETER","PART","PARTITION","PARTITIONED","PARTITIONING","PARTITIONS","PASSWORD","PATH","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","PIECESIZE","PLAN","POSITION","POWER","PRECISION","PREPARE","PREVVAL","PRIMARY","PRIQTY","PRIVILEGES","PROCEDURE","PROGRAM","PSID","PUBLIC","QUERY","QUERYNO","RANGE","RANK","READ","READS","REAL","RECOVERY","RECURSIVE","REF","REFERENCES","REFERENCING","REFRESH","REGR_AVGX","REGR_AVGY","REGR_COUNT","REGR_INTERCEPT","REGR_R2","REGR_SLOPE","REGR_SXX","REGR_SXY","REGR_SYY","RELEASE","RENAME","REPEAT","RESET","RESIGNAL","RESTART","RESTRICT","RESULT","RESULT_SET_LOCATOR","RETURN","RETURNS","REVOKE","RIGHT","ROLE","ROLLBACK","ROLLUP","ROUND_CEILING","ROUND_DOWN","ROUND_FLOOR","ROUND_HALF_DOWN","ROUND_HALF_EVEN","ROUND_HALF_UP","ROUND_UP","ROUTINE","ROW","ROWNUMBER","ROWS","ROWSET","ROW_NUMBER","RRN","RUN","SAVEPOINT","SCHEMA","SCOPE","SCRATCHPAD","SCROLL","SEARCH","SECOND","SECONDS","SECQTY","SECURITY","SENSITIVE","SEQUENCE","SESSION","SESSION_USER","SIGNAL","SIMILAR","SIMPLE","SMALLINT","SNAN","SOME","SOURCE","SPECIFIC","SPECIFICTYPE","SQL","SQLEXCEPTION","SQLID","SQLSTATE","SQLWARNING","SQRT","STACKED","STANDARD","START","STARTING","STATEMENT","STATIC","STATMENT","STAY","STDDEV_POP","STDDEV_SAMP","STOGROUP","STORES","STYLE","SUBMULTISET","SUBSTRING","SUM","SUMMARY","SYMMETRIC","SYNONYM","SYSFUN","SYSIBM","SYSPROC","SYSTEM","SYSTEM_USER","TABLE","TABLESAMPLE","TABLESPACE","THEN","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TRAILING","TRANSACTION","TRANSLATE","TRANSLATION","TREAT","TRIGGER","TRIM","TRUE","TRUNCATE","TYPE","UESCAPE","UNDO","UNIQUE","UNKNOWN","UNNEST","UNTIL","UPPER","USAGE","USER","USING","VALIDPROC","VALUE","VARCHAR","VARIABLE","VARIANT","VARYING","VAR_POP","VAR_SAMP","VCAT","VERSION","VIEW","VOLATILE","VOLUMES","WHEN","WHENEVER","WHILE","WIDTH_BUCKET","WINDOW","WITH","WITHIN","WITHOUT","WLM","WRITE","XMLELEMENT","XMLEXISTS","XMLNAMESPACES","YEAR","YEARS"],s=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INTERSECT","LIMIT","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS JOIN","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN"],f=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:u,reservedTopLevelWords:s,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``","[]"],openParens:["("],closeParens:[")"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["#","@"]})),new n.default(this.cfg,l).format(e)}}])&&a(t.prototype,r),e}();t.default=f,e.exports=t.default},41353:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(65697)),o=i(r(85174));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,u=["ALL","ALTER","ANALYZE","AND","ANY","ARRAY","AS","ASC","BEGIN","BETWEEN","BINARY","BOOLEAN","BREAK","BUCKET","BUILD","BY","CALL","CASE","CAST","CLUSTER","COLLATE","COLLECTION","COMMIT","CONNECT","CONTINUE","CORRELATE","COVER","CREATE","DATABASE","DATASET","DATASTORE","DECLARE","DECREMENT","DELETE","DERIVED","DESC","DESCRIBE","DISTINCT","DO","DROP","EACH","ELEMENT","ELSE","END","EVERY","EXCEPT","EXCLUDE","EXECUTE","EXISTS","EXPLAIN","FALSE","FETCH","FIRST","FLATTEN","FOR","FORCE","FROM","FUNCTION","GRANT","GROUP","GSI","HAVING","IF","IGNORE","ILIKE","IN","INCLUDE","INCREMENT","INDEX","INFER","INLINE","INNER","INSERT","INTERSECT","INTO","IS","JOIN","KEY","KEYS","KEYSPACE","KNOWN","LAST","LEFT","LET","LETTING","LIKE","LIMIT","LSM","MAP","MAPPING","MATCHED","MATERIALIZED","MERGE","MISSING","NAMESPACE","NEST","NOT","NULL","NUMBER","OBJECT","OFFSET","ON","OPTION","OR","ORDER","OUTER","OVER","PARSE","PARTITION","PASSWORD","PATH","POOL","PREPARE","PRIMARY","PRIVATE","PRIVILEGE","PROCEDURE","PUBLIC","RAW","REALM","REDUCE","RENAME","RETURN","RETURNING","REVOKE","RIGHT","ROLE","ROLLBACK","SATISFIES","SCHEMA","SELECT","SELF","SEMI","SET","SHOW","SOME","START","STATISTICS","STRING","SYSTEM","THEN","TO","TRANSACTION","TRIGGER","TRUE","TRUNCATE","UNDER","UNION","UNIQUE","UNKNOWN","UNNEST","UNSET","UPDATE","UPSERT","USE","USER","USING","VALIDATE","VALUE","VALUED","VALUES","VIA","VIEW","WHEN","WHERE","WHILE","WITH","WITHIN","WORK","XOR"],s=["DELETE FROM","EXCEPT ALL","EXCEPT","EXPLAIN DELETE FROM","EXPLAIN UPDATE","EXPLAIN UPSERT","FROM","GROUP BY","HAVING","INFER","INSERT INTO","LET","LIMIT","MERGE","NEST","ORDER BY","PREPARE","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UNNEST","UPDATE","UPSERT","USE KEYS","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","XOR"],f=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:u,reservedTopLevelWords:s,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``"],openParens:["(","[","{"],closeParens:[")","]","}"],namedPlaceholderTypes:["$"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,l).format(e)}}])&&a(t.prototype,r),e}();t.default=f,e.exports=t.default},24533:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(65697)),o=a(r(85174)),i=a(r(27301));function a(e){return e&&e.__esModule?e:{default:e}}function l(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var u,s=["A","ACCESSIBLE","AGENT","AGGREGATE","ALL","ALTER","ANY","ARRAY","AS","ASC","AT","ATTRIBUTE","AUTHID","AVG","BETWEEN","BFILE_BASE","BINARY_INTEGER","BINARY","BLOB_BASE","BLOCK","BODY","BOOLEAN","BOTH","BOUND","BREADTH","BULK","BY","BYTE","C","CALL","CALLING","CASCADE","CASE","CHAR_BASE","CHAR","CHARACTER","CHARSET","CHARSETFORM","CHARSETID","CHECK","CLOB_BASE","CLONE","CLOSE","CLUSTER","CLUSTERS","COALESCE","COLAUTH","COLLECT","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPILED","COMPRESS","CONNECT","CONSTANT","CONSTRUCTOR","CONTEXT","CONTINUE","CONVERT","COUNT","CRASH","CREATE","CREDENTIAL","CURRENT","CURRVAL","CURSOR","CUSTOMDATUM","DANGLING","DATA","DATE_BASE","DATE","DAY","DECIMAL","DEFAULT","DEFINE","DELETE","DEPTH","DESC","DETERMINISTIC","DIRECTORY","DISTINCT","DO","DOUBLE","DROP","DURATION","ELEMENT","ELSIF","EMPTY","END","ESCAPE","EXCEPTIONS","EXCLUSIVE","EXECUTE","EXISTS","EXIT","EXTENDS","EXTERNAL","EXTRACT","FALSE","FETCH","FINAL","FIRST","FIXED","FLOAT","FOR","FORALL","FORCE","FROM","FUNCTION","GENERAL","GOTO","GRANT","GROUP","HASH","HEAP","HIDDEN","HOUR","IDENTIFIED","IF","IMMEDIATE","IN","INCLUDING","INDEX","INDEXES","INDICATOR","INDICES","INFINITE","INSTANTIABLE","INT","INTEGER","INTERFACE","INTERVAL","INTO","INVALIDATE","IS","ISOLATION","JAVA","LANGUAGE","LARGE","LEADING","LENGTH","LEVEL","LIBRARY","LIKE","LIKE2","LIKE4","LIKEC","LIMITED","LOCAL","LOCK","LONG","MAP","MAX","MAXLEN","MEMBER","MERGE","MIN","MINUTE","MLSLABEL","MOD","MODE","MONTH","MULTISET","NAME","NAN","NATIONAL","NATIVE","NATURAL","NATURALN","NCHAR","NEW","NEXTVAL","NOCOMPRESS","NOCOPY","NOT","NOWAIT","NULL","NULLIF","NUMBER_BASE","NUMBER","OBJECT","OCICOLL","OCIDATE","OCIDATETIME","OCIDURATION","OCIINTERVAL","OCILOBLOCATOR","OCINUMBER","OCIRAW","OCIREF","OCIREFCURSOR","OCIROWID","OCISTRING","OCITYPE","OF","OLD","ON","ONLY","OPAQUE","OPEN","OPERATOR","OPTION","ORACLE","ORADATA","ORDER","ORGANIZATION","ORLANY","ORLVARY","OTHERS","OUT","OVERLAPS","OVERRIDING","PACKAGE","PARALLEL_ENABLE","PARAMETER","PARAMETERS","PARENT","PARTITION","PASCAL","PCTFREE","PIPE","PIPELINED","PLS_INTEGER","PLUGGABLE","POSITIVE","POSITIVEN","PRAGMA","PRECISION","PRIOR","PRIVATE","PROCEDURE","PUBLIC","RAISE","RANGE","RAW","READ","REAL","RECORD","REF","REFERENCE","RELEASE","RELIES_ON","REM","REMAINDER","RENAME","RESOURCE","RESULT_CACHE","RESULT","RETURN","RETURNING","REVERSE","REVOKE","ROLLBACK","ROW","ROWID","ROWNUM","ROWTYPE","SAMPLE","SAVE","SAVEPOINT","SB1","SB2","SB4","SEARCH","SECOND","SEGMENT","SELF","SEPARATE","SEQUENCE","SERIALIZABLE","SHARE","SHORT","SIZE_T","SIZE","SMALLINT","SOME","SPACE","SPARSE","SQL","SQLCODE","SQLDATA","SQLERRM","SQLNAME","SQLSTATE","STANDARD","START","STATIC","STDDEV","STORED","STRING","STRUCT","STYLE","SUBMULTISET","SUBPARTITION","SUBSTITUTABLE","SUBTYPE","SUCCESSFUL","SUM","SYNONYM","SYSDATE","TABAUTH","TABLE","TDO","THE","THEN","TIME","TIMESTAMP","TIMEZONE_ABBR","TIMEZONE_HOUR","TIMEZONE_MINUTE","TIMEZONE_REGION","TO","TRAILING","TRANSACTION","TRANSACTIONAL","TRIGGER","TRUE","TRUSTED","TYPE","UB1","UB2","UB4","UID","UNDER","UNIQUE","UNPLUG","UNSIGNED","UNTRUSTED","USE","USER","USING","VALIDATE","VALIST","VALUE","VARCHAR","VARCHAR2","VARIABLE","VARIANCE","VARRAY","VARYING","VIEW","VIEWS","VOID","WHENEVER","WHILE","WITH","WORK","WRAPPED","WRITE","YEAR","ZONE"],c=["ADD","ALTER COLUMN","ALTER TABLE","BEGIN","CONNECT BY","DECLARE","DELETE FROM","DELETE","END","EXCEPT","EXCEPTION","FETCH FIRST","FROM","GROUP BY","HAVING","INSERT INTO","INSERT","LIMIT","LOOP","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","START WITH","UPDATE","VALUES","WHERE"],d=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],f=["AND","CROSS APPLY","CROSS JOIN","ELSE","END","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],p=function(e,t){if(e.type===i.default.RESERVED_TOP_LEVEL&&"SET"===e.value&&"BY"===t.value)return e.type=i.default.RESERVED,e},g=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return u||(u=new o.default({reservedWords:s,reservedTopLevelWords:c,reservedNewlineWords:f,reservedTopLevelWordsNoIndent:d,stringTypes:['""',"N''","''","``"],openParens:["(","CASE","BEGIN"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["_","$","#",".","@"]})),new n.default(this.cfg,u,p).format(e)}}])&&l(t.prototype,r),e}();t.default=g,e.exports=t.default},92012:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(65697)),o=i(r(85174));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,u=["ACCESSIBLE","ACTION","AGAINST","AGGREGATE","ALGORITHM","ALL","ALTER","ANALYSE","ANALYZE","AS","ASC","AUTOCOMMIT","AUTO_INCREMENT","BACKUP","BEGIN","BETWEEN","BINLOG","BOTH","CASCADE","CASE","CHANGE","CHANGED","CHARACTER SET","CHARSET","CHECK","CHECKSUM","COLLATE","COLLATION","COLUMN","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPRESSED","CONCURRENT","CONSTRAINT","CONTAINS","CONVERT","CREATE","CROSS","CURRENT_TIMESTAMP","DATABASE","DATABASES","DAY","DAY_HOUR","DAY_MINUTE","DAY_SECOND","DEFAULT","DEFINER","DELAYED","DELETE","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DO","DROP","DUMPFILE","DUPLICATE","DYNAMIC","ELSE","ENCLOSED","END","ENGINE","ENGINES","ENGINE_TYPE","ESCAPE","ESCAPED","EVENTS","EXEC","EXECUTE","EXISTS","EXPLAIN","EXTENDED","FAST","FETCH","FIELDS","FILE","FIRST","FIXED","FLUSH","FOR","FORCE","FOREIGN","FULL","FULLTEXT","FUNCTION","GLOBAL","GRANT","GRANTS","GROUP_CONCAT","HEAP","HIGH_PRIORITY","HOSTS","HOUR","HOUR_MINUTE","HOUR_SECOND","IDENTIFIED","IF","IFNULL","IGNORE","IN","INDEX","INDEXES","INFILE","INSERT","INSERT_ID","INSERT_METHOD","INTERVAL","INTO","INVOKER","IS","ISOLATION","KEY","KEYS","KILL","LAST_INSERT_ID","LEADING","LEVEL","LIKE","LINEAR","LINES","LOAD","LOCAL","LOCK","LOCKS","LOGS","LOW_PRIORITY","MARIA","MASTER","MASTER_CONNECT_RETRY","MASTER_HOST","MASTER_LOG_FILE","MATCH","MAX_CONNECTIONS_PER_HOUR","MAX_QUERIES_PER_HOUR","MAX_ROWS","MAX_UPDATES_PER_HOUR","MAX_USER_CONNECTIONS","MEDIUM","MERGE","MINUTE","MINUTE_SECOND","MIN_ROWS","MODE","MODIFY","MONTH","MRG_MYISAM","MYISAM","NAMES","NATURAL","NOT","NOW()","NULL","OFFSET","ON DELETE","ON UPDATE","ON","ONLY","OPEN","OPTIMIZE","OPTION","OPTIONALLY","OUTFILE","PACK_KEYS","PAGE","PARTIAL","PARTITION","PARTITIONS","PASSWORD","PRIMARY","PRIVILEGES","PROCEDURE","PROCESS","PROCESSLIST","PURGE","QUICK","RAID0","RAID_CHUNKS","RAID_CHUNKSIZE","RAID_TYPE","RANGE","READ","READ_ONLY","READ_WRITE","REFERENCES","REGEXP","RELOAD","RENAME","REPAIR","REPEATABLE","REPLACE","REPLICATION","RESET","RESTORE","RESTRICT","RETURN","RETURNS","REVOKE","RLIKE","ROLLBACK","ROW","ROWS","ROW_FORMAT","SECOND","SECURITY","SEPARATOR","SERIALIZABLE","SESSION","SHARE","SHOW","SHUTDOWN","SLAVE","SONAME","SOUNDS","SQL","SQL_AUTO_IS_NULL","SQL_BIG_RESULT","SQL_BIG_SELECTS","SQL_BIG_TABLES","SQL_BUFFER_RESULT","SQL_CACHE","SQL_CALC_FOUND_ROWS","SQL_LOG_BIN","SQL_LOG_OFF","SQL_LOG_UPDATE","SQL_LOW_PRIORITY_UPDATES","SQL_MAX_JOIN_SIZE","SQL_NO_CACHE","SQL_QUOTE_SHOW_CREATE","SQL_SAFE_UPDATES","SQL_SELECT_LIMIT","SQL_SLAVE_SKIP_COUNTER","SQL_SMALL_RESULT","SQL_WARNINGS","START","STARTING","STATUS","STOP","STORAGE","STRAIGHT_JOIN","STRING","STRIPED","SUPER","TABLE","TABLES","TEMPORARY","TERMINATED","THEN","TO","TRAILING","TRANSACTIONAL","TRUE","TRUNCATE","TYPE","TYPES","UNCOMMITTED","UNIQUE","UNLOCK","UNSIGNED","USAGE","USE","USING","VARIABLES","VIEW","WHEN","WITH","WORK","WRITE","YEAR_MONTH"],s=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INSERT","LIMIT","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS APPLY","CROSS JOIN","ELSE","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],f=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:u,reservedTopLevelWords:s,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"N''","''","``","[]"],openParens:["(","CASE"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:["@",":"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,l).format(e)}}])&&a(t.prototype,r),e}();t.default=f,e.exports=t.default},83405:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=t.format=void 0;var n=l(r(83453)),o=l(r(41353)),i=l(r(24533)),a=l(r(92012));function l(e){return e&&e.__esModule?e:{default:e}}var u=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};switch(t.language){case"db2":return new n.default(t).format(e);case"n1ql":return new o.default(t).format(e);case"pl/sql":return new i.default(t).format(e);case"sql":case void 0:return new a.default(t).format(e);default:throw Error("Unsupported SQL dialect: ".concat(t.language))}};t.format=u;var s={format:u};t.default=s},41194:(e,t,r)=>{e.exports=r(34379)},34379:(e,t)=>{var r=t,n=/`/g,o=/\./g,i=/[\0\b\t\n\r\x1a\"\'\\]/g,a={"\0":"\\0","\b":"\\b","\t":"\\t","\n":"\\n","\r":"\\r","":"\\Z",'"':'\\"',"'":"\\'","\\":"\\\\"};function l(e){for(var t,r=i.lastIndex=0,n="";t=i.exec(e);)n+=e.slice(r,t.index)+a[t[0]],r=i.lastIndex;return 0===r?"'"+e+"'":r<e.length?"'"+n+e.slice(r)+"'":"'"+n+"'"}function u(e,t){for(e=e.toString();e.length<t;)e="0"+e;return e}r.escapeId=function(e,t){if(Array.isArray(e)){for(var i="",a=0;a<e.length;a++)i+=(0===a?"":", ")+r.escapeId(e[a],t);return i}return t?"`"+String(e).replace(n,"``")+"`":"`"+String(e).replace(n,"``").replace(o,"`.`")+"`"},r.escape=function(e,t,n){if(null==e)return"NULL";switch(typeof e){case"boolean":return e?"true":"false";case"number":return e+"";case"object":return"[object Date]"===Object.prototype.toString.call(e)?r.dateToString(e,n||"local"):Array.isArray(e)?r.arrayToList(e,n):Buffer.isBuffer(e)?r.bufferToString(e):"function"==typeof e.toSqlString?String(e.toSqlString()):t?l(e.toString()):r.objectToValues(e,n);default:return l(e)}},r.arrayToList=function(e,t){for(var n="",o=0;o<e.length;o++){var i=e[o];Array.isArray(i)?n+=(0===o?"":", ")+"("+r.arrayToList(i,t)+")":n+=(0===o?"":", ")+r.escape(i,!0,t)}return n},r.format=function(e,t,n,o){if(null==t)return e;Array.isArray(t)||(t=[t]);for(var i,a=0,l=/\?+/g,u="",s=0;s<t.length&&(i=l.exec(e));){var c=i[0].length;if(!(c>2)){var d=2===c?r.escapeId(t[s]):r.escape(t[s],n,o);u+=e.slice(a,i.index)+d,a=l.lastIndex,s++}}return 0===a?e:a<e.length?u+e.slice(a):u},r.dateToString=function(e,t){var r,n,o,i,a,s,c,d=new Date(e);if(isNaN(d.getTime()))return"NULL";if("local"===t)r=d.getFullYear(),n=d.getMonth()+1,o=d.getDate(),i=d.getHours(),a=d.getMinutes(),s=d.getSeconds(),c=d.getMilliseconds();else{var f=function(e){if("Z"===e)return 0;var t=e.match(/([\+\-\s])(\d\d):?(\d\d)?/);return!!t&&("-"===t[1]?-1:1)*(parseInt(t[2],10)+(t[3]?parseInt(t[3],10):0)/60)*60}(t);!1!==f&&0!==f&&d.setTime(d.getTime()+6e4*f),r=d.getUTCFullYear(),n=d.getUTCMonth()+1,o=d.getUTCDate(),i=d.getUTCHours(),a=d.getUTCMinutes(),s=d.getUTCSeconds(),c=d.getUTCMilliseconds()}return l(u(r,4)+"-"+u(n,2)+"-"+u(o,2)+" "+u(i,2)+":"+u(a,2)+":"+u(s,2)+"."+u(c,3))},r.bufferToString=function(e){return"X"+l(e.toString("hex"))},r.objectToValues=function(e,t){var n="";for(var o in e){var i=e[o];"function"!=typeof i&&(n+=(0===n.length?"":", ")+r.escapeId(o)+" = "+r.escape(i,!0,t))}return n},r.raw=function(e){if("string"!=typeof e)throw new TypeError("argument sql must be a string");return{toSqlString:function(){return e}}}},52298:(e,t,r)=>{"use strict";r.r(t),r.d(t,{default:()=>m});var n=r(95292),o=r.n(n),i=r(49893),a=r.n(i),l=r(9383),u=r.n(l),s=r(56884),c=r.n(s),d=r(99088),f=r.n(d),p=r(27997),g=r.n(p),v=r(78701),h={};h.styleTagTransform=g(),h.setAttributes=c(),h.insert=u().bind(null,"head"),h.domAPI=a(),h.insertStyleElement=f(),o()(v.A,h);const m=v.A&&v.A.locals?v.A.locals:void 0},95292:e=>{"use strict";var t=[];function r(e){for(var r=-1,n=0;n<t.length;n++)if(t[n].identifier===e){r=n;break}return r}function n(e,n){for(var i={},a=[],l=0;l<e.length;l++){var u=e[l],s=n.base?u[0]+n.base:u[0],c=i[s]||0,d="".concat(s," ").concat(c);i[s]=c+1;var f=r(d),p={css:u[1],media:u[2],sourceMap:u[3],supports:u[4],layer:u[5]};if(-1!==f)t[f].references++,t[f].updater(p);else{var g=o(p,n);n.byIndex=l,t.splice(l,0,{identifier:d,updater:g,references:1})}a.push(d)}return a}function o(e,t){var r=t.domAPI(t);return r.update(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap&&t.supports===e.supports&&t.layer===e.layer)return;r.update(e=t)}else r.remove()}}e.exports=function(e,o){var i=n(e=e||[],o=o||{});return function(e){e=e||[];for(var a=0;a<i.length;a++){var l=r(i[a]);t[l].references--}for(var u=n(e,o),s=0;s<i.length;s++){var c=r(i[s]);0===t[c].references&&(t[c].updater(),t.splice(c,1))}i=u}}},9383:e=>{"use strict";var t={};e.exports=function(e,r){var n=function(e){if(void 0===t[e]){var r=document.querySelector(e);if(window.HTMLIFrameElement&&r instanceof window.HTMLIFrameElement)try{r=r.contentDocument.head}catch(e){r=null}t[e]=r}return t[e]}(e);if(!n)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");n.appendChild(r)}},99088:e=>{"use strict";e.exports=function(e){var t=document.createElement("style");return e.setAttributes(t,e.attributes),e.insert(t,e.options),t}},56884:(e,t,r)=>{"use strict";e.exports=function(e){var t=r.nc;t&&e.setAttribute("nonce",t)}},49893:e=>{"use strict";e.exports=function(e){if("undefined"==typeof document)return{update:function(){},remove:function(){}};var t=e.insertStyleElement(e);return{update:function(r){!function(e,t,r){var n="";r.supports&&(n+="@supports (".concat(r.supports,") {")),r.media&&(n+="@media ".concat(r.media," {"));var o=void 0!==r.layer;o&&(n+="@layer".concat(r.layer.length>0?" ".concat(r.layer):""," {")),n+=r.css,o&&(n+="}"),r.media&&(n+="}"),r.supports&&(n+="}");var i=r.sourceMap;i&&"undefined"!=typeof btoa&&(n+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(i))))," */")),t.styleTagTransform(n,e,t.options)}(t,e,r)},remove:function(){!function(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e)}(t)}}}},27997:e=>{"use strict";e.exports=function(e,t){if(t.styleSheet)t.styleSheet.cssText=e;else{for(;t.firstChild;)t.removeChild(t.firstChild);t.appendChild(document.createTextNode(e))}}},60062:e=>{e.exports=function(){var e=document.getSelection();if(!e.rangeCount)return function(){};for(var t=document.activeElement,r=[],n=0;n<e.rangeCount;n++)r.push(e.getRangeAt(n));switch(t.tagName.toUpperCase()){case"INPUT":case"TEXTAREA":t.blur();break;default:t=null}return e.removeAllRanges(),function(){"Caret"===e.type&&e.removeAllRanges(),e.rangeCount||r.forEach((function(t){e.addRange(t)})),t&&t.focus()}}},84650:(e,t)=>{"use strict";t.c={linear:function(e){return e},quadratic:function(e){return e*(-e*e*e+4*e*e-6*e+4)},cubic:function(e){return e*(4*e*e-9*e+6)},elastic:function(e){return e*(33*e*e*e*e-106*e*e*e+126*e*e-67*e+15)},inQuad:function(e){return e*e},outQuad:function(e){return e*(2-e)},inOutQuad:function(e){return e<.5?2*e*e:(4-2*e)*e-1},inCubic:function(e){return e*e*e},outCubic:function(e){return--e*e*e+1},inOutCubic:function(e){return e<.5?4*e*e*e:(e-1)*(2*e-2)*(2*e-2)+1},inQuart:function(e){return e*e*e*e},outQuart:function(e){return 1- --e*e*e*e},inOutQuart:function(e){return e<.5?8*e*e*e*e:1-8*--e*e*e*e},inQuint:function(e){return e*e*e*e*e},outQuint:function(e){return 1+--e*e*e*e*e},inOutQuint:function(e){return e<.5?16*e*e*e*e*e:1+16*--e*e*e*e*e},inSine:function(e){return 1-Math.cos(e*(Math.PI/2))},outSine:function(e){return Math.sin(e*(Math.PI/2))},inOutSine:function(e){return-(Math.cos(Math.PI*e)-1)/2},inExpo:function(e){return Math.pow(2,10*(e-1))},outExpo:function(e){return 1-Math.pow(2,-10*e)},inOutExpo:function(e){return(e/=.5)<1?Math.pow(2,10*(e-1))/2:(e--,(2-Math.pow(2,-10*e))/2)},inCirc:function(e){return 1-Math.sqrt(1-e*e)},outCirc:function(e){return Math.sqrt(1-(e-=1)*e)},inOutCirc:function(e){return(e/=.5)<1?-(Math.sqrt(1-e*e)-1)/2:(e-=2,(Math.sqrt(1-e*e)+1)/2)}}},20567:e=>{"use strict";e.exports=function(){}},17103:e=>{"use strict";e.exports=function(e){e.prototype[Symbol.iterator]=function*(){for(let e=this.head;e;e=e.next)yield e.value}}},29691:(e,t,r)=>{"use strict";function n(e){var t=this;if(t instanceof n||(t=new n),t.tail=null,t.head=null,t.length=0,e&&"function"==typeof e.forEach)e.forEach((function(e){t.push(e)}));else if(arguments.length>0)for(var r=0,o=arguments.length;r<o;r++)t.push(arguments[r]);return t}function o(e,t,r){var n=t===e.head?new l(r,null,t,e):new l(r,t,t.next,e);return null===n.next&&(e.tail=n),null===n.prev&&(e.head=n),e.length++,n}function i(e,t){e.tail=new l(t,e.tail,null,e),e.head||(e.head=e.tail),e.length++}function a(e,t){e.head=new l(t,null,e.head,e),e.tail||(e.tail=e.head),e.length++}function l(e,t,r,n){if(!(this instanceof l))return new l(e,t,r,n);this.list=n,this.value=e,t?(t.next=this,this.prev=t):this.prev=null,r?(r.prev=this,this.next=r):this.next=null}e.exports=n,n.Node=l,n.create=n,n.prototype.removeNode=function(e){if(e.list!==this)throw new Error("removing node which does not belong to this list");var t=e.next,r=e.prev;return t&&(t.prev=r),r&&(r.next=t),e===this.head&&(this.head=t),e===this.tail&&(this.tail=r),e.list.length--,e.next=null,e.prev=null,e.list=null,t},n.prototype.unshiftNode=function(e){if(e!==this.head){e.list&&e.list.removeNode(e);var t=this.head;e.list=this,e.next=t,t&&(t.prev=e),this.head=e,this.tail||(this.tail=e),this.length++}},n.prototype.pushNode=function(e){if(e!==this.tail){e.list&&e.list.removeNode(e);var t=this.tail;e.list=this,e.prev=t,t&&(t.next=e),this.tail=e,this.head||(this.head=e),this.length++}},n.prototype.push=function(){for(var e=0,t=arguments.length;e<t;e++)i(this,arguments[e]);return this.length},n.prototype.unshift=function(){for(var e=0,t=arguments.length;e<t;e++)a(this,arguments[e]);return this.length},n.prototype.pop=function(){if(this.tail){var e=this.tail.value;return this.tail=this.tail.prev,this.tail?this.tail.next=null:this.head=null,this.length--,e}},n.prototype.shift=function(){if(this.head){var e=this.head.value;return this.head=this.head.next,this.head?this.head.prev=null:this.tail=null,this.length--,e}},n.prototype.forEach=function(e,t){t=t||this;for(var r=this.head,n=0;null!==r;n++)e.call(t,r.value,n,this),r=r.next},n.prototype.forEachReverse=function(e,t){t=t||this;for(var r=this.tail,n=this.length-1;null!==r;n--)e.call(t,r.value,n,this),r=r.prev},n.prototype.get=function(e){for(var t=0,r=this.head;null!==r&&t<e;t++)r=r.next;if(t===e&&null!==r)return r.value},n.prototype.getReverse=function(e){for(var t=0,r=this.tail;null!==r&&t<e;t++)r=r.prev;if(t===e&&null!==r)return r.value},n.prototype.map=function(e,t){t=t||this;for(var r=new n,o=this.head;null!==o;)r.push(e.call(t,o.value,this)),o=o.next;return r},n.prototype.mapReverse=function(e,t){t=t||this;for(var r=new n,o=this.tail;null!==o;)r.push(e.call(t,o.value,this)),o=o.prev;return r},n.prototype.reduce=function(e,t){var r,n=this.head;if(arguments.length>1)r=t;else{if(!this.head)throw new TypeError("Reduce of empty list with no initial value");n=this.head.next,r=this.head.value}for(var o=0;null!==n;o++)r=e(r,n.value,o),n=n.next;return r},n.prototype.reduceReverse=function(e,t){var r,n=this.tail;if(arguments.length>1)r=t;else{if(!this.tail)throw new TypeError("Reduce of empty list with no initial value");n=this.tail.prev,r=this.tail.value}for(var o=this.length-1;null!==n;o--)r=e(r,n.value,o),n=n.prev;return r},n.prototype.toArray=function(){for(var e=new Array(this.length),t=0,r=this.head;null!==r;t++)e[t]=r.value,r=r.next;return e},n.prototype.toArrayReverse=function(){for(var e=new Array(this.length),t=0,r=this.tail;null!==r;t++)e[t]=r.value,r=r.prev;return e},n.prototype.slice=function(e,t){(t=t||this.length)<0&&(t+=this.length),(e=e||0)<0&&(e+=this.length);var r=new n;if(t<e||t<0)return r;e<0&&(e=0),t>this.length&&(t=this.length);for(var o=0,i=this.head;null!==i&&o<e;o++)i=i.next;for(;null!==i&&o<t;o++,i=i.next)r.push(i.value);return r},n.prototype.sliceReverse=function(e,t){(t=t||this.length)<0&&(t+=this.length),(e=e||0)<0&&(e+=this.length);var r=new n;if(t<e||t<0)return r;e<0&&(e=0),t>this.length&&(t=this.length);for(var o=this.length,i=this.tail;null!==i&&o>t;o--)i=i.prev;for(;null!==i&&o>e;o--,i=i.prev)r.push(i.value);return r},n.prototype.splice=function(e,t,...r){e>this.length&&(e=this.length-1),e<0&&(e=this.length+e);for(var n=0,i=this.head;null!==i&&n<e;n++)i=i.next;var a=[];for(n=0;i&&n<t;n++)a.push(i.value),i=this.removeNode(i);for(null===i&&(i=this.tail),i!==this.head&&i!==this.tail&&(i=i.prev),n=0;n<r.length;n++)i=o(this,i,r[n]);return a},n.prototype.reverse=function(){for(var e=this.head,t=this.tail,r=e;null!==r;r=r.prev){var n=r.prev;r.prev=r.next,r.next=n}return this.head=t,this.tail=e,this};try{r(17103)(n)}catch(e){}},46089:t=>{"use strict";t.exports=e},87781:e=>{"use strict";e.exports=t},18531:e=>{"use strict";e.exports=r},82007:e=>{"use strict";e.exports=n},94706:e=>{"use strict";e.exports=o},20819:e=>{"use strict";e.exports=i},76142:e=>{"use strict";e.exports=a},51724:e=>{"use strict";e.exports=l},26147:e=>{"use strict";e.exports=u},93241:e=>{"use strict";e.exports=s},92468:e=>{"use strict";e.exports=c},28146:e=>{"use strict";e.exports=d},85959:e=>{"use strict";e.exports=f},48398:e=>{"use strict";e.exports=p},30200:e=>{"use strict";e.exports=g},7694:e=>{"use strict";e.exports=v},31269:e=>{"use strict";e.exports=h},78113:e=>{e.exports=function(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n},e.exports.__esModule=!0,e.exports.default=e.exports},70569:e=>{e.exports=function(e){if(Array.isArray(e))return e},e.exports.__esModule=!0,e.exports.default=e.exports},91819:(e,t,r)=>{var n=r(78113);e.exports=function(e){if(Array.isArray(e))return n(e)},e.exports.__esModule=!0,e.exports.default=e.exports},36417:e=>{e.exports=function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e},e.exports.__esModule=!0,e.exports.default=e.exports},58155:e=>{function t(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}e.exports=function(e){return function(){var r=this,n=arguments;return new Promise((function(o,i){var a=e.apply(r,n);function l(e){t(a,o,i,l,u,"next",e)}function u(e){t(a,o,i,l,u,"throw",e)}l(void 0)}))}},e.exports.__esModule=!0,e.exports.default=e.exports},39805:e=>{e.exports=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},e.exports.__esModule=!0,e.exports.default=e.exports},40989:(e,t,r)=>{var n=r(45498);function o(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,n(o.key),o)}}e.exports=function(e,t,r){return t&&o(e.prototype,t),r&&o(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e},e.exports.__esModule=!0,e.exports.default=e.exports},85707:(e,t,r)=>{var n=r(45498);e.exports=function(e,t,r){return(t=n(t))in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e},e.exports.__esModule=!0,e.exports.default=e.exports},78304:e=>{function t(){return e.exports=t=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},e.exports.__esModule=!0,e.exports.default=e.exports,t.apply(this,arguments)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},41621:(e,t,r)=>{var n=r(14718);function o(){return"undefined"!=typeof Reflect&&Reflect.get?(e.exports=o=Reflect.get.bind(),e.exports.__esModule=!0,e.exports.default=e.exports):(e.exports=o=function(e,t,r){var o=n(e,t);if(o){var i=Object.getOwnPropertyDescriptor(o,t);return i.get?i.get.call(arguments.length<3?e:r):i.value}},e.exports.__esModule=!0,e.exports.default=e.exports),o.apply(this,arguments)}e.exports=o,e.exports.__esModule=!0,e.exports.default=e.exports},29402:e=>{function t(r){return e.exports=t=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},87861:(e,t,r)=>{var n=r(91270);e.exports=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&n(e,t)},e.exports.__esModule=!0,e.exports.default=e.exports},96784:e=>{e.exports=function(e){return e&&e.__esModule?e:{default:e}},e.exports.__esModule=!0,e.exports.default=e.exports},20365:e=>{e.exports=function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)},e.exports.__esModule=!0,e.exports.default=e.exports},65474:e=>{e.exports=function(e,t){var r=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=r){var n,o,i,a,l=[],u=!0,s=!1;try{if(i=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;u=!1}else for(;!(u=(n=i.call(r)).done)&&(l.push(n.value),l.length!==t);u=!0);}catch(e){s=!0,o=e}finally{try{if(!u&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(s)throw o}}return l}},e.exports.__esModule=!0,e.exports.default=e.exports},11018:e=>{e.exports=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")},e.exports.__esModule=!0,e.exports.default=e.exports},78687:e=>{e.exports=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")},e.exports.__esModule=!0,e.exports.default=e.exports},40453:(e,t,r)=>{var n=r(10739);e.exports=function(e,t){if(null==e)return{};var r,o,i=n(e,t);if(Object.getOwnPropertySymbols){var a=Object.getOwnPropertySymbols(e);for(o=0;o<a.length;o++)r=a[o],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(i[r]=e[r])}return i},e.exports.__esModule=!0,e.exports.default=e.exports},10739:e=>{e.exports=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o},e.exports.__esModule=!0,e.exports.default=e.exports},15118:(e,t,r)=>{var n=r(10564).default,o=r(36417);e.exports=function(e,t){if(t&&("object"===n(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return o(e)},e.exports.__esModule=!0,e.exports.default=e.exports},53051:(e,t,r)=>{var n=r(10564).default;function o(){"use strict";e.exports=o=function(){return r},e.exports.__esModule=!0,e.exports.default=e.exports;var t,r={},i=Object.prototype,a=i.hasOwnProperty,l=Object.defineProperty||function(e,t,r){e[t]=r.value},u="function"==typeof Symbol?Symbol:{},s=u.iterator||"@@iterator",c=u.asyncIterator||"@@asyncIterator",d=u.toStringTag||"@@toStringTag";function f(e,t,r){return Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{f({},"")}catch(t){f=function(e,t,r){return e[t]=r}}function p(e,t,r,n){var o=t&&t.prototype instanceof E?t:E,i=Object.create(o.prototype),a=new D(n||[]);return l(i,"_invoke",{value:A(e,r,a)}),i}function g(e,t,r){try{return{type:"normal",arg:e.call(t,r)}}catch(e){return{type:"throw",arg:e}}}r.wrap=p;var v="suspendedStart",h="suspendedYield",m="executing",y="completed",b={};function E(){}function O(){}function S(){}var _={};f(_,s,(function(){return this}));var w=Object.getPrototypeOf,T=w&&w(w(L([])));T&&T!==i&&a.call(T,s)&&(_=T);var P=S.prototype=E.prototype=Object.create(_);function C(e){["next","throw","return"].forEach((function(t){f(e,t,(function(e){return this._invoke(t,e)}))}))}function I(e,t){function r(o,i,l,u){var s=g(e[o],e,i);if("throw"!==s.type){var c=s.arg,d=c.value;return d&&"object"==n(d)&&a.call(d,"__await")?t.resolve(d.__await).then((function(e){r("next",e,l,u)}),(function(e){r("throw",e,l,u)})):t.resolve(d).then((function(e){c.value=e,l(c)}),(function(e){return r("throw",e,l,u)}))}u(s.arg)}var o;l(this,"_invoke",{value:function(e,n){function i(){return new t((function(t,o){r(e,n,t,o)}))}return o=o?o.then(i,i):i()}})}function A(e,r,n){var o=v;return function(i,a){if(o===m)throw new Error("Generator is already running");if(o===y){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var l=n.delegate;if(l){var u=R(l,n);if(u){if(u===b)continue;return u}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===v)throw o=y,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=m;var s=g(e,r,n);if("normal"===s.type){if(o=n.done?y:h,s.arg===b)continue;return{value:s.arg,done:n.done}}"throw"===s.type&&(o=y,n.method="throw",n.arg=s.arg)}}}function R(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,R(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a '"+n+"' method")),b;var i=g(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,b;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,b):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,b)}function x(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function N(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function D(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(x,this),this.reset(!0)}function L(e){if(e||""===e){var r=e[s];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function r(){for(;++o<e.length;)if(a.call(e,o))return r.value=e[o],r.done=!1,r;return r.value=t,r.done=!0,r};return i.next=i}}throw new TypeError(n(e)+" is not iterable")}return O.prototype=S,l(P,"constructor",{value:S,configurable:!0}),l(S,"constructor",{value:O,configurable:!0}),O.displayName=f(S,d,"GeneratorFunction"),r.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===O||"GeneratorFunction"===(t.displayName||t.name))},r.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,S):(e.__proto__=S,f(e,d,"GeneratorFunction")),e.prototype=Object.create(P),e},r.awrap=function(e){return{__await:e}},C(I.prototype),f(I.prototype,c,(function(){return this})),r.AsyncIterator=I,r.async=function(e,t,n,o,i){void 0===i&&(i=Promise);var a=new I(p(e,t,n,o),i);return r.isGeneratorFunction(t)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},C(P),f(P,d,"Generator"),f(P,s,(function(){return this})),f(P,"toString",(function(){return"[object Generator]"})),r.keys=function(e){var t=Object(e),r=[];for(var n in t)r.push(n);return r.reverse(),function e(){for(;r.length;){var n=r.pop();if(n in t)return e.value=n,e.done=!1,e}return e.done=!0,e}},r.values=L,D.prototype={constructor:D,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(N),!e)for(var r in this)"t"===r.charAt(0)&&a.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function n(n,o){return l.type="throw",l.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],l=i.completion;if("root"===i.tryLoc)return n("end");if(i.tryLoc<=this.prev){var u=a.call(i,"catchLoc"),s=a.call(i,"finallyLoc");if(u&&s){if(this.prev<i.catchLoc)return n(i.catchLoc,!0);if(this.prev<i.finallyLoc)return n(i.finallyLoc)}else if(u){if(this.prev<i.catchLoc)return n(i.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return n(i.finallyLoc)}}}},abrupt:function(e,t){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&a.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=e,i.arg=t,o?(this.method="next",this.next=o.finallyLoc,b):this.complete(i)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),b},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.finallyLoc===e)return this.complete(r.completion,r.afterLoc),N(r),b}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.tryLoc===e){var n=r.completion;if("throw"===n.type){var o=n.arg;N(r)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:L(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),b}},r}e.exports=o,e.exports.__esModule=!0,e.exports.default=e.exports},91270:e=>{function t(r,n){return e.exports=t=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r,n)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},18821:(e,t,r)=>{var n=r(70569),o=r(65474),i=r(37744),a=r(11018);e.exports=function(e,t){return n(e)||o(e,t)||i(e,t)||a()},e.exports.__esModule=!0,e.exports.default=e.exports},14718:(e,t,r)=>{var n=r(29402);e.exports=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=n(e)););return e},e.exports.__esModule=!0,e.exports.default=e.exports},81719:(e,t,r)=>{var n=r(70569),o=r(20365),i=r(37744),a=r(11018);e.exports=function(e){return n(e)||o(e)||i(e)||a()},e.exports.__esModule=!0,e.exports.default=e.exports},10906:(e,t,r)=>{var n=r(91819),o=r(20365),i=r(37744),a=r(78687);e.exports=function(e){return n(e)||o(e)||i(e)||a()},e.exports.__esModule=!0,e.exports.default=e.exports},11327:(e,t,r)=>{var n=r(10564).default;e.exports=function(e,t){if("object"!==n(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==n(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)},e.exports.__esModule=!0,e.exports.default=e.exports},45498:(e,t,r)=>{var n=r(10564).default,o=r(11327);e.exports=function(e){var t=o(e,"string");return"symbol"===n(t)?t:String(t)},e.exports.__esModule=!0,e.exports.default=e.exports},10564:e=>{function t(r){return e.exports=t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},37744:(e,t,r)=>{var n=r(78113);e.exports=function(e,t){if(e){if("string"==typeof e)return n(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?n(e,t):void 0}},e.exports.__esModule=!0,e.exports.default=e.exports},61790:(e,t,r)=>{var n=r(53051)();e.exports=n;try{regeneratorRuntime=n}catch(e){"object"==typeof globalThis?globalThis.regeneratorRuntime=n:Function("r","regeneratorRuntime = r")(n)}},56147:(e,t)=>{"use strict";function r(e,t,r){return function(n,o){void 0===o&&(o=r);var i=e(n)+o;return t(i)}}function n(e){return function(t){return new Date(e(t).getTime()-1)}}function o(e,t){return function(r){return[e(r),t(r)]}}function i(e){if(e instanceof Date)return e.getFullYear();if("number"==typeof e)return e;var t=parseInt(e,10);if("string"==typeof e&&!isNaN(t))return t;throw new Error("Failed to get year from date: ".concat(e,"."))}function a(e){if(e instanceof Date)return e.getMonth();throw new Error("Failed to get month from date: ".concat(e,"."))}function l(e){if(e instanceof Date)return e.getMonth()+1;throw new Error("Failed to get human-readable month from date: ".concat(e,"."))}function u(e){if(e instanceof Date)return e.getDate();throw new Error("Failed to get year from date: ".concat(e,"."))}function s(e){if(e instanceof Date)return e.getHours();if("string"==typeof e){var t=e.split(":");if(t.length>=2){var r=t[0];if(r){var n=parseInt(r,10);if(!isNaN(n))return n}}}throw new Error("Failed to get hours from date: ".concat(e,"."))}function c(e){if(e instanceof Date)return e.getMinutes();if("string"==typeof e){var t=e.split(":");if(t.length>=2){var r=t[1]||"0",n=parseInt(r,10);if(!isNaN(n))return n}}throw new Error("Failed to get minutes from date: ".concat(e,"."))}function d(e){if(e instanceof Date)return e.getSeconds();if("string"==typeof e){var t=e.split(":");if(t.length>=2){var r=t[2]||"0",n=parseInt(r,10);if(!isNaN(n))return n}}throw new Error("Failed to get seconds from date: ".concat(e,"."))}function f(e){var t=i(e),r=t+(1-t)%100,n=new Date;return n.setFullYear(r,0,1),n.setHours(0,0,0,0),n}function p(e){var t=i(e),r=t+(1-t)%10,n=new Date;return n.setFullYear(r,0,1),n.setHours(0,0,0,0),n}function g(e){var t=i(e),r=new Date;return r.setFullYear(t,0,1),r.setHours(0,0,0,0),r}function v(e,t){return function(r,n){void 0===n&&(n=t);var o=i(r),l=a(r)+n,u=new Date;return u.setFullYear(o,l,1),u.setHours(0,0,0,0),e(u)}}function h(e){var t=i(e),r=a(e),n=new Date;return n.setFullYear(t,r,1),n.setHours(0,0,0,0),n}function m(e,t){return function(r,n){void 0===n&&(n=t);var o=i(r),l=a(r),s=u(r)+n,c=new Date;return c.setFullYear(o,l,s),c.setHours(0,0,0,0),e(c)}}function y(e){var t=i(e),r=a(e),n=u(e),o=new Date;return o.setFullYear(t,r,n),o.setHours(0,0,0,0),o}function b(e,t){void 0===t&&(t=2);var r="".concat(e);return r.length>=t?e:"0000".concat(r).slice(-t)}function E(e){var t=b(s(e)),r=b(c(e)),n=b(d(e));return"".concat(t,":").concat(r,":").concat(n)}function O(e){var t=b(i(e),4),r=b(l(e)),n=b(u(e));return"".concat(t,"-").concat(r,"-").concat(n)}Object.defineProperty(t,"__esModule",{value:!0}),t.getISOLocalDateTime=t.getISOLocalDate=t.getISOLocalMonth=t.getHoursMinutesSeconds=t.getHoursMinutes=t.getDaysInMonth=t.getDayRange=t.getNextDayEnd=t.getPreviousDayEnd=t.getDayEnd=t.getNextDayStart=t.getPreviousDayStart=t.getDayStart=t.getMonthRange=t.getNextMonthEnd=t.getPreviousMonthEnd=t.getMonthEnd=t.getNextMonthStart=t.getPreviousMonthStart=t.getMonthStart=t.getYearRange=t.getNextYearEnd=t.getPreviousYearEnd=t.getYearEnd=t.getNextYearStart=t.getPreviousYearStart=t.getYearStart=t.getDecadeRange=t.getNextDecadeEnd=t.getPreviousDecadeEnd=t.getDecadeEnd=t.getNextDecadeStart=t.getPreviousDecadeStart=t.getDecadeStart=t.getCenturyRange=t.getNextCenturyEnd=t.getPreviousCenturyEnd=t.getCenturyEnd=t.getNextCenturyStart=t.getPreviousCenturyStart=t.getCenturyStart=t.getMilliseconds=t.getSeconds=t.getMinutes=t.getHours=t.getDate=t.getMonthHuman=t.getMonth=t.getYear=void 0,t.getYear=i,t.getMonth=a,t.getMonthHuman=l,t.getDate=u,t.getHours=s,t.getMinutes=c,t.getSeconds=d,t.getMilliseconds=function(e){if(e instanceof Date)return e.getMilliseconds();if("string"==typeof e){var t=e.split(":");if(t.length>=2){var r=(t[2]||"0").split(".")[1]||"0",n=parseInt(r,10);if(!isNaN(n))return n}}throw new Error("Failed to get seconds from date: ".concat(e,"."))},t.getCenturyStart=f,t.getPreviousCenturyStart=r(i,f,-100),t.getNextCenturyStart=r(i,f,100),t.getCenturyEnd=n(t.getNextCenturyStart),t.getPreviousCenturyEnd=r(i,t.getCenturyEnd,-100),t.getNextCenturyEnd=r(i,t.getCenturyEnd,100),t.getCenturyRange=o(f,t.getCenturyEnd),t.getDecadeStart=p,t.getPreviousDecadeStart=r(i,p,-10),t.getNextDecadeStart=r(i,p,10),t.getDecadeEnd=n(t.getNextDecadeStart),t.getPreviousDecadeEnd=r(i,t.getDecadeEnd,-10),t.getNextDecadeEnd=r(i,t.getDecadeEnd,10),t.getDecadeRange=o(p,t.getDecadeEnd),t.getYearStart=g,t.getPreviousYearStart=r(i,g,-1),t.getNextYearStart=r(i,g,1),t.getYearEnd=n(t.getNextYearStart),t.getPreviousYearEnd=r(i,t.getYearEnd,-1),t.getNextYearEnd=r(i,t.getYearEnd,1),t.getYearRange=o(g,t.getYearEnd),t.getMonthStart=h,t.getPreviousMonthStart=v(h,-1),t.getNextMonthStart=v(h,1),t.getMonthEnd=n(t.getNextMonthStart),t.getPreviousMonthEnd=v(t.getMonthEnd,-1),t.getNextMonthEnd=v(t.getMonthEnd,1),t.getMonthRange=o(h,t.getMonthEnd),t.getDayStart=y,t.getPreviousDayStart=m(y,-1),t.getNextDayStart=m(y,1),t.getDayEnd=n(t.getNextDayStart),t.getPreviousDayEnd=m(t.getDayEnd,-1),t.getNextDayEnd=m(t.getDayEnd,1),t.getDayRange=o(y,t.getDayEnd),t.getDaysInMonth=function(e){return u((0,t.getMonthEnd)(e))},t.getHoursMinutes=function(e){var t=b(s(e)),r=b(c(e));return"".concat(t,":").concat(r)},t.getHoursMinutesSeconds=E,t.getISOLocalMonth=function(e){var t=b(i(e),4),r=b(l(e));return"".concat(t,"-").concat(r)},t.getISOLocalDate=O,t.getISOLocalDateTime=function(e){return"".concat(O(e),"T").concat(E(e))}},95159:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.getUserLocale=t.getUserLocales=void 0;var o=n(r(36682));function i(e){return JSON.stringify(e)}function a(e){return"string"==typeof e}function l(e,t,r){return r.indexOf(e)===t}function u(e){return-1===e.indexOf(",")?e:e.split(",")}function s(e){if(!e)return e;if("C"===e||"posix"===e||"POSIX"===e)return"en-US";if(-1!==e.indexOf(".")){var t=e.split(".")[0];return s(void 0===t?"":t)}if(-1!==e.indexOf("@")){var r=e.split("@")[0];return s(void 0===r?"":r)}if(-1===e.indexOf("-")||(n=e).toLowerCase()!==n)return e;var n,o=e.split("-"),i=o[0],a=o[1],l=void 0===a?"":a;return"".concat(i,"-").concat(l.toUpperCase())}t.getUserLocales=(0,o.default)((function(e){var t=void 0===e?{}:e,r=t.useFallbackLocale,n=void 0===r||r,o=t.fallbackLocale,i=void 0===o?"en-US":o,c=[];if("undefined"!=typeof navigator){for(var d=[],f=0,p=navigator.languages||[];f<p.length;f++){var g=p[f];d=d.concat(u(g))}var v=navigator.language,h=v?u(v):v;c=c.concat(d,h)}return n&&c.push(i),c.filter(a).map(s).filter(l)}),i),t.getUserLocale=(0,o.default)((function(e){return(0,t.getUserLocales)(e)[0]||null}),i),t.default=t.getUserLocale},56672:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__createBinding||(Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]}),i=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),a=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&o(t,e,r);return i(t,e),t},l=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var u=a(r(85959)),s=l(r(50012)),c=l(r(78784)),d=l(r(16169)),f=l(r(76473)),p=l(r(58735)),g=l(r(41866)),v=l(r(42603)),h=r(45649),m=r(18346),y=r(75825),b="react-calendar",E=["century","decade","year","month"],O=["decade","year","month","day"],S=new Date;S.setFullYear(1,0,1),S.setHours(0,0,0,0);var _=new Date(864e13);function w(e){return e instanceof Date?e:new Date(e)}function T(e,t){return E.slice(E.indexOf(e),E.indexOf(t)+1)}function P(e,t,r){return e&&function(e,t,r){return-1!==T(t,r).indexOf(e)}(e,t,r)?e:r}function C(e){var t=E.indexOf(e);return O[t]}function I(e,t){var r=e.value,n=e.minDate,o=e.maxDate,i=e.maxDetail,a=function(e,t){var r=Array.isArray(e)?e[t]:e;if(!r)return null;var n=w(r);if(isNaN(n.getTime()))throw new Error("Invalid date: ".concat(e));return n}(r,t);if(!a)return null;var l=C(i),u=function(){switch(t){case 0:return(0,h.getBegin)(l,a);case 1:return(0,h.getEnd)(l,a);default:throw new Error("Invalid index value: ".concat(t))}}();return(0,y.between)(u,n,o)}var A=function(e){return I(e,0)},R=function(e){return I(e,1)},x=function(e){return[A,R].map((function(t){return t(e)}))};function N(e){var t=e.maxDate,r=e.maxDetail,n=e.minDate,o=e.minDetail,i=e.value,a=P(e.view,o,r),l=A({value:i,minDate:n,maxDate:t,maxDetail:r})||new Date;return(0,h.getBegin)(a,l)}function D(e){return e&&(!Array.isArray(e)||1===e.length)}function L(e,t){return e instanceof Date&&t instanceof Date&&e.getTime()===t.getTime()}var j=(0,u.forwardRef)((function(e,t){var r,o=e.activeStartDate,i=e.allowPartialRange,a=e.calendarType,l=e.className,s=e.defaultActiveStartDate,m=e.defaultValue,y=e.defaultView,E=e.formatDay,O=e.formatLongDate,I=e.formatMonth,j=e.formatMonthYear,M=e.formatShortWeekday,k=e.formatWeekday,F=e.formatYear,q=e.goToRangeStartOnSelect,V=void 0===q||q,B=e.inputRef,U=e.locale,W=e.maxDate,G=void 0===W?_:W,H=e.maxDetail,K=void 0===H?"month":H,$=e.minDate,z=void 0===$?S:$,Y=e.minDetail,Q=void 0===Y?"century":Y,X=e.navigationAriaLabel,J=e.navigationAriaLive,Z=e.navigationLabel,ee=e.next2AriaLabel,te=e.next2Label,re=e.nextAriaLabel,ne=e.nextLabel,oe=e.onActiveStartDateChange,ie=e.onChange,ae=e.onClickDay,le=e.onClickDecade,ue=e.onClickMonth,se=e.onClickWeekNumber,ce=e.onClickYear,de=e.onDrillDown,fe=e.onDrillUp,pe=e.onViewChange,ge=e.prev2AriaLabel,ve=e.prev2Label,he=e.prevAriaLabel,me=e.prevLabel,ye=e.returnValue,be=void 0===ye?"start":ye,Ee=e.selectRange,Oe=e.showDoubleView,Se=e.showFixedNumberOfWeeks,_e=e.showNavigation,we=void 0===_e||_e,Te=e.showNeighboringCentury,Pe=e.showNeighboringDecade,Ce=e.showNeighboringMonth,Ie=void 0===Ce||Ce,Ae=e.showWeekNumbers,Re=e.tileClassName,xe=e.tileContent,Ne=e.tileDisabled,De=e.value,Le=e.view,je=(0,u.useState)(s),Me=je[0],ke=je[1],Fe=(0,u.useState)(null),qe=Fe[0],Ve=Fe[1],Be=(0,u.useState)(Array.isArray(m)?m.map((function(e){return null!==e?w(e):null})):null!=m?w(m):null),Ue=Be[0],We=Be[1],Ge=(0,u.useState)(y),He=Ge[0],Ke=Ge[1],$e=o||Me||function(e){var t=e.activeStartDate,r=e.defaultActiveStartDate,n=e.defaultValue,o=e.defaultView,i=e.maxDate,a=e.maxDetail,l=e.minDate,u=e.minDetail,s=e.value,c=e.view,d=P(c,u,a),f=t||r;return f?(0,h.getBegin)(d,f):N({maxDate:i,maxDetail:a,minDate:l,minDetail:u,value:s||n,view:c||o})}({activeStartDate:o,defaultActiveStartDate:s,defaultValue:m,defaultView:y,maxDate:G,maxDetail:K,minDate:z,minDetail:Q,value:De,view:Le}),ze=(r=Ee&&D(Ue)?Ue:void 0!==De?De:Ue)?Array.isArray(r)?r.map((function(e){return null!==e?w(e):null})):null!==r?w(r):null:null,Ye=C(K),Qe=P(Le||He,Q,K),Xe=T(Q,K),Je=Ee?qe:null,Ze=Xe.indexOf(Qe)<Xe.length-1,et=Xe.indexOf(Qe)>0,tt=(0,u.useCallback)((function(e){return function(){switch(be){case"start":return A;case"end":return R;case"range":return x;default:throw new Error("Invalid returnValue.")}}()({maxDate:G,maxDetail:K,minDate:z,value:e})}),[G,K,z,be]),rt=(0,u.useCallback)((function(e,t){ke(e);var r={action:t,activeStartDate:e,value:ze,view:Qe};oe&&!L($e,e)&&oe(r)}),[$e,oe,ze,Qe]),nt=(0,u.useCallback)((function(e,t){var r=function(){switch(Qe){case"century":return le;case"decade":return ce;case"year":return ue;case"month":return ae;default:throw new Error("Invalid view: ".concat(Qe,"."))}}();r&&r(e,t)}),[ae,le,ue,ce,Qe]),ot=(0,u.useCallback)((function(e,t){if(Ze){nt(e,t);var r=Xe[Xe.indexOf(Qe)+1];if(!r)throw new Error("Attempted to drill down from the lowest view.");ke(e),Ke(r);var n={action:"drillDown",activeStartDate:e,value:ze,view:r};oe&&!L($e,e)&&oe(n),pe&&Qe!==r&&pe(n),de&&de(n)}}),[$e,Ze,oe,nt,de,pe,ze,Qe,Xe]),it=(0,u.useCallback)((function(){if(et){var e=Xe[Xe.indexOf(Qe)-1];if(!e)throw new Error("Attempted to drill up from the highest view.");var t=(0,h.getBegin)(e,$e);ke(t),Ke(e);var r={action:"drillUp",activeStartDate:t,value:ze,view:e};oe&&!L($e,t)&&oe(r),pe&&Qe!==e&&pe(r),fe&&fe(r)}}),[$e,et,oe,fe,pe,ze,Qe,Xe]),at=(0,u.useCallback)((function(e,t){var r=ze;nt(e,t);var n,o=Ee&&!D(r);if(Ee)if(o)n=(0,h.getBegin)(Ye,e);else{if(!r)throw new Error("previousValue is required");if(Array.isArray(r))throw new Error("previousValue must not be an array");n=(0,h.getValueRange)(Ye,r,e)}else n=tt(e);var a=!Ee||o||V?N({maxDate:G,maxDetail:K,minDate:z,minDetail:Q,value:n,view:Qe}):null;t.persist(),ke(a),We(n);var l={action:"onChange",activeStartDate:a,value:n,view:Qe};if(oe&&!L($e,a)&&oe(l),ie)if(Ee)if(D(n)){if(i){if(Array.isArray(n))throw new Error("value must not be an array");ie([n||null,null],t)}}else ie(n||null,t);else ie(n||null,t)}),[$e,i,tt,V,G,K,z,Q,oe,ie,nt,Ee,ze,Ye,Qe]);function lt(e){Ve(e)}function ut(){Ve(null)}function st(e){var t={activeStartDate:e?(0,h.getBeginNext)(Qe,$e):(0,h.getBegin)(Qe,$e),hover:Je,locale:U,maxDate:G,minDate:z,onClick:Ze?ot:at,onMouseOver:Ee?lt:void 0,tileClassName:Re,tileContent:xe,tileDisabled:Ne,value:ze,valueType:Ye};switch(Qe){case"century":return u.default.createElement(f.default,n({formatYear:F,showNeighboringCentury:Te},t));case"decade":return u.default.createElement(p.default,n({formatYear:F,showNeighboringDecade:Pe},t));case"year":return u.default.createElement(g.default,n({formatMonth:I,formatMonthYear:j},t));case"month":return u.default.createElement(v.default,n({calendarType:a,formatDay:E,formatLongDate:O,formatShortWeekday:M,formatWeekday:k,onClickWeekNumber:se,onMouseLeave:Ee?ut:void 0,showFixedNumberOfWeeks:void 0!==Se?Se:Oe,showNeighboringMonth:Ie,showWeekNumbers:Ae},t));default:throw new Error("Invalid view: ".concat(Qe,"."))}}(0,u.useImperativeHandle)(t,(function(){return{activeStartDate:$e,drillDown:ot,drillUp:it,onChange:at,setActiveStartDate:rt,value:ze,view:Qe}}),[$e,ot,it,at,rt,ze,Qe]);var ct=Array.isArray(ze)?ze:[ze];return u.default.createElement("div",{className:(0,c.default)(b,Ee&&1===ct.length&&"".concat(b,"--selectRange"),Oe&&"".concat(b,"--doubleView"),l),ref:B},we?u.default.createElement(d.default,{activeStartDate:$e,drillUp:it,formatMonthYear:j,formatYear:F,locale:U,maxDate:G,minDate:z,navigationAriaLabel:X,navigationAriaLive:J,navigationLabel:Z,next2AriaLabel:ee,next2Label:te,nextAriaLabel:re,nextLabel:ne,prev2AriaLabel:ge,prev2Label:ve,prevAriaLabel:he,prevLabel:me,setActiveStartDate:rt,showDoubleView:Oe,view:Qe,views:Xe}):null,u.default.createElement("div",{className:"".concat(b,"__viewContainer"),onBlur:Ee?ut:void 0,onMouseLeave:Ee?ut:void 0},st(),Oe?st(!0):null))})),M=s.default.instanceOf(Date),k=s.default.oneOfType([s.default.string,s.default.instanceOf(Date)]),F=s.default.oneOfType([k,(0,m.rangeOf)(k)]);j.propTypes={activeStartDate:M,allowPartialRange:s.default.bool,calendarType:m.isCalendarType,className:m.isClassName,defaultActiveStartDate:M,defaultValue:F,defaultView:m.isView,formatDay:s.default.func,formatLongDate:s.default.func,formatMonth:s.default.func,formatMonthYear:s.default.func,formatShortWeekday:s.default.func,formatWeekday:s.default.func,formatYear:s.default.func,goToRangeStartOnSelect:s.default.bool,inputRef:m.isRef,locale:s.default.string,maxDate:m.isMaxDate,maxDetail:s.default.oneOf(E),minDate:m.isMinDate,minDetail:s.default.oneOf(E),navigationAriaLabel:s.default.string,navigationAriaLive:s.default.oneOf(["off","polite","assertive"]),navigationLabel:s.default.func,next2AriaLabel:s.default.string,next2Label:s.default.node,nextAriaLabel:s.default.string,nextLabel:s.default.node,onActiveStartDateChange:s.default.func,onChange:s.default.func,onClickDay:s.default.func,onClickDecade:s.default.func,onClickMonth:s.default.func,onClickWeekNumber:s.default.func,onClickYear:s.default.func,onDrillDown:s.default.func,onDrillUp:s.default.func,onViewChange:s.default.func,prev2AriaLabel:s.default.string,prev2Label:s.default.node,prevAriaLabel:s.default.string,prevLabel:s.default.node,returnValue:s.default.oneOf(["start","end","range"]),selectRange:s.default.bool,showDoubleView:s.default.bool,showFixedNumberOfWeeks:s.default.bool,showNavigation:s.default.bool,showNeighboringCentury:s.default.bool,showNeighboringDecade:s.default.bool,showNeighboringMonth:s.default.bool,showWeekNumbers:s.default.bool,tileClassName:s.default.oneOfType([s.default.func,m.isClassName]),tileContent:s.default.oneOfType([s.default.func,s.default.node]),tileDisabled:s.default.func,value:F,view:m.isView},t.default=j},16169:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(r(85959)),i=r(95159),a=r(45649),l=r(75730),u="react-calendar__navigation";t.default=function(e){var t,r=e.activeStartDate,n=e.drillUp,s=e.formatMonthYear,c=void 0===s?l.formatMonthYear:s,d=e.formatYear,f=void 0===d?l.formatYear:d,p=e.locale,g=e.maxDate,v=e.minDate,h=e.navigationAriaLabel,m=void 0===h?"":h,y=e.navigationAriaLive,b=e.navigationLabel,E=e.next2AriaLabel,O=void 0===E?"":E,S=e.next2Label,_=void 0===S?"»":S,w=e.nextAriaLabel,T=void 0===w?"":w,P=e.nextLabel,C=void 0===P?"›":P,I=e.prev2AriaLabel,A=void 0===I?"":I,R=e.prev2Label,x=void 0===R?"«":R,N=e.prevAriaLabel,D=void 0===N?"":N,L=e.prevLabel,j=void 0===L?"‹":L,M=e.setActiveStartDate,k=e.showDoubleView,F=e.view,q=e.views.indexOf(F)>0,V="century"!==F,B=(0,a.getBeginPrevious)(F,r),U=V?(0,a.getBeginPrevious2)(F,r):void 0,W=(0,a.getBeginNext)(F,r),G=V?(0,a.getBeginNext2)(F,r):void 0,H=function(){if(B.getFullYear()<0)return!0;var e=(0,a.getEndPrevious)(F,r);return v&&v>=e}(),K=V&&function(){if(U.getFullYear()<0)return!0;var e=(0,a.getEndPrevious2)(F,r);return v&&v>=e}(),$=g&&g<W,z=V&&g&&g<G;function Y(e){var t=function(){switch(F){case"century":return(0,a.getCenturyLabel)(p,f,e);case"decade":return(0,a.getDecadeLabel)(p,f,e);case"year":return f(p,e);case"month":return c(p,e);default:throw new Error("Invalid view: ".concat(F,"."))}}();return b?b({date:e,label:t,locale:p||(0,i.getUserLocale)()||void 0,view:F}):t}return o.default.createElement("div",{className:u},null!==x&&V?o.default.createElement("button",{"aria-label":A,className:"".concat(u,"__arrow ").concat(u,"__prev2-button"),disabled:K,onClick:function(){M(U,"prev2")},type:"button"},x):null,null!==j&&o.default.createElement("button",{"aria-label":D,className:"".concat(u,"__arrow ").concat(u,"__prev-button"),disabled:H,onClick:function(){M(B,"prev")},type:"button"},j),(t="".concat(u,"__label"),o.default.createElement("button",{"aria-label":m,"aria-live":y,className:t,disabled:!q,onClick:n,style:{flexGrow:1},type:"button"},o.default.createElement("span",{className:"".concat(t,"__labelText ").concat(t,"__labelText--from")},Y(r)),k?o.default.createElement(o.default.Fragment,null,o.default.createElement("span",{className:"".concat(t,"__divider")}," – "),o.default.createElement("span",{className:"".concat(t,"__labelText ").concat(t,"__labelText--to")},Y(W))):null)),null!==C&&o.default.createElement("button",{"aria-label":T,className:"".concat(u,"__arrow ").concat(u,"__next-button"),disabled:$,onClick:function(){M(W,"next")},type:"button"},C),null!==_&&V?o.default.createElement("button",{"aria-label":O,className:"".concat(u,"__arrow ").concat(u,"__next2-button"),disabled:z,onClick:function(){M(G,"next2")},type:"button"},_):null)}},76473:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var i=o(r(85959)),a=o(r(50012)),l=o(r(30247)),u=r(18346),s=function(e){return i.default.createElement("div",{className:"react-calendar__century-view"},i.default.createElement(l.default,n({},e)))};s.propTypes=n(n({},u.tileGroupProps),{showNeighboringCentury:a.default.bool}),t.default=s},62008:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(11078)),s=r(45649),c=r(75730),d="react-calendar__century-view__decades__decade";t.default=function(e){var t=e.classes,r=void 0===t?[]:t,i=e.currentCentury,f=e.formatYear,p=void 0===f?c.formatYear:f,g=o(e,["classes","currentCentury","formatYear"]),v=g.date,h=g.locale,m=[];return r&&m.push.apply(m,r),d&&m.push(d),(0,l.getCenturyStart)(v).getFullYear()!==i&&m.push("".concat(d,"--neighboringCentury")),a.default.createElement(u.default,n({},g,{classes:m,maxDateTransform:l.getDecadeEnd,minDateTransform:l.getDecadeStart,view:"century"}),(0,s.getDecadeLabel)(h,p,v))}},30247:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(3603)),s=i(r(62008)),c=r(45649);t.default=function(e){var t=e.activeStartDate,r=e.hover,i=e.showNeighboringCentury,d=e.value,f=e.valueType,p=o(e,["activeStartDate","hover","showNeighboringCentury","value","valueType"]),g=(0,c.getBeginOfCenturyYear)(t),v=g+(i?119:99);return a.default.createElement(u.default,{className:"react-calendar__century-view__decades",dateTransform:l.getDecadeStart,dateType:"decade",end:v,hover:r,renderTile:function(e){var r=e.date,i=o(e,["date"]);return a.default.createElement(s.default,n({key:r.getTime()},p,i,{activeStartDate:t,currentCentury:g,date:r}))},start:g,step:10,value:d,valueType:f})}},58735:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var i=o(r(85959)),a=o(r(50012)),l=o(r(68806)),u=r(18346),s=function(e){return i.default.createElement("div",{className:"react-calendar__decade-view"},i.default.createElement(l.default,n({},e)))};s.propTypes=n(n({},u.tileGroupProps),{showNeighboringDecade:a.default.bool}),t.default=s},55907:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(11078)),s=r(75730),c="react-calendar__decade-view__years__year";t.default=function(e){var t=e.classes,r=void 0===t?[]:t,i=e.currentDecade,d=e.formatYear,f=void 0===d?s.formatYear:d,p=o(e,["classes","currentDecade","formatYear"]),g=p.date,v=p.locale,h=[];return r&&h.push.apply(h,r),c&&h.push(c),(0,l.getDecadeStart)(g).getFullYear()!==i&&h.push("".concat(c,"--neighboringDecade")),a.default.createElement(u.default,n({},p,{classes:h,maxDateTransform:l.getYearEnd,minDateTransform:l.getYearStart,view:"decade"}),f(v,g))}},68806:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(3603)),s=i(r(55907)),c=r(45649);t.default=function(e){var t=e.activeStartDate,r=e.hover,i=e.showNeighboringDecade,d=e.value,f=e.valueType,p=o(e,["activeStartDate","hover","showNeighboringDecade","value","valueType"]),g=(0,c.getBeginOfDecadeYear)(t),v=g+(i?11:9);return a.default.createElement(u.default,{className:"react-calendar__decade-view__years",dateTransform:l.getYearStart,dateType:"year",end:v,hover:r,renderTile:function(e){var r=e.date,i=o(e,["date"]);return a.default.createElement(s.default,n({key:r.getTime()},p,i,{activeStartDate:t,currentDecade:g,date:r}))},start:g,value:d,valueType:f})}},32857:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959));function l(e){return"".concat(e,"%")}t.default=function(e){var t=e.children,r=e.className,i=e.count,u=e.direction,s=e.offset,c=e.style,d=e.wrap,f=o(e,["children","className","count","direction","offset","style","wrap"]);return a.default.createElement("div",n({className:r,style:n({display:"flex",flexDirection:u,flexWrap:d?"wrap":"nowrap"},c)},f),a.default.Children.map(t,(function(e,t){var r=s&&0===t?l(100*s/i):null;return a.default.cloneElement(e,n(n({},e.props),{style:{flexBasis:l(100/i),flexShrink:0,flexGrow:0,overflow:"hidden",marginLeft:r,marginInlineStart:r,marginInlineEnd:0}}))})))}},42603:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=i(r(50012)),u=i(r(78784)),s=i(r(78609)),c=i(r(92841)),d=i(r(94206)),f=r(96643),p=r(18346),g=function(e){var t=e.activeStartDate,r=e.locale,i=e.onMouseLeave,l=e.showFixedNumberOfWeeks,p=e.calendarType,g=void 0===p?function(e){if(e)for(var t=0,r=Object.entries(f.CALENDAR_TYPE_LOCALES);t<r.length;t++){var n=r[t],o=n[0];if(n[1].includes(e))return o}return f.CALENDAR_TYPES.ISO_8601}(r):p,v=e.formatShortWeekday,h=e.formatWeekday,m=e.onClickWeekNumber,y=e.showWeekNumbers,b=o(e,["calendarType","formatShortWeekday","formatWeekday","onClickWeekNumber","showWeekNumbers"]),E="react-calendar__month-view";return a.default.createElement("div",{className:(0,u.default)(E,y?"".concat(E,"--weekNumbers"):"")},a.default.createElement("div",{style:{display:"flex",alignItems:"flex-end"}},y?a.default.createElement(d.default,{activeStartDate:t,calendarType:g,onClickWeekNumber:m,onMouseLeave:i,showFixedNumberOfWeeks:l}):null,a.default.createElement("div",{style:{flexGrow:1,width:"100%"}},a.default.createElement(c.default,{calendarType:g,formatShortWeekday:v,formatWeekday:h,locale:r,onMouseLeave:i}),a.default.createElement(s.default,n({calendarType:g},b)))))};g.propTypes=n(n({},p.tileGroupProps),{calendarType:p.isCalendarType,formatDay:l.default.func,formatLongDate:l.default.func,formatShortWeekday:l.default.func,formatWeekday:l.default.func,onClickWeekNumber:l.default.func,onMouseLeave:l.default.func,showFixedNumberOfWeeks:l.default.bool,showNeighboringMonth:l.default.bool,showWeekNumbers:l.default.bool}),t.default=g},81746:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(11078)),s=r(45649),c=r(75730),d=r(75825),f="react-calendar__month-view__days__day";t.default=function(e){var t=e.calendarType,r=e.classes,i=void 0===r?[]:r,p=e.currentMonthIndex,g=e.formatDay,v=void 0===g?c.formatDay:g,h=e.formatLongDate,m=void 0===h?c.formatLongDate:h,y=o(e,["calendarType","classes","currentMonthIndex","formatDay","formatLongDate"]),b=(0,d.mapCalendarType)(t),E=y.date,O=y.locale,S=[];return i&&S.push.apply(S,i),f&&S.push(f),(0,s.isWeekend)(E,b)&&S.push("".concat(f,"--weekend")),E.getMonth()!==p&&S.push("".concat(f,"--neighboringMonth")),a.default.createElement(u.default,n({},y,{classes:S,formatAbbr:m,maxDateTransform:l.getDayEnd,minDateTransform:l.getDayStart,view:"month"}),v(O,E))}},78609:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(3603)),s=i(r(81746)),c=r(45649),d=r(75825);t.default=function(e){var t=e.activeStartDate,r=e.calendarType,i=e.hover,f=e.showFixedNumberOfWeeks,p=e.showNeighboringMonth,g=e.value,v=e.valueType,h=o(e,["activeStartDate","calendarType","hover","showFixedNumberOfWeeks","showNeighboringMonth","value","valueType"]),m=(0,d.mapCalendarType)(r),y=(0,l.getYear)(t),b=(0,l.getMonth)(t),E=f||p,O=(0,c.getDayOfWeek)(t,m),S=E?0:O,_=1+(E?-O:0),w=function(){if(f)return _+42-1;var e=(0,l.getDaysInMonth)(t);if(p){var r=new Date;return r.setFullYear(y,b,e),r.setHours(0,0,0,0),e+(7-(0,c.getDayOfWeek)(r,m)-1)}return e}();return a.default.createElement(u.default,{className:"react-calendar__month-view__days",count:7,dateTransform:function(e){var t=new Date;return t.setFullYear(y,b,e),(0,l.getDayStart)(t)},dateType:"day",hover:i,end:w,renderTile:function(e){var i=e.date,l=o(e,["date"]);return a.default.createElement(s.default,n({key:i.getTime()},h,l,{activeStartDate:t,calendarType:r,currentMonthIndex:b,date:i}))},offset:S,start:_,value:g,valueType:v})}},31115:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l="react-calendar__tile";t.default=function(e){var t=e.onClickWeekNumber,r=e.weekNumber,i=a.default.createElement("span",null,r);if(t){var u=e.date,s=e.onClickWeekNumber,c=e.weekNumber,d=o(e,["date","onClickWeekNumber","weekNumber"]);return a.default.createElement("button",n({},d,{className:l,onClick:function(e){return s(c,u,e)},type:"button"}),i)}return e.date,e.onClickWeekNumber,e.weekNumber,d=o(e,["date","onClickWeekNumber","weekNumber"]),a.default.createElement("div",n({},d,{className:l}),i)}},94206:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(r(85959)),i=r(56147),a=n(r(31115)),l=n(r(32857)),u=r(45649),s=r(75825);t.default=function(e){var t=e.activeStartDate,r=e.calendarType,n=e.onClickWeekNumber,c=e.onMouseLeave,d=e.showFixedNumberOfWeeks,f=(0,s.mapCalendarType)(r),p=function(){if(d)return 6;var e=(0,i.getDaysInMonth)(t)-(7-(0,u.getDayOfWeek)(t,f));return 1+Math.ceil(e/7)}(),g=function(){for(var e=(0,i.getYear)(t),r=(0,i.getMonth)(t),n=(0,i.getDate)(t),o=[],a=0;a<p;a+=1)o.push((0,u.getBeginOfWeek)(new Date(e,r,n+7*a),f));return o}(),v=g.map((function(e){return(0,u.getWeekNumber)(e,f)}));return o.default.createElement(l.default,{className:"react-calendar__month-view__weekNumbers",count:p,direction:"column",onFocus:c,onMouseOver:c,style:{flexBasis:"calc(100% * (1 / 8)",flexShrink:0}},v.map((function(e,t){var r=g[t];if(!r)throw new Error("date is not defined");return o.default.createElement(a.default,{key:e,date:r,onClickWeekNumber:n,weekNumber:e})})))}},92841:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(r(85959)),i=n(r(78784)),a=r(56147),l=n(r(32857)),u=r(45649),s=r(75730),c=r(75825),d="react-calendar__month-view__weekdays",f="".concat(d,"__weekday");t.default=function(e){for(var t=e.calendarType,r=e.formatShortWeekday,n=void 0===r?s.formatShortWeekday:r,p=e.formatWeekday,g=void 0===p?s.formatWeekday:p,v=e.locale,h=e.onMouseLeave,m=(0,c.mapCalendarType)(t),y=new Date,b=(0,a.getMonthStart)(y),E=(0,a.getYear)(b),O=(0,a.getMonth)(b),S=[],_=1;_<=7;_+=1){var w=new Date(E,O,_-(0,u.getDayOfWeek)(b,m)),T=g(v,w);S.push(o.default.createElement("div",{key:_,className:(0,i.default)(f,(0,u.isCurrentDayOfWeek)(w)&&"".concat(f,"--current"),(0,u.isWeekend)(w,m)&&"".concat(f,"--weekend"))},o.default.createElement("abbr",{"aria-label":T,title:T},n(v,w).replace(".",""))))}return o.default.createElement(l.default,{className:d,count:7,onFocus:h,onMouseOver:h},S)}},11078:function(e,t,r){"use strict";var n=this&&this.__createBinding||(Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]}),o=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),i=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&n(t,e,r);return o(t,e),t},a=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var l=i(r(85959)),u=a(r(78784));t.default=function(e){var t=e.activeStartDate,r=e.children,n=e.classes,o=e.date,i=e.formatAbbr,a=e.locale,s=e.maxDate,c=e.maxDateTransform,d=e.minDate,f=e.minDateTransform,p=e.onClick,g=e.onMouseOver,v=e.style,h=e.tileClassName,m=e.tileContent,y=e.tileDisabled,b=e.view,E=(0,l.useMemo)((function(){return"function"==typeof h?h({activeStartDate:t,date:o,view:b}):h}),[t,o,h,b]),O=(0,l.useMemo)((function(){return"function"==typeof m?m({activeStartDate:t,date:o,view:b}):m}),[t,o,m,b]);return l.default.createElement("button",{className:(0,u.default)(n,E),disabled:d&&f(d)>o||s&&c(s)<o||y&&y({activeStartDate:t,date:o,view:b}),onClick:p?function(e){return p(o,e)}:void 0,onFocus:g?function(){return g(o)}:void 0,onMouseOver:g?function(){return g(o)}:void 0,style:v,type:"button"},i?l.default.createElement("abbr",{"aria-label":i(a,o)},r):r,O)}},3603:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(r(85959)),i=n(r(32857)),a=r(75825);t.default=function(e){for(var t=e.className,r=e.count,n=void 0===r?3:r,l=e.dateTransform,u=e.dateType,s=e.end,c=e.hover,d=e.offset,f=e.renderTile,p=e.start,g=e.step,v=void 0===g?1:g,h=e.value,m=e.valueType,y=[],b=p;b<=s;b+=v){var E=l(b);y.push(f({classes:(0,a.getTileClasses)({date:E,dateType:u,hover:c,value:h,valueType:m}),date:E}))}return o.default.createElement(i.default,{className:t,count:n,offset:d,wrap:!0},y)}},41866:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var i=o(r(85959)),a=o(r(15374)),l=r(18346),u=function(e){return i.default.createElement("div",{className:"react-calendar__year-view"},i.default.createElement(a.default,n({},e)))};u.propTypes=n({},l.tileGroupProps),t.default=u},36859:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))},a=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var l=a(r(85959)),u=r(56147),s=a(r(11078)),c=r(75730);t.default=function(e){var t=e.classes,r=void 0===t?[]:t,a=e.formatMonth,d=void 0===a?c.formatMonth:a,f=e.formatMonthYear,p=void 0===f?c.formatMonthYear:f,g=o(e,["classes","formatMonth","formatMonthYear"]),v=g.date,h=g.locale;return l.default.createElement(s.default,n({},g,{classes:i(i([],r,!0),["react-calendar__year-view__months__month"],!1),formatAbbr:p,maxDateTransform:u.getMonthEnd,minDateTransform:u.getMonthStart,view:"year"}),d(h,v))}},15374:function(e,t,r){"use strict";var n=this&&this.__assign||function(){return n=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},n.apply(this,arguments)},o=this&&this.__rest||function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});var a=i(r(85959)),l=r(56147),u=i(r(3603)),s=i(r(36859));t.default=function(e){var t=e.activeStartDate,r=e.hover,i=e.value,c=e.valueType,d=o(e,["activeStartDate","hover","value","valueType"]),f=(0,l.getYear)(t);return a.default.createElement(u.default,{className:"react-calendar__year-view__months",dateTransform:function(e){var t=new Date;return t.setFullYear(f,e,1),(0,l.getMonthStart)(t)},dateType:"month",end:11,hover:r,renderTile:function(e){var r=e.date,i=o(e,["date"]);return a.default.createElement(s.default,n({key:r.getTime()},d,i,{activeStartDate:t,date:r}))},start:0,value:i,valueType:c})}},9636:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.YearView=t.Navigation=t.MonthView=t.DecadeView=t.CenturyView=t.Calendar=void 0;var o=n(r(56672));t.Calendar=o.default;var i=n(r(76473));t.CenturyView=i.default;var a=n(r(58735));t.DecadeView=a.default;var l=n(r(42603));t.MonthView=l.default;var u=n(r(16169));t.Navigation=u.default;var s=n(r(41866));t.YearView=s.default,t.default=o.default},96643:(e,t)=>{"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.WEEKDAYS=t.CALENDAR_TYPE_LOCALES=t.DEPRECATED_CALENDAR_TYPES=t.CALENDAR_TYPES=void 0,t.CALENDAR_TYPES={GREGORY:"gregory",HEBREW:"hebrew",ISLAMIC:"islamic",ISO_8601:"iso8601"},t.DEPRECATED_CALENDAR_TYPES={ARABIC:"Arabic",HEBREW:"Hebrew",ISO_8601:"ISO 8601",US:"US"},t.CALENDAR_TYPE_LOCALES=((r={})[t.CALENDAR_TYPES.GREGORY]=["en-CA","en-US","es-AR","es-BO","es-CL","es-CO","es-CR","es-DO","es-EC","es-GT","es-HN","es-MX","es-NI","es-PA","es-PE","es-PR","es-SV","es-VE","pt-BR"],r[t.CALENDAR_TYPES.HEBREW]=["he","he-IL"],r[t.CALENDAR_TYPES.ISLAMIC]=["ar","ar-AE","ar-BH","ar-DZ","ar-EG","ar-IQ","ar-JO","ar-KW","ar-LY","ar-OM","ar-QA","ar-SA","ar-SD","ar-SY","ar-YE","dv","dv-MV","ps","ps-AR"],r),t.WEEKDAYS=[0,1,2,3,4,5,6]},75730:function(e,t,r){"use strict";var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.formatYear=t.formatWeekday=t.formatShortWeekday=t.formatMonthYear=t.formatMonth=t.formatLongDate=t.formatDay=t.formatDate=void 0;var o=n(r(95159)),i=new Map;function a(e){return function(t,r){return function(e){return function(t,r){var n=t||(0,o.default)();i.has(n)||i.set(n,new Map);var a=i.get(n);return a.has(e)||a.set(e,new Intl.DateTimeFormat(n||void 0,e).format),a.get(e)(r)}}(e)(t,function(e){var t=new Date(e);return new Date(t.setHours(12))}(r))}}t.formatDate=a({day:"numeric",month:"numeric",year:"numeric"}),t.formatDay=a({day:"numeric"}),t.formatLongDate=a({day:"numeric",month:"long",year:"numeric"}),t.formatMonth=a({month:"long"}),t.formatMonthYear=a({month:"long",year:"numeric"}),t.formatShortWeekday=a({weekday:"short"}),t.formatWeekday=a({weekday:"long"}),t.formatYear=a({year:"numeric"})},45649:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWeekend=t.isCurrentDayOfWeek=t.getDecadeLabel=t.getCenturyLabel=t.getValueRange=t.getRange=t.getEndPrevious2=t.getEndPrevious=t.getEnd=t.getBeginNext2=t.getBeginPrevious2=t.getBeginNext=t.getBeginPrevious=t.getBegin=t.getWeekNumber=t.getBeginOfWeek=t.getBeginOfDecadeYear=t.getBeginOfCenturyYear=t.getDayOfWeek=void 0;var n=r(56147),o=r(96643),i=r(75730),a=o.WEEKDAYS[0],l=o.WEEKDAYS[5],u=o.WEEKDAYS[6];function s(e,t){void 0===t&&(t=o.CALENDAR_TYPES.ISO_8601);var r=e.getDay();switch(t){case o.CALENDAR_TYPES.ISO_8601:return(r+6)%7;case o.CALENDAR_TYPES.ISLAMIC:return(r+1)%7;case o.CALENDAR_TYPES.HEBREW:case o.CALENDAR_TYPES.GREGORY:return r;default:throw new Error("Unsupported calendar type.")}}function c(e,t){void 0===t&&(t=o.CALENDAR_TYPES.ISO_8601);var r=(0,n.getYear)(e),i=(0,n.getMonth)(e),a=e.getDate()-s(e,t);return new Date(r,i,a)}function d(e,t){switch(e){case"century":return(0,n.getCenturyStart)(t);case"decade":return(0,n.getDecadeStart)(t);case"year":return(0,n.getYearStart)(t);case"month":return(0,n.getMonthStart)(t);case"day":return(0,n.getDayStart)(t);default:throw new Error("Invalid rangeType: ".concat(e))}}function f(e,t){switch(e){case"century":return(0,n.getCenturyEnd)(t);case"decade":return(0,n.getDecadeEnd)(t);case"year":return(0,n.getYearEnd)(t);case"month":return(0,n.getMonthEnd)(t);case"day":return(0,n.getDayEnd)(t);default:throw new Error("Invalid rangeType: ".concat(e))}}function p(e,t,r){return void 0===t&&(t=i.formatYear),r.map((function(r){return t(e,r)})).join(" – ")}t.getDayOfWeek=s,t.getBeginOfCenturyYear=function(e){var t=(0,n.getCenturyStart)(e);return(0,n.getYear)(t)},t.getBeginOfDecadeYear=function(e){var t=(0,n.getDecadeStart)(e);return(0,n.getYear)(t)},t.getBeginOfWeek=c,t.getWeekNumber=function(e,t){void 0===t&&(t=o.CALENDAR_TYPES.ISO_8601);var r,i=t===o.CALENDAR_TYPES.GREGORY?o.CALENDAR_TYPES.GREGORY:o.CALENDAR_TYPES.ISO_8601,a=c(e,t),l=(0,n.getYear)(e)+1;do{r=c(new Date(l,0,i===o.CALENDAR_TYPES.ISO_8601?4:1),t),l-=1}while(e<r);return Math.round((a.getTime()-r.getTime())/6048e5)+1},t.getBegin=d,t.getBeginPrevious=function(e,t){switch(e){case"century":return(0,n.getPreviousCenturyStart)(t);case"decade":return(0,n.getPreviousDecadeStart)(t);case"year":return(0,n.getPreviousYearStart)(t);case"month":return(0,n.getPreviousMonthStart)(t);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getBeginNext=function(e,t){switch(e){case"century":return(0,n.getNextCenturyStart)(t);case"decade":return(0,n.getNextDecadeStart)(t);case"year":return(0,n.getNextYearStart)(t);case"month":return(0,n.getNextMonthStart)(t);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getBeginPrevious2=function(e,t){switch(e){case"decade":return(0,n.getPreviousDecadeStart)(t,-100);case"year":return(0,n.getPreviousYearStart)(t,-10);case"month":return(0,n.getPreviousMonthStart)(t,-12);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getBeginNext2=function(e,t){switch(e){case"decade":return(0,n.getNextDecadeStart)(t,100);case"year":return(0,n.getNextYearStart)(t,10);case"month":return(0,n.getNextMonthStart)(t,12);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getEnd=f,t.getEndPrevious=function(e,t){switch(e){case"century":return(0,n.getPreviousCenturyEnd)(t);case"decade":return(0,n.getPreviousDecadeEnd)(t);case"year":return(0,n.getPreviousYearEnd)(t);case"month":return(0,n.getPreviousMonthEnd)(t);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getEndPrevious2=function(e,t){switch(e){case"decade":return(0,n.getPreviousDecadeEnd)(t,-100);case"year":return(0,n.getPreviousYearEnd)(t,-10);case"month":return(0,n.getPreviousMonthEnd)(t,-12);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getRange=function(e,t){switch(e){case"century":return(0,n.getCenturyRange)(t);case"decade":return(0,n.getDecadeRange)(t);case"year":return(0,n.getYearRange)(t);case"month":return(0,n.getMonthRange)(t);case"day":return(0,n.getDayRange)(t);default:throw new Error("Invalid rangeType: ".concat(e))}},t.getValueRange=function(e,t,r){var n=[t,r].sort((function(e,t){return e.getTime()-t.getTime()}));return[d(e,n[0]),f(e,n[1])]},t.getCenturyLabel=function(e,t,r){return p(e,t,(0,n.getCenturyRange)(r))},t.getDecadeLabel=function(e,t,r){return p(e,t,(0,n.getDecadeRange)(r))},t.isCurrentDayOfWeek=function(e){return e.getDay()===(new Date).getDay()},t.isWeekend=function(e,t){void 0===t&&(t=o.CALENDAR_TYPES.ISO_8601);var r=e.getDay();switch(t){case o.CALENDAR_TYPES.ISLAMIC:case o.CALENDAR_TYPES.HEBREW:return r===l||r===u;case o.CALENDAR_TYPES.ISO_8601:case o.CALENDAR_TYPES.GREGORY:return r===u||r===a;default:throw new Error("Unsupported calendar type.")}}},18346:function(e,t,r){"use strict";var n=this&&this.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))},o=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.tileProps=t.tileGroupProps=t.rangeOf=t.isView=t.isViews=t.isValue=t.isRef=t.isMaxDate=t.isMinDate=t.isClassName=t.isCalendarType=void 0;var i=o(r(50012)),a=r(96643),l=Object.values(a.CALENDAR_TYPES),u=Object.values(a.DEPRECATED_CALENDAR_TYPES),s=["century","decade","year","month"];t.isCalendarType=i.default.oneOf(n(n([],l,!0),u,!0)),t.isClassName=i.default.oneOfType([i.default.string,i.default.arrayOf(i.default.string)]),t.isMinDate=function(e,t,r){var n=e[t];if(!n)return null;if(!(n instanceof Date))return new Error("Invalid prop `".concat(t,"` of type `").concat(typeof n,"` supplied to `").concat(r,"`, expected instance of `Date`."));var o=e.maxDate;return o&&n>o?new Error("Invalid prop `".concat(t,"` of type `").concat(typeof n,"` supplied to `").concat(r,"`, minDate cannot be larger than maxDate.")):null},t.isMaxDate=function(e,t,r){var n=e[t];if(!n)return null;if(!(n instanceof Date))return new Error("Invalid prop `".concat(t,"` of type `").concat(typeof n,"` supplied to `").concat(r,"`, expected instance of `Date`."));var o=e.minDate;return o&&n<o?new Error("Invalid prop `".concat(t,"` of type `").concat(typeof n,"` supplied to `").concat(r,"`, maxDate cannot be smaller than minDate.")):null},t.isRef=i.default.oneOfType([i.default.func,i.default.exact({current:i.default.any})]);var c=i.default.arrayOf(i.default.oneOfType([i.default.instanceOf(Date),i.default.oneOf([null])]).isRequired);t.isValue=i.default.oneOfType([i.default.instanceOf(Date),i.default.oneOf([null]),c]),t.isViews=i.default.arrayOf(i.default.oneOf(s)),t.isView=function(e,t,r){var n=e[t];return void 0===n||"string"==typeof n&&-1!==s.indexOf(n)?null:new Error("Invalid prop `".concat(t,"` of value `").concat(n,"` supplied to `").concat(r,"`, expected one of [").concat(s.map((function(e){return'"'.concat(e,'"')})).join(", "),"]."))},t.isView.isRequired=function(e,r,n,o,i){var a=e[r];return a?(0,t.isView)(e,r,n,o,i):new Error("The prop `".concat(r,"` is marked as required in `").concat(n,"`, but its value is `").concat(a,"`."))},t.rangeOf=function(e){return i.default.arrayOf(e)},t.tileGroupProps={activeStartDate:i.default.instanceOf(Date).isRequired,hover:i.default.instanceOf(Date),locale:i.default.string,maxDate:t.isMaxDate,minDate:t.isMinDate,onClick:i.default.func,onMouseOver:i.default.func,tileClassName:i.default.oneOfType([i.default.func,t.isClassName]),tileContent:i.default.oneOfType([i.default.func,i.default.node]),value:t.isValue,valueType:i.default.oneOf(["century","decade","year","month","day"]).isRequired},t.tileProps={activeStartDate:i.default.instanceOf(Date).isRequired,classes:i.default.arrayOf(i.default.string.isRequired).isRequired,date:i.default.instanceOf(Date).isRequired,locale:i.default.string,maxDate:t.isMaxDate,minDate:t.isMinDate,onClick:i.default.func,onMouseOver:i.default.func,style:i.default.objectOf(i.default.oneOfType([i.default.string,i.default.number])),tileClassName:i.default.oneOfType([i.default.func,t.isClassName]),tileContent:i.default.oneOfType([i.default.func,i.default.node]),tileDisabled:i.default.func}},75825:function(e,t,r){"use strict";var n,o=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.mapCalendarType=t.getTileClasses=t.doRangesOverlap=t.isRangeWithinRange=t.isValueWithinRange=t.between=void 0;var i=o(r(20567)),a=r(96643),l=r(45649);function u(e,t){return t[0]<=e&&t[1]>=e}function s(e,t){return e[0]<=t[0]&&e[1]>=t[1]}function c(e,t){return u(e[0],t)||u(e[1],t)}function d(e,t,r){var n=[];if(c(t,e)){n.push(r);var o=u(e[0],t),i=u(e[1],t);o&&n.push("".concat(r,"Start")),i&&n.push("".concat(r,"End")),o&&i&&n.push("".concat(r,"BothEnds"))}return n}t.between=function(e,t,r){return t&&t>e?t:r&&r<e?r:e},t.isValueWithinRange=u,t.isRangeWithinRange=s,t.doRangesOverlap=c,t.getTileClasses=function(e){if(!e)throw new Error("args is required");var t=e.value,r=e.date,n=e.hover,o="react-calendar__tile",i=[o];if(!r)return i;var a=new Date,f=function(){if(Array.isArray(r))return r;var t=e.dateType;if(!t)throw new Error("dateType is required when date is not an array of two dates");return(0,l.getRange)(t,r)}();if(u(a,f)&&i.push("".concat(o,"--now")),!t||!function(e){return Array.isArray(e)?null!==e[0]&&null!==e[1]:null!==e}(t))return i;var p=function(){if(Array.isArray(t))return t;var r=e.valueType;if(!r)throw new Error("valueType is required when value is not an array of two dates");return(0,l.getRange)(r,t)}();s(p,f)?i.push("".concat(o,"--active")):c(p,f)&&i.push("".concat(o,"--hasActive"));var g=d(p,f,"".concat(o,"--range"));i.push.apply(i,g);var v=Array.isArray(t)?t:[t];if(n&&1===v.length){var h=d(n>p[0]?[p[0],n]:[n,p[0]],f,"".concat(o,"--hover"));i.push.apply(i,h)}return i};var f=((n={})[a.DEPRECATED_CALENDAR_TYPES.ARABIC]=a.CALENDAR_TYPES.ISLAMIC,n[a.DEPRECATED_CALENDAR_TYPES.HEBREW]=a.CALENDAR_TYPES.HEBREW,n[a.DEPRECATED_CALENDAR_TYPES.ISO_8601]=a.CALENDAR_TYPES.ISO_8601,n[a.DEPRECATED_CALENDAR_TYPES.US]=a.CALENDAR_TYPES.GREGORY,n),p=!1;t.mapCalendarType=function(e){if(function(e){return void 0!==e&&e in a.DEPRECATED_CALENDAR_TYPES}(e)){var t=f[e];return(0,i.default)(p,'Specifying calendarType="'.concat(e,'" is deprecated. Use calendarType="').concat(t,'" instead.')),p=!0,t}return e}},49257:(e,t,r)=>{"use strict";function n(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}r.d(t,{A:()=>n})},91666:(e,t,r)=>{"use strict";r.r(t),r.d(t,{__addDisposableResource:()=>L,__assign:()=>i,__asyncDelegator:()=>T,__asyncGenerator:()=>w,__asyncValues:()=>P,__await:()=>_,__awaiter:()=>g,__classPrivateFieldGet:()=>x,__classPrivateFieldIn:()=>D,__classPrivateFieldSet:()=>N,__createBinding:()=>h,__decorate:()=>l,__disposeResources:()=>M,__esDecorate:()=>s,__exportStar:()=>m,__extends:()=>o,__generator:()=>v,__importDefault:()=>R,__importStar:()=>A,__makeTemplateObject:()=>C,__metadata:()=>p,__param:()=>u,__propKey:()=>d,__read:()=>b,__rest:()=>a,__runInitializers:()=>c,__setFunctionName:()=>f,__spread:()=>E,__spreadArray:()=>S,__spreadArrays:()=>O,__values:()=>y,default:()=>k});var n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)};function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var i=function(){return i=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},i.apply(this,arguments)};function a(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r}function l(e,t,r,n){var o,i=arguments.length,a=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,r,n);else for(var l=e.length-1;l>=0;l--)(o=e[l])&&(a=(i<3?o(a):i>3?o(t,r,a):o(t,r))||a);return i>3&&a&&Object.defineProperty(t,r,a),a}function u(e,t){return function(r,n){t(r,n,e)}}function s(e,t,r,n,o,i){function a(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var l,u=n.kind,s="getter"===u?"get":"setter"===u?"set":"value",c=!t&&e?n.static?e:e.prototype:null,d=t||(c?Object.getOwnPropertyDescriptor(c,n.name):{}),f=!1,p=r.length-1;p>=0;p--){var g={};for(var v in n)g[v]="access"===v?{}:n[v];for(var v in n.access)g.access[v]=n.access[v];g.addInitializer=function(e){if(f)throw new TypeError("Cannot add initializers after decoration has completed");i.push(a(e||null))};var h=(0,r[p])("accessor"===u?{get:d.get,set:d.set}:d[s],g);if("accessor"===u){if(void 0===h)continue;if(null===h||"object"!=typeof h)throw new TypeError("Object expected");(l=a(h.get))&&(d.get=l),(l=a(h.set))&&(d.set=l),(l=a(h.init))&&o.unshift(l)}else(l=a(h))&&("field"===u?o.unshift(l):d[s]=l)}c&&Object.defineProperty(c,n.name,d),f=!0}function c(e,t,r){for(var n=arguments.length>2,o=0;o<t.length;o++)r=n?t[o].call(e,r):t[o].call(e);return n?r:void 0}function d(e){return"symbol"==typeof e?e:"".concat(e)}function f(e,t,r){return"symbol"==typeof t&&(t=t.description?"[".concat(t.description,"]"):""),Object.defineProperty(e,"name",{configurable:!0,value:r?"".concat(r," ",t):t})}function p(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}function g(e,t,r,n){return new(r||(r=Promise))((function(o,i){function a(e){try{u(n.next(e))}catch(e){i(e)}}function l(e){try{u(n.throw(e))}catch(e){i(e)}}function u(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t)}))).then(a,l)}u((n=n.apply(e,t||[])).next())}))}function v(e,t){var r,n,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function l(l){return function(u){return function(l){if(r)throw new TypeError("Generator is already executing.");for(;i&&(i=0,l[0]&&(a=0)),a;)try{if(r=1,n&&(o=2&l[0]?n.return:l[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,l[1])).done)return o;switch(n=0,o&&(l=[2&l[0],o.value]),l[0]){case 0:case 1:o=l;break;case 4:return a.label++,{value:l[1],done:!1};case 5:a.label++,n=l[1],l=[0];continue;case 7:l=a.ops.pop(),a.trys.pop();continue;default:if(!((o=(o=a.trys).length>0&&o[o.length-1])||6!==l[0]&&2!==l[0])){a=0;continue}if(3===l[0]&&(!o||l[1]>o[0]&&l[1]<o[3])){a.label=l[1];break}if(6===l[0]&&a.label<o[1]){a.label=o[1],o=l;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(l);break}o[2]&&a.ops.pop(),a.trys.pop();continue}l=t.call(e,a)}catch(e){l=[6,e],n=0}finally{r=o=0}if(5&l[0])throw l[1];return{value:l[0]?l[1]:void 0,done:!0}}([l,u])}}}var h=Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]};function m(e,t){for(var r in e)"default"===r||Object.prototype.hasOwnProperty.call(t,r)||h(t,e,r)}function y(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function b(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function E(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(b(arguments[t]));return e}function O(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),o=0;for(t=0;t<r;t++)for(var i=arguments[t],a=0,l=i.length;a<l;a++,o++)n[o]=i[a];return n}function S(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}function _(e){return this instanceof _?(this.v=e,this):new _(e)}function w(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n,o=r.apply(e,t||[]),i=[];return n={},a("next"),a("throw"),a("return"),n[Symbol.asyncIterator]=function(){return this},n;function a(e){o[e]&&(n[e]=function(t){return new Promise((function(r,n){i.push([e,t,r,n])>1||l(e,t)}))})}function l(e,t){try{(r=o[e](t)).value instanceof _?Promise.resolve(r.value.v).then(u,s):c(i[0][2],r)}catch(e){c(i[0][3],e)}var r}function u(e){l("next",e)}function s(e){l("throw",e)}function c(e,t){e(t),i.shift(),i.length&&l(i[0][0],i[0][1])}}function T(e){var t,r;return t={},n("next"),n("throw",(function(e){throw e})),n("return"),t[Symbol.iterator]=function(){return this},t;function n(n,o){t[n]=e[n]?function(t){return(r=!r)?{value:_(e[n](t)),done:!1}:o?o(t):t}:o}}function P(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,r=e[Symbol.asyncIterator];return r?r.call(e):(e=y(e),t={},n("next"),n("throw"),n("return"),t[Symbol.asyncIterator]=function(){return this},t);function n(r){t[r]=e[r]&&function(t){return new Promise((function(n,o){!function(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}(n,o,(t=e[r](t)).done,t.value)}))}}}function C(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e}var I=Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t};function A(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&h(t,e,r);return I(t,e),t}function R(e){return e&&e.__esModule?e:{default:e}}function x(e,t,r,n){if("a"===r&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!n:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===r?n:"a"===r?n.call(e):n?n.value:t.get(e)}function N(e,t,r,n,o){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!o)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!o:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?o.call(e,r):o?o.value=r:t.set(e,r),r}function D(e,t){if(null===t||"object"!=typeof t&&"function"!=typeof t)throw new TypeError("Cannot use 'in' operator on non-object");return"function"==typeof e?t===e:e.has(t)}function L(e,t,r){if(null!=t){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object expected.");var n;if(r){if(!Symbol.asyncDispose)throw new TypeError("Symbol.asyncDispose is not defined.");n=t[Symbol.asyncDispose]}if(void 0===n){if(!Symbol.dispose)throw new TypeError("Symbol.dispose is not defined.");n=t[Symbol.dispose]}if("function"!=typeof n)throw new TypeError("Object not disposable.");e.stack.push({value:t,dispose:n,async:r})}else r&&e.stack.push({async:!0});return t}var j="function"==typeof SuppressedError?SuppressedError:function(e,t,r){var n=new Error(r);return n.name="SuppressedError",n.error=e,n.suppressed=t,n};function M(e){function t(t){e.error=e.hasError?new j(t,e.error,"An error was suppressed during disposal."):t,e.hasError=!0}return function r(){for(;e.stack.length;){var n=e.stack.pop();try{var o=n.dispose&&n.dispose.call(n.value);if(n.async)return Promise.resolve(o).then(r,(function(e){return t(e),r()}))}catch(e){t(e)}}if(e.hasError)throw e.error}()}const k={__extends:o,__assign:i,__rest:a,__decorate:l,__param:u,__metadata:p,__awaiter:g,__generator:v,__createBinding:h,__exportStar:m,__values:y,__read:b,__spread:E,__spreadArrays:O,__spreadArray:S,__await:_,__asyncGenerator:w,__asyncDelegator:T,__asyncValues:P,__makeTemplateObject:C,__importStar:A,__importDefault:R,__classPrivateFieldGet:x,__classPrivateFieldSet:N,__classPrivateFieldIn:D,__addDisposableResource:L,__disposeResources:M}}},y={};function b(e){var t=y[e];if(void 0!==t)return t.exports;var r=y[e]={id:e,loaded:!1,exports:{}};return m[e].call(r.exports,r,r.exports,b),r.loaded=!0,r.exports}b.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return b.d(t,{a:t}),t},b.d=(e,t)=>{for(var r in t)b.o(t,r)&&!b.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},b.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),b.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),b.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},b.nmd=e=>(e.paths=[],e.children||(e.children=[]),e),b.nc=void 0;var E={};return(()=>{"use strict";b.r(E),b.d(E,{plugin:()=>io});var e=b(87781),t=b(93241),r=b.n(t),n=b(94706),o=b.n(n),i=b(20819),a=b(51724),l=b(92468),u=b.n(l);const s="0",c="1",d="2",f="3",p="4",g="5",v="6",h=[{val:0,text:"Not classified"},{val:1,text:"Information"},{val:2,text:"Warning"},{val:3,text:"Average"},{val:4,text:"High"},{val:5,text:"Disaster"}],m="range_series";var y,O,S,_;!function(e){e.Group="group",e.Host="host",e.Application="application",e.Macro="macro",e.ItemTag="itemTag",e.Item="item",e.ItemValues="itemValues"}(y||(y={}));class w extends e.BusEventWithPayload{}function T(e){return r().forEach(e,(e=>(e.item=e.name,e.name=function(e,t){const n=function(e){const t=[];let n=!1,o=!1,i="";return r().forEach(e,(e=>{'"'===e&&o?i+=e:'"'===e&&n?n=!1:'"'!==e||n?"["!==e||n?"]"!==e||n?","!==e||n||o?i+=e:(t.push(i),i=""):o=!1:o=!0:n=!0})),t.push(i),t}(t.substring(t.indexOf("[")+1,t.lastIndexOf("]")));for(let t=n.length;t>=1;t--)e=e.replace("$"+t,n[t-1]);return e}(e.item,e.key_),e))),e}_="zbx-query-updated",(S="type")in(O=w)?Object.defineProperty(O,S,{value:_,enumerable:!0,configurable:!0,writable:!0}):O[S]=_;const P=/{\$[A-Z0-9_\.]+}/g;function C(e,t,n){let o=n?e.url:e.name;const i=o.match(P);return r().forEach(i,(i=>{const a=r().filter(t,(t=>{if(t.hostid){if(n){let n=!1;return r().forEach(e.hosts,(e=>{e.hostid===t.hostid&&(n=!0)})),n}return t.hostid===e.hostid}return!0})),l=r().find(a,{macro:i});if(l&&l.value){const e=l.value,t=new RegExp(function(e){return e=e.replace(/\$/,"\\$")}(i));o=o.replace(t,e)}})),o}function I(e){let t;const n=[];r().each(function(e){const t=/\{[^\{\}]*\}|\{\/.*\/\}/g;let n;if(function(e){return/^\{.+\}$/.test(e)}(e)){const o=e.match(t);n=r().map(o,(e=>r().trim(e,"{}")))}else n=e.split(".");return n}(e),(e=>{"*"===e&&(e="/.*/"),n.push(e)}));const o=r().zipObject(["group","host","app","item"],n);switch(4===n.length&&"/.*/"===o.app&&(o.app=""),n.length){case 1:t=y.Group;break;case 2:t=y.Host;break;case 3:t=y.Application;break;case 4:t=y.Item}return{queryType:t,group:o.group||"",host:o.host||"",application:o.app||"",item:o.item||""}}const A=/^\/(.*)\/([gmi]*)$/m;function R(e){return A.test(e)}function x(t){const r=t.to.diff(t.from),n=Math.round(r/1e3),o=e.rangeUtil.secondsToHms(r/1e3);return{__range_ms:{text:r,value:r},__range_s:{text:n,value:n},__range:{text:o,value:o},__range_series:{text:m,value:m}}}function N(e){const t=e.match(A),r=t[1],n=""!==t[2]?t[2]:void 0;return new RegExp(r,n)}function D(e){return e.replace(/[\\^$*+?.()|[\]{}\/]/g,"\\$&")}function L(e){const t=function(e){const t=/(^[\d]+)(y|M|w|d|h|m|s)?/g.exec(e);return!t||!e||t.length>2&&!t[2]?"":t[1]+(t.length>2?t[2]:"s")}(e);return t?j(t):0}function j(e){const t=/(^[\d]+)(y|M|w|d|h|m|s)/g.exec(e);return u().duration(Number(t[1]),t[2]).valueOf()}function M(e){return function(t){for(let r=0;r<e.length;r++)t=e[r].call(this,t);return t}}function k(e){return e.replace(/\s+/g," ").trim()}function F(e){if(!e)return[];let t=r().map(e.split(","),(e=>e.trim()));return t=r().map(t,(e=>{var t,r;const n=e.split(":");return{tag:null===(t=n[0])||void 0===t?void 0:t.trim(),value:null===(r=n[1])||void 0===r?void 0:r.trim()}})),t}function q(e){const t={tag:"",value:""},r=e.indexOf(":");return r>0?(t.tag=e.slice(0,r).trim(),t.value=e.slice(Math.min(r+1,e.length)).trim()):t.tag=e.trim(),t}function V(e){return e.value?`${e.tag}: ${e.value}`:e.tag}function B(e){return e||[]}const U={"%":"percent",b:"decbits",bps:"bps",B:"bytes",Bps:"binBps",uptime:"dtdhms",qps:"qps",iops:"iops",Hz:"hertz",V:"volt",C:"celsius",RPM:"rotrpm",dBm:"dBm"},W=(()=>{const t={},r=(0,e.getValueFormats)();for(const e of r)for(const r of e.submenu){const e=r.value;t[e]=e}return t})();function G(e){let t=U[e];return t||(t=W[e]),t}function H(e,t,r){if(null===e||e.length<2||r>e.length-1||r<0||t>e.length-1||t<0)return e;const n=new Array(e.length);for(let o=0;o<e.length;o++)n[o]=o===t?e[r]:o===r?e[t]:e[o];return n}function K(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function $(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){K(e,t,r[t])}))}return e}function z(e){return e.resultFormat=e.resultFormat||"time_series",function(e){return!(e.mode&&0!==e.mode&&2!==e.mode||!(e.hostFilter||e.itemFilter||e.downsampleFunction||e.host&&e.host.host)||void 0!==e.item.filter||void 0!==e.host.filter)}(e=function(e){return e.group&&Array.isArray(e.group)&&(e.group={filter:""}),e}(e))?function(e){return e.group.filter="*"===e.group.name?"/.*/":e.group.name,e.host.filter="*"===e.host.name?Y(e.hostFilter):e.host.name,e.application.filter="*"===e.application.name?"":e.application.name,e.item.filter="All"===e.item.name?Y(e.itemFilter):e.item.name,e.macro.filter="*"===e.macro.macro?Y(e.macroFilter):e.macro.macro,e}(e):(function(e){if(e.functions)for(const t of e.functions)t.def&&"percentil"===t.def.name&&(t.def.name="percentile")}(e),function(e){var t;void 0===e.queryType&&("Metrics"===e.mode?e.queryType=s:void 0!==e.mode&&(e.queryType=e.mode,delete e.mode)),"number"==typeof e.queryType&&(e.queryType=null===(t=e.queryType)||void 0===t?void 0:t.toString())}(e),function(e){e.queryType!==c||e.slaInterval||(e.slaInterval="none")}(e),function(e){var t;"priority"===(null===(t=e.options)||void 0===t?void 0:t.sortProblems)&&(e.options.sortProblems="severity")}(e),function(e){var t,r;e.itemTag||(e.itemTag={filter:""},(null===(t=e.application)||void 0===t?void 0:t.filter)&&(e.itemTag.filter=`Application: ${null===(r=e.application)||void 0===r?void 0:r.filter}`))}(e),function(e){var t,r;(null===(t=e.slaProperty)||void 0===t?void 0:t.property)&&(e.slaProperty=null===(r=e.slaProperty)||void 0===r?void 0:r.property)}(e),function(e){var t,r,n,o;(null===(t=e.triggers)||void 0===t?void 0:t.minSeverity)&&(e.options.minSeverity=null===(n=e.triggers)||void 0===n?void 0:n.minSeverity,delete e.triggers.minSeverity),(null===(r=e.triggers)||void 0===r?void 0:r.count)&&(e.options.count=null===(o=e.triggers)||void 0===o?void 0:o.count,delete e.triggers.count)}(e),function(e){e.schema>=11||("6"===e.queryType?(e.queryType=p,e.countTriggersBy="items"):"7"===e.queryType?(e.queryType=p,e.countTriggersBy="problems"):"8"===e.queryType&&(e.queryType=v))}(e),function(e){var t;e.schema>=12||(null==e||null===(t=e.options)||void 0===t?void 0:t.minSeverity)&&(e.options.severities=[0,1,2,3,4,5].filter((t=>t>=e.options.minSeverity)))}(e),e.schema=12,e)}function Y(e){return e?"/"+e+"/":"/.*/"}const Q=e=>{var t;const r=(e=>{var t,r,n,o,i,a,l,u;return{group:{filter:null!==(t=e.group)&&void 0!==t?t:""},host:{filter:null!==(r=e.host)&&void 0!==r?r:""},application:{filter:null!==(n=e.application)&&void 0!==n?n:""},trigger:{filter:null!==(o=e.trigger)&&void 0!==o?o:""},options:{minSeverity:null!==(i=e.minseverity)&&void 0!==i?i:0,showOkEvents:null!==(a=e.showOkEvents)&&void 0!==a&&a,hideAcknowledged:null!==(l=e.hideAcknowledged)&&void 0!==l&&l,showHostname:null!==(u=e.showHostname)&&void 0!==u&&u}}})(e);return e.target=(n=$({},r,e.target),o=null!=(o={fromAnnotations:!0,options:$({},r.options,null===(t=e.target)||void 0===t?void 0:t.options)})?o:{},Object.getOwnPropertyDescriptors?Object.defineProperties(n,Object.getOwnPropertyDescriptors(o)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(o)).forEach((function(e){Object.defineProperty(n,e,Object.getOwnPropertyDescriptor(o,e))})),n),e;var n,o};function X(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const J={},Z={Transform:[],Aggregate:[],Filter:[],Trends:[],Time:[],Alias:[],Special:[]};function ee(e){e.params=e.params||[],e.defaultParams=e.defaultParams||[],e.category&&Z[e.category].push(e),J[e.name]=e,J[e.shortName||e.name]=e}ee({name:"groupBy",category:"Transform",params:[{name:"interval",type:"string"},{name:"function",type:"string",options:["avg","min","max","sum","count","median","first","last"]}],defaultParams:["1m","avg"]}),ee({name:"scale",category:"Transform",params:[{name:"factor",type:"float",options:[100,.01,10,-1]}],defaultParams:[100]}),ee({name:"offset",category:"Transform",params:[{name:"delta",type:"float",options:[-100,100]}],defaultParams:[100]}),ee({name:"delta",category:"Transform",params:[],defaultParams:[]}),ee({name:"rate",category:"Transform",params:[],defaultParams:[]}),ee({name:"movingAverage",category:"Transform",params:[{name:"factor",type:"int",options:[6,10,60,100,600]}],defaultParams:[10]}),ee({name:"exponentialMovingAverage",category:"Transform",params:[{name:"smoothing",type:"float",options:[6,10,60,100,600]}],defaultParams:[.2]}),ee({name:"percentile",category:"Transform",params:[{name:"interval",type:"string"},{name:"percent",type:"float",options:[25,50,75,90,95,99,99.9]}],defaultParams:["1m",95]}),ee({name:"removeAboveValue",category:"Transform",params:[{name:"number",type:"float"}],defaultParams:[0]}),ee({name:"removeBelowValue",category:"Transform",params:[{name:"number",type:"float"}],defaultParams:[0]}),ee({name:"transformNull",category:"Transform",params:[{name:"number",type:"float"}],defaultParams:[0]}),ee({name:"aggregateBy",category:"Aggregate",params:[{name:"interval",type:"string"},{name:"function",type:"string",options:["avg","min","max","sum","count","median","first","last"]}],defaultParams:["1m","avg"]}),ee({name:"sumSeries",category:"Aggregate",params:[],defaultParams:[]}),ee({name:"percentileAgg",category:"Aggregate",params:[{name:"interval",type:"string"},{name:"percent",type:"float",options:[25,50,75,90,95,99,99.9]}],defaultParams:["1m",95]}),ee({name:"top",category:"Filter",params:[{name:"number",type:"int"},{name:"value",type:"string",options:["avg","min","max","sum","count","median","first","last"]}],defaultParams:[5,"avg"]}),ee({name:"bottom",category:"Filter",params:[{name:"number",type:"int"},{name:"value",type:"string",options:["avg","min","max","sum","count","median","first","last"]}],defaultParams:[5,"avg"]}),ee({name:"sortSeries",category:"Filter",params:[{name:"direction",type:"string",options:["asc","desc"]}],defaultParams:["asc"]}),ee({name:"trendValue",category:"Trends",params:[{name:"type",type:"string",options:["avg","min","max","sum","count"]}],defaultParams:["avg"]}),ee({name:"timeShift",category:"Time",params:[{name:"interval",type:"string",options:["24h","7d","1M","+24h","-24h"]}],defaultParams:["24h"]}),ee({name:"setAlias",category:"Alias",params:[{name:"alias",type:"string"}],defaultParams:[]}),ee({name:"setAliasByRegex",category:"Alias",params:[{name:"aliasByRegex",type:"string"}],defaultParams:[]}),ee({name:"replaceAlias",category:"Alias",params:[{name:"regexp",type:"string"},{name:"newAlias",type:"string"}],defaultParams:["/(.*)/","$1"]}),ee({name:"consolidateBy",category:"Special",params:[{name:"type",type:"string",options:["avg","min","max","sum","count"]}],defaultParams:["avg"]}),r().each(Z,((e,t)=>{Z[t]=r().sortBy(e,"name")}));class te{bindFunction(e){const t=e[this.def.name];if(t){let e,n=t;for(let t=0;t<this.params.length;t++)e=this.params[t],"int"!==this.def.params[t].type&&"float"!==this.def.params[t].type||(e=Number(e)),n=r().partial(n,e);return n}throw{message:"Method not found "+this.def.name}}render(e){const t=this.def.name+"(",n=r().map(this.params,((e,t)=>{const r=this.def.params[t].type;return"int"===r||"float"===r||"value_or_series"===r||"boolean"===r||"int_or_interval"===r&&(n=e,!isNaN(parseFloat(n))&&isFinite(n))?e:"'"+e+"'";var n}));return e&&n.unshift(e),t+n.join(", ")+")"}_hasMultipleParamsInString(e,t){return-1!==e.indexOf(",")&&this.def.params[t+1]&&this.def.params[t+1].optional}updateParam(e,t){this._hasMultipleParamsInString(e,t)?r().each(e.split(","),((e,t)=>{this.updateParam(e.trim(),t)})):(""===e&&this.def.params[t].optional?this.params.splice(t,1):this.params[t]=e,this.updateText())}updateText(){if(0===this.params.length)return void(this.text=this.def.name+"()");let e=this.def.name+"(";e+=this.params.join(", "),e+=")",this.text=e}constructor(e,t){X(this,"def",void 0),X(this,"params",void 0),X(this,"text",void 0),X(this,"added",void 0),this.def=e,t?this.params=t:(this.params=[],this.params=e.defaultParams.slice(0)),this.updateText()}}function re(e,t){if(r().isString(e)){if(!J[e])throw{message:"Method not found "+name};e=J[e]}return new te(e,t)}function ne(){return Z}var oe=b(18531);function ie(e,t){return new RegExp(t).exec(e)[0]}const ae={timeShift:function(e,t){const n=function(e){const t=/^([\+\-]*)([\d]+)(y|M|w|d|h|m|s)/g.exec(e);let r=0;return r="+"===t[1]?0-u().duration(Number(t[2]),t[3]).valueOf():u().duration(Number(t[2]),t[3]).valueOf(),r}(e)/1e3;return r().map(t,(e=>e-n))},setAlias:function(t,r){var n;if((null===(n=r.fields)||void 0===n?void 0:n.length)<=2){var o,i;const n=r.fields.find((t=>t.name===e.TIME_SERIES_VALUE_FIELD_NAME));var a,l;return(null==n||null===(i=n.config)||void 0===i||null===(o=i.custom)||void 0===o?void 0:o.scopedVars)&&(t=(0,oe.getTemplateSrv)().replace(t,null==n||null===(l=n.config)||void 0===l||null===(a=l.custom)||void 0===a?void 0:a.scopedVars)),n&&(n.config.displayNameFromDS=t),r.name=t,r}for(let n=0;n<r.fields.length;n++){const o=r.fields[n];var u,s,c,d;if(o.type!==e.FieldType.time)(null==o||null===(s=o.config)||void 0===s||null===(u=s.custom)||void 0===u?void 0:u.scopedVars)&&(t=(0,oe.getTemplateSrv)().replace(t,null==o||null===(d=o.config)||void 0===d||null===(c=d.custom)||void 0===c?void 0:c.scopedVars)),o.config.displayNameFromDS=t}return r},setAliasByRegex:function(t,r){var n;if((null===(n=r.fields)||void 0===n?void 0:n.length)<=2){const n=r.fields.find((t=>t.name===e.TIME_SERIES_VALUE_FIELD_NAME));try{var o;n&&(n.config.displayNameFromDS=ie(null===(o=n.config)||void 0===o?void 0:o.displayNameFromDS,t)),r.name=ie(r.name,t)}catch(e){console.error("Failed to apply RegExp:",(null==e?void 0:e.message)||e)}return r}for(const n of r.fields)if(n.type!==e.FieldType.time)try{var i;n.config.displayNameFromDS=ie(null===(i=n.config)||void 0===i?void 0:i.displayNameFromDS,t)}catch(e){console.error("Failed to apply RegExp:",(null==e?void 0:e.message)||e)}return r},replaceAlias:function(t,r,n){var o;let i;if(i=R(t)?N(t):t,(null===(o=n.fields)||void 0===o?void 0:o.length)<=2){var a;let t=n.name.replace(i,r);const o=n.fields.find((t=>t.name===e.TIME_SERIES_VALUE_FIELD_NAME));var l;return(null==o||null===(a=o.state)||void 0===a?void 0:a.scopedVars)&&(t=(0,oe.getTemplateSrv)().replace(t,null==o||null===(l=o.state)||void 0===l?void 0:l.scopedVars)),o&&(o.config.displayNameFromDS=t),n.name=t,n}for(const t of n.fields)if(t.type!==e.FieldType.time){var u,s,c;let e=null===(s=t.config)||void 0===s||null===(u=s.displayNameFromDS)||void 0===u?void 0:u.replace(i,r);var d;(null==t||null===(c=t.state)||void 0===c?void 0:c.scopedVars)&&e&&(e=(0,oe.getTemplateSrv)().replace(e,null==t||null===(d=t.state)||void 0===d?void 0:d.scopedVars)),t.name=e||t.name}return n}},le={get metricFunctions(){return ae}};var ue=b(76142),se=b.n(ue);function ce(e,t,n,o){const i=r().groupBy(e,"itemid"),a=r().uniqBy(r().flatten(r().map(t,"hosts")),"hostid");return r().map(i,((e,i)=>{const l=r().find(t,{itemid:i});let u=l.name;const s={__zbx_item:{value:l.name},__zbx_item_name:{value:l.name},__zbx_item_key:{value:l.key_},__zbx_item_interval:{value:l.delay}};if(r().keys(a).length>0){const e=r().find(a,{hostid:l.hostid});s.__zbx_host={value:e.host},s.__zbx_host_name={value:e.name},s.__zbx_host_id={value:e.id},r().keys(a).length>1&&n&&(u=e.name+": "+u)}return{target:u,datapoints:r().map(e,o),scopedVars:s,item:l}}))}function de(e,t){let r=t.value;return e.textFilter&&(r=fe(t.value,e.textFilter,e.useCaptureGroups)),[r,1e3*t.clock+Math.round(t.ns/1e6)]}function fe(e,t,r){const n=new RegExp(t).exec(e);return n?r?n[1]:n[0]:""}function pe(e){switch(e){case"sla":return"sli";case"okTime":return"uptime";case"downtimeTime":return"downtime";default:return e}}function ge(e){return[Number(e.value),1e3*e.clock+Math.round(e.ns/1e6)]}function ve(e,t){let r;switch(e){case"min":r=t.value_min;break;case"max":r=t.value_max;break;case"avg":default:r=t.value_avg;break;case"sum":r=t.value_avg*t.num;break;case"count":r=t.num}return[Number(r),1e3*t.clock]}const he=function(e,t,r=!0){return ce(e,t,r,ge)},me=function(e,t,n,o=!0){return ce(e,t,o,r().partial(ve,n))},ye=function(e,t,n,o=!0){return ce(e,t,o,r().partial(de,n))},be=function(t,r){const n=new e.MutableDataFrame({refId:r.refId,name:"macros",fields:[{name:"Host",type:e.FieldType.string},{name:"Macros",type:e.FieldType.string},{name:e.TIME_SERIES_VALUE_FIELD_NAME,type:e.FieldType.string}]});for(let r=0;r<t.length;r++){const o=t[r],i={Host:o.hosts[0].name,Macros:o.macro,[e.TIME_SERIES_VALUE_FIELD_NAME]:o.value};n.add(i)}return n},Ee=function(e,t,n){const o=new(se());o.addColumn({text:"Host"}),o.addColumn({text:"Item"}),o.addColumn({text:"Key"}),o.addColumn({text:"Last value"});const i=r().groupBy(e,"itemid");return r().each(t,(e=>{const t=i[e.itemid]||[],a=r().last(t);let l=a?a.value:null;if(n.options.skipEmptyValues&&(!l||""===l))return;n.textFilter&&(l=fe(l,n.textFilter,n.useCaptureGroups));let u=r().first(e.hosts);u=u?u.name:"",o.rows.push([u,e.name,e.key_,l])})),o},Oe=function(e,t,r){const n=r[e.serviceid].sla;if("status"===t){const o=parseInt(r[e.serviceid].status,10);return{target:e.name+" "+t,datapoints:[[o,1e3*n[0].to]]}}{let r;const o=[];for(r=0;r<n.length;r++)0===r&&o.push([n[r][t],1e3*n[r].from]),o.push([n[r][t],1e3*n[r].to]);return{target:e.name+" "+t,datapoints:o}}},Se=function(t,n,o,i){if(r().isArray(t)){const o=function(e){const t=r().uniq(r().flattenDeep(r().map(e,(e=>r().map(e.groups,"name"))))),n={};return r().each(t,(e=>{n[e]={0:0,1:0,2:0,3:0,4:0,5:0}})),r().each(e,(e=>{r().each(e.groups,(t=>{n[t.name][e.priority]++}))})),n}(t),a=new e.MutableDataFrame({name:`Triggers ${i.refId}`,refId:i.refId,fields:[{name:"Host group",type:e.FieldType.string,values:new e.ArrayVector}]});for(let t=h.length-1;t>=0;t--)a.fields.push({name:h[t].text,type:e.FieldType.number,config:{unit:"none",decimals:0},values:new e.ArrayVector});const l=null==n?void 0:n.map((e=>e.name));return null==l||l.forEach((e=>{a.add({"Host group":e,Disaster:o[e]?o[e][5]:0,High:o[e]?o[e][4]:0,Average:o[e]?o[e][3]:0,Warning:o[e]?o[e][2]:0,Information:o[e]?o[e][1]:0,"Not classified":o[e]?o[e][0]:0})})),a}{let r=null;try{r=Number(t)}catch(e){console.log("Error when handling triggers count: ",e)}return new e.MutableDataFrame({name:`Count ${i.refId}`,refId:i.refId,fields:[{name:e.TIME_SERIES_TIME_FIELD_NAME,type:e.FieldType.time,values:new e.ArrayVector([1e3*o[1]])},{name:e.TIME_SERIES_VALUE_FIELD_NAME,type:e.FieldType.number,values:new e.ArrayVector([r])}],length:1})}},_e=function(e){return r().forEach(e,(e=>{e.datapoints=r().sortBy(e.datapoints,(e=>e[1]))})),e},we=function(t,r,n,o){const{datapoints:i,scopedVars:a,target:l,item:u}=t,s={name:e.TIME_SERIES_TIME_FIELD_NAME,type:e.FieldType.time,config:{custom:{}},values:new e.ArrayVector(i.map((e=>e[1])))};let c;e.FieldType.string,c=new e.ArrayVector(i.map((e=>e[0])));const d={name:e.TIME_SERIES_VALUE_FIELD_NAME,type:null!=o?o:e.FieldType.number,labels:{},config:{displayNameFromDS:l,custom:{}},values:c};var f,p,g,v,h;if(a&&(s.config.custom={itemInterval:null===(f=a.__zbx_item_interval)||void 0===f?void 0:f.value},d.labels={host:null===(p=a.__zbx_host_name)||void 0===p?void 0:p.value,item:null===(g=a.__zbx_item)||void 0===g?void 0:g.value,item_key:null===(v=a.__zbx_item_key)||void 0===v?void 0:v.value},d.config.custom={itemInterval:null===(h=a.__zbx_item_interval)||void 0===h?void 0:h.value}),u){var m;const t=G(u.units);t&&(console.log(`Datasource: unit detected: ${t} (${u.units})`),d.config.unit=t,"percent"===t&&(d.config.min=0,d.config.max=100));const o=function(t,r){const{valuemapid:n}=t,o=null==r?void 0:r.find((e=>e.valuemapid===n));return o?o.mappings.map(((t,r)=>({type:e.MappingType.ValueToText,options:{value:t.value,text:t.newvalue}}))):null}(u,n);o&&(null===(m=r.options)||void 0===m?void 0:m.useZabbixValueMapping)&&(console.log("Datasource: using Zabbix value mapping"),d.config.mappings=o)}const y=[s,d],b={name:l,refId:r.refId,fields:y,length:i.length};return new e.MutableDataFrame(b)},Te=function(t,n,o){const i=[];if(0===t.length)return[];for(const l of t){const t=(0,e.dataFrameFromJSON)(l),{timeField:u,timeIndex:s}=(0,e.getTimeField)(t);for(let e=0;e<t.fields.length;e++){var a;const l=t.fields[e];if(e===s||!l.values||!l.values.length)continue;const c=[];for(let e=0;e<l.values.length;e++){const t=l.values.get(e);null!==t&&c.push({time:u.values.get(e)/1e3,value:t})}const d=l.name,f=r().find(n,{itemid:d});let p=1e6*o.intervalMs;const g=1e6*L(f.delay);p=Math.max(p,g),0===p&&(p=null);let v=f.name;(null===(a=f.hosts)||void 0===a?void 0:a.length)>0&&(v=`${f.hosts[0].name}: ${v}`);const h={ts:c,meta:{name:v,item:f,interval:p}};i.push(h)}}return i},Pe=function(e,t){const r=[];if(0===e.length)return[];for(const n of e){const e=[];if(!n.datapoints)continue;const o=n.datapoints;for(let t=0;t<o.length;t++)e.push({time:o[t][1]/1e3,value:o[t][0]});let i=1e6*L(t);0===i&&(i=null);const a={ts:e,meta:{name:n.target,interval:null,item:{}}};r.push(a)}return r},Ce=function(t){if(!t||t.length<2)return!1;const r=t[0].fields.find((t=>t.type===e.FieldType.time));if(!r)return!1;for(let n=1;n<t.length;n++){const o=t[n].fields.find((t=>t.type===e.FieldType.time));for(let e=0;e<Math.min(t.length,2);e++)if(o.values.get(e)!==r.values.get(e))return!1}return!0},Ie=function(t){const r=function(t){let r=0,n=0;for(let o=0;o<t.length;o++){const i=t[o].fields.find((t=>t.type===e.FieldType.time));i.values.length>n&&(n=i.values.length,r=o)}return r}(t),n=t[r].fields.find((t=>t.type===e.FieldType.time));if(!n)return[];const o=[n];for(let r=0;r<t.length;r++){let i=t[r].fields.find((t=>t.name===e.TIME_SERIES_VALUE_FIELD_NAME));"SLI"===t[r].name&&(i=t[r].fields.find((t=>t.type===e.FieldType.number))),i&&(i.name=t[r].name,n.values.length-i.values.length==1&&i.values.add(null),o.push(i))}return[{name:"wide",fields:o,length:n.values.length}]},Ae=function(t){if(!t||0===t.length)return t;let r=t[0].fields.find((t=>t.name===e.TIME_SERIES_TIME_FIELD_NAME)).values.get(0);for(let n=0;n<t.length;n++){const o=t[n].fields.find((t=>t.name===e.TIME_SERIES_TIME_FIELD_NAME)).values.get(0);o<r&&(r=o)}for(let o=0;o<t.length;o++){const i=t[o],a=i.fields.find((t=>t.name===e.TIME_SERIES_TIME_FIELD_NAME)),l=i.fields.find((t=>t.name===e.TIME_SERIES_VALUE_FIELD_NAME)),u=a.values.get(0);if(u>r){var n;console.log("Data frames: adding missing points");let t=a.values.toArray(),o=l.values.toArray();const i=[],s=[],c=null===(n=a.config.custom)||void 0===n?void 0:n.itemInterval;for(let e=r;e<u;e+=c)i.push(e),s.push(null);t=i.concat(t),o=s.concat(o),a.values=new e.ArrayVector(t),l.values=new e.ArrayVector(o)}}return t},Re=function(e){for(let r=0;r<e.data.length;r++){const n=e.data[r];for(const e of n.fields){var t;const r=null===(t=e.config.custom)||void 0===t?void 0:t.units;if(r){const t=G(r);t&&(e.config.unit=t,"percent"===t&&(e.config.min=0,e.config.max=100))}}}return e};function xe(e,t){const r=[];for(let n=0;n<e.length;n++){const o=e[n],i=t[Number(o.objectid)];if(i){const e={timestamp:Number(o.clock),triggerid:o.objectid,eventid:o.eventid,name:o.name,severity:o.severity,acknowledged:o.acknowledged,acknowledges:o.acknowledges,tags:o.tags,suppressed:o.suppressed,suppression_data:o.suppression_data,description:o.name||i.description,comments:i.comments,value:i.value,opdata:o.opdata,groups:i.groups,hosts:i.hosts,items:i.items,alerts:i.alerts,url:i.url,expression:i.expression,correlation_mode:i.correlation_mode,correlation_tag:i.correlation_tag,manual_close:i.manual_close,state:i.state,error:i.error};r.push(e)}}return r}function Ne(e,t,r){const{valueFromEvent:n}=r,o=[];for(let r=0;r<e.length;r++){const i=e[r],a=t[Number(i.objectid)];if(a){const e={value:n?i.value:a.value,timestamp:Number(i.clock),triggerid:i.objectid,eventid:i.eventid,name:i.name,severity:i.severity,acknowledged:i.acknowledged,acknowledges:i.acknowledges,tags:i.tags,suppressed:i.suppressed,description:a.description,comments:a.comments,groups:a.groups,hosts:a.hosts,items:a.items,alerts:a.alerts,url:a.url,expression:a.expression,correlation_mode:a.correlation_mode,correlation_tag:a.correlation_tag,manual_close:a.manual_close,state:a.state,error:a.error};o.push(e)}}return o}const De=function(e,t){return r().each(e,(e=>{e.datasource=t.datasource})),e},Le=function(e,t){return e.forEach((e=>{if(e.hosts&&e.hosts.length){const r=e.hosts[0],n=r.proxyid||r.proxy_hostid;if("0"!==n){const e=t[n];r.proxy=e?e.host:""}}})),e},je=function(t,r){if(r)return t.forEach((t=>{var n;if(null===(n=t.acknowledges)||void 0===n?void 0:n.length)for(let n=0;n<t.acknowledges.length;n++){const o=t.acknowledges[n];let i=r[o.userid];i||"1"!==o.userid||(i={username:"Admin"}),o.user=(null==i?void 0:i.username)||"",o.name=(null==i?void 0:i.name)||"",o.surname=(null==i?void 0:i.surname)||"";const a=1e3*Number(o.clock);isNaN(a)||(o.time=(0,e.dateTime)(a).format("YYYY-MM-DD HH:mm:ss"))}})),t},Me=function(e){return r().each(e,(e=>{e.hostInMaintenance=r().some(e.hosts,(e=>"1"===e.maintenance_status)),e.maintenance=!1,"1"===e.suppressed&&(e.maintenance=!0)})),e},ke=function(e,t){return r().each(e,(e=>{e.showAckButton=t})),e},Fe=function(e,t){const n=t.trigger.filter;return n&&(e=function(e,t){return R(t)?r().filter(e,(e=>N(t).test(e.description))):r().filter(e,(e=>e.description===t))}(e,n)),t.options.hostsInMaintenance||(e=r().filter(e,(e=>!e.maintenance))),e},qe=function(e,t){var n,o;return"severity"===(null===(n=t.options)||void 0===n?void 0:n.sortProblems)?e=r().orderBy(e,["severity","eventid"],["desc","desc"]):"lastchange"===(null===(o=t.options)||void 0===o?void 0:o.sortProblems)&&(e=r().orderBy(e,["timestamp","eventid"],["desc","desc"])),e},Ve=function(t,r){const n={name:"Problems",type:e.FieldType.other,values:new e.ArrayVector(t),config:{custom:{type:"problems"}}};return{name:"problems",refId:(null==r?void 0:r.refId)||"A",fields:[n],length:t.length}};var Be=b(98449),Ue=b.n(Be);function We(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}class Ge{cacheRequest(e,t,r){return function(e,t,r,n){return function(){n.cache[t]||(n.cache[t]={});const o=n.cache[t],i=He(arguments);return n.cacheEnabled&&!n._isExpired(o[i])?Promise.resolve(o[i].value):e.apply(r,arguments).then((e=>(void 0!==e&&(o[i]={value:e,timestamp:Date.now()}),e)))}}(e,t,r,this)}proxify(e,t,r){return this.promises[t]||(this.promises[t]={}),function(e,t,r){return function(){const n=He(arguments);return t[n]||(t[n]=Promise.resolve(e.apply(r,arguments).then((e=>(t[n]=null,e))).catch((e=>{throw t[n]=null,e})))),t[n]}}(e,this.promises[t],r)}proxifyWithCache(e,t,r){const n=this.proxify(e,t,r);return this.cacheRequest(n,t,r)}_isExpired(e){if(e){const t=Date.now()-e.timestamp;return!(e.timestamp&&t<this.ttl)}return!0}constructor(e){We(this,"cacheEnabled",void 0),We(this,"ttl",void 0),We(this,"cache",void 0),We(this,"promises",void 0),this.cacheEnabled=e.enabled,this.ttl=e.ttl||6e5,this.cache={},this.promises={}}}function He(e){try{return"object"==typeof e&&(e=Array.from(e||{}).filter((e=>{var t;return!Boolean(null==e||null===(t=e.scopedVars)||void 0===t?void 0:t.__sceneObject)}))),Ke(JSON.stringify(e))}catch(t){return console.error("failing to get the request hash for caching. type of args "+typeof e),Ke(crypto.randomUUID())}}function Ke(e){let t,r,n,o=0;if(0!==e.length)for(t=0,n=e.length;t<n;t++)r=e.charCodeAt(t),o=(o<<5)-o+r,o|=0;return o}function $e(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const ze={0:"history",1:"history_str",2:"history_log",3:"history_uint",4:"history_text"},Ye={0:"trends",3:"trends_uint"},Qe={avg:"value_avg",min:"value_min",max:"value_max",sum:"num*value_avg"};class Xe{static loadDatasource(e,t){if(!t&&void 0!==e){const n=r().find((0,oe.getDataSourceSrv)().getList(),{id:e});if(!n)return Promise.reject(`Data Source with ID ${e} not found`);t=n.name}return t?(0,oe.getDataSourceSrv)().get(t):Promise.reject("Data Source name should be specified")}loadDBDataSource(){return Xe.loadDatasource(this.datasourceId,this.datasourceName).then((e=>(this.datasourceTypeId=e.meta.id,this.datasourceName||(this.datasourceName=e.name),this.datasourceId||(this.datasourceId=e.id),e)))}constructor(e){$e(this,"datasourceId",void 0),$e(this,"datasourceName",void 0),$e(this,"datasourceTypeId",void 0),this.datasourceId=e.datasourceId,this.datasourceName=e.datasourceName,this.datasourceTypeId=null}}const Je={DBConnector:Xe,DEFAULT_QUERY_LIMIT:1e4,HISTORY_TO_TABLE_MAP:ze,TREND_TO_TABLE_MAP:Ye,consolidateByFunc:{avg:"AVG",min:"MIN",max:"MAX",sum:"SUM",count:"COUNT"},consolidateByTrendColumns:Qe};var Ze,et,tt=b(26147),rt=b.n(tt);function nt(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function ot(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){nt(i,n,o,a,l,"next",e)}function l(e){nt(i,n,o,a,l,"throw",e)}a(void 0)}))}}function it(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}!function(e){e.Problems="problems",e.Recent="recent",e.History="history"}(Ze||(Ze={})),function(e){e.AndOr="0",e.Or="2"}(et||(et={}));const at="3.0.0",lt=(null===e.rangeUtil||void 0===e.rangeUtil?void 0:e.rangeUtil.roundInterval)||rt().roundInterval||rt().round_interval;class ut{request(e,t){return this.version?this.backendAPIRequest(e,t):this.initVersion().then((()=>this.request(e,t)))}backendAPIRequest(e,t={}){var r=this;return ot((function*(){var n;const o={url:r.backendAPIUrl,method:"POST",headers:{"Content-Type":"application/json"},hideFromInspector:!1,data:{datasourceId:r.datasourceId,method:e,params:t}};(r.requestOptions.basicAuth||r.requestOptions.withCredentials)&&(o.withCredentials=!0),r.requestOptions.basicAuth&&(o.headers.Authorization=r.requestOptions.basicAuth);const i=yield(0,oe.getBackendSrv)().fetch(o).toPromise();return null==i||null===(n=i.data)||void 0===n?void 0:n.result}))()}getVersion(){return this.backendAPIRequest("apiinfo.version")}initVersion(){return this.version?Promise.resolve(this.version):(this.getVersionPromise||(this.getVersionPromise=Promise.resolve(this.getVersion().then((e=>(e?console.log(`Zabbix version detected: ${e}`):console.log(`Failed to detect Zabbix version, use default ${at}`),this.version=e||at,this.getVersionPromise=null,e))))),this.getVersionPromise)}isZabbix54OrHigher(){return Ue().gte(this.version,"5.4.0")}acknowledgeEvent(e,t,r,n){r||(r=Ue().gte(this.version,"4.0.0")?4:0);const o={eventids:e,message:t,action:r};return void 0!==n&&(o.severity=n),this.request("event.acknowledge",o)}getGroups(){const e={output:["name","groupid"],sortfield:"name",[pt("with_hosts",this.version,"hostgroup.get")]:!0};return this.request("hostgroup.get",e)}getHosts(e){const t={output:["hostid","name","host"],sortfield:"name"};return e&&(t.groupids=e),this.request("host.get",t)}getApps(e){var t=this;return ot((function*(){if(t.isZabbix54OrHigher())return[];const r={output:"extend",hostids:e};return t.request("application.get",r)}))()}getItems(e,t,r,n){const o={output:["itemid","name","key_","value_type","hostid","status","state","units","valuemapid","delay"],sortfield:"name",webitems:!0,filter:{},selectHosts:["hostid","name","host"]};if(e&&(o.hostids=e),t&&(o.applicationids=t),"num"===r&&(o.filter.value_type=[0,3]),"text"===r&&(o.filter.value_type=[1,2,4]),this.isZabbix54OrHigher()&&(o.selectTags="extend",n)){const e=n.split(",");let t=[];for(let r=0;r<e.length;r++){const n=q(e[r]);t.push({tag:n.tag,value:n.value,operator:"1"})}o.tags=t,o.evaltype=2}return this.request("item.get",o).then(T)}getItemsByIDs(e){const t={itemids:e,output:["itemid","name","key_","value_type","hostid","status","state","units","valuemapid","delay"],webitems:!0,selectHosts:["hostid","name"]};return this.isZabbix54OrHigher()&&(t.selectTags="extend"),this.request("item.get",t).then((e=>T(e)))}getMacros(e){const t={output:"extend",hostids:e};return this.request("usermacro.get",t)}getUserMacros(e){const t={output:"extend",hostmacroids:e,selectHosts:["hostid","name"]};return this.request("usermacro.get",t)}getGlobalMacros(){return this.request("usermacro.get",{output:"extend",globalmacro:!0})}getLastValue(e){const t={output:["lastvalue"],itemids:e};return this.request("item.get",t).then((e=>e.length?e[0].lastvalue:null))}getHistory(e,t,n){const o=r().groupBy(e,"value_type"),i=r().map(o,((e,o)=>{const i={output:"extend",history:o,itemids:r().map(e,"itemid"),sortfield:"clock",sortorder:"ASC",time_from:t};return n&&(i.time_till=n),this.request("history.get",i)}));return Promise.all(i).then(r().flatten)}getTrend_ZBXNEXT1193(e,t,n){const o=r().groupBy(e,"value_type"),i=r().map(o,((e,o)=>{const i={output:"extend",trend:o,itemids:r().map(e,"itemid"),sortfield:"clock",sortorder:"ASC",time_from:t};return n&&(i.time_till=n),this.request("trend.get",i)}));return Promise.all(i).then(r().flatten)}getTrend_30(e,t,n,o){const i={output:["itemid","clock",o],itemids:r().map(e,"itemid"),time_from:t};return n&&(i.time_till=n),this.request("trend.get",i)}getITService(e){const t={output:"extend",serviceids:e};return this.request("service.get",t)}getServices(e){const t={output:"extend",serviceids:e};return this.request("service.get",t)}getSLAList(){return this.request("sla.get",{output:"extend"})}getSLA(e,t,r){const[n,o]=t;let i=[{from:n,to:o}];"auto"===r.slaInterval?i=dt(t,ct(r.intervalMs)):"none"!==r.slaInterval&&(i=dt(t,j(r.slaInterval)/1e3));const a={serviceids:e,intervals:i};return this.request("service.getsla",a)}getSLA60(e,t,r){var n=this;return ot((function*(){const[o,i]=t;let a=[{from:o,to:i}];if("auto"===r.slaInterval){const e=ct(r.intervalMs);a=dt(t,e)}else if("none"!==r.slaInterval){const e=j(r.slaInterval)/1e3;a=dt(t,e)}const l={output:"extend",serviceids:e},u=yield n.request("sla.get",l);if(0===u.length)return{};const s={slaid:u[0].slaid,serviceids:e,period_from:o,period_to:i,periods:Math.min(a.length,100)},c=yield n.request("sla.getsli",s);if(0===c.length)return{};const d={};return c.serviceids.forEach((e=>{d[e]={sla:[]}})),c.sli.forEach(((e,t)=>{e.forEach(((e,r)=>{d[c.serviceids[r]].sla.push({downtimeTime:e.downtime,okTime:e.uptime,sla:e.sli,from:c.periods[t].period_from,to:c.periods[t].period_to})}))})),d}))()}getSLI(e,t,r,n){var o=this;return ot((function*(){const[i,a]=r;let l=[{from:i,to:a}];if("auto"===n.slaInterval){const e=ct(n.intervalMs);l=dt(r,e)}else if("none"!==n.slaInterval){const e=j(n.slaInterval)/1e3;l=dt(r,e)}const u={slaid:e,serviceids:t,period_from:i,period_to:a,periods:Math.min(l.length,100)};return yield o.request("sla.getsli",u)}))()}getProblems(e,t,r,n){const{timeFrom:o,timeTo:i,recent:a,severities:l,limit:u,acknowledged:s,tags:c,evaltype:d}=n,f={output:"extend",selectAcknowledges:"extend",selectSuppressionData:"extend",selectTags:"extend",source:"0",object:"0",sortfield:["eventid"],sortorder:"DESC",evaltype:"0",groupids:e,hostids:t,applicationids:r,recent:a};return l&&(f.severities=l),void 0!==s&&(f.acknowledged=s),c&&(f.tags=c),d&&(f.evaltype=d),u&&(f.limit=u),(o||i)&&(f.time_from=o,f.time_till=i),this.request("problem.get",f).then(B)}getTriggersByIds(e){var t=this;return ot((function*(){const r={output:"extend",triggerids:e,expandDescription:!0,expandData:!0,expandComment:!0,expandExpression:!0,monitored:!0,skipDependent:!0,[pt("selectHostGroups",t.version,"trigger.get")]:["name","groupid"],selectHosts:["hostid","name","host","maintenance_status","description"],selectItems:["itemid","name","key_","lastvalue"],preservekeys:"1"};Ue().lt(t.version,"7.0.0")?r.selectHosts.push("proxy_hostid"):r.selectHosts.push("proxyid");const n=yield t.request("trigger.get",r);return Ue().gte(t.version,"7.0.0")&&Object.keys(n).forEach((e=>{n[e].groups=n[e].hostgroups})),n}))()}getTriggers(e,t,r,n){var o=this;return ot((function*(){const{showTriggers:i,maintenance:a,timeFrom:l,timeTo:u}=n,s={output:"extend",groupids:e,hostids:t,applicationids:r,expandDescription:!0,expandData:!0,expandComment:!0,monitored:!0,skipDependent:!0,filter:{value:1},[pt("selectHostGroups",o.version,"trigger.get")]:["groupid","name"],selectHosts:["hostid","name","host","maintenance_status"],selectItems:["itemid","name","key_","lastvalue"],selectLastEvent:"extend",selectTags:"extend"};Ue().lt(o.version,"7.0.0")?s.selectHosts.push("proxy_hostid"):s.selectHosts.push("proxyid"),i===Ze.Problems?s.filter.value=1:i!==Ze.Recent&&i!==Ze.History||(s.filter.value=[0,1]),a&&(s.maintenance=!0),(l||u)&&(s.lastChangeSince=l,s.lastChangeTill=u);const c=yield o.request("trigger.get",s);return Ue().gte(o.version,"7.0.0")&&c.forEach((e=>{e.groups=e.hostgroups})),c}))()}getEvents(e,t,r,n,o){const i={output:"extend",time_from:t,time_till:r,objectids:e,selectHosts:"extend",[pt("selectAcknowledges",this.version,"event.get")]:"extend",value:n};return o&&(i.limit=o,i.sortfield="clock",i.sortorder="DESC"),this.request("event.get",i).then(B)}getEventsHistory(e,t,r,n){const{timeFrom:o,timeTo:i,severities:a,limit:l,value:u,tags:s,evaltype:c}=n,d={output:"extend",time_from:o,time_till:i,value:"1",source:"0",object:"0",evaltype:"0",sortfield:["eventid"],sortorder:"DESC",selectTags:"extend",[pt("selectAcknowledges",this.version,"event.get")]:"extend",selectSuppressionData:["maintenanceid","suppress_until"],groupids:e,hostids:t,applicationids:r};return l&&(d.limit=l),a&&(d.severities=a),u&&(d.value=u),s&&(d.tags=s),c&&(d.evaltype=c),this.request("event.get",d).then(B)}getExtendedEventData(e){const t={output:"extend",eventids:e,preservekeys:!0,selectTags:"extend",[pt("selectAcknowledges",this.version,"event.get")]:"extend",sortfield:"clock",sortorder:"DESC"};return this.request("event.get",t)}getEventAlerts(e){const t={eventids:e,output:["alertid","eventid","message","clock","error"],selectUsers:"extend"};return this.request("alert.get",t)}getAcknowledges(e){const t={output:"extend",eventids:e,preservekeys:!0,sortfield:"clock",sortorder:"DESC",[pt("selectAcknowledges",this.version,"event.get")]:"extend"};return this.request("event.get",t).then((e=>r().filter(e,(e=>e.acknowledges.length))))}getAlerts(e,t,r){const n={output:"extend",itemids:e,expandDescription:!0,expandData:!0,expandComment:!0,monitored:!0,skipDependent:!0,selectLastEvent:"extend"};return(t||r)&&(n.lastChangeSince=t,n.lastChangeTill=r),this.request("trigger.get",n)}getHostAlerts(e,t,r){var n=this;return ot((function*(){const{minSeverity:o,acknowledged:i,tags:a,count:l,timeFrom:u,timeTo:s}=r,c={output:"extend",hostids:e,min_severity:o,filter:{value:1},expandDescription:!0,expandData:!0,expandComment:!0,monitored:!0,skipDependent:!0,selectLastEvent:"extend",[pt("selectHostGroups",n.version,"trigger.get")]:"extend",selectHosts:["hostid","host","name"]};l&&1!==i&&(c.countOutput=!0,0===i&&(c.withLastEventUnacknowledged=!0)),t&&t.length&&(c.applicationids=t),(u||s)&&(c.lastChangeSince=u,c.lastChangeTill=s),a&&(c.tags=a,c.evaltype=0);let d=yield n.request("trigger.get",c);return l&&1!==i||(d=st(d,i),l&&(d=d.length),Ue().gte(n.version,"7.0.0")&&d.forEach((e=>{e.groups=e.hostgroups}))),d}))()}getHostICAlerts(e,t,r,n){const{minSeverity:o,acknowledged:i,count:a,timeFrom:l,timeTo:u}=n,s={output:"extend",hostids:e,min_severity:o,filter:{value:1},expandDescription:!0,expandData:!0,expandComment:!0,monitored:!0,skipDependent:!0,selectLastEvent:"extend",[pt("selectHostGroups",this.version,"trigger.get")]:"extend",selectHosts:["host","name"],selectItems:["name","key_"]};return a&&1!==i&&(s.countOutput=!0,0===i&&(s.withLastEventUnacknowledged=!0)),t&&t.length&&(s.applicationids=t),r&&r.length&&(s.itemids=r),(l||u)&&(s.lastChangeSince=l,s.lastChangeTill=u),this.request("trigger.get",s).then((e=>(a&&1!==i||(e=st(e,i),a&&(e=e.length),Ue().gte(this.version,"7.0.0")&&e.forEach((e=>{e.groups=e.hostgroups}))),e)))}getHostPCAlerts(e,t,r,n){const{minSeverity:o,acknowledged:i,count:a,timeFrom:l,timeTo:u}=n,s={output:"extend",hostids:e,triggerids:r,min_severity:o,filter:{value:1},expandDescription:!0,expandData:!0,expandComment:!0,monitored:!0,skipDependent:!0,selectLastEvent:"extend",[pt("selectHostGroups",this.version,"trigger.get")]:"extend",selectHosts:["host","name"],selectItems:["name","key_"]};return a&&0!==i&&1!==i&&(s.countOutput=!0),t&&t.length&&(s.applicationids=t),(l||u)&&(s.lastChangeSince=l,s.lastChangeTill=u),this.request("trigger.get",s).then((e=>(a&&0!==i&&1!==i||(e=st(e,i),a&&(e=e.length),Ue().gte(this.version,"7.0.0")&&e.forEach((e=>{e.groups=e.hostgroups}))),e)))}getProxies(){const e={output:["proxyid"]};return Ue().lt(this.version,"7.0.0")?e.output.push("host"):e.output.push("name"),this.request("proxy.get",e)}getScripts(e,t){const r={output:"extend",hostids:e};return this.request("script.get",r).then(B)}executeScript(e,t){const r={hostid:e,scriptid:t};return this.request("script.execute",r)}getValueMappings(){return this.request("valuemap.get",{output:"extend",selectMappings:"extend"})}getUsers(){return this.request("user.get",{output:["userid","username","name","surname"]})}constructor(e,t,r){it(this,"backendAPIUrl",void 0),it(this,"requestOptions",void 0),it(this,"getTrend",void 0),it(this,"version",void 0),it(this,"getVersionPromise",void 0),it(this,"datasourceId",void 0),this.datasourceId=r,this.backendAPIUrl=`/api/datasources/${this.datasourceId}/resources/zabbix-api`,this.requestOptions={basicAuth:e,withCredentials:t},this.getTrend=this.getTrend_ZBXNEXT1193,this.initVersion()}}function st(e,t){return 0===t?r().filter(e,(e=>"0"===e.lastEvent.acknowledged)):1===t?r().filter(e,(e=>"1"===e.lastEvent.acknowledged)):e}function ct(e){const t=lt(100*e)/1e3;return Math.max(t,3600)}function dt(e,t){let[r,n]=e;const o=[];r=Math.floor(r/t)*t,n=Math.ceil(n/t)*t;for(let e=r;e<=n-t;e+=t)o.push({from:e,to:e+t});return o}class ft{toString(){return this.name+" "+this.data}constructor(e){it(this,"code",void 0),it(this,"name",void 0),it(this,"data",void 0),it(this,"message",void 0),this.code=e.code||null,this.name=e.message||"",this.data=e.data||"",this.message="Zabbix API Error: "+this.name+" "+this.data}}function pt(e,t,r){switch(t||(console.log("Version not detected","key",e,"event_name",r),t="0.0.0"),e){case"selectHostGroups":return Ue().gte(t,"7.0.0")?"selectHostGroups":"selectGroups";case"selectAcknowledges":return Ue().gte(t,"7.0.0")?"selectAcknowledges":"select_acknowledges";case"with_hosts":return Ue().gte(t,"7.0.0")?"with_hosts":"real_hosts";default:return""}}const gt={historyQuery:function(e,t,r,n,o,i){const a=`clock DIV ${o} * ${o}`;return`\n      SELECT CAST(itemid AS CHAR) AS metric, ${a} AS time_sec, ${i}(value) AS value\n      FROM ${t}\n      WHERE itemid IN (${e})\n        AND clock\n          > ${r}\n        AND clock\n          < ${n}\n      GROUP BY ${a}, metric\n      ORDER BY time_sec ASC\n  `},trendsQuery:function(e,t,r,n,o,i,a){const l=`clock DIV ${o} * ${o}`;return`\n      SELECT CAST(itemid AS CHAR) AS metric, ${l} AS time_sec, ${i}(${a}) AS value\n      FROM ${t}\n      WHERE itemid IN (${e})\n        AND clock\n          > ${r}\n        AND clock\n          < ${n}\n      GROUP BY ${l}, metric\n      ORDER BY time_sec ASC\n  `},testQuery:function(){return"SELECT CAST(itemid AS CHAR) AS metric, clock AS time_sec, value_avg AS value\n          FROM trends_uint LIMIT 1"}},vt="FM99999999999999999999",ht=`\n    SELECT to_char(itemid, '${vt}') AS metric, clock AS time, value_avg AS value\n    FROM trends_uint LIMIT 1\n`,mt={historyQuery:function(e,t,r,n,o,i){return`\n      SELECT to_char(itemid, '${vt}') AS metric, clock / ${o} * ${o} AS time, ${i}(value) AS value\n      FROM ${t}\n      WHERE itemid IN (${e})\n        AND clock\n          > ${r}\n        AND clock\n          < ${n}\n      GROUP BY 1, 2\n      ORDER BY time ASC\n  `},trendsQuery:function(e,t,r,n,o,i,a){return`\n      SELECT to_char(itemid, '${vt}') AS metric, clock / ${o} * ${o} AS time, ${i}(${a}) AS value\n      FROM ${t}\n      WHERE itemid IN (${e})\n        AND clock\n          > ${r}\n        AND clock\n          < ${n}\n      GROUP BY 1, 2\n      ORDER BY time ASC\n  `},testQuery:function(){return ht}};function yt(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}class bt extends Xe{loadSQLDialect(){"postgres"===this.datasourceTypeId||"grafana-postgresql-datasource"===this.datasourceTypeId?this.sqlDialect=mt:this.sqlDialect=gt}testDataSource(){const e=this.sqlDialect.testQuery();return this.invokeSQLQuery(e)}getHistory(e,t,n,o){const{aggFunction:i,intervalSec:a}=Et(t,n,o),l=r().groupBy(e,"value_type"),u=r().map(l,((e,o)=>{const l=r().map(e,"itemid").join(", "),u=ze[o];let s=this.sqlDialect.historyQuery(l,u,t,n,a,i);return s=k(s),this.invokeSQLQuery(s)}));return Promise.all(u).then((e=>r().flatten(e)))}getTrends(e,t,n,o){const{consolidateBy:i}=o,{aggFunction:a,intervalSec:l}=Et(t,n,o),u=r().groupBy(e,"value_type"),s=r().map(u,((e,o)=>{const u=r().map(e,"itemid").join(", "),s=Ye[o];let c=r().includes(["avg","min","max","sum"],i)?i:"avg";c=Je.consolidateByTrendColumns[c];let d=this.sqlDialect.trendsQuery(u,s,t,n,l,a,c);return d=k(d),this.invokeSQLQuery(d)}));return Promise.all(s).then((e=>r().flatten(e)))}invokeSQLQuery(e){const t={refId:"A",format:"time_series",datasourceId:this.datasourceId,rawSql:e,maxDataPoints:this.limit};return(0,oe.getBackendSrv)().datasourceRequest({url:"/api/ds/query",method:"POST",data:{queries:[t]}}).then((e=>{const t=e.data.results;return t.A?t.A.frames:null}))}constructor(e){super(e),yt(this,"limit",void 0),yt(this,"sqlDialect",void 0),this.limit=e.limit||1e4,this.sqlDialect=null,super.loadDBDataSource().then((()=>{this.loadSQLDialect()}))}}function Et(e,t,r){const{intervalMs:n}=r;let{consolidateBy:o}=r,i=Math.ceil(n/1e3);const a=Math.ceil((t-e)/i);return i=Math.ceil((t-e)/a),o=o||"avg",{aggFunction:Je.consolidateByFunc[o],intervalSec:i}}function Ot(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function St(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const _t={avg:"MEAN",min:"MIN",max:"MAX",sum:"SUM",count:"COUNT"};class wt extends Xe{testDataSource(){return this.influxDS.testDatasource().then((e=>e.status&&"error"===e.status?Promise.reject({data:{message:`InfluxDB connection error: ${e.message}`}}):e))}getHistory(t,n,o,i){const{intervalMs:a,retentionPolicy:l}=i;let{consolidateBy:u}=i;const s=Math.ceil(a/1e3),c={timeFrom:n,timeTill:o};u=u||"avg";const d=r().groupBy(t,"value_type"),f=r().map(d,((e,t)=>{const n=r().map(e,"itemid"),o=ze[t],i=this.buildHistoryQuery(n,o,c,s,u,l);return this.invokeInfluxDBQuery(i)}));return Promise.all(f).then(r().flatten).then((t=>function(t){if(!t)return[];const r=[];for(let i=0;i<t.length;i++){const a=t[i];if(a.error){const e=`InfluxDB error: ${a.error}`;return Promise.reject(new Error(e))}if(!a||!a.series)continue;const l=t[i].series;for(let t=0;t<l.length;t++){var n,o;const a=l[t],u=[],s=[];if(a.values)for(i=0;i<a.values.length;i++)u.push(a.values[i][0]),s.push(a.values[i][1]);const c={name:e.TIME_SERIES_TIME_FIELD_NAME,type:e.FieldType.time,config:{},values:new e.ArrayVector(u)},d={name:null==a||null===(n=a.tags)||void 0===n?void 0:n.itemid,type:e.FieldType.number,config:{},values:new e.ArrayVector(s)};r.push(new e.MutableDataFrame({name:null==a||null===(o=a.tags)||void 0===o?void 0:o.itemid,fields:[c,d]}))}}return r.map((t=>(0,e.dataFrameToJSON)(t)))}(t)))}getTrends(e,t,r,n){return n.retentionPolicy=this.retentionPolicy,this.getHistory(e,t,r,n)}buildHistoryQuery(e,t,r,n,o,i){const{timeFrom:a,timeTill:l}=r;let u="value";return i&&(u=Qe[o]||"value_avg"),k(`SELECT ${_t[o]||o}("${u}")\n                   FROM ${i?`"${i}"."${t}"`:`"${t}"`}\n                   WHERE ${this.buildWhereClause(e)}\n                     AND "time" >= ${a}s\n                     AND "time" <= ${l}s\n                   GROUP BY time(${n}s), "itemid" fill(none)`)}buildWhereClause(e){return`(${e.map((e=>`"itemid" = '${e}'`)).join(" OR ")})`}invokeInfluxDBQuery(e){var t,r=this;return(t=function*(){const t=yield r.influxDS._seriesQuery(e).toPromise();return(null==t?void 0:t.results)||[]},function(){var e=this,r=arguments;return new Promise((function(n,o){var i=t.apply(e,r);function a(e){Ot(i,n,o,a,l,"next",e)}function l(e){Ot(i,n,o,a,l,"throw",e)}a(void 0)}))})()}constructor(e){super(e),St(this,"retentionPolicy",void 0),St(this,"influxDS",void 0),this.retentionPolicy=e.retentionPolicy,super.loadDBDataSource().then((e=>(this.influxDS=e,e)))}}function Tt(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function Pt(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Tt(i,n,o,a,l,"next",e)}function l(e){Tt(i,n,o,a,l,"throw",e)}a(void 0)}))}}function Ct(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const It=["getHistory","getTrend","getGroups","getHosts","getApps","getItems","getMacros","getUMacros","getItemsByIDs","getEvents","getAlerts","getHostAlerts","getUserMacros","getHostICAlerts","getHostPCAlerts","getAcknowledges","getITService","getSLA","getVersion","getProxies","getEventAlerts","getExtendedEventData","getProblems","getEventsHistory","getTriggersByIds","getScripts","getValueMappings","getSLAList","getUsers"],At=["getGroups","getHosts","getApps","getItems","getMacros","getUMacros","getItemsByIDs","getITService","getProxies","getValueMappings","getSLAList","getUsers"],Rt=["getHistory","getTrend","getMacros","getItemsByIDs","getEvents","getAlerts","getHostAlerts","getUserMacros","getHostICAlerts","getHostPCAlerts","getAcknowledges","getITService","acknowledgeEvent","getProxies","getEventAlerts","getExtendedEventData","getScripts","executeScript","getValueMappings","getSLAList","getUsers"];class xt{initDBConnector(e,t,r){return Xe.loadDatasource(e,t).then((n=>{const o={datasourceId:e,datasourceName:t};return"influxdb"===n.type?(o.retentionPolicy=r.dbConnectionRetentionPolicy,this.dbConnector=new wt(o)):this.dbConnector=new bt(o),this.dbConnector}))}proxifyRequests(){for(const e of It)this.zabbixAPI[e]=this.cachingProxy.proxify(this.zabbixAPI[e],e,this.zabbixAPI)}cacheRequests(){for(const e of At)this.zabbixAPI[e]=this.cachingProxy.cacheRequest(this.zabbixAPI[e],e,this.zabbixAPI)}bindRequests(){for(const e of Rt)this[e]=this.zabbixAPI[e].bind(this.zabbixAPI)}testDataSource(){let e,t;return this.getVersion().then((t=>(e=t,this.getAllGroups()))).then((()=>this.enableDirectDBConnection?this.dbConnector.testDataSource():Promise.resolve())).catch((e=>Promise.reject(e))).then((r=>(r&&(t={dsType:this.dbConnector.datasourceTypeName||this.dbConnector.datasourceTypeId,dsName:this.dbConnector.datasourceName}),{zabbixVersion:e,dbConnectorStatus:t})))}getVersion(){var e=this;return Pt((function*(){return e.version||(e.zabbixAPI.version?e.version=e.zabbixAPI.version:e.version=yield e.zabbixAPI.initVersion()),e.version}))()}supportsApplications(){const e=this.version||this.zabbixAPI.version;return!e||Ue().lt(e,"5.4.0")}supportSLA(){const e=this.version||this.zabbixAPI.version;return!e||Ue().gte(e,"6.0.0")}isZabbix54OrHigher(){var e=this;return Pt((function*(){const t=yield e.zabbixAPI.initVersion();return!!t&&Ue().gte(t,"5.4.0")}))()}isZabbix54OrHigherSync(){return!!this.version&&Ue().gte(this.version,"5.4.0")}getItemsFromTarget(e,t){const n=r().map(["group","host","application","itemTag","item"],(t=>e[t].filter));return this.getItems(...n,t)}getMacrosFromTarget(e){const t=r().map(["group","host","macro"],(t=>e[t].filter));return this.getUMacros(...t)}getHostsApsFromTarget(e){var t=this;return Pt((function*(){const r=["group","host","application"].map((t=>e[t].filter)),n=yield Promise.all([t.getHosts(...r),t.getApps(...r)]),o=n[0];let i=n[1];return i.appFilterEmpty&&(i=[]),[o,i]}))()}getHostsFromICTarget(e,t){var r=this;return Pt((function*(){const n=["group","host","application","itemTag","item"].map((t=>e[t].filter)),[o,i]=yield r.getHostsApsFromTarget(e);return[o,i,yield r.getItems(...n,t)]}))()}getHostsFromPCTarget(e,t){var r=this;return Pt((function*(){const n=["group","host","application","proxy","trigger"].map((t=>e[t].filter)),[o,i]=yield r.getHostsApsFromTarget(e);return[o,i,yield r.getCProblems(...n,t)]}))()}getAllGroups(){return this.zabbixAPI.getGroups()}getGroups(e){return this.getAllGroups().then((t=>Dt(t,e)))}getAllHosts(e){return this.getGroups(e).then((e=>{const t=r().map(e,"groupid");return this.zabbixAPI.getHosts(t)}))}getHosts(e,t){return this.getAllHosts(e).then((e=>Dt(e,t)))}getAllApps(e,t){var n=this;return Pt((function*(){return yield n.getVersion(),n.supportsApplications()?n.getHosts(e,t).then((e=>{const t=r().map(e,"hostid");return n.zabbixAPI.getApps(t)})):[]}))()}getApps(e,t,n){var o=this;return Pt((function*(){yield o.getVersion();const i=!o.supportsApplications();return o.getHosts(e,t).then((e=>{const t=r().map(e,"hostid");if(n&&!i)return o.zabbixAPI.getApps(t).then((e=>Lt(e,n)));{const e=t;return e.hostids=t,e.appFilterEmpty=!0,Promise.resolve(e)}}))}))()}getAllMacros(e,t){var r=this;return Pt((function*(){const n=yield r.getHosts(e,t),o=null==n?void 0:n.map((e=>e.hostid));return r.zabbixAPI.getMacros(o)}))()}getUMacros(e,t,n){var o=this;return Pt((function*(){return i=yield o.getAllMacros(e,t),R(a=n)?function(e,t){const n=N(t);return r().filter(e,(e=>n.test(null==e?void 0:e.macro)))}(i,a):function(e,t){return r().filter(e,{macro:t})||[]}(i,a);var i,a}))()}getItemTags(e,t,n){var o=this;return Pt((function*(){const i=yield o.getAllItems(e,t,null,null,{});let a=r().flatten(i.map((e=>e.tags?e.tags:[])));return a=r().uniqBy(a,(e=>e.tag+e.value||"")),Dt(a.map((e=>({name:V(e)}))),n)}))()}getAllItems(e,t,n,o,i={}){var a=this;return Pt((function*(){if(!a.isZabbix54OrHigher())return a.getAllItemsBefore54(e,t,n,o,i);const l=yield a.getHosts(e,t),u=r().map(l,"hostid");if(R(o)){const r=yield a.getItemTags(e,t,o);o=r.map((e=>e.name)).join(",")}let s=yield a.zabbixAPI.getItems(u,void 0,i.itemtype,o);return i.showDisabledItems||(s=r().filter(s,{status:"0"})),yield a.expandUserMacro(s,!1)}))()}getAllItemsBefore54(e,t,n,o,i={}){var a=this;return Pt((function*(){const o=yield a.getApps(e,t,n);let l;if(o.appFilterEmpty)l=yield a.zabbixAPI.getItems(o.hostids,void 0,i.itemtype,void 0);else{const e=r().map(o,"applicationid");l=yield a.zabbixAPI.getItems(void 0,e,i.itemtype,void 0)}return i.showDisabledItems||(l=r().filter(l,{status:"0"})),yield a.expandUserMacro(l,!1)}))()}expandUserMacro(e,t){const n=function(e){const t=r().map(e,(e=>r().map(e.hosts,"hostid")));return r().uniq(r().flatten(t))}(e);return this.getMacros(n).then((n=>(r().forEach(e,(e=>{var r;r=t?e.url:e.name,P.test(r)&&(t?e.url=C(e,n,t):e.name=C(e,n))})),e)))}getItems(e,t,r,n,o,i={}){return this.getAllItems(e,t,r,n,i).then((e=>Lt(e,o)))}getItemValues(e,t,n,o,i={}){return this.getItems(e,t,n,null,o,i).then((e=>{let t=[u()().subtract(2,"h").unix(),u()().unix()];i.range&&(t=[i.range.from.unix(),i.range.to.unix()]);const[n,o]=t;return this.zabbixAPI.getHistory(e,n,o).then((e=>e?r().uniq(e.map((e=>e.value))).map((e=>({name:e}))):[]))}))}getITServices(e){var t=this;return Pt((function*(){return Dt(yield t.zabbixAPI.getITService(),e)}))()}getSLAs(e){var t=this;return Pt((function*(){return Dt(yield t.zabbixAPI.getSLAList(),e)}))()}getProblems(e,t,n,o,i){const a=[this.getGroups(e),this.getHosts(e,t),this.getApps(e,t,n)];return Promise.all(a).then((o=>{const[i,a,l]=o,u={};return n&&(u.applicationids=r().flatten(r().map(l,"applicationid"))),t&&"/.*/"!==t&&(u.hostids=r().map(a,"hostid")),e&&(u.groupids=r().map(i,"groupid")),u})).then((e=>this.zabbixAPI.getProblems(e.groupids,e.hostids,e.applicationids,i))).then((e=>{const t=null==e?void 0:e.map((e=>e.objectid));return Promise.all([Promise.resolve(e),this.zabbixAPI.getTriggersByIds(t)])})).then((([e,t])=>xe(e,t))).then((e=>this.filterTriggersByProxy(e,o)))}getProblemsHistory(e,t,n,o,i){const{valueFromEvent:a}=i,l=[this.getGroups(e),this.getHosts(e,t),this.getApps(e,t,n)];return Promise.all(l).then((o=>{const[i,a,l]=o,u={};return n&&(u.applicationids=r().flatten(r().map(l,"applicationid"))),t&&(u.hostids=r().map(a,"hostid")),e&&(u.groupids=r().map(i,"groupid")),u})).then((e=>this.zabbixAPI.getEventsHistory(e.groupids,e.hostids,e.applicationids,i))).then((e=>{const t=null==e?void 0:e.map((e=>e.objectid));return Promise.all([Promise.resolve(e),this.zabbixAPI.getTriggersByIds(t)])})).then((([e,t])=>Ne(e,t,{valueFromEvent:a}))).then((e=>this.filterTriggersByProxy(e,o)))}getCProblems(e,t,n,o,i,a){const l=[this.getGroups(e),this.getHosts(e,t),this.getApps(e,t,n)];return Promise.all(l).then((o=>{const[i,a,l]=o,u={};return n&&(u.applicationids=r().flatten(r().map(l,"applicationid"))),t&&"/.*/"!==t&&(u.hostids=r().map(a,"hostid")),e&&(u.groupids=r().map(i,"groupid")),u})).then((e=>this.zabbixAPI.getProblems(e.groupids,e.hostids,e.applicationids,a))).then((e=>Dt(e,i))).then((e=>{const t=null==e?void 0:e.map((e=>e.objectid));return Promise.all([Promise.resolve(e),this.zabbixAPI.getTriggersByIds(t)])})).then((([e,t])=>xe(e,t))).then((e=>this.filterTriggersByProxy(e,o)))}filterTriggersByProxy(e,t){return this.getFilteredProxies(t).then((r=>{if(t&&"/.*/"!==t&&e){const t=r.map((e=>e.proxyid));e=e.filter((e=>{for(let r=0;r<e.hosts.length;r++){const n=e.hosts[r],o=n.proxyid||n.proxy_hostid;if(t.includes(o))return!0}return!1}))}return e}))}getFilteredProxies(e){return this.zabbixAPI.getProxies().then((t=>(t.forEach((e=>e.name=e.host)),Dt(t,e))))}getHistoryTS(e,t,r){const[n,o]=t;return this.enableDirectDBConnection?this.getHistoryDB(e,n,o,r).then((t=>Te(t,e,r))):this.zabbixAPI.getHistory(e,n,o).then((t=>he(t,e)))}getTrends(e,t,r){const[n,o]=t;if(this.enableDirectDBConnection)return this.getTrendsDB(e,n,o,r).then((t=>Te(t,e,r)));{const t=r.consolidateBy||r.valueType;return this.zabbixAPI.getTrend(e,n,o).then((r=>me(r,e,t))).then(_e)}}getHistoryText(e,t,r){const[n,o]=t;return e.length?this.zabbixAPI.getHistory(e,n,o).then((t=>"table"===r.resultFormat?Ee(t,e,r):ye(t,e,r))):Promise.resolve([])}getSLI(t,r,n,o,i){var a=this;return Pt((function*(){const l=t.map((e=>e.serviceid));if("status"===o.slaProperty)return function(t,r,n){const o=[];for(let r=0;r<(null==t?void 0:t.length);r++){const n=t[r],i=Number(n.status);o.push({name:n?n.name:r,type:e.FieldType.number,config:{},values:new e.ArrayVector([i])})}const i={name:e.TIME_SERIES_TIME_FIELD_NAME,type:e.FieldType.time,config:{custom:{}},values:new e.ArrayVector([Date.now()])};return new e.MutableDataFrame({refId:n.refId,name:"Service status",fields:[i,...o]})}(yield a.zabbixAPI.getServices(l),0,o);const u=r.map((e=>e.slaid));if(u.length>1){const s=null==u?void 0:u.map((e=>a.zabbixAPI.getSLI(e,l,n,i)));return function(t,r,n,o){var i;if(!t||0===(null==t?void 0:t.length))return new e.MutableDataFrame({refId:o.refId,name:"SLI",fields:[]});const a=t[0],l=[];for(let e=0;e<(null==a||null===(i=a.periods)||void 0===i?void 0:i.length);e++){const t=a.periods[e];l.push(1e3*t.period_from)}const u={name:e.TIME_SERIES_TIME_FIELD_NAME,type:e.FieldType.time,config:{custom:{}},values:new e.ArrayVector(l)},s=[],c=pe(o.slaProperty);for(let o=0;o<t.length;o++){var d,f;const i=t[o],a=[];for(let e=0;e<(null==i||null===(d=i.sli)||void 0===d?void 0:d.length);e++){const t=i.sli[e];for(let e=0;e<t.length;e++){const r=t[e][c];a[e]||(a[e]=[]),a[e].push(r)}}for(let l=0;l<(null==i||null===(f=i.serviceids)||void 0===f?void 0:f.length);l++){const u=null==i?void 0:i.serviceids[l].toString(),c=r.find((e=>e.serviceid===u));let d=`${(null==c?void 0:c.name)||u}`;t.length>1&&(d=`${d}: ${n[o].name}`),s.push({name:d,type:e.FieldType.number,config:{},values:new e.ArrayVector(a[l])})}}return new e.MutableDataFrame({refId:o.refId,name:"SLI",fields:[u,...s]})}(yield Promise.all(s),t,r,o)}{const r=(null==u?void 0:u.length)>0?u[0]:void 0;return function(t,r,n){var o,i,a;const l=[];for(let e=0;e<(null==t||null===(o=t.periods)||void 0===o?void 0:o.length);e++){const r=t.periods[e];l.push(1e3*r.period_from)}const u={name:e.TIME_SERIES_TIME_FIELD_NAME,type:e.FieldType.time,config:{custom:{}},values:new e.ArrayVector(l)},s=[],c=[];let d=pe(n.slaProperty);for(let e=0;e<(null==t||null===(i=t.sli)||void 0===i?void 0:i.length);e++){const r=t.sli[e];for(let e=0;e<r.length;e++){const t=r[e][d];c[e]||(c[e]=[]),c[e].push(t)}}for(let n=0;n<(null==t||null===(a=t.serviceids)||void 0===a?void 0:a.length);n++){const o=null==t?void 0:t.serviceids[n].toString(),i=r.find((e=>e.serviceid===o));s.push({name:i?i.name:o,type:e.FieldType.number,config:{},values:new e.ArrayVector(c[n])})}return new e.MutableDataFrame({refId:n.refId,name:"SLI",fields:[u,...s]})}(yield a.zabbixAPI.getSLI(r,l,n,i),t,o)}}))()}getSLA(e,t,n,o){var i=this;return Pt((function*(){const a=r().map(e,"serviceid");if(i.supportSLA()){const l=yield i.zabbixAPI.getSLA60(a,t,o);return r().map(a,(t=>{const o=r().find(e,{serviceid:t});return Oe(o,n.slaProperty,l)}))}const l=yield i.zabbixAPI.getSLA(a,t,o);return r().map(a,(t=>{const o=r().find(e,{serviceid:t});return Oe(o,n.slaProperty,l)}))}))()}constructor(e){Ct(this,"enableDirectDBConnection",void 0),Ct(this,"cachingProxy",void 0),Ct(this,"zabbixAPI",void 0),Ct(this,"getHistoryDB",void 0),Ct(this,"dbConnector",void 0),Ct(this,"getTrendsDB",void 0),Ct(this,"version",void 0),Ct(this,"getHistory",void 0),Ct(this,"getTrend",void 0),Ct(this,"getItemsByIDs",void 0),Ct(this,"getEvents",void 0),Ct(this,"getAlerts",void 0),Ct(this,"getHostAlerts",void 0),Ct(this,"getHostICAlerts",void 0),Ct(this,"getHostPCAlerts",void 0),Ct(this,"getAcknowledges",void 0),Ct(this,"getITService",void 0),Ct(this,"acknowledgeEvent",void 0),Ct(this,"getProxies",void 0),Ct(this,"getEventAlerts",void 0),Ct(this,"getExtendedEventData",void 0),Ct(this,"getMacros",void 0),Ct(this,"getUserMacros",void 0),Ct(this,"getValueMappings",void 0),Ct(this,"getSLAList",void 0),Ct(this,"getUsers",void 0);const{basicAuth:t,withCredentials:r,cacheTTL:n,enableDirectDBConnection:o,dbConnectionDatasourceId:i,dbConnectionDatasourceName:a,dbConnectionRetentionPolicy:l,datasourceId:u}=e;this.enableDirectDBConnection=o;const s={enabled:!0,ttl:n};if(this.cachingProxy=new Ge(s),this.zabbixAPI=new ut(t,r,u),this.proxifyRequests(),this.cacheRequests(),this.bindRequests(),o){const e={dbConnectionRetentionPolicy:l};this.initDBConnector(i,a,e).then((()=>{this.getHistoryDB=this.cachingProxy.proxifyWithCache(this.dbConnector.getHistory,"getHistory",this.dbConnector),this.getTrendsDB=this.cachingProxy.proxifyWithCache(this.dbConnector.getTrends,"getTrends",this.dbConnector)}))}}}function Nt(e,t){const n=N(t);return r().filter(e,(e=>n.test(e.name)))}function Dt(e,t){return R(t)?Nt(e,t):function(e,t){const n=r().find(e,{name:t});return n?[n]:[]}(e,t)}function Lt(e,t){return R(t)?Nt(e,t):function(e,t){return r().filter(e,{name:t})||[]}(e,t)}var jt=b(85959),Mt=b.n(jt),kt=function(){return kt=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},kt.apply(this,arguments)};function Ft(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var n,o,i=(0,jt.useRef)(0),a=(n=(0,jt.useRef)(!1),o=(0,jt.useCallback)((function(){return n.current}),[]),(0,jt.useEffect)((function(){return n.current=!0,function(){n.current=!1}}),[]),o),l=(0,jt.useState)(r),u=l[0],s=l[1],c=(0,jt.useCallback)((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var n=++i.current;return u.loading||s((function(e){return kt(kt({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return a()&&n===i.current&&s({value:e,loading:!1}),e}),(function(e){return a()&&n===i.current&&s({error:e,loading:!1}),e}))}),t);return[u,c]}Object.create,Object.create,"function"==typeof SuppressedError&&SuppressedError;var qt=b(82007),Vt=b(46089);const Bt=({children:e})=>{const t=Ut();return Mt().createElement(qt.InlineFieldRow,null,e,Mt().createElement(qt.InlineFormLabel,{className:t.rowTerminator},Mt().createElement(Mt().Fragment,null)))},Ut=()=>({rowTerminator:(0,Vt.css)({flexGrow:1})});(0,qt.stylesFactory)((t=>{const r=t.type===e.GrafanaThemeType.Light?"#497dc0":"#005f81",n=t.type===e.GrafanaThemeType.Light?"#456ba4":"#354f77";return{button:Vt.css`
      height: 2rem;
      background-image: none;
      background-color: ${r};
      border: 1px solid ${t.palette.gray1};
      border-radius: 1px;
      color: ${t.colors.text};

      i {
        vertical-align: middle;
      }

      &:hover {
        background-color: ${n};
      }
    `,icon:Vt.css`
      i {
        color: ${t.colors.text};
      }
    `}})),b(48398);Mt().createContext(oe.config).Consumer,Mt().Component;const Wt=({options:e,offset:t,minWidth:r,selected:n,onSelect:o})=>{const i=(0,qt.useTheme2)(),a=(0,qt.getSelectStyles)(i),l=(0,qt.useStyles2)(Ht(r));return Mt().createElement("div",{className:(0,Vt.cx)(a.menu,l.menuWrapper,{[l.menuLeft]:t.horizontal>0},Vt.css`
          bottom: ${t.vertical>0?`${t.vertical}px`:"unset"};
          top: ${t.vertical<0?`${Math.abs(t.vertical)}px`:"unset"};
        `)},Mt().createElement("div",{className:l.menu,"aria-label":"Metric picker menu"},Mt().createElement(qt.CustomScrollbar,{autoHide:!1,autoHeightMax:"300px",hideHorizontalTrack:!0},Mt().createElement("div",null,Mt().createElement("div",{className:a.optionBody},null==e?void 0:e.map(((e,t)=>Mt().createElement(Gt,{data:e,key:t,onClick:o,isFocused:n===t,hideDescription:!0}))))))))},Gt=Mt().forwardRef((({data:e,isFocused:t,disabled:r,onClick:n,hideDescription:o},i)=>{const a=(0,qt.useTheme2)(),l=(0,qt.getSelectStyles)(a),u=(0,qt.useStyles2)(Ht()),s=(0,Vt.cx)(l.option,u.menuOptionWrapper,t&&l.optionFocused,r&&u.menuOptionDisabled);return Mt().createElement("div",{ref:i,className:s,"aria-label":"Menu option",onClick:t=>{r||(t.preventDefault(),t.stopPropagation(),n(e))}},Mt().createElement("div",{className:(0,Vt.cx)(l.optionBody,u.menuOptionBody)},Mt().createElement("span",null,e.label||e.value),!o&&e.description&&Mt().createElement("div",{className:l.optionDescription},e.description)),e.description&&Mt().createElement(qt.Tooltip,{content:e.description},Mt().createElement(qt.Icon,{name:"info-circle",className:u.menuOptionInfoSign})))}));Gt.displayName="MenuOption";const Ht=e=>t=>({menuWrapper:Vt.css`
      display: flex;
      max-height: 650px;
      position: absolute;
      z-index: ${t.zIndex.dropdown};
      overflow: hidden;
      min-width: auto;
    `,menu:Vt.css`
      min-width: ${t.spacing(e||0)};

      & > div {
        padding-top: ${t.spacing(1)};
      }
    `,menuLeft:Vt.css`
      right: 0;
      flex-direction: row-reverse;
    `,container:Vt.css`
      padding: ${t.spacing(1)};
      border: 1px ${t.colors.border.weak} solid;
      border-radius: ${t.shape.borderRadius(1)};
      background-color: ${t.colors.background.primary};
      z-index: ${t.zIndex.modal};
    `,menuOptionWrapper:Vt.css`
      padding: ${t.spacing(.5)};
    `,menuOptionBody:Vt.css`
      font-weight: ${t.typography.fontWeightRegular};
      padding: ${t.spacing(0,1.5,0,0)};
    `,menuOptionDisabled:Vt.css`
      color: ${t.colors.text.disabled};
      cursor: not-allowed;
    `,menuOptionInfoSign:Vt.css`
      color: ${t.colors.text.disabled};
    `}),Kt=({value:e,options:t,isLoading:r,width:n,onChange:o})=>{const[i,a]=(0,jt.useState)(!1),[l,u]=(0,jt.useState)(e),[s,c]=(0,jt.useState)(t),[d,f]=(0,jt.useState)(-1),[p]=(0,jt.useState)({vertical:0,horizontal:0}),g=(0,jt.useRef)(null),v=(0,qt.useStyles2)($t),h=(0,Vt.cx)({[v.inputRegexp]:R(l),[v.inputVariable]:l.startsWith("$")});(0,jt.useEffect)((()=>{c(t)}),[t]);const m=(0,jt.useCallback)((()=>{a(!1)}),[]),y=e=>{const t=(null==e?void 0:e.value)||"";u(t),o(t),m()};return Mt().createElement("div",{"data-testid":"role-picker",style:{position:"relative"},ref:g},Mt().createElement(qt.ClickOutsideWrapper,{onClick:()=>i&&m()},Mt().createElement(qt.Input,{className:h,value:l,type:"text",onChange:r=>{var n;i||a(!0);const o=null==r||null===(n=r.currentTarget)||void 0===n?void 0:n.value;if(o)if(u(o),e!==o){const e=t.filter((e=>{var t,r;return(null===(t=e.value)||void 0===t?void 0:t.toLowerCase().includes(o.toLowerCase()))||(null===(r=e.label)||void 0===r?void 0:r.toLowerCase().includes(o.toLowerCase()))}));c(e)}else c(t);else u(""),c(t)},onBlur:()=>{o(l)},onMouseDown:()=>{a(!0),c(t)},suffix:r&&Mt().createElement(qt.Spinner,null),width:n,onKeyDown:e=>{if("ArrowDown"===e.key){i||a(!0),e.preventDefault(),e.stopPropagation();const t=d<s.length-1?d+1:0;f(t)}else if("ArrowUp"===e.key){i||a(!0),e.preventDefault(),e.stopPropagation();const t=d>0?d-1:s.length-1;f(t)}else"Enter"===e.key&&(e.preventDefault(),e.stopPropagation(),y(s[d]))}}),i&&Mt().createElement(Wt,{options:s,onSelect:y,offset:p,minWidth:n,selected:d})))},$t=e=>({inputRegexp:Vt.css`
      input {
        color: ${e.colors.warning.main};
      }
    `,inputVariable:Vt.css`
      input {
        color: ${e.colors.primary.text};
      }
    `}),zt=()=>{const e=(0,oe.getTemplateSrv)().getVariables().filter((e=>"datasource"!==e.type&&"interval"!==e.type));return null==e?void 0:e.map((e=>({value:`$${e.name}`,label:`$${e.name}`})))};function Yt(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function Qt(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Yt(i,n,o,a,l,"next",e)}function l(e){Yt(i,n,o,a,l,"throw",e)}a(void 0)}))}}function Xt(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Jt(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Xt(e,t,r[t])}))}return e}function Zt(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const er=[{value:0,label:"Not classified"},{value:1,label:"Information"},{value:2,label:"Warning"},{value:3,label:"Average"},{value:4,label:"High"},{value:5,label:"Disaster"}],tr=({annotation:e,onAnnotationChange:t,datasource:n})=>{var o,i,a,l,u,s,c;const d=(e=Q(e)).target,f=(p=Qt((function*(){const e=yield n.zabbix.getAllGroups(),t=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return t.unshift(...zt()),t})),function(){return p.apply(this,arguments)});var p;const[{loading:g,value:v},h]=Ft(Qt((function*(){return yield f()})),[]),m=function(){var e=Qt((function*(e){const t=n.replaceTemplateVars(e),o=yield n.zabbix.getAllHosts(t);let i=null==o?void 0:o.map((e=>({value:e.name,label:e.name})));return i=r().uniqBy(i,(e=>e.value)),i.unshift({value:"/.*/"}),i.unshift(...zt()),i}));return function(t){return e.apply(this,arguments)}}(),[{loading:y,value:b},E]=Ft(Qt((function*(){return yield m(d.group.filter)})),[d.group.filter]),O=function(){var e=Qt((function*(e,t){const o=n.replaceTemplateVars(e),i=n.replaceTemplateVars(t),a=yield n.zabbix.getAllApps(o,i);let l=null==a?void 0:a.map((e=>({value:e.name,label:e.name})));return l=r().uniqBy(l,(e=>e.value)),l.unshift(...zt()),l}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:S,value:_},w]=Ft(Qt((function*(){return yield O(d.group.filter,d.host.filter)})),[d.group.filter,d.host.filter]),T=n.replaceTemplateVars(null===(o=d.group)||void 0===o?void 0:o.filter),P=n.replaceTemplateVars(null===(i=d.host)||void 0===i?void 0:i.filter);(0,jt.useEffect)((()=>{h()}),[]),(0,jt.useEffect)((()=>{E()}),[T]),(0,jt.useEffect)((()=>{w()}),[T,P]);const C=r=>{t(Zt(Jt({},e),{target:r}))},I=e=>t=>{null!==t&&C(Zt(Jt({},d),{[e]:{filter:t}}))},A=e=>()=>{C(Zt(Jt({},d),{options:Zt(Jt({},d.options),{[e]:!d.options[e]})}))};return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(a=d.group)||void 0===a?void 0:a.filter,options:v,isLoading:g,onChange:I("group")})),Mt().createElement(qt.InlineField,{label:"Host",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(l=d.host)||void 0===l?void 0:l.filter,options:b,isLoading:y,onChange:I("host")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Application",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(u=d.application)||void 0===u?void 0:u.filter,options:_,isLoading:S,onChange:I("application")})),Mt().createElement(qt.InlineField,{label:"Problem",labelWidth:12},Mt().createElement(qt.Input,{width:24,defaultValue:null===(s=d.trigger)||void 0===s?void 0:s.filter,placeholder:"Problem name",onBlur:(R="trigger",e=>{var t;const r=null==e||null===(t=e.currentTarget)||void 0===t?void 0:t.value;null!==r&&C(Zt(Jt({},d),{[R]:{filter:r}}))})}))),Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineField,{label:"Min severity",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:null===(c=d.options)||void 0===c?void 0:c.minSeverity,options:er,onChange:e=>{null!==e.value&&C(Zt(Jt({},d),{options:Zt(Jt({},d.options),{minSeverity:e.value})}))}})),Mt().createElement(qt.InlineField,{label:"Show OK events",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:d.options.showOkEvents,onChange:A("showOkEvents")})),Mt().createElement(qt.InlineField,{label:"Hide acknowledged events",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:d.options.hideAcknowledged,onChange:A("hideAcknowledged")})),Mt().createElement(qt.InlineField,{label:"Show hostname",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:d.options.showHostname,onChange:A("showHostname")}))));var R};function rr(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function nr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){rr(i,n,o,a,l,"next",e)}function l(e){rr(i,n,o,a,l,"throw",e)}a(void 0)}))}}function or(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function ir(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){or(e,t,r[t])}))}return e}function ar(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}class lr extends e.DataSourceApi{query(t){(t=>{t.app!==e.CoreApp.Dashboard&&t.app!==e.CoreApp.PanelViewer&&t.targets.forEach((e=>{const r={app:t.app};switch(e.queryType){case s:r.queryType="Metrics";break;case c:r.queryType="Services";break;case d:r.queryType="Text";break;case f:r.queryType="Item Id";break;case p:r.queryType="Triggers";break;case g:r.queryType="Problems";break;case v:r.queryType="Macros"}(0,oe.reportInteraction)("grafana_zabbix_query_executed",r)}))})(t);const n=t.targets.map((e=>z(r().cloneDeep(e)))).map((e=>{var t;let r=(0,oe.getDataSourceSrv)().getInstanceSettings(null==e?void 0:e.datasource);var n;return(null==r||null===(t=r.rawRef)||void 0===t?void 0:t.uid)?ar(ir({},e),{datasource:ar(ir({},null==e?void 0:e.datasource),{uid:null===(n=r.rawRef)||void 0===n?void 0:n.uid})}):e})),o=this.backendQuery(ar(ir({},t),{targets:n})),i=this.dbConnectionQuery(ar(ir({},t),{targets:n})),a=this.frontendQuery(ar(ir({},t),{targets:n})),l=this.annotationRequest(ar(ir({},t),{targets:n}));return Promise.all([o,i,a,l]).then((r=>{const[n,o,i,a]=r;return o.data&&(n.data=n.data.concat(o.data)),i.data&&(n.data=n.data.concat(i.data)),a.data&&(n.data=n.data.concat(a.data)),{data:n.data,state:e.LoadingState.Done,key:t.requestId}}))}backendQuery(e){var t=this;return nr((function*(){const{intervalMs:n,maxDataPoints:o,range:i,requestId:a}=e,l=e.targets.filter(t.isBackendTarget);e.scopedVars=Object.assign({},e.scopedVars,x(e.range));const u=r().compact(l.map((r=>r.hide?null:(t.replaceTargetVariables(r,e),ar(ir({},r),{datasourceId:t.datasourceId,intervalMs:n,maxDataPoints:o})))));if(!u.length)return Promise.resolve({data:[]});const s={queries:u};let c;i&&(s.range=i,s.from=i.from.valueOf().toString(),s.to=i.to.valueOf().toString());try{c=yield(0,oe.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",data:s,requestId:a}).toPromise()}catch(e){return(0,oe.toDataQueryResponse)(e)}const d=(0,oe.toDataQueryResponse)(c);return t.sortByRefId(d),t.applyFrontendFunctions(d,e),Re(d),Ce(d.data)&&(console.log("Converting response to the wide format"),d.data=Ie(d.data)),d}))()}frontendQuery(t){var n=this;return nr((function*(){const o=t.targets.filter((e=>!(n.isBackendTarget(e)||n.isDBConnectionTarget(e)))),i=r().map(o,(e=>{if(e.hide)return[];t.scopedVars=Object.assign({},t.scopedVars,x(t.range)),n.replaceTargetVariables(e,t);const r=n.buildTimeRange(t,e);return e.queryType===d?e.group&&e.host&&e.item?n.queryTextData(e,r):[]:e.queryType===c?n.queryITServiceData(e,r,t):e.queryType===p?n.queryTriggersData(e,r,t):e.queryType===g?n.queryProblems(e,r,t):e.queryType===v?n.queryUserMacrosData(e):[]}));return Promise.all(r().flatten(i)).then(r().flatten).then((t=>(t&&t.length>0&&(0,e.isDataFrame)(t[0])&&!function(t){return t.fields.length&&t.fields[0].type===e.FieldType.other&&"problems"===t.fields[0].config.custom.type}(t[0])&&!function(e){return"macros"===e.name}(t[0])&&!function(t){return!t.fields.find((t=>t.type===e.FieldType.time||t.name===e.TIME_SERIES_TIME_FIELD_NAME))}(t[0])&&(t=Ae(t),Ce(t)&&(console.log("Converting response to the wide format"),t=Ie(t))),{data:t})))}))()}dbConnectionQuery(e){var t=this;return nr((function*(){const n=e.targets.filter(t.isDBConnectionTarget),o=r().compact(n.map((r=>{if(r.hide)return[];e.scopedVars=Object.assign({},e.scopedVars,x(e.range)),t.replaceTargetVariables(r,e);const n=t.buildTimeRange(e,r),o=t.isUseTrends(n,r);return r.queryType&&r.queryType!==s?r.queryType===f&&r.itemids?t.queryItemIdData(r,n,o,e):[]:t.queryNumericData(r,n,o,e)})));return Promise.all(o).then(r().flatten).then((e=>({data:e})))}))()}buildTimeRange(e,t){let r=Math.ceil(a.parse(e.range.from)/1e3),n=Math.ceil(a.parse(e.range.to)/1e3);const o=ur(t.functions,"Time");if(o.length){const[e,t]=M(o)([r,n]);r=e,n=t}return[r,n]}queryNumericData(e,t,r,n){var o=this;return nr((function*(){const i=yield o.zabbix.getItemsFromTarget(e,{itemtype:"num"}),a=(new Date).getTime(),l=yield o.queryNumericDataForItems(i,e,t,r,n),u=(new Date).getTime();return o.enableDebugLog&&console.log(`Datasource::Performance Query Time (${o.name}): ${u-a}`),o.handleBackendPostProcessingResponse(l,n,e)}))()}queryNumericDataForItems(e,t,n,o,i){var a=this;return nr((function*(){let l;i.valueType=a.getTrendValueType(t),i.consolidateBy=function(e){let t;const n=r().find(e.functions,(e=>"consolidateBy"===e.def.name));return n&&n.params&&n.params.length&&(t=n.params[0]),t}(t)||i.valueType,l=o?yield a.zabbix.getTrends(e,n,i):yield a.zabbix.getHistoryTS(e,n,i);const u={from:n[0],to:n[1]};return yield a.invokeDataProcessingQuery(l,t,u)}))()}invokeDataProcessingQuery(e,t,r){var n=this;return nr((function*(){const o={url:`/api/datasources/${n.datasourceId}/resources/db-connection-post`,method:"POST",headers:{"Content-Type":"application/json"},hideFromInspector:!1,data:{series:e,query:t,timeRange:r}};return(yield(0,oe.getBackendSrv)().fetch(o).toPromise()).data}))()}handleBackendPostProcessingResponse(t,r,n){const o=[];for(const r of t){const t=(0,e.dataFrameFromJSON)(r);t.refId=n.refId,o.push(t)}const i={data:o};return this.sortByRefId(i),this.applyFrontendFunctions(i,r),Ce(i.data)&&(console.log("Converting response to the wide format"),i.data=Ie(i.data)),i.data}getTrendValueType(e){const t=r().map(ne().Trends,"name"),n=r().find(e.functions,(e=>r().includes(t,e.def.name)));return n?n.params[0]:"avg"}sortByRefId(e){e.data.sort(((e,t)=>e.refId<t.refId?-1:e.refId>t.refId?1:0))}applyFrontendFunctions(e,t){for(let r=0;r<e.data.length;r++){const n=e.data[r];M(ur(pr(t,n.refId).functions,"Alias"))(n)}return e}queryTextData(t,r){return this.zabbix.getItemsFromTarget(t,{itemtype:"text"}).then((e=>this.zabbix.getHistoryText(e,r,t))).then((r=>"table"!==t.resultFormat?r.map((r=>we(r,t,[],e.FieldType.string))):r))}queryItemIdData(e,t,n,o){let i=e.itemids;return i=(0,oe.getTemplateSrv)().replace(i,o.scopedVars,dr),i=r().map(i.split(","),(e=>e.trim())),i?this.zabbix.getItemsByIDs(i).then((r=>this.queryNumericDataForItems(r,e,t,n,o))):[]}queryITServiceData(e,t,n){var o=this;return nr((function*(){if(e.hide||!e.itservice&&!e.itServiceFilter||!e.slaProperty)return[];let i;n.isOldVersion=e.itservice&&!e.itServiceFilter,i=n.isOldVersion?"/.*/":o.replaceTemplateVars(e.itServiceFilter,n.scopedVars),n.slaInterval=e.slaInterval;let a=yield o.zabbix.getITServices(i);var l;if(n.isOldVersion&&(a=r().filter(a,{serviceid:null===(l=e.itservice)||void 0===l?void 0:l.serviceid})),void 0!==e.slaFilter){const r=o.replaceTemplateVars(e.slaFilter,n.scopedVars),i=yield o.zabbix.getSLAs(r);return yield o.zabbix.getSLI(a,i,t,e,n)}const u=yield o.zabbix.getSLA(a,t,e,n),s=Pe(u,e.slaInterval),c=yield o.invokeDataProcessingQuery(s,e,{});return o.handleBackendPostProcessingResponse(c,n,e)}))()}queryUserMacrosData(e){var t=this;return nr((function*(){const n=e.group.filter,o=e.host.filter,i=e.macro.filter,a=yield t.zabbix.getUMacros(n,o,i),l=r().map(a,"hostmacroid"),u=yield t.zabbix.getUserMacros(l);return be(u,e)}))()}queryTriggersData(e,t,r){var n=this;return nr((function*(){var o;if("items"===e.countTriggersBy)return n.queryTriggersICData(e,t);if("problems"===e.countTriggersBy)return n.queryTriggersPCData(e,t,r);const[i,a]=yield n.zabbix.getHostsApsFromTarget(e);if(!i.length)return Promise.resolve([]);const l=e.group.filter,u=yield n.zabbix.getGroups(l),s=null==i?void 0:i.map((e=>e.hostid)),c=null==a?void 0:a.map((e=>e.applicationid)),d=gr(e,t),f=F(n.replaceTemplateVars(null===(o=e.tags)||void 0===o?void 0:o.filter,r.scopedVars).replace("/^","").replace("$/",""));f.forEach((e=>{e.operator=1})),f&&f.length&&(d.tags=f);const p=yield n.zabbix.getHostAlerts(s,c,d);return Se(p,u,t,e)}))()}queryTriggersICData(e,t){var r=this;return nr((function*(){const[n,o,i]=yield r.zabbix.getHostsFromICTarget(e,{itemtype:"num"});if(!n.length)return Promise.resolve([]);const a=e.group.filter,l=yield r.zabbix.getGroups(a),u=null==n?void 0:n.map((e=>e.hostid)),s=null==o?void 0:o.map((e=>e.applicationid)),c=null==i?void 0:i.map((e=>e.itemid));if(!c.length)return Promise.resolve([]);const d=gr(e,t),f=yield r.zabbix.getHostICAlerts(u,s,c,d);return Se(f,l,t,e)}))()}queryTriggersPCData(e,t,r){var n=this;return nr((function*(){var o,i,a,l,u,s,c,d;const[f,p]=t,g=F(n.replaceTemplateVars(null===(o=e.tags)||void 0===o?void 0:o.filter,r.scopedVars).replace("/^","").replace("$/",""));g.forEach((e=>{e.operator=1}));const v={minSeverity:null===(i=e.options)||void 0===i?void 0:i.minSeverity,limit:null===(a=e.options)||void 0===a?void 0:a.limit};var h;if(g&&g.length&&(v.tags=g),(0===(null===(l=e.options)||void 0===l?void 0:l.acknowledged)||1===(null===(u=e.options)||void 0===u?void 0:u.acknowledged))&&(v.acknowledged=!!(null===(h=e.options)||void 0===h?void 0:h.acknowledged)),null===(s=e.options)||void 0===s?void 0:s.minSeverity){var m;let t=[0,1,2,3,4,5].filter((t=>{var r;return t>=(null===(r=e.options)||void 0===r?void 0:r.minSeverity)}));(null===(m=e.options)||void 0===m?void 0:m.severities)&&(t=t.filter((t=>{var r;return null===(r=e.options)||void 0===r?void 0:r.severities.includes(t)}))),v.severities=t}e.options.useTimeRange&&(v.timeFrom=f,v.timeTo=p);const[y,b,E]=yield n.zabbix.getHostsFromPCTarget(e,v);if(!y.length)return Promise.resolve([]);const O=e.group.filter,S=yield n.zabbix.getGroups(O),_=null==y?void 0:y.map((e=>e.hostid)),w=null==b?void 0:b.map((e=>e.applicationid)),T=E.map((e=>e.triggerid)),P={minSeverity:null===(c=e.options)||void 0===c?void 0:c.minSeverity,acknowledged:null===(d=e.options)||void 0===d?void 0:d.acknowledged,count:e.options.count};e.options.useTimeRange&&(P.timeFrom=f,P.timeTo=p);const C=yield n.zabbix.getHostPCAlerts(_,w,T,P);return Se(C,S,t,e)}))()}queryProblems(e,t,n){var o=this;return nr((function*(){var a,l,u,s,c,d,f,p,g,v,h,m,y;const[b,E]=t,O=i.contextSrv.isEditor||i.contextSrv.isGrafanaAdmin;let S=!0;const _=e.showProblems||Ze.Problems,w=e.options.hostProxy?o.zabbix.getProxies():()=>[];S=!o.disableReadOnlyUsersAck||O;const T=o.replaceTemplateVars(null===(a=e.group)||void 0===a?void 0:a.filter,n.scopedVars),P=o.replaceTemplateVars(null===(l=e.host)||void 0===l?void 0:l.filter,n.scopedVars),C=o.replaceTemplateVars(null===(u=e.application)||void 0===u?void 0:u.filter,n.scopedVars),I=o.replaceTemplateVars(null===(s=e.proxy)||void 0===s?void 0:s.filter,n.scopedVars),A=o.replaceTemplateVars(null===(c=e.trigger)||void 0===c?void 0:c.filter,n.scopedVars),R=o.replaceTemplateVars(null===(d=e.tags)||void 0===d?void 0:d.filter,n.scopedVars),x=ar(ir({},e),{trigger:{filter:A},tags:{filter:R}}),N=F(R.replace("/^","").replace("$/",""));N.forEach((e=>{e.operator=1}));const D={recent:_===Ze.Recent,minSeverity:null===(f=e.options)||void 0===f?void 0:f.minSeverity,limit:null===(p=e.options)||void 0===p?void 0:p.limit};var L;if(N&&N.length&&(D.tags=N),(null==e?void 0:e.evaltype)&&(D.evaltype=null==e?void 0:e.evaltype),(0===(null===(g=e.options)||void 0===g?void 0:g.acknowledged)||1===(null===(v=e.options)||void 0===v?void 0:v.acknowledged))&&(D.acknowledged=!!(null===(L=e.options)||void 0===L?void 0:L.acknowledged)),null===(m=e.options)||void 0===m||null===(h=m.severities)||void 0===h?void 0:h.length){let t=[0,1,2,3,4,5].filter((t=>{var r;return null===(r=e.options)||void 0===r?void 0:r.severities.includes(t)}));D.severities=t}let j;_===Ze.History||(null===(y=e.options)||void 0===y?void 0:y.useTimeRange)?(D.timeFrom=b,D.timeTo=E,j=o.zabbix.getProblemsHistory(T,P,C,I,D)):j=o.zabbix.getProblems(T,P,C,I,D);const M=o.zabbix.getUsers();let k,q;return Promise.all([j,w,M]).then((([e,t,n])=>(q=r().keyBy(n,"userid"),k=r().keyBy(t,"proxyid"),e))).then((e=>Me(e))).then((e=>ke(e,S))).then((e=>Fe(e,x))).then((t=>qe(t,e))).then((t=>De(t,e))).then((e=>je(e,q))).then((e=>Le(e,k))).then((t=>Ve(t,e)))}))()}testDatasource(){var e=this;return nr((function*(){try{const{zabbixVersion:t,dbConnectorStatus:r}=yield e.zabbix.testDataSource();let n=`Zabbix API version: ${t}`;return r&&(n+=`, DB connector type: ${r.dsType}`),{status:"success",title:"Success",message:n}}catch(e){return e instanceof ft?{status:"error",title:e.message,message:e.message}:e.data&&e.data.message?{status:"error",title:"Zabbix Client Error",message:e.data.message}:"string"==typeof e?{status:"error",title:"Unknown Error",message:e}:(console.log(e),{status:"error",title:"Connection failed",message:"Could not connect to given url"})}}))()}metricFindQuery(e,t){let n,o=r().cloneDeep(e);if(!e)return Promise.resolve([]);"string"==typeof e&&(o=I(e));for(const e of["group","host","application","itemTag","item"])o[e]=this.replaceTemplateVars(o[e],{});const{group:i,host:a,application:l,item:u}=o;switch(o.queryType){case y.Group:n=this.zabbix.getGroups(o.group);break;case y.Host:n=this.zabbix.getHosts(o.group,o.host);break;case y.Application:n=this.zabbix.getApps(o.group,o.host,o.application);break;case y.ItemTag:n=this.zabbix.getItemTags(o.group,o.host,o.itemTag);break;case y.Item:n=this.zabbix.getItems(o.group,o.host,o.application,null,o.item);break;case y.ItemValues:const e=null==t?void 0:t.range;n=this.zabbix.getItemValues(i,a,l,u,{range:e});break;default:n=Promise.resolve([])}return n.then((e=>r().map(e,sr)))}targetContainsTemplate(e){var t,r,n,o,i,a,l,u;const s=(0,oe.getTemplateSrv)();return s.variableExists(null===(t=e.group)||void 0===t?void 0:t.filter)||s.variableExists(null===(r=e.host)||void 0===r?void 0:r.filter)||s.variableExists(null===(n=e.application)||void 0===n?void 0:n.filter)||s.variableExists(null===(o=e.itemTag)||void 0===o?void 0:o.filter)||s.variableExists(null===(i=e.item)||void 0===i?void 0:i.filter)||s.variableExists(null===(a=e.macro)||void 0===a?void 0:a.filter)||s.variableExists(null===(l=e.proxy)||void 0===l?void 0:l.filter)||s.variableExists(null===(u=e.trigger)||void 0===u?void 0:u.filter)||s.variableExists(e.textFilter)||s.variableExists(e.itServiceFilter)}annotationRequest(t){var r=this;return nr((function*(){const n=t.targets.filter((e=>e.fromAnnotations));if(!n.length)return Promise.resolve({data:[]});const o=yield r.annotationQueryLegacy(ar(ir({},t),{targets:n}));return{data:[(0,e.toDataFrame)(o)]}}))()}annotationQueryLegacy(e){const t=e.range||e.rangeRaw,n=Math.ceil(a.parse(t.from)/1e3),o=Math.ceil(a.parse(t.to)/1e3),i=e.targets[0],l={value:i.options.showOkEvents?["0","1"]:"1",valueFromEvent:!0,timeFrom:n,timeTo:o};if(i.options.minSeverity){const e=[0,1,2,3,4,5].filter((e=>e>=Number(i.options.minSeverity)));l.severities=e}const s=this.replaceTemplateVars(i.group.filter,{}),c=this.replaceTemplateVars(i.host.filter,{}),d=this.replaceTemplateVars(i.application.filter,{});return this.zabbix.getProblemsHistory(s,c,d,void 0,l).then((e=>{const t=this.replaceTemplateVars(i.trigger.filter,{});return R(t)?e=r().filter(e,(e=>N(t).test(e.description))):t&&(e=r().filter(e,(e=>e.description===t))),i.hideAcknowledged&&(e=r().filter(e,(e=>{var t;return!(null===(t=e.acknowledges)||void 0===t?void 0:t.length)}))),r().map(e,(e=>{const t=function(e){if(e.length){let t="<br><br>Acknowledges:<br><table><tr><td><b>Time</b></td><td><b>User</b></td><td><b>Comments</b></td></tr>";return r().each(r().map(e,(e=>"<tr><td><i>"+u().unix(e.clock).format("DD MMM YYYY HH:mm:ss")+"</i></td><td>"+e.alias+" ("+e.name+" "+e.surname+")</td><td>"+e.message+"</td></tr>")),(e=>{t=t.concat(e)})),t=t.concat("</table>"),t}return""}(e.acknowledges);let n=[];return i.showHostname&&(n=r().map(e.hosts,"name")),{title:"1"===e.value?"Problem":"OK",time:1e3*e.timestamp,annotation:i,text:e.name+t,tags:n}}))}))}replaceTargetVariables(e,t){const n=(0,oe.getTemplateSrv)();r().forEach(["group","host","application","itemTag","item"],(r=>{e[r]&&e[r].filter&&(e[r].filter=this.replaceTemplateVars(e[r].filter,t.scopedVars))})),e.textFilter&&(e.textFilter=this.replaceTemplateVars(e.textFilter,t.scopedVars)),e.itemids&&(e.itemids=n.replace(e.itemids,t.scopedVars,dr)),r().forEach(e.functions,(e=>{e.params=r().map(e.params,(e=>"number"==typeof e?+n.replace(e.toString(),t.scopedVars):n.replace(e,t.scopedVars)))}))}isUseTrends(e,t){if("false"===t.options.useTrends)return!1;const[r,n]=e,o=Math.ceil(a.parse("now-"+this.trendsFrom)/1e3),i=Math.ceil(j(this.trendsRange)/1e3);return("true"===t.options.useTrends||this.trends)&&(r<o||n-r>i)}constructor(e){super(e),or(this,"name",void 0),or(this,"basicAuth",void 0),or(this,"withCredentials",void 0),or(this,"trends",void 0),or(this,"trendsFrom",void 0),or(this,"trendsRange",void 0),or(this,"cacheTTL",void 0),or(this,"disableReadOnlyUsersAck",void 0),or(this,"disableDataAlignment",void 0),or(this,"enableDirectDBConnection",void 0),or(this,"dbConnectionDatasourceId",void 0),or(this,"dbConnectionDatasourceName",void 0),or(this,"dbConnectionRetentionPolicy",void 0),or(this,"enableDebugLog",void 0),or(this,"datasourceId",void 0),or(this,"zabbix",void 0),or(this,"replaceTemplateVars",void 0),or(this,"isBackendTarget",(e=>!this.enableDirectDBConnection&&(e.queryType===s||e.queryType===f))),or(this,"isDBConnectionTarget",(e=>this.enableDirectDBConnection&&(e.queryType===s||e.queryType===f))),this.enableDebugLog="development"===o().buildInfo.env,this.annotations={QueryEditor:tr,prepareAnnotation:Q};const t=(0,oe.getTemplateSrv)();this.replaceTemplateVars=r().partial(fr,t),this.datasourceId=e.id,this.name=e.name,this.basicAuth=e.basicAuth,this.withCredentials=e.withCredentials;const n=function(e){if(e||(e={}),!function(e){return!(!e.dbConnection||r().isEmpty(e.dbConnection))||!!(e.schema&&e.schema<3)}(e))return e;const t=e.schema||1;if(e.schema=3,t<2){const t=e.dbConnection||{};e.dbConnectionEnable=t.enable||!1,e.dbConnectionDatasourceId=t.datasourceId||null,delete e.dbConnection}return t<3&&(e.timeout=""===e.timeout?null:Number(e.timeout)),e}(e.jsonData);this.trends=n.trends,this.trendsFrom=n.trendsFrom||"7d",this.trendsRange=n.trendsRange||"4d";const i=n.cacheTTL||"1h";this.cacheTTL=j(i),this.disableReadOnlyUsersAck=n.disableReadOnlyUsersAck,this.disableDataAlignment=n.disableDataAlignment,this.enableDirectDBConnection=n.dbConnectionEnable||!1,this.dbConnectionDatasourceId=n.dbConnectionDatasourceId,this.dbConnectionDatasourceName=n.dbConnectionDatasourceName,this.dbConnectionRetentionPolicy=n.dbConnectionRetentionPolicy;const a={basicAuth:this.basicAuth,withCredentials:this.withCredentials,cacheTTL:this.cacheTTL,enableDirectDBConnection:this.enableDirectDBConnection,dbConnectionDatasourceId:this.dbConnectionDatasourceId,dbConnectionDatasourceName:this.dbConnectionDatasourceName,dbConnectionRetentionPolicy:this.dbConnectionRetentionPolicy,datasourceId:this.datasourceId};this.zabbix=new xt(a)}}function ur(e,t){const n=r().map(ne()[t],"name"),o=r().filter(e,(e=>r().includes(n,e.def.name)));return r().map(o,(e=>re(e.def,e.params).bindFunction(le.metricFunctions)))}function sr(e){return{text:e.name,expandable:!1}}function cr(e){return"string"==typeof e?D(e):"("+r().map(e,D).join("|")+")"}function dr(e){return"string"==typeof e?e:e.join(",")}function fr(e,t,r){let n=e.replace(t,r,cr);return t&&t!==n&&!R(n)&&(n="/^"+n+"$/"),n}function pr(e,t){for(let r=0;r<e.targets.length;r++){const n=e.targets[r];if(n.refId===t)return n}return null}const gr=(e,t)=>{var r,n,o,i;const[a,l]=t,u={minSeverity:null===(r=e.options)||void 0===r?void 0:r.minSeverity,acknowledged:null===(n=e.options)||void 0===n?void 0:n.acknowledged,count:null===(o=e.options)||void 0===o?void 0:o.count};return(null===(i=e.options)||void 0===i?void 0:i.useTimeRange)&&(u.timeFrom=a,u.timeTo=l),u};function vr(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function hr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){vr(i,n,o,a,l,"next",e)}function l(e){vr(i,n,o,a,l,"throw",e)}a(void 0)}))}}function mr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const yr=({query:e,datasource:t,onChange:n})=>{var o,i,a,l;const u=(s=hr((function*(){const e=yield t.zabbix.getAllGroups(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r})),function(){return s.apply(this,arguments)});var s;const[{loading:c,value:d},f]=Ft(hr((function*(){return yield u()})),[]),p=function(){var e=hr((function*(e){const n=t.replaceTemplateVars(e),o=yield t.zabbix.getAllHosts(n);let i=null==o?void 0:o.map((e=>({value:e.name,label:e.name})));return i=r().uniqBy(i,(e=>e.value)),i.unshift({value:"/.*/"}),i.unshift(...zt()),i}));return function(t){return e.apply(this,arguments)}}(),[{loading:g,value:v},h]=Ft(hr((function*(){return yield p(e.group.filter)})),[e.group.filter]),m=function(){var e=hr((function*(e,n){const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllApps(o,i);let l=null==a?void 0:a.map((e=>({value:e.name,label:e.name})));return l=r().uniqBy(l,(e=>e.value)),l.unshift(...zt()),l}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:y,value:b},E]=Ft(hr((function*(){return yield m(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),O=function(){var e=hr((function*(e,n){if(!(yield t.zabbix.isZabbix54OrHigher()))return[];const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllItems(o,i,null,null,{}),l=r().flatten(a.map((e=>e.tags||[]))),u=r().uniqBy(l,(e=>e.tag+e.value||"")).map((e=>V(e)));let s=null==u?void 0:u.map((e=>({value:e,label:e})));return s=r().uniqBy(s,(e=>e.value)),s.unshift(...zt()),s}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:S,value:_},w]=Ft(hr((function*(){return yield O(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),T=function(){var n=hr((function*(n,o,i,a){const l=t.replaceTemplateVars(n),u=t.replaceTemplateVars(o),s=t.replaceTemplateVars(i),c=t.replaceTemplateVars(a),d={itemtype:"num",showDisabledItems:e.options.showDisabledItems},f=yield t.zabbix.getAllItems(l,u,s,c,d);let p=null==f?void 0:f.map((e=>({value:e.name,label:e.name})));return p=r().uniqBy(p,(e=>e.value)),p.unshift(...zt()),p}));return function(e,t,r,o){return n.apply(this,arguments)}}(),[{loading:P,value:C},I]=Ft(hr((function*(){return yield T(e.group.filter,e.host.filter,e.application.filter,e.itemTag.filter)})),[e.group.filter,e.host.filter,e.application.filter,e.itemTag.filter]),A=t.replaceTemplateVars(null===(o=e.group)||void 0===o?void 0:o.filter),R=t.replaceTemplateVars(null===(i=e.host)||void 0===i?void 0:i.filter),x=t.replaceTemplateVars(null===(a=e.application)||void 0===a?void 0:a.filter),N=t.replaceTemplateVars(null===(l=e.itemTag)||void 0===l?void 0:l.filter);(0,jt.useEffect)((()=>{f()}),[]),(0,jt.useEffect)((()=>{h()}),[A]),(0,jt.useEffect)((()=>{E()}),[A,R]),(0,jt.useEffect)((()=>{w()}),[A,R]),(0,jt.useEffect)((()=>{I()}),[A,R,x,N]);const D=t=>r=>{var o,i;null!==r&&n((o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){mr(e,t,r[t])}))}return e}({},e),i=null!=(i={[t]:{filter:r}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o))},L=t.zabbix.supportsApplications();return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.group.filter,options:d,isLoading:c,onChange:D("group")})),Mt().createElement(qt.InlineField,{label:"Host",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.host.filter,options:v,isLoading:g,onChange:D("host")}))),Mt().createElement(Bt,null,L&&Mt().createElement(qt.InlineField,{label:"Application",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.application.filter,options:b,isLoading:y,onChange:D("application")})),!L&&Mt().createElement(qt.InlineField,{label:"Item tag",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.itemTag.filter,options:_,isLoading:S,onChange:D("itemTag")})),Mt().createElement(qt.InlineField,{label:"Item",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.item.filter,options:C,isLoading:P,onChange:D("item")}))))},br=e=>Mt().createElement(qt.Icon,{className:"pointer",name:"question-circle",onClick:()=>{window.open(`https://grafana.com/docs/plugins/alexanderzobnin-zabbix-app/latest/reference/functions/#${e.name}`,"_blank")}}),Er=e=>{const{func:t,onMoveLeft:r,onMoveRight:n,onRemove:o}=e;return Mt().createElement("div",{style:{display:"flex",width:"60px",justifyContent:"space-between"}},Mt().createElement(qt.Icon,{className:"pointer",name:"arrow-left",onClick:()=>r(t)}),Mt().createElement(br,{name:t.def.name,description:t.def.description}),Mt().createElement(qt.Icon,{className:"pointer",name:"times",onClick:()=>o(t)}),Mt().createElement(qt.Icon,{className:"pointer",name:"arrow-right",onClick:()=>n(t)}))};function Or(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const Sr=e=>({icon:Vt.css`
      margin-right: ${e.spacing(.5)};
    `,label:(0,Vt.css)({fontWeight:e.typography.fontWeightMedium,fontSize:e.typography.bodySmall.fontSize,cursor:"pointer",display:"inline-block"})}),_r=e=>{var{onMoveLeft:t,onMoveRight:r,func:n}=e,o=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["onMoveLeft","onMoveRight","func"]);const i=(0,qt.useStyles2)(Sr);return Mt().createElement(qt.Tooltip,{content:({updatePopperPosition:e})=>{return Mt().createElement(Er,(i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Or(e,t,r[t])}))}return e}({},o),a=null!=(a={func:n,onMoveLeft:()=>{t(n),e()},onMoveRight:()=>{r(n),e()}})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i));var i,a},placement:"top",interactive:!0},Mt().createElement("span",{className:i.label},n.def.name))};function wr({editableParam:e,onChange:t,onExpandedChange:r,autofocus:n}){var o;const i=(0,qt.useStyles2)(Tr);return(null===(o=e.options)||void 0===o?void 0:o.length)>0?Mt().createElement(qt.Segment,{autofocus:n,value:e.value,inputPlaceholder:e.name,className:i.segment,options:e.options,placeholder:" +"+e.name,onChange:e=>{t(e.value||"")},onExpandedChange:r,inputMinWidth:150,allowCustomValue:!0,allowEmptyValue:!0}):Mt().createElement(qt.SegmentInput,{autofocus:n,className:i.input,value:e.value||"",placeholder:" +"+e.name,inputPlaceholder:e.name,onChange:e=>{t(e.toString())},onExpandedChange:r,style:{height:"25px",paddingTop:"2px",marginTop:"2px",paddingLeft:"4px",minWidth:"100px"}})}const Tr=e=>({segment:(0,Vt.css)({margin:0,padding:0}),input:Vt.css`
    margin: 0;
    padding: 0;
    input {
      height: 25px;
    },
  `});function Pr(e,t,r){var n,o;return{name:e.name,value:(null==r?void 0:r.toString())||"",optional:!!e.optional||t,multiple:!!e.multiple,options:null!==(o=null===(n=e.options)||void 0===n?void 0:n.map((e=>({value:e.toString(),label:e.toString()}))))&&void 0!==o?o:[]}}function Cr({func:e,onMoveLeft:t,onMoveRight:r,onRemove:n,onParamChange:o}){const i=(0,qt.useStyles2)(Ir),[a,l]=(0,jt.useState)(!1),[u,s]=(0,jt.useState)(!1);let c=function(e){var t;const r=e.def.params.map(((t,r)=>Pr(t,!1,e.params[r])));for(;r.length<e.params.length;){const t=e.def.params[e.def.params.length-1],n=e.params[r.length];r.push(Pr(t,!0,n))}if(r.length&&r[r.length-1].value&&(null===(t=r[r.length-1])||void 0===t?void 0:t.multiple)){const t=e.def.params[e.def.params.length-1];r.push(Pr(t,!0,""))}return r}(e);return c=c.filter(((t,r)=>r<e.def.params.length&&!t.optional||e.added||t.value||u||a)),Mt().createElement("div",{className:(0,Vt.cx)(i.container),onMouseOver:()=>l(!0),onMouseLeave:()=>l(!1)},Mt().createElement(qt.HorizontalGroup,{spacing:"none"},Mt().createElement(_r,{func:e,onMoveLeft:t,onMoveRight:r,onRemove:n}),Mt().createElement(qt.InlineLabel,{className:i.label},"("),c.map(((t,r)=>Mt().createElement(Mt().Fragment,{key:r},Mt().createElement(wr,{autofocus:0===r&&e.added,editableParam:t,onChange:n=>{(""!==n||t.optional)&&o(e,r,n),s(!1),l(!1)},onExpandedChange:s}),r!==c.length-1?",":""))),Mt().createElement(qt.InlineLabel,{className:i.label},")")))}const Ir=e=>({container:(0,Vt.css)({backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(),marginRight:e.spacing(.5),padding:`0 ${e.spacing(1)}`,height:`${e.v1.spacing.formInputHeight}px`}),error:Vt.css`
    border: 1px solid ${e.colors.error.main};
  `,label:(0,Vt.css)({padding:0,margin:0}),button:(0,Vt.css)({padding:e.spacing(.5)})});function Ar({onFuncAdd:e}){const[t,r]=(0,jt.useState)(!1),n=(0,qt.useStyles2)(Rr),o=(0,qt.useTheme2)(),i=t=>{e(t),r(!1)},a=(0,jt.useMemo)((()=>function(e){const t=ne(),r=[];for(const n in t){const o=t[n].map((t=>Mt().createElement(qt.Menu.Item,{label:t.name,key:t.name,onClick:()=>e(t)})));r.push(Mt().createElement(qt.Menu.Item,{label:n,key:n,childItems:o}))}return r}(i)),[e]);return Mt().createElement("div",null,!t&&Mt().createElement(qt.Button,{icon:"plus",variant:"secondary",className:(0,Vt.cx)(n.button),"aria-label":"Add new function",onClick:()=>r(!t)}),t&&Mt().createElement(qt.ClickOutsideWrapper,{onClick:()=>{r(!1)},useCapture:!0},Mt().createElement(qt.Input,{onChange:e=>{console.log(e.currentTarget.value)},suffix:Mt().createElement(qt.Icon,{name:"search"})}),Mt().createElement(qt.Menu,{style:{position:"absolute",zIndex:o.zIndex.dropdown}},a)))}function Rr(e){return{button:Vt.css`
      margin-right: ${e.spacing(.5)};
    `}}function xr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Nr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){xr(e,t,r[t])}))}return e}function Dr(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Lr=({query:e,onChange:t})=>{var r;const n=(r,n,o)=>{r.params[n]=o;const i=e.functions.findIndex((e=>e===r)),a=e.functions;a[i]=r,t(Dr(Nr({},e),{functions:a}))},o=r=>{const n=e.functions.indexOf(r),o=H(e.functions,n,n-1);t(Dr(Nr({},e),{functions:o}))},i=r=>{const n=e.functions.indexOf(r),o=H(e.functions,n,n+1);t(Dr(Nr({},e),{functions:o}))},a=r=>{var n;const o=null===(n=e.functions)||void 0===n?void 0:n.filter((e=>e!==r));t(Dr(Nr({},e),{functions:o}))};return Mt().createElement(Bt,null,Mt().createElement(qt.InlineFormLabel,{width:6},"Functions"),null===(r=e.functions)||void 0===r?void 0:r.map(((e,t)=>Mt().createElement(Cr,{func:e,key:t,onParamChange:n,onMoveLeft:o,onMoveRight:i,onRemove:a}))),Mt().createElement(Ar,{onFuncAdd:r=>{const n=re(r);n.added=!0;let o=e.functions.concat(n);o=function(e){const t=e.findIndex((e=>"Alias"===e.def.category));if(console.log(t),t>=0){const r=e[t];e.splice(t,1),e.push(r)}return e}(o),t(Dr(Nr({},e),{functions:o}))}}))};function jr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Mr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){jr(e,t,r[t])}))}return e}function kr(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Fr=[{label:"all triggers",value:2},{label:"unacknowledged",value:0},{label:"acknowledged",value:1}],qr=[{label:"Default",value:"default"},{label:"Last change",value:"lastchange"},{label:"Severity",value:"severity"}],Vr=[{label:"Default",value:"default"},{label:"True",value:"true"},{label:"False",value:"false"}],Br=({queryType:e,queryOptions:t,onChange:r})=>{const[n,o]=(0,jt.useState)(!1),i=(0,qt.useStyles2)(Ur),a=e=>{var n;const o=Number(null==e||null===(n=e.currentTarget)||void 0===n?void 0:n.value);null!==o&&r(kr(Mr({},t),{limit:o}))},l=e=>n=>{null!==n.value&&r(kr(Mr({},t),{[e]:n.value}))},u=()=>Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineField,{label:"Trends",labelWidth:24},Mt().createElement(qt.Select,{isSearchable:!1,width:16,value:t.useTrends,options:Vr,onChange:l("useTrends")})),Mt().createElement(qt.InlineField,{label:"Show disabled items",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.showDisabledItems,onChange:()=>r(kr(Mr({},t),{showDisabledItems:!t.showDisabledItems}))})),Mt().createElement(qt.InlineField,{label:"Use Zabbix value mapping",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.useZabbixValueMapping,onChange:()=>r(kr(Mr({},t),{useZabbixValueMapping:!t.useZabbixValueMapping}))})),Mt().createElement(qt.InlineField,{label:"Disable data alignment",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.disableDataAlignment,onChange:()=>r(kr(Mr({},t),{disableDataAlignment:!t.disableDataAlignment}))})));return Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineFieldRow,null,Mt().createElement("div",{className:i.container,onClick:()=>o(!n)},Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.HorizontalGroup,null,!n&&Mt().createElement(qt.Icon,{name:"angle-right"}),n&&Mt().createElement(qt.Icon,{name:"angle-down"}),Mt().createElement("span",{className:i.label},"Options"),Mt().createElement("div",{className:i.options},(()=>{const e=[];for(const r in t)if(t.hasOwnProperty(r)){const n=t[r];!0===n&&""!==n&&null!=n&&e.push(Mt().createElement("span",{className:i.optionContainer,key:r},`${r} = ${n}`))}return e})()))))),Mt().createElement(qt.InlineFieldRow,null,n&&Mt().createElement("div",{className:i.editorContainer},e===s&&u(),e===f&&u(),e===c&&u(),e===d&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineField,{label:"Show disabled items",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.showDisabledItems,onChange:()=>r(kr(Mr({},t),{showDisabledItems:!t.showDisabledItems}))}))),e===g&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineField,{label:"Acknowledged",labelWidth:24},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:t.acknowledged,options:Fr,onChange:l("acknowledged")})),Mt().createElement(qt.InlineField,{label:"Sort by",labelWidth:24},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:t.sortProblems,options:qr,onChange:l("sortProblems")})),Mt().createElement(qt.InlineField,{label:"Use time range",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.useTimeRange,onChange:()=>r(kr(Mr({},t),{useTimeRange:!t.useTimeRange}))})),Mt().createElement(qt.InlineField,{label:"Hosts in maintenance",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.hostsInMaintenance,onChange:()=>r(kr(Mr({},t),{hostsInMaintenance:!t.hostsInMaintenance}))})),Mt().createElement(qt.InlineField,{label:"Host proxy",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.hostProxy,onChange:()=>r(kr(Mr({},t),{hostProxy:!t.hostProxy}))})),Mt().createElement(qt.InlineField,{label:"Limit",labelWidth:24},Mt().createElement(qt.Input,{width:12,type:"number",defaultValue:t.limit,onBlur:a}))),e===p&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineField,{label:"Acknowledged",labelWidth:24},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:t.acknowledged,options:Fr,onChange:l("acknowledged")})),Mt().createElement(qt.InlineField,{label:"Use time range",labelWidth:24},Mt().createElement(qt.InlineSwitch,{value:t.useTimeRange,onChange:()=>r(kr(Mr({},t),{useTimeRange:!t.useTimeRange}))}))))))},Ur=e=>({container:(0,Vt.css)({backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(),marginRight:e.spacing(.5),marginBottom:e.spacing(.5),padding:`0 ${e.spacing(1)}`,height:`${e.v1.spacing.formInputHeight}px`,width:"100%"}),label:(0,Vt.css)({color:e.colors.info.text,fontWeight:e.typography.fontWeightMedium,cursor:"pointer"}),options:(0,Vt.css)({color:e.colors.text.disabled,fontSize:e.typography.bodySmall.fontSize}),optionContainer:Vt.css`
    margin-right: ${e.spacing(2)};
  `,editorContainer:Vt.css`
    display: flex;
    flex-direction: column;
    margin-left: ${e.spacing(4)};
  `});function Wr(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function Gr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Wr(i,n,o,a,l,"next",e)}function l(e){Wr(i,n,o,a,l,"throw",e)}a(void 0)}))}}function Hr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Kr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Hr(e,t,r[t])}))}return e}function $r(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const zr=({query:e,datasource:t,onChange:n})=>{var o,i,a,l;const u=(s=Gr((function*(){const e=yield t.zabbix.getAllGroups(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r})),function(){return s.apply(this,arguments)});var s;const[{loading:c,value:d},f]=Ft(Gr((function*(){return yield u()})),[]),p=function(){var e=Gr((function*(e){const n=t.replaceTemplateVars(e),o=yield t.zabbix.getAllHosts(n);let i=null==o?void 0:o.map((e=>({value:e.name,label:e.name})));return i=r().uniqBy(i,(e=>e.value)),i.unshift({value:"/.*/"}),i.unshift(...zt()),i}));return function(t){return e.apply(this,arguments)}}(),[{loading:g,value:v},h]=Ft(Gr((function*(){return yield p(e.group.filter)})),[e.group.filter]),m=function(){var e=Gr((function*(e,n){const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllApps(o,i);let l=null==a?void 0:a.map((e=>({value:e.name,label:e.name})));return l=r().uniqBy(l,(e=>e.value)),l.unshift(...zt()),l}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:y,value:b},E]=Ft(Gr((function*(){return yield m(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),O=function(){var n=Gr((function*(n,o,i,a){const l=t.replaceTemplateVars(n),u=t.replaceTemplateVars(o),s=t.replaceTemplateVars(i),c=t.replaceTemplateVars(a),d={itemtype:"text",showDisabledItems:e.options.showDisabledItems},f=yield t.zabbix.getAllItems(l,u,s,c,d);let p=null==f?void 0:f.map((e=>({value:e.name,label:e.name})));return p=r().uniqBy(p,(e=>e.value)),p.unshift(...zt()),p}));return function(e,t,r,o){return n.apply(this,arguments)}}(),[{loading:S,value:_},w]=Ft(Gr((function*(){return yield O(e.group.filter,e.host.filter,e.application.filter,e.itemTag.filter)})),[e.group.filter,e.host.filter,e.application.filter,e.itemTag.filter]),T=t.replaceTemplateVars(null===(o=e.group)||void 0===o?void 0:o.filter),P=t.replaceTemplateVars(null===(i=e.host)||void 0===i?void 0:i.filter),C=t.replaceTemplateVars(null===(a=e.application)||void 0===a?void 0:a.filter),I=t.replaceTemplateVars(null===(l=e.itemTag)||void 0===l?void 0:l.filter);(0,jt.useEffect)((()=>{f()}),[]),(0,jt.useEffect)((()=>{h()}),[T]),(0,jt.useEffect)((()=>{E()}),[T,P]),(0,jt.useEffect)((()=>{w()}),[T,P,C,I]);const A=t=>r=>{null!==r&&n($r(Kr({},e),{[t]:{filter:r}}))};return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.group.filter,options:d,isLoading:c,onChange:A("group")})),Mt().createElement(qt.InlineField,{label:"Host",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.host.filter,options:v,isLoading:g,onChange:A("host")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Application",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.application.filter,options:b,isLoading:y,onChange:A("application")})),Mt().createElement(qt.InlineField,{label:"Item",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.item.filter,options:_,isLoading:S,onChange:A("item")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Text filter",labelWidth:12},Mt().createElement(qt.Input,{width:24,defaultValue:e.textFilter,onBlur:t=>{var r;const o=null==t||null===(r=t.currentTarget)||void 0===r?void 0:r.value;null!==o&&n($r(Kr({},e),{textFilter:o}))}})),Mt().createElement(qt.InlineField,{label:"Use capture groups",labelWidth:18},Mt().createElement(qt.InlineSwitch,{value:e.useCaptureGroups,onChange:()=>n($r(Kr({},e),{useCaptureGroups:!e.useCaptureGroups}))}))))};function Yr(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function Qr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Yr(i,n,o,a,l,"next",e)}function l(e){Yr(i,n,o,a,l,"throw",e)}a(void 0)}))}}function Xr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Jr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Xr(e,t,r[t])}))}return e}function Zr(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const en=[{label:"Problems",value:"problems"},{label:"Recent problems",value:"recent"},{label:"History",value:"history"}],tn=[{value:0,label:"Not classified"},{value:1,label:"Information"},{value:2,label:"Warning"},{value:3,label:"Average"},{value:4,label:"High"},{value:5,label:"Disaster"}],rn=[{label:"AND/OR",value:et.AndOr},{label:"OR",value:et.Or}],nn=({query:e,datasource:t,onChange:n})=>{var o,i,a,l,u,s,c,d,f;const p=(g=Qr((function*(){const e=yield t.zabbix.getAllGroups(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r})),function(){return g.apply(this,arguments)});var g;const[{loading:v,value:h},m]=Ft(Qr((function*(){return yield p()})),[]),y=function(){var e=Qr((function*(e){const n=t.replaceTemplateVars(e),o=yield t.zabbix.getAllHosts(n);let i=null==o?void 0:o.map((e=>({value:e.name,label:e.name})));return i=r().uniqBy(i,(e=>e.value)),i.unshift({value:"/.*/"}),i.unshift(...zt()),i}));return function(t){return e.apply(this,arguments)}}(),[{loading:b,value:E},O]=Ft(Qr((function*(){return yield y(e.group.filter)})),[e.group.filter]),S=function(){var e=Qr((function*(e,n){const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllApps(o,i);let l=null==a?void 0:a.map((e=>({value:e.name,label:e.name})));return l=r().uniqBy(l,(e=>e.value)),l.unshift(...zt()),l}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:_,value:w},T]=Ft(Qr((function*(){return yield S(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),P=function(){var e=Qr((function*(){const e=yield t.zabbix.getProxies(),r=null==e?void 0:e.map((e=>({value:e.host,label:e.host})));return r.unshift(...zt()),r}));return function(){return e.apply(this,arguments)}}(),[{loading:C,value:I},A]=Ft(Qr((function*(){return yield P()})),[]),R=t.replaceTemplateVars(null===(o=e.group)||void 0===o?void 0:o.filter),x=t.replaceTemplateVars(null===(i=e.host)||void 0===i?void 0:i.filter);(0,jt.useEffect)((()=>{m()}),[]),(0,jt.useEffect)((()=>{O()}),[R]),(0,jt.useEffect)((()=>{T()}),[R,x]),(0,jt.useEffect)((()=>{A()}),[]);const N=t=>r=>{var o;const i=null==r||null===(o=r.currentTarget)||void 0===o?void 0:o.value;null!==i&&n(Zr(Jr({},e),{[t]:{filter:i}}))},D=t=>r=>{null!==r&&n(Zr(Jr({},e),{[t]:{filter:r}}))},L=t=>r=>{null!==r.value&&n(Zr(Jr({},e),{[t]:r.value}))},j=t.zabbix.supportsApplications();return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(a=e.group)||void 0===a?void 0:a.filter,options:h,isLoading:v,onChange:D("group")})),Mt().createElement(qt.InlineField,{label:"Host",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(l=e.host)||void 0===l?void 0:l.filter,options:E,isLoading:b,onChange:D("host")})),Mt().createElement(qt.InlineField,{label:"Proxy",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(u=e.proxy)||void 0===u?void 0:u.filter,options:I,isLoading:C,onChange:D("proxy")}))),Mt().createElement(Bt,null,j&&Mt().createElement(qt.InlineField,{label:"Application",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(s=e.application)||void 0===s?void 0:s.filter,options:w,isLoading:_,onChange:D("application")})),Mt().createElement(qt.InlineField,{label:"Problem",labelWidth:12},Mt().createElement(qt.Input,{width:24,defaultValue:null===(c=e.trigger)||void 0===c?void 0:c.filter,placeholder:"Problem name",onBlur:N("trigger")})),Mt().createElement(qt.InlineField,{label:"Tags",labelWidth:12},Mt().createElement(qt.Input,{width:36,defaultValue:null===(d=e.tags)||void 0===d?void 0:d.filter,placeholder:"tag1:value1, tag2:value2",onBlur:N("tags")})),Mt().createElement(qt.InlineField,null,Mt().createElement(qt.Select,{isSearchable:!1,width:15,value:e.evaltype,options:rn,onChange:L("evaltype")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Show",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:e.showProblems,options:en,onChange:L("showProblems")})),Mt().createElement(qt.InlineField,{label:"Severity",labelWidth:12},Mt().createElement(qt.MultiSelect,{isSearchable:!1,isClearable:!0,placeholder:"Show all problems",value:null===(f=e.options)||void 0===f?void 0:f.severities,options:tn,onChange:t=>{null!==t&&n(Zr(Jr({},e),{options:Zr(Jr({},e.options),{severities:t.map((e=>e.value))})}))}}))))};function on(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const an=({query:e,onChange:t})=>Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Item Ids",labelWidth:12},Mt().createElement(qt.Input,{width:24,defaultValue:e.itemids,onBlur:r=>{var n;const o=null==r||null===(n=r.currentTarget)||void 0===n?void 0:n.value;var i,a;null!==o&&t((i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){on(e,t,r[t])}))}return e}({},e),a=null!=(a={itemids:o})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i))}})));function ln(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function un(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){ln(i,n,o,a,l,"next",e)}function l(e){ln(i,n,o,a,l,"throw",e)}a(void 0)}))}}function sn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function cn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){sn(e,t,r[t])}))}return e}function dn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const fn=[{label:"Status",value:"status"},{label:"SLI",value:"sli"},{label:"Uptime",value:"uptime"},{label:"Downtime",value:"downtime"},{label:"Error budget",value:"error_budget"}],pn=[{label:"No interval",value:"none"},{label:"Auto",value:"auto"},{label:"1 hour",value:"1h"},{label:"12 hours",value:"12h"},{label:"24 hours",value:"1d"},{label:"1 week",value:"1w"},{label:"1 month",value:"1M"}],gn=({query:e,datasource:t,onChange:r})=>{const n=(o=un((function*(){const e=yield t.zabbix.getITService(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r})),function(){return o.apply(this,arguments)});var o;const[{loading:i,value:a},l]=Ft(un((function*(){return yield n()})),[]),u=function(){var e=un((function*(){const e=yield t.zabbix.getSLAList(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r}));return function(){return e.apply(this,arguments)}}(),[{loading:s,value:c},d]=Ft(un((function*(){return yield u()})),[]);(0,jt.useEffect)((()=>{l(),d()}),[]);const f=t=>n=>{n.value&&r(dn(cn({},e),{[t]:n.value}))},p=t=>n=>{void 0!==n&&r(dn(cn({},e),{[t]:n}))};return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Service",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.itServiceFilter,options:a,isLoading:i,onChange:p("itServiceFilter")})),Mt().createElement(qt.InlineField,{label:"SLA",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.slaFilter,options:c,isLoading:s,onChange:p("slaFilter")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Property",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:e.slaProperty,options:fn,onChange:f("slaProperty")})),Mt().createElement(qt.InlineField,{label:"Interval",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:e.slaInterval,options:pn,onChange:f("slaInterval")}))))};function vn(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function hn(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){vn(i,n,o,a,l,"next",e)}function l(e){vn(i,n,o,a,l,"throw",e)}a(void 0)}))}}function mn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function yn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){mn(e,t,r[t])}))}return e}function bn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const En=[{value:"",label:"All triggers"},{value:"problems",label:"Problems"},{value:"items",label:"Items"}],On=[{value:0,label:"Not classified"},{value:1,label:"Information"},{value:2,label:"Warning"},{value:3,label:"Average"},{value:4,label:"High"},{value:5,label:"Disaster"}],Sn=({query:e,datasource:t,onChange:n})=>{var o,i,a,l,u,s,c,d,f,p,g,v;const h=(m=hn((function*(){const e=yield t.zabbix.getAllGroups(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r})),function(){return m.apply(this,arguments)});var m;const[{loading:y,value:b},E]=Ft(hn((function*(){return yield h()})),[]),O=function(){var e=hn((function*(e){const n=t.replaceTemplateVars(e),o=yield t.zabbix.getAllHosts(n);let i=null==o?void 0:o.map((e=>({value:e.name,label:e.name})));return i=r().uniqBy(i,(e=>e.value)),i.unshift({value:"/.*/"}),i.unshift(...zt()),i}));return function(t){return e.apply(this,arguments)}}(),[{loading:S,value:_},w]=Ft(hn((function*(){return yield O(e.group.filter)})),[e.group.filter]),T=function(){var e=hn((function*(e,n){const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllApps(o,i);let l=null==a?void 0:a.map((e=>({value:e.name,label:e.name})));return l=r().uniqBy(l,(e=>e.value)),l.unshift(...zt()),l}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:P,value:C},I]=Ft(hn((function*(){return yield T(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),A=function(){var e=hn((function*(e,n){if(!(yield t.zabbix.isZabbix54OrHigher()))return[];const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllItems(o,i,null,null,{}),l=r().flatten(a.map((e=>e.tags||[]))),u=r().uniqBy(l,(e=>e.tag+e.value||"")).map((e=>V(e)));let s=null==u?void 0:u.map((e=>({value:e,label:e})));return s=r().uniqBy(s,(e=>e.value)),s.unshift(...zt()),s}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:R,value:x},N]=Ft(hn((function*(){return yield A(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),D=function(){var e=hn((function*(){const e=yield t.zabbix.getProxies(),r=null==e?void 0:e.map((e=>({value:e.host,label:e.host})));return r.unshift(...zt()),r}));return function(){return e.apply(this,arguments)}}(),[{loading:L,value:j},M]=Ft(hn((function*(){return yield D()})),[]),k=function(){var n=hn((function*(n,o,i,a){const l=t.replaceTemplateVars(n),u=t.replaceTemplateVars(o),s=t.replaceTemplateVars(i),c=t.replaceTemplateVars(a),d={itemtype:"num",showDisabledItems:e.options.showDisabledItems},f=yield t.zabbix.getAllItems(l,u,s,c,d);let p=null==f?void 0:f.map((e=>({value:e.name,label:e.name})));return p=r().uniqBy(p,(e=>e.value)),p.unshift(...zt()),p}));return function(e,t,r,o){return n.apply(this,arguments)}}(),[{loading:F,value:q},B]=Ft(hn((function*(){return yield k(e.group.filter,e.host.filter,e.application.filter,e.itemTag.filter)})),[e.group.filter,e.host.filter,e.application.filter,e.itemTag.filter]),U=t.replaceTemplateVars(null===(o=e.group)||void 0===o?void 0:o.filter),W=t.replaceTemplateVars(null===(i=e.host)||void 0===i?void 0:i.filter),G=t.replaceTemplateVars(null===(a=e.application)||void 0===a?void 0:a.filter),H=t.replaceTemplateVars(null===(l=e.itemTag)||void 0===l?void 0:l.filter);(0,jt.useEffect)((()=>{E()}),[]),(0,jt.useEffect)((()=>{w()}),[U]),(0,jt.useEffect)((()=>{I()}),[U,W]),(0,jt.useEffect)((()=>{N()}),[U,W]),(0,jt.useEffect)((()=>{M()}),[]),(0,jt.useEffect)((()=>{B()}),[U,W,G,H]);const K=t=>r=>{var o;const i=null==r||null===(o=r.currentTarget)||void 0===o?void 0:o.value;null!==i&&n(bn(yn({},e),{[t]:{filter:i}}))},$=t=>r=>{null!==r&&n(bn(yn({},e),{[t]:{filter:r}}))},z=t.zabbix.supportsApplications();return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Count by",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:e.countTriggersBy,options:En,onChange:t=>{null!==t.value&&n(bn(yn({},e),{countTriggersBy:t.value}))}}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(u=e.group)||void 0===u?void 0:u.filter,options:b,isLoading:y,onChange:$("group")})),Mt().createElement(qt.InlineField,{label:"Host",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(s=e.host)||void 0===s?void 0:s.filter,options:_,isLoading:S,onChange:$("host")})),"problems"===e.countTriggersBy&&Mt().createElement(qt.InlineField,{label:"Proxy",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(c=e.proxy)||void 0===c?void 0:c.filter,options:j,isLoading:L,onChange:$("proxy")}))),Mt().createElement(Bt,null,z&&Mt().createElement(qt.InlineField,{label:"Application",labelWidth:12},Mt().createElement(Kt,{width:24,value:null===(d=e.application)||void 0===d?void 0:d.filter,options:C,isLoading:P,onChange:$("application")})),!z&&"items"===e.countTriggersBy&&Mt().createElement(qt.InlineField,{label:"Item tag",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.itemTag.filter,options:x,isLoading:R,onChange:$("itemTag")})),"problems"===e.countTriggersBy&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineField,{label:"Problem",labelWidth:12},Mt().createElement(qt.Input,{width:24,defaultValue:null===(f=e.trigger)||void 0===f?void 0:f.filter,placeholder:"Problem name",onBlur:K("trigger")}))),"items"===e.countTriggersBy&&Mt().createElement(qt.InlineField,{label:"Item",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.item.filter,options:q,isLoading:F,onChange:$("item")})),!z&&Mt().createElement(qt.InlineField,{label:"Tags",labelWidth:12},Mt().createElement(qt.Input,{width:24,defaultValue:null===(p=e.tags)||void 0===p?void 0:p.filter,placeholder:"tag1:value1, tag2:value2",onBlur:K("tags")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Min severity",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:null===(g=e.options)||void 0===g?void 0:g.minSeverity,options:On,onChange:t=>{null!==t.value&&n(bn(yn({},e),{options:bn(yn({},e.options),{minSeverity:t.value})}))}})),Mt().createElement(qt.InlineField,{label:"Count",labelWidth:12},Mt().createElement(qt.InlineSwitch,{value:null===(v=e.options)||void 0===v?void 0:v.count,onChange:()=>{var t;return n(bn(yn({},e),{options:bn(yn({},e.options),{count:!(null===(t=e.options)||void 0===t?void 0:t.count)})}))}}))))};function _n(e,t,r,n,o,i,a){try{var l=e[i](a),u=l.value}catch(e){return void r(e)}l.done?t(u):Promise.resolve(u).then(n,o)}function wn(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){_n(i,n,o,a,l,"next",e)}function l(e){_n(i,n,o,a,l,"throw",e)}a(void 0)}))}}function Tn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const Pn=({query:e,datasource:t,onChange:n})=>{var o,i;const a=(l=wn((function*(){const e=yield t.zabbix.getAllGroups(),r=null==e?void 0:e.map((e=>({value:e.name,label:e.name})));return r.unshift(...zt()),r})),function(){return l.apply(this,arguments)});var l;const[{loading:u,value:s},c]=Ft(wn((function*(){return yield a()})),[]),d=function(){var e=wn((function*(e){const n=t.replaceTemplateVars(e),o=yield t.zabbix.getAllHosts(n);let i=null==o?void 0:o.map((e=>({value:e.name,label:e.name})));return i=r().uniqBy(i,(e=>e.value)),i.unshift({value:"/.*/"}),i.unshift(...zt()),i}));return function(t){return e.apply(this,arguments)}}(),[{loading:f,value:p},g]=Ft(wn((function*(){return yield d(e.group.filter)})),[e.group.filter]),v=function(){var e=wn((function*(e,n){const o=t.replaceTemplateVars(e),i=t.replaceTemplateVars(n),a=yield t.zabbix.getAllMacros(o,i);let l=null==a?void 0:a.map((e=>({value:e.macro,label:e.macro})));return l=r().uniqBy(l,(e=>e.value)),l.unshift({value:"/.*/"}),l.unshift(...zt()),l}));return function(t,r){return e.apply(this,arguments)}}(),[{loading:h,value:m},y]=Ft(wn((function*(){return yield v(e.group.filter,e.host.filter)})),[e.group.filter,e.host.filter]),b=t.replaceTemplateVars(null===(o=e.group)||void 0===o?void 0:o.filter),E=t.replaceTemplateVars(null===(i=e.host)||void 0===i?void 0:i.filter);(0,jt.useEffect)((()=>{c()}),[]),(0,jt.useEffect)((()=>{g()}),[b]),(0,jt.useEffect)((()=>{y()}),[b,E]);const O=t=>r=>{var o,i;null!==r&&n((o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Tn(e,t,r[t])}))}return e}({},e),i=null!=(i={[t]:{filter:r}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o))};return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.group.filter,options:s,isLoading:u,onChange:O("group")})),Mt().createElement(qt.InlineField,{label:"Host",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.host.filter,options:p,isLoading:f,onChange:O("host")}))),Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Macros",labelWidth:12},Mt().createElement(Kt,{width:24,value:e.macro.filter,options:m,isLoading:h,onChange:O("macro")}))))};function Cn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function In(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Cn(e,t,r[t])}))}return e}function An(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Rn=[{value:s,label:"Metrics",description:"Query numeric metrics"},{value:d,label:"Text",description:"Query text data"},{value:c,label:"Services",description:"Query services SLA"},{value:f,label:"Item Id",description:"Query metrics by item ids"},{value:p,label:"Triggers",description:"Count triggers"},{value:g,label:"Problems",description:"Query problems"},{value:v,label:"User macros",description:"User Macros"}];function xn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}var Nn;const Dn=qt.Input||(null===(Nn=qt.LegacyForms)||void 0===Nn?void 0:Nn.Input),Ln=RegExp(`^${/\$(\w+)|\[\[([\s\S]+?)(?::(\w+))?\]\]|\${(\w+)(?:\.([^:^\}]+))?(?::(\w+))?}/g.source}`),jn=e=>({inputRegex:Vt.css`
    color: ${e.colors.warning.main};
  `,inputVariable:Vt.css`
    color: ${e.colors.action.focus};
  `}),Mn={[qt.EventsWithValidation.onBlur]:[{rule:e=>!e||!(e.length>1&&"/"===e[0]&&"/"!==e[e.length-1]),errorMessage:"Not a valid regex"},{rule:e=>"*"!==e,errorMessage:"Wildcards not supported. Use /.*/ instead"}]},kn=e=>{var{value:t,ref:r,validationEvents:n}=e,o=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["value","ref","validationEvents"]);const i=(0,qt.useStyles2)(jn);let a=i.inputRegex;return Ln.test(t)?a=i.inputVariable:R(t)&&(a=i.inputRegex),Mt().createElement(Dn,function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){xn(e,t,r[t])}))}return e}({className:a,value:t,validationEvents:Mn},o))};function Fn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function qn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Fn(e,t,r[t])}))}return e}function Vn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}class Bn extends jt.PureComponent{getSelectedQueryType(e){return this.queryTypes.find((t=>t.value===e))}render(){var e;const{selectedQueryType:t,legacyQuery:r,group:n,host:o,application:i,itemTag:a,item:l}=this.state,{datasource:u}=this.props,s=(null==u||null===(e=u.zabbix)||void 0===e?void 0:e.isZabbix54OrHigherSync())||!1;return Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineFieldRow,null,Mt().createElement(qt.InlineField,{label:"Query Type",labelWidth:16},Mt().createElement(qt.Select,{width:30,value:t,options:this.queryTypes,onChange:this.handleQueryTypeChange}))),Mt().createElement(qt.InlineFieldRow,null,Mt().createElement(qt.InlineField,{label:"Group",labelWidth:16},Mt().createElement(kn,{width:30,value:n,onChange:e=>this.handleQueryUpdate(e,"group"),onBlur:this.handleQueryChange}))),t.value!==y.Group&&Mt().createElement(qt.InlineFieldRow,null,Mt().createElement(qt.InlineField,{label:"Host",labelWidth:16},Mt().createElement(kn,{width:30,value:o,onChange:e=>this.handleQueryUpdate(e,"host"),onBlur:this.handleQueryChange}))),(t.value===y.Application||t.value===y.ItemTag||t.value===y.Item||t.value===y.ItemValues)&&Mt().createElement(Mt().Fragment,null,s&&Mt().createElement(qt.InlineFieldRow,null,Mt().createElement(qt.InlineField,{label:"Item Tag",labelWidth:16},Mt().createElement(kn,{width:30,value:a,onChange:e=>this.handleQueryUpdate(e,"itemTag"),onBlur:this.handleQueryChange}))),!s&&Mt().createElement(qt.InlineFieldRow,null,Mt().createElement(qt.InlineField,{label:"Application",labelWidth:16},Mt().createElement(kn,{width:30,value:i,onChange:e=>this.handleQueryUpdate(e,"application"),onBlur:this.handleQueryChange}))),(t.value===y.Item||t.value===y.ItemValues)&&Mt().createElement(qt.InlineFieldRow,null,Mt().createElement(qt.InlineField,{label:"Item",labelWidth:16},Mt().createElement(kn,{width:30,value:l,onChange:e=>this.handleQueryUpdate(e,"item"),onBlur:this.handleQueryChange})))),r&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.InlineFormLabel,{width:10,tooltip:"Original query string, read-only"},"Legacy Query"),Mt().createElement(qt.Input,{value:r,readOnly:!0})))}constructor(e){if(super(e),Fn(this,"queryTypes",[{value:y.Group,label:"Group"},{value:y.Host,label:"Host"},{value:y.Application,label:"Application"},{value:y.ItemTag,label:"Item tag"},{value:y.Item,label:"Item"},{value:y.ItemValues,label:"Item values"}]),Fn(this,"defaults",{selectedQueryType:{value:y.Group,label:"Group"},queryType:y.Group,group:"/.*/",host:"",application:"",itemTag:"",item:""}),Fn(this,"handleQueryUpdate",((e,t)=>{const r=e.currentTarget.value;this.setState((e=>{const n=qn({},e);return n[t]=r,qn({},n)}))})),Fn(this,"handleQueryChange",(()=>{const{queryType:e,group:t,host:r,application:n,itemTag:o,item:i}=this.state,a={queryType:e,group:t,host:r,application:n,itemTag:o,item:i};this.props.onChange(a,`Zabbix - ${e}`)})),Fn(this,"handleQueryTypeChange",(e=>{this.setState(Vn(qn({},this.state),{selectedQueryType:e,queryType:e.value}));const{group:t,host:r,application:n,itemTag:o,item:i}=this.state,a=e.value,l={queryType:a,group:t,host:r,application:n,itemTag:o,item:i};this.props.onChange(l,`Zabbix - ${a}`)})),this.props.query&&"string"==typeof this.props.query){const e=I(this.props.query),t=this.getSelectedQueryType(e.queryType);this.state=qn({selectedQueryType:t,legacyQuery:this.props.query},e)}else if(this.props.query){const e=this.props.query,t=this.getSelectedQueryType(e.queryType);this.state=Vn(qn({},this.defaults,e),{selectedQueryType:t})}else this.state=this.defaults}}var Un;!function(e){e.UserLogin="userLogin",e.Token="token"}(Un||(Un={}));var Wn=b(65991);const Gn=()=>{const e=(0,qt.useStyles2)(Hn);return Mt().createElement("hr",{className:e.horizontalDivider})},Hn=e=>({horizontalDivider:(0,Vt.css)({borderTop:`1px solid ${e.colors.border.weak}`,margin:e.spacing(2,0),width:"100%"})});function Kn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function $n(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Kn(e,t,r[t])}))}return e}function zn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t.push.apply(t,r)}return t}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Yn=["mysql","grafana-postgresql-datasource","postgres","influxdb"],Qn=[{label:"User and password",value:Un.UserLogin},{label:"API token",value:Un.Token}],Xn=e=>({space:(0,Vt.css)({width:"100%",height:e.spacing(2)})}),Jn=(e,t,r)=>n=>{r(zn($n({},t),{jsonData:zn($n({},t.jsonData),{[e]:n.currentTarget.value})}))},Zn=(e,t,r)=>n=>{r(zn($n({},t),{jsonData:zn($n({},t.jsonData),{[e]:n.value})}))},eo=(e,t,r)=>n=>{r(zn($n({},t),{jsonData:zn($n({},t.jsonData),{[e]:n.target.checked})}))},to=(e,t,r)=>n=>{r(zn($n({},t),{secureJsonData:zn($n({},t.secureJsonData),{[e]:n.currentTarget.value})}))},ro=(e,t,r)=>()=>{r(zn($n({},t),{secureJsonFields:zn($n({},t.secureJsonFields),{[e]:!1})}))},no=(e,t,r,n)=>o=>{const i=oo().find((e=>e.id===o.value));r({label:i.name,value:i.id}),n(i.type),t(zn($n({},e),{jsonData:zn($n({},e.jsonData),{dbConnectionDatasourceId:o.value})}))},oo=()=>{let e=(0,oe.getDataSourceSrv)().getAll();return e=e.filter((e=>Yn.includes(e.type))),e},io=new e.DataSourcePlugin(lr).setConfigEditor((e=>{var t,r;const n=(0,qt.useStyles2)(Xn),{options:o,onOptionsChange:i}=e,[a,l]=(0,jt.useState)(null),[u,s]=(0,jt.useState)("");return(0,jt.useEffect)((()=>{const{jsonData:e,secureJsonFields:t}=o,{password:r}=e,n=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["password"]);if((null==t?void 0:t.password)||(o.secureJsonData||(o.secureJsonData={}),o.secureJsonData.password=r),i(zn($n({},o),{jsonData:$n({authType:Un.UserLogin,trends:!0,trendsFrom:"",trendsRange:"",cacheTTL:"",timeout:void 0,disableDataAlignment:!1},n)})),o.jsonData.dbConnectionEnable)if(o.jsonData.dbConnectionDatasourceId){const e=oo().find((e=>e.id===o.jsonData.dbConnectionDatasourceId));l({label:null==e?void 0:e.name,value:null==e?void 0:e.id}),s(null==e?void 0:e.type)}else{const e=o.jsonData.dbConnectionDatasourceName;(0,oe.getDataSourceSrv)().get(e).then((e=>{if(e){const t=oo().find((t=>t.id===e.id));l({label:null==t?void 0:t.name,value:null==t?void 0:t.id}),s(null==t?void 0:t.type),i(zn($n({},o),{jsonData:zn($n({},o.jsonData),{dbConnectionDatasourceId:e.id})}))}}))}}),[]),Mt().createElement(Mt().Fragment,null,Mt().createElement(Wn.DataSourceDescription,{dataSourceName:"Zabbix",docsLink:"https://grafana.com/docs/grafana/latest/datasources/loki/configure-loki-data-source/",hasRequiredFields:!0}),Mt().createElement(Gn,null),Mt().createElement(Wn.ConnectionSettings,{config:o,onChange:i,urlPlaceholder:"http://localhost/zabbix/api_jsonrpc.php"}),Mt().createElement(Gn,null),Mt().createElement(Wn.Auth,(0,Wn.convertLegacyAuthProps)({config:o,onChange:i})),Mt().createElement(Gn,null),Mt().createElement(Wn.ConfigSection,{title:"Zabbix Connection"},Mt().createElement(qt.Field,{label:"Auth type"},Mt().createElement(qt.Select,{width:40,options:Qn,value:o.jsonData.authType,onChange:Zn("authType",o,i)})),(null===(t=o.jsonData)||void 0===t?void 0:t.authType)===Un.UserLogin&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.Field,{label:"Username"},Mt().createElement(qt.Input,{width:40,placeholder:"Username",value:o.jsonData.username||"",onChange:Jn("username",o,i)})),Mt().createElement(qt.Field,{label:"Password"},Mt().createElement(qt.SecretInput,{width:40,placeholder:"Password",isConfigured:o.secureJsonFields&&o.secureJsonFields.password,onReset:ro("password",o,i),onBlur:to("password",o,i)}))),(null===(r=o.jsonData)||void 0===r?void 0:r.authType)===Un.Token&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.Field,{label:"API Token"},Mt().createElement(qt.SecretInput,{width:40,placeholder:"API token",isConfigured:o.secureJsonFields&&o.secureJsonFields.apiToken,onReset:ro("apiToken",o,i),onBlur:to("apiToken",o,i)})))),Mt().createElement(Gn,null),Mt().createElement(Wn.ConfigSection,{title:"Additional settings",isCollapsible:!0},Mt().createElement(Wn.AdvancedHttpSettings,{config:o,onChange:i}),Mt().createElement("div",{className:n.space}),Mt().createElement(Wn.ConfigSubSection,{title:"Zabbix API"},Mt().createElement(qt.Field,{label:Mt().createElement(qt.Label,null,Mt().createElement(Wn.EditorStack,{gap:.5},Mt().createElement("span",null,"Cache TTL"),Mt().createElement(qt.Tooltip,{content:Mt().createElement("span",null,"Zabbix data source caches metric names in memory. Specify how often data will be updated.")},Mt().createElement(qt.Icon,{name:"info-circle",size:"sm"}))))},Mt().createElement(qt.Input,{width:40,value:o.jsonData.cacheTTL||"",placeholder:"1h",onChange:Jn("cacheTTL",o,i)})),Mt().createElement(qt.Field,{label:Mt().createElement(qt.Label,null,Mt().createElement(Wn.EditorStack,{gap:.5},Mt().createElement("span",null,"Timeout"),Mt().createElement(qt.Tooltip,{content:Mt().createElement("span",null,"Zabbix API connection timeout in seconds. Default is 30.")},Mt().createElement(qt.Icon,{name:"info-circle",size:"sm"}))))},Mt().createElement(qt.Input,{width:40,type:"number",value:o.jsonData.timeout,placeholder:"30",onChange:e=>{i(zn($n({},o),{jsonData:zn($n({},o.jsonData),{timeout:parseInt(e.currentTarget.value,10)})}))}}))),Mt().createElement(Wn.ConfigSubSection,{title:"Trends"},Mt().createElement(qt.Field,{label:"Enable Trends"},Mt().createElement(qt.Switch,{value:o.jsonData.trends,onChange:eo("trends",o,i)})),o.jsonData.trends&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.Field,{label:Mt().createElement(qt.Label,null,Mt().createElement(Wn.EditorStack,{gap:.5},Mt().createElement("span",null,"After"),Mt().createElement(qt.Tooltip,{content:Mt().createElement("span",null,"Time after which trends will be used. Best practice is to set this value to your history storage period (7d, 30d, etc).")},Mt().createElement(qt.Icon,{name:"info-circle",size:"sm"}))))},Mt().createElement(qt.Input,{width:40,placeholder:"7d",value:o.jsonData.trendsFrom||"",onChange:Jn("trendsFrom",o,i)})),Mt().createElement(qt.Field,{label:Mt().createElement(qt.Label,null,Mt().createElement(Wn.EditorStack,{gap:.5},Mt().createElement("span",null,"Range"),Mt().createElement(qt.Tooltip,{content:Mt().createElement("span",null,"Time range width after which trends will be used instead of history. It&aposs better to set this value in range of 4 to 7 days to prevent loading large amount of history data.")},Mt().createElement(qt.Icon,{name:"info-circle",size:"sm"}))))},Mt().createElement(qt.Input,{width:40,placeholder:"4d",value:o.jsonData.trendsRange||"",onChange:Jn("trendsRange",o,i)})))),Mt().createElement(Wn.ConfigSubSection,{title:"Direct DB Connection"},Mt().createElement(qt.Field,{label:"Enable Direct DB Connection"},Mt().createElement(qt.Switch,{value:o.jsonData.dbConnectionEnable,onChange:eo("dbConnectionEnable",o,i)})),o.jsonData.dbConnectionEnable&&Mt().createElement(Mt().Fragment,null,Mt().createElement(qt.Field,{label:"Data Source"},Mt().createElement(qt.Select,{width:40,value:a,options:oo().map((e=>({label:e.name,value:e.id,description:e.type}))),onChange:no(o,i,l,s)})),"influxdb"===u&&Mt().createElement(qt.Field,{label:"Retention Policy"},Mt().createElement(qt.Input,{width:40,value:o.jsonData.dbConnectionRetentionPolicy||"",placeholder:"Retention policy name",onChange:Jn("dbConnectionRetentionPolicy",o,i)})))),Mt().createElement(Wn.ConfigSubSection,{title:"Other"},Mt().createElement(qt.Field,{label:"Disable acknowledges for read-only users"},Mt().createElement(qt.Switch,{label:"Disable acknowledges for read-only users",value:o.jsonData.disableReadOnlyUsersAck,onChange:eo("disableReadOnlyUsersAck",o,i)})),Mt().createElement(qt.Field,{label:Mt().createElement(qt.Label,null,Mt().createElement(Wn.EditorStack,{gap:.5},Mt().createElement("span",null,"Disable data alignment"),Mt().createElement(qt.Tooltip,{content:Mt().createElement("span",null,"Data alignment feature aligns points based on item update interval. For instance, if value collected once per minute, then timestamp of the each point will be set to the start of corresponding minute. This alignment required for proper work of the stacked graphs. If you don't need stacked graphs and want to get exactly the same timestamps as in Zabbix, then you can disable this feature.")},Mt().createElement(qt.Icon,{name:"info-circle",size:"sm"}))))},Mt().createElement(qt.Switch,{value:!!o.jsonData.disableDataAlignment,onChange:eo("disableDataAlignment",o,i)}))),oe.config.secureSocksDSProxyEnabled&&(0,Be.gte)(oe.config.buildInfo.version,"10.0.0-0")&&Mt().createElement(qt.SecureSocksProxySettings,{options:o,onOptionsChange:i})))})).setQueryEditor((({query:e,datasource:t,onChange:r,onRunQuery:n})=>{const o={schema:12,queryType:s,group:{filter:""},host:{filter:""},application:{filter:""},itemTag:{filter:""},item:{filter:""},macro:{filter:""},functions:[],trigger:{filter:""},countTriggersBy:"",tags:{filter:""},proxy:{filter:""},textFilter:"",evaltype:et.AndOr,options:{showDisabledItems:!1,skipEmptyValues:!1,disableDataAlignment:!1,useZabbixValueMapping:!1,useTrends:"default",count:!1},table:{skipEmptyValues:!1}};(e=In({},o,e)).options=In({},o.options,e.options);const{queryType:i}=e;if(i===g||i===p){const t={showProblems:Ze.Problems,options:{minSeverity:0,sortProblems:"default",acknowledged:2,hostsInMaintenance:!1,hostProxy:!1,limit:1001,useTimeRange:!1,count:!1}};(e=In({},t,e)).options=In({},t.options,e.options)}i===c&&(e=In({},{itServiceFilter:"",slaFilter:"",slaProperty:"sla",slaInterval:"none"},e)),(0,jt.useEffect)((()=>{const t=z(e);r(t)}),[]);const a=e=>{r(e),n()};return Mt().createElement(Mt().Fragment,null,Mt().createElement(Bt,null,Mt().createElement(qt.InlineField,{label:"Query type",labelWidth:12},Mt().createElement(qt.Select,{isSearchable:!1,width:24,value:i,options:Rn,onChange:(l="queryType",t=>{null!==t.value&&a(An(In({},e),{[l]:t.value}))})}))),i===s&&Mt().createElement(Mt().Fragment,null,Mt().createElement(yr,{query:e,datasource:t,onChange:a}),Mt().createElement(Lr,{query:e,onChange:a})),i===f&&Mt().createElement(Mt().Fragment,null,Mt().createElement(an,{query:e,onChange:a}),Mt().createElement(Lr,{query:e,onChange:a})),i===d&&Mt().createElement(Mt().Fragment,null,Mt().createElement(zr,{query:e,datasource:t,onChange:a})),i===c&&Mt().createElement(Mt().Fragment,null,Mt().createElement(gn,{query:e,datasource:t,onChange:a}),Mt().createElement(Lr,{query:e,onChange:a})),i===g&&Mt().createElement(nn,{query:e,datasource:t,onChange:a}),i===p&&Mt().createElement(Sn,{query:e,datasource:t,onChange:a}),i===v&&Mt().createElement(Pn,{query:e,datasource:t,onChange:a}),Mt().createElement(Br,{queryType:i,queryOptions:e.options,onChange:t=>{a(An(In({},e),{options:t}))}}));var l})).setVariableQueryEditor(Bn)})(),E})()));
//# sourceMappingURL=module.js.map